/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/types","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/lazy","vs/base/common/themables","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/progress/common/progress","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(ye){for(var e=[],y=0,M=ye.length;y<M;y++)e[y]=Ae[ye[y]];return e};define(Ae[65],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function y(A){return(l,D,$)=>{let R=null,k=null;if(typeof $.value=="function"?(R="value",k=$.value):typeof $.get=="function"&&(R="get",k=$.get),!k)throw new Error("not supported");$[R]=A(k,D)}}function M(A,l,D){let $=null,R=null;if(typeof D.value=="function"?($="value",R=D.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&($="get",R=D.get),!R)throw new Error("not supported");const k=`$memoize$${l}`;D[$]=function(...a){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,a)}),this[k]}}e.$hh=M;function C(A,l,D){return y(($,R)=>{const k=`$debounce$${R}`,a=`$debounce$result$${R}`;return function(...p){this[a]||(this[a]=D?D():void 0),clearTimeout(this[k]),l&&(this[a]=l(this[a],...p),p=[this[a]]),this[k]=setTimeout(()=>{$.apply(this,p),this[a]=D?D():void 0},A)}})}e.$ih=C;function T(A,l,D){return y(($,R)=>{const k=`$throttle$timer$${R}`,a=`$throttle$result$${R}`,p=`$throttle$lastRun$${R}`,g=`$throttle$pending$${R}`;return function(...d){if(this[a]||(this[a]=D?D():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),l&&(this[a]=l(this[a],...d)),this[g])return;const t=this[p]+A;t<=Date.now()?(this[p]=Date.now(),$.apply(this,[this[a]]),this[a]=D?D():void 0):(this[g]=!0,this[k]=setTimeout(()=>{this[g]=!1,this[p]=Date.now(),$.apply(this,[this[a]]),this[a]=D?D():void 0},t-Date.now()))}})}e.$jh=T}),define(Ae[88],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.$lM=void 0;class y{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$lM=y,e.$mM=new y("id#")}),define(Ae[115],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var M;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var C;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var T;(function(s){s.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function A(s,r=!1){let n=0;const o=s.length;let w="",f=0,I=16,S=0;function u(j){let O=0,N=0;for(;O<j;){const ie=s.charCodeAt(n);if(ie>=48&&ie<=57)N=N*16+ie-48;else if(ie>=65&&ie<=70)N=N*16+ie-65+10;else if(ie>=97&&ie<=102)N=N*16+ie-97+10;else break;n++,O++}return O<j&&(N=-1),N}function m(j){n=j,w="",f=0,I=16,S=0}function h(){const j=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&$(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&$(s.charCodeAt(n)))for(n++;n<s.length&&$(s.charCodeAt(n));)n++;else return S=3,s.substring(j,n);let O=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&$(s.charCodeAt(n))){for(n++;n<s.length&&$(s.charCodeAt(n));)n++;O=n}else S=3;return s.substring(j,O)}function P(){let j="",O=n;for(;;){if(n>=o){j+=s.substring(O,n),S=2;break}const N=s.charCodeAt(n);if(N===34){j+=s.substring(O,n),n++;break}if(N===92){if(j+=s.substring(O,n),n++,n>=o){S=2;break}switch(s.charCodeAt(n++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const X=u(4);X>=0?j+=String.fromCharCode(X):S=4;break}default:S=5}O=n;continue}if(N>=0&&N<=31)if(D(N)){j+=s.substring(O,n),S=2;break}else S=6;n++}return j}function W(){if(w="",S=0,f=n,n>=o)return f=o,I=17;let j=s.charCodeAt(n);if(l(j)){do n++,w+=String.fromCharCode(j),j=s.charCodeAt(n);while(l(j));return I=15}if(D(j))return n++,w+=String.fromCharCode(j),j===13&&s.charCodeAt(n)===10&&(n++,w+=`
`),I=14;switch(j){case 123:return n++,I=1;case 125:return n++,I=2;case 91:return n++,I=3;case 93:return n++,I=4;case 58:return n++,I=6;case 44:return n++,I=5;case 34:return n++,w=P(),I=10;case 47:{const O=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<o&&!D(s.charCodeAt(n));)n++;return w=s.substring(O,n),I=12}if(s.charCodeAt(n+1)===42){n+=2;const N=o-1;let ie=!1;for(;n<N;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,ie=!0;break}n++}return ie||(n++,S=1),w=s.substring(O,n),I=13}return w+=String.fromCharCode(j),n++,I=16}case 45:if(w+=String.fromCharCode(j),n++,n===o||!$(s.charCodeAt(n)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=h(),I=11;default:for(;n<o&&K(j);)n++,j=s.charCodeAt(n);if(f!==n){switch(w=s.substring(f,n),w){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return w+=String.fromCharCode(j),n++,I=16}}function K(j){if(l(j)||D(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let j;do j=W();while(j>=12&&j<=15);return j}return{setPosition:m,getPosition:()=>n,scan:r?z:W,getToken:()=>I,getTokenValue:()=>w,getTokenOffset:()=>f,getTokenLength:()=>n-f,getTokenError:()=>S}}e.$Um=A;function l(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function D(s){return s===10||s===13||s===8232||s===8233}function $(s){return s>=48&&s<=57}var R;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(R||(R={}));function k(s,r){const n=[],o=new Object;let w;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function S(u,m,h,P){f.value=u,f.offset=m,f.length=h,f.type=P,f.colonOffset=void 0,w=f}try{b(s,{onObjectBegin:(u,m)=>{if(r<=u)throw o;w=void 0,I=r>u,n.push("")},onObjectProperty:(u,m,h)=>{if(r<m||(S(u,m,h,"property"),n[n.length-1]=u,r<=m+h))throw o},onObjectEnd:(u,m)=>{if(r<=u)throw o;w=void 0,n.pop()},onArrayBegin:(u,m)=>{if(r<=u)throw o;w=void 0,n.push(0)},onArrayEnd:(u,m)=>{if(r<=u)throw o;w=void 0,n.pop()},onLiteralValue:(u,m,h)=>{if(r<m||(S(u,m,h,v(u)),r<=m+h))throw o},onSeparator:(u,m,h)=>{if(r<=m)throw o;if(u===":"&&w&&w.type==="property")w.colonOffset=m,I=!1,w=void 0;else if(u===","){const P=n[n.length-1];typeof P=="number"?n[n.length-1]=P+1:(I=!0,n[n.length-1]=""),w=void 0}}})}catch(u){if(u!==o)throw u}return{path:n,previousNode:w,isAtPropertyKey:I,matches:u=>{let m=0;for(let h=0;m<u.length&&h<n.length;h++)if(u[m]===n[h]||u[m]==="*")m++;else if(u[m]!=="**")return!1;return m===u.length}}}e.$Vm=k;function a(s,r=[],n=T.DEFAULT){let o=null,w=[];const f=[];function I(u){Array.isArray(w)?w.push(u):o!==null&&(w[o]=u)}return b(s,{onObjectBegin:()=>{const u={};I(u),f.push(w),w=u,o=null},onObjectProperty:u=>{o=u},onObjectEnd:()=>{w=f.pop()},onArrayBegin:()=>{const u=[];I(u),f.push(w),w=u,o=null},onArrayEnd:()=>{w=f.pop()},onLiteralValue:I,onError:(u,m,h)=>{r.push({error:u,offset:m,length:h})}},n),w[0]}e.$Wm=a;function p(s,r=[],n=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(u){o.type==="property"&&(o.length=u-o.offset,o=o.parent)}function f(u){return o.children.push(u),u}b(s,{onObjectBegin:u=>{o=f({type:"object",offset:u,length:-1,parent:o,children:[]})},onObjectProperty:(u,m,h)=>{o=f({type:"property",offset:m,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:u,offset:m,length:h,parent:o})},onObjectEnd:(u,m)=>{o.length=u+m-o.offset,o=o.parent,w(u+m)},onArrayBegin:(u,m)=>{o=f({type:"array",offset:u,length:-1,parent:o,children:[]})},onArrayEnd:(u,m)=>{o.length=u+m-o.offset,o=o.parent,w(u+m)},onLiteralValue:(u,m,h)=>{f({type:v(u),offset:m,length:h,parent:o,value:u}),w(m+h)},onSeparator:(u,m,h)=>{o.type==="property"&&(u===":"?o.colonOffset=m:u===","&&w(m))},onError:(u,m,h)=>{r.push({error:u,offset:m,length:h})}},n);const S=o.children[0];return S&&delete S.parent,S}e.$Xm=p;function g(s,r){if(!s)return;let n=s;for(const o of r)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let w=!1;for(const f of n.children)if(Array.isArray(f.children)&&f.children[0].value===o){n=f.children[1],w=!0;break}if(!w)return}else{const w=o;if(n.type!=="array"||w<0||!Array.isArray(n.children)||w>=n.children.length)return;n=n.children[w]}return n}e.$Ym=g;function d(s){if(!s.parent||!s.parent.children)return[];const r=d(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;r.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&r.push(n)}return r}e.$Zm=d;function t(s){switch(s.type){case"array":return s.children.map(t);case"object":{const r=Object.create(null);for(const n of s.children){const o=n.children[1];o&&(r[n.children[0].value]=t(o))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$1m=t;function i(s,r,n=!1){return r>=s.offset&&r<s.offset+s.length||n&&r===s.offset+s.length}e.$2m=i;function c(s,r,n=!1){if(i(s,r,n)){const o=s.children;if(Array.isArray(o))for(let w=0;w<o.length&&o[w].offset<=r;w++){const f=c(o[w],r,n);if(f)return f}return s}}e.$3m=c;function b(s,r,n=T.DEFAULT){const o=A(s,!1);function w(ue){return ue?()=>ue(o.getTokenOffset(),o.getTokenLength()):()=>!0}function f(ue){return ue?oe=>ue(oe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const I=w(r.onObjectBegin),S=f(r.onObjectProperty),u=w(r.onObjectEnd),m=w(r.onArrayBegin),h=w(r.onArrayEnd),P=f(r.onLiteralValue),W=f(r.onSeparator),K=w(r.onComment),z=f(r.onError),j=n&&n.disallowComments,O=n&&n.allowTrailingComma;function N(){for(;;){const ue=o.scan();switch(o.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:j||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(ue){case 12:case 13:j?ie(10):K();break;case 16:ie(1);break;case 15:case 14:break;default:return ue}}}function ie(ue,oe=[],be=[]){if(z(ue),oe.length+be.length>0){let _=o.getToken();for(;_!==17;){if(oe.indexOf(_)!==-1){N();break}else if(be.indexOf(_)!==-1)break;_=N()}}}function X(ue){const oe=o.getTokenValue();return ue?P(oe):S(oe),N(),!0}function Ee(){switch(o.getToken()){case 11:{let ue=0;try{ue=JSON.parse(o.getTokenValue()),typeof ue!="number"&&(ie(2),ue=0)}catch{ie(2)}P(ue);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return N(),!0}function Se(){return o.getToken()!==10?(ie(3,[],[2,5]),!1):(X(!1),o.getToken()===6?(W(":"),N(),pe()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function Pe(){I(),N();let ue=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ue||ie(4,[],[]),W(","),N(),o.getToken()===2&&O)break}else ue&&ie(6,[],[]);Se()||ie(4,[],[2,5]),ue=!0}return u(),o.getToken()!==2?ie(7,[2],[]):N(),!0}function $e(){m(),N();let ue=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ue||ie(4,[],[]),W(","),N(),o.getToken()===4&&O)break}else ue&&ie(6,[],[]);pe()||ie(4,[],[4,5]),ue=!0}return h(),o.getToken()!==4?ie(8,[4],[]):N(),!0}function pe(){switch(o.getToken()){case 3:return $e();case 1:return Pe();case 10:return X(!0);default:return Ee()}}return N(),o.getToken()===17?n.allowEmptyContent?!0:(ie(4,[],[]),!1):pe()?(o.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$4m=b;function E(s,r){const n=A(s),o=[];let w,f=0,I;do switch(I=n.getPosition(),w=n.scan(),w){case 12:case 13:case 17:f!==I&&o.push(s.substring(f,I)),r!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,r)),f=n.getPosition();break}while(w!==17);return o.join("")}e.$5m=E;function v(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=v}),function(ye,e){typeof define=="function"&&define.amd?define(Ae[116],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ye=typeof globalThis<"u"?globalThis:ye||self,e(ye.marked={}))}(this,function(ye){"use strict";function e(ge,de){for(var De=0;De<de.length;De++){var re=de[De];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(ge,re.key,re)}}function y(ge,de,De){return de&&e(ge.prototype,de),De&&e(ge,De),Object.defineProperty(ge,"prototype",{writable:!1}),ge}function M(ge,de){if(ge){if(typeof ge=="string")return C(ge,de);var De=Object.prototype.toString.call(ge).slice(8,-1);if(De==="Object"&&ge.constructor&&(De=ge.constructor.name),De==="Map"||De==="Set")return Array.from(ge);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return C(ge,de)}}function C(ge,de){(de==null||de>ge.length)&&(de=ge.length);for(var De=0,re=new Array(de);De<de;De++)re[De]=ge[De];return re}function T(ge,de){var De=typeof Symbol<"u"&&ge[Symbol.iterator]||ge["@@iterator"];if(De)return(De=De.call(ge)).next.bind(De);if(Array.isArray(ge)||(De=M(ge))||de&&ge&&typeof ge.length=="number"){De&&(ge=De);var re=0;return function(){return re>=ge.length?{done:!0}:{done:!1,value:ge[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ye.defaults=A();function l(ge){ye.defaults=ge}var D=/[&<>"']/,$=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(de){return a[de]};function g(ge,de){if(de){if(D.test(ge))return ge.replace($,p)}else if(R.test(ge))return ge.replace(k,p);return ge}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(ge){return ge.replace(d,function(de,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var i=/(^|[^\[])\^/g;function c(ge,de){ge=typeof ge=="string"?ge:ge.source,de=de||"";var De={replace:function(le,ne){return ne=ne.source||ne,ne=ne.replace(i,"$1"),ge=ge.replace(le,ne),De},getRegex:function(){return new RegExp(ge,de)}};return De}var b=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(ge,de,De){if(ge){var re;try{re=decodeURIComponent(t(De)).replace(b,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}de&&!E.test(De)&&(De=w(de,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var s={},r=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(ge,de){s[" "+ge]||(r.test(ge)?s[" "+ge]=ge+"/":s[" "+ge]=u(ge,"/",!0)),ge=s[" "+ge];var De=ge.indexOf(":")===-1;return de.substring(0,2)==="//"?De?de:ge.replace(n,"$1")+de:de.charAt(0)==="/"?De?de:ge.replace(o,"$1")+de:ge+de}var f={exec:function(){}};function I(ge){for(var de=1,De,re;de<arguments.length;de++){De=arguments[de];for(re in De)Object.prototype.hasOwnProperty.call(De,re)&&(ge[re]=De[re])}return ge}function S(ge,de){var De=ge.replace(/\|/g,function(ne,ae,fe){for(var Ie=!1,F=ae;--F>=0&&fe[F]==="\\";)Ie=!Ie;return Ie?"|":" |"}),re=De.split(/ \|/),le=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>de)re.splice(de);else for(;re.length<de;)re.push("");for(;le<re.length;le++)re[le]=re[le].trim().replace(/\\\|/g,"|");return re}function u(ge,de,De){var re=ge.length;if(re===0)return"";for(var le=0;le<re;){var ne=ge.charAt(re-le-1);if(ne===de&&!De)le++;else if(ne!==de&&De)le++;else break}return ge.slice(0,re-le)}function m(ge,de){if(ge.indexOf(de[1])===-1)return-1;for(var De=ge.length,re=0,le=0;le<De;le++)if(ge[le]==="\\")le++;else if(ge[le]===de[0])re++;else if(ge[le]===de[1]&&(re--,re<0))return le;return-1}function h(ge){ge&&ge.sanitize&&!ge.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ge,de){if(de<1)return"";for(var De="";de>1;)de&1&&(De+=ge),de>>=1,ge+=ge;return De+ge}function W(ge,de,De,re){var le=de.href,ne=de.title?g(de.title):null,ae=ge[1].replace(/\\([\[\]])/g,"$1");if(ge[0].charAt(0)!=="!"){re.state.inLink=!0;var fe={type:"link",raw:De,href:le,title:ne,text:ae,tokens:re.inlineTokens(ae)};return re.state.inLink=!1,fe}return{type:"image",raw:De,href:le,title:ne,text:g(ae)}}function K(ge,de){var De=ge.match(/^(\s+)(?:```)/);if(De===null)return de;var re=De[1];return de.split(`
`).map(function(le){var ne=le.match(/^\s+/);if(ne===null)return le;var ae=ne[0];return ae.length>=re.length?le.slice(re.length):le}).join(`
`)}var z=function(){function ge(De){this.options=De||ye.defaults}var de=ge.prototype;return de.space=function(re){var le=this.rules.block.newline.exec(re);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},de.code=function(re){var le=this.rules.block.code.exec(re);if(le){var ne=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:u(ne,`
`)}}},de.fences=function(re){var le=this.rules.block.fences.exec(re);if(le){var ne=le[0],ae=K(ne,le[3]||"");return{type:"code",raw:ne,lang:le[2]?le[2].trim():le[2],text:ae}}},de.heading=function(re){var le=this.rules.block.heading.exec(re);if(le){var ne=le[2].trim();if(/#$/.test(ne)){var ae=u(ne,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(ne=ae.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:ne,tokens:this.lexer.inline(ne)}}},de.hr=function(re){var le=this.rules.block.hr.exec(re);if(le)return{type:"hr",raw:le[0]}},de.blockquote=function(re){var le=this.rules.block.blockquote.exec(re);if(le){var ne=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},de.list=function(re){var le=this.rules.block.list.exec(re);if(le){var ne,ae,fe,Ie,F,V,G,J,q,x,ce,Ne,Ue=le[1].trim(),Qe=Ue.length>1,Ge={type:"list",raw:"",ordered:Qe,start:Qe?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Qe?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Qe?Ue:"[*+-]");for(var xe=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(Ne=!1,!(!(le=xe.exec(re))||this.rules.block.hr.test(re)));){if(ne=le[0],re=re.substring(ne.length),J=le[2].split(`
`,1)[0],q=re.split(`
`,1)[0],this.options.pedantic?(Ie=2,ce=J.trimLeft()):(Ie=le[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ce=J.slice(Ie),Ie+=le[1].length),V=!1,!J&&/^ *$/.test(q)&&(ne+=q+`
`,re=re.substring(q.length+1),Ne=!0),!Ne)for(var Ye=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");re&&(x=re.split(`
`,1)[0],J=x,this.options.pedantic&&(J=J.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(J)||tt.test(J)||Ye.test(J)||_e.test(re)));){if(J.search(/[^ ]/)>=Ie||!J.trim())ce+=`
`+J.slice(Ie);else if(!V)ce+=`
`+J;else break;!V&&!J.trim()&&(V=!0),ne+=x+`
`,re=re.substring(x.length+1)}Ge.loose||(G?Ge.loose=!0:/\n *\n *$/.test(ne)&&(G=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(ce),ae&&(fe=ae[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:ne,task:!!ae,checked:fe,loose:!1,text:ce}),Ge.raw+=ne}Ge.items[Ge.items.length-1].raw=ne.trimRight(),Ge.items[Ge.items.length-1].text=ce.trimRight(),Ge.raw=Ge.raw.trimRight();var ze=Ge.items.length;for(F=0;F<ze;F++){this.lexer.state.top=!1,Ge.items[F].tokens=this.lexer.blockTokens(Ge.items[F].text,[]);var st=Ge.items[F].tokens.filter(function(Q){return Q.type==="space"}),Y=st.every(function(Q){for(var we=Q.raw.split(""),Be=0,Oe=T(we),Xe;!(Xe=Oe()).done;){var nt=Xe.value;if(nt===`
`&&(Be+=1),Be>1)return!0}return!1});!Ge.loose&&st.length&&Y&&(Ge.loose=!0,Ge.items[F].loose=!0)}return Ge}},de.html=function(re){var le=this.rules.block.html.exec(re);if(le){var ne={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(le[0]):g(le[0]);ne.type="paragraph",ne.text=ae,ne.tokens=this.lexer.inline(ae)}return ne}},de.def=function(re){var le=this.rules.block.def.exec(re);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var ne=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:le[0],href:le[2],title:le[3]}}},de.table=function(re){var le=this.rules.block.table.exec(re);if(le){var ne={type:"table",header:S(le[1]).map(function(G){return{text:G}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=le[0];var ae=ne.align.length,fe,Ie,F,V;for(fe=0;fe<ae;fe++)/^ *-+: *$/.test(ne.align[fe])?ne.align[fe]="right":/^ *:-+: *$/.test(ne.align[fe])?ne.align[fe]="center":/^ *:-+ *$/.test(ne.align[fe])?ne.align[fe]="left":ne.align[fe]=null;for(ae=ne.rows.length,fe=0;fe<ae;fe++)ne.rows[fe]=S(ne.rows[fe],ne.header.length).map(function(G){return{text:G}});for(ae=ne.header.length,Ie=0;Ie<ae;Ie++)ne.header[Ie].tokens=this.lexer.inline(ne.header[Ie].text);for(ae=ne.rows.length,Ie=0;Ie<ae;Ie++)for(V=ne.rows[Ie],F=0;F<V.length;F++)V[F].tokens=this.lexer.inline(V[F].text);return ne}}},de.lheading=function(re){var le=this.rules.block.lheading.exec(re);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},de.paragraph=function(re){var le=this.rules.block.paragraph.exec(re);if(le){var ne=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:ne,tokens:this.lexer.inline(ne)}}},de.text=function(re){var le=this.rules.block.text.exec(re);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},de.escape=function(re){var le=this.rules.inline.escape.exec(re);if(le)return{type:"escape",raw:le[0],text:g(le[1])}},de.tag=function(re){var le=this.rules.inline.tag.exec(re);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):g(le[0]):le[0]}},de.link=function(re){var le=this.rules.inline.link.exec(re);if(le){var ne=le[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var ae=u(ne.slice(0,-1),"\\");if((ne.length-ae.length)%2===0)return}else{var fe=m(le[2],"()");if(fe>-1){var Ie=le[0].indexOf("!")===0?5:4,F=Ie+le[1].length+fe;le[2]=le[2].substring(0,fe),le[0]=le[0].substring(0,F).trim(),le[3]=""}}var V=le[2],G="";if(this.options.pedantic){var J=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);J&&(V=J[1],G=J[3])}else G=le[3]?le[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(ne)?V=V.slice(1):V=V.slice(1,-1)),W(le,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},de.reflink=function(re,le){var ne;if((ne=this.rules.inline.reflink.exec(re))||(ne=this.rules.inline.nolink.exec(re))){var ae=(ne[2]||ne[1]).replace(/\s+/g," ");if(ae=le[ae.toLowerCase()],!ae||!ae.href){var fe=ne[0].charAt(0);return{type:"text",raw:fe,text:fe}}return W(ne,ae,ne[0],this.lexer)}},de.emStrong=function(re,le,ne){ne===void 0&&(ne="");var ae=this.rules.inline.emStrong.lDelim.exec(re);if(ae&&!(ae[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var fe=ae[1]||ae[2]||"";if(!fe||fe&&(ne===""||this.rules.inline.punctuation.exec(ne))){var Ie=ae[0].length-1,F,V,G=Ie,J=0,q=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,le=le.slice(-1*re.length+Ie);(ae=q.exec(le))!=null;)if(F=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!F){if(V=F.length,ae[3]||ae[4]){G+=V;continue}else if((ae[5]||ae[6])&&Ie%3&&!((Ie+V)%3)){J+=V;continue}if(G-=V,!(G>0)){if(V=Math.min(V,V+G+J),Math.min(Ie,V)%2){var x=re.slice(1,Ie+ae.index+V);return{type:"em",raw:re.slice(0,Ie+ae.index+V+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ce=re.slice(2,Ie+ae.index+V-1);return{type:"strong",raw:re.slice(0,Ie+ae.index+V+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}}}}},de.codespan=function(re){var le=this.rules.inline.code.exec(re);if(le){var ne=le[2].replace(/\n/g," "),ae=/[^ ]/.test(ne),fe=/^ /.test(ne)&&/ $/.test(ne);return ae&&fe&&(ne=ne.substring(1,ne.length-1)),ne=g(ne,!0),{type:"codespan",raw:le[0],text:ne}}},de.br=function(re){var le=this.rules.inline.br.exec(re);if(le)return{type:"br",raw:le[0]}},de.del=function(re){var le=this.rules.inline.del.exec(re);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},de.autolink=function(re,le){var ne=this.rules.inline.autolink.exec(re);if(ne){var ae,fe;return ne[2]==="@"?(ae=g(this.options.mangle?le(ne[1]):ne[1]),fe="mailto:"+ae):(ae=g(ne[1]),fe=ae),{type:"link",raw:ne[0],text:ae,href:fe,tokens:[{type:"text",raw:ae,text:ae}]}}},de.url=function(re,le){var ne;if(ne=this.rules.inline.url.exec(re)){var ae,fe;if(ne[2]==="@")ae=g(this.options.mangle?le(ne[0]):ne[0]),fe="mailto:"+ae;else{var Ie;do Ie=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(Ie!==ne[0]);ae=g(ne[0]),ne[1]==="www."?fe="http://"+ae:fe=ae}return{type:"link",raw:ne[0],text:ae,href:fe,tokens:[{type:"text",raw:ae,text:ae}]}}},de.inlineText=function(re,le){var ne=this.rules.inline.text.exec(re);if(ne){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):g(ne[0]):ne[0]:ae=g(this.options.smartypants?le(ne[0]):ne[0]),{type:"text",raw:ne[0],text:ae}}},ge}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=c(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=c(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=c(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=c(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=c(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=c(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=I({},j),j.gfm=I({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=c(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=c(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=I({},j.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:c(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=c(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=c(j._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=c(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=c(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=c(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=c(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=c(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=c(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=c(O.reflink).replace("label",O._label).replace("ref",j._label).getRegex(),O.nolink=c(O.nolink).replace("ref",j._label).getRegex(),O.reflinkSearch=c(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=I({},O),O.pedantic=I({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=I({},O.normal,{escape:c(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=c(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=I({},O.gfm,{br:c(O.br).replace("{2,}","*").getRegex(),text:c(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(ge){return ge.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ie(ge){var de="",De,re,le=ge.length;for(De=0;De<le;De++)re=ge.charCodeAt(De),Math.random()>.5&&(re="x"+re.toString(16)),de+="&#"+re+";";return de}var X=function(){function ge(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||ye.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:j.normal,inline:O.normal};this.options.pedantic?(re.block=j.pedantic,re.inline=O.pedantic):this.options.gfm&&(re.block=j.gfm,this.options.breaks?re.inline=O.breaks:re.inline=O.gfm),this.tokenizer.rules=re}ge.lex=function(re,le){var ne=new ge(le);return ne.lex(re)},ge.lexInline=function(re,le){var ne=new ge(le);return ne.inlineTokens(re)};var de=ge.prototype;return de.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},de.blockTokens=function(re,le){var ne=this;le===void 0&&(le=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(G,J,q){return J+"    ".repeat(q.length)});for(var ae,fe,Ie,F;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(ae=G.call({lexer:ne},re,le))?(re=re.substring(ae.raw.length),le.push(ae),!0):!1}))){if(ae=this.tokenizer.space(re)){re=re.substring(ae.raw.length),ae.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(ae);continue}if(ae=this.tokenizer.code(re)){re=re.substring(ae.raw.length),fe=le[le.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+ae.raw,fe.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):le.push(ae);continue}if(ae=this.tokenizer.fences(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.heading(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.hr(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.blockquote(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.list(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.html(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.def(re)){re=re.substring(ae.raw.length),fe=le[le.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+ae.raw,fe.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.lheading(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,J=re.slice(1),q=void 0;ne.options.extensions.startBlock.forEach(function(x){q=x.call({lexer:this},J),typeof q=="number"&&q>=0&&(G=Math.min(G,q))}),G<1/0&&G>=0&&(Ie=re.substring(0,G+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(Ie))){fe=le[le.length-1],F&&fe.type==="paragraph"?(fe.raw+=`
`+ae.raw,fe.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):le.push(ae),F=Ie.length!==re.length,re=re.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(re)){re=re.substring(ae.raw.length),fe=le[le.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+ae.raw,fe.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):le.push(ae);continue}if(re){var V="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,le},de.inline=function(re,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:re,tokens:le}),le},de.inlineTokens=function(re,le){var ne=this;le===void 0&&(le=[]);var ae,fe,Ie,F=re,V,G,J;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(F))!=null;)q.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(F=F.slice(0,V.index)+"["+P("a",V[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(F))!=null;)F=F.slice(0,V.index)+"["+P("a",V[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(F))!=null;)F=F.slice(0,V.index)+"++"+F.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(G||(J=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(ae=ce.call({lexer:ne},re,le))?(re=re.substring(ae.raw.length),le.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.tag(re)){re=re.substring(ae.raw.length),fe=le[le.length-1],fe&&ae.type==="text"&&fe.type==="text"?(fe.raw+=ae.raw,fe.text+=ae.text):le.push(ae);continue}if(ae=this.tokenizer.link(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(ae.raw.length),fe=le[le.length-1],fe&&ae.type==="text"&&fe.type==="text"?(fe.raw+=ae.raw,fe.text+=ae.text):le.push(ae);continue}if(ae=this.tokenizer.emStrong(re,F,J)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.codespan(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.br(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.del(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.autolink(re,ie)){re=re.substring(ae.raw.length),le.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(re,ie))){re=re.substring(ae.raw.length),le.push(ae);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,Ne=re.slice(1),Ue=void 0;ne.options.extensions.startInline.forEach(function(Qe){Ue=Qe.call({lexer:this},Ne),typeof Ue=="number"&&Ue>=0&&(ce=Math.min(ce,Ue))}),ce<1/0&&ce>=0&&(Ie=re.substring(0,ce+1))}(),ae=this.tokenizer.inlineText(Ie,N)){re=re.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(J=ae.raw.slice(-1)),G=!0,fe=le[le.length-1],fe&&fe.type==="text"?(fe.raw+=ae.raw,fe.text+=ae.text):le.push(ae);continue}if(re){var x="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return le},y(ge,null,[{key:"rules",get:function(){return{block:j,inline:O}}}]),ge}(),Ee=function(){function ge(De){this.options=De||ye.defaults}var de=ge.prototype;return de.code=function(re,le,ne){var ae=(le||"").match(/\S*/)[0];if(this.options.highlight){var fe=this.options.highlight(re,ae);fe!=null&&fe!==re&&(ne=!0,re=fe)}return re=re.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+g(ae,!0)+'">'+(ne?re:g(re,!0))+`</code></pre>
`:"<pre><code>"+(ne?re:g(re,!0))+`</code></pre>
`},de.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},de.html=function(re){return re},de.heading=function(re,le,ne,ae){if(this.options.headerIds){var fe=this.options.headerPrefix+ae.slug(ne);return"<h"+le+' id="'+fe+'">'+re+"</h"+le+`>
`}return"<h"+le+">"+re+"</h"+le+`>
`},de.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},de.list=function(re,le,ne){var ae=le?"ol":"ul",fe=le&&ne!==1?' start="'+ne+'"':"";return"<"+ae+fe+`>
`+re+"</"+ae+`>
`},de.listitem=function(re){return"<li>"+re+`</li>
`},de.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},de.paragraph=function(re){return"<p>"+re+`</p>
`},de.table=function(re,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+le+`</table>
`},de.tablerow=function(re){return`<tr>
`+re+`</tr>
`},de.tablecell=function(re,le){var ne=le.header?"th":"td",ae=le.align?"<"+ne+' align="'+le.align+'">':"<"+ne+">";return ae+re+("</"+ne+`>
`)},de.strong=function(re){return"<strong>"+re+"</strong>"},de.em=function(re){return"<em>"+re+"</em>"},de.codespan=function(re){return"<code>"+re+"</code>"},de.br=function(){return this.options.xhtml?"<br/>":"<br>"},de.del=function(re){return"<del>"+re+"</del>"},de.link=function(re,le,ne){if(re=v(this.options.sanitize,this.options.baseUrl,re),re===null)return ne;var ae='<a href="'+g(re)+'"';return le&&(ae+=' title="'+le+'"'),ae+=">"+ne+"</a>",ae},de.image=function(re,le,ne){if(re=v(this.options.sanitize,this.options.baseUrl,re),re===null)return ne;var ae='<img src="'+re+'" alt="'+ne+'"';return le&&(ae+=' title="'+le+'"'),ae+=this.options.xhtml?"/>":">",ae},de.text=function(re){return re},ge}(),Se=function(){function ge(){}var de=ge.prototype;return de.strong=function(re){return re},de.em=function(re){return re},de.codespan=function(re){return re},de.del=function(re){return re},de.html=function(re){return re},de.text=function(re){return re},de.link=function(re,le,ne){return""+ne},de.image=function(re,le,ne){return""+ne},de.br=function(){return""},ge}(),Pe=function(){function ge(){this.seen={}}var de=ge.prototype;return de.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},de.getNextSafeSlug=function(re,le){var ne=re,ae=0;if(this.seen.hasOwnProperty(ne)){ae=this.seen[re];do ae++,ne=re+"-"+ae;while(this.seen.hasOwnProperty(ne))}return le||(this.seen[re]=ae,this.seen[ne]=0),ne},de.slug=function(re,le){le===void 0&&(le={});var ne=this.serialize(re);return this.getNextSafeSlug(ne,le.dryrun)},ge}(),$e=function(){function ge(De){this.options=De||ye.defaults,this.options.renderer=this.options.renderer||new Ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Se,this.slugger=new Pe}ge.parse=function(re,le){var ne=new ge(le);return ne.parse(re)},ge.parseInline=function(re,le){var ne=new ge(le);return ne.parseInline(re)};var de=ge.prototype;return de.parse=function(re,le){le===void 0&&(le=!0);var ne="",ae,fe,Ie,F,V,G,J,q,x,ce,Ne,Ue,Qe,Ge,xe,Ye,_e,it,tt,ze=re.length;for(ae=0;ae<ze;ae++){if(ce=re[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(tt=this.options.extensions.renderers[ce.type].call({parser:this},ce),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){ne+=tt||"";continue}switch(ce.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,t(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(q="",J="",F=ce.header.length,fe=0;fe<F;fe++)J+=this.renderer.tablecell(this.parseInline(ce.header[fe].tokens),{header:!0,align:ce.align[fe]});for(q+=this.renderer.tablerow(J),x="",F=ce.rows.length,fe=0;fe<F;fe++){for(G=ce.rows[fe],J="",V=G.length,Ie=0;Ie<V;Ie++)J+=this.renderer.tablecell(this.parseInline(G[Ie].tokens),{header:!1,align:ce.align[Ie]});x+=this.renderer.tablerow(J)}ne+=this.renderer.table(q,x);continue}case"blockquote":{x=this.parse(ce.tokens),ne+=this.renderer.blockquote(x);continue}case"list":{for(Ne=ce.ordered,Ue=ce.start,Qe=ce.loose,F=ce.items.length,x="",fe=0;fe<F;fe++)xe=ce.items[fe],Ye=xe.checked,_e=xe.task,Ge="",xe.task&&(it=this.renderer.checkbox(Ye),Qe?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=it+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=it+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:it}):Ge+=it),Ge+=this.parse(xe.tokens,Qe),x+=this.renderer.listitem(Ge,_e,Ye);ne+=this.renderer.list(x,Ne,Ue);continue}case"html":{ne+=this.renderer.html(ce.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(x=ce.tokens?this.parseInline(ce.tokens):ce.text;ae+1<ze&&re[ae+1].type==="text";)ce=re[++ae],x+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);ne+=le?this.renderer.paragraph(x):x;continue}default:{var st='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return ne},de.parseInline=function(re,le){le=le||this.renderer;var ne="",ae,fe,Ie,F=re.length;for(ae=0;ae<F;ae++){if(fe=re[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(Ie=this.options.extensions.renderers[fe.type].call({parser:this},fe),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type))){ne+=Ie||"";continue}switch(fe.type){case"escape":{ne+=le.text(fe.text);break}case"html":{ne+=le.html(fe.text);break}case"link":{ne+=le.link(fe.href,fe.title,this.parseInline(fe.tokens,le));break}case"image":{ne+=le.image(fe.href,fe.title,fe.text);break}case"strong":{ne+=le.strong(this.parseInline(fe.tokens,le));break}case"em":{ne+=le.em(this.parseInline(fe.tokens,le));break}case"codespan":{ne+=le.codespan(fe.text);break}case"br":{ne+=le.br();break}case"del":{ne+=le.del(this.parseInline(fe.tokens,le));break}case"text":{ne+=le.text(fe.text);break}default:{var V='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return ne},ge}();function pe(ge,de,De){if(typeof ge>"u"||ge===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");if(typeof de=="function"&&(De=de,de=null),de=I({},pe.defaults,de||{}),h(de),De){var re=de.highlight,le;try{le=X.lex(ge,de)}catch(F){return De(F)}var ne=function(V){var G;if(!V)try{de.walkTokens&&pe.walkTokens(le,de.walkTokens),G=$e.parse(le,de)}catch(J){V=J}return de.highlight=re,V?De(V):De(null,G)};if(!re||re.length<3||(delete de.highlight,!le.length))return ne();var ae=0;pe.walkTokens(le,function(F){F.type==="code"&&(ae++,setTimeout(function(){re(F.text,F.lang,function(V,G){if(V)return ne(V);G!=null&&G!==F.text&&(F.text=G,F.escaped=!0),ae--,ae===0&&ne()})},0))}),ae===0&&ne();return}function fe(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+g(F.message+"",!0)+"</pre>";throw F}try{var Ie=X.lex(ge,de);if(de.walkTokens){if(de.async)return Promise.all(pe.walkTokens(Ie,de.walkTokens)).then(function(){return $e.parse(Ie,de)}).catch(fe);pe.walkTokens(Ie,de.walkTokens)}return $e.parse(Ie,de)}catch(F){fe(F)}}pe.options=pe.setOptions=function(ge){return I(pe.defaults,ge),l(pe.defaults),pe},pe.getDefaults=A,pe.defaults=ye.defaults,pe.use=function(){for(var ge=arguments.length,de=new Array(ge),De=0;De<ge;De++)de[De]=arguments[De];var re=I.apply(void 0,[{}].concat(de)),le=pe.defaults.extensions||{renderers:{},childTokens:{}},ne;de.forEach(function(ae){if(ae.extensions&&(ne=!0,ae.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var F=le.renderers?le.renderers[Ie.name]:null;F?le.renderers[Ie.name]=function(){for(var V=arguments.length,G=new Array(V),J=0;J<V;J++)G[J]=arguments[J];var q=Ie.renderer.apply(this,G);return q===!1&&(q=F.apply(this,G)),q}:le.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[Ie.level]?le[Ie.level].unshift(Ie.tokenizer):le[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?le.startBlock?le.startBlock.push(Ie.start):le.startBlock=[Ie.start]:Ie.level==="inline"&&(le.startInline?le.startInline.push(Ie.start):le.startInline=[Ie.start]))}Ie.childTokens&&(le.childTokens[Ie.name]=Ie.childTokens)})),ae.renderer&&function(){var Ie=pe.defaults.renderer||new Ee,F=function(J){var q=Ie[J];Ie[J]=function(){for(var x=arguments.length,ce=new Array(x),Ne=0;Ne<x;Ne++)ce[Ne]=arguments[Ne];var Ue=ae.renderer[J].apply(Ie,ce);return Ue===!1&&(Ue=q.apply(Ie,ce)),Ue}};for(var V in ae.renderer)F(V);re.renderer=Ie}(),ae.tokenizer&&function(){var Ie=pe.defaults.tokenizer||new z,F=function(J){var q=Ie[J];Ie[J]=function(){for(var x=arguments.length,ce=new Array(x),Ne=0;Ne<x;Ne++)ce[Ne]=arguments[Ne];var Ue=ae.tokenizer[J].apply(Ie,ce);return Ue===!1&&(Ue=q.apply(Ie,ce)),Ue}};for(var V in ae.tokenizer)F(V);re.tokenizer=Ie}(),ae.walkTokens){var fe=pe.defaults.walkTokens;re.walkTokens=function(Ie){var F=[];return F.push(ae.walkTokens.call(this,Ie)),fe&&(F=F.concat(fe.call(this,Ie))),F}}ne&&(re.extensions=le),pe.setOptions(re)})},pe.walkTokens=function(ge,de){for(var De=[],re=function(){var fe=ne.value;switch(De=De.concat(de.call(pe,fe)),fe.type){case"table":{for(var Ie=T(fe.header),F;!(F=Ie()).done;){var V=F.value;De=De.concat(pe.walkTokens(V.tokens,de))}for(var G=T(fe.rows),J;!(J=G()).done;)for(var q=J.value,x=T(q),ce;!(ce=x()).done;){var Ne=ce.value;De=De.concat(pe.walkTokens(Ne.tokens,de))}break}case"list":{De=De.concat(pe.walkTokens(fe.items,de));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[fe.type]?pe.defaults.extensions.childTokens[fe.type].forEach(function(Ue){De=De.concat(pe.walkTokens(fe[Ue],de))}):fe.tokens&&(De=De.concat(pe.walkTokens(fe.tokens,de)))}},le=T(ge),ne;!(ne=le()).done;)re();return De},pe.parseInline=function(ge,de){if(typeof ge>"u"||ge===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");de=I({},pe.defaults,de||{}),h(de);try{var De=X.lexInline(ge,de);return de.walkTokens&&pe.walkTokens(De,de.walkTokens),$e.parseInline(De,de)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+g(re.message+"",!0)+"</pre>";throw re}},pe.Parser=$e,pe.parser=$e.parse,pe.Renderer=Ee,pe.TextRenderer=Se,pe.Lexer=X,pe.lexer=X.lex,pe.Tokenizer=z,pe.Slugger=Pe,pe.parse=pe;var ue=pe.options,oe=pe.setOptions,be=pe.use,_=pe.walkTokens,B=pe.parseInline,Z=pe,ee=$e.parse,ve=X.lex;ye.Lexer=X,ye.Parser=$e,ye.Renderer=Ee,ye.Slugger=Pe,ye.TextRenderer=Se,ye.Tokenizer=z,ye.getDefaults=A,ye.lexer=ve,ye.marked=pe,ye.options=ue,ye.parse=Z,ye.parseInline=B,ye.parser=ee,ye.setOptions=oe,ye.use=be,ye.walkTokens=_,Object.defineProperty(ye,"__esModule",{value:!0})}),define(Ae[117],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.rot=e.$Ol=void 0;function y(l,D,$){return Math.min(Math.max(l,D),$)}e.$Ol=y;function M(l,D){return(D+l%D)%D}e.rot=M;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Ql=C;class T{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rl=T;class A{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const $=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sl=A}),function(){function ye(C){const T=[];typeof C=="number"&&T.push("code/timeOrigin",C);function A(D){T.push(D,Date.now())}function l(){const D=[];for(let $=0;$<T.length;$+=2)D.push({name:T[$],startTime:T[$+1]});return D}return{mark:A,getMarks:l}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ye():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(C+A.startTime)});return T}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ye(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ye()}function y(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=y(M))}(),function(ye,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var M in y)(typeof exports=="object"?exports:ye)[M]=y[M]}}(typeof self<"u"?self:this,function(){return function(ye){var e={};function y(M){if(e[M])return e[M].exports;var C=e[M]={i:M,l:!1,exports:{}};return ye[M].call(C.exports,C,C.exports,y),C.l=!0,C.exports}return y.m=ye,y.c=e,y.d=function(M,C,T){y.o(M,C)||Object.defineProperty(M,C,{enumerable:!0,get:T})},y.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},y.t=function(M,C){if(1&C&&(M=y(M)),8&C||4&C&&typeof M=="object"&&M&&M.__esModule)return M;var T=Object.create(null);if(y.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:M}),2&C&&typeof M!="string")for(var A in M)y.d(T,A,function(l){return M[l]}.bind(null,A));return T},y.n=function(M){var C=M&&M.__esModule?function(){return M.default}:function(){return M};return y.d(C,"a",C),C},y.o=function(M,C){return Object.prototype.hasOwnProperty.call(M,C)},y.p="",y(y.s=0)}([function(ye,e,y){(function(M){var C;e=ye.exports=be,C=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,l=e.re=[],D=e.src=[],$=0,R=$++;D[R]="0|[1-9]\\d*";var k=$++;D[k]="[0-9]+";var a=$++;D[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=$++;D[p]="("+D[R]+")\\.("+D[R]+")\\.("+D[R]+")";var g=$++;D[g]="("+D[k]+")\\.("+D[k]+")\\.("+D[k]+")";var d=$++;D[d]="(?:"+D[R]+"|"+D[a]+")";var t=$++;D[t]="(?:"+D[k]+"|"+D[a]+")";var i=$++;D[i]="(?:-("+D[d]+"(?:\\."+D[d]+")*))";var c=$++;D[c]="(?:-?("+D[t]+"(?:\\."+D[t]+")*))";var b=$++;D[b]="[0-9A-Za-z-]+";var E=$++;D[E]="(?:\\+("+D[b]+"(?:\\."+D[b]+")*))";var v=$++,s="v?"+D[p]+D[i]+"?"+D[E]+"?";D[v]="^"+s+"$";var r="[v=\\s]*"+D[g]+D[c]+"?"+D[E]+"?",n=$++;D[n]="^"+r+"$";var o=$++;D[o]="((?:<|>)?=?)";var w=$++;D[w]=D[k]+"|x|X|\\*";var f=$++;D[f]=D[R]+"|x|X|\\*";var I=$++;D[I]="[v=\\s]*("+D[f]+")(?:\\.("+D[f]+")(?:\\.("+D[f]+")(?:"+D[i]+")?"+D[E]+"?)?)?";var S=$++;D[S]="[v=\\s]*("+D[w]+")(?:\\.("+D[w]+")(?:\\.("+D[w]+")(?:"+D[c]+")?"+D[E]+"?)?)?";var u=$++;D[u]="^"+D[o]+"\\s*"+D[I]+"$";var m=$++;D[m]="^"+D[o]+"\\s*"+D[S]+"$";var h=$++;D[h]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=$++;D[P]="(?:~>?)";var W=$++;D[W]="(\\s*)"+D[P]+"\\s+",l[W]=new RegExp(D[W],"g");var K=$++;D[K]="^"+D[P]+D[I]+"$";var z=$++;D[z]="^"+D[P]+D[S]+"$";var j=$++;D[j]="(?:\\^)";var O=$++;D[O]="(\\s*)"+D[j]+"\\s+",l[O]=new RegExp(D[O],"g");var N=$++;D[N]="^"+D[j]+D[I]+"$";var ie=$++;D[ie]="^"+D[j]+D[S]+"$";var X=$++;D[X]="^"+D[o]+"\\s*("+r+")$|^$";var Ee=$++;D[Ee]="^"+D[o]+"\\s*("+s+")$|^$";var Se=$++;D[Se]="(\\s*)"+D[o]+"\\s*("+r+"|"+D[I]+")",l[Se]=new RegExp(D[Se],"g");var Pe=$++;D[Pe]="^\\s*("+D[I]+")\\s+-\\s+("+D[I]+")\\s*$";var $e=$++;D[$e]="^\\s*("+D[S]+")\\s+-\\s+("+D[S]+")\\s*$";var pe=$++;D[pe]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)C(ue,D[ue]),l[ue]||(l[ue]=new RegExp(D[ue]));function oe(q,x){if(q instanceof be)return q;if(typeof q!="string"||q.length>T||!(x?l[n]:l[v]).test(q))return null;try{return new be(q,x)}catch{return null}}function be(q,x){if(q instanceof be){if(q.loose===x)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof be))return new be(q,x);C("SemVer",q,x),this.loose=x;var ce=q.trim().match(x?l[n]:l[v]);if(!ce)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Ue=+Ne;if(Ue>=0&&Ue<A)return Ue}return Ne}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=oe,e.valid=function(q,x){var ce=oe(q,x);return ce?ce.version:null},e.clean=function(q,x){var ce=oe(q.trim().replace(/^[=v]+/,""),x);return ce?ce.version:null},e.SemVer=be,be.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},be.prototype.toString=function(){return this.version},be.prototype.compare=function(q){return C("SemVer.compare",this.version,this.loose,q),q instanceof be||(q=new be(q,this.loose)),this.compareMain(q)||this.comparePre(q)},be.prototype.compareMain=function(q){return q instanceof be||(q=new be(q,this.loose)),B(this.major,q.major)||B(this.minor,q.minor)||B(this.patch,q.patch)},be.prototype.comparePre=function(q){if(q instanceof be||(q=new be(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var x=0;do{var ce=this.prerelease[x],Ne=q.prerelease[x];if(C("prerelease compare",x,ce,Ne),ce===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ce===void 0)return-1;if(ce!==Ne)return B(ce,Ne)}while(++x)},be.prototype.inc=function(q,x){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,x,ce,Ne){typeof ce=="string"&&(Ne=ce,ce=void 0);try{return new be(q,ce).inc(x,Ne).version}catch{return null}},e.diff=function(q,x){if(ge(q,x))return null;var ce=oe(q),Ne=oe(x);if(ce.prerelease.length||Ne.prerelease.length){for(var Ue in ce)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ce[Ue]!==Ne[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ce)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ce[Ue]!==Ne[Ue])return Ue},e.compareIdentifiers=B;var _=/^[0-9]+$/;function B(q,x){var ce=_.test(q),Ne=_.test(x);return ce&&Ne&&(q=+q,x=+x),ce&&!Ne?-1:Ne&&!ce?1:q<x?-1:q>x?1:0}function Z(q,x,ce){return new be(q,ce).compare(new be(x,ce))}function ee(q,x,ce){return Z(q,x,ce)>0}function ve(q,x,ce){return Z(q,x,ce)<0}function ge(q,x,ce){return Z(q,x,ce)===0}function de(q,x,ce){return Z(q,x,ce)!==0}function De(q,x,ce){return Z(q,x,ce)>=0}function re(q,x,ce){return Z(q,x,ce)<=0}function le(q,x,ce,Ne){var Ue;switch(x){case"===":typeof q=="object"&&(q=q.version),typeof ce=="object"&&(ce=ce.version),Ue=q===ce;break;case"!==":typeof q=="object"&&(q=q.version),typeof ce=="object"&&(ce=ce.version),Ue=q!==ce;break;case"":case"=":case"==":Ue=ge(q,ce,Ne);break;case"!=":Ue=de(q,ce,Ne);break;case">":Ue=ee(q,ce,Ne);break;case">=":Ue=De(q,ce,Ne);break;case"<":Ue=ve(q,ce,Ne);break;case"<=":Ue=re(q,ce,Ne);break;default:throw new TypeError("Invalid operator: "+x)}return Ue}function ne(q,x){if(q instanceof ne){if(q.loose===x)return q;q=q.value}if(!(this instanceof ne))return new ne(q,x);C("comparator",q,x),this.loose=x,this.parse(q),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(q,x){return B(x,q)},e.major=function(q,x){return new be(q,x).major},e.minor=function(q,x){return new be(q,x).minor},e.patch=function(q,x){return new be(q,x).patch},e.compare=Z,e.compareLoose=function(q,x){return Z(q,x,!0)},e.rcompare=function(q,x,ce){return Z(x,q,ce)},e.sort=function(q,x){return q.sort(function(ce,Ne){return e.compare(ce,Ne,x)})},e.rsort=function(q,x){return q.sort(function(ce,Ne){return e.rcompare(ce,Ne,x)})},e.gt=ee,e.lt=ve,e.eq=ge,e.neq=de,e.gte=De,e.lte=re,e.cmp=le,e.Comparator=ne;var ae={};function fe(q,x){if(q instanceof fe)return q.loose===x?q:new fe(q.raw,x);if(q instanceof ne)return new fe(q.value,x);if(!(this instanceof fe))return new fe(q,x);if(this.loose=x,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Ie(q){return!q||q.toLowerCase()==="x"||q==="*"}function F(q,x,ce,Ne,Ue,Qe,Ge,xe,Ye,_e,it,tt,ze){return((x=Ie(ce)?"":Ie(Ne)?">="+ce+".0.0":Ie(Ue)?">="+ce+"."+Ne+".0":">="+x)+" "+(xe=Ie(Ye)?"":Ie(_e)?"<"+(+Ye+1)+".0.0":Ie(it)?"<"+Ye+"."+(+_e+1)+".0":tt?"<="+Ye+"."+_e+"."+it+"-"+tt:"<="+xe)).trim()}function V(q,x){for(var ce=0;ce<q.length;ce++)if(!q[ce].test(x))return!1;if(x.prerelease.length){for(ce=0;ce<q.length;ce++)if(C(q[ce].semver),q[ce].semver!==ae&&q[ce].semver.prerelease.length>0){var Ne=q[ce].semver;if(Ne.major===x.major&&Ne.minor===x.minor&&Ne.patch===x.patch)return!0}return!1}return!0}function G(q,x,ce){try{x=new fe(x,ce)}catch{return!1}return x.test(q)}function J(q,x,ce,Ne){var Ue,Qe,Ge,xe,Ye;switch(q=new be(q,Ne),x=new fe(x,Ne),ce){case">":Ue=ee,Qe=re,Ge=ve,xe=">",Ye=">=";break;case"<":Ue=ve,Qe=De,Ge=ee,xe="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(q,x,Ne))return!1;for(var _e=0;_e<x.set.length;++_e){var it=x.set[_e],tt=null,ze=null;if(it.forEach(function(st){st.semver===ae&&(st=new ne(">=0.0.0")),tt=tt||st,ze=ze||st,Ue(st.semver,tt.semver,Ne)?tt=st:Ge(st.semver,ze.semver,Ne)&&(ze=st)}),tt.operator===xe||tt.operator===Ye||(!ze.operator||ze.operator===xe)&&Qe(q,ze.semver)||ze.operator===Ye&&Ge(q,ze.semver))return!1}return!0}ne.prototype.parse=function(q){var x=this.loose?l[X]:l[Ee],ce=q.match(x);if(!ce)throw new TypeError("Invalid comparator: "+q);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new be(ce[2],this.loose):this.semver=ae},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(q){return C("Comparator.test",q,this.loose),this.semver===ae||(typeof q=="string"&&(q=new be(q,this.loose)),le(q,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(q,x){if(!(q instanceof ne))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new fe(q.value,x),G(this.value,ce,x);if(q.operator==="")return ce=new fe(this.value,x),G(q.semver,ce,x);var Ne=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Qe=this.semver.version===q.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),xe=le(this.semver,"<",q.semver,x)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),Ye=le(this.semver,">",q.semver,x)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Ne||Ue||Qe&&Ge||xe||Ye},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(q){var x=this.loose;q=q.trim(),C("range",q,x);var ce=x?l[$e]:l[Pe];q=q.replace(ce,F),C("hyphen replace",q),q=q.replace(l[Se],"$1$2$3"),C("comparator trim",q,l[Se]),q=(q=(q=q.replace(l[W],"$1~")).replace(l[O],"$1^")).split(/\s+/).join(" ");var Ne=x?l[X]:l[Ee],Ue=q.split(" ").map(function(Qe){return function(Ge,xe){return C("comp",Ge),Ge=function(Ye,_e){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){C("caret",tt,ze);var st=ze?l[ie]:l[N];return tt.replace(st,function(Y,Q,we,Be,Oe){var Xe;return C("caret",tt,Y,Q,we,Be,Oe),Ie(Q)?Xe="":Ie(we)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ie(Be)?Xe=Q==="0"?">="+Q+"."+we+".0 <"+Q+"."+(+we+1)+".0":">="+Q+"."+we+".0 <"+(+Q+1)+".0.0":Oe?(C("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Xe=Q==="0"?we==="0"?">="+Q+"."+we+"."+Be+Oe+" <"+Q+"."+we+"."+(+Be+1):">="+Q+"."+we+"."+Be+Oe+" <"+Q+"."+(+we+1)+".0":">="+Q+"."+we+"."+Be+Oe+" <"+(+Q+1)+".0.0"):(C("no pr"),Xe=Q==="0"?we==="0"?">="+Q+"."+we+"."+Be+" <"+Q+"."+we+"."+(+Be+1):">="+Q+"."+we+"."+Be+" <"+Q+"."+(+we+1)+".0":">="+Q+"."+we+"."+Be+" <"+(+Q+1)+".0.0"),C("caret return",Xe),Xe})}(it,_e)}).join(" ")}(Ge,xe),C("caret",Ge),Ge=function(Ye,_e){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){var st=ze?l[z]:l[K];return tt.replace(st,function(Y,Q,we,Be,Oe){var Xe;return C("tilde",tt,Y,Q,we,Be,Oe),Ie(Q)?Xe="":Ie(we)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ie(Be)?Xe=">="+Q+"."+we+".0 <"+Q+"."+(+we+1)+".0":Oe?(C("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Xe=">="+Q+"."+we+"."+Be+Oe+" <"+Q+"."+(+we+1)+".0"):Xe=">="+Q+"."+we+"."+Be+" <"+Q+"."+(+we+1)+".0",C("tilde return",Xe),Xe})}(it,_e)}).join(" ")}(Ge,xe),C("tildes",Ge),Ge=function(Ye,_e){return C("replaceXRanges",Ye,_e),Ye.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var st=ze?l[m]:l[u];return tt.replace(st,function(Y,Q,we,Be,Oe,Xe){C("xRange",tt,Y,Q,we,Be,Oe,Xe);var nt=Ie(we),ft=nt||Ie(Be),wt=ft||Ie(Oe);return Q==="="&&wt&&(Q=""),nt?Y=Q===">"||Q==="<"?"<0.0.0":"*":Q&&wt?(ft&&(Be=0),wt&&(Oe=0),Q===">"?(Q=">=",ft?(we=+we+1,Be=0,Oe=0):wt&&(Be=+Be+1,Oe=0)):Q==="<="&&(Q="<",ft?we=+we+1:Be=+Be+1),Y=Q+we+"."+Be+"."+Oe):ft?Y=">="+we+".0.0 <"+(+we+1)+".0.0":wt&&(Y=">="+we+"."+Be+".0 <"+we+"."+(+Be+1)+".0"),C("xRange return",Y),Y})}(it,_e)}).join(" ")}(Ge,xe),C("xrange",Ge),Ge=function(Ye,_e){return C("replaceStars",Ye,_e),Ye.trim().replace(l[pe],"")}(Ge,xe),C("stars",Ge),Ge}(Qe,x)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Qe){return!!Qe.match(Ne)})),Ue=Ue.map(function(Qe){return new ne(Qe,x)})},fe.prototype.intersects=function(q,x){if(!(q instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(Ne){return q.set.some(function(Ue){return Ue.every(function(Qe){return Ne.intersects(Qe,x)})})})})},e.toComparators=function(q,x){return new fe(q,x).set.map(function(ce){return ce.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new be(q,this.loose));for(var x=0;x<this.set.length;x++)if(V(this.set[x],q))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(q,x,ce){var Ne=null,Ue=null;try{var Qe=new fe(x,ce)}catch{return null}return q.forEach(function(Ge){Qe.test(Ge)&&(Ne&&Ue.compare(Ge)!==-1||(Ue=new be(Ne=Ge,ce)))}),Ne},e.minSatisfying=function(q,x,ce){var Ne=null,Ue=null;try{var Qe=new fe(x,ce)}catch{return null}return q.forEach(function(Ge){Qe.test(Ge)&&(Ne&&Ue.compare(Ge)!==1||(Ue=new be(Ne=Ge,ce)))}),Ne},e.validRange=function(q,x){try{return new fe(q,x).range||"*"}catch{return null}},e.ltr=function(q,x,ce){return J(q,x,"<",ce)},e.gtr=function(q,x,ce){return J(q,x,">",ce)},e.outside=J,e.prerelease=function(q,x){var ce=oe(q,x);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(q,x,ce){return q=new fe(q,ce),x=new fe(x,ce),q.intersects(x)},e.coerce=function(q){if(q instanceof be)return q;if(typeof q!="string")return null;var x=q.match(l[h]);return x==null?null:oe((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,y(1))},function(ye,e){var y,M,C=ye.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function l(t){if(y===setTimeout)return setTimeout(t,0);if((y===T||!y)&&setTimeout)return y=setTimeout,setTimeout(t,0);try{return y(t,0)}catch{try{return y.call(null,t,0)}catch{return y.call(this,t,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:T}catch{y=T}try{M=typeof clearTimeout=="function"?clearTimeout:A}catch{M=A}})();var D,$=[],R=!1,k=-1;function a(){R&&D&&(R=!1,D.length?$=D.concat($):k=-1,$.length&&p())}function p(){if(!R){var t=l(a);R=!0;for(var i=$.length;i;){for(D=$,$=[];++k<i;)D&&D[k].run();k=-1,i=$.length}D=null,R=!1,function(c){if(M===clearTimeout)return clearTimeout(c);if((M===A||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(c);try{M(c)}catch{try{return M.call(null,c)}catch{return M.call(this,c)}}}(t)}}function g(t,i){this.fun=t,this.array=i}function d(){}C.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)i[c-1]=arguments[c];$.push(new g(t,i)),$.length!==1||R||l(p)},g.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=d,C.addListener=d,C.once=d,C.off=d,C.removeListener=d,C.removeAllListeners=d,C.emit=d,C.prependListener=d,C.prependOnceListener=d,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ae[118],Re([1,0,9,6]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function C(E){const v=E;return v?typeof v.read=="function":!1}e.$Yd=C;function T(E){const v=E;return v?[v.on,v.pause,v.resume,v.destroy].every(s=>typeof s=="function"):!1}e.$Zd=T;function A(E){const v=E;return v?T(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.$1d=A;function l(E,v){return new D(E,v)}e.$2d=l;class D{constructor(v,s){this.e=v,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(s=>s(v))}h(v){this.c.error.length===0?(0,y.$1)(v):this.c.error.slice(0).forEach(s=>s(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,s){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(v,s){if(this.a.destroyed)return;let r;switch(v){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const n=r.indexOf(s);n>=0&&r.splice(n,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(E,v){const s=[];let r;for(;(r=E.read())!==null;)s.push(r);return v(s)}e.$3d=$;function R(E,v,s){const r=[];let n;for(;(n=E.read())!==null&&r.length<s;)r.push(n);return n===null&&r.length>0?v(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const o=n;return n=void 0,o}return E.read()}}}e.$4d=R;function k(E,v){return new Promise((s,r)=>{const n=[];a(E,{onData:o=>{v&&n.push(o)},onError:o=>{v?r(o):s(void 0)},onEnd:()=>{s(v?v(n):void 0)}})})}e.$5d=k;function a(E,v,s){E.on("error",r=>{s?.isCancellationRequested||v.onError(r)}),E.on("end",()=>{s?.isCancellationRequested||v.onEnd()}),E.on("data",r=>{s?.isCancellationRequested||v.onData(r)})}e.$6d=a;function p(E,v){return new Promise((s,r)=>{const n=new M.$Rc,o=[],w=S=>{if(o.push(S),o.length>v)return n.dispose(),E.pause(),s({stream:E,buffer:o,ended:!1})},f=S=>(n.dispose(),r(S)),I=()=>(n.dispose(),s({stream:E,buffer:o,ended:!0}));n.add((0,M.$Qc)(()=>E.removeListener("error",f))),E.on("error",f),n.add((0,M.$Qc)(()=>E.removeListener("end",I))),E.on("end",I),n.add((0,M.$Qc)(()=>E.removeListener("data",w))),E.on("data",w)})}e.$7d=p;function g(E,v){const s=l(v);return s.end(E),s}e.$8d=g;function d(){const E=l(()=>{throw new Error("not supported")});return E.end(),E}e.$9d=d;function t(E){let v=!1;return{read:()=>v?null:(v=!0,E)}}e.$0d=t;function i(E,v,s){const r=l(s);return a(E,{onData:n=>r.write(v.data(n)),onError:n=>r.error(v.error?v.error(n):n),onEnd:()=>r.end()}),r}e.$$d=i;function c(E,v,s){let r=!1;return{read:()=>{const n=v.read();return r?n:(r=!0,n!==null?s([E,n]):E)}}}e.$_d=c;function b(E,v,s){let r=!1;const n=l(s);return a(v,{onData:o=>r?n.write(o):(r=!0,n.write(s([E,o]))),onError:o=>n.error(o),onEnd:()=>{r||(r=!0,n.write(E)),n.end()}}),n}e.$ae=b}),define(Ae[26],Re([1,0,41,118]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const C=typeof Buffer<"u",T=new y.$V(()=>new Uint8Array(256));let A,l;class D{static alloc(h){return C?new D(Buffer.allocUnsafe(h)):new D(new Uint8Array(h))}static wrap(h){return C&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new D(h)}static fromString(h,P){return!(P?.dontUseNodeBuffer||!1)&&C?new D(Buffer.from(h)):(A||(A=new TextEncoder),new D(A.encode(h)))}static fromByteArray(h){const P=D.alloc(h.length);for(let W=0,K=h.length;W<K;W++)P.buffer[W]=h[W];return P}static concat(h,P){if(typeof P>"u"){P=0;for(let z=0,j=h.length;z<j;z++)P+=h[z].byteLength}const W=D.alloc(P);let K=0;for(let z=0,j=h.length;z<j;z++){const O=h[z];W.set(O,K),K+=O.byteLength}return W}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=D.alloc(this.byteLength);return h.set(this),h}toString(){return C?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(h,P){return new D(this.buffer.subarray(h,P))}set(h,P){if(h instanceof D)this.buffer.set(h.buffer,P);else if(h instanceof Uint8Array)this.buffer.set(h,P);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),P);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return a(this.buffer,h)}writeUInt32BE(h,P){p(this.buffer,h,P)}readUInt32LE(h){return g(this.buffer,h)}writeUInt32LE(h,P){d(this.buffer,h,P)}readUInt8(h){return t(this.buffer,h)}writeUInt8(h,P){i(this.buffer,h,P)}indexOf(h,P=0){return $(this.buffer,h instanceof D?h.buffer:h,P)}}e.$be=D;function $(m,h,P=0){const W=h.byteLength,K=m.byteLength;if(W===0)return 0;if(W===1)return m.indexOf(h[0]);if(W>K-P)return-1;const z=T.value;z.fill(h.length);for(let ie=0;ie<h.length;ie++)z[h[ie]]=h.length-ie-1;let j=P+h.length-1,O=j,N=-1;for(;j<K;)if(m[j]===h[O]){if(O===0){N=j;break}j--,O--}else j+=Math.max(h.length-O,z[m[j]]),O=h.length-1;return N}e.$ce=$;function R(m,h){return m[h+0]<<0>>>0|m[h+1]<<8>>>0}e.$de=R;function k(m,h,P){m[P+0]=h&255,h=h>>>8,m[P+1]=h&255}e.$ee=k;function a(m,h){return m[h]*2**24+m[h+1]*2**16+m[h+2]*2**8+m[h+3]}e.$fe=a;function p(m,h,P){m[P+3]=h,h=h>>>8,m[P+2]=h,h=h>>>8,m[P+1]=h,h=h>>>8,m[P]=h}e.$ge=p;function g(m,h){return m[h+0]<<0>>>0|m[h+1]<<8>>>0|m[h+2]<<16>>>0|m[h+3]<<24>>>0}e.$he=g;function d(m,h,P){m[P+0]=h&255,h=h>>>8,m[P+1]=h&255,h=h>>>8,m[P+2]=h&255,h=h>>>8,m[P+3]=h&255}e.$ie=d;function t(m,h){return m[h]}e.$je=t;function i(m,h,P){m[P]=h}e.$ke=i;function c(m){return M.$3d(m,h=>D.concat(h))}e.$le=c;function b(m){return M.$0d(m)}e.$me=b;function E(m){return M.$5d(m,h=>D.concat(h))}e.$ne=E;async function v(m){return m.ended?D.concat(m.buffer):D.concat([...m.buffer,await E(m.stream)])}e.$oe=v;function s(m){return M.$8d(m,h=>D.concat(h))}e.$pe=s;function r(m){return M.$$d(m,{data:h=>typeof h=="string"?D.fromString(h):D.wrap(h)},h=>D.concat(h))}e.$qe=r;function n(m){return M.$2d(h=>D.concat(h),m)}e.$re=n;function o(m,h){return M.$_d(m,h,P=>D.concat(P))}e.$se=o;function w(m,h){return M.$ae(m,h,P=>D.concat(P))}e.$te=w;function f(m){let h=0,P=0,W=0;const K=new Uint8Array(Math.floor(m.length/4*3)),z=O=>{switch(P){case 3:K[W++]=h|O,P=0;break;case 2:K[W++]=h|O>>>2,h=O<<6,P=3;break;case 1:K[W++]=h|O>>>4,h=O<<4,P=2;break;default:h=O<<2,P=1}};for(let O=0;O<m.length;O++){const N=m.charCodeAt(O);if(N>=65&&N<=90)z(N-65);else if(N>=97&&N<=122)z(N-97+26);else if(N>=48&&N<=57)z(N-48+52);else if(N===43||N===45)z(62);else if(N===47||N===95)z(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${m[O]}`)}}const j=W;for(;P>0;)z(0);return D.wrap(K).slice(0,j)}e.$ue=f;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:m},h=!0,P=!1){const W=P?S:I;let K="";const z=m.byteLength%3;let j=0;for(;j<m.byteLength-z;j+=3){const O=m[j+0],N=m[j+1],ie=m[j+2];K+=W[O>>>2],K+=W[(O<<4|N>>>4)&63],K+=W[(N<<2|ie>>>6)&63],K+=W[ie&63]}if(z===1){const O=m[j+0];K+=W[O>>>2],K+=W[O<<4&63],h&&(K+="==")}else if(z===2){const O=m[j+0],N=m[j+1];K+=W[O>>>2],K+=W[(O<<4|N>>>4)&63],K+=W[N<<2&63],h&&(K+="=")}return K}e.$ve=u}),define(Ae[119],Re([1,0,28,16]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.FuzzyScore=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.or=void 0;function C(...ne){return function(ae,fe){for(let Ie=0,F=ne.length;Ie<F;Ie++){const V=ne[Ie](ae,fe);if(V)return V}return null}}e.or=C,e.$Cj=T.bind(void 0,!1),e.$Dj=T.bind(void 0,!0);function T(ne,ae,fe){if(!fe||fe.length<ae.length)return null;let Ie;return ne?Ie=M.$3e(fe,ae):Ie=fe.indexOf(ae)===0,Ie?ae.length>0?[{start:0,end:ae.length}]:[]:null}function A(ne,ae){const fe=ae.toLowerCase().indexOf(ne.toLowerCase());return fe===-1?null:[{start:fe,end:fe+ne.length}]}e.$Ej=A;function l(ne,ae){return D(ne.toLowerCase(),ae.toLowerCase(),0,0)}e.$Fj=l;function D(ne,ae,fe,Ie){if(fe===ne.length)return[];if(Ie===ae.length)return null;if(ne[fe]===ae[Ie]){let F=null;return(F=D(ne,ae,fe+1,Ie+1))?i({start:Ie,end:Ie+1},F):null}return D(ne,ae,fe,Ie+1)}function $(ne){return 97<=ne&&ne<=122}function R(ne){return 65<=ne&&ne<=90}e.$Gj=R;function k(ne){return 48<=ne&&ne<=57}function a(ne){return ne===32||ne===9||ne===10||ne===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>p.add(ne.charCodeAt(0)));function g(ne){return a(ne)||p.has(ne)}function d(ne,ae){return ne===ae||g(ne)&&g(ae)}function t(ne){return $(ne)||R(ne)||k(ne)}function i(ne,ae){return ae.length===0?ae=[ne]:ne.end===ae[0].start?ae[0].start=ne.start:ae.unshift(ne),ae}function c(ne,ae){for(let fe=ae;fe<ne.length;fe++){const Ie=ne.charCodeAt(fe);if(R(Ie)||k(Ie)||fe>0&&!t(ne.charCodeAt(fe-1)))return fe}return ne.length}function b(ne,ae,fe,Ie){if(fe===ne.length)return[];if(Ie===ae.length)return null;if(ne[fe]!==ae[Ie].toLowerCase())return null;{let F=null,V=Ie+1;for(F=b(ne,ae,fe+1,Ie+1);!F&&(V=c(ae,V))<ae.length;)F=b(ne,ae,fe+1,V),V++;return F===null?null:i({start:Ie,end:Ie+1},F)}}function E(ne){let ae=0,fe=0,Ie=0,F=0,V=0;for(let ce=0;ce<ne.length;ce++)V=ne.charCodeAt(ce),R(V)&&ae++,$(V)&&fe++,t(V)&&Ie++,k(V)&&F++;const G=ae/ne.length,J=fe/ne.length,q=Ie/ne.length,x=F/ne.length;return{upperPercent:G,lowerPercent:J,alphaPercent:q,numericPercent:x}}function v(ne){const{upperPercent:ae,lowerPercent:fe}=ne;return fe===0&&ae>.6}function s(ne){const{upperPercent:ae,lowerPercent:fe,alphaPercent:Ie,numericPercent:F}=ne;return fe>.2&&ae<.8&&Ie>.6&&F<.2}function r(ne){let ae=0,fe=0,Ie=0,F=0;for(let V=0;V<ne.length;V++)Ie=ne.charCodeAt(V),R(Ie)&&ae++,$(Ie)&&fe++,a(Ie)&&F++;return(ae===0||fe===0)&&F===0?ne.length<=30:ae<=5}function n(ne,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!r(ne)||ae.length>60)return null;const fe=E(ae);if(!s(fe)){if(!v(fe))return null;ae=ae.toLowerCase()}let Ie=null,F=0;for(ne=ne.toLowerCase();F<ae.length&&(Ie=b(ne,ae,0,F))===null;)F=c(ae,F+1);return Ie}e.$Hj=n;function o(ne,ae,fe=!1){if(!ae||ae.length===0)return null;let Ie=null,F=0;for(ne=ne.toLowerCase(),ae=ae.toLowerCase();F<ae.length&&(Ie=w(ne,ae,0,F,fe))===null;)F=f(ae,F+1);return Ie}e.$Ij=o;function w(ne,ae,fe,Ie,F){if(fe===ne.length)return[];if(Ie===ae.length)return null;if(d(ne.charCodeAt(fe),ae.charCodeAt(Ie))){let V=null,G=Ie+1;if(V=w(ne,ae,fe+1,Ie+1,F),!F)for(;!V&&(G=f(ae,G))<ae.length;)V=w(ne,ae,fe+1,G,F),G++;return V?ne.charCodeAt(fe)!==ae.charCodeAt(Ie)?V:i({start:Ie,end:Ie+1},V):null}else return null}function f(ne,ae){for(let fe=ae;fe<ne.length;fe++)if(g(ne.charCodeAt(fe))||fe>0&&g(ne.charCodeAt(fe-1)))return fe;return ne.length}const I=C(e.$Dj,n,A),S=C(e.$Dj,n,l),u=new y.$Dc(1e4);function m(ne,ae,fe=!1){if(typeof ne!="string"||typeof ae!="string")return null;let Ie=u.get(ne);Ie||(Ie=new RegExp(M.$Le(ne),"i"),u.set(ne,Ie));const F=Ie.exec(ae);return F?[{start:F.index,end:F.index+F[0].length}]:fe?S(ne,ae):I(ne,ae)}e.$Jj=m;function h(ne,ae){const fe=ee(ne,ne.toLowerCase(),0,ae,ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return fe?W(fe):null}e.$Kj=h;function P(ne,ae,fe,Ie,F,V){const G=Math.min(13,ne.length);for(;fe<G;fe++){const J=ee(ne,ae,fe,Ie,F,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,V]}e.$Lj=P;function W(ne){if(typeof ne>"u")return[];const ae=[],fe=ne[1];for(let Ie=ne.length-1;Ie>1;Ie--){const F=ne[Ie]+fe,V=ae[ae.length-1];V&&V.end===F?V.end=F+1:ae.push({start:F,end:F+1})}return ae}e.$Mj=W;const K=128;function z(){const ne=[],ae=[];for(let fe=0;fe<=K;fe++)ae[fe]=0;for(let fe=0;fe<=K;fe++)ne.push(ae.slice(0));return ne}function j(ne){const ae=[];for(let fe=0;fe<=ne;fe++)ae[fe]=0;return ae}const O=j(2*K),N=j(2*K),ie=z(),X=z(),Ee=z(),Se=!1;function Pe(ne,ae,fe,Ie,F){function V(J,q,x=" "){for(;J.length<q;)J=x+J;return J}let G=` |   |${Ie.split("").map(J=>V(J,3)).join("|")}
`;for(let J=0;J<=fe;J++)J===0?G+=" |":G+=`${ae[J-1]}|`,G+=ne[J].slice(0,F+1).map(q=>V(q.toString(),3)).join("|")+`
`;return G}function $e(ne,ae,fe,Ie){ne=ne.substr(ae),fe=fe.substr(Ie),console.log(Pe(X,ne,ne.length,fe,fe.length)),console.log(Pe(Ee,ne,ne.length,fe,fe.length)),console.log(Pe(ie,ne,ne.length,fe,fe.length))}function pe(ne,ae){if(ae<0||ae>=ne.length)return!1;const fe=ne.codePointAt(ae);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$if(fe)}}function ue(ne,ae){if(ae<0||ae>=ne.length)return!1;switch(ne.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function oe(ne,ae,fe){return ae[ne]!==fe[ne]}function be(ne,ae,fe,Ie,F,V,G=!1){for(;ae<fe&&F<V;)ne[ae]===Ie[F]&&(G&&(O[ae]=F),ae+=1),F+=1;return ae===fe}e.$Nj=be;var _;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(_||(_={}));var B;(function(ne){ne.Default=[-100,0];function ae(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}ne.isDefault=ae})(B||(e.FuzzyScore=B={}));class Z{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ae,fe){this.firstMatchCanBeWeak=ae,this.boostFullMatch=fe}}e.$Oj=Z;function ee(ne,ae,fe,Ie,F,V,G=Z.default){const J=ne.length>K?K:ne.length,q=Ie.length>K?K:Ie.length;if(fe>=J||V>=q||J-fe>q-V||!be(ae,fe,J,F,V,q,!0))return;ve(J,q,fe,V,ae,F);let x=1,ce=1,Ne=fe,Ue=V;const Qe=[!1];for(x=1,Ne=fe;Ne<J;x++,Ne++){const it=O[Ne],tt=N[Ne],ze=Ne+1<J?N[Ne+1]:q;for(ce=it-V+1,Ue=it;Ue<ze;ce++,Ue++){let st=Number.MIN_SAFE_INTEGER,Y=!1;Ue<=tt&&(st=ge(ne,ae,Ne,fe,Ie,F,Ue,q,V,ie[x-1][ce-1]===0,Qe));let Q=0;st!==Number.MAX_SAFE_INTEGER&&(Y=!0,Q=st+X[x-1][ce-1]);const we=Ue>it,Be=we?X[x][ce-1]+(ie[x][ce-1]>0?-5:0):0,Oe=Ue>it+1&&ie[x][ce-1]>0,Xe=Oe?X[x][ce-2]+(ie[x][ce-2]>0?-5:0):0;if(Oe&&(!we||Xe>=Be)&&(!Y||Xe>=Q))X[x][ce]=Xe,Ee[x][ce]=3,ie[x][ce]=0;else if(we&&(!Y||Be>=Q))X[x][ce]=Be,Ee[x][ce]=2,ie[x][ce]=0;else if(Y)X[x][ce]=Q,Ee[x][ce]=1,ie[x][ce]=ie[x-1][ce-1]+1;else throw new Error("not possible")}}if(Se&&$e(ne,fe,Ie,V),!Qe[0]&&!G.firstMatchCanBeWeak)return;x--,ce--;const Ge=[X[x][ce],V];let xe=0,Ye=0;for(;x>=1;){let it=ce;do{const tt=Ee[x][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);xe>1&&ae[fe+x-1]===F[V+ce-1]&&!oe(it+V-1,Ie,F)&&xe+1>ie[x][it]&&(it=ce),it===ce?xe++:xe=1,Ye||(Ye=it),x--,ce=it-1,Ge.push(ce)}q===J&&G.boostFullMatch&&(Ge[0]+=2);const _e=Ye-J;return Ge[0]-=_e,Ge}e.$Pj=ee;function ve(ne,ae,fe,Ie,F,V){let G=ne-1,J=ae-1;for(;G>=fe&&J>=Ie;)F[G]===V[J]&&(N[G]=J,G--),J--}function ge(ne,ae,fe,Ie,F,V,G,J,q,x,ce){if(ae[fe]!==V[G])return Number.MIN_SAFE_INTEGER;let Ne=1,Ue=!1;return G===fe-Ie?Ne=ne[fe]===F[G]?7:5:oe(G,F,V)&&(G===0||!oe(G-1,F,V))?(Ne=ne[fe]===F[G]?7:5,Ue=!0):pe(V,G)&&(G===0||!pe(V,G-1))?Ne=5:(pe(V,G-1)||ue(V,G-1))&&(Ne=5,Ue=!0),Ne>1&&fe===Ie&&(ce[0]=!0),Ue||(Ue=oe(G,F,V)||pe(V,G-1)||ue(V,G-1)),fe===Ie?G>q&&(Ne-=Ue?3:5):x?Ne+=Ue?2:0:Ne+=Ue?0:1,G+1===J&&(Ne-=Ue?3:5),Ne}function de(ne,ae,fe,Ie,F,V,G){return re(ne,ae,fe,Ie,F,V,!0,G)}e.$Qj=de;function De(ne,ae,fe,Ie,F,V,G){return re(ne,ae,fe,Ie,F,V,!1,G)}e.$Rj=De;function re(ne,ae,fe,Ie,F,V,G,J){let q=ee(ne,ae,fe,Ie,F,V,J);if(q&&!G)return q;if(ne.length>=3){const x=Math.min(7,ne.length-1);for(let ce=fe+1;ce<x;ce++){const Ne=le(ne,ce);if(Ne){const Ue=ee(Ne,Ne.toLowerCase(),fe,Ie,F,V,J);Ue&&(Ue[0]-=3,(!q||Ue[0]>q[0])&&(q=Ue))}}}return q}function le(ne,ae){if(ae+1>=ne.length)return;const fe=ne[ae],Ie=ne[ae+1];if(fe!==Ie)return ne.slice(0,ae)+Ie+fe+ne.slice(ae+2)}}),define(Ae[29],Re([1,0,16]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(M||(M={})),function(C){const T="error",A="warning",l="warn",D="info",$="ignore";function R(a){return a?y.$2e(T,a)?C.Error:y.$2e(A,a)||y.$2e(l,a)?C.Warning:y.$2e(D,a)?C.Info:C.Ignore:C.Ignore}C.fromValue=R;function k(a){switch(a){case C.Error:return T;case C.Warning:return A;case C.Info:return D;default:return $}}C.toString=k}(M||(M={})),e.default=M}),define(Ae[120],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(Ae[49],Re([1,0,18,16]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=void 0;class C{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const g=p.charCodeAt(0),d=this.b.charCodeAt(this.c);return g-d}value(){return this.b[this.c]}}e.$Rh=C;class T{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,M.$Ve)(p,this.b,0,p.length,this.c,this.d):(0,M.$Xe)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Sh=T;class A{constructor(p=!0,g=!0){this.f=p,this.g=g}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let g=p.length-1;g>=0;g--,this.c--){const d=this.b.charCodeAt(g);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,M.$Ve)(p,this.b,0,p.length,this.d,this.e):(0,M.$Xe)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Th=A;var l;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(l||(l={}));class D{constructor(p,g){this.f=p,this.g=g,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,M.$We)(p,this.c.scheme);if(this.d[this.e]===2)return(0,M.$We)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,M.$Ue)(p,this.c.query);if(this.d[this.e]===5)return(0,M.$Ue)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Uh=D;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(R||(R={}));class k{static forUris(p=()=>!1,g=()=>!1){return new k(new D(p,g))}static forPaths(p=!1){return new k(new A(void 0,!p))}static forStrings(){return new k(new C)}static forConfigKeys(){return new k(new T)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,g){if(g){const d=g.slice(0);(0,y.$Xb)(d);for(const t of d)this.set(t,p)}else{const d=p.slice(0);(0,y.$Xb)(d);for(const t of d)this.set(t[0],t[1])}}set(p,g){const d=this.b.reset(p);let t;this.c||(this.c=new $,this.c.segment=d.value());const i=[];for(t=this.c;;){const b=d.cmp(t.segment);if(b>0)t.left||(t.left=new $,t.left.segment=d.value()),i.push([-1,t]),t=t.left;else if(b<0)t.right||(t.right=new $,t.right.segment=d.value()),i.push([1,t]),t=t.right;else if(d.hasNext())d.next(),t.mid||(t.mid=new $,t.mid.segment=d.value()),i.push([0,t]),t=t.mid;else break}const c=t.value;t.value=g,t.key=p;for(let b=i.length-1;b>=0;b--){const E=i[b][1];E.updateHeight();const v=E.balanceFactor();if(v<-1||v>1){const s=i[b][0],r=i[b+1][0];if(s===1&&r===1)i[b][1]=E.rotateLeft();else if(s===-1&&r===-1)i[b][1]=E.rotateRight();else if(s===1&&r===-1)E.right=i[b+1][1]=i[b+1][1].rotateRight(),i[b][1]=E.rotateLeft();else if(s===-1&&r===1)E.left=i[b+1][1]=i[b+1][1].rotateLeft(),i[b][1]=E.rotateRight();else throw new Error;if(b>0)switch(i[b-1][0]){case-1:i[b-1][1].left=i[b][1];break;case 1:i[b-1][1].right=i[b][1];break;case 0:i[b-1][1].mid=i[b][1];break}else this.c=i[0][1]}}return c}get(p){return this.d(p)?.value}d(p){const g=this.b.reset(p);let d=this.c;for(;d;){const t=g.cmp(d.segment);if(t>0)d=d.left;else if(t<0)d=d.right;else if(g.hasNext())g.next(),d=d.mid;else break}return d}has(p){const g=this.d(p);return!(g?.value===void 0&&g?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,g){const d=this.b.reset(p),t=[];let i=this.c;for(;i;){const c=d.cmp(i.segment);if(c>0)t.push([-1,i]),i=i.left;else if(c<0)t.push([1,i]),i=i.right;else if(d.hasNext())d.next(),t.push([0,i]),i=i.mid;else break}if(i){if(g?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const c=this.f(i.right);if(c.key){const{key:b,value:E,segment:v}=c;this.e(c.key,!1),i.key=b,i.value=E,i.segment=v}}else{const c=i.left??i.right;if(t.length>0){const[b,E]=t[t.length-1];switch(b){case-1:E.left=c;break;case 0:E.mid=c;break;case 1:E.right=c;break}}else this.c=c}for(let c=t.length-1;c>=0;c--){const b=t[c][1];b.updateHeight();const E=b.balanceFactor();if(E>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),t[c][1]=b.rotateLeft()):E<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),t[c][1]=b.rotateRight()),c>0)switch(t[c-1][0]){case-1:t[c-1][1].left=t[c][1];break;case 1:t[c-1][1].right=t[c][1];break;case 0:t[c-1][1].mid=t[c][1];break}else this.c=t[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const g=this.b.reset(p);let d=this.c,t;for(;d;){const i=g.cmp(d.segment);if(i>0)d=d.left;else if(i<0)d=d.right;else if(g.hasNext())g.next(),t=d.value||t,d=d.mid;else break}return d&&d.value||t}findSuperstr(p){return this.g(p,!1)}g(p,g){const d=this.b.reset(p);let t=this.c;for(;t;){const i=d.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(d.hasNext())d.next(),t=t.mid;else return t.mid?this.h(t.mid):g?t.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[g,d]of this)p(d,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const g=[];return this.j(p,g),g[Symbol.iterator]()}j(p,g){p&&(p.left&&this.j(p.left,g),p.value&&g.push([p.key,p.value]),p.mid&&this.j(p.mid,g),p.right&&this.j(p.right,g))}_isBalanced(){const p=g=>{if(!g)return!0;const d=g.balanceFactor();return d<-1||d>1?!1:p(g.left)&&p(g.right)};return p(this.c)}}e.$Vh=k}),define(Ae[42],Re([1,0,89]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Vj=e.ThemeColor=void 0;var M;(function(A){function l(D){return D&&typeof D=="object"&&typeof D.id=="string"}A.isThemeColor=l})(M||(e.ThemeColor=M={}));function C(A){return{id:A}}e.$Vj=C;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const l=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function D(c){const b=l.exec(c.id);if(!b)return D(y.$Uj.error);const[,E,v]=b,s=["codicon","codicon-"+E];return v&&s.push("codicon-modifier-"+v.substring(1)),s}A.asClassNameArray=D;function $(c){return D(c).join(" ")}A.asClassName=$;function R(c){return"."+D(c).join(".")}A.asCSSSelector=R;function k(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||M.isThemeColor(c.color))}A.isThemeIcon=k;const a=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function p(c){const b=a.exec(c);if(!b)return;const[,E]=b;return{id:E}}A.fromString=p;function g(c){return{id:c}}A.fromId=g;function d(c,b){let E=c.id;const v=E.lastIndexOf("~");return v!==-1&&(E=E.substring(0,v)),b&&(E=`${E}~${b}`),{id:E}}A.modify=d;function t(c){const b=c.id.lastIndexOf("~");if(b!==-1)return c.id.substring(b+1)}A.getModifier=t;function i(c,b){return c.id===b.id&&c.color?.id===b.color?.id}A.isEqual=i})(T||(e.ThemeIcon=T={}))}),define(Ae[121],Re([1,0,119,16,42]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=void 0;const T="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),l=new RegExp(`(\\\\)?${A.source}`,"g");function D(i){return i.replace(l,(c,b)=>b?c:`\\${c}`)}e.$Wj=D;const $=new RegExp(`\\\\${A.source}`,"g");function R(i){return i.replace($,c=>`\\${c}`)}e.$Xj=R;const k=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function a(i){return i.indexOf(T)===-1?i:i.replace(k,(c,b,E,v)=>E?c:b||v||"")}e.$Yj=a;function p(i){return i?i.replace(/\$\((.*?)\)/g,(c,b)=>` ${b} `).trim():""}e.$Zj=p;const g=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function d(i){g.lastIndex=0;let c="";const b=[];let E=0;for(;;){const v=g.lastIndex,s=g.exec(i),r=i.substring(v,s?.index);if(r.length>0){c+=r;for(let n=0;n<r.length;n++)b.push(E)}if(!s)break;E+=s[0].length}return{text:c,iconOffsets:b}}e.$1j=d;function t(i,c,b=!1){const{text:E,iconOffsets:v}=c;if(!v||v.length===0)return(0,y.$Jj)(i,E,b);const s=(0,M.$Je)(E," "),r=E.length-s.length,n=(0,y.$Jj)(i,s,b);if(n)for(const o of n){const w=v[o.start+r]+r;o.start+=w,o.end+=w}return n}e.$2j=t}),define(Ae[36],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return y.test(C)}e.$dg=M,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(l){for(let D=0;D<l.length;D++)l[D]=Math.floor(Math.random()*256);return l};const T=new Uint8Array(16),A=[];for(let l=0;l<256;l++)A.push(l.toString(16).padStart(2,"0"));return function(){C(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let D=0,$="";return $+=A[T[D++]],$+=A[T[D++]],$+=A[T[D++]],$+=A[T[D++]],$+="-",$+=A[T[D++]],$+=A[T[D++]],$+="-",$+=A[T[D++]],$+=A[T[D++]],$+="-",$+=A[T[D++]],$+=A[T[D++]],$+="-",$+=A[T[D++]],$+=A[T[D++]],$+=A[T[D++]],$+=A[T[D++]],$+=A[T[D++]],$+=A[T[D++]],$}}()}),define(Ae[122],Re([1,0,18,66,36]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.$2s=e.$1s=e.$Zs=e.$Ys=void 0;function T(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$Ys=T;function A(k,a,p){const g={id:(0,C.$eg)(),name:k,uri:a,data:p};return{asString:async()=>"",asFile:()=>g,value:void 0}}e.$Zs=A;class l{constructor(){this.a=new Map}get size(){let a=0;for(const p of this.a)a++;return a}has(a){return this.a.has(this.b(a))}matches(a){const p=[...this.a.keys()];return M.Iterable.some(this,([g,d])=>d.asFile())&&p.push("files"),R(D(a),p)}get(a){return this.a.get(this.b(a))?.[0]}append(a,p){const g=this.a.get(a);g?g.push(p):this.a.set(this.b(a),[p])}replace(a,p){this.a.set(this.b(a),[p])}delete(a){this.a.delete(this.b(a))}*[Symbol.iterator](){for(const[a,p]of this.a)for(const g of p)yield[a,g]}b(a){return D(a)}}e.$1s=l;function D(k){return k.toLowerCase()}function $(k,a){return R(D(k),a.map(D))}e.$2s=$;function R(k,a){if(k==="*/*")return a.length>0;if(a.includes(k))return!0;const p=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[g,d,t]=p;return t==="*"?a.some(i=>i.startsWith(d+"/")):!1}e.$3s=Object.freeze({create:k=>(0,y.$Mb)(k.map(a=>a.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$3s.split(k).filter(a=>!a.startsWith("#"))})}),define(Ae[123],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0,e.$4r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[124],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$pt=e.IndentAction=void 0;var y;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class M{constructor(l){if(this.e=null,this.f=!1,this.open=l.open,this.close=l.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(l.notIn))for(let D=0,$=l.notIn.length;D<$;D++)switch(l.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(l){switch(l){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(l,D){if(l.getTokenCount()===0)return!0;const $=l.findTokenIndexAtOffset(D-2),R=l.getStandardTokenType($);return this.isOK(R)}g(l,D){for(let $=l;$<=D;$++){const R=String.fromCharCode($);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$pt=M;class C{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of l)T(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),T(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),T(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),T(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&T(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.$qt=C;function T(A,l,D){A.has(l)?A.get(l).push(D):A.set(l,[D])}}),define(Ae[125],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M7=e.$L7=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const A=this.a.get(T);return this.a.delete(T),A}}addDragOperationTransfer(T,A){this.a.set(T,A)}}e.$L7=y;class M{constructor(T){this.identifier=T}}e.$M7=M}),define(Ae[126],Re([10,11]),function(ye,e){return ye.create("vs/base/common/actions",e)}),define(Ae[127],Re([1,0,5,6,126]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=void 0;class T extends M.$Sc{constructor(a,p="",g="",d=!0,t){super(),this.h=this.B(new y.$Nd),this.onDidChange=this.h.event,this.w=!0,this.j=a,this.m=p,this.u=g,this.w=d,this.C=t}get id(){return this.j}get label(){return this.m}set label(a){this.D(a)}D(a){this.m!==a&&(this.m=a,this.h.fire({label:a}))}get tooltip(){return this.n||""}set tooltip(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.h.fire({tooltip:a}))}get class(){return this.u}set class(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.h.fire({class:a}))}get enabled(){return this.w}set enabled(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.h.fire({enabled:a}))}get checked(){return this.z}set checked(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.h.fire({checked:a}))}async run(a,p){this.C&&await this.C(a)}}e.$ui=T;class A extends M.$Sc{constructor(){super(...arguments),this.f=this.B(new y.$Nd),this.onWillRun=this.f.event,this.m=this.B(new y.$Nd),this.onDidRun=this.m.event}async run(a,p){if(!a.enabled)return;this.f.fire({action:a});let g;try{await this.u(a,p)}catch(d){g=d}this.m.fire({action:a,error:g})}async u(a,p){await a.run(p)}}e.$vi=A;class l{constructor(){this.id=l.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let p=[];for(const g of a)g.length&&(p.length?p=[...p,new l,...g]:p=g);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$wi=l;class D{get actions(){return this.a}constructor(a,p,g,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=p,this.class=d,this.a=g}async run(){}}e.$xi=D;class $ extends T{static{this.ID="vs.actions.empty"}constructor(){super($.ID,C.localize(0,null),void 0,!1)}}e.$yi=$;function R(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...a)=>k.run(...a),tooltip:k.label}}e.$zi=R}),define(Ae[128],Re([10,11]),function(ye,e){return ye.create("vs/base/common/date",e)}),define(Ae[129],Re([1,0,128]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const M=60,C=M*60,T=C*24,A=T*7,l=T*30,D=T*365;function $(k,a,p,g){typeof k!="number"&&(k=k.getTime());const d=Math.round((new Date().getTime()-k)/1e3);if(d<-30)return(0,y.localize)(0,null,$(new Date().getTime()+d*1e3,!1));if(!g&&d<30)return(0,y.localize)(1,null);let t;return d<M?(t=d,a?t===1?p?(0,y.localize)(2,null,t):(0,y.localize)(3,null,t):p?(0,y.localize)(4,null,t):(0,y.localize)(5,null,t):t===1?p?(0,y.localize)(6,null,t):(0,y.localize)(7,null,t):p?(0,y.localize)(8,null,t):(0,y.localize)(9,null,t)):d<C?(t=Math.floor(d/M),a?t===1?p?(0,y.localize)(10,null,t):(0,y.localize)(11,null,t):p?(0,y.localize)(12,null,t):(0,y.localize)(13,null,t):t===1?p?(0,y.localize)(14,null,t):(0,y.localize)(15,null,t):p?(0,y.localize)(16,null,t):(0,y.localize)(17,null,t)):d<T?(t=Math.floor(d/C),a?t===1?p?(0,y.localize)(18,null,t):(0,y.localize)(19,null,t):p?(0,y.localize)(20,null,t):(0,y.localize)(21,null,t):t===1?p?(0,y.localize)(22,null,t):(0,y.localize)(23,null,t):p?(0,y.localize)(24,null,t):(0,y.localize)(25,null,t)):d<A?(t=Math.floor(d/T),a?t===1?(0,y.localize)(26,null,t):(0,y.localize)(27,null,t):t===1?(0,y.localize)(28,null,t):(0,y.localize)(29,null,t)):d<l?(t=Math.floor(d/A),a?t===1?p?(0,y.localize)(30,null,t):(0,y.localize)(31,null,t):p?(0,y.localize)(32,null,t):(0,y.localize)(33,null,t):t===1?p?(0,y.localize)(34,null,t):(0,y.localize)(35,null,t):p?(0,y.localize)(36,null,t):(0,y.localize)(37,null,t)):d<D?(t=Math.floor(d/l),a?t===1?p?(0,y.localize)(38,null,t):(0,y.localize)(39,null,t):p?(0,y.localize)(40,null,t):(0,y.localize)(41,null,t):t===1?p?(0,y.localize)(42,null,t):(0,y.localize)(43,null,t):p?(0,y.localize)(44,null,t):(0,y.localize)(45,null,t)):(t=Math.floor(d/D),a?t===1?p?(0,y.localize)(46,null,t):(0,y.localize)(47,null,t):p?(0,y.localize)(48,null,t):(0,y.localize)(49,null,t):t===1?p?(0,y.localize)(50,null,t):(0,y.localize)(51,null,t):p?(0,y.localize)(52,null,t):(0,y.localize)(53,null,t))}e.$dm=$;function R(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=R}),define(Ae[130],Re([10,11]),function(ye,e){return ye.create("vs/base/common/errorMessage",e)}),define(Ae[37],Re([1,0,18,15,130]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function T(k,a){return a&&(k.stack||k.stacktrace)?C.localize(0,null,l(k),A(k.stack)||A(k.stacktrace)):l(k)}function A(k){return Array.isArray(k)?k.join(`
`):k}function l(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function D(k=null,a=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const p=y.$Hb(k),g=D(p[0],a);return p.length>1?C.localize(4,null,g,p.length):g}if(M.$yf(k))return k;if(k.detail){const p=k.detail;if(p.error)return T(p.error,a);if(p.exception)return T(p.exception,a)}return k.stack?T(k,a):k.message?k.message:C.localize(5,null)}e.$Ai=D;function $(k){const a=k;return a instanceof Error&&Array.isArray(a.actions)}e.$Bi=$;function R(k,a){let p;return typeof k=="string"?p=new Error(k):p=k,p.actions=a,p}e.$Ci=R}),define(Ae[131],Re([1,0,41,19]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=void 0;const C=new y.$V(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),T=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function l(S,u,m=!1){const h=S||"",P=u||"",W=C.value.collator.compare(h,P);return C.value.collatorIsNumeric&&W===0&&h!==P?h<P?-1:1:W}e.$iq=l;function D(S,u){const m=T.value.collator;return S=S||"",u=u||"",E(m,S,u)}e.$jq=D;function $(S,u){const m=T.value.collator;return S=S||"",u=u||"",n(S,u)||E(m,S,u)}e.$kq=$;function R(S,u){const m=T.value.collator;return S=S||"",u=u||"",r(S,u)||E(m,S,u)}e.$lq=R;function k(S,u){return S=S||"",u=u||"",S===u?0:S<u?-1:1}e.$mq=k;function a(S,u){const[m,h]=c(S),[P,W]=c(u);let K=C.value.collator.compare(h,W);if(K===0){if(C.value.collatorIsNumeric&&h!==W)return h<W?-1:1;if(K=C.value.collator.compare(m,P),C.value.collatorIsNumeric&&K===0&&m!==P)return m<P?-1:1}return K}e.$nq=a;function p(S,u){S=S||"",u=u||"";const m=b(S),h=b(u),P=T.value.collator,W=A.value.collator;return E(W,m,h)||E(P,S,u)}e.$oq=p;function g(S,u){S=S||"",u=u||"";const m=b(S),h=b(u),P=T.value.collator,W=A.value.collator;return E(W,m,h)||n(S,u)||E(P,S,u)}e.$pq=g;function d(S,u){S=S||"",u=u||"";const m=b(S),h=b(u),P=T.value.collator,W=A.value.collator;return E(W,m,h)||r(S,u)||E(P,S,u)}e.$qq=d;function t(S,u){S=S||"",u=u||"";const m=b(S).toLowerCase(),h=b(u).toLowerCase();return m!==h?m<h?-1:1:S!==u?S<u?-1:1:0}e.$rq=t;const i=/^(.*?)(\.([^.]*))?$/;function c(S,u=!1){const m=S?i.exec(S):[];let h=[m&&m[1]||"",m&&m[3]||""];return u&&(!h[0]&&h[1]||h[0]&&h[0].charAt(0)===".")&&(h=[h[0]+"."+h[1],""]),h}function b(S){const u=S?i.exec(S):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function E(S,u,m){const h=S.compare(u,m);return h!==0?h:u.length!==m.length?u.length<m.length?-1:1:0}function v(S){const u=S.charAt(0);return u.toLocaleUpperCase()!==u}function s(S){const u=S.charAt(0);return u.toLocaleLowerCase()!==u}function r(S,u){return v(S)&&s(u)?-1:s(S)&&v(u)?1:0}function n(S,u){return s(S)&&v(u)?-1:v(S)&&s(u)?1:0}function o(S,u,m=!1){return m||(S=S&&S.toLowerCase(),u=u&&u.toLowerCase()),S===u?0:S<u?-1:1}function w(S,u,m=!1){const h=S.split(M.sep),P=u.split(M.sep),W=h.length-1,K=P.length-1;let z,j;for(let O=0;;O++){if(z=W===O,j=K===O,z&&j)return l(h[O],P[O],m);if(z)return-1;if(j)return 1;const N=o(h[O],P[O],m);if(N!==0)return N}}e.$sq=w;function f(S,u,m){const h=S.toLowerCase(),P=u.toLowerCase(),W=I(S,u,m);if(W)return W;const K=h.endsWith(m),z=P.endsWith(m);if(K!==z)return K?-1:1;const j=l(h,P);return j!==0?j:h.localeCompare(P)}e.$tq=f;function I(S,u,m){const h=S.toLowerCase(),P=u.toLowerCase(),W=h.startsWith(m),K=P.startsWith(m);if(W!==K)return W?-1:1;if(W&&K){if(h.length<P.length)return-1;if(h.length>P.length)return 1}return 0}e.$uq=I}),define(Ae[43],Re([1,0,19,22,16,15]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function A(f){return f===47||f===92}e.$Qf=A;function l(f){return f.replace(/[\\/]/g,y.$gc.sep)}e.$Rf=l;function D(f){return f.indexOf("/")===-1&&(f=l(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$Sf=D;function $(f,I=y.$gc.sep){if(!f)return"";const S=f.length,u=f.charCodeAt(0);if(A(u)){if(A(f.charCodeAt(1))&&!A(f.charCodeAt(2))){let h=3;const P=h;for(;h<S&&!A(f.charCodeAt(h));h++);if(P!==h&&!A(f.charCodeAt(h+1))){for(h+=1;h<S;h++)if(A(f.charCodeAt(h)))return f.slice(0,h+1).replace(/[\\/]/g,I)}}return I}else if(i(u)&&f.charCodeAt(1)===58)return A(f.charCodeAt(2))?f.slice(0,2)+I:f.slice(0,2);let m=f.indexOf("://");if(m!==-1){for(m+=3;m<S;m++)if(A(f.charCodeAt(m)))return f.slice(0,m+1)}return""}e.$Tf=$;function R(f){if(!M.$j||!f||f.length<5)return!1;let I=f.charCodeAt(0);if(I!==92||(I=f.charCodeAt(1),I!==92))return!1;let S=2;const u=S;for(;S<f.length&&(I=f.charCodeAt(S),I!==92);S++);return!(u===S||(I=f.charCodeAt(S+1),isNaN(I)||I===92))}e.$Uf=R;const k=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(f,I=M.$j){const S=I?k:a;return!(!f||f.length===0||/^\s+$/.test(f)||(S.lastIndex=0,S.test(f))||I&&p.test(f)||f==="."||f===".."||I&&f[f.length-1]==="."||I&&f.length!==f.trim().length||f.length>255)}e.$Vf=g;function d(f,I,S){const u=f===I;return!S||u?u:!f||!I?!1:(0,C.$2e)(f,I)}e.$Wf=d;function t(f,I,S,u=y.sep){if(f===I)return!0;if(!f||!I||I.length>f.length)return!1;if(S){if(!(0,C.$3e)(f,I))return!1;if(I.length===f.length)return!0;let h=I.length;return I.charAt(I.length-1)===u&&h--,f.charAt(h)===u}return I.charAt(I.length-1)!==u&&(I+=u),f.indexOf(I)===0}e.$Xf=t;function i(f){return f>=65&&f<=90||f>=97&&f<=122}e.$Yf=i;function c(f,I){return M.$j&&f.endsWith(":")&&(f+=y.sep),(0,y.$ic)(f)||(f=(0,y.$jc)(I,f)),f=(0,y.$hc)(f),M.$j?(f=(0,C.$Ke)(f,y.sep),f.endsWith(":")&&(f+=y.sep)):(f=(0,C.$Ke)(f,y.sep),f||(f=y.sep)),f}e.$Zf=c;function b(f){const I=(0,y.$hc)(f);return M.$j?f.length>3?!1:E(I)&&(f.length===2||I.charCodeAt(2)===92):I===y.$gc.sep}e.$1f=b;function E(f,I=M.$j){return I?i(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$2f=E;function v(f,I=M.$j){return E(f,I)?f[0]:void 0}e.$3f=v;function s(f,I,S){return I.length>f.length?-1:f===I?0:(S&&(f=f.toLowerCase(),I=I.toLowerCase()),f.indexOf(I))}e.$4f=s;function r(f){const I=f.split(":");let S,u,m;for(const h of I){const P=Number(h);(0,T.$Cf)(P)?u===void 0?u=P:m===void 0&&(m=P):S=S?[S,h].join(":"):h}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:u!==void 0?u:void 0,column:m!==void 0?m:u!==void 0?1:void 0}}e.$5f=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(f,I,S=8){let u="";for(let h=0;h<S;h++){let P;h===0&&M.$j&&!I&&(S===3||S===4)?P=o:P=n,u+=P.charAt(Math.floor(Math.random()*P.length))}let m;return I?m=`${I}-${u}`:m=u,f?(0,y.$jc)(f,m):m}e.$6f=w}),define(Ae[67],Re([1,0,19]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=e.$Tr=e.$Sr=e.$Rr=e.$Qr=void 0,e.$Qr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(R){const k=(0,y.$oc)(R),a=M[k.toLowerCase()];return a!==void 0?a:A(R)}e.$Rr=T;function A(R){const k=(0,y.$oc)(R);return C[k.toLowerCase()]}e.$Sr=A;function l(R){for(const k in C)if(C[k]===R)return k}e.$Tr=l;const D=/^(.+)\/(.+?)(;.+)?$/;function $(R,k){const a=D.exec(R);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:k?void 0:R}e.$Ur=$}),define(Ae[68],Re([1,0,26,2]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function C(D){return JSON.stringify(D,A)}e.$kh=C;function T(D){let $=JSON.parse(D);return $=l($),$}e.$lh=T;function A(D,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function l(D,$=0){if(!D||$>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return M.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 17:return new Date(D.source)}if(D instanceof y.$be||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let R=0;R<D.length;++R)D[R]=l(D[R],$+1);else for(const R in D)Object.hasOwnProperty.call(D,R)&&(D[R]=l(D[R],$+1))}return D}e.$mh=l}),define(Ae[13],Re([1,0,9,22,2]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var T;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm"})(T||(e.Schemas=T={})),e.$7f="vscode-tkn",e.$8f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${T.vscodeRemoteResource}`}set(R,k,a){this.a[R]=k,this.b[R]=a}setConnectionToken(R,k){this.c[R]=k}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(t){return y.$1(t),R}const k=R.authority;let a=this.a[k];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const p=this.b[k],g=this.c[k];let d=`path=${encodeURIComponent(R.path)}`;return typeof g=="string"&&(d+=`&${e.$8f}=${encodeURIComponent(g)}`),C.URI.from({scheme:M.$p?this.d:T.vscodeRemoteResource,authority:`${a}:${p}`,path:this.f,query:d})}}e.$9f=new A,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class l{static{this.a=e.$bg}asBrowserUri(R){const k=this.b(R,ye);return this.uriToBrowserUri(k)}uriToBrowserUri(R){return R.scheme===T.vscodeRemote?e.$9f.rewrite(R):R.scheme===T.file&&(M.$n||M.$q&&M.$h.origin===`${T.vscodeFileResource}://${l.a}`)?R.with({scheme:T.vscodeFileResource,authority:R.authority||l.a,query:null,fragment:null}):R}asFileUri(R){const k=this.b(R,ye);return this.uriToFileUri(k)}uriToFileUri(R){return R.scheme===T.vscodeFileResource?R.with({scheme:T.file,authority:R.authority!==l.a?R.authority:null,query:null,fragment:null}):R}b(R,k){return C.URI.isUri(R)?R:C.URI.parse(k.toUrl(R))}}e.$cg=new l;var D;(function($){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(R.get("3"));const k="vscode-coi";function a(g){let d;typeof g=="string"?d=new URL(g).searchParams:g instanceof URL?d=g.searchParams:C.URI.isUri(g)&&(d=new URL(g.toString(!0)).searchParams);const t=d?.get(k);if(t)return R.get(t)}$.getHeadersFromQuery=a;function p(g,d,t){if(!globalThis.crossOriginIsolated)return;const i=d&&t?"3":t?"2":"1";g instanceof URLSearchParams?g.set(k,i):g[k]=i}$.addSearchParam=p})(D||(e.COI=D={}))}),define(Ae[23],Re([1,0,43,13,19,22,16,2]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function D(p){return(0,l.$wc)(p,!0)}e.$jg=D;class ${constructor(g){this.a=g}compare(g,d,t=!1){return g===d?0:(0,A.$Ue)(this.getComparisonKey(g,t),this.getComparisonKey(d,t))}isEqual(g,d,t=!1){return g===d?!0:!g||!d?!1:this.getComparisonKey(g,t)===this.getComparisonKey(d,t)}getComparisonKey(g,d=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,d,t=!1){if(g.scheme===d.scheme){if(g.scheme===M.Schemas.file)return y.$Xf(D(g),D(d),this.a(g))&&g.query===d.query&&(t||g.fragment===d.fragment);if((0,e.$Ag)(g.authority,d.authority))return y.$Xf(g.path,d.path,this.a(g),"/")&&g.query===d.query&&(t||g.fragment===d.fragment)}return!1}joinPath(g,...d){return l.URI.joinPath(g,...d)}basenameOrAuthority(g){return(0,e.$sg)(g)||g.authority}basename(g){return C.$gc.basename(g.path)}extname(g){return C.$gc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let d;return g.scheme===M.Schemas.file?d=l.URI.file(C.$mc(D(g))).path:(d=C.$gc.dirname(g.path),g.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),d="/")),g.with({path:d})}normalizePath(g){if(!g.path.length)return g;let d;return g.scheme===M.Schemas.file?d=l.URI.file(C.$hc(D(g))).path:d=C.$gc.normalize(g.path),g.with({path:d})}relativePath(g,d){if(g.scheme!==d.scheme||!(0,e.$Ag)(g.authority,d.authority))return;if(g.scheme===M.Schemas.file){const c=C.$lc(D(g),D(d));return T.$j?y.$Rf(c):c}let t=g.path||"/";const i=d.path||"/";if(this.a(g)){let c=0;for(const b=Math.min(t.length,i.length);c<b&&!(t.charCodeAt(c)!==i.charCodeAt(c)&&t.charAt(c).toLowerCase()!==i.charAt(c).toLowerCase());c++);t=i.substr(0,c)+t.substr(c)}return C.$gc.relative(t,i)}resolvePath(g,d){if(g.scheme===M.Schemas.file){const t=l.URI.file(C.$kc(D(g),d));return g.with({authority:t.authority,path:t.path})}return d=y.$Sf(d),g.with({path:C.$gc.resolve(g.path,d)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,d){return g===d||g!==void 0&&d!==void 0&&(0,A.$2e)(g,d)}hasTrailingPathSeparator(g,d=C.sep){if(g.scheme===M.Schemas.file){const t=D(g);return t.length>y.$Tf(t).length&&t[t.length-1]===d}else{const t=g.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,d=C.sep){return(0,e.$Bg)(g,d)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,d=C.sep){let t=!1;if(g.scheme===M.Schemas.file){const i=D(g);t=i!==void 0&&i.length===y.$Tf(i).length&&i[i.length-1]===d}else{d="/";const i=g.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Bg)(g,d)?g.with({path:g.path+"/"}):g}}e.$kg=$,e.$lg=new $(()=>!1),e.$mg=new $(p=>p.scheme===M.Schemas.file?!T.$l:!0),e.$ng=new $(p=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function R(p,g){const d=[];for(let t=0;t<p.length;t++){const i=g(p[t]);p.some((c,b)=>b===t?!1:(0,e.$pg)(i,g(c)))||d.push(p[t])}return d}e.$Eg=R;var k;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function g(d){const t=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(b=>{const[E,v]=b.split(":");E&&v&&t.set(E,v)});const c=d.path.substring(0,d.path.indexOf(";"));return c&&t.set(p.META_DATA_MIME,c),t}p.parseMetaData=g})(k||(e.DataUri=k={}));function a(p,g,d){if(g){let t=p.path;return t&&t[0]!==C.$gc.sep&&(t=C.$gc.sep+t),p.with({scheme:d,authority:g,path:t})}return p.with({scheme:d})}e.$Fg=a}),define(Ae[12],Re([1,0,20,9,5,6,23,22,120]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function $(Z){return!!Z&&typeof Z.then=="function"}e.$Gg=$;function R(Z){const ee=new y.$Xd,ve=Z(ee.token),ge=new Promise((de,De)=>{const re=ee.token.onCancellationRequested(()=>{re.dispose(),ee.dispose(),De(new M.$5)});Promise.resolve(ve).then(le=>{re.dispose(),ee.dispose(),de(le)},le=>{re.dispose(),ee.dispose(),De(le)})});return new class{cancel(){ee.cancel()}then(de,De){return ge.then(de,De)}catch(de){return this.then(void 0,de)}finally(de){return ge.finally(de)}}}e.$Hg=R;function k(Z,ee,ve){return new Promise((ge,de)=>{const De=ee.onCancellationRequested(()=>{De.dispose(),ge(ve)});Z.then(ge,de).finally(()=>De.dispose())})}e.$Ig=k;function a(Z,ee){return new Promise((ve,ge)=>{const de=ee.onCancellationRequested(()=>{de.dispose(),ge(new M.$5)});Z.then(ve,ge).finally(()=>de.dispose())})}e.$Jg=a;async function p(Z){let ee=-1;const ve=Z.map((ge,de)=>ge.then(De=>(ee=de,De)));try{return await Promise.race(ve)}finally{Z.forEach((ge,de)=>{de!==ee&&ge.cancel()})}}e.$Kg=p;function g(Z,ee,ve){let ge;const de=setTimeout(()=>{ge?.(void 0),ve?.()},ee);return Promise.race([Z.finally(()=>clearTimeout(de)),new Promise(De=>ge=De)])}e.$Lg=g;function d(Z){return new Promise((ee,ve)=>{const ge=Z();$(ge)?ge.then(ee,ve):ee(ge)})}e.$Mg=d;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ee){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ee,!this.b){const ve=()=>{if(this.b=null,this.f)return;const ge=this.queue(this.d);return this.d=null,ge};this.b=new Promise(ge=>{this.a.then(ve,ve).then(ge)})}return new Promise((ve,ge)=>{this.b.then(ve,ge)})}return this.a=ee(),new Promise((ve,ge)=>{this.a.then(de=>{this.a=null,ve(de)},de=>{this.a=null,ge(de)})})}dispose(){this.f=!0}}e.$Ng=t;class i{constructor(){this.a=Promise.resolve(null)}queue(ee){return this.a=this.a.then(()=>ee(),()=>ee())}}e.$Og=i;class c{constructor(){this.a=new Map}queue(ee,ve){const de=(this.a.get(ee)??Promise.resolve()).catch(()=>{}).then(ve).finally(()=>{this.a.get(ee)===de&&this.a.delete(ee)});return this.a.set(ee,de),de}}e.$Pg=c;const b=(Z,ee)=>{let ve=!0;const ge=setTimeout(()=>{ve=!1,ee()},Z);return{isTriggered:()=>ve,dispose:()=>{clearTimeout(ge),ve=!1}}},E=Z=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,Z())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};class v{constructor(ee){this.defaultDelay=ee,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ee,ve=this.defaultDelay){this.g=ee,this.h(),this.b||(this.b=new Promise((de,De)=>{this.d=de,this.f=De}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const ge=()=>{this.a=null,this.d?.(null)};return this.a=ve===D.$Kd?E(ge):b(ve,ge),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=v;class s{constructor(ee){this.a=new v(ee),this.b=new t}trigger(ee,ve){return this.a.trigger(()=>this.b.queue(ee),ve)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=s;class r{constructor(){this.a=!1,this.b=new Promise((ee,ve)=>{this.d=ee})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=r;class n extends r{constructor(ee){super(),this.f=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this.f),super.open()}}e.$Tg=n;function o(Z,ee){return ee?new Promise((ve,ge)=>{const de=setTimeout(()=>{De.dispose(),ve()},Z),De=ee.onCancellationRequested(()=>{clearTimeout(de),De.dispose(),ge(new M.$5)})}):R(ve=>o(Z,ve))}e.$Ug=o;function w(Z,ee=0,ve){const ge=setTimeout(()=>{Z(),ve&&de.dispose()},ee),de=(0,T.$Qc)(()=>{clearTimeout(ge),ve?.deleteAndLeak(de)});return ve?.add(de),de}e.$Vg=w;function f(Z){const ee=[];let ve=0;const ge=Z.length;function de(){return ve<ge?Z[ve++]():null}function De(re){re!=null&&ee.push(re);const le=de();return le?le.then(De):Promise.resolve(ee)}return Promise.resolve(null).then(De)}e.$Wg=f;function I(Z,ee=ge=>!!ge,ve=null){let ge=0;const de=Z.length,De=()=>{if(ge>=de)return Promise.resolve(ve);const re=Z[ge++];return Promise.resolve(re()).then(ne=>ee(ne)?Promise.resolve(ne):De())};return De()}e.$Xg=I;function S(Z,ee=ge=>!!ge,ve=null){if(Z.length===0)return Promise.resolve(ve);let ge=Z.length;const de=()=>{ge=-1;for(const De of Z)De.cancel?.()};return new Promise((De,re)=>{for(const le of Z)le.then(ne=>{--ge>=0&&ee(ne)?(de(),De(ne)):ge===0&&De(ve)}).catch(ne=>{--ge>=0&&(de(),re(ne))})})}e.$Yg=S;class u{constructor(ee){this.a=0,this.d=ee,this.f=[],this.b=0,this.g=new C.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(ee){return this.a++,new Promise((ve,ge)=>{this.f.push({factory:ee,c:ve,e:ge}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ee=this.f.shift();this.b++;const ve=ee.factory();ve.then(ee.c,ee.e),ve.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=u;class m extends u{constructor(){super(1)}}e.$1g=m;class h{constructor(){this.a=new Ee,this.b=0}queue(ee){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ee())):this.a.run(this.b++,ee())}}e.$2g=h;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ee=new $e;return this.b.add(ee),ee.p}g(){for(const[,ee]of this.a)if(ee.size>0)return!1;return!0}queueFor(ee,ve=A.$lg){const ge=ve.getComparisonKey(ee);let de=this.a.get(ge);if(!de){de=new m;const De=this.f++,re=C.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose(De),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$1c),this.d.set(De,re),this.a.set(ge,de)}return de}h(){this.g()&&this.j()}j(){for(const ee of this.b)ee.complete();this.b.clear()}dispose(){for(const[,ee]of this.a)ee.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=P;class W{constructor(ee,ve){this.a=-1,typeof ee=="function"&&typeof ve=="number"&&this.setIfNotSet(ee,ve)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ee,ve){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ee()},ve)}setIfNotSet(ee,ve){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ee()},ve))}}e.$4g=W;class K{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(ee,ve){this.cancel(),this.a=setInterval(()=>{ee()},ve)}}e.$5g=K;class z{constructor(ee,ve){this.b=-1,this.a=ee,this.d=ve,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ee=this.d){this.cancel(),this.b=setTimeout(this.f,ee)}get delay(){return this.d}set delay(ee){this.d=ee}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=z;class j{constructor(ee,ve){ve%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ve}ms is not a multiple of 1000ms.`),this.a=ee,this.b=ve,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ee=this.b){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ee/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=j;class O extends z{constructor(ee,ve){super(ee,ve),this.j=[]}work(ee){this.j.push(ee),this.isScheduled()||this.schedule()}h(){const ee=this.j;this.j=[],this.a?.(ee)}dispose(){this.j=[],super.dispose()}}e.$8g=O;class N extends T.$Sc{constructor(ee,ve){super(),this.g=ee,this.h=ve,this.a=[],this.b=this.B(new T.$Tc),this.f=!1}get pending(){return this.a.length}work(ee){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ee.length>this.g.maxBufferedWork)return!1}else if(this.pending+ee.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ve of ee)this.a.push(ve);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=Z=>{(0,l.$B)(()=>{if(ee)return;const ve=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ve-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.$0g=(Z,ee)=>{const ve=requestIdleCallback(Z,typeof ee=="number"?{timeout:ee}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,cancelIdleCallback(ve))}}}}();class ie{constructor(ee){this.d=!1,this.a=()=>{try{this.f=ee()}catch(ve){this.g=ve}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=ie;async function X(Z,ee,ve){let ge;for(let de=0;de<ve;de++)try{return await Z()}catch(De){ge=De,await o(ee)}throw ge}e.$_g=X;class Ee{isRunning(ee){return typeof ee=="number"?this.a?.taskId===ee:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ee,ve,ge){return this.a={taskId:ee,cancel:()=>ge?.(),promise:ve},ve.then(()=>this.d(ee),()=>this.d(ee)),ve}d(ee){this.a&&ee===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ee=this.b;this.b=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}queue(ee){if(this.b)this.b.run=ee;else{let ve,ge;const de=new Promise((De,re)=>{ve=De,ge=re});this.b={run:ee,promise:de,promiseResolve:ve,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=Ee;class Se{constructor(ee,ve=()=>Date.now()){this.d=ee,this.f=ve,this.a=0,this.b=0}increment(){const ee=this.f();return ee-this.a>this.d&&(this.a=ee,this.b=0),this.b++,this.b}}e.$bh=Se;var Pe;(function(Z){Z[Z.Resolved=0]="Resolved",Z[Z.Rejected=1]="Rejected"})(Pe||(Pe={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ee,ve)=>{this.a=ee,this.b=ve})}complete(ee){return new Promise(ve=>{this.a(ee),this.d={outcome:0,value:ee},ve()})}error(ee){return new Promise(ve=>{this.b(ee),this.d={outcome:1,value:ee},ve()})}cancel(){return this.error(new M.$5)}}e.$ch=$e;var pe;(function(Z){async function ee(ge){let de;const De=await Promise.all(ge.map(re=>re.then(le=>le,le=>{de||(de=le)})));if(typeof de<"u")throw de;return De}Z.settled=ee;function ve(ge){return new Promise(async(de,De)=>{try{await ge(de,De)}catch(re){De(re)}})}Z.withAsyncBody=ve})(pe||(e.Promises=pe={}));var ue;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(ue||(ue={}));class oe{static fromArray(ee){return new oe(ve=>{ve.emitMany(ee)})}static fromPromise(ee){return new oe(async ve=>{ve.emitMany(await ee)})}static fromPromises(ee){return new oe(async ve=>{await Promise.all(ee.map(async ge=>ve.emitOne(await ge)))})}static merge(ee){return new oe(async ve=>{await Promise.all(ee.map(async ge=>{for await(const de of ge)ve.emitOne(de)}))})}static{this.EMPTY=oe.fromArray([])}constructor(ee){this.a=0,this.b=[],this.d=null,this.f=new C.$Nd,queueMicrotask(async()=>{const ve={emitOne:ge=>this.g(ge),emitMany:ge=>this.h(ge),reject:ge=>this.k(ge)};try{await Promise.resolve(ee(ve)),this.j()}catch(ge){this.k(ge)}finally{ve.emitOne=void 0,ve.emitMany=void 0,ve.reject=void 0}})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ee<this.b.length)return{done:!1,value:this.b[ee++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(ee,ve){return new oe(async ge=>{for await(const de of ee)ge.emitOne(ve(de))})}map(ee){return oe.map(this,ee)}static filter(ee,ve){return new oe(async ge=>{for await(const de of ee)ve(de)&&ge.emitOne(de)})}filter(ee){return oe.filter(this,ee)}static coalesce(ee){return oe.filter(ee,ve=>!!ve)}coalesce(){return oe.coalesce(this)}static async toPromise(ee){const ve=[];for await(const ge of ee)ve.push(ge);return ve}toPromise(){return oe.toPromise(this)}g(ee){this.a===0&&(this.b.push(ee),this.f.fire())}h(ee){this.a===0&&(this.b=this.b.concat(ee),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ee){this.a===0&&(this.a=2,this.d=ee,this.f.fire())}}e.$dh=oe;class be extends oe{constructor(ee,ve){super(ve),this.l=ee}cancel(){this.l.cancel()}}e.$eh=be;function _(Z){const ee=new y.$Xd,ve=Z(ee.token);return new be(ee,async ge=>{const de=ee.token.onCancellationRequested(()=>{de.dispose(),ee.dispose(),ge.reject(new M.$5)});try{for await(const De of ve){if(ee.token.isCancellationRequested)return;ge.emitOne(De)}de.dispose(),ee.dispose()}catch(De){de.dispose(),ee.dispose(),ge.reject(De)}})}e.$fh=_;class B{constructor(){this.a=new $e,this.b=new oe(ge=>{if(ee){ge.reject(ee);return}return ve&&ge.emitMany(ve),this.d=de=>ge.reject(de),this.f=de=>ge.emitOne(de),this.a.p});let ee,ve;this.f=ge=>{ve||(ve=[]),ve.push(ge)},this.d=ge=>{ee||(ee=ge)}}get asyncIterable(){return this.b}complete(){this.a.complete()}error(ee){this.d(ee),this.a.complete()}emit(ee){this.f(ee)}}e.$gh=B}),define(Ae[38],Re([1,0,18,12,43,28,19,22,16]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=void 0;function $(){return Object.create(null)}e.$rj=$,e.$sj="**",e.$tj="/";const R="[/\\\\]",k="[^/\\\\]",a=/\//g;function p(Ee,Se){switch(Ee){case 0:return"";case 1:return`${k}*?`;default:return`(?:${R}|${k}+${R}${Se?`|${R}${k}+`:""})*?`}}function g(Ee,Se){if(!Ee)return[];const Pe=[];let $e=!1,pe=!1,ue="";for(const oe of Ee){switch(oe){case Se:if(!$e&&!pe){Pe.push(ue),ue="";continue}break;case"{":$e=!0;break;case"}":$e=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}ue+=oe}return ue&&Pe.push(ue),Pe}e.$uj=g;function d(Ee){if(!Ee)return"";let Se="";const Pe=g(Ee,e.$tj);if(Pe.every($e=>$e===e.$sj))Se=".*";else{let $e=!1;Pe.forEach((pe,ue)=>{if(pe===e.$sj){if($e)return;Se+=p(2,ue===Pe.length-1)}else{let oe=!1,be="",_=!1,B="";for(const Z of pe){if(Z!=="}"&&oe){be+=Z;continue}if(_&&(Z!=="]"||!B)){let ee;Z==="-"?ee=Z:(Z==="^"||Z==="!")&&!B?ee="^":Z===e.$tj?ee="":ee=(0,D.$Fe)(Z),B+=ee;continue}switch(Z){case"{":oe=!0;continue;case"[":_=!0;continue;case"}":{const ve=`(?:${g(be,",").map(ge=>d(ge)).join("|")})`;Se+=ve,oe=!1,be="";break}case"]":{Se+="["+B+"]",_=!1,B="";break}case"?":Se+=k;continue;case"*":Se+=p(1);continue;default:Se+=(0,D.$Fe)(Z)}}ue<Pe.length-1&&(Pe[ue+1]!==e.$sj||ue+2<Pe.length)&&(Se+=R)}$e=pe===e.$sj})}return Se}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new T.$Dc(1e4),r=function(){return!1},n=function(){return null};function o(Ee,Se){if(!Ee)return n;let Pe;typeof Ee!="string"?Pe=Ee.pattern:Pe=Ee,Pe=Pe.trim();const $e=`${Pe}_${!!Se.trimForExclusions}`;let pe=s.get($e);if(pe)return w(pe,Ee);let ue;return t.test(Pe)?pe=I(Pe.substr(4),Pe):(ue=i.exec(f(Pe,Se)))?pe=S(ue[1],Pe):(Se.trimForExclusions?b:c).test(Pe)?pe=u(Pe,Se):(ue=E.exec(f(Pe,Se)))?pe=m(ue[1].substr(1),Pe,!0):(ue=v.exec(f(Pe,Se)))?pe=m(ue[1],Pe,!1):pe=h(Pe),s.set($e,pe),w(pe,Ee)}function w(Ee,Se){if(typeof Se=="string")return Ee;const Pe=function($e,pe){return(0,C.$Xf)($e,Se.base,!l.$l)?Ee((0,D.$Je)($e.substr(Se.base.length),A.sep),pe):null};return Pe.allBasenames=Ee.allBasenames,Pe.allPaths=Ee.allPaths,Pe.basenames=Ee.basenames,Pe.patterns=Ee.patterns,Pe}function f(Ee,Se){return Se.trimForExclusions&&Ee.endsWith("/**")?Ee.substr(0,Ee.length-2):Ee}function I(Ee,Se){return function(Pe,$e){return typeof Pe=="string"&&Pe.endsWith(Ee)?Se:null}}function S(Ee,Se){const Pe=`/${Ee}`,$e=`\\${Ee}`,pe=function(oe,be){return typeof oe!="string"?null:be?be===Ee?Se:null:oe===Ee||oe.endsWith(Pe)||oe.endsWith($e)?Se:null},ue=[Ee];return pe.basenames=ue,pe.patterns=[Se],pe.allBasenames=ue,pe}function u(Ee,Se){const Pe=ie(Ee.slice(1,-1).split(",").map(be=>o(be,Se)).filter(be=>be!==n),Ee),$e=Pe.length;if(!$e)return n;if($e===1)return Pe[0];const pe=function(be,_){for(let B=0,Z=Pe.length;B<Z;B++)if(Pe[B](be,_))return Ee;return null},ue=Pe.find(be=>!!be.allBasenames);ue&&(pe.allBasenames=ue.allBasenames);const oe=Pe.reduce((be,_)=>_.allPaths?be.concat(_.allPaths):be,[]);return oe.length&&(pe.allPaths=oe),pe}function m(Ee,Se,Pe){const $e=A.sep===A.$gc.sep,pe=$e?Ee:Ee.replace(a,A.sep),ue=A.sep+pe,oe=A.$gc.sep+Ee;let be;return Pe?be=function(_,B){return typeof _=="string"&&(_===pe||_.endsWith(ue)||!$e&&(_===Ee||_.endsWith(oe)))?Se:null}:be=function(_,B){return typeof _=="string"&&(_===pe||!$e&&_===Ee)?Se:null},be.allPaths=[(Pe?"*/":"./")+Ee],be}function h(Ee){try{const Se=new RegExp(`^${d(Ee)}$`);return function(Pe){return Se.lastIndex=0,typeof Pe=="string"&&Se.test(Pe)?Ee:null}}catch{return n}}function P(Ee,Se,Pe){return!Ee||typeof Se!="string"?!1:W(Ee)(Se,void 0,Pe)}e.$vj=P;function W(Ee,Se={}){if(!Ee)return r;if(typeof Ee=="string"||K(Ee)){const Pe=o(Ee,Se);if(Pe===n)return r;const $e=function(pe,ue){return!!Pe(pe,ue)};return Pe.allBasenames&&($e.allBasenames=Pe.allBasenames),Pe.allPaths&&($e.allPaths=Pe.allPaths),$e}return O(Ee,Se)}e.$wj=W;function K(Ee){const Se=Ee;return Se?typeof Se.base=="string"&&typeof Se.pattern=="string":!1}e.$xj=K;function z(Ee){return Ee.allBasenames||[]}e.$yj=z;function j(Ee){return Ee.allPaths||[]}e.$zj=j;function O(Ee,Se){const Pe=ie(Object.getOwnPropertyNames(Ee).map(be=>N(be,Ee[be],Se)).filter(be=>be!==n)),$e=Pe.length;if(!$e)return n;if(!Pe.some(be=>!!be.requiresSiblings)){if($e===1)return Pe[0];const be=function(Z,ee){let ve;for(let ge=0,de=Pe.length;ge<de;ge++){const De=Pe[ge](Z,ee);if(typeof De=="string")return De;(0,M.$Gg)(De)&&(ve||(ve=[]),ve.push(De))}return ve?(async()=>{for(const ge of ve){const de=await ge;if(typeof de=="string")return de}return null})():null},_=Pe.find(Z=>!!Z.allBasenames);_&&(be.allBasenames=_.allBasenames);const B=Pe.reduce((Z,ee)=>ee.allPaths?Z.concat(ee.allPaths):Z,[]);return B.length&&(be.allPaths=B),be}const pe=function(be,_,B){let Z,ee;for(let ve=0,ge=Pe.length;ve<ge;ve++){const de=Pe[ve];de.requiresSiblings&&B&&(_||(_=(0,A.$nc)(be)),Z||(Z=_.substr(0,_.length-(0,A.$oc)(be).length)));const De=de(be,_,Z,B);if(typeof De=="string")return De;(0,M.$Gg)(De)&&(ee||(ee=[]),ee.push(De))}return ee?(async()=>{for(const ve of ee){const ge=await ve;if(typeof ge=="string")return ge}return null})():null},ue=Pe.find(be=>!!be.allBasenames);ue&&(pe.allBasenames=ue.allBasenames);const oe=Pe.reduce((be,_)=>_.allPaths?be.concat(_.allPaths):be,[]);return oe.length&&(pe.allPaths=oe),pe}function N(Ee,Se,Pe){if(Se===!1)return n;const $e=o(Ee,Pe);if($e===n)return n;if(typeof Se=="boolean")return $e;if(Se){const pe=Se.when;if(typeof pe=="string"){const ue=(oe,be,_,B)=>{if(!B||!$e(oe,be))return null;const Z=pe.replace("$(basename)",()=>_),ee=B(Z);return(0,M.$Gg)(ee)?ee.then(ve=>ve?Ee:null):ee?Ee:null};return ue.requiresSiblings=!0,ue}}return $e}function ie(Ee,Se){const Pe=Ee.filter(be=>!!be.basenames);if(Pe.length<2)return Ee;const $e=Pe.reduce((be,_)=>{const B=_.basenames;return B?be.concat(B):be},[]);let pe;if(Se){pe=[];for(let be=0,_=$e.length;be<_;be++)pe.push(Se)}else pe=Pe.reduce((be,_)=>{const B=_.patterns;return B?be.concat(B):be},[]);const ue=function(be,_){if(typeof be!="string")return null;if(!_){let Z;for(Z=be.length;Z>0;Z--){const ee=be.charCodeAt(Z-1);if(ee===47||ee===92)break}_=be.substr(Z)}const B=$e.indexOf(_);return B!==-1?pe[B]:null};ue.basenames=$e,ue.patterns=pe,ue.allBasenames=$e;const oe=Ee.filter(be=>!be.basenames);return oe.push(ue),oe}function X(Ee,Se){return(0,y.$ub)(Ee,Se,(Pe,$e)=>typeof Pe=="string"&&typeof $e=="string"?Pe===$e:typeof Pe!="string"&&typeof $e!="string"?Pe.base===$e.base&&Pe.pattern===$e.pattern:!1)}e.$Aj=X}),define(Ae[50],Re([1,0,9,121,23,16,2]),function(ye,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.MarkdownStringTextNewlineStyle=void 0;var l;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(l||(e.MarkdownStringTextNewlineStyle=l={}));class D{constructor(i="",c=!1){if(this.value=i,typeof this.value!="string")throw(0,y.$7)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(i,c=0){return this.value+=a(this.supportThemeIcons?(0,M.$Wj)(i):i).replace(/([ \t]+)/g,(b,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,c){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(i,c,b){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(i),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(i,c){const b=new RegExp((0,T.$Fe)(c),"g");return i.replace(b,(E,v)=>i.charAt(v-1)!=="\\"?`\\${E}`:E)}}e.$3j=D;function $(t){return R(t)?!t.value:Array.isArray(t)?t.every($):!0}e.$4j=$;function R(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$5j=R;function k(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,C.$og)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.$6j=k;function a(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$7j=a;function p(t){return t.replace(/"/g,"&quot;")}e.$8j=p;function g(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$9j=g;function d(t){const i=[],c=t.split("|").map(E=>E.trim());t=c[0];const b=c[1];if(b){const E=/height=(\d+)/.exec(b),v=/width=(\d+)/.exec(b),s=E?E[1]:"",r=v?v[1]:"",n=isFinite(parseInt(r)),o=isFinite(parseInt(s));n&&i.push(`width="${r}"`),o&&i.push(`height="${s}"`)}return{href:t,dimensions:i}}e.$0j=d}),define(Ae[90],Re([1,0,18,43,19,22,23,16]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=void 0;function D(o,w){const{os:f,tildify:I,relative:S}=w;if(S){const h=$(o,S,f);if(typeof h=="string")return h}let u=o.fsPath;if(f===1&&!T.$j?u=u.replace(/\//g,"\\"):f!==1&&T.$j&&(u=u.replace(/\\/g,"/")),f!==1&&I?.userHome){const h=I.userHome.fsPath;let P;o.scheme!==I.userHome.scheme&&o.path.startsWith(C.$gc.sep)?P=I.userHome.with({path:o.path}).fsPath:P=o.fsPath,u=a(P,h,f)}return(f===1?C.$fc:C.$gc).normalize(R(u,f===1))}e.$qv=D;function $(o,w,f){const I=f===1?C.$fc:C.$gc,S=f===3?A.$lg:A.$ng,u=w.getWorkspace(),m=(0,y.$Ob)(u.folders);if(!m)return;o.scheme!==m.uri.scheme&&o.path.startsWith(C.$gc.sep)&&(o=m.uri.with({path:o.path}));const h=w.getWorkspaceFolder(o);if(!h)return;let P;if(S.isEqual(h.uri,o)?P="":P=S.relativePath(h.uri,o)??"",P&&(P=I.normalize(P)),u.folders.length>1&&!w.noPrefix){const W=h.name?h.name:S.basenameOrAuthority(h.uri);P=P?`${W} \u2022 ${P}`:W}return P}function R(o,w=T.$j){return(0,M.$2f)(o,w)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$rv=R;let k=Object.create(null);function a(o,w,f=T.OS){if(f===1||!o||!w)return o;let I=k.original===w?k.normalized:void 0;I||(I=w,T.$j&&(I=(0,M.$Rf)(I)),I=`${(0,l.$Ke)(I,C.$gc.sep)}${C.$gc.sep}`,k={original:w,normalized:I});let S=o;return T.$j&&(S=(0,M.$Rf)(S)),(f===3?S.startsWith(I):(0,l.$3e)(S,I))?`~/${S.substr(I.length)}`:o}e.$sv=a;function p(o,w){return o.replace(/^~($|\/|\\)/,`${w}$1`)}e.$tv=p;const g="\u2026",d="\\\\",t="~";function i(o,w=C.sep){const f=new Array(o.length);let I=!1;for(let S=0;S<o.length;S++){const u=o[S];if(u===""){f[S]=`.${w}`;continue}if(!u){f[S]=u;continue}I=!0;let m="",h=u;h.indexOf(d)===0?(m=h.substr(0,h.indexOf(d)+d.length),h=h.substr(h.indexOf(d)+d.length)):h.indexOf(w)===0?(m=h.substr(0,h.indexOf(w)+w.length),h=h.substr(h.indexOf(w)+w.length)):h.indexOf(t)===0&&(m=h.substr(0,h.indexOf(t)+t.length),h=h.substr(h.indexOf(t)+t.length));const P=h.split(w);for(let W=1;I&&W<=P.length;W++)for(let K=P.length-W;I&&K>=0;K--){I=!1;let z=P.slice(K,K+W).join(w);for(let j=0;!I&&j<o.length;j++)if(j!==S&&o[j]&&o[j].indexOf(z)>-1){const O=K+W===P.length,N=K>0&&o[j].indexOf(w)>-1?w+z:z,ie=o[j].endsWith(N);I=!O||ie}if(!I){let j="";(P[0].endsWith(":")||m!=="")&&(K===1&&(K=0,W++,z=P[0]+w+z),K>0&&(j=P[0]+w),j=m+j),K>0&&(j=j+g+w),j=j+z,K+W<P.length&&(j=j+w+g),f[S]=j}}I&&(f[S]=u)}return f}e.$uv=i;var c;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function b(o,w=Object.create(null)){const f=[];let I=!1,S="";for(const u of o)if(u==="$"||I&&u==="{")S&&f.push({value:S,type:c.TEXT}),S="",I=!0;else if(u==="}"&&I){const m=w[S];if(typeof m=="string")m.length&&f.push({value:m,type:c.VARIABLE});else if(m){const h=f[f.length-1];(!h||h.type!==c.SEPARATOR)&&f.push({value:m.label,type:c.SEPARATOR})}S="",I=!1}else S+=u;return S&&!I&&f.push({value:S,type:c.TEXT}),f.filter((u,m)=>{if(u.type===c.SEPARATOR){const h=f[m-1],P=f[m+1];return[h,P].every(W=>W&&(W.type===c.VARIABLE||W.type===c.TEXT)&&W.value.length>0)}return!0}).map(u=>u.value).join("")}e.$vv=b;function E(o,w){return T.$k||w?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.$k?"&":"&&"):o.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.$wv=E;function v(o,w){return T.$k||w?o.replace(/\(&&\w\)|&&/g,""):T.$j?o.replace(/&&|&/g,f=>f==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$xv=v;function s(o){return o.replace(/&/g,"&&")}e.$yv=s;function r(o){if(o.endsWith("]")){const w=o.lastIndexOf(" [",o.length-2);if(w!==-1){const f=n(o.substring(0,w));return{name:f.name,parentPath:f.parentPath+o.substring(w)}}}return n(o)}e.$zv=r;function n(o){const w=o.indexOf("/")!==-1?C.$gc:C.$fc,f=w.basename(o),I=w.dirname(o);return f.length?{name:f,parentPath:I}:{name:I,parentPath:""}}}),define(Ae[132],Re([1,0,26,2]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0;function C(k){return k.toJSON()}class T{constructor(a){this.a=a}transformIncoming(a){const p=this.a.transformIncoming(a);return p===a?a:C(M.URI.from(p))}transformOutgoing(a){const p=this.a.transformOutgoing(a);return p===a?a:C(M.URI.from(p))}transformOutgoingURI(a){const p=this.a.transformOutgoing(a);return p===a?a:M.URI.from(p)}transformOutgoingScheme(a){return this.a.transformOutgoingScheme(a)}}e.$Lm=T,e.$Mm=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function A(k,a,p){if(!k||p>200)return null;if(typeof k=="object"){if(k instanceof M.URI)return a.transformOutgoing(k);for(const g in k)if(Object.hasOwnProperty.call(k,g)){const d=A(k[g],a,p+1);d!==null&&(k[g]=d)}}return null}function l(k,a){const p=A(k,a,0);return p===null?k:p}e.$Nm=l;function D(k,a,p,g){if(!k||g>200)return null;if(typeof k=="object"){if(k.$mid===1)return p?M.URI.revive(a.transformIncoming(k)):a.transformIncoming(k);if(k instanceof y.$be)return null;for(const d in k)if(Object.hasOwnProperty.call(k,d)){const t=D(k[d],a,p,g+1);t!==null&&(k[d]=t)}}return null}function $(k,a){const p=D(k,a,!1,0);return p===null?k:p}e.$Om=$;function R(k,a){const p=D(k,a,!0,0);return p===null?k:p}e.$Pm=R}),define(Ae[133],Re([1,0,38,19]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rE=void 0;function C(T,A,l,D,$,R){if(Array.isArray(T)){let k=0;for(const a of T){const p=C(a,A,l,D,$,R);if(p===10)return p;p>k&&(k=p)}return k}else{if(typeof T=="string")return D?T==="*"?5:T===l?10:0:0;if(T){const{language:k,pattern:a,scheme:p,hasAccessToAllModels:g,notebookType:d}=T;if(!D&&!g)return 0;d&&$&&(A=$);let t=0;if(p)if(p===A.scheme)t=10;else if(p==="*")t=5;else return 0;if(k)if(k===l)t=10;else if(k==="*")t=Math.max(t,5);else return 0;if(d)if(d===R)t=10;else if(d==="*"&&R!==void 0)t=Math.max(t,5);else return 0;if(a){let i;if(typeof a=="string"?i=a:i={...a,base:(0,M.$hc)(a.base)},i===A.fsPath||(0,y.$vj)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.$rE=C}),define(Ae[91],Re([1,0,26,22]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W0=e.$V0=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function T(k){for(let a=0,p=k.length;a<p;a+=4){const g=k[a+0],d=k[a+1],t=k[a+2],i=k[a+3];k[a+0]=i,k[a+1]=t,k[a+2]=d,k[a+3]=g}}function A(k){const a=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return M.$D()||T(a),y.$be.wrap(a)}function l(k){const a=k.buffer;if(M.$D()||T(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const p=new Uint8Array(a.byteLength);return p.set(a),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function D(k){const a=new Uint32Array($(k));let p=0;if(a[p++]=k.id,k.type==="full")a[p++]=1,a[p++]=k.data.length,a.set(k.data,p),p+=k.data.length;else{a[p++]=2,a[p++]=k.deltas.length;for(const g of k.deltas)a[p++]=g.start,a[p++]=g.deleteCount,g.data?(a[p++]=g.data.length,a.set(g.data,p),p+=g.data.length):a[p++]=0}return A(a)}e.$V0=D;function $(k){let a=0;if(a+=1+1,k.type==="full")a+=1+k.data.length;else{a+=1,a+=(1+1+1)*k.deltas.length;for(const p of k.deltas)p.data&&(a+=p.data.length)}return a}function R(k){const a=l(k);let p=0;const g=a[p++];if(a[p++]===1){const c=a[p++],b=a.subarray(p,p+c);return p+=c,{id:g,type:"full",data:b}}const t=a[p++],i=[];for(let c=0;c<t;c++){const b=a[p++],E=a[p++],v=a[p++];let s;v>0&&(s=a.subarray(p,p+v),p+=v),i[c]={start:b,deleteCount:E,data:s}}return{id:g,type:"delta",deltas:i}}e.$W0=R}),define(Ae[134],Re([10,11]),function(ye,e){return ye.create("vs/editor/common/config/editorOptions",e)}),define(Ae[135],Re([1,0,18,24,22,123,136,134]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class ${constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=$;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class k{constructor(Q,we,Be,Oe){this.id=Q,this.name=we,this.defaultValue=Be,this.schema=Oe}applyUpdate(Q,we){return p(Q,we)}compute(Q,we,Be){return Be}}class a{constructor(Q,we){this.newValue=Q,this.didChange=we}}e.ApplyUpdateResult=a;function p(Y,Q){if(typeof Y!="object"||typeof Q!="object"||!Y||!Q)return new a(Q,Y!==Q);if(Array.isArray(Y)||Array.isArray(Q)){const Be=Array.isArray(Y)&&Array.isArray(Q)&&y.$ub(Y,Q);return new a(Q,!Be)}let we=!1;for(const Be in Q)if(Q.hasOwnProperty(Be)){const Oe=p(Y[Be],Q[Be]);Oe.didChange&&(Y[Be]=Oe.newValue,we=!0)}return new a(Y,we)}class g{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,we){return p(Q,we)}validate(Q){return this.defaultValue}}class d{constructor(Q,we,Be,Oe){this.id=Q,this.name=we,this.defaultValue=Be,this.schema=Oe}applyUpdate(Q,we){return p(Q,we)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,we,Be){return Be}}function t(Y,Q){return typeof Y>"u"?Q:Y==="false"?!1:!!Y}e.boolean=t;class i extends d{constructor(Q,we,Be,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=Be),super(Q,we,Be,Oe)}validate(Q){return t(Q,this.defaultValue)}}function c(Y,Q,we,Be){if(typeof Y>"u")return Q;let Oe=parseInt(Y,10);return isNaN(Oe)?Q:(Oe=Math.max(we,Oe),Oe=Math.min(Be,Oe),Oe|0)}e.clampedInt=c;class b extends d{static clampedInt(Q,we,Be,Oe){return c(Q,we,Be,Oe)}constructor(Q,we,Be,Oe,Xe,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Be,nt.minimum=Oe,nt.maximum=Xe),super(Q,we,Be,nt),this.minimum=Oe,this.maximum=Xe}validate(Q){return b.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function E(Y,Q,we,Be){if(typeof Y>"u")return Q;const Oe=v.float(Y,Q);return v.clamp(Oe,we,Be)}e.clampedFloat=E;class v extends d{static clamp(Q,we,Be){return Q<we?we:Q>Be?Be:Q}static float(Q,we){if(typeof Q=="number")return Q;if(typeof Q>"u")return we;const Be=parseFloat(Q);return isNaN(Be)?we:Be}constructor(Q,we,Be,Oe,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Be),super(Q,we,Be,Xe),this.validationFn=Oe}validate(Q){return this.validationFn(v.float(Q,this.defaultValue))}}class s extends d{static string(Q,we){return typeof Q!="string"?we:Q}constructor(Q,we,Be,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=Be),super(Q,we,Be,Oe)}validate(Q){return s.string(Q,this.defaultValue)}}function r(Y,Q,we,Be){return typeof Y!="string"?Q:Be&&Y in Be?Be[Y]:we.indexOf(Y)===-1?Q:Y}e.stringSet=r;class n extends d{constructor(Q,we,Be,Oe,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Oe,Xe.default=Be),super(Q,we,Be,Xe),this.c=Oe}validate(Q){return r(Q,this.defaultValue,this.c)}}class o extends k{constructor(Q,we,Be,Oe,Xe,nt,ft=void 0){typeof ft<"u"&&(ft.type="string",ft.enum=Xe,ft.default=Oe),super(Q,we,Be,ft),this.c=Xe,this.d=nt}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function w(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,we,Be){return Be===0?Q.accessibilitySupport:Be}}class I extends k{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:l.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{insertSpace:t(we.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(we.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function u(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(m||(e.TextEditorCursorStyle=m={}));function h(Y){switch(Y){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=h;function P(Y){switch(Y){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class W extends g{constructor(){super(140)}compute(Q,we,Be){const Oe=["monaco-editor"];return we.get(39)&&Oe.push(we.get(39)),Q.extraEditorClassName&&Oe.push(Q.extraEditorClassName),we.get(73)==="default"?Oe.push("mouse-default"):we.get(73)==="copy"&&Oe.push("mouse-copy"),we.get(110)&&Oe.push("showUnused"),we.get(138)&&Oe.push("showDeprecated"),Oe.join(" ")}}class K extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(Q,we,Be){return Be&&Q.emptySelectionClipboard}}class z extends k{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:l.localize(16,null),included:C.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:l.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{cursorMoveOnType:t(we.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":r(we.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":r(we.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(we.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(we.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(we.loop,this.defaultValue.loop)}}}class j extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?j.OFF:Q==="true"?j.ON:Q:Q?j.ON:j.OFF}}e.EditorFontLigatures=j;class O extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?O.OFF:Q==="true"?O.TRANSLATE:Q:Q?O.TRANSLATE:O.OFF}compute(Q,we,Be){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class N extends g{constructor(){super(50)}compute(Q,we,Be){return Q.fontInfo}}class ie extends d{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(Q){const we=v.float(Q,this.defaultValue);return we===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(we,6,100)}compute(Q,we,Be){return Q.fontInfo.fontSize}}class X extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.d,maximum:X.e,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(b.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,X.d,X.e))}}class Ee extends k{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},we={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...we},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...we},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...we},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...we},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...we},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Be,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Be,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Be,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Be,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Be,description:l.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{multiple:r(we.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:we.multipleDefinitions??r(we.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:we.multipleTypeDefinitions??r(we.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:we.multipleDeclarations??r(we.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:we.multipleImplementations??r(we.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:we.multipleReferences??r(we.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:s.string(we.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:s.string(we.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:s.string(we.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:s.string(we.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:s.string(we.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Se extends k{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:l.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),delay:b.clampedInt(we.delay,this.defaultValue.delay,0,1e4),sticky:t(we.sticky,this.defaultValue.sticky),hidingDelay:b.clampedInt(we.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(we.above,this.defaultValue.above)}}}var Pe;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class $e extends g{constructor(){super(143)}compute(Q,we,Be){return $e.computeLayout(we,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const we=Q.height/Q.lineHeight,Be=Math.floor(Q.paddingTop/Q.lineHeight);let Oe=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(Oe=Math.max(Oe,we-1));const Xe=(Be+Q.viewLineCount+Oe)/(Q.pixelRatio*Q.height),nt=Math.floor(Q.viewLineCount/Xe);return{typicalViewportLineCount:we,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Oe,desiredRatio:Xe,minimapLineCount:nt}}static c(Q,we){const Be=Q.outerWidth,Oe=Q.outerHeight,Xe=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const nt=we.stableMinimapLayoutInput,ft=nt&&Q.outerHeight===nt.outerHeight&&Q.lineHeight===nt.lineHeight&&Q.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&Q.pixelRatio===nt.pixelRatio&&Q.scrollBeyondLastLine===nt.scrollBeyondLastLine&&Q.paddingTop===nt.paddingTop&&Q.paddingBottom===nt.paddingBottom&&Q.minimap.enabled===nt.minimap.enabled&&Q.minimap.side===nt.minimap.side&&Q.minimap.size===nt.minimap.size&&Q.minimap.showSlider===nt.minimap.showSlider&&Q.minimap.renderCharacters===nt.minimap.renderCharacters&&Q.minimap.maxColumn===nt.minimap.maxColumn&&Q.minimap.scale===nt.minimap.scale&&Q.verticalScrollbarWidth===nt.verticalScrollbarWidth&&Q.isViewportWrapping===nt.isViewportWrapping,wt=Q.lineHeight,Pt=Q.typicalHalfwidthCharacterWidth,Zt=Q.scrollBeyondLastLine,Gt=Q.minimap.renderCharacters;let pt=Xe>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const jt=Q.minimap.maxColumn,Nt=Q.minimap.size,Bt=Q.minimap.side,At=Q.verticalScrollbarWidth,Rt=Q.viewLineCount,Ot=Q.remainingWidth,Wt=Q.isViewportWrapping,Jt=Gt?2:3;let Kt=Math.floor(Xe*Oe);const Vt=Kt/Xe;let Mt=!1,ut=!1,ht=Jt*pt,Lt=pt/Xe,qt=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Fe,extraLinesBeyondLastLine:me,desiredRatio:H,minimapLineCount:Me}=$e.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Zt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:Oe,lineHeight:wt,pixelRatio:Xe});if(Rt/Me>1)Mt=!0,ut=!0,pt=1,ht=1,Lt=pt/Xe;else{let Je=!1,Ve=pt+1;if(Nt==="fit"){const et=Math.ceil((Fe+Rt+me)*ht);Wt&&ft&&Ot<=we.stableFitRemainingWidth?(Je=!0,Ve=we.stableFitMaxMinimapScale):Je=et>Kt}if(Nt==="fill"||Je){Mt=!0;const et=pt;ht=Math.min(wt*Xe,Math.max(1,Math.floor(1/H))),Wt&&ft&&Ot<=we.stableFitRemainingWidth&&(Ve=we.stableFitMaxMinimapScale),pt=Math.min(Ve,Math.max(1,Math.floor(ht/Jt))),pt>et&&(qt=Math.min(2,pt/et)),Lt=pt/Xe/qt,Kt=Math.ceil(Math.max(Ce,Fe+Rt+me)*ht),Wt?(we.stableMinimapLayoutInput=Q,we.stableFitRemainingWidth=Ot,we.stableFitMaxMinimapScale=pt):(we.stableMinimapLayoutInput=null,we.stableFitRemainingWidth=0)}}}const kt=Math.floor(jt*Lt),at=Math.min(kt,Math.max(0,Math.floor((Ot-At-2)*Lt/(Pt+Lt)))+e.MINIMAP_GUTTER_WIDTH);let vt=Math.floor(Xe*at);const Ht=vt/Xe;vt=Math.floor(vt*qt);const Ct=Gt?1:2,We=Bt==="left"?0:Be-at-At;return{renderMinimap:Ct,minimapLeft:We,minimapWidth:at,minimapHeightIsEditorHeight:Mt,minimapIsSampling:ut,minimapScale:pt,minimapLineHeight:ht,minimapCanvasInnerWidth:vt,minimapCanvasInnerHeight:Kt,minimapCanvasOuterWidth:Ht,minimapCanvasOuterHeight:Vt}}static computeLayout(Q,we){const Be=we.outerWidth|0,Oe=we.outerHeight|0,Xe=we.lineHeight|0,nt=we.lineNumbersDigitCount|0,ft=we.typicalHalfwidthCharacterWidth,wt=we.maxDigitWidth,Pt=we.pixelRatio,Zt=we.viewLineCount,Gt=Q.get(135),pt=Gt==="inherit"?Q.get(134):Gt,jt=pt==="inherit"?Q.get(130):pt,Nt=Q.get(133),Bt=we.isDominatedByLongLines,At=Q.get(57),Rt=Q.get(67).renderType!==0,Ot=Q.get(68),Wt=Q.get(104),Jt=Q.get(83),Kt=Q.get(72),Vt=Q.get(102),Mt=Vt.verticalScrollbarSize,ut=Vt.verticalHasArrows,ht=Vt.arrowSize,Lt=Vt.horizontalScrollbarSize,qt=Q.get(43),kt=Q.get(109)!=="never";let at=Q.get(65);qt&&kt&&(at+=16);let vt=0;if(Rt){const zt=Math.max(nt,Ot);vt=Math.round(zt*wt)}let Ht=0;At&&(Ht=Xe*we.glyphMarginDecorationLaneCount);let Ct=0,We=Ct+Ht,Ce=We+vt,Fe=Ce+at;const me=Be-Ht-vt-at;let H=!1,Me=!1,je=-1;pt==="inherit"&&Bt?(H=!0,Me=!0):jt==="on"||jt==="bounded"?Me=!0:jt==="wordWrapColumn"&&(je=Nt);const Je=$e.c({outerWidth:Be,outerHeight:Oe,lineHeight:Xe,typicalHalfwidthCharacterWidth:ft,pixelRatio:Pt,scrollBeyondLastLine:Wt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Kt,verticalScrollbarWidth:Mt,viewLineCount:Zt,remainingWidth:me,isViewportWrapping:Me},we.memory||new R);Je.renderMinimap!==0&&Je.minimapLeft===0&&(Ct+=Je.minimapWidth,We+=Je.minimapWidth,Ce+=Je.minimapWidth,Fe+=Je.minimapWidth);const Ve=me-Je.minimapWidth,et=Math.max(1,Math.floor((Ve-Mt-2)/ft)),bt=ut?ht:0;return Me&&(je=Math.max(1,et),jt==="bounded"&&(je=Math.min(je,Nt))),{width:Be,height:Oe,glyphMarginLeft:Ct,glyphMarginWidth:Ht,glyphMarginDecorationLaneCount:we.glyphMarginDecorationLaneCount,lineNumbersLeft:We,lineNumbersWidth:vt,decorationsLeft:Ce,decorationsWidth:at,contentLeft:Fe,contentWidth:Ve,minimap:Je,viewportColumn:et,isWordWrapMinified:H,isViewportWrapping:Me,wrappingColumn:je,verticalScrollbarWidth:Mt,horizontalScrollbarHeight:Lt,overviewRuler:{top:bt,width:Mt,height:Oe-2*bt,right:0}}}}e.EditorLayoutInfoComputer=$e;class pe extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(Q){return r(Q,"simple",["simple","advanced"])}compute(Q,we,Be){return we.get(2)===2?"advanced":Be}}class ue extends k{constructor(){const Q={enabled:!0};super(64,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:l.localize(50,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:t(Q.enabled,this.defaultValue.enabled)}}}class oe extends k{constructor(){const Q={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:l.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:l.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:l.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:l.localize(54,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(we.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(we.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(we.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class be extends k{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:l.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(56,null),l.localize(57,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),l.localize(58,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),l.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:l.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:l.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:l.localize(62,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return typeof we.enabled=="boolean"&&(we.enabled=we.enabled?"on":"off"),{enabled:r(we.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(we.fontSize,this.defaultValue.fontSize,0,100),fontFamily:s.string(we.fontFamily,this.defaultValue.fontFamily),padding:t(we.padding,this.defaultValue.padding)}}}class _ extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):b.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,we,Be){return Be<0?b.clampedInt(-Be*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class B extends v{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>v.clamp(Q,0,150),{markdownDescription:l.localize(63,null)})}compute(Q,we,Be){return Q.fontInfo.lineHeight}}class Z extends k{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:l.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:l.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(66,null),l.localize(67,null),l.localize(68,null)],default:Q.size,description:l.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:l.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:l.localize(71,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:l.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:l.localize(74,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),autohide:t(we.autohide,this.defaultValue.autohide),size:r(we.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(we.side,this.defaultValue.side,["right","left"]),showSlider:r(we.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(we.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(we.scale,1,1,3),maxColumn:b.clampedInt(we.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ee(Y){return Y==="ctrlCmd"?C.$k?"metaKey":"ctrlKey":"altKey"}class ve extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(76,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{top:b.clampedInt(we.top,0,0,1e3),bottom:b.clampedInt(we.bottom,0,0,1e3)}}}class ge extends k{constructor(){const Q={enabled:!0,cycle:!0};super(85,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:l.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:l.localize(78,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),cycle:t(we.cycle,this.defaultValue.cycle)}}}class de extends g{constructor(){super(141)}compute(Q,we,Be){return Q.pixelRatio}}class De extends k{constructor(){const Q={other:"on",comments:"off",strings:"off"},we=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(79,null),l.localize(80,null),l.localize(81,null)]}];super(88,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:we,default:Q.strings,description:l.localize(82,null)},comments:{anyOf:we,default:Q.comments,description:l.localize(83,null)},other:{anyOf:we,default:Q.other,description:l.localize(84,null)}},default:Q,markdownDescription:l.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Pt=Q?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:we,comments:Be,strings:Oe}=Q,Xe=["on","inline","off"];let nt,ft,wt;return typeof we=="boolean"?nt=we?"on":"off":nt=r(we,this.defaultValue.other,Xe),typeof Be=="boolean"?ft=Be?"on":"off":ft=r(Be,this.defaultValue.comments,Xe),typeof Oe=="boolean"?wt=Oe?"on":"off":wt=r(Oe,this.defaultValue.strings,Xe),{other:nt,comments:ft,strings:wt}}}var re;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(re||(e.RenderLineNumbersType=re={}));class le extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null),l.localize(89,null)],default:"on",description:l.localize(90,null)})}validate(Q){let we=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(we=4,Be=Q):Q==="interval"?we=3:Q==="relative"?we=2:Q==="on"?we=1:we=0),{renderType:we,renderFn:Be}}}function ne(Y){const Q=Y.get(97);return Q==="editable"?Y.get(90):Q!=="on"}e.filterValidationDecorations=ne;class ae extends k{constructor(){const Q=[],we={type:"number",description:l.localize(91,null)};super(101,"rulers",Q,{type:"array",items:{anyOf:[we,{type:["object"],properties:{column:we,color:{type:"string",description:l.localize(92,null),format:"color-hex"}}}]},default:Q,description:l.localize(93,null)})}validate(Q){if(Array.isArray(Q)){const we=[];for(const Be of Q)if(typeof Be=="number")we.push({column:b.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Oe=Be;we.push({column:b.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return we.sort((Be,Oe)=>Be.column-Oe.column),we}return this.defaultValue}}class fe extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function Ie(Y,Q){if(typeof Y!="string")return Q;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends k{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"auto",description:l.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(98,null),l.localize(99,null),l.localize(100,null)],default:"auto",description:l.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:l.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:l.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:l.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q,Be=b.clampedInt(we.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=b.clampedInt(we.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(we.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(we.vertical,this.defaultValue.vertical),horizontal:Ie(we.horizontal,this.defaultValue.horizontal),useShadows:t(we.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(we.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(we.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(we.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(we.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:b.clampedInt(we.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:b.clampedInt(we.verticalSliderSize,Oe,0,1e3),scrollByPage:t(we.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends k{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:l.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:l.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:l.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:l.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:l.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:l.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:l.localize(111,null)}})}applyUpdate(Q,we){let Be=!1;we.allowedCharacters&&Q&&(M.$$m(Q.allowedCharacters,we.allowedCharacters)||(Q={...Q,allowedCharacters:we.allowedCharacters},Be=!0)),we.allowedLocales&&Q&&(M.$$m(Q.allowedLocales,we.allowedLocales)||(Q={...Q,allowedLocales:we.allowedLocales},Be=!0));const Oe=super.applyUpdate(Q,we);return Be?new a(Oe.newValue,!0):Oe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{nonBasicASCII:x(we.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(we.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(we.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(we.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(we.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,we){if(typeof Q!="object"||!Q)return we;const Be={};for(const[Oe,Xe]of Object.entries(Q))Xe===!0&&(Be[Oe]=!0);return Be}}class G extends k{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:l.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[l.localize(113,null),l.localize(114,null)],description:l.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:l.localize(116,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),mode:r(we.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(we.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(we.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(we.keepOnBlur,this.defaultValue.keepOnBlur)}}}class J extends k{constructor(){const Q={enabled:T.$4r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$4r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:l.localize(118,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(we.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends k{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(119,null),l.localize(120,null),l.localize(121,null)],default:Q.bracketPairs,description:l.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(123,null),l.localize(124,null),l.localize(125,null)],default:Q.bracketPairsHorizontal,description:l.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:l.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:l.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(129,null),l.localize(130,null),l.localize(131,null)],default:Q.highlightActiveIndentation,description:l.localize(132,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{bracketPairs:x(we.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(we.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(we.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(we.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(we.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(Y,Q,we){const Be=we.indexOf(Y);return Be===-1?Q:we[Be]}class ce extends k{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(133,null),l.localize(134,null)],default:Q.insertMode,description:l.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:l.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:l.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:l.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(139,null),l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:Q.selectionMode,markdownDescription:l.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:l.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:l.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:l.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:l.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:l.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{insertMode:r(we.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(we.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(we.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(we.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(we.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(we.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(we.showIcons,this.defaultValue.showIcons),showStatusBar:t(we.showStatusBar,this.defaultValue.showStatusBar),preview:t(we.preview,this.defaultValue.preview),previewMode:r(we.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(we.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(we.showMethods,this.defaultValue.showMethods),showFunctions:t(we.showFunctions,this.defaultValue.showFunctions),showConstructors:t(we.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(we.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(we.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(we.showFields,this.defaultValue.showFields),showVariables:t(we.showVariables,this.defaultValue.showVariables),showClasses:t(we.showClasses,this.defaultValue.showClasses),showStructs:t(we.showStructs,this.defaultValue.showStructs),showInterfaces:t(we.showInterfaces,this.defaultValue.showInterfaces),showModules:t(we.showModules,this.defaultValue.showModules),showProperties:t(we.showProperties,this.defaultValue.showProperties),showEvents:t(we.showEvents,this.defaultValue.showEvents),showOperators:t(we.showOperators,this.defaultValue.showOperators),showUnits:t(we.showUnits,this.defaultValue.showUnits),showValues:t(we.showValues,this.defaultValue.showValues),showConstants:t(we.showConstants,this.defaultValue.showConstants),showEnums:t(we.showEnums,this.defaultValue.showEnums),showEnumMembers:t(we.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(we.showKeywords,this.defaultValue.showKeywords),showWords:t(we.showWords,this.defaultValue.showWords),showColors:t(we.showColors,this.defaultValue.showColors),showFiles:t(we.showFiles,this.defaultValue.showFiles),showReferences:t(we.showReferences,this.defaultValue.showReferences),showFolders:t(we.showFolders,this.defaultValue.showFolders),showTypeParameters:t(we.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(we.showSnippets,this.defaultValue.showSnippets),showUsers:t(we.showUsers,this.defaultValue.showUsers),showIssues:t(we.showIssues,this.defaultValue.showIssues)}}}class Ne extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(182,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Q.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Qe extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(183,null),l.localize(184,null),l.localize(185,null),l.localize(186,null)],description:l.localize(187,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,we,Be){return we.get(2)===2?0:Be}}class Ge extends g{constructor(){super(144)}compute(Q,we,Be){const Oe=we.get(143);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class xe extends k{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(190,null),l.localize(191,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),showDropSelector:r(we.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ye extends k{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(194,null),l.localize(195,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const we=Q;return{enabled:t(we.enabled,this.defaultValue.enabled),showPasteSelector:r(we.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const _e="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$k?it:C.$l?tt:_e,fontWeight:"normal",fontSize:C.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var st;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.letterSpacing=63]="letterSpacing",Y[Y.lightbulb=64]="lightbulb",Y[Y.lineDecorationsWidth=65]="lineDecorationsWidth",Y[Y.lineHeight=66]="lineHeight",Y[Y.lineNumbers=67]="lineNumbers",Y[Y.lineNumbersMinChars=68]="lineNumbersMinChars",Y[Y.linkedEditing=69]="linkedEditing",Y[Y.links=70]="links",Y[Y.matchBrackets=71]="matchBrackets",Y[Y.minimap=72]="minimap",Y[Y.mouseStyle=73]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=75]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=77]="multiCursorModifier",Y[Y.multiCursorPaste=78]="multiCursorPaste",Y[Y.multiCursorLimit=79]="multiCursorLimit",Y[Y.occurrencesHighlight=80]="occurrencesHighlight",Y[Y.overviewRulerBorder=81]="overviewRulerBorder",Y[Y.overviewRulerLanes=82]="overviewRulerLanes",Y[Y.padding=83]="padding",Y[Y.pasteAs=84]="pasteAs",Y[Y.parameterHints=85]="parameterHints",Y[Y.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=88]="quickSuggestions",Y[Y.quickSuggestionsDelay=89]="quickSuggestionsDelay",Y[Y.readOnly=90]="readOnly",Y[Y.readOnlyMessage=91]="readOnlyMessage",Y[Y.renameOnType=92]="renameOnType",Y[Y.renderControlCharacters=93]="renderControlCharacters",Y[Y.renderFinalNewline=94]="renderFinalNewline",Y[Y.renderLineHighlight=95]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=97]="renderValidationDecorations",Y[Y.renderWhitespace=98]="renderWhitespace",Y[Y.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Y[Y.roundedSelection=100]="roundedSelection",Y[Y.rulers=101]="rulers",Y[Y.scrollbar=102]="scrollbar",Y[Y.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=104]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=105]="scrollPredominantAxis",Y[Y.selectionClipboard=106]="selectionClipboard",Y[Y.selectionHighlight=107]="selectionHighlight",Y[Y.selectOnLineNumbers=108]="selectOnLineNumbers",Y[Y.showFoldingControls=109]="showFoldingControls",Y[Y.showUnused=110]="showUnused",Y[Y.snippetSuggestions=111]="snippetSuggestions",Y[Y.smartSelect=112]="smartSelect",Y[Y.smoothScrolling=113]="smoothScrolling",Y[Y.stickyScroll=114]="stickyScroll",Y[Y.stickyTabStops=115]="stickyTabStops",Y[Y.stopRenderingLineAfter=116]="stopRenderingLineAfter",Y[Y.suggest=117]="suggest",Y[Y.suggestFontSize=118]="suggestFontSize",Y[Y.suggestLineHeight=119]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Y[Y.suggestSelection=121]="suggestSelection",Y[Y.tabCompletion=122]="tabCompletion",Y[Y.tabIndex=123]="tabIndex",Y[Y.unicodeHighlighting=124]="unicodeHighlighting",Y[Y.unusualLineTerminators=125]="unusualLineTerminators",Y[Y.useShadowDOM=126]="useShadowDOM",Y[Y.useTabStops=127]="useTabStops",Y[Y.wordBreak=128]="wordBreak",Y[Y.wordSeparators=129]="wordSeparators",Y[Y.wordWrap=130]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=133]="wordWrapColumn",Y[Y.wordWrapOverride1=134]="wordWrapOverride1",Y[Y.wordWrapOverride2=135]="wordWrapOverride2",Y[Y.wrappingIndent=136]="wrappingIndent",Y[Y.wrappingStrategy=137]="wrappingStrategy",Y[Y.showDeprecated=138]="showDeprecated",Y[Y.inlayHints=139]="inlayHints",Y[Y.editorClassName=140]="editorClassName",Y[Y.pixelRatio=141]="pixelRatio",Y[Y.tabFocusMode=142]="tabFocusMode",Y[Y.layoutInfo=143]="layoutInfo",Y[Y.wrappingInfo=144]="wrappingInfo",Y[Y.defaultColorDecorators=145]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(196,null)})),acceptSuggestionOnEnter:ze(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(197,null),""],markdownDescription:l.localize(198,null)})),accessibilitySupport:ze(new f),accessibilityPageSize:ze(new b(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(199,null),tags:["accessibility"]})),ariaLabel:ze(new s(4,"ariaLabel",l.localize(200,null))),ariaRequired:ze(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:ze(new n(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(202,null),l.localize(203,null),""],description:l.localize(204,null)})),autoClosingComments:ze(new n(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(205,null),l.localize(206,null),""],description:l.localize(207,null)})),autoClosingDelete:ze(new n(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(208,null),""],description:l.localize(209,null)})),autoClosingOvertype:ze(new n(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(210,null),""],description:l.localize(211,null)})),autoClosingQuotes:ze(new n(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(212,null),l.localize(213,null),""],description:l.localize(214,null)})),autoIndent:ze(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[l.localize(215,null),l.localize(216,null),l.localize(217,null),l.localize(218,null),l.localize(219,null)],description:l.localize(220,null)})),automaticLayout:ze(new i(13,"automaticLayout",!1)),autoSurround:ze(new n(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(221,null),l.localize(222,null),l.localize(223,null),""],description:l.localize(224,null)})),bracketPairColorization:ze(new J),bracketPairGuides:ze(new q),stickyTabStops:ze(new i(115,"stickyTabStops",!1,{description:l.localize(225,null)})),codeLens:ze(new i(17,"codeLens",!0,{description:l.localize(226,null)})),codeLensFontFamily:ze(new s(18,"codeLensFontFamily","",{description:l.localize(227,null)})),codeLensFontSize:ze(new b(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(228,null)})),colorDecorators:ze(new i(20,"colorDecorators",!0,{description:l.localize(229,null)})),colorDecoratorActivatedOn:ze(new n(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(230,null),l.localize(231,null),l.localize(232,null)],description:l.localize(233,null)})),colorDecoratorsLimit:ze(new b(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(234,null)})),columnSelection:ze(new i(22,"columnSelection",!1,{description:l.localize(235,null)})),comments:ze(new I),contextmenu:ze(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new i(25,"copyWithSyntaxHighlighting",!0,{description:l.localize(236,null)})),cursorBlinking:ze(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:l.localize(237,null)})),cursorSmoothCaretAnimation:ze(new n(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(238,null),l.localize(239,null),l.localize(240,null)],description:l.localize(241,null)})),cursorStyle:ze(new o(28,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:l.localize(242,null)})),cursorSurroundingLines:ze(new b(29,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(243,null)})),cursorSurroundingLinesStyle:ze(new n(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(244,null),l.localize(245,null)],markdownDescription:l.localize(246,null)})),cursorWidth:ze(new b(31,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(247,null)})),disableLayerHinting:ze(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new i(34,"domReadOnly",!1)),dragAndDrop:ze(new i(35,"dragAndDrop",!0,{description:l.localize(248,null)})),emptySelectionClipboard:ze(new K),dropIntoEditor:ze(new xe),stickyScroll:ze(new oe),experimentalWhitespaceRendering:ze(new n(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),extraEditorClassName:ze(new s(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new v(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:l.localize(253,null)})),find:ze(new z),fixedOverflowWidgets:ze(new i(42,"fixedOverflowWidgets",!1)),folding:ze(new i(43,"folding",!0,{description:l.localize(254,null)})),foldingStrategy:ze(new n(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(255,null),l.localize(256,null)],description:l.localize(257,null)})),foldingHighlight:ze(new i(45,"foldingHighlight",!0,{description:l.localize(258,null)})),foldingImportsByDefault:ze(new i(46,"foldingImportsByDefault",!1,{description:l.localize(259,null)})),foldingMaximumRegions:ze(new b(47,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(260,null)})),unfoldOnClickAfterEndOfLine:ze(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(261,null)})),fontFamily:ze(new s(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(262,null)})),fontInfo:ze(new N),fontLigatures2:ze(new j),fontSize:ze(new ie),fontWeight:ze(new X),fontVariations:ze(new O),formatOnPaste:ze(new i(55,"formatOnPaste",!1,{description:l.localize(263,null)})),formatOnType:ze(new i(56,"formatOnType",!1,{description:l.localize(264,null)})),glyphMargin:ze(new i(57,"glyphMargin",!0,{description:l.localize(265,null)})),gotoLocation:ze(new Ee),hideCursorInOverviewRuler:ze(new i(59,"hideCursorInOverviewRuler",!1,{description:l.localize(266,null)})),hover:ze(new Se),inDiffEditor:ze(new i(61,"inDiffEditor",!1)),letterSpacing:ze(new v(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>v.clamp(Y,-5,20),{description:l.localize(267,null)})),lightbulb:ze(new ue),lineDecorationsWidth:ze(new _),lineHeight:ze(new B),lineNumbers:ze(new le),lineNumbersMinChars:ze(new b(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new i(69,"linkedEditing",!1,{description:l.localize(268,null)})),links:ze(new i(70,"links",!0,{description:l.localize(269,null)})),matchBrackets:ze(new n(71,"matchBrackets","always",["always","near","never"],{description:l.localize(270,null)})),minimap:ze(new Z),mouseStyle:ze(new n(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new v(74,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:l.localize(271,null)})),mouseWheelZoom:ze(new i(75,"mouseWheelZoom",!1,{markdownDescription:l.localize(272,null)})),multiCursorMergeOverlapping:ze(new i(76,"multiCursorMergeOverlapping",!0,{description:l.localize(273,null)})),multiCursorModifier:ze(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ee,{markdownEnumDescriptions:[l.localize(274,null),l.localize(275,null)],markdownDescription:l.localize(276,null)})),multiCursorPaste:ze(new n(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(277,null),l.localize(278,null)],markdownDescription:l.localize(279,null)})),multiCursorLimit:ze(new b(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(280,null)})),occurrencesHighlight:ze(new i(80,"occurrencesHighlight",!0,{description:l.localize(281,null)})),overviewRulerBorder:ze(new i(81,"overviewRulerBorder",!0,{description:l.localize(282,null)})),overviewRulerLanes:ze(new b(82,"overviewRulerLanes",3,0,3)),padding:ze(new ve),pasteAs:ze(new Ye),parameterHints:ze(new ge),peekWidgetDefaultFocus:ze(new n(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(283,null),l.localize(284,null)],description:l.localize(285,null)})),definitionLinkOpensInPeek:ze(new i(87,"definitionLinkOpensInPeek",!1,{description:l.localize(286,null)})),quickSuggestions:ze(new De),quickSuggestionsDelay:ze(new b(89,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(287,null)})),readOnly:ze(new i(90,"readOnly",!1)),readOnlyMessage:ze(new fe),renameOnType:ze(new i(92,"renameOnType",!1,{description:l.localize(288,null),markdownDeprecationMessage:l.localize(289,null)})),renderControlCharacters:ze(new i(93,"renderControlCharacters",!0,{description:l.localize(290,null),restricted:!0})),renderFinalNewline:ze(new n(94,"renderFinalNewline",C.$l?"dimmed":"on",["off","on","dimmed"],{description:l.localize(291,null)})),renderLineHighlight:ze(new n(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(292,null)],description:l.localize(293,null)})),renderLineHighlightOnlyWhenFocus:ze(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(294,null)})),renderValidationDecorations:ze(new n(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new n(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(295,null),l.localize(296,null),l.localize(297,null),""],description:l.localize(298,null)})),revealHorizontalRightPadding:ze(new b(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new i(100,"roundedSelection",!0,{description:l.localize(299,null)})),rulers:ze(new ae),scrollbar:ze(new F),scrollBeyondLastColumn:ze(new b(103,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(300,null)})),scrollBeyondLastLine:ze(new i(104,"scrollBeyondLastLine",!0,{description:l.localize(301,null)})),scrollPredominantAxis:ze(new i(105,"scrollPredominantAxis",!0,{description:l.localize(302,null)})),selectionClipboard:ze(new i(106,"selectionClipboard",!0,{description:l.localize(303,null),included:C.$l})),selectionHighlight:ze(new i(107,"selectionHighlight",!0,{description:l.localize(304,null)})),selectOnLineNumbers:ze(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new n(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(305,null),l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),showUnused:ze(new i(110,"showUnused",!0,{description:l.localize(309,null)})),showDeprecated:ze(new i(138,"showDeprecated",!0,{description:l.localize(310,null)})),inlayHints:ze(new be),snippetSuggestions:ze(new n(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(311,null),l.localize(312,null),l.localize(313,null),l.localize(314,null)],description:l.localize(315,null)})),smartSelect:ze(new Ne),smoothScrolling:ze(new i(113,"smoothScrolling",!1,{description:l.localize(316,null)})),stopRenderingLineAfter:ze(new b(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ce),inlineSuggest:ze(new G),inlineCompletionsAccessibilityVerbose:ze(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(317,null)})),suggestFontSize:ze(new b(118,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new b(119,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new i(120,"suggestOnTriggerCharacters",!0,{description:l.localize(320,null)})),suggestSelection:ze(new n(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(321,null),l.localize(322,null),l.localize(323,null)],description:l.localize(324,null)})),tabCompletion:ze(new n(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(325,null),l.localize(326,null),l.localize(327,null)],description:l.localize(328,null)})),tabIndex:ze(new b(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new V),unusualLineTerminators:ze(new n(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(329,null),l.localize(330,null),l.localize(331,null)],description:l.localize(332,null)})),useShadowDOM:ze(new i(126,"useShadowDOM",!0)),useTabStops:ze(new i(127,"useTabStops",!0,{description:l.localize(333,null)})),wordBreak:ze(new n(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(334,null),l.localize(335,null)],description:l.localize(336,null)})),wordSeparators:ze(new s(129,"wordSeparators",A.$5r,{description:l.localize(337,null)})),wordWrap:ze(new n(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(338,null),l.localize(339,null),l.localize(340,null),l.localize(341,null)],description:l.localize(342,null)})),wordWrapBreakAfterCharacters:ze(new s(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new s(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new b(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(343,null)})),wordWrapOverride1:ze(new n(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new n(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new W),defaultColorDecorators:ze(new i(145,"defaultColorDecorators",!1,{markdownDescription:l.localize(344,null)})),pixelRatio:ze(new de),tabFocusMode:ze(new i(142,"tabFocusMode",!1,{markdownDescription:l.localize(345,null)})),layoutInfo:ze(new $e),wrappingInfo:ze(new Ge),wrappingIndent:ze(new Qe),wrappingStrategy:ze(new pe)}}),define(Ae[137],Re([10,11]),function(ye,e){return ye.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[138],Re([10,11]),function(ye,e){return ye.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[139],Re([10,11]),function(ye,e){return ye.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[140],Re([10,11]),function(ye,e){return ye.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[141],Re([10,11]),function(ye,e){return ye.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[142],Re([10,11]),function(ye,e){return ye.create("vs/platform/files/common/files",e)}),define(Ae[143],Re([10,11]),function(ye,e){return ye.create("vs/platform/markers/common/markers",e)}),define(Ae[144],Re([10,11]),function(ye,e){return ye.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[145],Re([10,11]),function(ye,e){return ye.create("vs/platform/workspace/common/workspace",e)}),define(Ae[146],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[147],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[148],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[149],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[150],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[151],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[152],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[153],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[154],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[155],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[156],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[157],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[158],Re([10,11]),function(ye,e){return ye.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[159],Re([10,11]),function(ye,e){return ye.create("vs/workbench/common/editor",e)}),define(Ae[160],Re([10,11]),function(ye,e){return ye.create("vs/workbench/common/views",e)}),define(Ae[161],Re([10,11]),function(ye,e){return ye.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[162],Re([10,11]),function(ye,e){return ye.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[163],Re([10,11]),function(ye,e){return ye.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[164],Re([10,11]),function(ye,e){return ye.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[165],Re([10,11]),function(ye,e){return ye.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[166],Re([10,11]),function(ye,e){return ye.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[167],Re([10,11]),function(ye,e){return ye.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[168],Re([1,0,9,139]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var C;(function($){$[$.LParen=0]="LParen",$[$.RParen=1]="RParen",$[$.Neg=2]="Neg",$[$.Eq=3]="Eq",$[$.NotEq=4]="NotEq",$[$.Lt=5]="Lt",$[$.LtEq=6]="LtEq",$[$.Gt=7]="Gt",$[$.GtEq=8]="GtEq",$[$.RegexOp=9]="RegexOp",$[$.RegexStr=10]="RegexStr",$[$.True=11]="True",$[$.False=12]="False",$[$.In=13]="In",$[$.Not=14]="Not",$[$.And=15]="And",$[$.Or=16]="Or",$[$.Str=17]="Str",$[$.QuotedStr=18]="QuotedStr",$[$.Error=19]="Error",$[$.EOF=20]="EOF"})(C||(e.TokenType=C={}));function T(...$){switch($.length){case 1:return(0,M.localize)(0,null,$[0]);case 2:return(0,M.localize)(1,null,$[0],$[1]);case 3:return(0,M.localize)(2,null,$[0],$[1],$[2]);default:return}}const A=(0,M.localize)(3,null),l=(0,M.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,y.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(T("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(T("&&"));break;case 124:this.h(124)?this.k(16):this.l(T("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const k=this.d,a=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:a};this.g.push({offset:k,lexeme:a,additionalInfo:R}),this.f.push(p)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const k=this.c.substring(this.d,this.e),a=D.b.get(k);a?this.k(a):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,k=!1,a=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(l);return}const g=this.c.charCodeAt(R);if(k)k=!1;else if(g===47&&!a){R++;break}else g===91?a=!0:g===92?k=!0:g===93&&(a=!1);R++}for(;R<this.c.length&&D.a.has(this.c.charCodeAt(R));)R++;this.e=R;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=D}),define(Ae[169],Re([1,0,23,29,141,278]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function D(i){return i=i.trim(),i==="*"||A.test(i)}e.$Mo=D;function $(i){if(!D(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=i.match(A);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$No=$;function R(i){if(!i)return null;const c=i.majorBase,b=i.majorMustEqual,E=i.minorBase;let v=i.minorMustEqual;const s=i.patchBase;let r=i.patchMustEqual;i.hasCaret&&(c===0||(v=!1),r=!1);let n=0;if(i.preRelease){const o=l.exec(i.preRelease);if(o){const[,w,f,I]=o;n=Date.UTC(Number(w),Number(f)-1,Number(I))}}return{majorBase:c,majorMustEqual:b,minorBase:E,minorMustEqual:v,patchBase:s,patchMustEqual:r,isMinimum:i.hasGreaterEquals,notBefore:n}}e.$Oo=R;function k(i,c,b){let E;typeof i=="string"?E=R($(i)):E=i;let v;c instanceof Date?v=c.getTime():typeof c=="string"&&(v=new Date(c).getTime());let s;if(typeof b=="string"?s=R($(b)):s=b,!E||!s)return!1;const r=E.majorBase,n=E.minorBase,o=E.patchBase;let w=s.majorBase,f=s.minorBase,I=s.patchBase;const S=s.notBefore;let u=s.majorMustEqual,m=s.minorMustEqual,h=s.patchMustEqual;return s.isMinimum?r>w?!0:r<w?!1:n>f?!0:n<f||v&&v<S?!1:o>=I:(r===1&&w===0&&(!u||!m||!h)&&(w=1,f=0,I=0,u=!0,m=!1,h=!1),r<w?!1:r>w?!u:n<f?!1:n>f?!m:o<I?!1:o>I?!h:!(v&&v<S))}e.$Po=k;function a(i,c,b,E,v){const s=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return s.push([M.default.Error,C.localize(0,null)]),s;if(typeof E.name!="string")return s.push([M.default.Error,C.localize(1,null,"name")]),s;if(typeof E.version!="string")return s.push([M.default.Error,C.localize(2,null,"version")]),s;if(!E.engines)return s.push([M.default.Error,C.localize(3,null,"engines")]),s;if(typeof E.engines.vscode!="string")return s.push([M.default.Error,C.localize(4,null,"engines.vscode")]),s;if(typeof E.extensionDependencies<"u"&&!t(E.extensionDependencies))return s.push([M.default.Error,C.localize(5,null,"extensionDependencies")]),s;if(typeof E.activationEvents<"u"){if(!t(E.activationEvents))return s.push([M.default.Error,C.localize(6,null,"activationEvents")]),s;if(typeof E.main>"u"&&typeof E.browser>"u")return s.push([M.default.Error,C.localize(7,null,"activationEvents","main","browser")]),s}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&s.push([M.default.Warning,C.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return s.push([M.default.Error,C.localize(9,null,"main")]),s;{const o=(0,y.$vg)(b,E.main);(0,y.$pg)(o,b)||s.push([M.default.Warning,C.localize(10,null,o.path,b.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return s.push([M.default.Error,C.localize(11,null,"browser")]),s;{const o=(0,y.$vg)(b,E.browser);(0,y.$pg)(o,b)||s.push([M.default.Warning,C.localize(12,null,o.path,b.path)])}}if(!T.valid(E.version))return s.push([M.default.Error,C.localize(13,null)]),s;const r=[];if(!p(i,c,E,v,r))for(const o of r)s.push([M.default.Error,o]);return s}e.$Qo=a;function p(i,c,b,E,v){return E||typeof b.main>"u"&&typeof b.browser>"u"?!0:d(i,c,b.engines.vscode,v)}e.$Ro=p;function g(i,c,b){return i==="*"||d(c,b,i)}e.$So=g;function d(i,c,b,E=[]){const v=R($(b));if(!v)return E.push(C.localize(14,null,b)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return E.push(C.localize(15,null,b)),!1}else if(!v.majorMustEqual)return E.push(C.localize(16,null,b)),!1;return k(i,c,v)?!0:(E.push(C.localize(17,null,i,b)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let c=0,b=i.length;c<b;c++)if(typeof i[c]!="string")return!1;return!0}}),define(Ae[69],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class y{constructor(C,T=[],A=!1){this.ctor=C,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.$Mh=y}),define(Ae[70],Re([1,0,69]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.InstantiationType=void 0;const M=[];var C;(function(l){l[l.Eager=0]="Eager",l[l.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function T(l,D,$){D instanceof y.$Mh||(D=new y.$Mh(D,[],!!$)),M.push([l,D])}e.$xr=T;function A(){return M}e.$yr=A}),define(Ae[170],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class y{constructor(T,A){this.key=T,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$cq=y;class M{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const A of this.a.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const l=this.lookupOrInsertNode(T),D=this.lookupOrInsertNode(A);l.outgoing.set(D.key,D),D.incoming.set(l.key,l)}removeNode(T){const A=this.b(T);this.a.delete(A);for(const l of this.a.values())l.outgoing.delete(A),l.incoming.delete(A)}lookupOrInsertNode(T){const A=this.b(T);let l=this.a.get(A);return l||(l=new y(A,T),this.a.set(A,l)),l}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[A,l]of this.a)T.push(`${A}
	(-> incoming)[${[...l.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...l.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,A]of this.a){const l=new Set([T]),D=this.c(A,l);if(D)return D}}c(T,A){for(const[l,D]of T.outgoing){if(A.has(l))return[...A,l].join(" -> ");A.add(l);const $=this.c(D,A);if($)return $;A.delete(l)}}}e.$dq=M}),define(Ae[4],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e._util=void 0;var y;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function l(D){return D[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=l})(y||(e._util=y={})),e.$Oh=C("instantiationService");function M(A,l,D){l[y.DI_TARGET]===l?l[y.DI_DEPENDENCIES].push({id:A,index:D}):(l[y.DI_DEPENDENCIES]=[{id:A,index:D}],l[y.DI_TARGET]=l)}function C(A){if(y.serviceIds.has(A))return y.serviceIds.get(A);const l=function(D,$,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(l,D,R)};return l.toString=()=>A,y.serviceIds.set(A,l),l}e.$Ph=C;function T(A){return A}e.$Qh=T}),define(Ae[44],Re([1,0,15,2,4]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,C.$Ph)("configurationService");function T(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof M.URI)}e.$ki=T;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof M.URI)}e.$li=A;var l;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(l||(e.ConfigurationTarget=l={}));function D(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=D;function $(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$ni=$;function R(i,c){const b=Object.create(null);for(const E in i)k(b,E,i[E],c);return b}e.$oi=R;function k(i,c,b,E){const v=c.split("."),s=v.pop();let r=i;for(let n=0;n<v.length;n++){const o=v[n];let w=r[o];switch(typeof w){case"undefined":w=r[o]=Object.create(null);break;case"object":break;default:E(`Ignoring ${c} as ${v.slice(0,n+1).join(".")} is ${JSON.stringify(w)}`);return}r=w}if(typeof r=="object"&&r!==null)try{r[s]=b}catch{E(`Ignoring ${c} as ${v.join(".")} is ${JSON.stringify(r)}`)}else E(`Ignoring ${c} as ${v.join(".")} is ${JSON.stringify(r)}`)}e.$pi=k;function a(i,c){const b=c.split(".");p(i,b)}e.$qi=a;function p(i,c){const b=c.shift();if(c.length===0){delete i[b];return}if(Object.keys(i).indexOf(b)!==-1){const E=i[b];typeof E=="object"&&!Array.isArray(E)&&(p(E,c),Object.keys(E).length===0&&delete i[b])}}function g(i,c,b){function E(r,n){let o=r;for(const w of n){if(typeof o!="object"||o===null)return;o=o[w]}return o}const v=c.split("."),s=E(i,v);return typeof s>"u"?b:s}e.$ri=g;function d(i,c,b){Object.keys(c).forEach(E=>{E!=="__proto__"&&(E in i?y.$Af(i[E])&&y.$Af(c[E])?d(i[E],c[E],b):b&&(i[E]=c[E]):i[E]=c[E])})}e.$si=d;function t(i){return i.replace(/[\[\]]/g,"")}e.$ti=t}),define(Ae[32],Re([1,0,22,16,168,4,138,9]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",y.$k),D.set("isLinux",y.$l),D.set("isWindows",y.$j),D.set("isWeb",y.$p),D.set("isMacNative",y.$k&&!y.$p),D.set("isEdge",y.$H),D.set("isFirefox",y.$F),D.set("isChrome",y.$E),D.set("isSafari",y.$G);function $(_,B){if(D.get(_)!==void 0)throw(0,l.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(_,B)}e.$Li=$;const R=Object.prototype.hasOwnProperty;var k;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const a={regexParsingWithErrorRecovery:!0},p=(0,A.localize)(0,null),g=(0,A.localize)(1,null),d=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),c=(0,A.localize)(5,null),b=(0,A.localize)(6,null),E=(0,A.localize)(7,null);class v{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=a){this.k=B,this.d=new C.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const Z=this.l();if(!this.E()){const ee=this.D(),ve=ee.type===17?c:void 0;throw this.h.push({message:i,offset:ee.offset,lexeme:C.$Ki.getLexeme(ee),additionalInfo:ve}),v.c}return Z}catch(Z){if(Z!==v.c)throw Z;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const Z=this.o();B.push(Z)}return B.length===1?B[0]:s.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const Z=this.s();B.push(Z)}return B.length===1?B[0]:s.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),f.INSTANCE;case 0:{this.z();const Z=this.l();return this.A(1,t),Z?.negate()}case 17:return this.z(),P.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const Z=this.l();return this.A(1,t),Z}case 17:{const Z=B.lexeme;if(this.z(),this.y(9)){const ve=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ve.type!==10)throw this.B("REGEX",ve);const ge=ve.lexeme,de=ge.lastIndexOf("/"),De=de===ge.length-1?void 0:this.w(ge.substring(de+1));let re;try{re=new RegExp(ge.substring(1,de),De)}catch{throw this.B("REGEX",ve)}return N.create(Z,re)}switch(ve.type){case 10:case 19:{const ge=[ve.lexeme];this.z();let de=this.D(),De=0;for(let fe=0;fe<ve.lexeme.length;fe++)ve.lexeme.charCodeAt(fe)===40?De++:ve.lexeme.charCodeAt(fe)===41&&De--;for(;!this.E()&&de.type!==15&&de.type!==16;){switch(de.type){case 0:De++;break;case 1:De--;break;case 10:case 18:for(let fe=0;fe<de.lexeme.length;fe++)de.lexeme.charCodeAt(fe)===40?De++:ve.lexeme.charCodeAt(fe)===41&&De--}if(De<0)break;ge.push(C.$Ki.getLexeme(de)),this.z(),de=this.D()}const re=ge.join(""),le=re.lastIndexOf("/"),ne=le===re.length-1?void 0:this.w(re.substring(le+1));let ae;try{ae=new RegExp(re.substring(1,le),ne)}catch{throw this.B("REGEX",ve)}return s.regex(Z,ae)}case 18:{const ge=ve.lexeme;this.z();let de=null;if(!(0,M.$Be)(ge)){const De=ge.indexOf("/"),re=ge.lastIndexOf("/");if(De!==re&&De>=0){const le=ge.slice(De+1,re),ne=ge[re+1]==="i"?"i":"";try{de=new RegExp(le,ne)}catch{throw this.B("REGEX",ve)}}}if(de===null)throw this.B("REGEX",ve);return N.create(Z,de)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,d);const ve=this.u();return s.notIn(Z,ve)}switch(this.D().type){case 3:{this.z();const ve=this.u();if(this.x().type===18)return s.equals(Z,ve);switch(ve){case"true":return s.has(Z);case"false":return s.not(Z);default:return s.equals(Z,ve)}}case 4:{this.z();const ve=this.u();if(this.x().type===18)return s.notEquals(Z,ve);switch(ve){case"true":return s.not(Z);case"false":return s.has(Z);default:return s.notEquals(Z,ve)}}case 5:return this.z(),j.create(Z,this.u());case 6:return this.z(),O.create(Z,this.u());case 7:return this.z(),K.create(Z,this.u());case 8:return this.z(),z.create(Z,this.u());case 13:return this.z(),s.in(Z,this.u());default:return s.has(Z)}}case 20:throw this.h.push({message:b,offset:B.offset,lexeme:"",additionalInfo:E}),v.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,Z){if(this.C(B))return this.z();throw this.B(Z,this.D())}B(B,Z,ee){const ve=(0,A.localize)(8,null,B,C.$Ki.getLexeme(Z)),ge=Z.offset,de=C.$Ki.getLexeme(Z);return this.h.push({message:ve,offset:ge,lexeme:de,additionalInfo:ee}),v.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=v;class s{static false(){return w.INSTANCE}static true(){return f.INSTANCE}static has(B){return I.create(B)}static equals(B,Z){return S.create(B,Z)}static notEquals(B,Z){return h.create(B,Z)}static regex(B,Z){return N.create(B,Z)}static in(B,Z){return u.create(B,Z)}static notIn(B,Z){return m.create(B,Z)}static not(B){return P.create(B)}static and(...B){return Ee.create(B,null,!0)}static or(...B){return Se.create(B,null,!0)}static greater(B,Z){return K.create(B,Z)}static greaterEquals(B,Z){return z.create(B,Z)}static smaller(B,Z){return j.create(B,Z)}static smallerEquals(B,Z){return O.create(B,Z)}static{this.c=new v({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Ni=s;function r(_){const B=new v({regexParsingWithErrorRecovery:!1});return _.map(Z=>(B.parse(Z),B.lexingErrors.length>0?B.lexingErrors.map(ee=>({errorMessage:ee.additionalInfo?(0,A.localize)(9,null,ee.additionalInfo):(0,A.localize)(10,null),offset:ee.offset,length:ee.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(ee=>({errorMessage:ee.additionalInfo?`${ee.message}. ${ee.additionalInfo}`:ee.message,offset:ee.offset,length:ee.lexeme.length})):[]))}e.$Oi=r;function n(_,B){const Z=_?_.substituteConstants():void 0,ee=B?B.substituteConstants():void 0;return!Z&&!ee?!0:!Z||!ee?!1:Z.equals(ee)}e.$Pi=n;function o(_,B){return _.cmp(B)}class w{static{this.INSTANCE=new w}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return f.INSTANCE}}e.$Qi=w;class f{static{this.INSTANCE=new f}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return w.INSTANCE}}e.$Ri=f;class I{static create(B,Z=null){const ee=D.get(B);return typeof ee=="boolean"?ee?f.INSTANCE:w.INSTANCE:new I(B,Z)}constructor(B,Z){this.key=B,this.c=Z,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:$e(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=D.get(this.key);return typeof B=="boolean"?B?f.INSTANCE:w.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$Si=I;class S{static create(B,Z,ee=null){if(typeof Z=="boolean")return Z?I.create(B,ee):P.create(B,ee);const ve=D.get(B);return typeof ve=="boolean"?Z===(ve?"true":"false")?f.INSTANCE:w.INSTANCE:new S(B,Z,ee)}constructor(B,Z,ee){this.c=B,this.d=Z,this.f=ee,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=D.get(this.c);if(typeof B=="boolean"){const Z=B?"true":"false";return this.d===Z?f.INSTANCE:w.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.$Ti=S;class u{static create(B,Z){return new u(B,Z)}constructor(B,Z){this.d=B,this.f=Z,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const Z=B.getValue(this.f),ee=B.getValue(this.d);return Array.isArray(Z)?Z.includes(ee):typeof ee=="string"&&typeof Z=="object"&&Z!==null?R.call(Z,ee):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.$Ui=u;class m{static create(B,Z){return new m(B,Z)}constructor(B,Z){this.d=B,this.f=Z,this.type=11,this.c=u.create(B,Z)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=m;class h{static create(B,Z,ee=null){if(typeof Z=="boolean")return Z?P.create(B,ee):I.create(B,ee);const ve=D.get(B);return typeof ve=="boolean"?Z===(ve?"true":"false")?w.INSTANCE:f.INSTANCE:new h(B,Z,ee)}constructor(B,Z,ee){this.c=B,this.d=Z,this.f=ee,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=D.get(this.c);if(typeof B=="boolean"){const Z=B?"true":"false";return this.d===Z?w.INSTANCE:f.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Wi=h;class P{static create(B,Z=null){const ee=D.get(B);return typeof ee=="boolean"?ee?w.INSTANCE:f.INSTANCE:new P(B,Z)}constructor(B,Z){this.c=B,this.d=Z,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:$e(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=D.get(this.c);return typeof B=="boolean"?B?w.INSTANCE:f.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Xi=P;function W(_,B){if(typeof _=="string"){const Z=parseFloat(_);isNaN(Z)||(_=Z)}return typeof _=="string"||typeof _=="number"?B(_):w.INSTANCE}class K{static create(B,Z,ee=null){return W(Z,ve=>new K(B,ve,ee))}constructor(B,Z,ee){this.c=B,this.d=Z,this.f=ee,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Yi=K;class z{static create(B,Z,ee=null){return W(Z,ve=>new z(B,ve,ee))}constructor(B,Z,ee){this.c=B,this.d=Z,this.f=ee,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Zi=z;class j{static create(B,Z,ee=null){return W(Z,ve=>new j(B,ve,ee))}constructor(B,Z,ee){this.c=B,this.d=Z,this.f=ee,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$1i=j;class O{static create(B,Z,ee=null){return W(Z,ve=>new O(B,ve,ee))}constructor(B,Z,ee){this.c=B,this.d=Z,this.f=ee,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$2i=O;class N{static create(B,Z){return new N(B,Z)}constructor(B,Z){this.d=B,this.f=Z,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const Z=this.f?this.f.source:"",ee=B.f?B.f.source:"";return Z<ee?-1:Z>ee?1:0}equals(B){if(B.type===this.type){const Z=this.f?this.f.source:"",ee=B.f?B.f.source:"";return this.d===B.d&&Z===ee}return!1}substituteConstants(){return this}evaluate(B){const Z=B.getValue(this.d);return this.f?this.f.test(Z):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$3i=N;class ie{static create(B){return new ie(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new ie(this.c.map(B))}negate(){return this.c}}e.$4i=ie;function X(_){let B=null;for(let Z=0,ee=_.length;Z<ee;Z++){const ve=_[Z].substituteConstants();if(_[Z]!==ve&&B===null){B=[];for(let ge=0;ge<Z;ge++)B[ge]=_[ge]}B!==null&&(B[Z]=ve)}return B===null?_:B}class Ee{static create(B,Z,ee){return Ee.d(B,Z,ee)}constructor(B,Z){this.expr=B,this.c=Z,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let Z=0,ee=this.expr.length;Z<ee;Z++){const ve=o(this.expr[Z],B.expr[Z]);if(ve!==0)return ve}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let Z=0,ee=this.expr.length;Z<ee;Z++)if(!this.expr[Z].equals(B.expr[Z]))return!1;return!0}return!1}substituteConstants(){const B=X(this.expr);return B===this.expr?this:Ee.create(B,this.c,!1)}evaluate(B){for(let Z=0,ee=this.expr.length;Z<ee;Z++)if(!this.expr[Z].evaluate(B))return!1;return!0}static d(B,Z,ee){const ve=[];let ge=!1;for(const de of B)if(de){if(de.type===1){ge=!0;continue}if(de.type===0)return w.INSTANCE;if(de.type===6){ve.push(...de.expr);continue}ve.push(de)}if(ve.length===0&&ge)return f.INSTANCE;if(ve.length!==0){if(ve.length===1)return ve[0];ve.sort(o);for(let de=1;de<ve.length;de++)ve[de-1].equals(ve[de])&&(ve.splice(de,1),de--);if(ve.length===1)return ve[0];for(;ve.length>1;){const de=ve[ve.length-1];if(de.type!==9)break;ve.pop();const De=ve.pop(),re=ve.length===0,le=Se.create(de.expr.map(ne=>Ee.create([ne,De],null,ee)),null,re);le&&(ve.push(le),ve.sort(o))}if(ve.length===1)return ve[0];if(ee){for(let de=0;de<ve.length;de++)for(let De=de+1;De<ve.length;De++)if(ve[de].negate().equals(ve[De]))return w.INSTANCE;if(ve.length===1)return ve[0]}return new Ee(ve,Z)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const Z of this.expr)B.push(...Z.keys());return B}map(B){return new Ee(this.expr.map(Z=>Z.map(B)),null)}negate(){if(!this.c){const B=[];for(const Z of this.expr)B.push(Z.negate());this.c=Se.create(B,this,!0)}return this.c}}e.$5i=Ee;class Se{static create(B,Z,ee){return Se.d(B,Z,ee)}constructor(B,Z){this.expr=B,this.c=Z,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let Z=0,ee=this.expr.length;Z<ee;Z++){const ve=o(this.expr[Z],B.expr[Z]);if(ve!==0)return ve}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let Z=0,ee=this.expr.length;Z<ee;Z++)if(!this.expr[Z].equals(B.expr[Z]))return!1;return!0}return!1}substituteConstants(){const B=X(this.expr);return B===this.expr?this:Se.create(B,this.c,!1)}evaluate(B){for(let Z=0,ee=this.expr.length;Z<ee;Z++)if(this.expr[Z].evaluate(B))return!0;return!1}static d(B,Z,ee){let ve=[],ge=!1;if(B){for(let de=0,De=B.length;de<De;de++){const re=B[de];if(re){if(re.type===0){ge=!0;continue}if(re.type===1)return f.INSTANCE;if(re.type===9){ve=ve.concat(re.expr);continue}ve.push(re)}}if(ve.length===0&&ge)return w.INSTANCE;ve.sort(o)}if(ve.length!==0){if(ve.length===1)return ve[0];for(let de=1;de<ve.length;de++)ve[de-1].equals(ve[de])&&(ve.splice(de,1),de--);if(ve.length===1)return ve[0];if(ee){for(let de=0;de<ve.length;de++)for(let De=de+1;De<ve.length;De++)if(ve[de].negate().equals(ve[De]))return f.INSTANCE;if(ve.length===1)return ve[0]}return new Se(ve,Z)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const Z of this.expr)B.push(...Z.keys());return B}map(B){return new Se(this.expr.map(Z=>Z.map(B)),null)}negate(){if(!this.c){const B=[];for(const Z of this.expr)B.push(Z.negate());for(;B.length>1;){const Z=B.shift(),ee=B.shift(),ve=[];for(const ge of be(Z))for(const de of be(ee))ve.push(Ee.create([ge,de],null,!1));B.unshift(Se.create(ve,null,!1))}this.c=Se.create(B,this,!0)}return this.c}}e.$6i=Se;class Pe extends I{static{this.d=[]}static all(){return Pe.d.values()}constructor(B,Z,ee){super(B,null),this.f=Z,typeof ee=="object"?Pe.d.push({...ee,key:B}):ee!==!0&&Pe.d.push({key:B,description:ee,type:Z!=null?typeof Z:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return S.create(this.key,B)}notEqualsTo(B){return h.create(this.key,B)}}e.$7i=Pe,e.$8i=(0,T.$Ph)("contextKeyService");function $e(_,B){return _<B?-1:_>B?1:0}function pe(_,B,Z,ee){return _<Z?-1:_>Z?1:B<ee?-1:B>ee?1:0}function ue(_,B){if(_.type===0||B.type===1)return!0;if(_.type===9)return B.type===9?oe(_.expr,B.expr):!1;if(B.type===9){for(const Z of B.expr)if(ue(_,Z))return!0;return!1}if(_.type===6){if(B.type===6)return oe(B.expr,_.expr);for(const Z of _.expr)if(ue(Z,B))return!0;return!1}return _.equals(B)}e.$9i=ue;function oe(_,B){let Z=0,ee=0;for(;Z<_.length&&ee<B.length;){const ve=_[Z].cmp(B[ee]);if(ve<0)return!1;ve===0&&Z++,ee++}return Z===_.length}function be(_){return _.type===9?_.expr:[_]}}),define(Ae[171],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,y.$Ph)("environmentService"),e.$Xh=(0,y.$Qh)(e.$Wh)}),define(Ae[92],Re([1,0,140,4]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$$n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=void 0,e.$Xn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Yn=new RegExp(e.$Xn),e.$Zn="__web_extension",e.$1n="skipWalkthrough",e.$2n="extensionsSync",e.$3n="dependecyOrPackExtensionInstall";function C(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$4n=C;function T(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$5n=T;function A(c,b){switch(c){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$6n=A;function l(c,b){return b==="web"&&!c.includes("web")}e.$7n=l;function D(c,b,E){return l(b,E)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===E?!0:$(E).includes(c)}e.$8n=D;function $(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$9n=$;function R(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$0n=R;var k;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var a;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(a||(e.SortOrder=a={}));var p;(function(c){c.Install="install",c.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var g;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.$$n=(0,M.$Ph)("extensionGalleryService");var d;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));var t;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class i extends Error{constructor(b,E){super(b),this.code=E,this.name=E}}e.$_n=i,e.$ao=(0,M.$Ph)("extensionManagementService"),e.$bo="extensionsIdentifiers/disabled",e.$co="extensionsIdentifiers/enabled",e.$do=(0,M.$Ph)("IGlobalExtensionEnablementService"),e.$eo=(0,M.$Ph)("IExtensionTipsService"),e.$fo=(0,y.localize)(0,null),e.$go={value:e.$fo,original:"Extensions"},e.$ho={value:(0,y.localize)(1,null),original:"Preferences"}}),define(Ae[39],Re([1,0,49,19,16,15,2,142,4,22,13,41]),function(ye,e,y,M,C,T,A,l,D,$,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileKind=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileOperationResult=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileChangeType=e.$qk=e.FileOperation=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileSystemProviderErrorCode=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileSystemProviderCapabilities=e.$ak=e.FilePermission=e.FileType=e.$_j=e.$$j=void 0,e.$$j=(0,D.$Ph)("fileService");function a(ue){return ue.create===!0}e.$_j=a;var p;(function(ue){ue[ue.Unknown=0]="Unknown",ue[ue.File=1]="File",ue[ue.Directory=2]="Directory",ue[ue.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var g;(function(ue){ue[ue.Readonly=1]="Readonly",ue[ue.Locked=2]="Locked"})(g||(e.FilePermission=g={}));function d(ue){const oe=ue;return!!oe&&typeof oe.onDidChange=="function"}e.$ak=d;var t;(function(ue){ue[ue.None=0]="None",ue[ue.FileReadWrite=2]="FileReadWrite",ue[ue.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ue[ue.FileReadStream=16]="FileReadStream",ue[ue.FileFolderCopy=8]="FileFolderCopy",ue[ue.PathCaseSensitive=1024]="PathCaseSensitive",ue[ue.Readonly=2048]="Readonly",ue[ue.Trash=4096]="Trash",ue[ue.FileWriteUnlock=8192]="FileWriteUnlock",ue[ue.FileAtomicRead=16384]="FileAtomicRead",ue[ue.FileAtomicWrite=32768]="FileAtomicWrite",ue[ue.FileAtomicDelete=65536]="FileAtomicDelete",ue[ue.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(ue){return!!(ue.capabilities&2)}e.$bk=i;function c(ue){return!!(ue.capabilities&8)}e.$ck=c;function b(ue){return!!(ue.capabilities&131072)}e.$dk=b;function E(ue){return!!(ue.capabilities&4)}e.$ek=E;function v(ue){return!!(ue.capabilities&16)}e.$fk=v;function s(ue){return i(ue)?!!(ue.capabilities&16384):!1}e.$gk=s;function r(ue){return i(ue)?!!(ue.capabilities&32768):!1}e.$hk=r;function n(ue){return!!(ue.capabilities&65536)}e.$ik=n;function o(ue){return!!(ue.capabilities&2048)}e.$jk=o;var w;(function(ue){ue.FileExists="EntryExists",ue.FileNotFound="EntryNotFound",ue.FileNotADirectory="EntryNotADirectory",ue.FileIsADirectory="EntryIsADirectory",ue.FileExceedsStorageQuota="EntryExceedsStorageQuota",ue.FileTooLarge="EntryTooLarge",ue.FileWriteLocked="EntryWriteLocked",ue.NoPermissions="NoPermissions",ue.Unavailable="Unavailable",ue.Unknown="Unknown"})(w||(e.FileSystemProviderErrorCode=w={}));class f extends Error{static create(oe,be){const _=new f(oe.toString(),be);return u(_,be),_}constructor(oe,be){super(oe),this.code=be}}e.$kk=f;function I(ue,oe){return f.create(ue,oe)}e.$lk=I;function S(ue){return ue||I((0,l.localize)(0,null),w.Unknown)}e.$mk=S;function u(ue,oe){return ue.name=oe?`${oe} (FileSystemError)`:"FileSystemError",ue}e.$nk=u;function m(ue){if(!ue)return w.Unknown;if(ue instanceof f)return ue.code;const oe=/^(.+) \(FileSystemError\)$/.exec(ue.name);if(!oe)return w.Unknown;switch(oe[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.$ok=m;function h(ue){if(ue instanceof O)return ue.fileOperationResult;switch(m(ue)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 9;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileTooLarge:return 7;default:return 10}}e.$pk=h;var P;(function(ue){ue[ue.CREATE=0]="CREATE",ue[ue.DELETE=1]="DELETE",ue[ue.MOVE=2]="MOVE",ue[ue.COPY=3]="COPY",ue[ue.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class W{constructor(oe,be,_){this.resource=oe,this.operation=be,this.target=_}isOperation(oe){return this.operation===oe}}e.$qk=W;var K;(function(ue){ue[ue.UPDATED=0]="UPDATED",ue[ue.ADDED=1]="ADDED",ue[ue.DELETED=2]="DELETED"})(K||(e.FileChangeType=K={}));class z{static{this.a=null}constructor(oe,be){this.c=be,this.b=void 0,this.d=new k.$V(()=>{const _=y.$Vh.forUris(()=>this.c);return _.fill(this.rawAdded.map(B=>[B,!0])),_}),this.f=new k.$V(()=>{const _=y.$Vh.forUris(()=>this.c);return _.fill(this.rawUpdated.map(B=>[B,!0])),_}),this.g=new k.$V(()=>{const _=y.$Vh.forUris(()=>this.c);return _.fill(this.rawDeleted.map(B=>[B,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of oe){switch(_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}this.b!==z.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(oe,...be){return this.h(oe,{includeChildren:!1},...be)}affects(oe,...be){return this.h(oe,{includeChildren:!0},...be)}h(oe,be,..._){if(!oe)return!1;const B=_.length>0;return!!((!B||_.includes(1))&&(this.d.value.get(oe)||be.includeChildren&&this.d.value.findSuperstr(oe))||(!B||_.includes(0))&&(this.f.value.get(oe)||be.includeChildren&&this.f.value.findSuperstr(oe))||(!B||_.includes(2))&&(this.g.value.findSubstr(oe)||be.includeChildren&&this.g.value.findSuperstr(oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(oe){return this.b===oe}hasCorrelation(){return typeof this.b=="number"}}e.$rk=z;function j(ue,oe,be){return!ue||!oe||ue===oe||oe.length>ue.length?!1:(oe.charAt(oe.length-1)!==M.sep&&(oe+=M.sep),be?(0,C.$3e)(ue,oe):ue.indexOf(oe)===0)}e.$sk=j;class O extends Error{constructor(oe,be,_){super(oe),this.fileOperationResult=be,this.options=_}}e.$tk=O;class N extends O{constructor(oe,be,_,B){super(oe,be,B),this.fileOperationResult=be,this.size=_}}e.$uk=N;class ie extends O{constructor(oe,be,_){super(oe,2,_),this.stat=be}}e.$vk=ie;var X;(function(ue){ue[ue.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ue[ue.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ue[ue.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ue[ue.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ue[ue.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ue[ue.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ue[ue.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ue[ue.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ue[ue.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ue[ue.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ue[ue.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.$wk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yk="files.associations",e.$zk="files.exclude",e.$Ak="files.readonlyInclude",e.$Bk="files.readonlyExclude",e.$Ck="files.readonlyFromPermissions";var Ee;(function(ue){ue[ue.FILE=0]="FILE",ue[ue.FOLDER=1]="FOLDER",ue[ue.ROOT_FOLDER=2]="ROOT_FOLDER"})(Ee||(e.FileKind=Ee={})),e.$Dk="";function Se(ue){if(!(typeof ue.size!="number"||typeof ue.mtime!="number"))return ue.mtime.toString(29)+ue.size.toString(31)}e.$Ek=Se;async function Pe(ue,oe){if(!oe.hasProvider(A.URI.from({scheme:ue.scheme})))return new Promise(be=>{const _=oe.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===ue.scheme&&B.added&&(_.dispose(),be())})})}e.$Fk=Pe;class $e{static{this.KB=1024}static{this.MB=$e.KB*$e.KB}static{this.GB=$e.MB*$e.KB}static{this.TB=$e.GB*$e.KB}static formatSize(oe){return(0,T.$Cf)(oe)||(oe=0),oe<$e.KB?(0,l.localize)(1,null,oe.toFixed(0)):oe<$e.MB?(0,l.localize)(2,null,(oe/$e.KB).toFixed(2)):oe<$e.GB?(0,l.localize)(3,null,(oe/$e.MB).toFixed(2)):oe<$e.TB?(0,l.localize)(4,null,(oe/$e.GB).toFixed(2)):(0,l.localize)(5,null,(oe/$e.TB).toFixed(2))}}e.$Gk=$e;function pe(ue){const oe=typeof ue=="string"||ue?.scheme===R.Schemas.vscodeRemote;return typeof ue!="string"&&ue?.scheme===R.Schemas.file?1024*$e.MB:oe?10*$e.MB:$.$p?50*$e.MB:1024*$e.MB}e.$Hk=pe}),define(Ae[71],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class y{constructor(...C){this.a=new Map;for(const[T,A]of C)this.set(T,A)}set(C,T){const A=this.a.get(C);return this.a.set(C,T),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Nh=y}),define(Ae[172],Re([1,0,12,9,6,69,170,4,71,173]),function(ye,e,y,M,C,T,A,l,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;const R=!1;class k extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class a{constructor(t=new D.$Nh,i=!1,c,b=R){this.f=t,this.g=i,this.h=c,this.i=b,this.o=new Set,this.f.set(l.$Oh,this),this._globalGraph=b?c?._globalGraph??new A.$dq(E=>E):void 0}createChild(t){return new a(t,this.g,this,this.i)}invokeFunction(t,...i){const c=g.traceInvocation(this.i,t);let b=!1;try{return t({get:v=>{if(b)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const s=this.m(v,c);if(!s)throw new Error(`[invokeFunction] unknown service '${v}'`);return s}},...i)}finally{b=!0,c.stop()}}createInstance(t,...i){let c,b;return t instanceof T.$Mh?(c=g.traceCreation(this.i,t.ctor),b=this.j(t.ctor,t.staticArguments.concat(i),c)):(c=g.traceCreation(this.i,t),b=this.j(t,i,c)),c.stop(),b}j(t,i=[],c){const b=l._util.getServiceDependencies(t).sort((s,r)=>s.index-r.index),E=[];for(const s of b){const r=this.m(s.id,c);r||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${s.id}.`,!1),E.push(r)}const v=b.length>0?b[0].index:i.length;if(i.length!==v){console.trace(`[createInstance] First service dependency of ${t.name} at position ${v+1} conflicts with ${i.length} static arguments`);const s=v-i.length;s>0?i=i.concat(new Array(s)):i=i.slice(0,v)}return Reflect.construct(t,i.concat(E))}k(t,i){if(this.f.get(t)instanceof T.$Mh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const c=this.l(t);return c instanceof T.$Mh?this.q(t,c,i.branch(t,!0)):(i.branch(t,!1),c)}q(t,i,c){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,c)}finally{this.o.delete(t)}}r(t,i,c){const b=new A.$dq(s=>s.id.toString());let E=0;const v=[{id:t,desc:i,_trace:c}];for(;v.length;){const s=v.pop();if(b.lookupOrInsertNode(s),E++>1e3)throw new k(b);for(const r of l._util.getServiceDependencies(s.desc.ctor)){const n=this.l(r.id);if(n||this.u(`[createInstance] ${t} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(r.id)),n instanceof T.$Mh){const o={id:r.id,desc:n,_trace:s._trace.branch(r.id,!0)};b.insertEdge(s,o),v.push(o)}}}for(;;){const s=b.roots();if(s.length===0){if(!b.isEmpty())throw new k(b);break}for(const{data:r}of s){if(this.l(r.id)instanceof T.$Mh){const o=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,o)}b.removeNode(r)}}return this.l(t)}s(t,i,c=[],b,E){if(this.f.get(t)instanceof T.$Mh)return this.t(t,i,c,b,E);if(this.h)return this.h.s(t,i,c,b,E);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,c=[],b,E){if(b){const v=new a(void 0,this.g,this,this.i);v.c=String(t);const s=new Map,r=new y.$$g(()=>{const n=v.j(i,c,E);for(const[o,w]of s){const f=n[o];if(typeof f=="function")for(const I of w)f.apply(n,I)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,o){if(!r.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let I=s.get(o);return I||(I=new $.$2c,s.set(o,I)),(u,m,h)=>{const P=I.push([u,m,h]);return(0,C.$Qc)(P)}}if(o in n)return n[o];const w=r.value;let f=w[o];return typeof f!="function"||(f=f.bind(w),n[o]=f),f},set(n,o,w){return r.value[o]=w,!0},getPrototypeOf(n){return i.prototype}})}else return this.j(i,c,E)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$eq=a;var p;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(p||(p={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new g(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(t,i){return t?new g(1,i.name):g.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const c=new g(3,t.toString());return this.h.push([t,i,c]),c}stop(){const t=Date.now()-this.g;g.f+=t;let i=!1;function c(E,v){const s=[],r=new Array(E+1).join("	");for(const[n,o,w]of v.h)if(o&&w){i=!0,s.push(`${r}CREATES -> ${n}`);const f=c(E+1,w);f&&s.push(f)}else s.push(`${r}uses -> ${n}`);return s.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(t>2||i)&&g.all.add(b.join(`
`))}}e.$fq=g}),define(Ae[14],Re([1,0,37,5,93,6,28,22,23,15,2,32,4]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,a.$Ph)("logService"),e.$$i=(0,a.$Ph)("loggerService");function p(){return new Date().toISOString()}function g(u){return(0,$.$Cf)(u)}e.$_i=g;var d;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(d||(e.LogLevel=d={})),e.$aj=d.Info;function t(u,m,h){switch(m){case d.Trace:u.trace(h);break;case d.Debug:u.debug(h);break;case d.Info:u.info(h);break;case d.Warning:u.warn(h);break;case d.Error:u.error(h);break;case d.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=t;function i(u,m=!1){let h="";for(let P=0;P<u.length;P++){let W=u[P];if(W instanceof Error&&(W=(0,y.$Ai)(W,m)),typeof W=="object")try{W=JSON.stringify(W)}catch{}h+=(P>0?" ":"")+W}return h}class c extends T.$Sc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new M.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(m){this.b!==m&&(this.b=m,this.c.fire(this.b))}getLevel(){return this.b}f(m){return this.b!==d.Off&&this.b<=m}}e.$cj=c;class b extends c{constructor(m){super(),this.h=m}f(m){return this.h||super.f(m)}trace(m,...h){this.f(d.Trace)&&this.g(d.Trace,i([m,...h],!0))}debug(m,...h){this.f(d.Debug)&&this.g(d.Debug,i([m,...h]))}info(m,...h){this.f(d.Info)&&this.g(d.Info,i([m,...h]))}warn(m,...h){this.f(d.Warning)&&this.g(d.Warning,i([m,...h]))}error(m,...h){if(this.f(d.Error))if(m instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=m.stack,this.g(d.Error,i(P))}else this.g(d.Error,i([m,...h]))}flush(){}}e.$dj=b;class E extends c{constructor(m=e.$aj){super(),this.setLevel(m),this.g=!l.$j}trace(m,...h){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,m,...h):console.log(`[main ${p()}]`,m,...h))}debug(m,...h){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,m,...h):console.log(`[main ${p()}]`,m,...h))}info(m,...h){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,m,...h):console.log(`[main ${p()}]`,m,...h))}warn(m,...h){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,m,...h):console.warn(`[main ${p()}]`,m,...h))}error(m,...h){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,m,...h):console.error(`[main ${p()}]`,m,...h))}dispose(){}flush(){}}e.$ej=E;class v extends c{constructor(m=e.$aj,h=!0){super(),this.g=h,this.setLevel(m)}trace(m,...h){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",m,...h):console.log(m,...h))}debug(m,...h){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",m,...h):console.log(m,...h))}info(m,...h){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",m,...h):console.log(m,...h))}warn(m,...h){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",m,...h):console.log(m,...h))}error(m,...h){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",m,...h):console.error(m,...h))}dispose(){}flush(){}}e.$fj=v;class s extends c{constructor(m,h=e.$aj){super(),this.g=m,this.setLevel(h)}trace(m,...h){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(m),...h])}debug(m,...h){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(m),...h])}info(m,...h){this.f(d.Info)&&this.g.log(d.Info,[this.h(m),...h])}warn(m,...h){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(m),...h])}error(m,...h){this.f(d.Error)&&this.g.log(d.Error,[this.h(m),...h])}h(m){return typeof m=="string"?m:(0,y.$Ai)(m,this.f(d.Trace))}dispose(){}flush(){}}e.$gj=s;class r extends c{constructor(m){super(),this.g=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const h of this.g)h.setLevel(m);super.setLevel(m)}trace(m,...h){for(const P of this.g)P.trace(m,...h)}debug(m,...h){for(const P of this.g)P.debug(m,...h)}info(m,...h){for(const P of this.g)P.info(m,...h)}warn(m,...h){for(const P of this.g)P.warn(m,...h)}error(m,...h){for(const P of this.g)P.error(m,...h)}flush(){for(const m of this.g)m.flush()}dispose(){for(const m of this.g)m.dispose()}}e.$hj=r;class n extends T.$Sc{constructor(m,h,P){if(super(),this.h=m,this.j=h,this.b=new A.$Ac,this.c=this.B(new M.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Nd),this.onDidChangeVisibility=this.g.event,P)for(const W of P)this.b.set(W.resource,{logger:void 0,info:W})}m(m){return(0,$.$yf)(m)?[...this.b.values()].find(h=>h.info.id===m):this.b.get(m)}getLogger(m){return this.m(m)?.logger}createLogger(m,h){const P=this.n(m),W=(0,$.$yf)(m)?m:h?.id??(0,C.$Di)(P.toString()).toString(16);let K=this.b.get(P)?.logger;const z=h?.logLevel==="always"?d.Trace:h?.logLevel;K||(K=this.s(P,z??this.getLogLevel(P)??this.h,{...h,id:W}));const j={logger:K,info:{resource:P,id:W,logLevel:z,name:h?.name,hidden:h?.hidden,extensionId:h?.extensionId,when:h?.when}};return this.registerLogger(j.info),this.b.set(P,j),K}n(m){return(0,$.$yf)(m)?(0,D.$vg)(this.j,`${m}.log`):m}setLogLevel(m,h){if(R.URI.isUri(m)){const P=m,W=h,K=this.b.get(P);K&&W!==K.info.logLevel&&(K.info.logLevel=W===this.h?void 0:W,K.logger?.setLevel(W),this.b.set(K.info.resource,K),this.f.fire([P,W]))}else{this.h=m;for(const[P,W]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(m,h){const P=this.m(m);P&&h!==!P.info.hidden&&(P.info.hidden=!h,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,h]))}getLogLevel(m){let h;return m&&(h=this.b.get(m)?.info.logLevel),h??this.h}registerLogger(m){const h=this.b.get(m.resource);h?h.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this.b.set(m.resource,{info:m,logger:void 0}),this.c.fire({added:[m],removed:[]}))}deregisterLogger(m){const h=this.b.get(m);h&&(h.logger&&h.logger.dispose(),this.b.delete(m),this.c.fire({added:[],removed:[h.info]}))}*getRegisteredLoggers(){for(const m of this.b.values())yield m.info}getRegisteredLogger(m){return this.b.get(m)?.info}dispose(){this.b.forEach(m=>m.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=n;class o{constructor(){this.onDidChangeLogLevel=new M.$Nd().event}setLevel(m){}getLevel(){return d.Info}trace(m,...h){}debug(m,...h){}info(m,...h){}warn(m,...h){}error(m,...h){}critical(m,...h){}dispose(){}flush(){}}e.$jj=o;class w extends o{}e.$kj=w;function f(u){if(u.verbose)return d.Trace;if(typeof u.logLevel=="string"){const m=S(u.logLevel.toLowerCase());if(m!==void 0)return m}return e.$aj}e.$lj=f;function I(u){switch(u){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.$mj=I;function S(u){switch(u){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.$nj=S,e.$oj=new k.$7i("logLevel",I(d.Info))}),define(Ae[174],Re([1,0,6,14]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=void 0;class C extends y.$Sc{constructor(A,l=[]){super(),this.a=new M.$hj([A,...l]),this.B(A.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...l){this.a.trace(A,...l)}debug(A,...l){this.a.debug(A,...l)}info(A,...l){this.a.info(A,...l)}warn(A,...l){this.a.warn(A,...l)}error(A,...l){this.a.error(A,...l)}flush(){this.a.flush()}}e.$DN=C}),define(Ae[94],Re([1,0,29,143,4]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(T||(e.MarkerTag=T={}));var A;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(D){function $(g,d){return d-g}D.compare=$;const R=Object.create(null);R[D.Error]=(0,M.localize)(0,null),R[D.Warning]=(0,M.localize)(1,null),R[D.Info]=(0,M.localize)(2,null);function k(g){return R[g]||""}D.toString=k;function a(g){switch(g){case y.default.Error:return D.Error;case y.default.Warning:return D.Warning;case y.default.Info:return D.Info;case y.default.Ignore:return D.Hint}}D.fromSeverity=a;function p(g){switch(g){case D.Error:return y.default.Error;case D.Warning:return y.default.Warning;case D.Info:return y.default.Info;case D.Hint:return y.default.Ignore}}D.toSeverity=p}(A||(e.MarkerSeverity=A={}));var l;(function(D){const $="";function R(a){return k(a,!0)}D.makeKey=R;function k(a,p){const g=[$];return a.source?g.push(a.source.replace("\xA6","\\\xA6")):g.push($),a.code?typeof a.code=="string"?g.push(a.code.replace("\xA6","\\\xA6")):g.push(a.code.value.replace("\xA6","\\\xA6")):g.push($),a.severity!==void 0&&a.severity!==null?g.push(A.toString(a.severity)):g.push($),a.message&&p?g.push(a.message.replace("\xA6","\\\xA6")):g.push($),a.startLineNumber!==void 0&&a.startLineNumber!==null?g.push(a.startLineNumber.toString()):g.push($),a.startColumn!==void 0&&a.startColumn!==null?g.push(a.startColumn.toString()):g.push($),a.endLineNumber!==void 0&&a.endLineNumber!==null?g.push(a.endLineNumber.toString()):g.push($),a.endColumn!==void 0&&a.endColumn!==null?g.push(a.endColumn.toString()):g.push($),g.push($),g.join("\xA6")}D.makeKeyOptionalMessage=k})(l||(e.IMarkerData=l={})),e.$_s=(0,C.$Ph)("markerService")}),define(Ae[175],Re([1,0,5,29,4]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2u=e.$1u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Zu=e.Severity=void 0,e.Severity=M.default,e.$Zu=(0,C.$Ph)("notificationService");var T;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(T||(e.NotificationPriority=T={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var l;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(l||(e.NotificationsFilter=l={}));class D{constructor(){this.progress=new $,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.$1u=D;class ${infinite(){}done(){}total(k){}worked(k){}}e.$2u=$}),define(Ae[95],Re([1,0,16,2,4]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fU=e.$eU=e.$dU=e.$cU=e.$bU=void 0,e.$bU=(0,C.$Ph)("openerService");function T($,R){return M.URI.isUri($)?(0,y.$2e)($.scheme,R):(0,y.$3e)($,R+":")}e.$cU=T;function A($,...R){return R.some(k=>T($,k))}e.$dU=A;function l($,R){return $.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.$eU=l;function D($){let R;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec($.fragment);return k&&(R={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},$=$.with({fragment:""})),{selection:R,uri:$}}e.$fU=D}),define(Ae[176],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,y.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(ye,e,y,M){var C=arguments.length,T=C<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,y):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(ye,e,y,M);else for(var l=ye.length-1;l>=0;l--)(A=ye[l])&&(T=(C<3?A(T):C>3?A(e,y,T):A(e,y))||T);return C>3&&T&&Object.defineProperty(e,y,T),T},Ke=this&&this.__param||function(ye,e){return function(y,M){e(y,M,ye)}};define(Ae[51],Re([1,0,12,20,6,4]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8u=e.$7u=e.$6u=e.$5u=e.$4u=e.ProgressLocation=e.$3u=void 0,e.$3u=(0,T.$Ph)("progressService");var A;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$4u=Object.freeze({total(){},worked(){},done(){}});class l{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(k,a){this.e=k,this.report=a?.async?this.g.bind(this):this.f.bind(this)}f(k){this.a=k,this.e(this.a)}g(k){this.b?this.b.push(k):this.b=[k],this.h()}async h(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const k=this.b.shift();this.a=k,await this.e(this.a)}}finally{this.c=!1;const k=this.d;this.d=void 0,k?.()}}drain(){return this.c?new Promise(k=>{const a=this.d;this.d=()=>{a?.(),k()}}):Promise.resolve()}}e.$5u=l;let D=class extends C.$Sc{constructor(k,a){super(),this.a=new y.$ch,a.withProgress(k,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,C.$Qc)(()=>this.a.complete()))}report(k){this.b?this.b.report(k):this.c=k}};e.$6u=D,e.$6u=D=qe([Ke(1,e.$3u)],D);class $ extends C.$Sc{constructor(k){super(),this.g=k,this.a=0,this.b=this.B(new C.$Rc)}start(k){this.stop();const a=++this.a,p=new M.$Xd;return this.f=setTimeout(()=>{a===this.a&&(this.c=this.g.show(!0))},k),this.b.add((0,C.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Qc)(()=>p.cancel())),this.b.add((0,C.$Qc)(()=>this.c?this.c.done():void 0)),{id:a,token:p.token,stop:()=>this.h(a),isCurrent:()=>this.a===a}}stop(){this.h(this.a)}h(k){this.a===k&&this.b.clear()}}e.$7u=$,e.$8u=(0,T.$Ph)("editorProgressService")}),define(Ae[30],Re([1,0,52,15]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=void 0;class C{constructor(){this.a=new Map}add(A,l){y.ok(M.$yf(A)),y.ok(M.$Af(l)),y.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,l)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$gn=new C}),define(Ae[72],Re([1,0,5,30]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0,e.$hn={JSONContribution:"base.contributions.json"};function C(l){return l.length>0&&l.charAt(l.length-1)==="#"?l.substring(0,l.length-1):l}class T{constructor(){this.b=new y.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,$){this.a[C(D)]=$,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const A=new T;M.$gn.add(e.$hn.JSONContribution,A)}),define(Ae[96],Re([1,0,18,5,15,137,44,72,30]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ConfigurationScope=e.$ln=e.EditPresentationTypes=void 0;var $;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})($||(e.EditPresentationTypes=$={})),e.$ln={Configuration:"base.contributions.configuration"};var R;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn="vscode://schemas/settings/resourceLanguage",e.$tn="vscode://schemas/settings/configurationDefaults";const k=D.$gn.as(l.$hn.JSONContribution);class a{constructor(){this.h=new Set,this.i=new M.$Nd,this.onDidSchemaChange=this.i.event,this.j=new M.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$sn,this.g),this.v()}registerConfiguration(s,r=!0){this.registerConfigurations([s],r)}registerConfigurations(s,r=!0){const n=new Set;this.n(s,r,n),k.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(s){const r=new Set;this.o(s,r),k.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:s,remove:r}){const n=new Set;this.o(r,n),this.n(s,!1,n),k.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(s){const r=new Set;this.k(s,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(s,r){const n=[];for(const{overrides:o,source:w}of s)for(const f in o)if(r.add(f),e.$vn.test(f)){const I=this.a.get(f),S=I?.valuesSources??new Map;if(w)for(const P of Object.keys(o[f]))S.set(P,w);const u={...I?.value||{},...o[f]};this.a.set(f,{source:w,value:u,valuesSources:S});const m=(0,A.$ti)(f),h={type:"object",default:u,description:T.localize(1,null,m),$ref:e.$sn,defaultDefaultValue:u,source:C.$yf(w)?void 0:w,defaultValueSource:w};n.push(...d(f)),this.d[f]=h,this.b.properties[f]=h}else{this.a.set(f,{value:o[f],source:w});const I=this.d[f];I&&(this.w(f,I),this.r(f,I))}this.m(n)}deregisterDefaultConfigurations(s){const r=new Set;this.l(s,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(s,r){for(const{overrides:n,source:o}of s)for(const w in n){const f=this.a.get(w),I=C.$yf(o)?o:o?.id,S=C.$yf(f?.source)?f?.source:f?.source?.id;if(I===S)if(r.add(w),this.a.delete(w),e.$vn.test(w))delete this.d[w],delete this.b.properties[w];else{const u=this.d[w];u&&(this.w(w,u),this.r(w,u))}}this.u()}deltaConfiguration(s){let r=!1;const n=new Set;s.removedDefaults&&(this.l(s.removedDefaults,n),r=!0),s.addedDefaults&&(this.k(s.addedDefaults,n),r=!0),s.removedConfigurations&&this.o(s.removedConfigurations,n),s.addedConfigurations&&this.n(s.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const r of s)this.h.add(r);this.u()}n(s,r,n){s.forEach(o=>{this.p(o,r,o.extensionInfo,o.restrictedProperties,void 0,n),this.c.push(o),this.q(o)})}o(s,r){const n=o=>{if(o.properties)for(const w in o.properties){r.add(w);const f=this.d[w];f?.policy?.name&&this.e.delete(f.policy.name),delete this.d[w],this.s(w,o.properties[w])}o.allOf?.forEach(w=>n(w))};for(const o of s){n(o);const w=this.c.indexOf(o);w!==-1&&this.c.splice(w,1)}}p(s,r=!0,n,o,w=3,f){w=C.$Hf(s.scope)?w:s.scope;const I=s.properties;if(I)for(const u in I){const m=I[u];if(r&&b(u,m)){delete I[u];continue}if(m.source=n,m.defaultDefaultValue=I[u].default,this.w(u,m),e.$vn.test(u)?m.scope=void 0:(m.scope=C.$Hf(m.scope)?w:m.scope,m.restricted=C.$Hf(m.restricted)?!!o?.includes(u):m.restricted),I[u].hasOwnProperty("included")&&!I[u].included){this.f[u]=I[u],delete I[u];continue}else this.d[u]=I[u],I[u].policy?.name&&this.e.set(I[u].policy.name,u);!I[u].deprecationMessage&&I[u].markdownDeprecationMessage&&(I[u].deprecationMessage=I[u].markdownDeprecationMessage),f.add(u)}const S=s.allOf;if(S)for(const u of S)this.p(u,r,n,o,w,f)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const r=n=>{const o=n.properties;if(o)for(const f in o)this.r(f,o[f]);n.allOf?.forEach(r)};r(s)}r(s,r){switch(e.$mn.properties[s]=r,r.scope){case 1:e.$nn.properties[s]=r;break;case 2:e.$on.properties[s]=r;break;case 6:e.$pn.properties[s]=r;break;case 3:e.$qn.properties[s]=r;break;case 4:e.$rn.properties[s]=r;break;case 5:e.$rn.properties[s]=r,this.g.properties[s]=r;break}}s(s,r){switch(delete e.$mn.properties[s],r.scope){case 1:delete e.$nn.properties[s];break;case 2:delete e.$on.properties[s];break;case 6:delete e.$pn.properties[s];break;case 3:delete e.$qn.properties[s];break;case 4:case 5:delete e.$rn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const r=`[${s}]`,n={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.$sn};this.w(r,n),e.$mn.properties[r]=n,e.$nn.properties[r]=n,e.$on.properties[r]=n,e.$pn.properties[r]=n,e.$qn.properties[r]=n,e.$rn.properties[r]=n}}v(){const s={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.$sn};e.$mn.patternProperties[e.$un]=s,e.$nn.patternProperties[e.$un]=s,e.$on.patternProperties[e.$un]=s,e.$pn.patternProperties[e.$un]=s,e.$qn.patternProperties[e.$un]=s,e.$rn.patternProperties[e.$un]=s,this.i.fire()}w(s,r){const n=this.a.get(s);let o=n?.value,w=n?.source;C.$Ff(o)&&(o=r.defaultDefaultValue,w=void 0),C.$Ff(o)&&(o=i(r.type)),r.default=o,r.defaultValueSource=w}}const p="\\[([^\\]]+)\\]",g=new RegExp(p,"g");e.$un=`^(${p})+$`,e.$vn=new RegExp(e.$un);function d(v){const s=[];if(e.$vn.test(v)){let r=g.exec(v);for(;r?.length;){const n=r[1].trim();n&&s.push(n),r=g.exec(v)}}return(0,y.$Mb)(s)}e.$wn=d;function t(v){return v.reduce((s,r)=>`${s}[${r}]`,"")}e.$xn=t;function i(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$yn=i;const c=new a;D.$gn.add(e.$ln.Configuration,c);function b(v,s){return v.trim()?e.$vn.test(v)?T.localize(7,null,v):c.getConfigurationProperties()[v]!==void 0?T.localize(8,null,v):s.policy?.name&&c.getPolicyConfigurations().get(s.policy?.name)!==void 0?T.localize(9,null,v,s.policy?.name,c.getPolicyConfigurations().get(s.policy?.name)):null:T.localize(6,null)}e.$zn=b;function E(){const v=[],s=c.getConfigurationProperties();for(const r of Object.keys(s))v.push([r,s[r].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.$An=E}),define(Ae[177],Re([1,0,18,5,115,6,28,24,15,2,44,96,30]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0;function p(r){return Object.isFrozen(r)?r:l.$8m(r)}class g{constructor(n={},o=[],w=[],f){this.b=n,this.c=o,this.d=w,this.raw=f,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(o=>{if(o instanceof g)return o;const w=new d("");return w.parseRaw(o),w.configurationModel});this.f=n.reduce((o,w)=>w===o?w:o.merge(w),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,R.$ri)(this.contents,n):this.contents}inspect(n,o){const w=this.rawConfiguration.getValue(n),f=o?this.rawConfiguration.getOverrideValue(n,o):void 0,I=o?this.rawConfiguration.override(o).getValue(n):w;return{value:w,override:f,merged:I}}getOverrideValue(n,o){const w=this.i(o);return w?n?(0,R.$ri)(w,n):w:void 0}getKeysForOverrideIdentifier(n){const o=[];for(const w of this.overrides)w.identifiers.includes(n)&&o.push(...w.keys);return y.$Mb(o)}getAllOverrideIdentifiers(){const n=[];for(const o of this.overrides)n.push(...o.identifiers);return y.$Mb(n)}override(n){let o=this.a.get(n);return o||(o=this.g(n),this.a.set(n,o)),o}merge(...n){const o=l.$7m(this.contents),w=l.$7m(this.overrides),f=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const S of n)if(I.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(o,S.contents);for(const u of S.overrides){const[m]=w.filter(h=>y.$ub(h.identifiers,u.identifiers));m?(this.h(m.contents,u.contents),m.keys.push(...u.keys),m.keys=y.$Mb(m.keys)):w.push(l.$7m(u))}for(const u of S.keys)f.indexOf(u)===-1&&f.push(u)}return new g(o,f,w,I.every(S=>S instanceof g)?void 0:I)}g(n){const o=this.i(n);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const w={};for(const f of y.$Mb([...Object.keys(this.contents),...Object.keys(o)])){let I=this.contents[f];const S=o[f];S&&(typeof I=="object"&&typeof S=="object"?(I=l.$7m(I),this.h(I,S)):I=S),w[f]=I}return new g(w,this.keys,this.overrides)}h(n,o){for(const w of Object.keys(o)){if(w in n&&D.$Af(n[w])&&D.$Af(o[w])){this.h(n[w],o[w]);continue}n[w]=l.$7m(o[w])}}i(n){let o=null,w=null;const f=I=>{I&&(w?this.h(w,I):w=l.$7m(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===n?o=I.contents:I.identifiers.includes(n)&&f(I.contents);return f(o),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,o){this.j(n,o,!0)}setValue(n,o){this.j(n,o,!1)}removeValue(n){const o=this.keys.indexOf(n);o!==-1&&(this.keys.splice(o,1),(0,R.$qi)(this.contents,n),k.$vn.test(n)&&this.overrides.splice(this.overrides.findIndex(w=>y.$ub(w.identifiers,(0,k.$wn)(n))),1))}j(n,o,w){(0,R.$pi)(this.contents,n,o,f=>console.error(f)),w=w||this.keys.indexOf(n)===-1,w&&this.keys.push(n),k.$vn.test(n)&&this.overrides.push({identifiers:(0,k.$wn)(n),keys:Object.keys(this.contents[n]),contents:(0,R.$oi)(this.contents[n],f=>console.error(f))})}}e.$Bn=g;class d{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,o){if(!D.$Hf(n)){const w=this.g(n);this.parseRaw(w,o)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,o){this.a=n;const{contents:w,keys:f,overrides:I,restricted:S,hasExcludedProperties:u}=this.h(n,o);this.b=new g(w,f,I,u?[n]:void 0),this.c=S||[]}g(n){let o={},w=null,f=[];const I=[],S=[];function u(h){Array.isArray(f)?f.push(h):w!==null&&(f[w]=h)}const m={onObjectBegin:()=>{const h={};u(h),I.push(f),f=h,w=null},onObjectProperty:h=>{w=h},onObjectEnd:()=>{f=I.pop()},onArrayBegin:()=>{const h=[];u(h),I.push(f),f=h,w=null},onArrayEnd:()=>{f=I.pop()},onLiteralValue:u,onError:(h,P,W)=>{S.push({error:h,offset:P,length:W})}};if(n)try{C.$4m(n,m),o=f[0]||{}}catch(h){console.error(`Error while parsing settings file ${this.f}: ${h}`),this.d=[h]}return o}h(n,o){const w=a.$gn.as(k.$ln.Configuration).getConfigurationProperties(),f=this.i(n,w,!0,o);n=f.raw;const I=(0,R.$oi)(n,m=>console.error(`Conflict in settings file ${this.f}: ${m}`)),S=Object.keys(n),u=this.j(n,m=>console.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:I,keys:S,overrides:u,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}i(n,o,w,f){let I=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:I};const S={},u=[];for(const m in n)if(k.$vn.test(m)&&w){const h=this.i(n[m],o,!1,f);S[m]=h.raw,I=I||h.hasExcludedProperties,u.push(...h.restricted)}else{const h=o[m],P=h?typeof h.scope<"u"?h.scope:3:void 0;h?.restricted&&u.push(m),!f.exclude?.includes(m)&&(f.include?.includes(m)||(P===void 0||f.scopes===void 0||f.scopes.includes(P))&&!(f.skipRestricted&&h?.restricted))?S[m]=n[m]:I=!0}return{raw:S,restricted:u,hasExcludedProperties:I}}j(n,o){const w=[];for(const f of Object.keys(n))if(k.$vn.test(f)){const I={};for(const S in n[f])I[S]=n[f][S];w.push({identifiers:(0,k.$wn)(f),keys:Object.keys(I),contents:(0,R.$oi)(I,o)})}return w}}e.$Cn=d;class t extends T.$Sc{constructor(n,o,w,f){super(),this.c=n,this.f=o,this.g=f,this.b=this.B(new M.$Nd),this.onDidChange=this.b.event,this.a=new d(this.c.toString()),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&w.isEqual(I.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new g}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Dn=t;class i{constructor(n,o,w,f,I,S,u,m,h,P,W,K,z){this.a=n,this.b=o,this.c=w,this.overrideIdentifiers=f,this.d=I,this.f=S,this.g=u,this.h=m,this.i=h,this.j=P,this.k=W,this.l=K,this.m=z}get value(){return p(this.c)}n(n,o,w){const f=n.inspect(o,w);return{get value(){return p(f.value)},get override(){return p(f.override)},get merged(){return p(f.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(n,o,w,f,I=new g,S=new g,u=new A.$Ac,m=new g,h=new A.$Ac){this.c=n,this.d=o,this.f=w,this.g=f,this.h=I,this.i=S,this.j=u,this.l=m,this.m=h,this.a=null,this.b=new A.$Ac,this.n=null}getValue(n,o,w){return this.q(n,o,w).getValue(n)}updateValue(n,o,w={}){let f;w.resource?(f=this.m.get(w.resource),f||(f=new g,this.m.set(w.resource,f))):f=this.l,o===void 0?f.removeValue(n):f.setValue(n,o),w.resource||(this.a=null)}inspect(n,o,w){const f=this.q(n,o,w),I=this.u(o.resource,w),S=o.resource?this.m.get(o.resource)||this.l:this.l,u=new Set;for(const m of f.overrides)for(const h of m.identifiers)f.getOverrideValue(n,h)!==void 0&&u.add(h);return new i(n,o,f.getValue(n),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.i:void 0,I||void 0,S)}keys(n){const o=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,o){this.j.set(n,o),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,o){const w=[];if(!o){const{added:f,updated:I,removed:S}=v(this.c,n);o=[...f,...I,...S]}for(const f of o)for(const I of(0,k.$wn)(f)){const S=this.c.getKeysForOverrideIdentifier(I),u=n.getKeysForOverrideIdentifier(I),m=[...u.filter(h=>S.indexOf(h)===-1),...S.filter(h=>u.indexOf(h)===-1),...S.filter(h=>!l.$$m(this.c.override(I).getValue(h),n.override(I).getValue(h)))];w.push([I,m])}return this.updateDefaultConfiguration(n),{keys:o,overrides:w}}compareAndUpdatePolicyConfiguration(n){const{added:o,updated:w,removed:f}=v(this.d,n),I=[...o,...w,...f];return I.length&&this.updatePolicyConfiguration(n),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:o,updated:w,removed:f,overrides:I}=v(this.applicationConfiguration,n),S=[...o,...w,...f];return S.length&&this.updateApplicationConfiguration(n),{keys:S,overrides:I}}compareAndUpdateLocalUserConfiguration(n){const{added:o,updated:w,removed:f,overrides:I}=v(this.localUserConfiguration,n),S=[...o,...w,...f];return S.length&&this.updateLocalUserConfiguration(n),{keys:S,overrides:I}}compareAndUpdateRemoteUserConfiguration(n){const{added:o,updated:w,removed:f,overrides:I}=v(this.remoteUserConfiguration,n),S=[...o,...w,...f];return S.length&&this.updateRemoteUserConfiguration(n),{keys:S,overrides:I}}compareAndUpdateWorkspaceConfiguration(n){const{added:o,updated:w,removed:f,overrides:I}=v(this.workspaceConfiguration,n),S=[...o,...w,...f];return S.length&&this.updateWorkspaceConfiguration(n),{keys:S,overrides:I}}compareAndUpdateFolderConfiguration(n,o){const w=this.p.get(n),{added:f,updated:I,removed:S,overrides:u}=v(w,o),m=[...f,...I,...S];return(m.length||!w)&&this.updateFolderConfiguration(n,o),{keys:m,overrides:u}}compareAndDeleteFolderConfiguration(n){const o=this.p.get(n);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:w,updated:f,removed:I,overrides:S}=v(o,void 0);return{keys:[...w,...f,...I],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,o,w){let f=this.r(o,w);return o.overrideIdentifier&&(f=f.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(f=f.merge(this.d)),f}r({resource:n},o){let w=this.s();if(o&&n){const f=o.getFolder(n);f&&(w=this.t(f.uri)||w);const I=this.m.get(n);I&&(w=w.merge(I))}return w}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let o=this.b.get(n);if(!o){const w=this.s(),f=this.j.get(n);f?(o=w.merge(f),this.b.set(n,o)):o=w}return o}u(n,o){if(o&&n){const w=o.getFolder(n);if(w)return this.j.get(w.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,o)=>{const{contents:w,overrides:f,keys:I}=this.j.get(o);return n.push([o,{contents:w,overrides:f,keys:I}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(o=>n.add(o)),this.userConfiguration.keys.forEach(o=>n.add(o)),this.i.keys.forEach(o=>n.add(o)),this.j.forEach(o=>o.keys.forEach(w=>n.add(w))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(w=>n.add(w))),[...n.values()]}w(n){const o=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(w=>o.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(w=>o.add(w)),this.i.getKeysForOverrideIdentifier(n).forEach(w=>o.add(w)),this.j.forEach(w=>w.getKeysForOverrideIdentifier(n).forEach(f=>o.add(f))),[...o.values()]}static parse(n){const o=this.x(n.defaults),w=this.x(n.policy),f=this.x(n.application),I=this.x(n.user),S=this.x(n.workspace),u=n.folders.reduce((m,h)=>(m.set($.URI.revive(h[0]),this.x(h[1])),m),new A.$Ac);return new c(o,w,f,I,new g,S,u,new g,new A.$Ac)}static x(n){return new g(n.contents,n.keys,n.overrides)}}e.$En=c;function b(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const n=new Set,o=new Map;for(const f of r)f.keys.forEach(I=>n.add(I)),f.overrides.forEach(([I,S])=>{const u=(0,A.$xc)(o,I,new Set);S.forEach(m=>u.add(m))});const w=[];return o.forEach((f,I)=>w.push([I,[...f.values()]])),{keys:[...n.values()],overrides:w}}e.$Fn=b;class E{constructor(n,o,w,f){this.change=n,this.f=o,this.g=w,this.h=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of n.keys)this.affectedKeys.add(I);for(const[,I]of n.overrides)for(const S of I)this.affectedKeys.add(S);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(n,o){const w=this.a+n,f=this.d.indexOf(w);if(f<0)return!1;const I=f+w.length;if(I>=this.d.length)return!1;const S=this.d.charCodeAt(I);if(S!==this.b&&S!==this.c)return!1;if(o){const u=this.previousConfiguration?this.previousConfiguration.getValue(n,o,this.f?.workspace):void 0,m=this.g.getValue(n,o,this.h);return!l.$$m(u,m)}return!0}}e.$Gn=E;function v(r,n){const{added:o,removed:w,updated:f}=s(n?.rawConfiguration,r?.rawConfiguration),I=[],S=r?.getAllOverrideIdentifiers()||[],u=n?.getAllOverrideIdentifiers()||[];if(n){const m=u.filter(h=>!S.includes(h));for(const h of m)I.push([h,n.getKeysForOverrideIdentifier(h)])}if(r){const m=S.filter(h=>!u.includes(h));for(const h of m)I.push([h,r.getKeysForOverrideIdentifier(h)])}if(n&&r){for(const m of S)if(u.includes(m)){const h=s({contents:r.getOverrideValue(void 0,m)||{},keys:r.getKeysForOverrideIdentifier(m)},{contents:n.getOverrideValue(void 0,m)||{},keys:n.getKeysForOverrideIdentifier(m)});I.push([m,[...h.added,...h.removed,...h.updated]])}}return{added:o,removed:w,updated:f,overrides:I}}function s(r,n){const o=r?n?r.keys.filter(I=>n.keys.indexOf(I)===-1):[...r.keys]:[],w=n?r?n.keys.filter(I=>r.keys.indexOf(I)===-1):[...n.keys]:[],f=[];if(r&&n){for(const I of n.keys)if(r.keys.indexOf(I)!==-1){const S=(0,R.$ri)(n.contents,I),u=(0,R.$ri)(r.contents,I);l.$$m(S,u)||f.push(I)}}return{added:o,removed:w,updated:f}}}),define(Ae[97],Re([1,0,9,4]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.RemoteAuthorityResolverErrorCode=e.$Rk=e.$Qk=e.RemoteConnectionType=e.$Pk=void 0,e.$Pk=(0,M.$Ph)("remoteAuthorityResolverService");var C;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class T{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$Qk=T;class A{constructor(k,a){this.host=k,this.port=a,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rk=A;var l;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(l||(e.RemoteAuthorityResolverErrorCode=l={}));class D extends y.$bb{static isNotAvailable(k){return k instanceof D&&k._code===l.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===l.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===l.NoResolverFound}static isInvalidAuthority(k){return k instanceof D&&k._code===l.InvalidAuthority}static isHandled(k){return k instanceof D&&k.isHandled}constructor(k,a=l.Unknown,p){super(k),this._message=k,this._code=a,this._detail=p,this.isHandled=a===l.NotAvailable&&p===!0,Object.setPrototypeOf(this,D.prototype)}}e.$Sk=D;function $(R){const k=R.indexOf("+");return k===-1?R:R.substring(0,k)}e.$Tk=$}),define(Ae[53],Re([1,0,13]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function M($){return $.scheme===y.Schemas.vscodeRemote?$.authority:void 0}e.$Uk=M;function C($){if(!$)return;const R=$.indexOf("+");return R<0?$:$.substr(0,R)}e.$Vk=C;function T($){return`/${$.quality??"oss"}-${$.commit??"dev"}`}e.$Wk=T;function A($){const{host:R,port:k}=D($);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:k}}e.$Xk=A;function l($,R){let{host:k,port:a}=D($);return typeof a>"u"&&(a=R),{host:k,port:a}}e.$Yk=l;function D($){const R=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const k=$.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const a=$.match(/(.*):(\d+)$/);return a?{host:a[1],port:parseInt(a[2],10)}:{host:$,port:void 0}}}),define(Ae[21],Re([1,0,16,4,53]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function T(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$4l=T,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(A||(e.ExtensionType=A={}));var l;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(l||(e.TargetPlatform=l={}));class D{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const c=typeof t=="string"?t:t.value,b=typeof i=="string"?i:i.value;return y.$2e(c,b)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$6l=D;class ${get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(D.toKey(t))}delete(t){return this.c.delete(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}}e.$7l=$;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(D.toKey(t))}get(t){return this.c.get(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}set(t,i){this.c.set(D.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=R;function k(d){return a(d)}e.$9l=k;function a(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.$0l=a;function p(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.$$l=p;function g(d,t){if(t){const i=`onResolveRemoteAuthority:${(0,C.$Vk)(t)}`;return!!d.activationEvents?.includes(i)}return!1}e.$_l=g,e.$am=(0,M.$Ph)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,9,21]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UE=e.$TE=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,l){this.a.set(A,l)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const l=Object.create(null);for(const D of A){const $=this.readActivationEvents(D);$.length>0&&(l[M.$6l.toKey(D.identifier)]=$)}return l}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const l=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return l;for(const D in A.contributes){const $=this.a.get(D);if(!$)continue;const R=A.contributes[D],k=Array.isArray(R)?R:[R];try{$(k,l)}catch(a){(0,y.$1)(a)}}return l}}e.$TE=C,e.$UE=new C}),define(Ae[178],Re([1,0,22,73,36]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=void 0;function T(D){if(y.$u===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function A(D,$,R,k,a,p,g,d,t){const i=Object.create(null);i["common.machineId"]=p,i["common.sqmId"]=g,i.sessionID=(0,C.$eg)()+Date.now(),i.commitHash=k,i.version=a,i["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,y.$i)(y.$u),i["common.nodePlatform"]=M.$dc,i["common.nodeArch"]=R,i["common.product"]=t||"desktop",d&&(i["common.msftInternal"]=d);let c=0;const b=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-b,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),y.$m&&(i["common.snap"]="true");const E=T($);return E&&(i["common.platformDetail"]=E),i}e.$io=A;function l(D){const $=M.env.USERDNSDOMAIN;if(!$)return!1;const R=$.toLowerCase();return D.some(k=>R===k)}e.$jo=l}),define(Ae[179],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,y.$Ph)("telemetryService"),e.$dl=(0,y.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var M;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var C;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ae[54],Re([1,0,24,15,5,44,53,178,179]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=void 0;class ${constructor(w){this.value=w,this.isTrustedTelemetryValue=!0}}e.$ko=$;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$lo=R,e.$mo=new R;class k{async publicLog(w,f,I){}async publicLogError(w,f,I){}}e.$no=k,e.$oo="telemetry",e.$po="extensionTelemetryLog",e.$qo={log:()=>null,flush:()=>Promise.resolve(null)};function a(o,w){return C.Event.debounce(w.onDidChangeConfiguration,(I,S)=>{const u=I?new Set([...I.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:u}},1e3,!0)(I=>{I.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,T.$mi)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$ro=a;function p(o,w){return!w.isBuilt&&!w.disableTelemetry?!0:!(w.disableTelemetry||!o.enableTelemetry)}e.$so=p;function g(o,w){return w.extensionTestsLocationURI?!0:!(w.isBuilt||w.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$to=g;function d(o){const w=o.getValue(D.$kl),f=o.getValue(D.$ll);if(o.getValue(D.$ml)===!1||f===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$uo=d;function t(o){const w={},f={},I={};b(o,I);for(let S in I){S=S.length>150?S.substr(S.length-149):S;const u=I[S];typeof u=="number"?f[S]=u:typeof u=="boolean"?f[S]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${u.length}`),w[S]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(w[S]=u)}return{properties:w,measurements:f}}e.$vo=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(o){if(!o)return"none";const w=(0,A.$Vk)(o);return i.has(w)?w:"other"}e.$wo=c;function b(o,w,f=0,I){if(o)for(const S of Object.getOwnPropertyNames(o)){const u=o[S],m=I?I+S:S;Array.isArray(u)?w[m]=(0,y.$_m)(u):u instanceof Date?w[m]=u.toISOString():(0,M.$Af)(u)?f<2?b(u,w,f+1,m+"."):w[m]=(0,y.$_m)(u):w[m]=u}}function E(o,w){const f=o.msftInternalDomains||[],I=w.getValue("telemetry.internalTesting");return(0,l.$jo)(f)||I}e.$xo=E;function v(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$yo=v;function s(o,w){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let f=o;const I=[];for(const h of w)for(;;){const P=h.exec(o);if(!P)break;I.push([P.index,h.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(f="";;){const h=u.exec(o);if(!h)break;const P=I.some(([W,K])=>h.index<K&&W<u.lastIndex);!S.test(h[0])&&!P&&(f+=o.substring(m,h.index)+"<REDACTED: user-file-path>",m=u.lastIndex)}return m<o.length&&(f+=o.substr(m)),f}function r(o){if(!o)return o;const w=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of w)if(f.regex.test(o))return`<REDACTED: ${f.label}>`;return o}function n(o,w){return(0,y.$9m)(o,f=>{if(f instanceof $||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let I=f.replaceAll("%20"," ");I=s(I,w);for(const S of w)I=I.replace(S,"");return I=r(I),I}})}e.$zo=n}),define(Ae[180],Re([1,0,16,92,21,22,2,9,73,54]),function(ye,e,y,M,C,T,A,l,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;function R(n,o){return n.uuid&&o.uuid?n.uuid===o.uuid:n.id===o.id?!0:(0,y.$We)(n.id,o.id)===0}e.$Ao=R;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(o){const w=o.manifest?o.manifest.version:o.version,f=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new a(o.identifier,w,f)}static parse(o){const w=k.exec(o);return w&&w[1]&&w[2]?new a({id:w[1]},w[2],w[4]||void 0):null}constructor(o,w,f="undefined"){this.version=w,this.targetPlatform=f,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof a?R(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$Bo=a;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(n){const o=p.exec(n);return o&&o[1]?[t(o[1]),o[2]]:[t(n),void 0]}e.$Co=g;function d(n,o){return`${n}.${o}`}e.$Do=d;function t(n){return n.toLowerCase()}e.$Eo=t;function i(n,o){return t(d(n??C.$2l,o))}e.$Fo=i;function c(n,o){const w=[],f=I=>{for(const S of w)if(S.some(u=>R(o(u),o(I))))return S;return null};for(const I of n){const S=f(I);S?S.push(I):w.push([I])}return w}e.$Go=c;function b(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$Ho=b;function E(n){return{id:new $.$ko(n.identifier.id),name:new $.$ko(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Io=E,e.$Jo=new C.$6l("pprice.better-merge");function v(n,o){const w=[],f=o.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const I=f.shift();if(I&&w.every(S=>!R(S.identifier,{id:I}))){const S=n.filter(u=>R(u.identifier,{id:I}));S.length===1&&(w.push(S[0]),f.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.$Ko=v;async function s(n,o){if(!T.$l)return!1;let w;try{w=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){o.debug("Error while getting the os-release file.",(0,l.$0)(I))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(n,o){const w=await s(n,o),f=(0,M.$6n)(w?"alpine":T.$u,D.$ec);return o.debug("ComputeTargetPlatform:",f),f}e.$Lo=r}),define(Ae[181],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=e.$or=e.$nr=e.$mr=e.$lr=void 0;function y(D){return[...D.entries()]}e.$lr=y;function M(D){return D?[...D.entries()]:[]}e.$mr=M;function C(D){return new Map(D)}e.$nr=C;function T(D){return new Map(D??[])}e.$or=T;function A(D){return Array.from(D.entries()).map($=>[$[0],y($[1].map),M($[1].descriptionMap)])}e.$pr=A;function l(D){return new Map(D.map($=>[$[0],{map:C($[1]),descriptionMap:T($[2])}]))}e.$qr=l}),define(Ae[182],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skb=void 0;class y{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,T,A=5){const l=T(D=>{const $=typeof D=="string"?D:D.data;let R=this.a.get(C);if(R){R.data.push($);return}const k=setTimeout(()=>this.flushBuffer(C),A);R={data:[$],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),l.dispose()}},this.a.set(C,R)});return l}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const T=this.a.get(C);T&&(this.a.delete(C),this.b(C,T.data.join("")))}}e.$Skb=y}),define(Ae[183],Re([1,0,12,89,42,5,15,2,144,72,30]),function(ye,e,y,M,C,T,A,l,D,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_v=e.$$v=e.$0v=e.$9v=e.$8v=e.$7v=e.$6v=e.$5v=e.IconFontDefinition=e.IconContribution=e.$4v=void 0,e.$4v={IconContribution:"base.contributions.icons"};var k;(function(E){function v(s,r){let n=s.defaults;for(;C.ThemeIcon.isThemeIcon(n);){const o=g.getIcon(n.id);if(!o)return;n=o.defaults}return n}E.getDefinition=v})(k||(e.IconContribution=k={}));var a;(function(E){function v(r){return{weight:r.weight,style:r.style,src:r.src.map(n=>({format:n.format,location:n.location.toString()}))}}E.toJSONObject=v;function s(r){const n=o=>(0,A.$yf)(o)?o:void 0;if(r&&Array.isArray(r.src)&&r.src.every(o=>(0,A.$yf)(o.format)&&(0,A.$yf)(o.location)))return{weight:n(r.weight),style:n(r.style),src:r.src.map(o=>({format:o.format,location:l.URI.parse(o.location)}))}}E.fromJSONObject=s})(a||(e.IconFontDefinition=a={}));class p{constructor(){this.a=new T.$Nd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(v,s,r,n){const o=this.b[v];if(o){if(r&&!o.description){o.description=r,this.d.properties[v].markdownDescription=`${r} $(${v})`;const I=this.e.enum.indexOf(v);I!==-1&&(this.e.enumDescriptions[I]=r),this.a.fire()}return o}const w={id:v,description:r,defaults:s,deprecationMessage:n};this.b[v]=w;const f={$ref:"#/definitions/icons"};return n&&(f.deprecationMessage=n),r&&(f.markdownDescription=`${r}: $(${v})`),this.d.properties[v]=f,this.e.enum.push(v),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:v}}deregisterIcon(v){delete this.b[v],delete this.d.properties[v];const s=this.e.enum.indexOf(v);s!==-1&&(this.e.enum.splice(s,1),this.e.enumDescriptions.splice(s,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(v=>this.b[v])}getIcon(v){return this.b[v]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(v,s){const r=this.f[v];return r||(this.f[v]=s,this.a.fire(),s)}deregisterIconFont(v){delete this.f[v]}getIconFont(v){return this.f[v]}toString(){const v=(o,w)=>o.id.localeCompare(w.id),s=o=>{for(;C.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.b).map(o=>this.b[o]);for(const o of n.filter(w=>!!w.description).sort(v))r.push(`|<i class="${s(o)}"></i>|${o.id}|${C.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const o of n.filter(w=>!C.ThemeIcon.isThemeIcon(w.defaults)).sort(v))r.push(`|<i class="${s(o)}"></i>|${o.id}|`);return r.join(`
`)}}const g=new p;R.$gn.add(e.$4v.IconContribution,g);function d(E,v,s,r){return g.registerIcon(E,v,s,r)}e.$5v=d;function t(){return g}e.$6v=t;function i(){const E=(0,M.$Sj)();for(const v in E){const s="\\"+E[v].toString(16);g.registerIcon(v,{fontCharacter:s})}}i(),e.$7v="vscode://schemas/icons";const c=R.$gn.as($.$hn.JSONContribution);c.registerSchema(e.$7v,g.getIconSchema());const b=new y.$6g(()=>c.notifySchemaChanged(e.$7v),200);g.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.$8v=d("widget-close",M.$Uj.close,(0,D.localize)(2,null)),e.$9v=d("goto-previous-location",M.$Uj.arrowUp,(0,D.localize)(3,null)),e.$0v=d("goto-next-location",M.$Uj.arrowDown,(0,D.localize)(4,null)),e.$$v=C.ThemeIcon.modify(M.$Uj.sync,"spin"),e.$_v=C.ThemeIcon.modify(M.$Uj.loading,"spin")}),define(Ae[184],Re([1,0,5,44,4,14]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gv=e.$fv=e.$ev=e.$dv=e.$cv=e.$bv=e.$av=e.$_u=e.ProvidedOnAutoForward=e.$$u=e.TunnelPrivacyId=e.TunnelProtocol=e.$0u=e.$9u=void 0,e.$9u=(0,C.$Ph)("tunnelService"),e.$0u=(0,C.$Ph)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var l;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(l||(e.TunnelPrivacyId=l={}));function D(t){return!!t.forwardPort}e.$$u=D;var $;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})($||(e.ProvidedOnAutoForward=$={}));function R(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$_u=R,e.$av=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(t){return e.$av.indexOf(t)>=0}e.$bv=k,e.$cv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(t){return e.$cv.indexOf(t)>=0}e.$dv=a;function p(t,i,c,b){if(c===1)return!1;if(c===2&&a(i)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(E?.length===4&&parseInt(E[1])>=18)return!1}return t<1024}e.$ev=p;class g{constructor(i,c,b){this.remoteAddress=i,this.localAddress=c,this.b=b,this.a=new y.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$fv=g;let d=class{constructor(i,c){this.j=i,this.k=c,this.a=new y.$Nd,this.onTunnelOpened=this.a.event,this.b=new y.$Nd,this.onTunnelClosed=this.b.event,this.c=new y.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],c=Array.from(this.e.values());for(const b of c){const E=Array.from(b.values());for(const v of E){const s=await v.value;s&&typeof s!="string"&&i.push(s)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:c}of i.values())await c.then(b=>typeof b!="string"?b?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,c,b,E,v){this.p(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:b,privacy:E,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(a(i)||k(i))&&(i=e.$av[0]);const b=this.r(i,c);if(b)return++b.refcount,b.value}openTunnel(i,c,b,E,v,s=!1,r,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${b} on local port ${v}.`);const o=this.f??i;if(!o)return;if(c||(c="localhost"),E||(E=this.l),this.f&&this.i.has(b)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const w=this.s(o,c,b,E,v,s,r,n);return w?w.then(f=>{if(f){if(typeof f=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(c,b),f}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(c,b);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(f);return(f.tunnelRemoteHost!==c||f.tunnelRemotePort!==b)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&f.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),w)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this.e.get(i.tunnelRemoteHost);if(c){const b=c.get(i.tunnelRemotePort);b&&(b.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,b))}}}}async o(i,c,b){if(b.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const E=b.value.then(async v=>{v&&typeof v!="string"&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(c),E}}async closeTunnel(i,c){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const b=this.e.get(i);if(b&&b.has(c)){const E=b.get(c);E.refcount=0,await this.o(i,c,E)}}p(i,c,b){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(c,{refcount:1,value:b})}async q(i,c){const b=this.e.get(i);if(b){const E=b.get(c),v=E?await E.value:void 0;(!v||typeof v=="string")&&b.delete(c),b.size===0&&this.e.delete(i)}}r(i,c){const b=[i];k(i)?(b.push(...e.$av),b.push(...e.$cv)):a(i)&&b.push(...e.$cv);const E=b.map(v=>this.e.get(v));for(const v of E){const s=v?.get(c);if(s)return s}}canTunnel(i){return!!R(i)}t(i,c,b,E,v,s,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${b} on local port ${E}.`);const n=b;this.i.add(n);const o=E===void 0?b:E,w={elevationRequired:v?this.isPortPrivileged(o):!1},f={remoteAddress:{host:c,port:b},localAddressPort:E,privacy:s,public:s?s!==l.Private:void 0,protocol:r},I=i.forwardPort(f,w);return I?(this.p(c,b,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),I}};e.$gv=d,e.$gv=d=qe([Ke(0,T.$0i),Ke(1,M.$ji)],d)}),define(Ae[185],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$hv=void 0,e.$hv=(0,y.$Ph)("editSessionIdentityService");var M;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Ae[186],Re([1,0,13]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=void 0;function M(D){return D.scheme!==y.Schemas.file&&D.scheme!==y.Schemas.vscodeRemote}e.$OJ=M;function C(D){if(D.folders.length)return D.folders.every($=>M($.uri))?D.folders[0].uri:void 0;if(D.configuration&&M(D.configuration))return D.configuration}e.$PJ=C;function T(D){return C(D)?.scheme}e.$QJ=T;function A(D){return C(D)?.authority}e.$RJ=A;function l(D){return C(D)!==void 0}e.$SJ=l}),define(Ae[55],Re([1,0,145,19,49,23,2,4,13]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,l.$Ph)("contextService");function $(o){const w=o;return typeof w?.id=="string"&&A.URI.isUri(w.uri)}e.$Zh=$;function R(o){return typeof o?.id=="string"&&!$(o)&&!a(o)}e.$1h=R,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function k(o,w){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,M.$nc)(o)}:w?e.$2h:e.$3h;const f=o;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.$4h=k;function a(o){const w=o;return typeof w?.id=="string"&&A.URI.isUri(w.configPath)}e.$5h=a;function p(o){const w=o;if(w?.uri)return{id:w.id,uri:A.URI.revive(w.uri)};const f=o;if(f?.configPath)return{id:f.id,configPath:A.URI.revive(f.configPath)};if(o?.id)return{id:o.id}}e.$6h=p;var g;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function d(o){const w=o;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.$7h=d;function t(o){const w=o;return!!(w&&typeof w=="object"&&A.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.$8h=t;class i{constructor(w,f,I,S,u){this.h=w,this.j=I,this.k=S,this.l=u,this.c=C.$Vh.forUris(this.l,()=>!0),this.folders=f}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=C.$Vh.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=i;class c{constructor(w,f){this.raw=f,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,T.$vg)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=c;function b(o){return new c({uri:o,index:0,name:(0,T.$rg)(o)},{uri:o.toString()})}e.$$h=b,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,y.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function E(o,w){return T.$mg.isEqualOrParent(o,w.untitledWorkspacesHome)}e.$di=E;function v(o){let w;return A.URI.isUri(o)?w=o:w=o.configuration,w?.scheme===D.Schemas.tmp}e.$ei=v,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(o){return o.id===e.$fi}e.$gi=s;function r(o,w){return!E(o,w)&&!v(o)}e.$hi=r;function n(o){return(typeof o=="string"?(0,M.$oc)(o):(0,T.$tg)(o))===e.$ai}e.$ii=n}),define(Ae[74],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=void 0;class y{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const T=this.c++;return this.b.set(T,C),this.e(),T}get(C,T){return this.b.has(C)?this.b.get(C)[T]:void 0}delete(C){this.b.delete(C),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Wbc=y}),define(Ae[40],Re([1,0,13,23,4]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=void 0;class T{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new M.$kg(l=>{const D=this.b.get(l.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(l,D){D===null?this.b.delete(l.scheme):this.b.set(l.scheme,D)}isFreeScheme(l){return!this.b.has(l)&&!this.a.has(l)}getCapabilities(l){return this.b.get(l)}}e.$Ybc=T,e.$Zbc=(0,C.$Ph)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=void 0,e.$wM=(0,y.$Ph)("IExtHostInitDataService")}),define(Ae[187],Re([1,0,150,14,174,27]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;let A=class extends C.$DN{constructor(D,$,R){const k=R.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",a=R.remote.isRemote?(0,y.localize)(0,null):D?(0,y.localize)(1,null):(0,y.localize)(2,null);super($.createLogger(k,{name:a}))}};e.$8dc=A,e.$8dc=A=qe([Ke(1,M.$$i),Ke(2,T.$wM)],A)}),define(Ae[188],Re([1,0,12]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=e.$pcc=void 0;class M{constructor(A,l,D){this.h=new Map,this.a=A,this.b=l,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then($=>(this.f=$,this)),this.g=this.c.onDidChangeStorage($=>{$.shared===this.b&&$.key===this.a&&(this.f=$.value)}),this.i=new y.$6g(()=>{const $=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of $.values())R.complete()}catch(R){for(const k of $.values())k.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,l){let D=this.f[A];return typeof D>"u"&&(D=l),D}update(A,l){this.f[A]=l;const D=this.h.get(A);if(D!==void 0)return D.p;const $=new y.$ch;return this.h.set(A,$),this.i.isScheduled()||this.i.schedule(),$.p}dispose(){this.g.dispose()}}e.$pcc=M;class C extends M{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,l){super(A.identifier.value,!0,l),this.j=A}}e.$qcc=C}),define(Ae[189],Re([1,0,5,2]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;class C{constructor(A){this.c=A,this.a=new y.$Nd,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$Nd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,l,D,$){const k=this.c.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(l.value,D,$);this.b.fire(k)}$acceptDirtyStateChanged(A,l){this.c.getNotebookDocument(M.URI.revive(A)).acceptDirty(l)}$acceptModelSaved(A){const l=this.c.getNotebookDocument(M.URI.revive(A));this.a.fire(l.apiNotebook)}}e.$Odc=C}),define(Ae[17],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=e.$gM=void 0,e.$gM=(0,y.$Ph)("IExtHostRpcService");class M{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.$hM=M}),define(Ae[190],Re([1,0,21,5]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;class C{#e;constructor(A,l){this.b=new M.$Nd,this.onDidChange=this.b.event,this.a=y.$6l.toKey(A.identifier),this.#e=l,this.#e.onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(A){return this.#e.get(this.a,A)}store(A,l){return this.#e.store(this.a,A,l)}delete(A){return this.#e.delete(this.a,A)}}e.$Bcc=C}),define(Ae[56],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=e.$0bc=void 0,e.$0bc=(0,y.$Ph)("IURITransformerService");class M{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$$bc=M}),define(Ae[191],Re([1,0,26]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcb=e.$ycb=void 0;class M{constructor(){this.buffers=[]}add(D){let $=this.buffers.indexOf(D);return $<0&&($=this.buffers.length,this.buffers.push(D)),$}}function C(l,D){if(D.serializeBuffersForPostMessage){const $=new M,k=JSON.stringify(l,(p,g)=>{if(g instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:$.add(g)};if(ArrayBuffer.isView(g)){const d=T(g);if(d)return{$$vscode_array_buffer_reference$$:!0,index:$.add(g.buffer),view:{type:d,byteLength:g.byteLength,byteOffset:g.byteOffset}}}return g}),a=$.buffers.map(p=>{const g=new Uint8Array(p);return y.$be.wrap(g)});return{message:k,buffers:a}}else return{message:JSON.stringify(l),buffers:[]}}e.$ycb=C;function T(l){switch(l.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(l,D){const $=D.map(a=>{const p=new ArrayBuffer(a.byteLength);return new Uint8Array(p).set(a.buffer),p}),R=D.length?(a,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const g=p,{index:d}=g,t=$[d];if(g.view)switch(g.view.type){case 1:return new Int8Array(t,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return p}:void 0;return{message:JSON.parse(l,R),arrayBuffers:$}}e.$zcb=A}),define(Ae[99],Re([1,0,159,15,2,6,4,30,39,13,37,127,29]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fE=e.$eE=e.$dE=e.EditorsOrder=e.$cE=e.CloseDirection=e.$bE=e.$aE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$_D=e.$$D=e.$0D=e.$9D=e.$8D=e.$7D=e.$6D=e.$5D=e.EditorInputCapabilities=e.$4D=e.SaveReason=e.Verbosity=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=e.$WD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$VD=e.$UD=e.$TD=e.$SD=e.$RD=void 0,e.$RD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$SD={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$TD="workbench.editor.sidebysideEditor",e.$UD="workbench.editors.textDiffEditor",e.$VD="workbench.editors.binaryResourceDiffEditor";var p;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var g;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function d(oe){const be=oe;return!!be&&typeof be.getSelection=="function"&&!!be.onDidChangeSelection}e.$WD=d;function t(oe,be,_){for(const B of _.visibleEditorPanes)if(B.group.id===be&&oe.matches(B.input))return B.getViewState()}e.$XD=t;function i(oe){if(f(oe))return!1;const be=oe;return C.URI.isUri(be?.resource)}e.$YD=i;function c(oe){if(f(oe))return!1;const be=oe;return be?.original!==void 0&&be.modified!==void 0}e.$ZD=c;function b(oe){if(f(oe)||c(oe))return!1;const be=oe;return be?.primary!==void 0&&be.secondary!==void 0}e.$1D=b;function E(oe){if(f(oe))return!1;const be=oe;return be?be.resource===void 0||be.resource.scheme===$.Schemas.untitled||be.forceUntitled===!0:!1}e.$2D=E;function v(oe){if(f(oe))return!1;const be=oe;return C.URI.isUri(be?.base?.resource)&&C.URI.isUri(be?.input1?.resource)&&C.URI.isUri(be?.input2?.resource)&&C.URI.isUri(be?.result?.resource)}e.$3D=v;var s;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var r;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class n{constructor(){this.a=new Map}registerSource(be,_){let B=this.a.get(be);return B||(B={source:be,label:_},this.a.set(be,B)),B.source}getSourceLabel(be){return this.a.get(be)?.label??be}}e.$4D=new n;var o;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class w extends T.$Sc{}e.$5D=w;function f(oe){return oe instanceof w}e.$6D=f;function I(oe){const be=oe;return C.URI.isUri(be?.preferredResource)}function S(oe){const be=oe;return f(be?.primary)&&f(be?.secondary)}e.$7D=S;function u(oe){const be=oe;return f(be?.modified)&&f(be?.original)}e.$8D=u;function m(oe,be,_,B,Z){return ue(B,[(0,k.$zi)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const ee={..._,limits:{size:Number.MAX_VALUE}};oe.openEditor(be,ee)}}),(0,k.$zi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>Z.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}e.$9D=m;function h(oe){return f(oe?.editor)}e.$0D=h;function P(oe){const be=oe;return h(oe)&&be?.group!==void 0}e.$$D=P;function W(oe){const be=oe;return typeof be?.groupId=="number"&&f(be.editor)}e.$_D=W;var K;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(K||(e.EditorCloseContext=K={}));var z;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LOCKED=2]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=3]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=4]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=5]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=7]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=9]="EDITOR_PIN",oe[oe.EDITOR_STICKY=10]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=11]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(z||(e.GroupModelChangeKind=z={}));var j;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class O{getOriginalUri(be,_){if(!be)return;if(v(be))return e.$bE.getOriginalUri(be.result,_);if(_?.supportSideBySide){const{primary:Z,secondary:ee}=this.a(be);if(Z&&ee){if(_?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(Z,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(ee,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===j.ANY)return this.getOriginalUri(Z,{filterByScheme:_.filterByScheme})??this.getOriginalUri(ee,{filterByScheme:_.filterByScheme});be=_.supportSideBySide===j.PRIMARY?Z:ee}}if(c(be)||b(be)||v(be))return;const B=I(be)?be.preferredResource:be.resource;return!B||!_||!_.filterByScheme?B:this.b(B,_.filterByScheme)}a(be){return S(be)||b(be)?{primary:be.primary,secondary:be.secondary}:u(be)||c(be)?{primary:be.modified,secondary:be.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(be,_){if(!be)return;if(v(be))return e.$bE.getCanonicalUri(be.result,_);if(_?.supportSideBySide){const{primary:Z,secondary:ee}=this.a(be);if(Z&&ee){if(_?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(Z,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(ee,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===j.ANY)return this.getCanonicalUri(Z,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(ee,{filterByScheme:_.filterByScheme});be=_.supportSideBySide===j.PRIMARY?Z:ee}}if(c(be)||b(be)||v(be))return;const B=be.resource;return!B||!_||!_.filterByScheme?B:this.b(B,_.filterByScheme)}b(be,_){if(Array.isArray(_)){if(_.some(B=>be.scheme===B))return be}else if(_===be.scheme)return be}}var N;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(N||(e.EditorCloseMethod=N={}));function ie(oe,be,_,B){if(!oe.isSticky(be))return!1;switch(B.preventPinnedEditorClose){case"keyboardAndMouse":return _===N.MOUSE||_===N.KEYBOARD;case"mouse":return _===N.MOUSE;case"keyboard":return _===N.KEYBOARD}return!1}e.$aE=ie,e.$bE=new O;var X;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(X||(e.CloseDirection=X={}));class Ee{constructor(){this.c=new Map,this.d=new Map}start(be){const _=this.a=be.get(A.$Oh);for(const[B,Z]of this.c)this.e(B,Z,_);this.c.clear()}e(be,_,B){const Z=B.createInstance(_);this.d.set(be,Z)}registerFileEditorFactory(be){if(this.b)throw new Error("Can only register one file editor factory.");this.b=be}getFileEditorFactory(){return(0,M.$Jf)(this.b)}registerEditorSerializer(be,_){if(this.c.has(be)||this.d.has(be))throw new Error(`A editor serializer with type ID '${be}' was already registered.`);return this.a?this.e(be,_,this.a):this.c.set(be,_),(0,T.$Qc)(()=>{this.c.delete(be),this.d.delete(be)})}getEditorSerializer(be){return this.d.get(typeof be=="string"?be:be.typeId)}}l.$gn.add(e.$RD.EditorFactory,new Ee);async function Se(oe,be,_){return!oe||!oe.length?[]:await Promise.all(oe.map(async B=>{const Z=C.URI.revive(B.fileUri);if(!Z){_.info("Cannot resolve the path because it is not valid.",B);return}if(!await be.canHandleResource(Z)){_.info("Cannot resolve the path because it cannot be handled",B);return}let ve=B.exists,ge=B.type;if(typeof ve!="boolean"||typeof ge!="number")try{ge=(await be.stat(Z)).isDirectory?D.FileType.Directory:D.FileType.Unknown,ve=!0}catch(De){_.error(De),ve=!1}if(!ve&&B.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",B);return}if(ge===D.FileType.Directory){_.info("Cannot resolve the path because it is a directory",B);return}const de={...B.options,pinned:!0};return ve?{resource:Z,options:de}:{resource:Z,options:de,forceUntitled:!0}}))}e.$cE=Se;var Pe;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function $e(oe){const be=oe;if(!be)return!1;const _=be;if(_.modified)return $e(_.modified);const B=be;return!!(B.contributionsState&&B.viewState&&Array.isArray(B.cursorState))}e.$dE=$e;function pe(oe){return(0,R.$Bi)(oe)}e.$eE=pe;function ue(oe,be,_){const B=(0,R.$Ci)(oe,be);return B.forceMessage=_?.forceMessage,B.forceSeverity=_?.forceSeverity,B.allowDialog=_?.allowDialog,B}e.$fE=ue}),define(Ae[192],Re([1,0,5,160,4,6,28,30,18,24,89,183]),function(ye,e,y,M,C,T,A,l,D,$,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qE=e.$pE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$oE=e.$nE=e.ViewContentGroups=e.$mE=e.$lE=e.ViewContainerLocation=e.Extensions=e.$kE=e.$jE=e.$iE=void 0,e.$iE="views",e.$jE=(0,M.localize)(0,null),e.$kE=(0,k.$5v)("default-view-icon",R.$Uj.window,(0,M.localize)(1,null));var a;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(a||(e.Extensions=a={}));var p;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$lE=[0,1,2];function g(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$mE=g;class d extends T.$Sc{constructor(){super(...arguments),this.c=this.B(new y.$Nd),this.onDidRegister=this.c.event,this.f=this.B(new y.$Nd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.$Rb)([...this.g.values()])}registerViewContainer(n,o,w){const f=this.get(n.id);if(f)return f;const I=n;return I.openCommandActionDescriptor=w?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.$xc)(this.g,o,[]).push(I),w?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:o}),I}deregisterViewContainer(n){for(const o of this.g.keys()){const w=this.g.get(o),f=w?.indexOf(n);if(f!==-1){w?.splice(f,1),w.length===0&&this.g.delete(o),this.f.fire({viewContainer:n,viewContainerLocation:o});return}}}get(n){return this.all.filter(o=>o.id===n)[0]}getViewContainers(n){return[...this.g.get(n)||[]]}getViewContainerLocation(n){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(w=>w?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.h.find(o=>this.getViewContainerLocation(o)===n)}}l.$gn.add(a.ViewContainersRegistry,new d);var t;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(r,n){const o=r.group??t.More,w=n.group??t.More;return o!==w?o.localeCompare(w):(r.order??5)-(n.order??5)}class c extends T.$Sc{constructor(){super(...arguments),this.c=this.B(new y.$Nd),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$Nd),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$Nd),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$Nd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(n,o){this.registerViews2([{views:n,viewContainer:o}])}registerViews2(n){n.forEach(({views:o,viewContainer:w})=>this.r(o,w)),this.c.fire(n)}deregisterViews(n,o){const w=this.s(n,o);w.length&&this.f.fire({views:w,viewContainer:o})}moveViews(n,o){for(const w of this.m.keys())if(w!==o){const f=this.s(n,w);f.length&&(this.r(f,o),this.g.fire({views:f,from:w,to:o}))}}getViews(n){return this.m.get(n)||[]}getView(n){for(const o of this.j){const w=(this.m.get(o)||[]).filter(f=>f.id===n)[0];if(w)return w}return null}getViewContainer(n){for(const o of this.j)if((this.m.get(o)||[]).filter(f=>f.id===n)[0])return o;return null}registerViewWelcomeContent(n,o){return this.n.add(n,o),this.h.fire(n),(0,T.$Qc)(()=>{this.n.delete(n,o),this.h.fire(n)})}registerViewWelcomeContent2(n,o){const w=new Map;for(const[f,I]of o)this.n.add(n,I),w.set(f,(0,T.$Qc)(()=>{this.n.delete(n,I),this.h.fire(n)}));return this.h.fire(n),w}getViewWelcomeContent(n){const o=[];return this.n.forEach(n,w=>o.push(w)),o.sort(i)}r(n,o){let w=this.m.get(o);w||(w=[],this.m.set(o,w),this.j.push(o));for(const f of n){if(this.getView(f.id)!==null)throw new Error((0,M.localize)(2,null,f.id));w.push(f)}}s(n,o){const w=this.m.get(o);if(!w)return[];const f=[],I=[];for(const S of w)n.includes(S)?f.push(S):I.push(S);return f.length&&(I.length?this.m.set(o,I):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),f}}l.$gn.add(a.ViewsRegistry,new c),e.$nE=(0,C.$Ph)("viewsService"),e.$oE=(0,C.$Ph)("viewDescriptorService");var b;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(b||(e.ViewVisibilityState=b={}));var E;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(E||(e.TreeItemCollapsibleState=E={}));class v{constructor(n,o){this.c=!1,this.d=!1,(0,$.$0m)(this,n),this.d=!!o,this.resolve=async w=>{if(o&&!this.c){const f=await o(w);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}w.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$pE=v;class s extends Error{constructor(n){super((0,M.localize)(3,null,n)),this.name="NoTreeViewError"}static is(n){return n.name==="NoTreeViewError"}}e.$qE=s}),define(Ae[193],Re([1,0,5,12,161]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cb=void 0;class T{constructor(){this.f=new Map,this.k=[],this.m=new y.$Nd,this.n=new y.$Nd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(l){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=l}onEvent(l){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=l}onRequest(l){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=l}sendResponse(l){l.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${l.command}`)):this.s("response",l)}sendRequest(l,D,$,R){const k={command:l};if(D&&Object.keys(D).length>0&&(k.arguments=D),this.s("request",k),typeof R=="number"){const a=setTimeout(()=>{clearTimeout(a);const p=this.f.get(k.seq);if(p){this.f.delete(k.seq);const g={type:"response",seq:0,request_seq:k.seq,success:!1,command:l,message:(0,C.localize)(0,null,R,l)};p(g)}},R)}return $&&this.f.set(k.seq,$),k.seq}acceptMessage(l){this.j?this.j(l):(this.k.push(l),this.k.length===1&&this.q())}o(l,D){return l.type!=="event"||D.type!=="event"}async q(){let l;for(;this.k.length;){if((!l||this.o(this.k[0],l))&&await(0,M.$Ug)(0),l=this.k.shift(),!l)return;switch(l.type){case"event":this.i?.(l);break;case"request":this.g?.(l);break;case"response":{const D=l,$=this.f.get(D.request_seq);$&&(this.f.delete(D.request_seq),$(D));break}}}}s(l,D){D.type=l,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const l=new Map;this.f.forEach((D,$)=>l.set($,D)),await(0,M.$Ug)(500),l.forEach((D,$)=>{D({type:"response",seq:0,request_seq:$,success:!1,command:"canceled",message:"canceled"}),this.f.delete($)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$5cb=T}),define(Ae[194],Re([1,0,162,32,4]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$3G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$2G=e.MemoryRangeType=e.$1G=e.State=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=void 0,e.$YF="workbench.view.debug",e.$ZF="workbench.debug.variablesView",e.$1F="workbench.debug.watchExpressionsView",e.$2F="workbench.debug.callStackView",e.$3F="workbench.debug.loadedScriptsView",e.$4F="workbench.debug.breakPointsView",e.$5F="workbench.debug.disassemblyView",e.$6F="workbench.panel.repl",e.$7F="workbench.panel.repl.view",e.$8F=new M.$7i("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$9F=new M.$7i("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$0F=new M.$7i("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$$F="debugUx",e.$_F=new M.$7i(e.$$F,"default",{type:"string",description:y.localize(3,null)}),e.$aG=new M.$7i("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$bG=new M.$7i("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$cG=new M.$7i("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$dG=new M.$7i("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$eG=new M.$7i("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$fG=new M.$7i("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$gG=new M.$7i("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$hG=new M.$7i("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$iG=new M.$7i("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$jG=new M.$7i("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$kG=new M.$7i("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$lG=new M.$7i("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$mG=new M.$7i("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$nG=new M.$7i("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$oG=new M.$7i("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$pG=new M.$7i("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$qG=new M.$7i("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$rG=new M.$7i("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$sG=new M.$7i("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(22,null)}),e.$tG=new M.$7i("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(23,null)}),e.$uG=new M.$7i("loadedScriptsItemType",void 0,{type:"string",description:y.localize(24,null)}),e.$vG=new M.$7i("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(25,null)}),e.$wG=new M.$7i("stepBackSupported",!1,{type:"boolean",description:y.localize(26,null)}),e.$xG=new M.$7i("restartFrameSupported",!1,{type:"boolean",description:y.localize(27,null)}),e.$yG=new M.$7i("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(28,null)}),e.$zG=new M.$7i("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(29,null)}),e.$AG=new M.$7i("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$BG=new M.$7i("breakpointsExist",!1,{type:"boolean",description:y.localize(31,null)}),e.$CG=new M.$7i("debuggersAvailable",!1,{type:"boolean",description:y.localize(32,null)}),e.$DG=new M.$7i("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(33,null)}),e.$EG=new M.$7i("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(34,null)}),e.$FG=new M.$7i("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(35,null)}),e.$GG=new M.$7i("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(36,null)}),e.$HG=new M.$7i("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(37,null)}),e.$IG=new M.$7i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$JG=new M.$7i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$KG=new M.$7i("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$LG=new M.$7i("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$MG=new M.$7i("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(42,null)}),e.$NG=new M.$7i("variableIsReadonly",!1,{type:"boolean",description:y.localize(43,null)}),e.$OG=new M.$7i("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(44,null)}),e.$PG=new M.$7i("multiSessionRepl",!1,{type:"boolean",description:y.localize(45,null)}),e.$QG=new M.$7i("multiSessionDebug",!1,{type:"boolean",description:y.localize(46,null)}),e.$RG=new M.$7i("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(47,null)}),e.$SG=new M.$7i("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(48,null)}),e.$TG=new M.$7i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(49,null)}),e.$UG=new M.$7i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(50,null)});const T=a=>y.localize(51,null,a);e.$VG=T,e.$WG="editor.contrib.debug",e.$XG="editor.contrib.breakpoint",e.$YG="debug",e.$ZG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(52,null)};var A;(function(a){a[a.Inactive=0]="Inactive",a[a.Initializing=1]="Initializing",a[a.Stopped=2]="Stopped",a[a.Running=3]="Running"})(A||(e.State=A={}));function l(a){switch(a){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$1G=l;var D;(function(a){a[a.Valid=0]="Valid",a[a.Unreadable=1]="Unreadable",a[a.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$2G="vscode-debug-memory";var $;(function(a){a[a.Initial=1]="Initial",a[a.Dynamic=2]="Dynamic"})($||(e.DebugConfigurationProviderTriggerKind=$={}));var R;(function(a){a.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$3G=(0,C.$Ph)("debugService");var k;(function(a){a[a.CONDITION=0]="CONDITION",a[a.HIT_COUNT=1]="HIT_COUNT",a[a.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Ae[195],Re([1,0,16,2,19,24,13,45,20,18]),function(ye,e,y,M,C,T,A,l,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=void 0;const R=/{([^}]+)}/g;function k(S,u,m){return S.replace(R,function(h,P){return u&&P.length>0&&P[0]!=="_"?h:m&&m.hasOwnProperty(P)?m[P]:h})}e.$nF=k;function a(S){const u={};for(const m of Object.keys(S))m.startsWith("!")||(u[m]=S[m]);return u}e.$oF=a;function p(S){return S.configuration.request==="attach"&&!g(S)&&(!S.parentSession||p(S.parentSession))}e.$pF=p;function g(S){let u=S.configuration.type;if(u)return u==="vslsShare"&&(u=S.configuration.adapterProxy.configuration.type),(0,y.$2e)(u,"extensionhost")||(0,y.$2e)(u,"pwa-extensionhost")?S:S.parentSession?g(S.parentSession):void 0}e.$qF=g;function d(S){return S.type&&(S.label||S.program||S.runtime)}e.$rF=d;function t(S,u,m){let h,P=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let K=null;for(;K=W.exec(S);){const z=K.index+1,j=z+K[0].length;if(z<=u&&j>=m){h=K[0],P=z;break}}if(h){const z=/\w+/g;let j=null;for(;(j=z.exec(h))&&!(j.index+1+P+j[0].length>=m););j&&(h=h.substring(0,z.lastIndex))}return h?{start:P,end:P+h.length-1}:{start:0,end:0}}e.$sF=t;async function i(S,u,m,h){if(S.evaluatableExpressionProvider.has(u)){const P=S.evaluatableExpressionProvider.ordered(u),W=(0,$.$Hb)(await Promise.all(P.map(async K=>{try{return await K.provideEvaluatableExpression(u,m,h??D.CancellationToken.None)}catch{return}})));if(W.length>0){let K=W[0].expression;const z=W[0].range;return K||(K=u.getLineContent(m.lineNumber).substring(z.startColumn-1,z.endColumn-1)),{range:z,matchingExpression:K}}}else{const P=u.getLineContent(m.lineNumber),{start:W,end:K}=t(P,m.column,m.column),z=P.substring(W-1,K);return{matchingExpression:z,range:new l.$ts(m.lineNumber,W,m.lineNumber,W+z.length)}}return null}e.$tF=i;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(S){return!!(S&&S.match(c))}e.$uF=b;function E(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(b(S.path))return M.URI.parse(S.path);if((0,C.$ic)(S.path))return M.URI.file(S.path)}return S.path}function v(S){if(typeof S.path=="object"){const u=M.URI.revive(S.path);if(u)return u.scheme===A.Schemas.file?u.fsPath:u.toString()}return S.path}function s(S,u){const m=u?E:v,h=(0,T.$7m)(S);return n(h,(P,W)=>{P&&W&&(W.path=m(W))}),h}e.$vF=s;function r(S,u){const m=u?E:v,h=(0,T.$7m)(S);return n(h,(P,W)=>{!P&&W&&(W.path=m(W))}),h}e.$wF=r;function n(S,u){switch(S.type){case"event":{const m=S;switch(m.event){case"output":u(!1,m.body.source);break;case"loadedSource":u(!1,m.body.source);break;case"breakpoint":u(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=S;switch(m.command){case"setBreakpoints":u(!0,m.arguments.source);break;case"breakpointLocations":u(!0,m.arguments.source);break;case"source":u(!0,m.arguments.source);break;case"gotoTargets":u(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(h=>u(!1,h));break;default:break}break}case"response":{const m=S;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(h=>u(!1,h.source));break;case"loadedSources":m.body.sources.forEach(h=>u(!1,h));break;case"scopes":m.body.scopes.forEach(h=>u(!1,h.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(h=>u(!1,h.source));break;case"setBreakpoints":m.body.breakpoints.forEach(h=>u(!1,h.source));break;case"disassemble":m.body?.instructions.forEach(P=>u(!1,P.location));break;default:break}break}}}function o(S){return S.filter(u=>!u.presentation?.hidden).sort((u,m)=>u.presentation?m.presentation?u.presentation.group?m.presentation.group?u.presentation.group!==m.presentation.group?u.presentation.group.localeCompare(m.presentation.group):w(u.presentation.order,m.presentation.order):-1:m.presentation.group?1:w(u.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.$xF=o;function w(S,u){return typeof S!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:S-u}async function f(S,u){const m=S.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(m!=="none"&&(await u.saveAll(),m==="allEditorsInActiveGroup")){const h=u.activeEditorPane;h&&h.input.resource?.scheme===A.Schemas.untitled&&await u.save({editor:h.input,groupId:h.group.id})}await S.reloadConfiguration()}e.$yF=f;const I=(S,u)=>!S||!u?S===u:S.name===u.name&&S.path===u.path&&S.sourceReference===u.sourceReference;e.$zF=I}),define(Ae[75],Re([1,0,26,38,66,67,13,19,22,32]),function(ye,e,y,M,C,T,A,l,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rI=e.$qI=e.$pI=e.$oI=e.CellStatusbarAlignment=e.$nI=e.$mI=e.$lI=e.NotebookEditorPriority=e.$kI=e.$jI=e.$iI=e.$hI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$gI=e.$fI=e.$eI=e.$dI=e.CellKind=e.$cI=e.$bI=e.$aI=void 0,e.$aI="workbench.editor.notebook",e.$bI="workbench.editor.notebookTextDiffEditor",e.$cI="workbench.editor.interactive";var R;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(R||(e.CellKind=R={})),e.$dI=["application/json","application/javascript","text/html","image/svg+xml",T.$Qr.latex,T.$Qr.markdown,"image/png","image/jpeg",T.$Qr.text],e.$eI=[T.$Qr.latex,T.$Qr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",T.$Qr.text],e.$fI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$gI="_notAvailable";var k;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var a;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(a||(e.NotebookCellExecutionState=a={}));var p;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var g;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})(g||(e.NotebookRendererMatch=g={}));var d;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(d||(e.RendererMessagingSpec=d={}));var t;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var c;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var b;(function(N){N.scheme=A.Schemas.vscodeNotebookCell;const ie=["W","X","Y","Z","a","b","c","d","e","f"],X=new RegExp(`^[${ie.join("")}]+`),Ee=7;function Se(be,_){const B=_.toString(Ee),ee=`${B.length<ie.length?ie[B.length-1]:"z"}${B}s${(0,y.$ve)(y.$be.fromString(be.scheme),!0,!0)}`;return be.with({scheme:N.scheme,fragment:ee})}N.generate=Se;function Pe(be){if(be.scheme!==N.scheme)return;const _=be.fragment.indexOf("s");if(_<0)return;const B=parseInt(be.fragment.substring(0,_).replace(X,""),Ee),Z=(0,y.$ue)(be.fragment.substring(_+1)).toString();if(!isNaN(B))return{handle:B,notebook:be.with({scheme:Z,fragment:null})}}N.parse=Pe;function $e(be,_){return be.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${_??""},${be.scheme!==A.Schemas.file?be.scheme:""}`})}N.generateCellOutputUri=$e;function pe(be){if(be.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const _=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(be.fragment);if(!_)return;const B=_[1]&&_[1]!==""?_[1]:void 0,Z=_[2];return{outputId:B,notebook:be.with({scheme:Z||A.Schemas.file,fragment:null})}}N.parseCellOutputUri=pe;function ue(be,_,B){return N.generate(be,_).with({scheme:B})}N.generateCellPropertyUri=ue;function oe(be,_){if(be.scheme===_)return N.parse(be.with({scheme:N.scheme}))}N.parseCellPropertyUri=oe})(b||(e.CellUri=b={}));const E=N=>D.$j?N.replace(/\//g,"\\"):N;class v{constructor(ie=[],X=e.$dI){this.e=X,this.d=[...new Set(ie)].map(Ee=>({pattern:Ee,matches:M.$wj(E(Ee))}))}sort(ie){const X=new Map(C.Iterable.map(ie,Se=>[Se,E(Se)]));let Ee=[];for(const{matches:Se}of this.d)for(const[Pe,$e]of X)if(Se($e)){Ee.push(Pe),X.delete(Pe);break}return X.size&&(Ee=Ee.concat([...X.keys()].sort((Se,Pe)=>this.e.indexOf(Se)-this.e.indexOf(Pe)))),Ee}prioritize(ie,X){const Ee=this.f(ie);if(Ee===-1){this.d.unshift({pattern:ie,matches:M.$wj(E(ie))});return}const Se=new Set(X.map($e=>this.f($e,Ee)));Se.delete(-1);const Pe=Array.from(Se).sort();this.d.splice(Ee+1,0,...Pe.map($e=>this.d[$e]));for(let $e=Pe.length-1;$e>=0;$e--)this.d.splice(Pe[$e],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,X=this.d.length){const Ee=E(ie);for(let Se=0;Se<X;Se++)if(this.d[Se].matches(Ee))return Se;return-1}}e.$hI=v;function s(N,ie,X,Ee=(Se,Pe)=>Se===Pe){const Se=[];function Pe(ue,oe,be){if(oe===0&&be.length===0)return;const _=Se[Se.length-1];_&&_.start+_.deleteCount===ue?(_.deleteCount+=oe,_.toInsert.push(...be)):Se.push({start:ue,deleteCount:oe,toInsert:be})}let $e=0,pe=0;for(;;){if($e===N.length){Pe($e,0,ie.slice(pe));break}if(pe===ie.length){Pe($e,N.length-$e,[]);break}const ue=N[$e],oe=ie[pe];if(Ee(ue,oe)){$e+=1,pe+=1;continue}X(oe)?(Pe($e,1,[]),$e+=1):(Pe($e,0,[oe]),pe+=1)}return Se}e.$iI=s,e.$jI=new $.$7i("notebookEditorCursorAtBoundary","none"),e.$kI=new $.$7i("notebookEditorCursorAtLineBoundary","none");var r;(function(N){N.default="default",N.option="option"})(r||(e.NotebookEditorPriority=r={}));function n(N){const ie=N;return!!((typeof ie.include=="string"||M.$xj(ie.include))&&(typeof ie.exclude=="string"||M.$xj(ie.exclude)))}e.$lI=n;function o(N,ie,X){if(Array.isArray(N.viewType)&&N.viewType.indexOf(ie)>=0||N.viewType===ie)return!0;if(N.filenamePattern){const Ee=n(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,Se=n(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(M.$vj(Ee,(0,l.$nc)(X.fsPath).toLowerCase()))return!(Se&&M.$vj(Se,(0,l.$nc)(X.fsPath).toLowerCase()))}return!1}e.$mI=o,e.$nI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var w;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class f{static{this.d="notebook/"}static create(ie){return`${f.d}${ie}`}static parse(ie){if(ie.startsWith(f.d))return ie.substring(f.d.length)}}e.$oI=f;function I(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.$pI=I;const S=new TextDecoder;function u(N){const ie=[];let X=!1;for(const $e of N)(ie.length===0||X)&&(ie.push($e),X=!0);let Ee=P(ie);const Se=y.$be.concat(ie.map($e=>y.$be.wrap($e))),Pe=O(Se);return Ee=Ee||Pe.byteLength!==Se.byteLength,{data:Pe,didCompression:Ee}}e.$qI=u,e.$rI=`${String.fromCharCode(27)}[A`;const m=e.$rI.split("").map(N=>N.charCodeAt(0)),h=10;function P(N){let ie=!1;return N.forEach((X,Ee)=>{if(Ee===0||X.length<e.$rI.length)return;const Se=N[Ee-1],Pe=X.subarray(0,e.$rI.length);if(Pe[0]===m[0]&&Pe[1]===m[1]&&Pe[2]===m[2]){const $e=Se.lastIndexOf(h);if($e===-1)return;ie=!0,N[Ee-1]=Se.subarray(0,$e),N[Ee]=X.subarray(e.$rI.length)}}),ie}function W(N){let ie=N;do N=ie,ie=N.replace(/[^\n]\x08/gm,"");while(ie.length<N.length);return N}function K(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const ie=N.match(/^(.*)\r+/m)[1];let X=N.match(/\r+(.*)$/m)[1];X=X+ie.slice(X.length,ie.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return N}const z="\b".charCodeAt(0),j="\r".charCodeAt(0);function O(N){return!N.buffer.includes(z)&&!N.buffer.includes(j)?N:y.$be.fromString(K(W(S.decode(N.buffer))))}}),define(Ae[7],Re([1,0,18,9,50,28,67,16,15,2,36,21,39,97,75]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g){"use strict";var d,t,i,c,b,E,v,s,r,n,o,w,f,I,S,u,m,h;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.$8L=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.TestRunProfileKind=e.TestResultState=e.$OL=e.$NL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$ML=e.$LL=e.$KL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$JL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.ColorThemeKind=e.$DL=e.$CL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$BL=e.DebugConsoleMode=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$vL=e.$uL=e.FileChangeType=e.$tL=e.$sL=e.$rL=e.$qL=e.InlineCompletionTriggerKind=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.ConfigurationTarget=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$6K=e.ViewBadge=e.ProgressLocation=e.$5K=e.$4K=e.TaskScope=e.ShellQuoting=e.$3K=e.$2K=e.$1K=e.TaskPanelKind=e.TaskRevealKind=e.$ZK=e.TerminalLocation=e.$YK=e.$XK=e.$WK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$VK=e.$UK=e.$TK=e.$SK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$RK=e.StatusBarAlignment=e.ViewColumn=e.$QK=e.$PK=e.$OK=e.$NK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$MK=e.$LK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.LanguageStatusSeverity=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.CodeActionTriggerKind=e.$zK=e.$yK=e.SymbolTag=e.SymbolKind=e.$xK=e.DocumentHighlightKind=e.$wK=e.$vK=e.$uK=e.$tK=e.DiagnosticSeverity=e.DiagnosticTag=e.$sK=e.$rK=e.FileEditType=e.$qK=e.$pK=e.$oK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(U){return Object.assign(U,{apply:function(...se){if(se.length===0)return Reflect.construct(U,[]);{const ke=se.length===1?[]:se[1];return Reflect.construct(U,ke,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(U,[]);{const[ke,...He]=se;return Reflect.construct(U,He,ke.constructor)}}})}var W;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var K;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(K||(e.TerminalQuickFixType=K={}));let z=d=class{static from(...L){let se=L;return new d(function(){if(se){for(const ke of se)ke&&typeof ke.dispose=="function"&&ke.dispose();se=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$hK=z,e.$hK=z=d=qe([P],z);let j=t=class{static Min(...L){if(L.length===0)throw new TypeError;let se=L[0];for(let ke=1;ke<L.length;ke++){const He=L[ke];He.isBefore(se)&&(se=He)}return se}static Max(...L){if(L.length===0)throw new TypeError;let se=L[0];for(let ke=1;ke<L.length;ke++){const He=L[ke];He.isAfter(se)&&(se=He)}return se}static isPosition(L){if(!L)return!1;if(L instanceof t)return!0;const{line:se,character:ke}=L;return typeof se=="number"&&typeof ke=="number"}static of(L){if(L instanceof t)return L;if(this.isPosition(L))return new t(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,se){if(L<0)throw(0,M.$7)("line must be non-negative");if(se<0)throw(0,M.$7)("character must be non-negative");this.c=L,this.e=se}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,se=0){if(L===null||se===null)throw(0,M.$7)();let ke;return typeof L>"u"?ke=0:typeof L=="number"?ke=L:(ke=typeof L.lineDelta=="number"?L.lineDelta:0,se=typeof L.characterDelta=="number"?L.characterDelta:0),ke===0&&se===0?this:new t(this.line+ke,this.character+se)}with(L,se=this.character){if(L===null||se===null)throw(0,M.$7)();let ke;return typeof L>"u"?ke=this.line:typeof L=="number"?ke=L:(ke=typeof L.line=="number"?L.line:this.line,se=typeof L.character=="number"?L.character:this.character),ke===this.line&&se===this.character?this:new t(ke,se)}toJSON(){return{line:this.line,character:this.character}}};e.$iK=j,e.$iK=j=t=qe([P],j);let O=i=class{static isRange(L){return L instanceof i?!0:L?j.isPosition(L.start)&&j.isPosition(L.end):!1}static of(L){if(L instanceof i)return L;if(this.isRange(L))return new i(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,se,ke,He){let Ze,ot;if(typeof L=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof He=="number"?(Ze=new j(L,se),ot=new j(ke,He)):j.isPosition(L)&&j.isPosition(se)&&(Ze=j.of(L),ot=j.of(se)),!Ze||!ot)throw new Error("Invalid arguments");Ze.isBefore(ot)?(this.c=Ze,this.e=ot):(this.c=ot,this.e=Ze)}contains(L){return i.isRange(L)?this.contains(L.start)&&this.contains(L.end):j.isPosition(L)?!(j.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const se=j.Max(L.start,this.c),ke=j.Min(L.end,this.e);if(!se.isAfter(ke))return new i(se,ke)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const se=j.Min(L.start,this.c),ke=j.Max(L.end,this.end);return new i(se,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,se=this.end){if(L===null||se===null)throw(0,M.$7)();let ke;return L?j.isPosition(L)?ke=L:(ke=L.start||this.start,se=L.end||this.end):ke=this.start,ke.isEqual(this.c)&&se.isEqual(this.end)?this:new i(ke,se)}toJSON(){return[this.start,this.end]}};e.$jK=O,e.$jK=O=i=qe([P],O);let N=c=class extends O{static isSelection(L){return L instanceof c?!0:L?O.isRange(L)&&j.isPosition(L.anchor)&&j.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,se,ke,He){let Ze,ot;if(typeof L=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof He=="number"?(Ze=new j(L,se),ot=new j(ke,He)):j.isPosition(L)&&j.isPosition(se)&&(Ze=j.of(L),ot=j.of(se)),!Ze||!ot)throw new Error("Invalid arguments");super(Ze,ot),this.f=Ze,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$kK=N,e.$kK=N=c=qe([P],N);const ie=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,M.$7)("connectionToken")};class X{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,se,ke){if(typeof L!="string"||L.length===0)throw(0,M.$7)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,M.$7)("port");typeof ke<"u"&&ie(ke),this.host=L,this.port=Math.round(se),this.connectionToken=ke}}e.$lK=X;class Ee{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,se){this.makeConnection=L,this.connectionToken=se,typeof se<"u"&&ie(se)}}e.$mK=Ee;class Se extends Error{static NotAvailable(L,se){return new Se(L,p.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(L){return new Se(L,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,se=p.RemoteAuthorityResolverErrorCode.Unknown,ke){super(L),this._message=L,this._code=se,this._detail=ke,Object.setPrototypeOf(this,Se.prototype)}}e.$nK=Se;var Pe;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var $e;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})($e||(e.EnvironmentVariableMutatorType=$e={}));let pe=b=class{static isTextEdit(L){return L instanceof b?!0:L?O.isRange(L)&&typeof L.newText=="string":!1}static replace(L,se){return new b(L,se)}static insert(L,se){return b.replace(new O(L,L),se)}static delete(L){return b.replace(L,"")}static setEndOfLine(L){const se=new b(new O(new j(0,0),new j(0,0)),"");return se.newEol=L,se}get range(){return this.c}set range(L){if(L&&!O.isRange(L))throw(0,M.$7)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,M.$7)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,M.$7)("newEol");this.f=L}constructor(L,se){this.c=L,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$oK=pe,e.$oK=pe=b=qe([P],pe);let ue=E=class{static isNotebookCellEdit(L){return L instanceof E?!0:L?xt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,se){return new E(L,se)}static insertCells(L,se){return new E(new xt(L,L),se)}static deleteCells(L){return new E(L,[])}static updateCellMetadata(L,se){const ke=new E(new xt(L,L),[]);return ke.newCellMetadata=se,ke}static updateNotebookMetadata(L){const se=new E(new xt(0,0),[]);return se.newNotebookMetadata=L,se}constructor(L,se){this.range=L,this.newCells=se}};e.$pK=ue,e.$pK=ue=E=qe([P],ue);class oe{static isSnippetTextEdit(L){return L instanceof oe?!0:L?O.isRange(L.range)&&B.isSnippetString(L.snippet):!1}static replace(L,se){return new oe(L,se)}static insert(L,se){return oe.replace(new O(L,L),se)}constructor(L,se){this.range=L,this.snippet=se}}e.$qK=oe;var be;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(be||(e.FileEditType=be={}));let _=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,se,ke,He){this.c.push({_type:1,from:L,to:se,options:ke,metadata:He})}createFile(L,se,ke){this.c.push({_type:1,from:void 0,to:L,options:se,metadata:ke})}deleteFile(L,se,ke){this.c.push({_type:1,from:L,to:void 0,options:se,metadata:ke})}e(L,se,ke){this.c.push({_type:3,metadata:ke,uri:L,edit:{editType:5,metadata:se},notebookMetadata:se})}f(L,se,ke,He){const Ze=se.start,ot=se.end;(Ze!==ot||ke.length>0)&&this.c.push({_type:5,uri:L,index:Ze,count:ot-Ze,cells:ke,metadata:He})}g(L,se,ke,He){this.c.push({_type:3,metadata:He,uri:L,edit:{editType:3,index:se,metadata:ke}})}replace(L,se,ke,He){this.c.push({_type:2,uri:L,edit:new pe(se,ke),metadata:He})}insert(L,se,ke,He){this.replace(L,new O(se,se),ke,He)}delete(L,se,ke){this.replace(L,se,"",ke)}has(L){return this.c.some(se=>se._type===2&&se.uri.toString()===L.toString())}set(L,se){if(se)for(const ke of se){if(!ke)continue;let He,Ze;Array.isArray(ke)?(He=ke[0],Ze=ke[1]):He=ke,ue.isNotebookCellEdit(He)?He.newCellMetadata?this.g(L,He.range.start,He.newCellMetadata,Ze):He.newNotebookMetadata?this.e(L,He.newNotebookMetadata,Ze):this.f(L,He.range,He.newCells,Ze):oe.isSnippetTextEdit(He)?this.c.push({_type:6,uri:L,range:He.range,edit:He.snippet,metadata:Ze}):this.c.push({_type:2,uri:L,edit:He,metadata:Ze})}else{for(let ke=0;ke<this.c.length;ke++){const He=this.c[ke];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===L.toString()&&(this.c[ke]=void 0);break}}(0,y.$Ib)(this.c)}}get(L){const se=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===L.toString()&&se.push(ke.edit);return se}entries(){const L=new T.$Ac;for(const se of this.c)if(se._type===2){let ke=L.get(se.uri);ke||(ke=[se.uri,[]],L.set(se.uri,ke)),ke[1].push(se.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$rK=_,e.$rK=_=qe([P],_);let B=v=class{static isSnippetString(L){return L instanceof v?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=v.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,se=this.e++){if(typeof L=="function"){const ke=new v;ke.e=this.e,L(ke),this.e=ke.e,L=ke.value}else L=v.c(L);return this.value+="${",this.value+=se,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,se=this.e++){const ke=L.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(L,se){if(typeof se=="function"){const ke=new v;ke.e=this.e,se(ke),this.e=ke.e,se=ke.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.$sK=B,e.$sK=B=v=qe([P],B);var Z;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(Z||(e.DiagnosticTag=Z={}));var ee;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ee||(e.DiagnosticSeverity=ee={}));let ve=s=class{static isLocation(L){return L instanceof s?!0:L?O.isRange(L.range)&&$.URI.isUri(L.uri):!1}constructor(L,se){if(this.uri=L,se)if(O.isRange(se))this.range=O.of(se);else if(j.isPosition(se))this.range=new O(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$tK=ve,e.$tK=ve=s=qe([P],ve);let ge=class{static is(L){return L?typeof L.message=="string"&&L.location&&O.isRange(L.location.range)&&$.URI.isUri(L.location.uri):!1}constructor(L,se){this.location=L,this.message=se}static isEqual(L,se){return L===se?!0:!L||!se?!1:L.message===se.message&&L.location.range.isEqual(se.location.range)&&L.location.uri.toString()===se.location.uri.toString()}};e.$uK=ge,e.$uK=ge=qe([P],ge);let de=class{constructor(L,se,ke=ee.Error){if(!O.isRange(L))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=L,this.message=se,this.severity=ke}toJSON(){return{severity:ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,se){return L===se?!0:!L||!se?!1:L.message===se.message&&L.severity===se.severity&&L.code===se.code&&L.severity===se.severity&&L.source===se.source&&L.range.isEqual(se.range)&&(0,y.$ub)(L.tags,se.tags)&&(0,y.$ub)(L.relatedInformation,se.relatedInformation,ge.isEqual)}};e.$vK=de,e.$vK=de=qe([P],de);let De=class{constructor(L,se){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=se}};e.$wK=De,e.$wK=De=qe([P],De);var re;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let le=class{constructor(L,se=re.Text){this.range=L,this.kind=se}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.$xK=le,e.$xK=le=qe([P],le);var ne;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(ne||(e.SymbolKind=ne={}));var ae;(function(U){U[U.Deprecated=1]="Deprecated"})(ae||(e.SymbolTag=ae={}));let fe=r=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,se,ke,He,Ze){this.name=L,this.kind=se,this.containerName=Ze,typeof ke=="string"&&(this.containerName=ke),He instanceof ve?this.location=He:ke instanceof O&&(this.location=new ve(He,ke)),r.validate(this)}toJSON(){return{name:this.name,kind:ne[this.kind],location:this.location,containerName:this.containerName}}};e.$yK=fe,e.$yK=fe=r=qe([P],fe);let Ie=n=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(n.validate)}constructor(L,se,ke,He,Ze){this.name=L,this.detail=se,this.kind=ke,this.range=He,this.selectionRange=Ze,this.children=[],n.validate(this)}};e.$zK=Ie,e.$zK=Ie=n=qe([P],Ie);var F;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(F||(e.CodeActionTriggerKind=F={}));let V=class{constructor(L,se){this.title=L,this.kind=se}};e.$AK=V,e.$AK=V=qe([P],V);let G=class{static{o=this}static{this.c="."}constructor(L){this.value=L}append(L){return new o(this.value?this.value+o.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+o.c)}};e.$BK=G,e.$BK=G=o=qe([P],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let J=class{constructor(L,se){if(this.range=L,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$CK=J,e.$CK=J=qe([P],J);class q{constructor(L,se,ke,He,Ze,ot){this.kind=L,this.name=se,this.detail=ke,this.uri=He,this.range=Ze,this.selectionRange=ot}}e.$DK=q;class x{constructor(L,se){this.fromRanges=se,this.from=L}}e.$EK=x;class ce{constructor(L,se){this.fromRanges=se,this.to=L}}e.$FK=ce;var Ne;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let Ue=class{constructor(L,se){this.range=L,this.command=se}get isResolved(){return!!this.command}};e.$GK=Ue,e.$GK=Ue=qe([P],Ue);let Qe=w=class{#e;static isMarkdownString(L){return L instanceof w?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,se=!1){this.#e=new C.$3j(L,{supportThemeIcons:se})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,se){return this.#e.appendCodeblock(se??"",L),this}};e.$HK=Qe,e.$HK=Qe=w=qe([P],Qe);let Ge=class{constructor(L,se){this.label=L,this.documentation=se}};e.$IK=Ge,e.$IK=Ge=qe([P],Ge);let xe=class{constructor(L,se){this.label=L,this.documentation=se,this.parameters=[]}};e.$JK=xe,e.$JK=xe=qe([P],xe);let Ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$KK=Ye,e.$KK=Ye=qe([P],Ye);var _e;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(_e||(e.SignatureHelpTriggerKind=_e={}));var it;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(L){this.value=L}};e.$LK=tt,e.$LK=tt=qe([P],tt);let ze=class{constructor(L,se,ke){this.position=L,this.label=se,this.kind=ke}};e.$MK=ze,e.$MK=ze=qe([P],ze);var st;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var Y;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Y||(e.CompletionItemKind=Y={}));var Q;(function(U){U[U.Deprecated=1]="Deprecated"})(Q||(e.CompletionItemTag=Q={}));let we=class{constructor(L,se){this.label=L,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Y[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$NK=we,e.$NK=we=qe([P],we);let Be=class{constructor(L=[],se=!1){this.items=L,this.isIncomplete=se}};e.$OK=Be,e.$OK=Be=qe([P],Be);let Oe=class{constructor(L,se,ke){this.insertText=L,this.range=se,this.command=ke}};e.$PK=Oe,e.$PK=Oe=qe([P],Oe);let Xe=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$QK=Xe,e.$QK=Xe=qe([P],Xe);var nt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var ft;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(ft||(e.StatusBarAlignment=ft={}));function wt(U,L){return`${k.$6l.toKey(U)}.${L}`}e.$RK=wt;var Pt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Zt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Zt||(e.TextDocumentSaveReason=Zt={}));var Gt;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Gt||(e.TextEditorRevealType=Gt={}));var pt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(pt||(e.TextEditorSelectionChangeKind=pt={}));var jt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Nt;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(U){function L(se){switch(se){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=L}(pt||(e.TextEditorSelectionChangeKind=pt={}));var Bt;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(U){function L(se){switch(se){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=L}(Bt||(e.SyntaxTokenType=Bt={}));let At=class{constructor(L,se){if(se&&!$.URI.isUri(se))throw(0,M.$7)("target");if(!O.isRange(L)||L.isEmpty)throw(0,M.$7)("range");this.range=L,this.target=se}};e.$SK=At,e.$SK=At=qe([P],At);let Rt=class{constructor(L,se,ke,He){this.red=L,this.green=se,this.blue=ke,this.alpha=He}};e.$TK=Rt,e.$TK=Rt=qe([P],Rt);let Ot=class{constructor(L,se){if(se&&!(se instanceof Rt))throw(0,M.$7)("color");if(!O.isRange(L)||L.isEmpty)throw(0,M.$7)("range");this.range=L,this.color=se}};e.$UK=Ot,e.$UK=Ot=qe([P],Ot);let Wt=class{constructor(L){if(!L||typeof L!="string")throw(0,M.$7)("label");this.label=L}};e.$VK=Wt,e.$VK=Wt=qe([P],Wt);var Jt;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Kt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Kt||(e.SourceControlInputBoxValidationType=Kt={}));var Vt;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(Vt||(e.TerminalExitReason=Vt={}));class Mt{constructor(L,se,ke){if(this.startIndex=L,this.length=se,this.tooltip=ke,typeof L!="number"||L<0)throw(0,M.$7)("startIndex");if(typeof se!="number"||se<1)throw(0,M.$7)("length");if(ke!==void 0&&typeof ke!="string")throw(0,M.$7)("tooltip")}}e.$WK=Mt;class ut{constructor(L){this.uri=L}}e.$XK=ut;class ht{constructor(L){this.terminalCommand=L}}e.$YK=ht;var Lt;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Lt||(e.TerminalLocation=Lt={}));class qt{constructor(L){if(this.options=L,typeof L!="object")throw(0,M.$7)("options")}}e.$ZK=qt;var kt;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(kt||(e.TaskRevealKind=kt={}));var at;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(at||(e.TaskPanelKind=at={}));let vt=class{static{f=this}static{this.Clean=new f("clean","Clean")}static{this.Build=new f("build","Build")}static{this.Rebuild=new f("rebuild","Rebuild")}static{this.Test=new f("test","Test")}static from(L){switch(L){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}constructor(L,se){if(this.label=se,typeof L!="string"||typeof se!="string")throw(0,M.$7)("name");this.c=L}get id(){return this.c}};e.$1K=vt,e.$1K=vt=f=qe([P],vt);function Ht(U){let L="";for(let se=0;se<U.length;se++)L+=U[se].replace(/,/g,",,")+",";return L}let Ct=class{constructor(L,se,ke){if(typeof L!="string")throw(0,M.$7)("process");this.e=[],this.c=L,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=ke):this.f=se)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,M.$7)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const se of this.e)L.push(se);return Ht(L)}};e.$2K=Ct,e.$2K=Ct=qe([P],Ct);let We=class{constructor(L,se,ke){if(this.f=[],Array.isArray(se)){if(!L)throw(0,M.$7)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,M.$7)("command");this.e=L,this.f=se,this.g=ke}else{if(typeof L!="string")throw(0,M.$7)("commandLine");this.c=L,this.g=se}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,M.$7)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,M.$7)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)L.push(typeof se=="string"?se:se.value);return Ht(L)}};e.$3K=We,e.$3K=We=qe([P],We);var Ce;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(Ce||(e.ShellQuoting=Ce={}));var Fe;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Fe||(e.TaskScope=Fe={}));class me{constructor(L){this.c=L}computeId(){return"customExecution"+(0,R.$eg)()}set callback(L){this.c=L}get callback(){return this.c}}e.$4K=me;let H=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,se,ke,He,Ze,ot){this.j=!1,this.k=this.definition=L;let dt;typeof se=="string"?(this.m=this.name=se,this.t=this.source=ke,this.execution=He,dt=Ze,this.j=!0):se===Fe.Global||se===Fe.Workspace?(this.target=se,this.m=this.name=ke,this.t=this.source=He,this.execution=Ze,dt=ot):(this.target=se,this.m=this.name=ke,this.t=this.source=He,this.execution=Ze,dt=ot),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(L){this.h=L}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ct?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof We?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof me?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,R.$eg)()}}get definition(){return this.k}set definition(L){if(L==null)throw(0,M.$7)("Kind can't be undefined or null");this.z(),this.k=L}get scope(){return this.l}set target(L){this.z(),this.l=L}get name(){return this.m}set name(L){if(typeof L!="string")throw(0,M.$7)("name");this.z(),this.m=L}get execution(){return this.n}set execution(L){L===null&&(L=void 0),this.z(),this.n=L;const se=this.k.type;(I.g===se||I.e===se||I.f===se||I.c===se)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(L){if(Array.isArray(L))this.z(),this.o=L,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.z(),this.r=L}get source(){return this.t}set source(L){if(typeof L!="string"||L.length===0)throw(0,M.$7)("source must be a string of length > 0");this.z(),this.t=L}get group(){return this.u}set group(L){L===null&&(L=void 0),this.z(),this.u=L}get detail(){return this.y}set detail(L){L===null&&(L=void 0),this.y=L}get presentationOptions(){return this.w}set presentationOptions(L){L==null&&(L=Object.create(null)),this.z(),this.w=L}get runOptions(){return this.x}set runOptions(L){L==null&&(L=Object.create(null)),this.z(),this.x=L}};e.$5K=H,e.$5K=H=I=qe([P],H);var Me;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(Me||(e.ProgressLocation=Me={}));var je;(function(U){function L(se){const ke=se;return(0,D.$Cf)(ke.value)?ke.tooltip&&!(0,D.$yf)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}U.isViewBadge=L})(je||(e.ViewBadge=je={}));let Je=S=class{static isTreeItem(L,se){const ke=L;if(ke.checkboxState!==void 0){const He=(0,D.$Cf)(ke.checkboxState)?ke.checkboxState:(0,D.$Af)(ke.checkboxState)&&(0,D.$Cf)(ke.checkboxState.state)?ke.checkboxState.state:void 0,Ze=!(0,D.$Cf)(ke.checkboxState)&&(0,D.$Af)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(He===void 0||He!==et.Checked&&He!==et.Unchecked||Ze!==void 0&&!(0,D.$yf)(Ze))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(L instanceof S)return!0;if(ke.label!==void 0&&!(0,D.$yf)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,D.$yf)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,D.$yf)(ke.iconPath)&&!$.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,D.$yf)(ke.iconPath.id))){const He=ke.iconPath;if(!He||!(0,D.$yf)(He.light)&&!$.URI.isUri(He.light)&&!(0,D.$yf)(He.dark)&&!$.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,D.$yf)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!$.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,D.$yf)(ke.tooltip)&&!(ke.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<Ve.None&&ke.collapsibleState>Ve.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,D.$yf)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(L,se=Ve.None){this.collapsibleState=se,$.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$6K=Je,e.$6K=Je=S=qe([P],Je);var Ve;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(Ve||(e.TreeItemCollapsibleState=Ve={}));var et;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(et||(e.TreeItemCheckboxState=et={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$7K=bt,e.$7K=bt=qe([P],bt);class zt extends bt{}e.$8K=zt;class Dt extends zt{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$9K=Dt;class lt{constructor(L,se,ke,He){this.name=L,this.uri=se,this._itemId=ke,this.c=He}data(){return this.c()}}e.$0K=lt;let gt=class{#e=new Map;constructor(L){for(const[se,ke]of L??[]){const He=this.#e.get(this.#t(se));He?He.push(ke):this.#e.set(this.#t(se),[ke])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,se){this.#e.set(this.#t(L),[se])}forEach(L,se){for(const[ke,He]of this.#e)for(const Ze of He)L.call(se,Ze,ke,this)}*[Symbol.iterator](){for(const[L,se]of this.#e)for(const ke of se)yield[L,ke]}#t(L){return L.toLowerCase()}};e.$$K=gt,e.$$K=gt=qe([P],gt);let yt=class{constructor(L){this.insertText=L}};e.$_K=yt,e.$_K=yt=qe([P],yt);let mi=class{constructor(L,se){this.label=se,this.insertText=L}};e.$aL=mi,e.$aL=mi=qe([P],mi);let St=class{constructor(L,se){this.id=L,this.color=se}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$bL=St,e.$bL=St=qe([P],St),St.File=new St("file"),St.Folder=new St("folder");let Si=class{constructor(L){this.id=L}};e.$cL=Si,e.$cL=Si=qe([P],Si);var ui;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(ui||(e.ConfigurationTarget=ui={}));let $i=class{get base(){return this.c}set base(L){this.c=L,this.e=$.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,se){if(typeof L!="string"&&(!L||!$.URI.isUri(L)&&!$.URI.isUri(L.uri)))throw(0,M.$7)("base");if(typeof se!="string")throw(0,M.$7)("pattern");typeof L=="string"?this.baseUri=$.URI.file(L):$.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$dL=$i,e.$dL=$i=qe([P],$i);const It=new WeakMap;function fn(U,L){It.set(U,L)}e.$eL=fn;let ri=class{constructor(L,se,ke,He){this.enabled=typeof L=="boolean"?L:!0,typeof se=="string"&&(this.condition=se),typeof ke=="string"&&(this.hitCondition=ke),typeof He=="string"&&(this.logMessage=He)}get id(){return this.c||(this.c=It.get(this)??(0,R.$eg)()),this.c}};e.$fL=ri,e.$fL=ri=qe([P],ri);let Et=class extends ri{constructor(L,se,ke,He,Ze){if(super(se,ke,He,Ze),L===null)throw(0,M.$7)("location");this.location=L}};e.$gL=Et,e.$gL=Et=qe([P],Et);let pi=class extends ri{constructor(L,se,ke,He,Ze){super(se,ke,He,Ze),this.functionName=L}};e.$hL=pi,e.$hL=pi=qe([P],pi);let vi=class extends ri{constructor(L,se,ke,He,Ze,ot,dt){if(super(He,Ze,ot,dt),!se)throw(0,M.$7)("dataId");this.label=L,this.dataId=se,this.canPersist=ke}};e.$iL=vi,e.$iL=vi=qe([P],vi);let si=class{constructor(L,se,ke){this.command=L,this.args=se||[],this.options=ke}};e.$jL=si,e.$jL=si=qe([P],si);let Ii=class{constructor(L,se){this.port=L,this.host=se}};e.$kL=Ii,e.$kL=Ii=qe([P],Ii);let Ci=class{constructor(L){this.path=L}};e.$lL=Ci,e.$lL=Ci=qe([P],Ci);let Ft=class{constructor(L){this.implementation=L}};e.$mL=Ft,e.$mL=Ft=qe([P],Ft);let bi=class{constructor(L,se,ke){this.session=L,this.threadId=se,this.frameId=ke}};e.$nL=bi,e.$nL=bi=qe([P],bi);let Pi=class{constructor(L,se){this.session=L,this.threadId=se}};e.$oL=Pi,e.$oL=Pi=qe([P],Pi);let oi=class{constructor(L,se){this.range=L,this.expression=se}};e.$pL=oi,e.$pL=oi=qe([P],oi);var li;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(li||(e.InlineCompletionTriggerKind=li={}));let ct=class{constructor(L,se){this.range=L,this.text=se}};e.$qL=ct,e.$qL=ct=qe([P],ct);let Ai=class{constructor(L,se,ke=!0){this.range=L,this.variableName=se,this.caseSensitiveLookup=ke}};e.$rL=Ai,e.$rL=Ai=qe([P],Ai);let Yt=class{constructor(L,se){this.range=L,this.expression=se}};e.$sL=Yt,e.$sL=Yt=qe([P],Yt);let ii=class{constructor(L,se){this.frameId=L,this.stoppedLocation=se}};e.$tL=ii,e.$tL=ii=qe([P],ii);var Ri;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Mi=u=class extends Error{static FileExists(L){return new u(L,a.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(L){return new u(L,a.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(L){return new u(L,a.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(L){return new u(L,a.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(L){return new u(L,a.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(L){return new u(L,a.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}constructor(L,se=a.FileSystemProviderErrorCode.Unknown,ke){super($.URI.isUri(L)?L.toString(!0):L),this.code=ke?.name??"Unknown",(0,a.$nk)(this,se),Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$uL=Mi,e.$uL=Mi=u=qe([P],Mi);let Fi=class{constructor(L,se,ke){this.start=L,this.end=se,this.kind=ke}};e.$vL=Fi,e.$vL=Fi=qe([P],Fi);var Xi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Ti;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ti||(e.CommentThreadCollapsibleState=Ti={}));var Zi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var Li;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Li||(e.CommentState=Li={}));var ai;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class gn{constructor(L,se=[]){this.tokenTypes=L,this.tokenModifiers=se}}e.$wL=gn;function Ni(U){return typeof U>"u"||(0,D.$zf)(U)}class di{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,L){this.l=!0;for(let se=0,ke=L.tokenTypes.length;se<ke;se++)this.j.set(L.tokenTypes[se],se);for(let se=0,ke=L.tokenModifiers.length;se<ke;se++)this.k.set(L.tokenModifiers[se],se)}}push(L,se,ke,He,Ze){if(typeof L=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof He=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this.n(L,se,ke,He,Ze);if(O.isRange(L)&&typeof se=="string"&&Ni(ke))return this.m(L,se,ke);throw(0,M.$7)()}m(L,se,ke){if(!this.l)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(se))throw new Error("`tokenType` is not in the provided legend");const He=L.start.line,Ze=L.start.character,ot=L.end.character-L.start.character,dt=this.j.get(se);let Ut=0;if(ke)for(const Xt of ke){if(!this.k.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Xt);Ut|=1<<ei>>>0}this.n(He,Ze,ot,dt,Ut)}n(L,se,ke,He,Ze){if(this.f&&(L<this.c||L===this.c&&se<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Xt=0,ei=0;for(let ti=0;ti<Ut;ti++){let ni=this.g[5*ti],Ji=this.g[5*ti+1];ni===0?(ni=Xt,Ji+=ei):ni+=Xt,this.g[5*ti]=ni,this.g[5*ti+1]=Ji,Xt=ni,ei=Ji}}let ot=L,dt=se;this.f&&this.h>0&&(ot-=this.c,ot===0&&(dt-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=dt,this.g[this.h++]=ke,this.g[this.h++]=He,this.g[this.h++]=Ze,this.c=L,this.e=se}static o(L){const se=[],ke=L.length/5|0;for(let dt=0;dt<ke;dt++)se[dt]=dt;se.sort((dt,Ut)=>{const Xt=L[5*dt],ei=L[5*Ut];if(Xt===ei){const ti=L[5*dt+1],ni=L[5*Ut+1];return ti-ni}return Xt-ei});const He=new Uint32Array(L.length);let Ze=0,ot=0;for(let dt=0;dt<ke;dt++){const Ut=5*se[dt],Xt=L[Ut+0],ei=L[Ut+1],ti=L[Ut+2],ni=L[Ut+3],Ji=L[Ut+4],In=Xt-Ze,Fn=In===0?ei-ot:ei,Qi=5*dt;He[Qi+0]=In,He[Qi+1]=Fn,He[Qi+2]=ti,He[Qi+3]=ni,He[Qi+4]=Ji,Ze=Xt,ot=ei}return He}build(L){return this.f?new Oi(new Uint32Array(this.g),L):new Oi(di.o(this.g),L)}}e.$xL=di;class Oi{constructor(L,se){this.resultId=se,this.data=L}}e.$yL=Oi;class mn{constructor(L,se,ke){this.start=L,this.deleteCount=se,this.data=ke}}e.$zL=mn;class hi{constructor(L,se){this.resultId=se,this.edits=L}}e.$AL=hi;var Yi;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));let zi=class{static{this.Back={iconPath:new St("arrow-left")}}constructor(){}};e.$BL=zi,e.$BL=zi=qe([P],zi);var xi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var fi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(fi||(e.InputBoxValidationSeverity=fi={}));var _i;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class $n{static validate(L){if(typeof L.badge=="string"){let se=(0,l.$_e)(L.badge,0);if(se<L.badge.length&&(se+=(0,l.$_e)(L.badge,se)),L.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!St.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,se,ke){this.badge=L,this.tooltip=se,this.color=ke}}e.$CL=$n;let Ui=class{constructor(L){this.kind=L}};e.$DL=Ui,e.$DL=Ui=qe([P],Ui);var gi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(gi||(e.ColorThemeKind=gi={}));class xt{static isNotebookRange(L){return L instanceof xt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,se){if(L<0)throw(0,M.$7)("start must be positive");if(se<0)throw(0,M.$7)("end must be positive");L<=se?(this.c=L,this.e=se):(this.c=se,this.e=L)}with(L){let se=this.c,ke=this.e;return L.start!==void 0&&(se=L.start),L.end!==void 0&&(ke=L.end),se===this.c&&ke===this.e?this:new xt(se,ke)}}e.$EL=xt;class wi{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(se=>wi.isNotebookCellData(se))}static isNotebookCellData(L){return!0}constructor(L,se,ke,He,Ze,ot,dt){this.kind=L,this.value=se,this.languageId=ke,this.mime=He,this.outputs=Ze??[],this.metadata=ot,this.executionSummary=dt,wi.validate(this)}}e.$FL=wi;class pn{constructor(L){this.cells=L}}e.$GL=pn;class Qt{static isNotebookCellOutputItem(L){return L instanceof Qt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const se={name:L.name,message:L.message,stack:L.stack};return Qt.json(se,"application/vnd.code.notebook.error")}static stdout(L){return Qt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Qt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,se="application/octet-stream"){return new Qt(L,se)}static#e=new TextEncoder;static text(L,se=A.$Qr.text){const ke=Qt.#e.encode(String(L));return new Qt(ke,se)}static json(L,se="text/x-json"){const ke=JSON.stringify(L,void 0,"	");return Qt.text(ke,se)}constructor(L,se){this.data=L,this.mime=se;const ke=(0,A.$Ur)(se,!0);if(!ke)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$HL=Qt;class yi{static isNotebookCellOutput(L){return L instanceof yi?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,se=!1){const ke=new Set,He=new Set;for(let Ze=0;Ze<L.length;Ze++){const ot=L[Ze],dt=(0,A.$Ur)(ot.mime);if(!ke.has(dt)||(0,g.$pI)(dt)){ke.add(dt);continue}He.add(Ze),se&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return He.size===0?L:L.filter((Ze,ot)=>!He.has(ot))}constructor(L,se,ke){this.items=yi.ensureUniqueMimeTypes(L,!0),typeof se=="string"?(this.id=se,this.metadata=ke):(this.id=(0,R.$eg)(),this.metadata=se??ke)}}e.$IL=yi;var en;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(en||(e.NotebookCellKind=en={}));var tn;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(tn||(e.NotebookCellExecutionState=tn={}));var nn;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(nn||(e.NotebookCellStatusBarAlignment=nn={}));var Ei;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class rn{constructor(L,se){this.text=L,this.alignment=se}}e.$JL=rn;var Le;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Le||(e.NotebookControllerAffinity=Le={}));var _t;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class sn{constructor(L,se=[]){this.uri=L,this.provides=(0,y.$3b)(se)}}e.$KL=sn;class mt{constructor(L){this.label=L}}e.$LL=mt;let ji=class{constructor(L,se){this.label=L,this.timestamp=se}};e.$ML=ji,e.$ML=ji=qe([P],ji);var on;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var Bi;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var an;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class Di{constructor(L,se){this.ranges=L,this.wordPattern=se}}e.$NL=Di;class vn{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$OL=vn;var cn;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let ki=class{constructor(L=void 0,se=void 0,ke=void 0,He=!1){this.include=L,this.exclude=se,this.profile=ke,this.continuous=He}};e.$PL=ki,e.$PL=ki=qe([P],ki);let Wi=m=class{static diff(L,se,ke){const He=new m(L);return He.expectedOutput=se,He.actualOutput=ke,He}constructor(L){this.message=L}};e.$QL=Wi,e.$QL=Wi=m=qe([P],Wi);let Ki=class{constructor(L){this.id=L}};e.$RL=Ki,e.$RL=Ki=qe([P],Ki);let ci=class{constructor(L,se){this.covered=L,this.total=se}};e.$SL=ci,e.$SL=ci=qe([P],ci);let Vi=h=class{static fromDetails(L,se){const ke=new ci(0,0),He=new ci(0,0),Ze=new ci(0,0);for(const dt of se)if("branches"in dt){ke.total+=1,ke.covered+=dt.executionCount>0?1:0;for(const Ut of dt.branches)He.total+=1,He.covered+=Ut.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=dt.executionCount>0?1:0;const ot=new h(L,ke,He.total>0?He:void 0,Ze.total>0?Ze:void 0);return ot.detailedCoverage=se,ot}constructor(L,se,ke,He){this.uri=L,this.statementCoverage=se,this.branchCoverage=ke,this.functionCoverage=He}};e.$TL=Vi,e.$TL=Vi=h=qe([P],Vi);let qi=class{constructor(L,se,ke=[]){this.executionCount=L,this.location=se,this.branches=ke}};e.$UL=qi,e.$UL=qi=qe([P],qi);let Hi=class{constructor(L,se){this.executionCount=L,this.location=se}};e.$VL=Hi,e.$VL=Hi=qe([P],Hi);let Gi=class{constructor(L,se){this.executionCount=L,this.location=se}};e.$WL=Gi,e.$WL=Gi=qe([P],Gi);var ln;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(ln||(e.ExternalUriOpenerPriority=ln={}));var dn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(dn||(e.WorkspaceTrustState=dn={}));var hn;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(hn||(e.PortAutoForwardAction=hn={}));class te{constructor(L,se,ke,He,Ze,ot){this.kind=L,this.name=se,this.detail=ke,this.uri=He,this.range=Ze,this.selectionRange=ot}}e.$XL=te;class he{constructor(L){this.uri=L}}e.$YL=he;class Te{constructor(L,se){this.original=L,this.modified=se}}e.$ZL=Te;class rt{constructor(L,se,ke,He){this.base=L,this.input1=se,this.input2=ke,this.result=He}}e.$1L=rt;class $t{constructor(L,se){this.uri=L,this.viewType=se}}e.$2L=$t;class Tt{constructor(L){this.viewType=L}}e.$3L=Tt;class Cn{constructor(L,se){this.uri=L,this.notebookType=se}}e.$4L=Cn;class Pn{constructor(L,se,ke){this.original=L,this.modified=se,this.notebookType=ke}}e.$5L=Pn;class An{constructor(){}}e.$6L=An;class Rn{constructor(L,se){this.uri=L,this.inputBoxUri=se}}e.$7L=Rn;var bn;(function(U){U[U.Up=1]="Up",U[U.Down=2]="Down"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var wn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(wn||(e.InteractiveSessionCopyKind=wn={}));var yn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var Dn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class Mn{constructor(L,se){this.role=L,this.content=se}}e.$8L=Mn;var kn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(kn||(e.RelatedInformationType=kn={}));var Sn;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}))}),define(Ae[100],Re([1,0,52,13,16,279,136,7,18]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=e.$jM=e.$iM=void 0;const $=new Map;function R(g,d){d?$.set(g,d):$.delete(g)}e.$iM=R;function k(g){return $.get(g)}class a extends T.$Vu{constructor(d,t,i,c,b,E,v,s){super(t,i,c,b),this.c=d,this.m=E,this.q=v,this.notebook=s,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,D.$ub)(this.f,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.d},get fileName(){return d.d.fsPath},get isUntitled(){return d.d.scheme===M.Schemas.untitled},get languageId(){return d.m},get version(){return d.h},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(t){return t?d.s(t):d.getText()},get eol(){return d.g===`
`?l.EndOfLine.LF:l.EndOfLine.CRLF},get lineCount(){return d.f.length},lineAt(t){return d.t(t)},offsetAt(t){return d.u(t)},positionAt(t){return d.v(t)},validateRange(t){return d.w(t)},validatePosition(t){return d.x(t)},getWordRangeAtPosition(t,i){return d.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,y.ok)(!this.b),this.m=d}_acceptIsDirty(d){(0,y.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(d){const t=this.w(d);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,c=t.start.line,b=t.end.line,E=[];E.push(this.f[c].substring(t.start.character));for(let v=c+1;v<b;v++)E.push(this.f[v]);return E.push(this.f[b].substring(0,t.end.character)),E.join(i)}t(d){let t;if(d instanceof l.$iK?t=d.line:typeof d=="number"&&(t=d),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new p(t,this.f[t],t===this.f.length-1)}u(d){return d=this.x(d),this.l(),this.j.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.l();const t=this.j.getIndexOf(d),i=this.f[t.index].length;return new l.$iK(t.index,Math.min(t.remainder,i))}w(d){if(!(d instanceof l.$jK))throw new Error("Invalid argument");const t=this.x(d.start),i=this.x(d.end);return t===d.start&&i===d.end?d:new l.$jK(t.line,t.character,i.line,i.character)}x(d){if(!(d instanceof l.$iK))throw new Error("Invalid argument");if(this.f.length===0)return d.with(0,0);let{line:t,character:i}=d,c=!1;if(t<0)t=0,i=0,c=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,c=!0;else{const b=this.f[t].length;i<0?(i=0,c=!0):i>b&&(i=b,c=!0)}return c?new l.$iK(t,i):d}y(d,t){const i=this.x(d);if(!t)t=k(this.m);else if((0,C.$Oe)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const c=(0,A.$9r)(i.character+1,(0,A.$7r)(t),this.f[i.line],0);if(c)return new l.$jK(i.line,c.startColumn-1,i.line,c.endColumn-1)}}e.$jM=a;class p{constructor(d,t,i){this.a=d,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new l.$jK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new l.$jK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$kM=p}),define(Ae[196],Re([1,0,7,17,5]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;let T=class{constructor(l){this.a=new y.$DL(y.ColorThemeKind.Dark),this.b=new C.$Nd}get activeColorTheme(){return this.a}$onColorThemeChange(l){let D;switch(l){case"light":D=y.ColorThemeKind.Light;break;case"hcDark":D=y.ColorThemeKind.HighContrast;break;case"hcLight":D=y.ColorThemeKind.HighContrastLight;break;default:D=y.ColorThemeKind.Dark}this.a=new y.$DL(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$xdc=T,e.$xdc=T=qe([Ke(0,M.$gM)],T)}),define(Ae[197],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tI=e.CellExecutionUpdateType=void 0;var M;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$tI=(0,y.$Ph)("INotebookExecutionService")}),define(Ae[46],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$I=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(T){T.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var M;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class C{static fromExtHostTestItem(A,l,D=A.parent){if(A._isRoot)return new C([l]);const $=[A.id];for(let R=D;R&&R.id!==l;R=R.parent)$.push(R.id);return $.push(l),new C($.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const l=A.indexOf("\0");return l===-1?A:A.slice(0,l)}static fromString(A){return new C(A.split("\0"))}static join(A,l){return new C([...A.path,l])}static joinToString(A,l){return A.toString()+"\0"+l}static parentId(A){const l=A.lastIndexOf("\0");return l===-1?void 0:A.slice(0,l)}static localId(A){const l=A.lastIndexOf("\0");return l===-1?A:A.slice(l+1)}static isChild(A,l){return l.startsWith(A)&&l[A.length]==="\0"}static compare(A,l){return A===l?0:C.isChild(A,l)?2:C.isChild(l,A)?3:1}constructor(A,l=A.length){if(this.path=A,this.d=l,A.length===0||l<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let l=0;l<A.d&&l<this.d;l++)if(A.path[l]!==this.path[l])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$$I=C}),define(Ae[57],Re([1,0,2,45,46]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$eJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$dJ=e.$cJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$bJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$aJ=e.$_I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var T;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(T||(e.TestResultState=T={}));var A;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var l;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})(l||(e.TestRunProfileBitset=l={})),e.$_I=[2,4,8,16,32,64];const D=S=>"runId"in S;e.$aJ=D;var $;(function(S){S.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),S.deserialize=u=>({range:M.$ts.lift(u.range),uri:y.URI.revive(u.uri)})})($||(e.IRichLocation=$={}));var R;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(R||(e.TestMessageType=R={}));var k;(function(S){S.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&$.serialize(u.location)}),S.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&$.deserialize(u.location)})})(k||(e.ITestErrorMessage=k={}));const a=(S,u)=>`${u?"s":"e"}${S}`;e.$bJ=a;var p;(function(S){S.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&$.serialize(u.location)}),S.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&$.deserialize(u.location)})})(p||(e.ITestOutputMessage=p={}));var g;(function(S){S.serialize=u=>u.type===0?k.serialize(u):p.serialize(u),S.deserialize=u=>u.type===0?k.deserialize(u):p.deserialize(u)})(g||(e.ITestMessage=g={}));var d;(function(S){S.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),S.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(g.serialize)}),S.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(g.deserialize)})})(d||(e.ITestTaskState=d={}));const t="\0",i=(S,u)=>S+t+u;e.$cJ=i;const c=S=>{const u=S.indexOf(t);return{ctrlId:S.slice(0,u),tagId:S.slice(u+1)}};e.$dJ=c;var b;(function(S){S.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),S.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?y.URI.revive(u.uri):void 0,range:u.range?M.$ts.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(b||(e.ITestItem=b={}));var E;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(E||(e.TestItemExpandState=E={}));var v;(function(S){S.serialize=u=>({expand:u.expand,item:b.serialize(u.item)}),S.deserialize=u=>({controllerId:C.$$I.root(u.item.extId),expand:u.expand,item:b.deserialize(u.item)})})(v||(e.InternalTestItem=v={}));var s;(function(S){S.serialize=u=>{let m;return u.item&&(m={},u.item.label!==void 0&&(m.label=u.item.label),u.item.tags!==void 0&&(m.tags=u.item.tags),u.item.busy!==void 0&&(m.busy=u.item.busy),u.item.uri!==void 0&&(m.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(m.range=u.item.range?.toJSON()),u.item.description!==void 0&&(m.description=u.item.description),u.item.error!==void 0&&(m.error=u.item.error),u.item.sortText!==void 0&&(m.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:m}},S.deserialize=u=>{let m;return u.item&&(m={},u.item.label!==void 0&&(m.label=u.item.label),u.item.tags!==void 0&&(m.tags=u.item.tags),u.item.busy!==void 0&&(m.busy=u.item.busy),u.item.range!==void 0&&(m.range=u.item.range?M.$ts.lift(u.item.range):null),u.item.description!==void 0&&(m.description=u.item.description),u.item.error!==void 0&&(m.error=u.item.error),u.item.sortText!==void 0&&(m.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:m}}})(s||(e.ITestItemUpdate=s={}));const r=(S,u)=>{u.expand!==void 0&&(S.expand=u.expand),u.item!==void 0&&(S.item=S.item?Object.assign(S.item,u.item):u.item)};e.$eJ=r;var n;(function(S){S.serializeWithoutMessages=u=>({...v.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(d.serializeWithoutMessages)}),S.serialize=u=>({...v.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(d.serialize)}),S.deserialize=u=>({...v.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(d.deserialize),retired:!0})})(n||(e.TestResultItem=n={}));var o;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(o||(e.DetailType=o={}));var w;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(w||(e.TestDiffOpType=w={}));var f;(function(S){S.deserialize=u=>u.op===0?{op:u.op,item:v.deserialize(u.item)}:u.op===1?{op:u.op,item:s.deserialize(u.item)}:u.op===2?{op:u.op,uri:y.URI.revive(u.uri),docv:u.docv}:u,S.serialize=u=>u.op===0?{op:u.op,item:v.serialize(u.item)}:u.op===1?{op:u.op,item:s.serialize(u.item)}:u})(f||(e.TestsDiffOp=f={}));class I{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(u){const m=this.p();for(const h of u)switch(h.op){case 0:this.k(v.deserialize(h.item),m);break;case 1:this.l(s.deserialize(h.item),m);break;case 3:this.m(h.itemId,m);break;case 5:this.o(h.itemId);break;case 4:this.updatePendingRoots(h.amount);break;case 6:this.d.set(h.tag.id,h.tag);break;case 7:this.d.delete(h.id);break}m.complete?.()}k(u,m){const h=C.$$I.parentId(u.item.extId)?.toString();let P;if(!h)P=this.q(u),this.g.add(P),this.f.set(u.item.extId,P);else if(this.f.has(h)){const W=this.f.get(h);W.children.add(u.item.extId),P=this.q(u,W),this.f.set(u.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return m.add?.(P),u.expand===2&&this.h++,P}l(u,m){const h=this.f.get(u.extId);if(h)return u.expand!==void 0&&(h.expand===2&&this.h--,u.expand===2&&this.h++),(0,e.$eJ)(h,u),m.update?.(h),h}m(u,m){const h=this.f.get(u);if(!h)return;const P=C.$$I.parentId(h.item.extId)?.toString();P?this.f.get(P).children.delete(h.item.extId):this.g.delete(h);const W=[[u]];for(;W.length;)for(const K of W.pop()){const z=this.f.get(K);z&&(W.push(z.children),this.f.delete(K),m.remove?.(z,z!==h),z.expand===2&&this.h--)}}o(u){}updatePendingRoots(u){this.j+=u}p(){return{}}}e.$fJ=I}),define(Ae[76],Re([1,0,12,5,6,52,57,46]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.TestItemEventOp=void 0;var D;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(D||(e.TestItemEventOp=D={}));const $=(c,b)=>c===b,k=Object.entries({range:(c,b)=>c===b?!0:!c||!b?!1:c.equalsRange(b),busy:$,label:$,description:$,error:$,sortText:$,tags:(c,b)=>!(c.length!==b.length||c.some(E=>!b.includes(E)))}),a=(c,b)=>{let E;for(const[v,s]of k)s(c[v],b[v])||(E?E[v]=b[v]:E={[v]:b[v]});return E};class p extends C.$Sc{get root(){return this.s.root}constructor(b){super(),this.s=b,this.f=this.B(new y.$6g(()=>this.flushDiff(),200)),this.g=this.B(new M.$Nd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(b){this.h=b;for(const E of this.tree.values())this.I(E)}get resolveHandler(){return this.h}collectDiff(){const b=this.m;return this.m=[],b}pushDiff(b){switch(b.op){case 2:{for(const E of this.m)if(E.op===2&&E.uri===b.uri){E.docv=b.docv;return}break}case 1:{const E=this.m[this.m.length-1];if(E){if(E.op===1&&E.item.extId===b.item.extId){(0,A.$eJ)(E.item,b.item);return}if(E.op===0&&E.item.item.extId===b.item.extId){(0,A.$eJ)(E.item,b.item);return}}break}}this.m.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,E){const v=this.tree.get(b);if(v){if((v.expandLevels===void 0||E>v.expandLevels)&&(v.expandLevels=E),v.expand===1){const s=this.L(v);return s.isOpen()?this.J(v,E-1):s.wait().then(()=>this.J(v,E-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.J(v,E-1)):this.J(v,E-1)}}dispose(){for(const b of this.tree.values())this.s.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(b,E){switch(E.op){case 3:this.N(l.$$I.joinToString(b.fullId,E.id));break;case 0:this.y(E.item,b);break;case 5:for(const v of E.ops)this.u(b,v);break;case 1:this.z(E.new,E.old,b.fullId.toString());break;case 2:this.I(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:E.update}});break;case 6:this.w(b.actual.uri);break;default:(0,T.$4c)(E)}}w(b){b&&this.pushDiff({op:2,uri:b,docv:this.s.getDocumentVersion(b)})}y(b,E){const v=l.$$I.fromExtHostTestItem(b,this.root.id,E?.actual),s=this.s.getApiFor(b);s.parent&&s.parent!==E?.actual&&this.s.getChildren(s.parent).delete(b.id);let r=this.tree.get(v.toString());if(!r){r={fullId:v,actual:b,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},b.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(b,E),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(b)}}),this.H(b,r,E);return}if(r.actual===b){this.G(b,r,E);return}if(r.actual.uri?.toString()!==b.uri?.toString())return this.N(v.toString()),this.y(b,E);const n=this.s.getChildren(r.actual),o=r.actual,w=a(this.s.toITestItem(o),this.s.toITestItem(b));this.s.getApiFor(o).listener=void 0,r.actual=b,r.expand=0,w&&(w.hasOwnProperty("tags")&&(this.z(b.tags,o.tags,v.toString()),delete w.tags),this.u(r,{op:4,update:w})),this.H(b,r,E);for(const[f,I]of n)this.s.getChildren(b).get(I.id)||this.N(l.$$I.joinToString(v,I.id));this.w(r.actual.uri)}z(b,E,v){const s=new Set(E.map(r=>r.id));for(const r of b)s.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:v,item:{tags:b.map(r=>(0,A.$cJ)(this.s.controllerId,r.id))}}}),s.forEach(this.D,this)}C(b){const E=this.j.get(b.id);E?E.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$cJ)(this.s.controllerId,b.id)}}))}D(b){const E=this.j.get(b);E&&!--E.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,A.$cJ)(this.s.controllerId,b)}))}F(b,E){this.s.getApiFor(b).parent=E&&E.actual!==this.root?E.actual:void 0}G(b,E,v){this.F(b,v);const s=this.s.getApiFor(b);s.parent=v?.actual,s.listener=r=>this.u(E,r),this.I(E)}H(b,E,v){this.G(b,E,v);for(const[s,r]of this.s.getChildren(b))this.y(r,E)}I(b){let E;this.h?b.resolveBarrier?E=b.resolveBarrier.isOpen()?3:2:E=b.actual.canResolveChildren?1:0:E=0,E!==b.expand&&(b.expand=E,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:E}}),E===1&&b.expandLevels!==void 0&&this.L(b))}J(b,E){if(E<0)return;const v=[];for(const[s,r]of this.s.getChildren(b.actual)){const n=this.expand(l.$$I.joinToString(b.fullId,r.id),E);(0,y.$Gg)(n)&&v.push(n)}if(v.length)return Promise.all(v).then(()=>{})}L(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const r=new y.$Sg;return r.open(),r}b.expand=2,this.M(b);const E=b.resolveBarrier=new y.$Sg,v=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let s;try{s=this.h(b.actual===this.root?void 0:b.actual)}catch(r){v(r)}return(0,y.$Gg)(s)?s.catch(v).then(()=>{E.open(),this.I(b)}):(E.open(),this.I(b)),b.resolveBarrier}M(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}N(b){const E=this.tree.get(b);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const v=[E];for(;v.length;){const s=v.pop();if(s){this.s.getApiFor(s.actual).listener=void 0;for(const r of s.actual.tags)this.D(r.id);this.tree.delete(s.fullId.toString());for(const[r,n]of this.s.getChildren(s.actual))v.push(this.tree.get(l.$$I.joinToString(s.fullId,n.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.$9L=p;class g extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.$0L=g;class d extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$$L=d;class t extends Error{constructor(b,E,v){super(`TestItem with ID "${b}" is from controller "${E}" and cannot be added as a child of an item from controller "${v}".`)}}e.$_L=t;const i=(c,b,E)=>{let v=new Map;return{get size(){return v.size},forEach(s,r){for(const n of v.values())s.call(r,n,this)},[Symbol.iterator](){return v.entries()},replace(s){const r=new Map,n=new Set(v.keys()),o={op:5,ops:[]};for(const w of s){if(!(w instanceof E))throw new d(w.id);const f=b(w).controllerId;if(f!==c.controllerId)throw new t(w.id,f,c.controllerId);if(r.has(w.id))throw new g(w.id);r.set(w.id,w),n.delete(w.id),o.ops.push({op:0,item:w})}for(const w of n.keys())o.ops.push({op:3,id:w});c.listener?.(o),v=r},add(s){if(!(s instanceof E))throw new d(s.id);v.set(s.id,s),c.listener?.({op:0,item:s})},delete(s){v.delete(s)&&c.listener?.({op:3,id:s})},get(s){return v.get(s)},toJSON(){return Array.from(v.values())}}};e.$aM=i}),define(Ae[101],Re([1,0,76]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$bM=void 0;const M=new WeakMap,C=(A,l)=>{const D={controllerId:l};return M.set(A,D),D};e.$bM=C;const T=A=>{const l=M.get(A);if(!l)throw new y.$$L(A?.id||"<unknown>");return l};e.$cM=T}),define(Ae[77],Re([1,0,13,2]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ob=e.$8ob=e.$7ob=e.$6ob=e.$5ob=void 0,e.$5ob="vscode-cdn.net",e.$6ob=`vscode-resource.${e.$5ob}`,e.$7ob=`'self' https://*.${e.$5ob}`;function C(l,D){return l.scheme===y.Schemas.http||l.scheme===y.Schemas.https?l:(D&&D.authority&&D.isRemote&&l.scheme===y.Schemas.file&&(l=M.URI.from({scheme:y.Schemas.vscodeRemote,authority:D.authority,path:l.path})),M.URI.from({scheme:y.Schemas.https,authority:`${l.scheme}+${T(l.authority)}.${e.$6ob}`,path:l.path,fragment:l.fragment,query:l.query}))}e.$8ob=C;function T(l){return l.replace(/./g,D=>{const $=D.charCodeAt(0);return $>=97&&$<=122||$>=65&&$<=90||$>=48&&$<=57?D:"-"+$.toString(16).padStart(4,"0")})}function A(l){return l.replace(/-([0-9a-f]{4})/g,(D,$)=>String.fromCharCode(parseInt($,16)))}e.$9ob=A}),define(Ae[198],Re([1,0,5,6,77]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=void 0;class T{constructor(l,D,$){this.d=l,this.e=D,this.f=$,this.a=0,this.b=new M.$Rc,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const R=D.getVisibleTextEditors();for(const k of this.c.values())R.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(l=>l.inset.dispose()),this.b.dispose()}createWebviewEditorInset(l,D,$,R,k){let a;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===l){a=b;break}if(!a)throw new Error("not a visible editor");const p=this,g=this.a++,d=new y.$Nd,t=new y.$Nd,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,C.$8ob)(b,p.f)}get cspSource(){return C.$7ob}set options(b){this.b=b,p.d.$setOptions(g,b)}get options(){return this.b}set html(b){this.a=b,p.d.$setHtml(g,b)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(b){return p.d.$postMessage(g,b)}},c=new class{constructor(){this.editor=l,this.line=D,this.height=$,this.webview=i,this.onDidDispose=t.event}dispose(){p.c.has(g)&&(p.c.delete(g),p.d.$disposeEditorInset(g),t.fire(),t.dispose(),d.dispose())}};return this.d.$createEditorInset(g,a.id,a.value.document.uri,D+1,$,R||{},k.identifier,k.extensionLocation),this.c.set(g,{editor:l,inset:c,onDidReceiveMessage:d}),c}$onDidDispose(l){const D=this.c.get(l);D&&D.inset.dispose()}$onDidReceiveMessage(l,D){this.c.get(l)?.onDidReceiveMessage.fire(D)}}e.$8cc=T}),define(Ae[199],Re([1,0,4]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=e.VariableKind=e.$5M=void 0,e.$5M=(0,y.$Ph)("configurationResolverService");var M;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator"})(M||(e.VariableKind=M={}));class C extends Error{constructor(A,l){super(l),this.variable=A}}e.$6M=C}),define(Ae[200],Re([1,0,19,73,15,24,22,90,165,199,16]),function(ye,e,y,M,C,T,A,l,D,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,g,d,t){this.h=new Map,this.a=p,this.b=g,this.g=d,t&&(this.c=t.then(i=>this.i(i)))}i(p){if(A.$j){const g=Object.create(null);return Object.keys(p).forEach(d=>{g[d.toLowerCase()]=p[d]}),g}return p}resolveWithEnvironment(p,g,d){return this.l({env:this.i(p),userHome:void 0},g?g.uri:void 0,d)}async resolveAsync(p,g){const d={env:await this.c,userHome:await this.g};return this.l(d,p?p.uri:void 0,g)}async j(p,g,d,t){const i=T.$7m(g);A.$j&&i.windows?Object.keys(i.windows).forEach(b=>i[b]=i.windows[b]):A.$k&&i.osx?Object.keys(i.osx).forEach(b=>i[b]=i.osx[b]):A.$l&&i.linux&&Object.keys(i.linux).forEach(b=>i[b]=i.linux[b]),delete i.windows,delete i.osx,delete i.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,p?p.uri:void 0,i,d,t)}async resolveAnyAsync(p,g,d){return this.j(p,g,d)}async resolveAnyMap(p,g,d){const t=new Map;return{newConfig:await this.j(p,g,d,t),resolvedVariables:t}}resolveWithInteractionReplace(p,g,d,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,g,d,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,g){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,g)}async l(p,g,d,t,i){if(C.$yf(d))return this.m(p,g,d,t,i);if(Array.isArray(d))return Promise.all(d.map(c=>this.l(p,g,c,t,i)));if(C.$Af(d)){const c=Object.create(null),b=await Promise.all(Object.keys(d).map(async E=>[await this.m(p,g,E,t,i),await this.l(p,g,d[E],t,i)]));for(const[E,v]of b)c[E]=v;return c}return d}m(p,g,d,t,i){return(0,R.$Te)(d,k.VARIABLE_REGEXP,async(c,b)=>{if(b.includes(k.VARIABLE_LHS))return c;let E=await this.o(p,c,b,g,t);return i?.set(b,E),E!==c&&C.$yf(E)&&E.match(k.VARIABLE_REGEXP)&&(E=await this.m(p,g,E,t,i)),E})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,g,d,t,i){let c;const b=d.split(":");b.length>1&&(d=b[0],c=b[1]);const E=r=>{const n=this.a.getFilePath();if(n)return(0,l.$rv)(n);throw new $.$6M(r,(0,D.localize)(0,null,g))},v=r=>{const n=E(r);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,l.$rv)(o)}throw new $.$6M(r,(0,D.localize)(1,null,g,y.$nc(n)))},s=r=>{if(c){const n=this.a.getFolderUri(c);if(n)return n;throw new $.$6M(r,(0,D.localize)(2,null,g,c))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new $.$6M(r,(0,D.localize)(3,null,g)):new $.$6M(r,(0,D.localize)(4,null,g))};switch(d){case"env":if(c){if(p.env){const r=p.env[A.$j?c.toLowerCase():c];if(C.$yf(r))return r}return""}throw new $.$6M($.VariableKind.Env,(0,D.localize)(5,null,g));case"config":if(c){const r=this.a.getConfigurationValue(t,c);if(C.$Hf(r))throw new $.$6M($.VariableKind.Config,(0,D.localize)(6,null,g,c));if(C.$Af(r))throw new $.$6M($.VariableKind.Config,(0,D.localize)(7,null,g,c));return r}throw new $.$6M($.VariableKind.Config,(0,D.localize)(8,null,g));case"command":return this.p($.VariableKind.Command,g,c,i,"command");case"input":return this.p($.VariableKind.Input,g,c,i,"input");case"extensionInstallFolder":if(c){const r=await this.a.getExtension(c);if(!r)throw new $.$6M($.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,g,c));return this.n(r.extensionLocation)}throw new $.$6M($.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,g));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,l.$rv)(this.n(s($.VariableKind.WorkspaceFolder)));case"cwd":return t||c?(0,l.$rv)(this.n(s($.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,l.$rv)(y.$nc(this.n(s($.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new $.$6M($.VariableKind.UserHome,(0,D.localize)(11,null,g))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new $.$6M($.VariableKind.LineNumber,(0,D.localize)(12,null,g))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new $.$6M($.VariableKind.SelectedText,(0,D.localize)(13,null,g))}case"file":return E($.VariableKind.File);case"fileWorkspaceFolder":return v($.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||c?y.$lc(this.n(s($.VariableKind.RelativeFile)),E($.VariableKind.RelativeFile)):E($.VariableKind.RelativeFile);case"relativeFileDirname":{const r=y.$mc(E($.VariableKind.RelativeFileDirname));if(t||c){const n=y.$lc(this.n(s($.VariableKind.RelativeFileDirname)),r);return n.length===0?".":n}return r}case"fileDirname":return y.$mc(E($.VariableKind.FileDirname));case"fileExtname":return y.$oc(E($.VariableKind.FileExtname));case"fileBasename":return y.$nc(E($.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=y.$nc(E($.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-y.$oc(r).length)}case"fileDirnameBasename":return y.$nc(y.$mc(E($.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||g}case"execInstallFolder":{const r=this.a.getAppRoot();return r||g}case"pathSeparator":return y.sep;default:try{const r=c?`${d}:${c}`:d;return this.p($.VariableKind.Unknown,g,r,i,void 0)}catch{return g}}}}p(p,g,d,t,i){if(d&&t){const c=i===void 0?t[d]:t[i+":"+d];if(typeof c=="string")return c;throw new $.$6M(p,(0,D.localize)(14,null,g))}return g}}e.$hN=k}),define(Ae[102],Re([1,0,4,99]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gC=e.$fC=e.OpenEditorContext=e.GroupsOrder=e.$eC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$dC=void 0,e.$dC=(0,y.$Ph)("editorGroupsService");var C;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var T;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(T||(e.GroupOrientation=T={}));var A;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var l;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(l||(e.GroupsArrangement=l={}));var D;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(D||(e.MergeGroupMode=D={}));function $(g){const d=g;return(0,M.$6D)(d?.editor)&&(0,M.$6D)(d?.replacement)}e.$eC=$;var R;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var k;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function a(g){const d=g;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.$fC=a;function p(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$gC=p}),define(Ae[201],Re([1,0,4,102]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kC=e.$jC=e.$iC=e.$hC=void 0,e.$hC=(0,y.$Ph)("editorService"),e.$iC=-1,e.$jC=-2;function C(T){const A=T;return typeof T=="number"||(0,M.$fC)(A)}e.$kC=C}),define(Ae[8],Re([1,0,18,26,122,202,50,28,116,68,67,24,15,2,45,78,94,101,99,75,46,57,201,7]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d,t,i,c,b,E,v,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$fM=e.$eM=e.MarkdownString=e.$dM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Ce){function Fe(H){const{selectionStartLineNumber:Me,selectionStartColumn:je,positionLineNumber:Je,positionColumn:Ve}=H,et=new r.$iK(Me-1,je-1),bt=new r.$iK(Je-1,Ve-1);return new r.$kK(et,bt)}Ce.to=Fe;function me(H){const{anchor:Me,active:je}=H;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}Ce.from=me})(n||(e.Selection=n={}));var o;(function(Ce){function Fe(H){if(!H)return;const{start:Me,end:je}=H;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}Ce.from=Fe;function me(H){if(!H)return;const{startLineNumber:Me,startColumn:je,endLineNumber:Je,endColumn:Ve}=H;return new r.$jK(Me-1,je-1,Je-1,Ve-1)}Ce.to=me})(o||(e.Range=o={}));var w;(function(Ce){function Fe(me){switch(me){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Ce.to=Fe})(w||(e.TokenType=w={}));var f;(function(Ce){function Fe(H){return new r.$iK(H.lineNumber-1,H.column-1)}Ce.to=Fe;function me(H){return{lineNumber:H.line+1,column:H.character+1}}Ce.from=me})(f||(e.Position=f={}));var I;(function(Ce){function Fe(Me,je,Je){return(0,y.$Hb)((0,y.$3b)(Me).map(Ve=>me(Ve,je,Je)))}Ce.from=Fe;function me(Me,je,Je){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Je?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:H(Me.scheme,je),pattern:st.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Je?.isBuiltin}}function H(Me,je){return je&&typeof Me=="string"?je.transformOutgoingScheme(Me):Me}})(I||(e.DocumentSelector=I={}));var S;(function(Ce){function Fe(H){switch(H){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Ce.from=Fe;function me(H){switch(H){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Ce.to=me})(S||(e.DiagnosticTag=S={}));var u;(function(Ce){function Fe(H){let Me;return H.code&&((0,a.$yf)(H.code)||(0,a.$Cf)(H.code)?Me=String(H.code):Me={value:String(H.code.value),target:H.code.target}),{...o.from(H.range),message:H.message,source:H.source,code:Me,severity:h.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(m.from),tags:Array.isArray(H.tags)?(0,y.$Hb)(H.tags.map(S.from)):void 0}}Ce.from=Fe;function me(H){const Me=new r.$vK(o.to(H),H.message,h.to(H.severity));return Me.source=H.source,Me.code=(0,a.$yf)(H.code)?H.code:H.code?.value,Me.relatedInformation=H.relatedInformation&&H.relatedInformation.map(m.to),Me.tags=H.tags&&(0,y.$Hb)(H.tags.map(S.to)),Me}Ce.to=me})(u||(e.Diagnostic=u={}));var m;(function(Ce){function Fe(H){return{...o.from(H.location.range),message:H.message,resource:H.location.uri}}Ce.from=Fe;function me(H){return new r.$uK(new r.$tK(H.resource,o.to(H)),H.message)}Ce.to=me})(m||(e.DiagnosticRelatedInformation=m={}));var h;(function(Ce){function Fe(H){switch(H){case r.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Fe;function me(H){switch(H){case t.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Ce.to=me})(h||(e.DiagnosticSeverity=h={}));var P;(function(Ce){function Fe(H){return typeof H=="number"&&H>=r.ViewColumn.One?H-1:H===r.ViewColumn.Beside?s.$jC:s.$iC}Ce.from=Fe;function me(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=me})(P||(e.ViewColumn=P={}));function W(Ce){return typeof Ce.range<"u"}function K(Ce){return Ce.length===0?!0:!!W(Ce[0])}e.$dM=K;var z;(function(Ce){function Fe(Ve){return Ve.map(Ce.from)}Ce.fromMany=Fe;function me(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function H(Ve){let et;if(me(Ve)){const{language:lt,value:gt}=Ve;et={value:"```"+lt+`
`+gt+"\n```\n"}}else r.$HK.isMarkdownString(Ve)?et={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?et={value:Ve}:et={value:""};const bt=Object.create(null);et.uris=bt;const zt=lt=>{try{let gt=p.URI.parse(lt,!0);gt=gt.with({query:Me(gt.query,bt)}),bt[lt]=gt}catch{}return""},Dt=new D.marked.Renderer;return Dt.link=zt,Dt.image=lt=>typeof lt=="string"?zt(A.$0j(lt).href):"",(0,D.marked)(et.value,{renderer:Dt}),et}Ce.from=H;function Me(Ve,et){if(!Ve)return Ve;let bt;try{bt=(0,$.$lh)(Ve)}catch{}if(!bt)return Ve;let zt=!1;return bt=(0,k.$9m)(bt,Dt=>{if(p.URI.isUri(Dt)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[lt]=Dt,zt=!0,lt}else return}),zt?JSON.stringify(bt):Ve}function je(Ve){const et=new r.$HK(Ve.value,Ve.supportThemeIcons);return et.isTrusted=Ve.isTrusted,et.supportHtml=Ve.supportHtml,et.baseUri=Ve.baseUri?p.URI.from(Ve.baseUri):void 0,et}Ce.to=je;function Je(Ve){if(Ve)return typeof Ve=="string"?Ve:Ce.from(Ve)}Ce.fromStrict=Je})(z||(e.MarkdownString=z={}));function j(Ce){return K(Ce)?Ce.map(Fe=>({range:o.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?z.fromMany(Fe.hoverMessage):Fe.hoverMessage?z.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Ce.map(Fe=>({range:o.from(Fe)}))}e.$eM=j;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?p.URI.file(Ce):Ce}e.$fM=O;var N;(function(Ce){function Fe(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?O(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Ce.from=Fe})(N||(e.ThemableDecorationAttachmentRenderOptions=N={}));var ie;(function(Ce){function Fe(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?N.from(me.before):void 0,after:me.after?N.from(me.after):void 0}}Ce.from=Fe})(ie||(e.ThemableDecorationRenderOptions=ie={}));var X;(function(Ce){function Fe(me){if(typeof me>"u")return me;switch(me){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Fe})(X||(e.DecorationRangeBehavior=X={}));var Ee;(function(Ce){function Fe(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?X.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?ie.from(me.light):void 0,dark:me.dark?ie.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?N.from(me.before):void 0,after:me.after?N.from(me.after):void 0}}Ce.from=Fe})(Ee||(e.DecorationRenderOptions=Ee={}));var Se;(function(Ce){function Fe(H){return{text:H.newText,eol:H.newEol&&Ye.from(H.newEol),range:o.from(H.range)}}Ce.from=Fe;function me(H){const Me=new r.$oK(o.to(H.range),H.text);return Me.newEol=typeof H.eol>"u"?void 0:Ye.to(H.eol),Me}Ce.to=me})(Se||(e.TextEdit=Se={}));var Pe;(function(Ce){function Fe(H,Me){const je={edits:[]};if(H instanceof r.$rK){const Je=new l.$Bc;for(const Ve of H._allEntries())Ve._type===1&&p.URI.isUri(Ve.to)&&Ve.from===void 0&&Je.add(Ve.to);for(const Ve of H._allEntries())if(Ve._type===1){let et;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?et={type:"base64",value:(0,M.$ve)(M.$be.wrap(Ve.options.contents))}:et={type:"dataTransferItem",id:Ve.options.contents._itemId}),je.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:et},metadata:Ve.metadata})}else Ve._type===2?je.edits.push({resource:Ve.uri,textEdit:Se.from(Ve.edit),versionId:Je.has(Ve.uri)?void 0:Me?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?je.edits.push({resource:Ve.uri,textEdit:{range:o.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Je.has(Ve.uri)?void 0:Me?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?je.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&je.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Me?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(ft.from)}})}return je}Ce.from=Fe;function me(H){const Me=new r.$rK,je=new l.$Ac;for(const Je of H.edits)if(Je.textEdit){const Ve=Je,et=p.URI.revive(Ve.resource),bt=o.to(Ve.textEdit.range),zt=Ve.textEdit.text,Dt=Ve.textEdit.insertAsSnippet;let lt;Dt?lt=r.$qK.replace(bt,new r.$sK(zt)):lt=r.$oK.replace(bt,zt);const gt=je.get(et);gt?gt.push(lt):je.set(et,[lt])}else Me.renameFile(p.URI.revive(Je.oldResource),p.URI.revive(Je.newResource),Je.options);for(const[Je,Ve]of je)Me.set(Je,Ve);return Me}Ce.to=me})(Pe||(e.WorkspaceEdit=Pe={}));var $e;(function(Ce){const Fe=Object.create(null);Fe[r.SymbolKind.File]=0,Fe[r.SymbolKind.Module]=1,Fe[r.SymbolKind.Namespace]=2,Fe[r.SymbolKind.Package]=3,Fe[r.SymbolKind.Class]=4,Fe[r.SymbolKind.Method]=5,Fe[r.SymbolKind.Property]=6,Fe[r.SymbolKind.Field]=7,Fe[r.SymbolKind.Constructor]=8,Fe[r.SymbolKind.Enum]=9,Fe[r.SymbolKind.Interface]=10,Fe[r.SymbolKind.Function]=11,Fe[r.SymbolKind.Variable]=12,Fe[r.SymbolKind.Constant]=13,Fe[r.SymbolKind.String]=14,Fe[r.SymbolKind.Number]=15,Fe[r.SymbolKind.Boolean]=16,Fe[r.SymbolKind.Array]=17,Fe[r.SymbolKind.Object]=18,Fe[r.SymbolKind.Key]=19,Fe[r.SymbolKind.Null]=20,Fe[r.SymbolKind.EnumMember]=21,Fe[r.SymbolKind.Struct]=22,Fe[r.SymbolKind.Event]=23,Fe[r.SymbolKind.Operator]=24,Fe[r.SymbolKind.TypeParameter]=25;function me(Me){return typeof Fe[Me]=="number"?Fe[Me]:6}Ce.from=me;function H(Me){for(const je in Fe)if(Fe[je]===Me)return Number(je);return r.SymbolKind.Property}Ce.to=H})($e||(e.SymbolKind=$e={}));var pe;(function(Ce){function Fe(H){switch(H){case r.SymbolTag.Deprecated:return 1}}Ce.from=Fe;function me(H){switch(H){case 1:return r.SymbolTag.Deprecated}}Ce.to=me})(pe||(e.SymbolTag=pe={}));var ue;(function(Ce){function Fe(H){return{name:H.name,kind:$e.from(H.kind),tags:H.tags&&H.tags.map(pe.from),containerName:H.containerName,location:Z.from(H.location)}}Ce.from=Fe;function me(H){const Me=new r.$yK(H.name,$e.to(H.kind),H.containerName,Z.to(H.location));return Me.tags=H.tags&&H.tags.map(pe.to),Me}Ce.to=me})(ue||(e.WorkspaceSymbol=ue={}));var oe;(function(Ce){function Fe(H){const Me={name:H.name||"!!MISSING: name!!",detail:H.detail,range:o.from(H.range),selectionRange:o.from(H.selectionRange),kind:$e.from(H.kind),tags:H.tags?.map(pe.from)??[]};return H.children&&(Me.children=H.children.map(Fe)),Me}Ce.from=Fe;function me(H){const Me=new r.$zK(H.name,H.detail,$e.to(H.kind),o.to(H.range),o.to(H.selectionRange));return(0,y.$Lb)(H.tags)&&(Me.tags=H.tags.map(pe.to)),H.children&&(Me.children=H.children.map(me)),Me}Ce.to=me})(oe||(e.DocumentSymbol=oe={}));var be;(function(Ce){function Fe(H){const Me=new r.$DK($e.to(H.kind),H.name,H.detail||"",p.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ce.to=Fe;function me(H,Me,je){if(Me=Me??H._sessionId,je=je??H._itemId,Me===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:je,name:H.name,detail:H.detail,kind:$e.from(H.kind),uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(pe.from)}}Ce.from=me})(be||(e.CallHierarchyItem=be={}));var _;(function(Ce){function Fe(me){return new r.$EK(be.to(me.from),me.fromRanges.map(H=>o.to(H)))}Ce.to=Fe})(_||(e.CallHierarchyIncomingCall=_={}));var B;(function(Ce){function Fe(me){return new r.$FK(be.to(me.to),me.fromRanges.map(H=>o.to(H)))}Ce.to=Fe})(B||(e.CallHierarchyOutgoingCall=B={}));var Z;(function(Ce){function Fe(H){return{range:H.range&&o.from(H.range),uri:H.uri}}Ce.from=Fe;function me(H){return new r.$tK(p.URI.revive(H.uri),o.to(H.range))}Ce.to=me})(Z||(e.location=Z={}));var ee;(function(Ce){function Fe(H){const Me=H,je=H;return{originSelectionRange:Me.originSelectionRange?o.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:je.uri,range:o.from(Me.targetRange?Me.targetRange:je.range),targetSelectionRange:Me.targetSelectionRange?o.from(Me.targetSelectionRange):void 0}}Ce.from=Fe;function me(H){return{targetUri:p.URI.revive(H.uri),targetRange:o.to(H.range),targetSelectionRange:H.targetSelectionRange?o.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?o.to(H.originSelectionRange):void 0}}Ce.to=me})(ee||(e.DefinitionLink=ee={}));var ve;(function(Ce){function Fe(H){return{range:o.from(H.range),contents:z.fromMany(H.contents)}}Ce.from=Fe;function me(H){return new r.$wK(H.contents.map(z.to),o.to(H.range))}Ce.to=me})(ve||(e.Hover=ve={}));var ge;(function(Ce){function Fe(H){return{range:o.from(H.range),expression:H.expression}}Ce.from=Fe;function me(H){return new r.$pL(o.to(H.range),H.expression)}Ce.to=me})(ge||(e.EvaluatableExpression=ge={}));var de;(function(Ce){function Fe(H){if(H instanceof r.$qL)return{type:"text",range:o.from(H.range),text:H.text};if(H instanceof r.$rL)return{type:"variable",range:o.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof r.$sL)return{type:"expression",range:o.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Fe;function me(H){switch(H.type){case"text":return{range:o.to(H.range),text:H.text};case"variable":return{range:o.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:o.to(H.range),expression:H.expression}}}Ce.to=me})(de||(e.InlineValue=de={}));var De;(function(Ce){function Fe(H){return{frameId:H.frameId,stoppedLocation:o.from(H.stoppedLocation)}}Ce.from=Fe;function me(H){return new r.$tL(H.frameId,o.to(H.stoppedLocation))}Ce.to=me})(De||(e.InlineValueContext=De={}));var re;(function(Ce){function Fe(H){return{range:o.from(H.range),kind:H.kind}}Ce.from=Fe;function me(H){return new r.$xK(o.to(H.range),H.kind)}Ce.to=me})(re||(e.DocumentHighlight=re={}));var le;(function(Ce){function Fe(me){switch(me){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Ce.to=Fe})(le||(e.CompletionTriggerKind=le={}));var ne;(function(Ce){function Fe(me){return{triggerKind:le.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Ce.to=Fe})(ne||(e.CompletionContext=ne={}));var ae;(function(Ce){function Fe(H){switch(H){case r.CompletionItemTag.Deprecated:return 1}}Ce.from=Fe;function me(H){switch(H){case 1:return r.CompletionItemTag.Deprecated}}Ce.to=me})(ae||(e.CompletionItemTag=ae={}));var fe;(function(Ce){const Fe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function me(je){return Fe.get(je)??9}Ce.from=me;const H=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Me(je){return H.get(je)??r.CompletionItemKind.Property}Ce.to=Me})(fe||(e.CompletionItemKind=fe={}));var Ie;(function(Ce){function Fe(me,H){const Me=new r.$NK(me.label);return Me.insertText=me.insertText,Me.kind=fe.to(me.kind),Me.tags=me.tags?.map(ae.to),Me.detail=me.detail,Me.documentation=A.$5j(me.documentation)?z.to(me.documentation):me.documentation,Me.sortText=me.sortText,Me.filterText=me.filterText,Me.preselect=me.preselect,Me.commitCharacters=me.commitCharacters,g.$ts.isIRange(me.range)?Me.range=o.to(me.range):typeof me.range=="object"&&(Me.range={inserting:o.to(me.range.insert),replacing:o.to(me.range.replace)}),Me.keepWhitespace=typeof me.insertTextRules>"u"?!1:!!(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Me.insertText=new r.$sK(me.insertText):(Me.insertText=me.insertText,Me.textEdit=Me.range instanceof r.$jK?new r.$oK(Me.range,Me.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Me.additionalTextEdits=me.additionalTextEdits.map(je=>Se.to(je))),Me.command=H&&me.command?H.fromInternal(me.command):void 0,Me}Ce.to=Fe})(Ie||(e.CompletionItem=Ie={}));var F;(function(Ce){function Fe(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:z.fromStrict(H.documentation)}}Ce.from=Fe;function me(H){return{label:H.label,documentation:A.$5j(H.documentation)?z.to(H.documentation):H.documentation}}Ce.to=me})(F||(e.ParameterInformation=F={}));var V;(function(Ce){function Fe(H){return{label:H.label,documentation:z.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(F.from):[],activeParameter:H.activeParameter}}Ce.from=Fe;function me(H){return{label:H.label,documentation:A.$5j(H.documentation)?z.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(F.to):[],activeParameter:H.activeParameter}}Ce.to=me})(V||(e.SignatureInformation=V={}));var G;(function(Ce){function Fe(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(V.from):[]}}Ce.from=Fe;function me(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(V.to):[]}}Ce.to=me})(G||(e.SignatureHelp=G={}));var J;(function(Ce){function Fe(me,H){const Me=new r.$MK(f.to(H.position),typeof H.label=="string"?H.label:H.label.map(q.to.bind(void 0,me)),H.kind&&x.to(H.kind));return Me.textEdits=H.textEdits&&H.textEdits.map(Se.to),Me.tooltip=A.$5j(H.tooltip)?z.to(H.tooltip):H.tooltip,Me.paddingLeft=H.paddingLeft,Me.paddingRight=H.paddingRight,Me}Ce.to=Fe})(J||(e.InlayHint=J={}));var q;(function(Ce){function Fe(me,H){const Me=new r.$LK(H.label);return Me.tooltip=A.$5j(H.tooltip)?z.to(H.tooltip):H.tooltip,d.Command.is(H.command)&&(Me.command=me.fromInternal(H.command)),H.location&&(Me.location=Z.to(H.location)),Me}Ce.to=Fe})(q||(e.InlayHintLabelPart=q={}));var x;(function(Ce){function Fe(H){return H}Ce.from=Fe;function me(H){return H}Ce.to=me})(x||(e.InlayHintKind=x={}));var ce;(function(Ce){function Fe(H){return{range:o.from(H.range),url:H.target,tooltip:H.tooltip}}Ce.from=Fe;function me(H){let Me;if(H.url)try{Me=typeof H.url=="string"?p.URI.parse(H.url,!0):p.URI.revive(H.url)}catch{}return new r.$SK(o.to(H.range),Me)}Ce.to=me})(ce||(e.DocumentLink=ce={}));var Ne;(function(Ce){function Fe(H){const Me=new r.$VK(H.label);return H.textEdit&&(Me.textEdit=Se.to(H.textEdit)),H.additionalTextEdits&&(Me.additionalTextEdits=H.additionalTextEdits.map(je=>Se.to(je))),Me}Ce.to=Fe;function me(H){return{label:H.label,textEdit:H.textEdit?Se.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Me=>Se.from(Me)):void 0}}Ce.from=me})(Ne||(e.ColorPresentation=Ne={}));var Ue;(function(Ce){function Fe(H){return new r.$TK(H[0],H[1],H[2],H[3])}Ce.to=Fe;function me(H){return[H.red,H.green,H.blue,H.alpha]}Ce.from=me})(Ue||(e.Color=Ue={}));var Qe;(function(Ce){function Fe(H){return{range:o.from(H.range)}}Ce.from=Fe;function me(H){return new r.$CK(o.to(H.range))}Ce.to=me})(Qe||(e.SelectionRange=Qe={}));var Ge;(function(Ce){function Fe(me){switch(me){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Ce.to=Fe})(Ge||(e.TextDocumentSaveReason=Ge={}));var xe;(function(Ce){function Fe(H){switch(H){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Fe;function me(H){switch(H){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Ce.to=me})(xe||(e.TextEditorLineNumbersStyle=xe={}));var Ye;(function(Ce){function Fe(H){if(H===r.EndOfLine.CRLF)return 1;if(H===r.EndOfLine.LF)return 0}Ce.from=Fe;function me(H){if(H===1)return r.EndOfLine.CRLF;if(H===0)return r.EndOfLine.LF}Ce.to=me})(Ye||(e.EndOfLine=Ye={}));var _e;(function(Ce){function Fe(me){if(typeof me=="object")return me.viewId;switch(me){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Fe})(_e||(e.ProgressLocation=_e={}));var it;(function(Ce){function Fe(H){const Me={start:H.start+1,end:H.end+1};return H.kind&&(Me.kind=tt.from(H.kind)),Me}Ce.from=Fe;function me(H){const Me={start:H.start-1,end:H.end-1};return H.kind&&(Me.kind=tt.to(H.kind)),Me}Ce.to=me})(it||(e.FoldingRange=it={}));var tt;(function(Ce){function Fe(H){if(H)switch(H){case r.FoldingRangeKind.Comment:return d.$it.Comment;case r.FoldingRangeKind.Imports:return d.$it.Imports;case r.FoldingRangeKind.Region:return d.$it.Region}}Ce.from=Fe;function me(H){if(H)switch(H.value){case d.$it.Comment.value:return r.FoldingRangeKind.Comment;case d.$it.Imports.value:return r.FoldingRangeKind.Imports;case d.$it.Region.value:return r.FoldingRangeKind.Region}}Ce.to=me})(tt||(e.FoldingRangeKind=tt={}));var ze;(function(Ce){function Fe(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?o.from(me.selection):void 0,override:typeof me.override=="boolean"?c.$SD.id:void 0}}Ce.from=Fe})(ze||(e.TextEditorOpenOptions=ze={}));var st;(function(Ce){function Fe(je){return je instanceof r.$dL?je.toJSON():typeof je=="string"?je:me(je)||H(je)?new r.$dL(je.baseUri??je.base,je.pattern).toJSON():je}Ce.from=Fe;function me(je){const Je=je;return Je?p.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function H(je){const Je=je;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Me(je){return typeof je=="string"?je:new r.$dL(p.URI.revive(je.baseUri),je.pattern)}Ce.to=Me})(st||(e.GlobPattern=st={}));var Y;(function(Ce){function Fe(me){if(me){if(Array.isArray(me))return me.map(Fe);if(typeof me=="string")return me;{const H=me;return{language:H.language,scheme:H.scheme,pattern:st.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ce.from=Fe})(Y||(e.LanguageSelector=Y={}));var Q;(function(Ce){function Fe(H){return!!H&&typeof H=="object"&&"documents"in H&&Array.isArray(H.documents)&&H.documents.every(Me=>Array.isArray(Me)&&Me.every(je=>je&&typeof je=="object"&&"uri"in je&&p.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Je=>Je instanceof r.$jK)))}Ce.is=Fe;function me(H){return{documents:H.documents.map(Me=>Me.map(je=>({uri:p.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Je=>o.from(Je))})))}}Ce.from=me})(Q||(e.MappedEditsContext=Q={}));var we;(function(Ce){function Fe(H){return{start:H.start,end:H.end}}Ce.from=Fe;function me(H){return new r.$EL(H.start,H.end)}Ce.to=me})(we||(e.NotebookRange=we={}));var Be;(function(Ce){function Fe(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ce.to=Fe;function me(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ce.from=me})(Be||(e.NotebookCellExecutionSummary=Be={}));var Oe;(function(Ce){function Fe(me){if(me===b.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(me===b.NotebookCellExecutionState.Pending)return;if(me===b.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}Ce.to=Fe})(Oe||(e.NotebookCellExecutionState=Oe={}));var Xe;(function(Ce){function Fe(H){switch(H){case r.NotebookCellKind.Markup:return b.CellKind.Markup;case r.NotebookCellKind.Code:default:return b.CellKind.Code}}Ce.from=Fe;function me(H){switch(H){case b.CellKind.Markup:return r.NotebookCellKind.Markup;case b.CellKind.Code:default:return r.NotebookCellKind.Code}}Ce.to=me})(Xe||(e.NotebookCellKind=Xe={}));var nt;(function(Ce){function Fe(H){const Me={metadata:H.metadata??Object.create(null),cells:[]};for(const je of H.cells)r.$FL.validate(je),Me.cells.push(ft.from(je));return Me}Ce.from=Fe;function me(H){const Me=new r.$GL(H.cells.map(ft.to));return(0,a.$Lf)(H.metadata)||(Me.metadata=H.metadata),Me}Ce.to=me})(nt||(e.NotebookData=nt={}));var ft;(function(Ce){function Fe(H){return{cellKind:Xe.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Be.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Pt.from):[]}}Ce.from=Fe;function me(H){return new r.$FL(Xe.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Pt.to):void 0,H.metadata,H.internalMetadata?Be.to(H.internalMetadata):void 0)}Ce.to=me})(ft||(e.NotebookCellData=ft={}));var wt;(function(Ce){function Fe(H){return{mime:H.mime,valueBytes:M.$be.wrap(H.data)}}Ce.from=Fe;function me(H){return new r.$HL(H.valueBytes.buffer,H.mime)}Ce.to=me})(wt||(e.NotebookCellOutputItem=wt={}));var Pt;(function(Ce){function Fe(H){return{outputId:H.id,items:H.items.map(wt.from),metadata:H.metadata}}Ce.from=Fe;function me(H){const Me=H.items.map(wt.to);return new r.$IL(Me,H.outputId,H.metadata)}Ce.to=me})(Pt||(e.NotebookCellOutput=Pt={}));var Zt;(function(Ce){function Fe(Me){return H(Me)?{include:st.from(Me.include)??void 0,exclude:st.from(Me.exclude)??void 0}:st.from(Me)??void 0}Ce.from=Fe;function me(Me){return H(Me)?{include:st.to(Me.include),exclude:st.to(Me.exclude)}:st.to(Me)}Ce.to=me;function H(Me){const je=Me;return je?!(0,a.$Hf)(je.include)&&!(0,a.$Hf)(je.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var Gt;(function(Ce){function Fe(me,H,Me){const je=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(je,Me),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Ce.from=Fe})(Gt||(e.NotebookStatusBarItem=Gt={}));var pt;(function(Ce){function Fe(me,H,Me){const je=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:H.toInternal(je,Me),label:me.label,description:me.description,detail:me.detail,documentation:me.documentation}}Ce.from=Fe})(pt||(e.NotebookKernelSourceAction=pt={}));var jt;(function(Ce){function Fe(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}Ce.from=Fe})(jt||(e.NotebookDocumentContentOptions=jt={}));var Nt;(function(Ce){function Fe(H){return{uri:H.uri,provides:H.provides}}Ce.from=Fe;function me(H){return new r.$KL(p.URI.revive(H.uri),H.provides)}Ce.to=me})(Nt||(e.NotebookRendererScript=Nt={}));var Bt;(function(Ce){function Fe(H){return{message:z.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:o.from(H.location.range),uri:H.location.uri}}}Ce.from=Fe;function me(H){const Me=new r.$QL(typeof H.message=="string"?H.message:z.to(H.message));return Me.actualOutput=H.actual,Me.expectedOutput=H.expected,Me.contextValue=H.contextValue,Me.location=H.location?Z.to(H.location):void 0,Me}Ce.to=me})(Bt||(e.TestMessage=Bt={}));var At;(function(Ce){Ce.namespace=v.$cJ,Ce.denamespace=v.$dJ})(At||(e.TestTag=At={}));var Rt;(function(Ce){function Fe(H){const Me=(0,i.$cM)(H).controllerId;return{extId:E.$$I.fromExtHostTestItem(H,Me).toString(),label:H.label,uri:p.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(je=>At.namespace(Me,je.id)),range:g.$ts.lift(o.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&z.fromStrict(H.error)||null}}Ce.from=Fe;function me(H){return{parent:void 0,error:void 0,id:E.$$I.fromString(H.extId).localId,label:H.label,uri:p.URI.revive(H.uri),tags:(H.tags||[]).map(Me=>{const{tagId:je}=At.denamespace(Me);return new r.$RL(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ce.toPlain=me})(Rt||(e.TestItem=Rt={})),function(Ce){function Fe(H){return{id:H.id}}Ce.from=Fe;function me(H){return new r.$RL(H.id)}Ce.to=me}(At||(e.TestTag=At={}));var Ot;(function(Ce){const Fe=(H,Me)=>{const je=[];for(const[Ve,et]of Me)E.$$I.compare(et.item.extId,Ve)===2&&(Me.delete(Ve),je.push(et));const Je={...Rt.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(et=>et.type===0).map(Bt.to)})),children:je.map(Ve=>Fe(Ve,Me))};for(const Ve of Je.children)Ve.parent=Je;return Je};function me(H){const Me=[],je=new Map;for(const Je of H.items){je.set(Je.item.extId,Je);const Ve=E.$$I.root(Je.item.extId);H.request.targets.some(et=>et.controllerId===Ve&&et.testIds.includes(Je.item.extId))&&Me.push(Je)}return{completedAt:H.completedAt,results:Me.map(Je=>Fe(Je,je))}}Ce.to=me})(Ot||(e.TestResults=Ot={}));var Wt;(function(Ce){function Fe(je){return{covered:je.covered,total:je.covered}}function me(je){return"line"in je?f.from(je):o.from(je)}function H(je){return"branches"in je?{count:je.executionCount,location:me(je.location),type:1,branches:je.branches.length?je.branches.map(Je=>({count:Je.executionCount,location:Je.location&&me(Je.location)})):void 0}:{type:0,count:je.executionCount,location:me(je.location)}}Ce.fromDetailed=H;function Me(je){return{uri:je.uri,statement:Fe(je.statementCoverage),branch:je.branchCoverage&&Fe(je.branchCoverage),function:je.functionCoverage&&Fe(je.functionCoverage),details:je.detailedCoverage?.map(H)}}Ce.fromFile=Me})(Wt||(e.TestCoverage=Wt={}));var Jt;(function(Ce){function Fe(me){switch(me){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Ce.to=Fe})(Jt||(e.CodeActionTriggerKind=Jt={}));var Kt;(function(Ce){function Fe(H){const Me=new r.$XL($e.to(H.kind),H.name,H.detail||"",p.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ce.to=Fe;function me(H,Me,je){if(Me=Me??H._sessionId,je=je??H._itemId,Me===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:je,kind:$e.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(pe.from)}}Ce.from=me})(Kt||(e.TypeHierarchyItem=Kt={}));var Vt;(function(Ce){function Fe(me){if(me)return{value:me.value,tooltip:me.tooltip}}Ce.from=Fe})(Vt||(e.ViewBadge=Vt={}));var Mt;(function(Ce){function Fe(je,Je,Ve){const et=Je.fileData;return et?new r.$9K(new r.$0K(et.name,p.URI.revive(et.uri),et.id,(0,T.$db)(()=>Ve(et.id)))):je===R.$Qr.uriList&&Je.uriListData?new r.$8K(Me(Je.uriListData)):new r.$8K(Je.asString)}Ce.to=Fe;async function me(je,Je){const Ve=await Je.asString();if(je===R.$Qr.uriList)return{asString:Ve,fileData:void 0,uriListData:H(Ve)};const et=Je.asFile();return{asString:Ve,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Ce.from=me;function H(je){return C.$3s.split(je).map(Je=>{if(Je.startsWith("#"))return Je;try{return p.URI.parse(Je)}catch{}return Je})}function Me(je){return C.$3s.create(je.map(Je=>typeof Je=="string"?Je:p.URI.revive(Je)))}})(Mt||(e.DataTransferItem=Mt={}));var ut;(function(Ce){function Fe(H,Me){const je=H.items.map(([Je,Ve])=>[Je,Mt.to(Je,Ve,Me)]);return new r.$$K(je)}Ce.toDataTransfer=Fe;async function me(H){const Me={items:[]},je=[];for(const[Je,Ve]of H)je.push((async()=>{Me.items.push([Je,await Mt.from(Je,Ve)])})());return await Promise.all(je),Me}Ce.from=me})(ut||(e.DataTransfer=ut={}));var ht;(function(Ce){function Fe(H){return{message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.to=Fe;function me(H){return{kind:"reply",message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.from=me})(ht||(e.ChatReplyFollowup=ht={}));var Lt;(function(Ce){function Fe(me){return typeof me=="string"?{title:me,message:me,kind:"reply"}:"commandId"in me?{kind:"command",title:me.title??"",commandId:me.commandId??"",when:me.when??"",args:me.args}:ht.from(me)}Ce.from=Fe})(Lt||(e.ChatFollowup=Lt={}));var qt;(function(Ce){function Fe(H){const Me=new r.$8L(kt.to(H.role),H.content);return Me.name=H.name,Me}Ce.to=Fe;function me(H){return{role:kt.from(H.role),content:H.content,name:H.name}}Ce.from=me})(qt||(e.ChatMessage=qt={}));var kt;(function(Ce){function Fe(H){switch(H){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Ce.to=Fe;function me(H){switch(H){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Ce.from=me})(kt||(e.ChatMessageRole=kt={}));var at;(function(Ce){function Fe(Me){const je={};for(const Je of Object.keys(Me))je[Je]=Me[Je].map(Ce.to);return je}Ce.objectTo=Fe;function me(Me){return{level:vt.to(Me.level),value:Me.value,description:Me.description}}Ce.to=me;function H(Me){return{level:vt.from(Me.level),value:Me.value,description:Me.description}}Ce.from=H})(at||(e.ChatVariable=at={}));var vt;(function(Ce){function Fe(H){switch(H){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Ce.to=Fe;function me(H){switch(H){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Ce.from=me})(vt||(e.ChatVariableLevel=vt={}));var Ht;(function(Ce){function Fe(me){switch(me){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted}}Ce.to=Fe})(Ht||(e.InteractiveEditorResponseFeedbackKind=Ht={}));var Ct;(function(Ce){function Fe(me){return"placeholder"in me&&"resolvedContent"in me?{placeholder:me.placeholder}:"responseId"in me?{requestId:me.responseId}:"content"in me?{content:typeof me.content=="string"?me.content:z.from(me.content)}:"documents"in me?{documents:me.documents.map(H=>({uri:H.uri,version:H.version,ranges:H.ranges.map(Me=>o.from(Me))}))}:"reference"in me?{reference:"uri"in me.reference?{uri:me.reference.uri,range:o.from(me.reference.range)}:me.reference}:"inlineReference"in me?{inlineReference:"uri"in me.inlineReference?{uri:me.inlineReference.uri,range:o.from(me.inlineReference.range)}:me.inlineReference,title:me.title}:me}Ce.from=Fe})(Ct||(e.ChatResponseProgress=Ct={}));var We;(function(Ce){function Fe(me,H,Me){return"terminalCommand"in me?{terminalCommand:me.terminalCommand}:"uri"in me?{uri:me.uri}:H.toInternal(me,Me)}Ce.from=Fe})(We||(e.TerminalQuickFix=We={}))}),define(Ae[203],Re([1,0,2,9,7,8,173]),function(ye,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=void 0;class l{constructor($,R,k,a={timeout:1500,errors:3}){this.c=$,this.d=R,this.f=k,this.g=a,this.a=new A.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent($){return(R,k,a)=>{const g={dispose:this.a.push([R,k,$])};return Array.isArray(a)&&a.push(g),g}}async $participateInSave($,R){const k=y.URI.revive($);let a=!1;const p=setTimeout(()=>a=!0,this.g.timeout),g=[];try{for(const d of[...this.a]){if(a)break;const t=this.d.getDocument(k),i=await this.h(d,{document:t,reason:T.TextDocumentSaveReason.to(R)});g.push(i)}}finally{clearTimeout(p)}return g}h([$,R,k],a){const p=this.b.get($);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(k,$,R,a).then(()=>!0,g=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const d=this.b.get($);this.b.set($,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i($,R,k,a){const p=[],g=Date.now(),{document:d,reason:t}=a,{version:i}=d,c=Object.freeze({document:d,reason:t,waitUntil(b){if(Object.isFrozen(p))throw(0,M.$8)("waitUntil can not be called async");p.push(Promise.resolve(b))}});try{R.apply(k,[c])}catch(b){return Promise.reject(b)}return Object.freeze(p),new Promise((b,E)=>{const v=setTimeout(()=>E(new Error("timeout")),this.g.timeout);return Promise.all(p).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(v),b(s)}).catch(s=>{clearTimeout(v),E(s)})}).then(b=>{const E={edits:[]};for(const v of b)if(Array.isArray(v)&&v.every(s=>s instanceof C.$oK))for(const{newText:s,newEol:r,range:n}of v)E.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:n&&T.Range.from(n),text:s,eol:r&&T.EndOfLine.from(r)}});if(E.edits.length!==0)return i===d.version?this.f.$tryApplyWorkspaceEdit(E):Promise.reject(new Error("concurrent_edits"))})}}e.$gcc=l}),define(Ae[204],Re([1,0,13,2,8,7,75]),function(ye,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=e.$tdc=void 0;class l{constructor(k,a,p,g){this.start=k,this.deletedCount=a,this.deletedItems=p,this.items=g}asApiEvent(){return{range:new T.$EL(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(k,a){return{EOL:a.eol,lines:a.source,languageId:a.language,uri:a.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,a,p){this.notebook=k,this.h=a,this.j=p,this.handle=p.handle,this.uri=M.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(C.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,a=this.h.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:a.document,get mime(){return k.g},set mime(g){k.g=g},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(p)}return this.f}setOutputs(k){this.a=k.map(C.NotebookCellOutput.to)}setOutputItems(k,a,p){const g=p.map(C.NotebookCellOutputItem.to),d=this.a.find(t=>t.id===k);if(d&&(a||(d.items.length=0),d.items.push(...g),d.items.length>1&&d.items.every(t=>A.$pI(t.mime)))){const t=new Map,i=[];d.items.forEach(c=>{let b;t.has(c.mime)?b=t.get(c.mime):(b=[],t.set(c.mime,b),i.push(c.mime)),b.push(c.data)}),d.items.length=0,i.forEach(c=>{const b=A.$qI(t.get(c));d.items.push({mime:c,data:b.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$tdc=D;class ${static{this.a=0}constructor(k,a,p,g,d){this.k=k,this.l=a,this.m=p,this.uri=g,this.handle=$.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,a={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===y.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(p){return p=k.n(p),k.b[p].apiCell},getCells(p){return(p?k.p(p):k.b).map(d=>d.apiCell)},save(){return k.q()}};this.e=Object.freeze(a)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,a,p){this.g=k.versionId,this.h=a,this.acceptDocumentPropertiesChanged({metadata:p});const g={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},d=[];for(const i of k.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,g.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,g.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),d.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),d.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),d.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),d.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),d.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<d.length;i++){const c=d[i],b=t.get(c.cell);if(b===void 0){const E=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});t.set(c.cell,E-1)}else g.cellChanges[b]={...g.cellChanges[b],...c}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let a=k.start|0,p=k.end|0;return a<0&&(a=0),p>this.b.length&&(p=this.b.length),k.with({start:a,end:p})}p(k){k=this.o(k);const a=[];for(let p=k.start;p<k.end;p++)a.push(this.b[p]);return a}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,a,p){if(this.j)return;const g=[],d=[],t=[];if(k.reverse().forEach(i=>{const b=i[2].map(s=>{const r=new D(this,this.l,s);return a||d.push(D.asModelAddData(this.apiNotebook,s)),r}),E=new l(i[0],i[1],[],b),v=this.b.splice(i[0],i[1],...b);for(const s of v)t.push(s.uri),E.deletedItems.push(s.apiCell);g.push(E)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:t}),p)for(const i of g)p.push(i.asApiEvent())}s(k,a,p,g){const d=this.b.splice(k,a);this.b.splice(p,0,...d);const t=[new l(k,a,d.map(i=>i.apiCell),[]),new l(p,0,[],d)];for(const i of t)g.push(i.asApiEvent())}t(k,a){this.b[k].setOutputs(a)}u(k,a,p,g){this.b[k].setOutputItems(a,p,g)}v(k,a){const p=this.b[k];p.apiCell.document.languageId!==a&&this.m.$acceptModelLanguageChanged(p.uri,a)}w(k,a){const p=this.b[k];p.apiCell.mime=a}x(k,a){this.b[k].setMetadata(a)}y(k,a){this.b[k].setInternalMetadata(a)}getCellFromApiCell(k){return this.b.find(a=>a.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(a=>a.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$udc=$}),define(Ae[205],Re([1,0,5,2,8,7]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;class A{constructor(D,$,R,k={timeout:1500,errors:3}){this.b=D,this.c=$,this.d=R,this.f=k,this.a=new y.$Pd}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return($,R,k)=>{const a=function(g){$.call(R,g)};return a.extension=D,this.a.event(a,void 0,k)}}async $participateInSave(D,$,R){const k=M.URI.revive(D),a=this.c.getNotebookDocument(k);if(!a)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:a.apiNotebook,reason:C.TextDocumentSaveReason.to($)},R,async(d,t)=>{const i=Date.now(),c=await await Promise.resolve(d);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!R.isCancellationRequested&&c&&(c instanceof T.$rK?p.push(c):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(p.length===0)return!0;const g={edits:[]};for(const d of p){const{edits:t}=C.WorkspaceEdit.from(d);g.edits=g.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(g)}}e.$Udc=A}),define(Ae[103],Re([1,0,9,8,7]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=void 0;class T{static{this.apiEditorsToExtHost=new WeakMap}constructor(l,D,$,R,k,a){this.id=l,this.f=D,this.notebookData=$,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=R,this.c=a}get apiEditor(){if(!this.e){const l=this;this.e={get notebook(){return l.notebookData.apiNotebook},get selection(){return l.a[0]},set selection(D){this.selections=[D]},get selections(){return l.a},set selections(D){if(!Array.isArray(D)||!D.every(C.$EL.isNotebookRange))throw(0,y.$7)("selections");l.a=D,l.g(D)},get visibleRanges(){return l.b},revealRange(D,$){l.f.$tryRevealRange(l.id,M.NotebookRange.from(D),$??C.NotebookEditorRevealType.Default)},get viewColumn(){return l.c}},T.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(l){this.d=l}_acceptVisibleRanges(l){this.b=l}_acceptSelections(l){this.a=l}g(l){this.f.$trySetSelections(this.id,l.map(M.NotebookRange.from))}_acceptViewColumn(l){this.c=l}}e.$vdc=T}),define(Ae[206],Re([1,0,9,5,14,8]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;let A=class{constructor(D,$){this.c=D,this.d=$,this.a=new M.$Nd({onListenerError:y.$2}),this.b=new M.$Nd({onListenerError:y.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,$);const R=this.d.getEditorById(D);$.visibleRanges&&R._acceptVisibleRanges($.visibleRanges.ranges.map(T.NotebookRange.to)),$.selections&&R._acceptSelections($.selections.selections.map(T.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const $ in D)this.d.getEditorById($)._acceptViewColumn(T.ViewColumn.to(D[$]))}};e.$Ndc=A,e.$Ndc=A=qe([Ke(0,C.$0i)],A)}),define(Ae[207],Re([1,0,8,51,152,20,65,9]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=void 0;class D{constructor(a){this.b=0,this.c=new Map,this.a=a}async withProgress(a,p,g){const d=this.b++,{title:t,location:i,cancellable:c}=p,b={label:(0,C.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this.a.$startProgress(d,{location:y.ProgressLocation.from(i),title:t,source:b,cancellable:c},a.isUnderDevelopment?void 0:a.identifier.value).catch(l.$2),this.d(d,g,!!c)}d(a,p,g){let d;g&&(d=new T.$Xd,this.c.set(a,d));const t=c=>{this.a.$progressEnd(c),this.c.delete(c),d?.dispose()};let i;try{i=p(new R(this.a,a),g&&d?d.token:T.CancellationToken.None)}catch(c){throw t(a),c}return i.then(c=>t(a),c=>t(a)),i}$acceptProgressCanceled(a){const p=this.c.get(a);p&&(p.cancel(),this.c.delete(a))}}e.$Rcc=D;function $(k,a){return k.message=a.message,typeof a.increment=="number"&&(typeof k.increment=="number"?k.increment+=a.increment:k.increment=a.increment),k}class R extends M.$5u{constructor(a,p){super(g=>this.throttledReport(g)),this.i=a,this.j=p}throttledReport(a){this.i.$progressReport(this.j,a)}}qe([(0,A.$jh)(100,(k,a)=>$(k,a),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ae[104],Re([1,0,45,101,46,76,57,8,2]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.$tM=e.$sM=void 0;const $=(b,E,v,s)=>{let r=E;return{enumerable:!0,configurable:!1,get(){return r},set(n){if(!v(r,n)){const o=r;r=n,b.listener?.(s(n,o))}}}},R=(b,E)=>b===E,k={range:(b,E)=>b===E?!0:!b||!E?!1:b.isEqual(E),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(b,E)=>!(b.length!==E.length||b.some(v=>!E.find(s=>v.id===s.id)))},a=b=>E=>({op:4,update:b(E)}),p=(b,E)=>({range:(()=>{let v;const s=a(r=>({range:y.$ts.lift(l.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return v},set(r){b.listener?.({op:6}),k.range(v,r)||(v=r,b.listener?.(s(r)))}}})(),label:$(b,E,k.label,a(v=>({label:v}))),description:$(b,void 0,k.description,a(v=>({description:v}))),sortText:$(b,void 0,k.sortText,a(v=>({sortText:v}))),canResolveChildren:$(b,!1,k.canResolveChildren,v=>({op:2,state:v})),busy:$(b,!1,k.busy,a(v=>({busy:v}))),error:$(b,void 0,k.error,a(v=>({error:l.MarkdownString.fromStrict(v)||null}))),tags:$(b,[],k.tags,(v,s)=>({op:1,new:v.map(l.TestTag.from),old:s.map(l.TestTag.from)}))}),g=b=>{const E=C.$$I.fromString(b.extId),v=new t(E.controllerId,E.localId,b.label,D.URI.revive(b.uri)||void 0);return v.range=l.Range.to(b.range||void 0),v.description=b.description||void 0,v.sortText=b.sortText||void 0,v.tags=b.tags.map(s=>l.TestTag.to({id:(0,A.$dJ)(s).tagId})),v},d=b=>{let E;for(const v of b.tests){const s=g(v.item);(0,M.$cM)(s).parent=E,E=s}return E};e.$sM=d;class t{constructor(E,v,s,r){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const n=(0,M.$bM)(this,E);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof i?void 0:n.parent}},children:{value:(0,T.$aM)(n,M.$cM,t),enumerable:!0,writable:!1},...p(n,s)})}}e.$tM=t;class i extends t{constructor(E,v){super(E,E,v,void 0),this._isRoot=!0}}e.$uM=i;class c extends T.$9L{constructor(E,v,s){super({controllerId:E,getDocumentVersion:r=>r&&s.getDocument(r)?.version,getApiFor:M.$cM,getChildren:r=>r.children,root:new i(E,v),toITestItem:l.TestItem.from})}}e.$vM=c}),define(Ae[105],Re([1,0,52,9,88,8,7]),function(ye,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pM=e.$oM=e.$nM=void 0;class l{static{this.c=new C.$lM("TextEditorDecorationType")}constructor(a,p,g){const d=l.c.nextId();a.$registerTextEditorDecorationType(p.identifier,d,T.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:d,dispose(){a.$removeTextEditorDecorationType(d)}})}}e.$nM=l;class D{constructor(a,p){this.g=[],this.h=void 0,this.j=!1,this.c=a,this.d=a.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(a,p){this.k();let g=null;if(a instanceof A.$iK)g=new A.$jK(a,a);else if(a instanceof A.$jK)g=a;else throw new Error("Unrecognized location");this.l(g,p,!1)}insert(a,p){this.k(),this.l(new A.$jK(a,a),p,!0)}delete(a){this.k();let p=null;if(a instanceof A.$jK)p=a;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(a,p,g){const d=this.c.validateRange(a);this.g.push({range:d,text:p,forceMoveMarkers:g})}setEndOfLine(a){if(this.k(),a!==A.EndOfLine.LF&&a!==A.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=a}}class ${constructor(a,p,g,d){this.c=a,this.d=p,this._accept(g),this.e=d;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(a){this.f=a.tabSize,this.g=a.indentSize,this.h=a.insertSpaces,this.j=a.cursorStyle,this.k=T.TextEditorLineNumbersStyle.to(a.lineNumbers)}l(a){if(a==="auto")return"auto";if(typeof a=="number"){const p=Math.floor(a);return p>0?p:null}if(typeof a=="string"){const p=parseInt(a,10);return isNaN(p)?null:p>0?p:null}return null}m(a){const p=this.l(a);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const p=Math.floor(a);return p>0?p:null}if(typeof a=="string"){const p=parseInt(a,10);return isNaN(p)?null:p>0?p:null}return null}o(a){const p=this.n(a);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(a){return a==="auto"?"auto":a==="false"?!1:!!a}q(a){const p=this.p(a);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(a){this.j!==a&&(this.j=a,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:a})))}t(a){this.k!==a&&(this.k=a,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:T.TextEditorLineNumbersStyle.from(a)})))}assign(a){const p={};let g=!1;if(typeof a.tabSize<"u"){const d=this.l(a.tabSize);d==="auto"?(g=!0,p.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,g=!0,p.tabSize=d)}if(typeof a.indentSize<"u"){const d=this.n(a.indentSize);d==="tabSize"?(g=!0,p.indentSize=d):typeof d=="number"&&this.g!==d&&(this.g=d,g=!0,p.indentSize=d)}if(typeof a.insertSpaces<"u"){const d=this.p(a.insertSpaces);d==="auto"?(g=!0,p.insertSpaces=d):this.h!==d&&(this.h=d,g=!0,p.insertSpaces=d)}typeof a.cursorStyle<"u"&&this.j!==a.cursorStyle&&(this.j=a.cursorStyle,g=!0,p.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this.k!==a.lineNumbers&&(this.k=a.lineNumbers,g=!0,p.lineNumbers=T.TextEditorLineNumbersStyle.from(a.lineNumbers)),g&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(a,p){p.catch(g=>{this.e.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this.e.warn(g)})}}e.$oM=$;class R{constructor(a,p,g,d,t,i,c,b){this.id=a,this.j=p,this.k=g,this.g=!1,this.h=new Set,this.c=t,this.d=new $(this.j,this.id,i,g),this.e=c,this.f=b;const E=this;this.value=Object.freeze({get document(){return d.value},set document(v){throw new M.$9("document")},get selection(){return E.c&&E.c[0]},set selection(v){if(!(v instanceof A.$kK))throw(0,M.$7)("selection");E.c=[v],E.l()},get selections(){return E.c},set selections(v){if(!Array.isArray(v)||v.some(s=>!(s instanceof A.$kK)))throw(0,M.$7)("selections");E.c=v,E.l()},get visibleRanges(){return E.e},set visibleRanges(v){throw new M.$9("visibleRanges")},get options(){return E.d.value},set options(v){E.g||E.d.assign(v)},get viewColumn(){return E.f},set viewColumn(v){throw new M.$9("viewColumn")},edit(v,s={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new D(d.value,s);return v(r),E.m(r)},insertSnippet(v,s,r={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!s||Array.isArray(s)&&s.length===0)n=E.c.map(o=>T.Range.from(o));else if(s instanceof A.$iK){const{lineNumber:o,column:w}=T.Position.from(s);n=[{startLineNumber:o,startColumn:w,endLineNumber:o,endColumn:w}]}else if(s instanceof A.$jK)n=[T.Range.from(s)];else{n=[];for(const o of s)if(o instanceof A.$jK)n.push(T.Range.from(o));else{const{lineNumber:w,column:f}=T.Position.from(o);n.push({startLineNumber:w,startColumn:f,endLineNumber:w,endColumn:f})}}return p.$tryInsertSnippet(a,d.value.version,v.value,n,r)},setDecorations(v,s){const r=s.length===0;r&&!E.h.has(v.key)||(r?E.h.delete(v.key):E.h.add(v.key),E.n(()=>{if(T.$dM(s))return p.$trySetDecorations(a,v.key,T.$eM(s));{const n=new Array(4*s.length);for(let o=0,w=s.length;o<w;o++){const f=s[o];n[4*o]=f.start.line+1,n[4*o+1]=f.start.character+1,n[4*o+2]=f.end.line+1,n[4*o+3]=f.end.character+1}return p.$trySetDecorationsFast(a,v.key,n)}}))},revealRange(v,s){E.n(()=>p.$tryRevealRange(a,T.Range.from(v),s||A.TextEditorRevealType.Default))},show(v){p.$tryShowEditor(a,T.ViewColumn.from(v))},hide(){p.$tryHideEditor(a)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(a){(0,y.ok)(!this.g),this.d._accept(a)}_acceptVisibleRanges(a){(0,y.ok)(!this.g),this.e=a}_acceptViewColumn(a){(0,y.ok)(!this.g),this.f=a}_acceptSelections(a){(0,y.ok)(!this.g),this.c=a}async l(){const a=this.c.map(T.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,a)),this.value}m(a){const p=a.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const g=p.edits.map(t=>t.range);g.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=g.length-1;t<i;t++){const c=g[t].end;if(g[t+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=p.edits.map(t=>({range:T.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,d,{setEndOfLine:typeof p.setEndOfLine=="number"?T.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(a){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$pM=R}),define(Ae[208],Re([1,0,4,171]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJ=void 0,e.$CJ=(0,y.$Qh)(M.$Wh)}),define(Ae[106],Re([1,0,21,5,19,6]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l4b=e.$k4b=e.$j4b=e.$i4b=e.$h4b=e.$g4b=void 0;class A{constructor(i,c){this.versionId=i,this.removedDueToLooping=c}}e.$g4b=A;class l{static isHostExtension(i,c,b){if(c.getExtensionDescription(i))return!1;const E=b.getExtensionDescription(i);return E?!!((E.main||E.browser)&&E.api==="none"):!1}constructor(i,c){this.j=i,this.c=new M.$Nd,this.onDidChange=this.c.event,this.d=0,this.e=c,this.k()}k(){this.e.sort(g),this.f=new y.$8l,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const c=this.j.readActivationEvents(i);if(Array.isArray(c))for(let b of c)b==="onUri"&&(b=`onUri:${y.$6l.toKey(i.identifier)}`),this.h.has(b)||this.h.set(b,[]),this.h.get(b).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,c){this.e=d(this.e,c),this.e=this.e.concat(i);const b=l.l(this.e);return this.e=d(this.e,b.map(E=>E.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,b)}static l(i){const c=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,n){this.addNode(r),this.addNode(n),this.c.has(r)?this.c.get(r).push(n):this.c.set(r,[n])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,n){const o=c.getArcs(r);for(let w=0;w<o.length;w++)if(!n.has(o[w]))return!1;return!0}getNodes(){return this.e}},b=new y.$8l;for(const r of i)if(b.set(r.identifier,r),r.extensionDependencies)for(const n of r.extensionDependencies)c.addArc(y.$6l.toKey(r.identifier),y.$6l.toKey(n));const E=new Set;c.getNodes().filter(r=>c.getArcs(r).length===0).forEach(r=>E.add(r));const v=c.getNodes().filter(r=>!E.has(r));let s;do{s=!1;for(let r=0;r<v.length;r++){const n=v[r];c.hasOnlyGoodArcs(n,E)&&(v.splice(r,1),r--,E.add(n),s=!0)}}while(s);return v.map(r=>b.get(r))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const c=this.h.get(i);return c?c.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const c=this.f.get(i);return c||void 0}getExtensionDescriptionByUUID(i){for(const c of this.g)if(c.uuid===i)return c}getExtensionDescriptionByIdOrUUID(i,c){return this.getExtensionDescription(i)??(c?this.getExtensionDescriptionByUUID(c):void 0)}}e.$h4b=l;class D{constructor(i,c){this.versionId=i,this.extensions=c}}e.$i4b=D,e.$j4b={readActivationEvents:t=>t.activationEvents};class ${constructor(i){this.d=new a,this.c=new l(i,[])}async acquireLock(i){const c=await this.d.acquire(i);return new R(this,c)}deltaExtensions(i,c,b){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(c,b)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,c){return this.c.getExtensionDescriptionByIdOrUUID(i,c)}}e.$k4b=$;class R extends T.$Sc{constructor(i,c){super(),this.f=i,this.c=!1,this.B(c)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$l4b=R;class k{constructor(i){this.name=i,this.promise=new Promise((c,b)=>{this.c=c})}resolve(i){this.c(i)}}class a{constructor(){this.c=[],this.d=!1}async acquire(i){const c=new k(i);return this.c.push(c),this.e(),c.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let c=!0;const b=setTimeout(()=>{c&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),E=()=>{c&&(clearTimeout(b),c=!1,this.d=!1,this.e())};i.resolve((0,T.$Qc)(E))}}var p;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(p||(p={}));function g(t,i){const c=t.isBuiltin?0:t.isUnderDevelopment?2:1,b=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(c!==b)return c-b;const E=C.$gc.basename(t.extensionLocation.path),v=C.$gc.basename(i.extensionLocation.path);return E<v?-1:E>v?1:0}function d(t,i){const c=new y.$7l(i);return t.filter(b=>!c.has(b.identifier))}}),define(Ae[79],Re([1,0,26]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$cm=e.$bm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function($){$[$.Desktop=1]="Desktop",$[$.Web=2]="Web"})(M||(e.UIKind=M={}));var C;(function($){$[$.VersionMismatch=55]="VersionMismatch",$[$.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var T;(function($){$[$.Initialized=0]="Initialized",$[$.Ready=1]="Ready",$[$.Terminate=2]="Terminate"})(T||(e.MessageType=T={}));function A($){const R=y.$be.alloc(1);switch($){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$bm=A;function l($,R){if($.byteLength!==1)return!1;switch($.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$cm=l;var D;(function($){$.Start="START_NATIVE_LOG",$.End="END_NATIVE_LOG"})(D||(e.NativeLogMarkers=D={}))}),define(Ae[58],Re([1,0,4,5,14,27,79,53,54,24,2,6,154]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=e.$zM=e.$yM=e.$xM=void 0;let p=class extends k.$Sc{constructor(i,c){super(),this.s=i,this.t=c,this.a=this.B(new M.$Nd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Nd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=c.createLogger(this.m,{id:D.$po,name:(0,a.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(b=>{(0,C.$_i)(b)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,c,b){const E=this.getTelemetryDetails(),v=new g(c,b,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:E.isUsageEnabled,isErrorsEnabled:E.isErrorsEnabled}),s=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...s,v]),v.apiTelemetryLogger}$initializeTelemetryLevel(i,c,b){this.f=i,this.g=c,this.c=b??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const c=Object.create(null);switch(c["common.extname"]=`${i.publisher}.${i.name}`,c["common.extversion"]=i.version,c["common.vscodemachineid"]=this.s.telemetryInfo.machineId,c["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,c["common.vscodeversion"]=this.s.version,c["common.isnewappinstall"]=d(this.s.telemetryInfo.firstSessionDate),c["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:c["common.uikind"]="web";break;case A.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,l.$Vk)((0,D.$wo)(this.s.remote.authority)),c}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const c=this.getTelemetryDetails();this.r.forEach((b,E)=>{const v=b.filter(s=>!s.isDisposed);v.length===0?this.r.delete(E):this.r.set(E,v)}),this.r.forEach(b=>{for(const E of b)E.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,c){const E=this.r.get(i.value)?.filter(s=>!s.isDisposed);if(!E)return this.r.delete(i.value),!1;let v=!1;for(const s of E)s.ignoreUnhandledExtHostErrors||(s.logError(c),v=!0);return v}};e.$xM=p,e.$xM=p=qe([Ke(0,T.$wM),Ke(1,C.$$i)],p);class g{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,c,b,E,v,s,r){this.g=b,this.h=E,this.i=v,this.j=s,this.a=new M.$Nd,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(i,c){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let c="properties"in i?i.properties??{}:i;return c=(0,D.$zo)(c,[]),this.c&&(c=(0,$.$0m)(c,this.c)),this.b||(c=(0,$.$0m)(c,this.j)),"properties"in i?i.properties=c:i=c,i}k(i,c){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(i,c),this.h.trace(i,c))}logUsage(i,c){this.d.isUsageEnabled&&this.k(i,c)}logError(i,c){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,c);else{const b={name:i.name,message:i.message,stack:i.stack,cause:i.cause},E=(0,D.$zo)(b,[]),v=new Error(E.message,{cause:E.cause});v.stack=E.stack,v.name=E.name,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f.sendErrorData(v,c),this.h.trace("exception",c)}}get apiTelemetryLogger(){if(!this.e){const i=this,c={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$yM=g;function d(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$zM=d,e.$AM=(0,y.$Ph)("IExtHostTelemetry")}),define(Ae[25],Re([1,0,5,2,180,98,21,4]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iF=e.$hF=e.$gF=e.ActivationKind=e.$fF=e.$eF=e.$dF=e.$cF=e.$bF=e.ExtensionHostStartup=e.$aF=e.$_E=e.$$E=e.$0E=void 0,e.$0E=Object.freeze({identifier:new A.$6l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$$E="extensions.webWorker",e.$_E=(0,l.$Ph)("extensionService");class D{constructor(v){this.dependency=v}}e.$aF=D;var $;(function(E){E[E.EagerAutoStart=1]="EagerAutoStart",E[E.EagerManualStart=2]="EagerManualStart",E[E.Lazy=3]="Lazy"})($||(e.ExtensionHostStartup=$={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(v,s,r){this.c=v,this.d=s.slice(0),this.e=r.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:T.$UE.createActivationEventsMap(this.d)}}set(v,s,r){if(this.c>v)throw new Error(`ExtensionHostExtensions: invalid versionId ${v} (current: ${this.c})`);const n=[],o=[],w=[],f=[],I=k(this.d),S=k(s),u=(K,z)=>K.extensionLocation.toString()===z.extensionLocation.toString()||K.isBuiltin===z.isBuiltin||K.isUserBuiltin===z.isUserBuiltin||K.isUnderDevelopment===z.isUnderDevelopment;for(const K of this.d){const z=S.get(K.identifier);if(!z){n.push(K.identifier),I.delete(K.identifier);continue}if(!u(K,z)){n.push(K.identifier),I.delete(K.identifier);continue}}for(const K of s){const z=I.get(K.identifier);if(!z){o.push(K);continue}if(!u(z,K)){n.push(z.identifier),I.delete(z.identifier);continue}}const m=new A.$7l(this.e),h=new A.$7l(r);for(const K of this.e)h.has(K)||w.push(K);for(const K of r)m.has(K)||f.push(K);const P=T.$UE.createActivationEventsMap(o),W={versionId:v,toRemove:n,toAdd:o,addActivationEvents:P,myToRemove:w,myToAdd:f};return this.delta(W),W}delta(v){if(this.c>=v.versionId)return null;const{toRemove:s,toAdd:r,myToRemove:n,myToAdd:o}=v,w=new A.$7l(s),f=new A.$7l(n);for(let I=0;I<this.d.length;I++)w.has(this.d[I].identifier)&&(this.d.splice(I,1),I--);for(let I=0;I<this.e.length;I++)f.has(this.e[I])&&(this.e.splice(I,1),I--);for(const I of r)this.d.push(I);for(const I of o)this.e.push(I);return v}containsExtension(v){for(const s of this.e)if(A.$6l.equals(s,v))return!0;return!1}}e.$bF=R;function k(E){const v=new A.$8l;for(const s of E)v.set(s.identifier,s);return v}function a(E,v){return E.enabledApiProposals?E.enabledApiProposals.includes(v):!1}e.$cF=a;function p(E,v){if(!a(E,v))throw new Error(`Extension '${E.identifier.value}' CANNOT use API proposal: ${v}.
Its package.json#enabledApiProposals-property declares: ${E.enabledApiProposals?.join(", ")??"[]"} but NOT ${v}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.$dF=p;class g{constructor(v,s,r,n){this.codeLoadingTime=v,this.activateCallTime=s,this.activateResolvedTime=r,this.activationReason=n}}e.$eF=g;class d{constructor(v,s){this.description=v,this.value=s}}e.$fF=d;var t;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,C.$Fo)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation,targetPlatform:E.targetPlatform,validations:[],isValid:!0}}e.$gF=i;function c(E,v){return{identifier:new A.$6l((0,C.$Do)(E.manifest.publisher,E.manifest.name)),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!v,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid,targetPlatform:E.targetPlatform}}e.$hF=c;class b{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(v){return Promise.resolve(void 0)}activationEventIsDone(v){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(v,s){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$iF=b}),define(Ae[209],Re([1,0,9,106,21,25,14,12]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=e.$lcc=e.$kcc=e.$jcc=e.$icc=e.$hcc=void 0;class D{static{this.NONE=new D(!1,-1,-1,-1)}constructor(i,c,b,E){this.startup=i,this.codeLoadingTime=c,this.activateCallTime=b,this.activateResolvedTime=E}}e.$hcc=D;class ${constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,c){return i===-1||c===-1?-1:c-i}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$icc=$;class R{constructor(i,c,b,E,v,s){this.activationFailed=i,this.activationFailedError=c,this.activationTimes=b,this.module=E,this.exports=v,this.subscriptions=s}}e.$jcc=R;class k extends R{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$kcc=k;class a extends R{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$lcc=a;class p extends R{constructor(i){super(!0,i,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=class{constructor(i,c,b,E){this.g=E,this.a=i,this.b=c,this.c=b,this.d=new C.$8l,this.f=Object.create(null)}dispose(){for(const[i,c]of this.d)c.dispose()}async waitForActivatingExtensions(){const i=[];for(const[c,b]of this.d)i.push(b.wait());await Promise.all(i)}isActivated(i){const c=this.d.get(i);return!!(c&&c.value)}getActivatedExtension(i){const c=this.d.get(i);if(!c||!c.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return c.value}async activateByEvent(i,c){if(this.f[i])return;const b=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(b.map(E=>({id:E.identifier,reason:{startup:c,extensionId:E.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,c){const b=this.a.getExtensionDescription(i);if(!b)throw new Error(`Extension '${i}' is not known`);return this.h([{id:b.identifier,reason:c}])}async h(i){const c=i.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(c.map(b=>b.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const c=this.a.getExtensionDescription(i.id);if(!c){const v=new Error(`Cannot activate unknown extension '${i.id.value}'`),s=this.k(i,null,[],new p(v));return this.c.onExtensionActivationError(i.id,v,new T.$aF(i.id.value)),s}const b=[],E=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const v of E){if(this.m(v))continue;const s=this.d.get(v);if(s){b.push(s);continue}if(this.l(v)){b.push(this.j({id:this.b.getExtensionDescription(v).identifier,reason:i.reason}));continue}const r=this.a.getExtensionDescription(v);if(r){if(!r.main&&!r.browser)continue;b.push(this.j({id:r.identifier,reason:i.reason}));continue}const n=c.displayName||c.identifier.value,o=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${v}'`),w=this.k(i,c.displayName,[],new p(o));return this.c.onExtensionActivationError(c.identifier,o,new T.$aF(v)),w}return this.k(i,c.displayName,b,null)}k(i,c,b,E){const v=new d(i.id,c,i.reason,b,E,this.c,this.g);return this.d.set(i.id,v),v}l(i){return M.$h4b.isHostExtension(i,this.a,this.b)}m(i){const c=this.b.getExtensionDescription(i);return c?!c.main&&!c.browser:!1}};e.$mcc=g,e.$mcc=g=qe([Ke(3,A.$0i)],g);let d=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,c,b,E,v,s,r){this.c=i,this.d=c,this.f=b,this.g=E,this.h=v,this.j=s,this.k=r,this.a=new l.$Sg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const c=this.g[i];if(c.value&&!c.value.activationFailed){this.g.splice(i,1),i--;continue}if(c.value&&c.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);b.detail=c.value.activationFailedError,this.h=new p(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const c=new Error;if(i&&i.name&&(c.name=i.name),i&&i.message?c.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:c.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(c.stack=i.stack),this.h=new p(c),this.b&&y.$4(i))return;this.j.onExtensionActivationError(this.c,c,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};d=qe([Ke(6,A.$0i)],d)}),define(Ae[210],Re([1,0,156,23,2,5,6,192,12,7,15,18,8,50,20,125,25]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;function i(E,v){if((0,R.$yf)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let s;return Array.isArray(E.highlights)&&(s=E.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),s=s.length?s:void 0),{label:E.label,highlights:s}}}class c extends A.$Sc{constructor(v,s,r){super(),this.f=v,this.g=s,this.h=r,this.a=new Map,this.b=new d.$L7;function n(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}s.registerArgumentProcessor({processArgument:o=>n(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(w=>n(w)?this.r(w):w):o})}registerTreeDataProvider(v,s,r){const n=this.createTreeView(v,{treeDataProvider:s},r);return{dispose:()=>n.dispose()}}createTreeView(v,s,r){if(!s||!s.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=s.dragAndDropController?.dropMimeTypes??[],o=s.dragAndDropController?.dragMimeTypes??[],w=!!s.dragAndDropController?.handleDrag,f=!!s.dragAndDropController?.handleDrop,I=this.m(v,s,r),S={showCollapseAll:!!s.showCollapseAll,canSelectMany:!!s.canSelectMany,dropMimeTypes:n,dragMimeTypes:o,hasHandleDrag:w,hasHandleDrop:f,manuallyManageCheckboxes:!!s.manageCheckboxStateManually},u=this.f.$registerTreeViewDataProvider(v,S),m={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.$dF)(r,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.$dF)(r,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(h){(0,p.$5j)(h)&&(0,t.$dF)(r,"treeViewMarkdownMessage"),I.message=h},get title(){return I.title},set title(h){I.title=h},get description(){return I.description},set description(h){I.description=h},get badge(){return I.badge},set badge(h){h!==void 0&&$.ViewBadge.isViewBadge(h)?I.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(I.badge=void 0)},reveal:(h,P)=>I.reveal(h,P),dispose:async()=>{await u,this.a.delete(v),I.dispose()}};return this.B(m),m}$getChildren(v,s){const r=this.a.get(v);return r?r.getChildren(s):Promise.reject(new l.$qE(v))}async $handleDrop(v,s,r,n,o,w,f,I){const S=this.a.get(v);if(!S)return Promise.reject(new l.$qE(v));const u=a.DataTransfer.toDataTransfer(r,async m=>(await this.f.$resolveDropFileData(v,s,m)).buffer);return f===v&&I&&await this.j(u,S,I,o,w),S.onDrop(u,n,o)}async j(v,s,r,n,o){const w=this.b.removeDragOperationTransfer(o);if(w)(await w)?.forEach((f,I)=>{f&&v.set(I,f)});else if(o&&s.handleDrag){const f=s.handleDrag(r,v,n);this.b.addDragOperationTransfer(o,f),await f}return v}async $handleDrag(v,s,r,n){const o=this.a.get(v);if(!o)return Promise.reject(new l.$qE(v));const w=await this.j(new $.$$K,o,s,n,r);if(!(!w||n.isCancellationRequested))return a.DataTransfer.from(w)}async $hasResolve(v){const s=this.a.get(v);if(!s)throw new l.$qE(v);return s.hasResolve}$resolve(v,s,r){const n=this.a.get(v);if(!n)throw new l.$qE(v);return n.resolveTreeItem(s,r)}$setExpanded(v,s,r){const n=this.a.get(v);if(!n)throw new l.$qE(v);n.setExpanded(s,r)}$setSelectionAndFocus(v,s,r){const n=this.a.get(v);if(!n)throw new l.$qE(v);n.setSelectionAndFocus(s,r)}$setVisible(v,s){const r=this.a.get(v);if(!r){if(!s)return;throw new l.$qE(v)}r.setVisible(s)}$changeCheckboxState(v,s){const r=this.a.get(v);if(!r)throw new l.$qE(v);r.setCheckboxState(s)}m(v,s,r){const n=this.B(new b(v,s,this.f,this.g.converter,this.h,r));return this.a.set(v,n),n}r(v){const s=this.a.get(v.$treeViewId);return s&&"$treeItemHandle"in v?s.getExtensionElement(v.$treeItemHandle):s&&"$focusedTreeItem"in v&&v.$focusedTreeItem?s.focusedElement:null}}e.$Ycc=c;class b extends A.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(v=>this.getExtensionElement(v)).filter(v=>!(0,R.$Hf)(v))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(v,s,r,n,o,w){if(super(),this.I=v,this.J=r,this.L=n,this.M=o,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new T.$Nd),this.onDidExpandElement=this.u.event,this.w=this.B(new T.$Nd),this.onDidCollapseElement=this.w.event,this.y=this.B(new T.$Nd),this.onDidChangeSelection=this.y.event,this.z=this.B(new T.$Nd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new T.$Nd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new T.$Nd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new T.$Nd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new g.$Xd,w.contributes&&w.contributes.views)for(const u in w.contributes.views)for(const m of w.contributes.views[u])m.id===v&&(this.P=m.name);this.f=s.treeDataProvider,this.g=s.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.F.fire({message:!1,element:u})));let f,I;const S=T.Event.debounce(this.F.event,(u,m)=>(u||(u={message:!1,elements:[]}),m.element!==!1&&(f||(f=new Promise(h=>I=h),this.G=this.G.then(()=>f)),Array.isArray(m.element)?u.elements.push(...m.element):u.elements.push(m.element)),m.message&&(u.message=!0),u),200,!0);this.B(S(({message:u,elements:m})=>{m.length&&(this.H=this.H.then(()=>{const h=I;return f=null,this.$(m).then(()=>h())})),u&&this.J.$setMessage(this.I,a.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(v){const s=v?this.getExtensionElement(v):void 0;if(v&&!s)return this.M.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let r=this.X(v);return r||(r=await this.Y(s)),r?r.map(n=>n.item):void 0}getExtensionElement(v){return this.j.get(v)}reveal(v,s){s=s||{select:!0,focus:!1};const r=(0,R.$Hf)(s.select)?!0:s.select,n=(0,R.$Hf)(s.focus)?!1:s.focus,o=(0,R.$Hf)(s.expand)?!1:s.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.G.then(()=>this.S(v)).then(w=>this.W(v,w[w.length-1]).then(f=>this.J.$reveal(this.I,{item:f.item,parentChain:w.map(I=>I.item)},{select:r,focus:n,expand:o})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:r,focus:n,expand:o})}get message(){return this.O}set message(v){this.O=v,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(v){this.P=v,this.J.$setTitle(this.I,v,this.Q)}get description(){return this.Q}set description(v){this.Q=v,this.J.$setTitle(this.I,this.P,v)}get badge(){return this.R}set badge(v){this.R?.value===v?.value&&this.R?.tooltip===v?.tooltip||(this.R=a.ViewBadge.from(v),this.J.$setBadge(this.I,v))}setExpanded(v,s){const r=this.getExtensionElement(v);r&&(s?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(v,s){const r=!(0,k.$ub)(this.s,v);this.s=v;const n=this.t!==s;this.t=s,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),n&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(v){v!==this.r&&(this.r=v,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(v){const s=(await Promise.all(v.map(async r=>{const n=this.getExtensionElement(r.treeItemHandle);return n?{extensionItem:n,treeItem:await this.f.getTreeItem(n),newState:r.newState?$.TreeItemCheckboxState.Checked:$.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);s.forEach(r=>{r.treeItem.checkboxState=r.newState?$.TreeItemCheckboxState.Checked:$.TreeItemCheckboxState.Unchecked}),this.D.fire({items:s.map(r=>[r.extensionItem,r.newState])})}async handleDrag(v,s,r){const n=[];for(const o of v){const w=this.getExtensionElement(o);w&&n.push(w)}if(!(!this.g?.handleDrag||n.length===0))return await this.g.handleDrag(n,s,r),s}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,s,r){const n=s?this.getExtensionElement(s):void 0;if(!(!n&&s||!this.g?.handleDrop))return(0,D.$Mg)(()=>this.g?.handleDrop?this.g.handleDrop(n,v,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,s){if(!this.f.resolveTreeItem)return;const r=this.j.get(v);if(r){const n=this.m.get(r);if(n){const o=await this.f.resolveTreeItem(n.extensionItem,r,s)??n.extensionItem;return this.hb(o),n.item.tooltip=this.eb(o.tooltip),n.item.command=this.fb(n.disposableStore,o.command),n.item}}}S(v){return this.U(v).then(s=>s?this.S(s).then(r=>this.W(s,r[r.length-1]).then(n=>(r.push(n),r))):Promise.resolve([]))}U(v){const s=this.m.get(v);return s?Promise.resolve(s.parent?this.j.get(s.parent.item.handle):void 0):(0,D.$Mg)(()=>this.f.getParent(v))}W(v,s){const r=this.m.get(v);return r?Promise.resolve(r):(0,D.$Mg)(()=>this.f.getTreeItem(v)).then(n=>this.kb(v,n,s,!0)).then(n=>this.getChildren(s?s.item.handle:void 0).then(()=>{const o=this.getExtensionElement(n);if(o){const w=this.m.get(o);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${n} from extension ${this.N.identifier.value}`)}))}X(v){if(v){let s;if(typeof v=="string"){const r=this.getExtensionElement(v);s=r?this.m.get(r):void 0}else s=v;return s&&s.children||void 0}return this.h}async Y(v){this.rb(v);const s=new g.$Xd(this.Z.token);try{const r=v?this.m.get(v):void 0,n=await this.f.getChildren(v);if(s.token.isCancellationRequested)return;const o=await Promise.all((0,k.$Hb)(n||[]).map(async w=>{const f=await this.f.getTreeItem(w);return f&&!s.token.isCancellationRequested?this.db(w,f,r):null}));return s.token.isCancellationRequested?void 0:(0,k.$Hb)(o)}finally{s.dispose()}}$(v){if(v.some(r=>!r))return this.Z.dispose(!0),this.Z=new g.$Xd,this.tb(),this.J.$refresh(this.I);{const r=this.ab(v);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(v){const s=new Set,r=v.map(o=>this.m.get(o));for(const o of r)if(o&&!s.has(o.item.handle)){let w=o;for(;w&&w.parent&&r.findIndex(f=>w&&w.parent&&f&&f.item.handle===w.parent.item.handle)===-1;){const f=this.j.get(w.parent.item.handle);w=f?this.m.get(f):void 0}w&&!w.parent&&s.add(o.item.handle)}const n=[];return s.forEach(o=>{const w=this.j.get(o);if(w){const f=this.m.get(w);f&&(!f.parent||!s.has(f.parent.item.handle))&&n.push(o)}}),n}bb(v){const s={};return Promise.all(v.map(r=>this.cb(r).then(n=>{n&&(s[r]=n.item)}))).then(()=>Object.keys(s).length?this.J.$refresh(this.I,s):void 0)}cb(v){const s=this.getExtensionElement(v);if(s){const r=this.m.get(s);if(r)return this.rb(s),(0,D.$Mg)(()=>this.f.getTreeItem(s)).then(n=>{if(n){const o=this.ib(s,n,r.parent);return this.pb(s,o,r,r.parent),r.dispose(),o}return null})}return Promise.resolve(null)}db(v,s,r){const n=this.ib(v,s,r);if(s.id&&this.j.has(n.item.handle))throw new Error((0,y.localize)(0,null,s.id));return this.ob(v,n),this.qb(n,r),n}eb(v){return $.$HK.isMarkdownString(v)?a.MarkdownString.from(v):v}fb(v,s){return s?{...this.L.toInternal(s,v),originalId:s.command}:void 0}gb(v){if(v.checkboxState===void 0)return;let s,r,n;return typeof v.checkboxState=="number"?s=v.checkboxState:(s=v.checkboxState.state,r=v.checkboxState.tooltip,n=v.checkboxState.accessibilityInformation),{isChecked:s===$.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:n}}hb(v){if(!$.$6K.isTreeItem(v,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(v,s,r){this.hb(s);const n=this.B(new A.$Rc),o=this.kb(v,s,r),w=this.lb(s);return{item:{handle:o,parentHandle:r?r.item.handle:void 0,label:i(s.label,this.N),description:s.description,resourceUri:s.resourceUri,tooltip:this.eb(s.tooltip),command:this.fb(n,s.command),contextValue:s.contextValue,icon:w,iconDark:this.mb(s)||w,themeIcon:this.jb(s),collapsibleState:(0,R.$Hf)(s.collapsibleState)?$.TreeItemCollapsibleState.None:s.collapsibleState,accessibilityInformation:s.accessibilityInformation,checkbox:this.gb(s)},extensionItem:s,parent:r,children:void 0,disposableStore:n,dispose(){n.dispose()}}}jb(v){return v.iconPath instanceof $.$bL?v.iconPath:void 0}kb(v,{id:s,label:r,resourceUri:n},o,w){if(s)return`${b.b}/${s}`;const f=i(r,this.N),I=o?o.item.handle:b.a;let S=f?f.label:n?(0,M.$sg)(n):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const u=this.m.has(v)?this.m.get(v).item.handle:void 0,m=this.X(o)||[];let h,P=0;do{if(h=`${I}/${P}:${S}`,w||!this.j.has(h)||u===h)break;P++}while(P<=m.length);return h}lb(v){if(v.iconPath&&!(v.iconPath instanceof $.$bL))return typeof v.iconPath=="string"||C.URI.isUri(v.iconPath)?this.nb(v.iconPath):this.nb(v.iconPath.light)}mb(v){if(v.iconPath&&!(v.iconPath instanceof $.$bL)&&v.iconPath.dark)return this.nb(v.iconPath.dark)}nb(v){return C.URI.isUri(v)?v:C.URI.file(v)}ob(v,s){this.j.set(s.item.handle,v),this.m.set(v,s)}pb(v,s,r,n){this.j.delete(s.item.handle),this.m.delete(v),s.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(v,s);const o=this.X(n)||[],w=o.filter(f=>f.item.handle===r.item.handle)[0];w&&o.splice(o.indexOf(w),1,s)}qb(v,s){s?(s.children||(s.children=[]),s.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}rb(v){if(v){const s=this.m.get(v);if(s){if(s.children)for(const r of s.children){const n=this.j.get(r.item.handle);n&&this.sb(n)}s.children=void 0}}else this.tb()}sb(v){const s=this.m.get(v);if(s){if(s.children)for(const r of s.children){const n=this.j.get(r.item.handle);n&&this.sb(n)}this.m.delete(v),this.j.delete(s.item.handle),s.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(v=>v.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[211],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[212],Re([1,0,166,9,29,92,72,30,21,211,176,98]),function(ye,e,y,M,C,T,A,l,D,$,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9E=e.$8E=e.$7E=e.$6E=e.$5E=e.$4E=void 0;const a=l.$gn.as(A.$hn.JSONContribution);class p{constructor(v,s,r){this.a=v,this.b=s,this.c=r}d(v,s){this.a({type:v,message:s,extensionId:this.b.identifier,extensionPointId:this.c})}error(v){this.d(C.default.Error,v)}warn(v){this.d(C.default.Warning,v)}info(v){this.d(C.default.Info,v)}}e.$4E=p;class g{static a(v){const s=new D.$7l;for(let r=0,n=v.length;r<n;r++)s.add(v[r].description.identifier);return s}static compute(v,s){if(!v||!v.length)return new g(s,[]);if(!s||!s.length)return new g([],v);const r=this.a(v),n=this.a(s),o=s.filter(f=>!r.has(f.description.identifier)),w=v.filter(f=>!n.has(f.description.identifier));return new g(o,w)}constructor(v,s){this.added=v,this.removed=s}}e.$5E=g;class d{constructor(v,s){this.name=v,this.defaultExtensionKind=s,this.a=null,this.b=null,this.c=null}setHandler(v){if(this.a!==null)throw new Error("Handler already set!");this.a=v,this.d()}acceptUsers(v){this.c=g.compute(this.b,v),this.b=v,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(v){(0,M.$1)(v)}}}e.$6E=d;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$7E={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.$5l},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys($.allApiProposals),markdownEnumDescriptions:Object.values($.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"*",description:y.localize(42,null),body:"*"}]}},badges:{type:"array",description:y.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(44,null)},href:{type:"string",description:y.localize(45,null)},description:{type:"string",description:y.localize(46,null)}}}},markdown:{type:"string",description:y.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$Xn}},extensionPack:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$Xn}},extensionKind:{description:y.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(52,null)},{body:["workspace"],description:y.localize(53,null)},{body:["ui","workspace"],description:y.localize(54,null)},{body:["workspace","ui"],description:y.localize(55,null)},{body:[],description:y.localize(56,null)}]},capabilities:{description:y.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(60,null),y.localize(61,null),y.localize(62,null)]},description:{type:"string",markdownDescription:y.localize(63,null)}}},untrustedWorkspaces:{description:y.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(66,null),y.localize(67,null),y.localize(68,null)]},restrictedConfigurations:{description:y.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(70,null)}}}}},sponsor:{description:y.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(73,null),type:"string"},"vscode:uninstall":{description:y.localize(74,null),type:"string"}}},icon:{type:"string",description:y.localize(75,null)},l10n:{type:"string",description:y.localize(76,null)},pricing:{type:"string",markdownDescription:y.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this.a=new Map}registerExtensionPoint(v){if(this.a.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const s=new d(v.extensionPoint,v.defaultExtensionKind);return this.a.set(v.extensionPoint,s),v.activationEventsGenerator&&k.$UE.register(v.extensionPoint,v.activationEventsGenerator),e.$7E.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,a.registerSchema(i,e.$7E),s}getExtensionPoints(){return Array.from(this.a.values())}}e.$8E=c;const b={ExtensionsRegistry:"ExtensionsRegistry"};l.$gn.add(b.ExtensionsRegistry,new c),e.$9E=l.$gn.as(b.ExtensionsRegistry),a.registerSchema(i,e.$7E),a.registerSchema(R.$qj,{properties:{extensionEnabledApiProposals:{description:y.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys($.allApiProposals),markdownEnumDescriptions:Object.values($.allApiProposals)}}]}}}})}),define(Ae[213],Re([1,0,163,15,24,212,32,5]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NF=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var $;(function(a){function p(g,d,t){if(!g)return;const i=M.$yf(g.type)?g.type:void 0;if(!i||i.length===0){t.error(y.localize(3,null));return}const c=[];if(Array.isArray(g.required))for(const b of g.required)M.$yf(b)&&c.push(b);return{extensionId:d.value,taskType:i,required:c,properties:g.properties?C.$7m(g.properties):{},when:g.when?A.$Ni.deserialize(g.when):void 0}}a.from=p})($||($={}));const R=T.$9E.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,p)=>{for(const g of a)g.type&&p.push(`onTaskType:${g.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:D}});class k{constructor(){this.d=new l.$Nd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,g)=>{R.setHandler((d,t)=>{this.c=void 0;try{for(const i of t.removed){const c=i.value;for(const b of c)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const i of t.added){const c=i.value;for(const b of c){const E=$.from(b,i.description.identifier,i.collector);E&&(this.a[E.taskType]=E)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const g of this.all()){const d={type:"object",additionalProperties:!1};g.required.length>0&&(d.required=g.required.slice(0)),g.properties!==void 0?d.properties=C.$7m(g.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[g.taskType]},p.push(d)}this.c={oneOf:p}}return this.c}}e.$NF=new k}),define(Ae[214],Re([1,0,164,15,23,24,32,213]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$XF=e.JsonSchemaVersion=e.ExecutionEngine=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$RF=e.ShellQuoting=e.$QF=e.$PF=e.$OF=void 0,e.$OF="settings",e.$PF=new A.$7i("taskRunning",!1,y.localize(0,null)),e.$QF={value:y.localize(1,null),original:"Tasks"};var D;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(D||(e.ShellQuoting=D={})),e.$RF="$customized",function(O){function N(ie){if(!ie)return O.Strong;switch(ie.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=N}(D||(e.ShellQuoting=D={}));var $;(function(O){O.defaults={cwd:"${workspaceFolder}"}})($||(e.CommandOptions=$={}));var R;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(R||(e.RevealKind=R={})),function(O){function N(ie){switch(ie.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=N}(R||(e.RevealKind=R={}));var k;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(O){function N(ie){switch(ie.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=N}(k||(e.RevealProblemKind=k={}));var a;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(a||(e.PanelKind=a={})),function(O){function N(ie){switch(ie.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=N}(a||(e.PanelKind=a={}));var p;(function(O){O.defaults={echo:!0,reveal:R.Always,revealProblems:k.Never,focus:!1,panel:a.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var g;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(g||(e.RuntimeType=g={})),function(O){function N(X){switch(X.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=N;function ie(X){switch(X){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=ie}(g||(e.RuntimeType=g={}));var d;(function(O){function N(ie){return M.$yf(ie)?ie:ie.value}O.value=N})(d||(e.CommandString=d={}));var t;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function N(X){return X===O.Clean._id||X===O.Build._id||X===O.Rebuild._id||X===O.Test._id}O.is=N;function ie(X){if(X!==void 0)return M.$yf(X)?N(X)?{_id:X,isDefault:!1}:void 0:X}O.from=ie})(t||(e.TaskGroup=t={}));var i;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var c;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function N(ie){switch(ie){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=N})(c||(e.TaskSourceKind=c={}));var b;(function(O){O.parallel="parallel",O.sequence="sequence"})(b||(e.DependsOrder=b={}));var E;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(E||(e.RunOnOptions=E={}));var v;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:E.default,instanceLimit:1}})(v||(e.RunOptions=v={}));class s{constructor(N,ie,X,Ee,Se,Pe){this._label="",this._id=N,ie&&(this._label=ie),X&&(this.type=X),this.runOptions=Ee,this.configurationProperties=Se,this._source=Pe}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,ie=!1){if(N===void 0)return!1;if(M.$yf(N))return N===this._label||N===this.configurationProperties.identifier||ie&&N===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$SF=s;class r extends s{constructor(N,ie,X,Ee,Se,Pe,$e,pe){super(N,X,void 0,$e,pe,ie),this.command={},this._source=ie,this.hasDefinedMatchers=Pe,Se&&(this.command=Se)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let ie;switch(this.command?this.command.runtime:void 0){case g.Shell:ie="shell";break;case g.Process:ie="process";break;case g.CustomExecution:ie="customExecution";break;case void 0:ie="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ie,_key:this._id,id:this._id}}}static is(N){return N instanceof r}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===c.User?e.$OF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let ie=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ie+=this._source.kind);const X={type:e.$RF,folder:N,id:ie};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new r(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$TF=r;class n extends s{constructor(N,ie,X,Ee,Se,Pe,$e){super(N,X,Ee,Pe,$e,ie),this._source=ie,this.configures=Se}static is(N){return N instanceof n}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===c.User?e.$OF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let ie=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ie+=this._source.kind);const X={type:e.$RF,folder:N,id:ie};return JSON.stringify(X)}}e.$UF=n;class o extends s{constructor(N,ie,X,Ee,Se,Pe,$e,pe,ue){super(N,X,Ee,pe,ue,ie),this.defines=Se,this.hasDefinedMatchers=$e,this.command=Pe,this.icon=ue.icon,this.hide=ue.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof o}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new o(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$VF=o;class w extends s{constructor(N,ie,X,Ee,Se,Pe){super(N,X,Ee,Se,Pe,ie),this._source=ie}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new w(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$WF=w;var f;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(f||(e.ExecutionEngine=f={})),function(O){O._default=O.Terminal}(f||(e.ExecutionEngine=f={}));var I;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class S{constructor(N){this.c=new Map;for(let ie=0;ie<N.length;ie++)this.c.set(N[ie].uri.toString(),ie)}compare(N,ie){const X=N.getWorkspaceFolder(),Ee=ie.getWorkspaceFolder();if(X&&Ee){let Se=this.c.get(X.uri.toString());Se=Se===void 0?0:Se+1;let Pe=this.c.get(Ee.uri.toString());return Pe=Pe===void 0?0:Pe+1,Se===Pe?N._label.localeCompare(ie._label):Se-Pe}else return!X&&Ee?-1:X&&!Ee?1:0}}e.$XF=S;var u;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(u||(e.TaskEventKind=u={}));var m;(function(O){O.SingleRun="singleRun",O.Background="background"})(m||(e.TaskRunType=m={}));var h;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(h||(e.TaskRunSource=h={}));var P;(function(O){function N(pe){return{taskId:pe._id,taskName:pe.configurationProperties.name,runType:pe.configurationProperties.isBackground?"background":"singleRun",group:pe.configurationProperties.group,__task:pe}}function ie(pe,ue,oe){return{...N(pe),kind:"start",terminalId:ue,resolvedVariables:oe}}O.start=ie;function X(pe,ue,oe){return{...N(pe),kind:"processStarted",terminalId:ue,processId:oe}}O.processStarted=X;function Ee(pe,ue,oe){return{...N(pe),kind:"processEnded",terminalId:ue,exitCode:oe}}O.processEnded=Ee;function Se(pe,ue,oe){return{...N(pe),kind:"terminated",exitReason:oe,terminalId:ue}}O.terminated=Se;function Pe(pe,ue,oe){return{...N(ue),kind:pe,terminalId:oe}}O.general=Pe;function $e(){return{kind:"changed"}}O.changed=$e})(P||(e.TaskEvent=P={}));var W;(function(O){function N(X){const Ee=Object.keys(X).sort();let Se="";for(const Pe of Ee){let $e=X[Pe];$e instanceof Object?$e=N($e):typeof $e=="string"&&($e=$e.replace(/,/g,",,")),Se+=Pe+","+$e+","}return Se}function ie(X){const Se={_key:N(X),type:X.taskType};return Object.assign(Se,X),Se}O.create=ie})(W||(e.KeyedTaskIdentifier=W={}));var K;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(K||(e.TaskSettingId=K={}));var z;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(z||(e.TasksSchemaProperties=z={}));var j;(function(O){function N(ie,X){const Ee=l.$NF.get(ie.type);if(Ee===void 0){const pe=T.$7m(ie);return delete pe._key,W.create(pe)}const Se=Object.create(null);Se.type=Ee.taskType;const Pe=new Set;Ee.required.forEach(pe=>Pe.add(pe));const $e=Ee.properties;for(const pe of Object.keys($e)){const ue=ie[pe];if(ue!=null)Se[pe]=ue;else if(Pe.has(pe)){const oe=$e[pe];if(oe.default!==void 0)Se[pe]=T.$7m(oe.default);else switch(oe.type){case"boolean":Se[pe]=!1;break;case"number":case"integer":Se[pe]=0;break;case"string":Se[pe]="";break;default:X.error(y.localize(2,null,JSON.stringify(ie,void 0,0),pe));return}}}return W.create(Se)}O.createTaskIdentifier=N})(j||(e.TaskDefinition=j={}))}),define(Ae[215],Re([1,0,9]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n4b=e.$m4b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,l)=>{this.b=A,this.d=l,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,y.$1)(A))}then(A,l){return this.j().then(A,l)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$m4b=M;class C extends M{constructor(){super(),this.h=!0,this.i=new y.$5}}e.$n4b=C}),define(Ae[47],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pv=e.$ov=e.$nv=e.$mv=void 0;class y{static{this.count=0}constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++y.count}}e.$mv=y;const M=[];function C(l){const D=new y(l);return M[D.nid]=D,D}e.$nv=C;function T(l){return M[l].sid}e.$ov=T;class A{constructor(D){this.value=D}}e.$pv=A}),define(Ae[3],Re([1,0,47]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gK=e.$fK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$eK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var C;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var T;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(T||(e.TabModelOperationKind=T={}));var A;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var l;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(l||(e.WebviewMessageArrayBufferViewType=l={}));var D;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(D||(e.CellOutputKind=D={}));var $;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})($||(e.NotebookEditorRevealType=$={}));var R;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class k{static{this.a=0}static mixin(t){return t._id=k.a++,t}}e.$eK=k;var a;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var p;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var g;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.$fK={MainThreadAuthentication:(0,y.$nv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$nv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$nv)("MainThreadChatProvider"),MainThreadChatAgents:(0,y.$nv)("MainThreadChatAgents"),MainThreadChatAgents2:(0,y.$nv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$nv)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$nv)("MainThreadClipboard"),MainThreadCommands:(0,y.$nv)("MainThreadCommands"),MainThreadComments:(0,y.$nv)("MainThreadComments"),MainThreadConfiguration:(0,y.$nv)("MainThreadConfiguration"),MainThreadConsole:(0,y.$nv)("MainThreadConsole"),MainThreadDebugService:(0,y.$nv)("MainThreadDebugService"),MainThreadDecorations:(0,y.$nv)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$nv)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$nv)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$nv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$nv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$nv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$nv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$nv)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$nv)("MainThreadErrors"),MainThreadTreeViews:(0,y.$nv)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$nv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$nv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$nv)("MainThreadLanguages"),MainThreadLogger:(0,y.$nv)("MainThreadLogger"),MainThreadMessageService:(0,y.$nv)("MainThreadMessageService"),MainThreadOutputService:(0,y.$nv)("MainThreadOutputService"),MainThreadProgress:(0,y.$nv)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$nv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$nv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$nv)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$nv)("MainThreadSecretState"),MainThreadStorage:(0,y.$nv)("MainThreadStorage"),MainThreadSpeech:(0,y.$nv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$nv)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$nv)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$nv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$nv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$nv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$nv)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$nv)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$nv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$nv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$nv)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$nv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$nv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$nv)("MainThreadExtensionService"),MainThreadSCM:(0,y.$nv)("MainThreadSCM"),MainThreadSearch:(0,y.$nv)("MainThreadSearch"),MainThreadShare:(0,y.$nv)("MainThreadShare"),MainThreadTask:(0,y.$nv)("MainThreadTask"),MainThreadWindow:(0,y.$nv)("MainThreadWindow"),MainThreadLabelService:(0,y.$nv)("MainThreadLabelService"),MainThreadNotebook:(0,y.$nv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$nv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$nv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$nv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$nv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$nv)("MainThreadInteractive"),MainThreadChat:(0,y.$nv)("MainThreadChat"),MainThreadInlineChat:(0,y.$nv)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$nv)("MainThreadTheming"),MainThreadTunnelService:(0,y.$nv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$nv)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$nv)("MainThreadTimeline"),MainThreadTesting:(0,y.$nv)("MainThreadTesting"),MainThreadLocalization:(0,y.$nv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$nv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$nv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$nv)("MainThreadIssueReporter")},e.$gK={ExtHostCommands:(0,y.$nv)("ExtHostCommands"),ExtHostConfiguration:(0,y.$nv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$nv)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$nv)("ExtHostDebugService"),ExtHostDecorations:(0,y.$nv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$nv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$nv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$nv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$nv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$nv)("ExtHostEditors"),ExtHostTreeViews:(0,y.$nv)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$nv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$nv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$nv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$nv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$nv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$nv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$nv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$nv)("ExtHostStatusBar"),ExtHostShare:(0,y.$nv)("ExtHostShare"),ExtHostExtensionService:(0,y.$nv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$nv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$nv)("ExtHostTerminalService"),ExtHostSCM:(0,y.$nv)("ExtHostSCM"),ExtHostSearch:(0,y.$nv)("ExtHostSearch"),ExtHostTask:(0,y.$nv)("ExtHostTask"),ExtHostWorkspace:(0,y.$nv)("ExtHostWorkspace"),ExtHostWindow:(0,y.$nv)("ExtHostWindow"),ExtHostWebviews:(0,y.$nv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$nv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$nv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$nv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$nv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$nv)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$nv)("ExtHostProgress"),ExtHostComments:(0,y.$nv)("ExtHostComments"),ExtHostSecretState:(0,y.$nv)("ExtHostSecretState"),ExtHostStorage:(0,y.$nv)("ExtHostStorage"),ExtHostUrls:(0,y.$nv)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$nv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$nv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$nv)("ExtHostOutputService"),ExtHosLabelService:(0,y.$nv)("ExtHostLabelService"),ExtHostNotebook:(0,y.$nv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$nv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$nv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$nv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$nv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$nv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$nv)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$nv)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$nv)("ExtHostChat"),ExtHostChatAgents:(0,y.$nv)("ExtHostChatAgents"),ExtHostChatAgents2:(0,y.$nv)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$nv)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$nv)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$nv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$nv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$nv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$nv)("ExtHostTheming"),ExtHostTunnelService:(0,y.$nv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$nv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$nv)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$nv)("ExtHostTimeline"),ExtHostTesting:(0,y.$nv)("ExtHostTesting"),ExtHostTelemetry:(0,y.$nv)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$nv)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$nv)("ExtHostIssueReporter")}}),define(Ae[216],Re([1,0,3,7]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$fK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,l,D){if(this.a.size===0)throw new Error("No related information providers registered");const $=this.a.get(A);if(!$)throw new Error("related information provider not found");return await $.provideRelatedInformation(l,D)??[]}getRelatedInformation(A,l,D){return this.c.$getAiRelatedInformation(l,D)}registerRelatedInformationProvider(A,l,D){const $=this.b;return this.b++,this.a.set($,D),this.c.$registerAiRelatedInformationProvider($,l),new M.$hK(()=>{this.c.$unregisterAiRelatedInformationProvider($),this.a.delete($)})}}e.$1dc=C}),define(Ae[80],Re([1,0,4,14,3,17]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=e.$4bc=e.$3bc=void 0,e.$3bc=(0,y.$Ph)("IExtHostApiDeprecationService");let A=class{constructor(D,$){this.c=$,this.a=new Set,this.b=D.getProxy(C.$fK.MainThreadTelemetry)}report(D,$,R){const k=this.d(D,$);this.a.has(k)||(this.a.add(k),$.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:$.identifier.value,apiId:D}))}d(D,$){return`${D}-${$.identifier.value}`}};e.$4bc=A,e.$4bc=A=qe([Ke(0,T.$gM),Ke(1,M.$0i)],A),e.$5bc=Object.freeze(new class{report(l,D,$){}})}),define(Ae[217],Re([1,0,5,3,7,21]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;class A{constructor($){this.b=new Map,this.c=[],this.d=new y.$Nd,this.onDidChangeSessions=this.d.event,this.f=new l,this.g=new l,this.a=$.getProxy(M.$fK.MainThreadAuthentication)}$setProviders($){return this.c=$,Promise.resolve()}async getSession($,R,k,a={}){const p=T.$6l.toKey($.identifier),g=[...k].sort().join(" ");return await this.f.getOrCreate(`${p} ${R} ${g}`,async()=>{await this.a.$ensureProvider(R);const d=$.displayName||$.name;return this.a.$getSession(R,k,p,d,a)})}async getSessions($,R,k){const a=T.$6l.toKey($.identifier),p=[...k].sort().join(" ");return await this.g.getOrCreate(`${a} ${p}`,async()=>{await this.a.$ensureProvider(R);const g=$.displayName||$.name;return this.a.$getSessions(R,k,a,g)})}async removeSession($,R){const k=this.b.get($);return k?k.provider.removeSession(R):this.a.$removeSession($,R)}registerAuthenticationProvider($,R,k,a){if(this.b.get($))throw new Error(`An authentication provider with id '${$}' is already registered.`);this.b.set($,{label:R,provider:k,options:a??{supportsMultipleAccounts:!1}}),this.c.find(g=>g.id===$)||this.c.push({id:$,label:R});const p=k.onDidChangeSessions(g=>{this.a.$sendDidChangeSessions($,{added:g.added??[],changed:g.changed??[],removed:g.removed??[]})});return this.a.$registerAuthenticationProvider($,R,a?.supportsMultipleAccounts??!1),new C.$hK(()=>{p.dispose(),this.b.delete($);const g=this.c.findIndex(d=>d.id===$);g>-1&&this.c.splice(g),this.a.$unregisterAuthenticationProvider($)})}$createSession($,R,k){const a=this.b.get($);if(a)return Promise.resolve(a.provider.createSession(R,k));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$removeSession($,R){const k=this.b.get($);if(k)return Promise.resolve(k.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$getSessions($,R){const k=this.b.get($);if(k)return Promise.resolve(k.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$onDidChangeAuthenticationSessions($,R){return this.d.fire({provider:{id:$,label:R}}),Promise.resolve()}}e.$ydc=A;class l{constructor(){this.a=new Map}getOrCreate($,R){const k=this.a.get($);if(k)return k;const a=R().finally(()=>this.a.delete($));return this.a.set($,a),a}}}),define(Ae[218],Re([1,0,3,17,8]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;let T=class{constructor(l,D){this.a=l.getProxy(y.$fK.MainThreadBulkEdits),this.b={getTextDocumentVersion:$=>D.getDocument($)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(l,D,$){const R=C.WorkspaceEdit.from(l,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,$?.isRefactoring??!1)}};e.$Edc=T,e.$Edc=T=qe([Ke(0,M.$gM)],T)}),define(Ae[219],Re([1,0,12,5,66,6,59,146,3,8]),function(ye,e,y,M,C,T,A,l,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;class R{static{this.a=0}constructor(p,g){this.extension=p,this.provider=g,this.handle=R.a++}}class k{static{this.a=0}constructor(p,g){this.h=g,this.b=new Map,this.d=new Map,this.e=new M.$Nd,this.onDidPerformUserAction=this.e.event,this.g=p.getProxy(D.$fK.MainThreadChat)}registerChatProvider(p,g,d){const t=new R(p,d);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,g),(0,T.$Qc)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(p,g){const d=C.Iterable.find(this.d.keys(),t=>this.d.get(t)===p)??0;typeof d=="number"&&this.g.$transferChatSession(d,g)}sendInteractiveRequestToProvider(p,g){this.g.$sendRequestToProvider(p,g)}async $prepareChat(p,g,d){const t=this.b.get(p);if(!t)return;const i=await t.provider.prepareSession(g,d);if(!i)return;const c=k.a++;return this.d.set(c,i),{id:c,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $provideWelcomeMessage(p,g){const d=this.b.get(p);if(!d||!d.provider.provideWelcomeMessage)return;const t=await d.provider.provideWelcomeMessage(g);if(t)return t.map(i=>typeof i=="string"?i:i.map(c=>$.ChatReplyFollowup.from(c)))}async $provideFollowups(p,g,d){const t=this.b.get(p);if(!t)return;const i=this.d.get(g);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,d))?.map(b=>$.ChatFollowup.from(b))}async $provideSampleQuestions(p,g){const d=this.b.get(p);if(!d||!d.provider.provideSampleQuestions)return;const t=await d.provider.provideSampleQuestions(g);if(t)return t?.map(i=>$.ChatReplyFollowup.from(i))}$removeRequest(p,g,d){const t=this.b.get(p);if(!t)return;const i=this.d.get(g);i&&t.provider.removeRequest&&t.provider.removeRequest(i,d)}async $provideReply(p,g,d,t){const i=this.b.get(p);if(!i)return;const c=this.d.get(g);if(!c)return;const b={session:c,message:typeof d.message=="string"?d.message:$.ChatReplyFollowup.to(d.message),variables:{}};if(d.variables)for(const o of Object.keys(d.variables))b.variables[o]=d.variables[o].map($.ChatVariable.to);const E=A.$Jd.create(!1);let v;const s={report:o=>{if(t.isCancellationRequested)return;typeof v>"u"&&(v=E.elapsed());const w=$.ChatResponseProgress.from(o);if("placeholder"in o&&"resolvedContent"in o){const f=Promise.all([this.g.$acceptResponseProgress(p,g,w),o.resolvedContent]);(0,y.$Ig)(f,t).then(I=>{if(!I)return;const[S,u]=I;this.g.$acceptResponseProgress(p,g,u,S??void 0)})}else this.g.$acceptResponseProgress(p,g,w)}};let r;try{r=await i.provider.provideResponseWithProgress(b,s,t),r||(r={errorDetails:{message:(0,l.localize)(0,null)}})}catch(o){r={errorDetails:{message:(0,l.localize)(1,null,o.message),responseIsIncomplete:!0}},this.h.error(o)}try{if(c.saveState&&this.d.has(g)){const o=c.saveState();this.g.$acceptChatState(g,o)}}catch(o){this.h.warn(o)}const n={firstProgress:v??0,totalElapsed:E.elapsed()};return{errorDetails:r.errorDetails,timings:n}}async $provideSlashCommands(p,g,d){const t=this.b.get(p);if(!t)return;const i=this.d.get(g);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,d))?.map(b=>({...b,kind:$.CompletionItemKind.from(b.kind)}))}$releaseSession(p){this.d.delete(p)}async $onDidPerformUserAction(p){this.e.fire(p)}}e.$Sdc=k}),define(Ae[220],Re([1,0,12,6,51,3,8,7]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;class D{static{this.a=0}constructor(k,a,p){this.d=a,this.e=p,this.b=new Map,this.c=k.getProxy(T.$fK.MainThreadChatAgents)}registerAgent(k,a,p,g){const d=D.a++;return this.b.set(d,{extension:k,agent:p}),this.c.$registerAgent(d,a,g),(0,M.$Qc)(()=>{this.c.$unregisterAgent(d),this.b.delete(d)})}async $invokeAgent(k,a,p,g,d){const t=this.b.get(k);if(!t){this.e.warn(`[CHAT](${k}) CANNOT invoke agent because the agent is not registered`);return}let i=!1;function c(){if(i)throw new Error("Only valid while executing the command")}const b=new y.$ch;d.onCancellationRequested(()=>b.complete()),setTimeout(()=>b.complete(),10*1e3),this.d.allowListExtensionWhile(t.extension,b.p);const E=t.agent({role:l.ChatMessageRole.User,content:p},{history:g.history.map(A.ChatMessage.to)},new C.$5u(v=>{c(),this.c.$handleProgressChunk(a,{content:$(v.message)?v.message:v.message.value})}),d);try{return await(0,y.$Ig)(Promise.resolve(E).then(v=>{if(v&&"followUp"in v)return{followUp:v?.followUp?.map(r=>A.ChatFollowup.from(r))}}),d)}finally{i=!0,b.complete()}}}e.$3dc=D;function $(R){return!!R&&typeof R=="object"&&"treeData"in R}}),define(Ae[221],Re([1,0,12,20,37,15,51,3,8]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=void 0;class ${static{this.a=0}constructor(a,p,g){this.h=p,this.i=g,this.b=new Map,this.g=new Map,this.d=a.getProxy(l.$fK.MainThreadChatAgents2)}createChatAgent(a,p,g){const d=$.a++,t=new R(a,p,this.d,d,g);return this.b.set(d,t),this.d.$registerAgent(d,p,{}),t.apiAgent}async $invokeAgent(a,p,g,d,t,i){const c=this.b.get(a);if(!c)throw new Error(`[CHAT](${a}) CANNOT invoke agent because the agent is not registered`);let b=!1;function E(){if(b)throw new Error("Only valid while executing the command")}const v=new y.$ch;i.onCancellationRequested(()=>v.complete()),setTimeout(()=>v.complete(),3*1e3),this.h.allowListExtensionWhile(c.extension,v.p);const s=d.command?await c.validateSlashCommand(d.command):void 0;try{const r=c.invoke({prompt:d.message,variables:D.ChatVariable.objectTo(d.variables),slashCommand:s},{history:t.history.map(D.ChatMessage.to)},new A.$5u(n=>{E();const o=D.ChatResponseProgress.from(n);this.d.$handleProgressChunk(g,o)}),i);return await(0,y.$Ig)(Promise.resolve(r).then(n=>{if(n)return this.g.set(p,n),{errorDetails:n.errorDetails};this.g.delete(p)}),i)}catch(r){return this.i.error(r,c.extension),{errorDetails:{message:(0,C.$Ai)(r)}}}finally{b=!0,v.complete()}}$releaseSession(a){this.g.delete(a)}async $provideSlashCommands(a,p){const g=this.b.get(a);return g?g.provideSlashCommand(p):[]}$provideFollowups(a,p,g){const d=this.b.get(a);if(!d)return Promise.resolve([]);const t=this.g.get(p);return t?d.provideFollowups(t,g):Promise.resolve([])}}e.$4dc=$;class R{constructor(a,p,g,d,t){this.extension=a,this.j=p,this.k=g,this.l=d,this.m=t}async validateSlashCommand(a){this.b||(await this.provideSlashCommand(M.CancellationToken.None),(0,T.$If)(this.b));const p=this.b.find(g=>g.name===a);if(!p)throw new Error(`Unknown slashCommand: ${a}`);return p}async provideSlashCommand(a){if(!this.a)return[];const p=await this.a.provideSlashCommands(a);return p?(this.b=p,p.map(g=>({name:g.name,description:g.description}))):[]}async provideFollowups(a,p){if(!this.d)return[];const g=await this.d.provideFollowups(a,p);return g?g.map(d=>D.ChatFollowup.from(d)):[]}get apiAgent(){let a=!1;const p=()=>{a||(a=!0,queueMicrotask(()=>{this.k.$updateAgent(this.l,{description:this.g??"",fullName:this.h,icon:this.i,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0}),a=!1}))},g=this;return{get name(){return g.j},get description(){return g.g??""},set description(d){g.g=d,p()},get fullName(){return g.h??g.extension.value},set fullName(d){g.h=d,p()},get iconPath(){return g.i},set iconPath(d){g.i=d,p()},get slashCommandProvider(){return g.a},set slashCommandProvider(d){g.a=d,p()},get followupProvider(){return g.d},set followupProvider(d){g.d=d,p()},dispose(){g.k.$unregisterAgent(g.l)}}}invoke(a,p,g,d){return this.m(a,p,g,d)}}}),define(Ae[222],Re([1,0,20,6,3,8,51,21,12,5]),function(ye,e,y,M,C,T,A,l,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=void 0;class R{constructor(g,d){this.stream=new D.$gh,this.stream=d??new D.$gh;const t=this;this.apiObj={option:g,response:t.stream.asyncIterable}}}class k{constructor(g,d){this.a=new $.$Nd,this.b=new Map,this.c=new D.$gh,this.d=!1;const t=this;this.apiObject={result:g,response:t.c.asyncIterable,onDidStartResponseStream:t.a.event,cancel(){d.cancel()}},g.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,i]of this.b)i.stream.complete();else this.c.complete()})}handleFragment(g){if(this.d)return;let d=this.b.get(g.index);d||(this.b.size===0?d=new R(g.index,this.c):d=new R(g.index),this.b.set(g.index,d),this.a.fire(d.apiObj)),d.stream.emit(g.part)}}class a{static{this.a=1}constructor(g,d){this.d=d,this.c=new Map,this.e=new Map,this.f=new l.$8l,this.b=g.getProxy(C.$fK.MainThreadChatProvider)}registerProvider(g,d,t,i){const c=a.a++;return this.c.set(c,{extension:g,provider:t}),this.b.$registerProvider(c,d,{extension:g,displayName:i.name??g.value}),(0,M.$Qc)(()=>{this.b.$unregisterProvider(c),this.c.delete(c)})}async $provideChatResponse(g,d,t,i,c){const b=this.c.get(g);if(!b)return;const E=new A.$5u(async v=>{if(c.isCancellationRequested){this.d.warn(`[CHAT](${b.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(d,{index:v.index,part:v.part})},{async:!0});return b.provider.provideChatResponse(t.map(T.ChatMessage.to),i,E,c)}allowListExtensionWhile(g,d){this.f.set(g,d),d.finally(()=>this.f.delete(g))}async requestChatResponseProvider(g,d){if(!this.f.has(g))throw new Error("Extension is NOT allowed to make chat requests");const t=this;return{get isRevoked(){return!t.f.has(g)},makeRequest(i,c,b){if(!t.f.has(g))throw new Error("Access to chat has been revoked");const E=new y.$Xd(b),v=Math.random()*1e6|0,s=t.b.$fetchResponse(g,d,v,i.map(T.ChatMessage.from),c??{},E.token),r=new k(s,E);return t.e.set(v,{res:r}),s.finally(()=>{t.e.delete(v)}),r.apiObject}}}async $handleResponseFragment(g,d){const t=this.e.get(g);t&&t.res.handleFragment(d)}}e.$Xdc=a}),define(Ae[223],Re([1,0,6,3,9,8]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=void 0;class A{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(M.$fK.MainThreadChatVariables)}async $resolveVariable(D,$,R){const k=this.b.get(D);if(k)try{const a=await k.resolver.resolve(k.data.name,{message:$},R);if(a)return a.map(T.ChatVariable.from)}catch(a){(0,C.$2)(a)}}registerVariableResolver(D,$,R,k){const a=A.a++;return this.b.set(a,{extension:D.identifier,data:{name:$,description:R},resolver:k}),this.c.$registerVariable(a,{name:$,description:R}),(0,y.$Qc)(()=>{this.b.delete(a),this.c.$unregisterVariable(a)})}}e.$Zdc=A}),define(Ae[224],Re([1,0,3]),function(ye,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=void 0;class M{constructor(T){const A=T.getProxy(y.$fK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(l){return A.$writeText(l)}})}}e.$8bc=M}),define(Ae[31],Re([1,0,15,7,8,24,3,18,14,68,45,280,2,6,4,17,104,26,47,37,59,54,58]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d,t,i,c,b,E,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=void 0;let r=class{#e;#t;#i;constructor(S,u,m){this.b=new Map,this.c=new Map,this.#e=S.getProxy(A.$fK.MainThreadCommands),this.d=u,this.#i=m,this.#t=S.getProxy(A.$fK.MainThreadTelemetry),this.converter=new n(this,h=>{const P=this.c.get(h);return P?.result===w.Void?P:void 0},u),this.f=[{processArgument(h){return(0,$.$mh)(h)}},{processArgument(h){return(0,T.$9m)(h,function(P){if(R.$ts.isIRange(P))return C.Range.to(P);if(k.$ss.isIPosition(P))return C.Position.to(P);if(R.$ts.isIRange(P.range)&&a.URI.isUri(P.uri))return C.location.to(P);if(P instanceof i.$be)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const u=this.registerCommand(!1,S.id,async(...m)=>{const h=S.args.map((W,K)=>{if(!W.validate(m[K]))throw new Error(`Invalid argument '${W.name}' when running '${S.id}', received: ${typeof m[K]=="object"?JSON.stringify(m[K],null,"	"):m[K]} `);return W.convert(m[K])}),P=await this.executeCommand(S.internalId,...h);return S.result.convert(P,m,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new M.$hK(()=>{u.dispose(),this.c.delete(S.id)})}registerCommand(S,u,m,h,P,W){if(this.d.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this.b.has(u))throw new Error(`command '${u}' already exists`);return this.b.set(u,{callback:m,thisArg:h,metadata:P,extension:W}),S&&this.#e.$registerCommand(u),new M.$hK(()=>{this.b.delete(u)&&S&&this.#e.$unregisterCommand(u)})}executeCommand(S,...u){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,u,!0)}async g(S,u,m){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,u,!1);{let h=!1;const P=(0,T.$9m)(u,function(W){if(W instanceof M.$iK)return C.Position.from(W);if(W instanceof M.$jK)return C.Range.from(W);if(W instanceof M.$tK)return C.location.from(W);if(M.$EL.isNotebookRange(W))return C.NotebookRange.from(W);if(W instanceof ArrayBuffer)return h=!0,i.$be.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return h=!0,i.$be.wrap(W);if(W instanceof i.$be)return h=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(S,h?new c.$pv(P):P,m);return(0,$.$mh)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(S,u,!1);throw W}}}async h(S,u,m){const h=this.b.get(S);if(!h)throw new Error("Unknown command");const{callback:P,thisArg:W,metadata:K}=h;if(K?.args)for(let j=0;j<K.args.length;j++)try{(0,y.$Pf)(u[j],K.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${K.args[j].name}' - ${K.args[j].description}`)}const z=E.$Jd.create();try{return await P.apply(W,u)}catch(j){if(S===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...u);O&&(S=O.command)}if(this.d.error(j,S,h.extension?.identifier),!m)throw j;if(h.extension?.identifier){const O=this.#i.onExtensionError(h.extension.identifier,j);this.d.trace("forwarded error to extension?",O,h.extension?.identifier)}throw new class extends Error{constructor(){super((0,b.$Ai)(j)),this.id=S,this.source=h.extension?.displayName??h.extension?.name}}}finally{this.j(h,S,z.elapsed())}}j(S,u,m){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new v.$ko(u),duration:m})}$executeContributedCommand(S,...u){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const m=this.b.get(S);return m?(u=u.map(h=>this.f.reduce((P,W)=>W.processArgument(P,m.extension?.identifier),h)),this.h(S,u,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then(u=>(S&&(u=u.filter(m=>m[0]!=="_")),u))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[u,m]of this.b){const{metadata:h}=m;h&&(S[u]=h)}return Promise.resolve(S)}};e.$BM=r,e.$BM=r=qe([Ke(0,d.$gM),Ke(1,D.$0i),Ke(2,s.$AM)],r),e.$CM=(0,g.$Ph)("IExtHostCommands");class n{constructor(S,u,m){this.d=S,this.f=u,this.g=m,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,u){if(!S)return;const m={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return m;const h=this.f(S.command);if(h)m.id=h.internalId,m.arguments=h.args.map((P,W)=>P.convert(S.arguments&&S.arguments[W]));else if((0,l.$Lb)(S.arguments)){const P=`${S.command} /${++this.c}`;this.b.set(P,S),u.add((0,p.$Qc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),m.$ident=P,m.id=this.delegatingCommandId,m.arguments=[P],this.g.trace("CommandsConverter#CREATE",S.command,P)}return m}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const u=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],u?u.command:"MISSING"),u?this.d.executeCommand(u.command,...u.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$DM=n;class o{static{this.Uri=new o("uri","Uri of a text document",S=>a.URI.isUri(S),S=>S)}static{this.Position=new o("position","A position in a text document",S=>M.$iK.isPosition(S),C.Position.from)}static{this.Range=new o("range","A range in a text document",S=>M.$jK.isRange(S),C.Range.from)}static{this.Selection=new o("selection","A selection in a text document",S=>M.$kK.isSelection(S),C.Selection.from)}static{this.Number=new o("number","",S=>typeof S=="number",S=>S)}static{this.String=new o("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=o.Arr(o.String)}static Arr(S){return new o(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,u=>Array.isArray(u)&&u.every(m=>S.validate(m)),u=>u.map(m=>S.convert(m)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",S=>S instanceof M.$DK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",S=>S instanceof M.$XL,C.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",S=>S instanceof t.$tM,C.TestItem.from)}constructor(S,u,m,h){this.name=S,this.description=u,this.validate=m,this.convert=h}optional(){return new o(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,u){return new o(S??this.name,u??this.description,this.validate,this.convert)}}e.$EM=o;class w{static{this.Void=new w("no result",S=>S)}constructor(S,u){this.description=S,this.convert=u}}e.$FM=w;class f{constructor(S,u,m,h,P){this.id=S,this.internalId=u,this.description=m,this.args=h,this.result=P}}e.$GM=f}),define(Ae[225],Re([1,0,18,13,2,78,91,32,95,31,8,7]),function(ye,e,y,M,C,T,A,l,D,$,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=void 0;const a=[new $.$GM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$EM.Uri,$.$EM.Position],new $.$FM("A promise that resolves to an array of DocumentHighlight-instances.",g(R.DocumentHighlight.to))),new $.$GM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$EM.Uri],new $.$FM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,y.$Kb)(t))return;class c extends k.$yK{static to(E){const v=new c(E.name,R.SymbolKind.to(E.kind),E.containerName||"",new k.$tK(i[0],R.Range.to(E.range)));return v.detail=E.detail,v.range=v.location.range,v.selectionRange=R.Range.to(E.selectionRange),v.children=E.children?E.children.map(c.to):[],v}}return t.map(c.to)})),new $.$GM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$EM.Uri,new $.$EM("options","Formatting options",t=>!0,t=>t)],new $.$FM("A promise that resolves to an array of TextEdits.",g(R.TextEdit.to))),new $.$GM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$EM.Uri,$.$EM.Range,new $.$EM("options","Formatting options",t=>!0,t=>t)],new $.$FM("A promise that resolves to an array of TextEdits.",g(R.TextEdit.to))),new $.$GM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$EM.Uri,$.$EM.Position,new $.$EM("ch","Trigger character",t=>typeof t=="string",t=>t),new $.$EM("options","Formatting options",t=>!0,t=>t)],new $.$FM("A promise that resolves to an array of TextEdits.",g(R.TextEdit.to))),new $.$GM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$EM.Uri,$.$EM.Position],new $.$FM("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$GM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$EM.Uri,$.$EM.Position],new $.$FM("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$GM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$EM.Uri,$.$EM.Position],new $.$FM("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$GM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$EM.Uri,$.$EM.Position],new $.$FM("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$GM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$EM.Uri,$.$EM.Position],new $.$FM("A promise that resolves to an array of Location-instances.",g(R.location.to))),new $.$GM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$EM.Uri,$.$EM.Position],new $.$FM("A promise that resolves to an array of Hover-instances.",g(R.Hover.to))),new $.$GM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$EM.Uri,new $.$EM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>k.$iK.isPosition(i)),t=>t.map(R.Position.from))],new $.$FM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let c;for(const b of i.reverse())c=new k.$CK(R.Range.to(b),c);return c}))),new $.$GM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$EM.String.with("query","Search string")],new $.$FM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(R.WorkspaceSymbol.to))),new $.$GM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$EM.Uri,$.$EM.Position],new $.$FM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(R.CallHierarchyItem.to))),new $.$GM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$EM.CallHierarchyItem],new $.$FM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(R.CallHierarchyIncomingCall.to))),new $.$GM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$EM.CallHierarchyItem],new $.$FM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(R.CallHierarchyOutgoingCall.to))),new $.$GM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$EM.Uri,$.$EM.Position],new $.$FM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:R.Range.to(t.range),placeholder:t.text}})),new $.$GM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$EM.Uri,$.$EM.Position,$.$EM.String.with("newName","The new symbol name")],new $.$FM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return R.WorkspaceEdit.to(t)}})),new $.$GM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$EM.Uri,$.$EM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$FM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(R.DocumentLink.to))),new $.$GM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$EM.Uri],new $.$FM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$wL(t.tokenTypes,t.tokenModifiers)})),new $.$GM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$EM.Uri],new $.$FM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$W0)(t);if(i.type==="full")return new k.$yL(i.data,void 0)})),new $.$GM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$EM.Uri,$.$EM.Range.optional()],new $.$FM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$wL(t.tokenTypes,t.tokenModifiers)})),new $.$GM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$EM.Uri,$.$EM.Range],new $.$FM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$W0)(t);if(i.type==="full")return new k.$yL(i.data,void 0)})),new $.$GM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$EM.Uri,$.$EM.Position,$.$EM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$EM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$FM("A promise that resolves to a CompletionList-instance.",(t,i,c)=>{if(!t)return new k.$OK([]);const b=t.suggestions.map(E=>R.CompletionItem.to(E,c));return new k.$OK(b,t.incomplete)})),new $.$GM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$EM.Uri,$.$EM.Position,$.$EM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$FM("A promise that resolves to SignatureHelp.",t=>{if(t)return R.SignatureHelp.to(t)})),new $.$GM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$EM.Uri,$.$EM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$FM("A promise that resolves to an array of CodeLens-instances.",(t,i,c)=>g(b=>new k.$GK(R.Range.to(b.range),b.command&&c.fromInternal(b.command)))(t))),new $.$GM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$EM.Uri,new $.$EM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>k.$jK.isRange(t),t=>k.$kK.isSelection(t)?R.Selection.from(t):R.Range.from(t)),$.$EM.String.with("kind","Code action kind to return code actions for").optional(),$.$EM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$FM("A promise that resolves to an array of Command-instances.",(t,i,c)=>g(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(b.command)}else{const E=new k.$AK(b.title,b.kind?new k.$BK(b.kind):void 0);return b.edit&&(E.edit=R.WorkspaceEdit.to(b.edit)),b.command&&(E.command=c.fromInternal(b.command)),E.isPreferred=b.isPreferred,E}})(t))),new $.$GM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$EM.Uri],new $.$FM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new k.$UK(R.Range.to(i.range),R.Color.to(i.color))):[])),new $.$GM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$EM("color","The color to show and insert",t=>t instanceof k.$TK,R.Color.from),new $.$EM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:R.Range.from(t.range)}))],new $.$FM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(R.ColorPresentation.to):[])),new $.$GM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$EM.Uri,$.$EM.Range],new $.$FM("A promise that resolves to an array of Inlay objects",(t,i,c)=>t.map(R.InlayHint.to.bind(void 0,c)))),new $.$GM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$EM.Uri],new $.$FM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(R.FoldingRange.to)})),new $.$GM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$FM("A promise that resolves to an array of NotebookContentProvider static info objects.",g(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>R.NotebookExclusiveDocumentPattern.to(i))})))),new $.$GM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$EM.Uri,$.$EM.Range,new $.$EM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof k.$jK,t=>R.InlineValueContext.from(t))],new $.$FM("A promise that resolves to an array of InlineValue objects",t=>t.map(R.InlineValue.to))),new $.$GM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$EM("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,D.$dU)(t,M.Schemas.http,M.Schemas.https),t=>t),new $.$EM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional(),$.$EM.String.with("label","").optional()],$.$FM.Void),new $.$GM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$EM.Uri.with("resource","Resource to open"),$.$EM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$EM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional()],$.$FM.Void),new $.$GM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$EM.Uri.with("left","Left-hand side resource of the diff editor"),$.$EM.Uri.with("right","Right-hand side resource of the diff editor"),$.$EM.String.with("title","Human readable title for the diff editor").optional(),new $.$EM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)]).optional()],$.$FM.Void),new $.$GM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$EM.Uri,$.$EM.Position],new $.$FM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new $.$GM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$EM.TypeHierarchyItem],new $.$FM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new $.$GM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$EM.TypeHierarchyItem],new $.$FM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new $.$GM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$EM.TestItem],$.$FM.Void),new $.$GM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$EM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$FM.Void),new $.$GM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$EM.String.with("name","The context key name"),new $.$EM("value","The context key value",()=>!0,t=>t)],$.$FM.Void),new $.$GM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$EM.Uri,$.$EM.StringArray,new $.$EM("MappedEditsContext","Mapped Edits Context",t=>R.MappedEditsContext.is(t),t=>R.MappedEditsContext.from(t))],new $.$FM("A promise that resolves to a workspace edit or null",t=>t?R.WorkspaceEdit.to(t):null))];class p{static register(i){a.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",l.$Oi)}}e.$7bc=p;function g(t){return i=>{if(Array.isArray(i))return i.map(t)}}function d(t){if(!Array.isArray(t))return;const i=[];for(const c of t)T.$et(c)?i.push(R.DefinitionLink.to(c)):i.push(R.location.to(c));return i}}),define(Ae[226],Re([1,0,12,65,5,6,2,78,21,8,7,3,25]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=void 0;function p(g,d,t){const i=g.getProxy(k.$fK.MainThreadComments);class c{static{this.a=0}constructor(){this.b=new Map,this.c=new D.$8l,d.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const I=this.b.get(f.handle);return I?I.value:f}else if(f&&f.$mid===7){const I=this.b.get(f.commentControlHandle);if(!I)return f;const S=I.getCommentThread(f.commentThreadHandle);return S?S.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const I=this.b.get(f.thread.commentControlHandle);if(!I)return f;const S=I.getCommentThread(f.thread.commentThreadHandle);return S?f.$mid===8?S.value:{thread:S.value,text:f.text}:f}else if(f&&f.$mid===10){const I=this.b.get(f.thread.commentControlHandle);if(!I)return f;const S=I.getCommentThread(f.thread.commentThreadHandle);if(!S)return f;const u=f.commentUniqueId,m=S.getCommentByUniqueId(u);return m||f}else if(f&&f.$mid===11){const I=this.b.get(f.thread.commentControlHandle);if(!I)return f;const S=I.getCommentThread(f.thread.commentThreadHandle);if(!S)return f;const u=f.text,m=f.commentUniqueId,h=S.getCommentByUniqueId(m);return h?(typeof h.body=="string"?h.body=u:h.body=new R.$HK(u),h):f}return f}})}createCommentController(f,I,S){const u=c.a++,m=new E(f,u,I,S);this.b.set(m.handle,m);const h=this.c.get(f.identifier)||[];return h.push(m),this.c.set(f.identifier,h),m.value}async $createCommentThreadTemplate(f,I,S){const u=this.b.get(f);u&&u.$createCommentThreadTemplate(I,S)}async $updateCommentThreadTemplate(f,I,S){const u=this.b.get(f);u&&u.$updateCommentThreadTemplate(I,S)}$deleteCommentThread(f,I){this.b.get(f)?.$deleteCommentThread(I)}$provideCommentingRanges(f,I,S){const u=this.b.get(f);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const m=t.getDocument(A.URI.revive(I));return(0,y.$Mg)(async()=>{const h=await u.commentingRangeProvider.provideCommentingRanges(m,S);let P;return Array.isArray(h)?P={ranges:h,fileComments:!1}:h?P={ranges:h.ranges||[],fileComments:h.fileComments||!1}:P=h??void 0,P}).then(h=>{let P;return h&&(P={ranges:h.ranges.map(W=>$.Range.from(W)),fileComments:h.fileComments}),P})}$toggleReaction(f,I,S,u,m){const h=this.b.get(f);return!h||!h.reactionHandler?Promise.resolve(void 0):(0,y.$Mg)(()=>{const P=h.getCommentThread(I);if(P){const W=P.getCommentByUniqueId(u.uniqueIdInThread);if(h!==void 0&&W&&h.reactionHandler)return h.reactionHandler(W,r(m))}return Promise.resolve(void 0)})}}class b{static{this.a=0}set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,I,S,u,m,h,P,W){this.m=I,this.n=S,this.o=u,this.p=m,this.q=h,this.extensionDescription=P,this.r=W,this.handle=b.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$Nd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new T.$Tc,this.l.value=new T.$Rc,this.n===void 0&&(this.n=`${f}.${this.handle}`),i.$createCommentThread(I,this.handle,this.n,this.o,$.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=h,this.i.push({dispose:()=>{i.$deleteCommentThread(I,this.handle)}});const K=this;this.value={get uri(){return K.uri},get range(){return K.range},set range(z){K.range=z},get comments(){return K.comments},set comments(z){K.comments=z},get collapsibleState(){return K.collapsibleState},set collapsibleState(z){K.collapsibleState=z},get canReply(){return K.canReply},set canReply(z){K.canReply=z},get contextValue(){return K.contextValue},set contextValue(z){K.contextValue=z},get label(){return K.label},set label(z){K.label=z},get state(){return K.state},set state(z){K.state=z},dispose:()=>{K.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new T.$Rc);const f=S=>Object.prototype.hasOwnProperty.call(this.b,S),I={};f("range")&&(I.range=$.Range.from(this.p)),f("label")&&(I.label=this.label),f("contextValue")&&(I.contextValue=this.contextValue??null),f("comments")&&(I.comments=this.q.map(S=>v(this,S,this.k,this.extensionDescription))),f("collapsibleState")&&(I.collapseState=n(this.g)),f("canReply")&&(I.canReply=this.canReply),f("state")&&(I.state=o(this.h)),f("isTemplate")&&(I.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(f){for(const I of this.k){const S=I[0],u=I[1];if(f===u)return S}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}qe([(0,M.$ih)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(f,I,S,u){this.f=f,this.g=I,this.h=S,this.i=u,this.a=new Map,i.$registerCommentController(this.handle,S,u,this.f.identifier.value);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(h){m.options=h},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(h){m.commentingRangeProvider=h},get reactionHandler(){return m.reactionHandler},set reactionHandler(h){m.reactionHandler=h},createCommentThread(h,P,W){return m.createCommentThread(h,P,W).value},dispose:()=>{m.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(f,I,S){I===void 0&&(0,a.$dF)(this.f,"fileComments");const u=new b(this.id,this.handle,void 0,f,I,S,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate(f,I){const S=new b(this.id,this.handle,void 0,A.URI.revive(f),$.Range.to(I),[],this.f,!0);return S.collapsibleState=l.CommentThreadCollapsibleState.Expanded,this.a.set(S.handle,S),S}$updateCommentThreadTemplate(f,I){const S=this.a.get(f);S&&(S.range=$.Range.to(I))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.e.forEach(f=>f.dispose())}}function v(w,f,I,S){let u=I.get(f);return u||(u=++w.commentHandle,I.set(f,u)),f.state!==void 0&&(0,a.$dF)(S,"commentsDraftState"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:u,body:typeof f.body=="string"?f.body:$.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(m=>s(m)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function s(w){return{label:w.label,iconPath:w.iconPath?$.$fM(w.iconPath):void 0,count:w.count,hasReacted:w.authorHasReacted}}function r(w){return{label:w.label||"",count:w.count||0,iconPath:w.iconPath?A.URI.revive(w.iconPath):"",authorHasReacted:w.hasReacted||!1}}function n(w){if(w!==void 0)switch(w){case R.CommentThreadCollapsibleState.Expanded:return l.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return l.CommentThreadCollapsibleState.Collapsed}return l.CommentThreadCollapsibleState.Collapsed}function o(w){if(w!==void 0)switch(w){case R.CommentThreadState.Unresolved:return l.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return l.CommentThreadState.Resolved}return l.CommentThreadState.Unresolved}return new c}e.$9bc=p}),define(Ae[227],Re([1,0,24,3,27,17]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=void 0;let A=class{constructor(R,k){this.a=R.getProxy(M.$fK.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,k){const a=this,p=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){a.e(R,k,p,arguments)}})}e(R,k,a,p){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:D(p,this.b)}),this.c&&this.f(R,a,p)}};e.$7dc=A,e.$7dc=A=qe([Ke(0,T.$gM),Ke(1,C.$wM)],A);const l=1e5;function D($,R){const k=[];if($.length)for(let a=0;a<$.length;a++){let p=$[a];if(typeof p>"u")p="undefined";else if(p instanceof Error){const g=p;g.stack?p=g.stack:p=g.toString()}k.push(p)}if(R){const a=new Error().stack;a&&k.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,y.$_m)(k);return a.length>l?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Ae[107],Re([1,0,2,3,7,4,17,14,18,16,19,25]),function(ye,e,y,M,C,T,A,l,D,$,R,k){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=e.$0cc=void 0;let p=class{static{a=this}static{this.c=0}static{this.d=250}constructor(d,t){this.h=t,this.f=new Map,this.g=d.getProxy(M.$fK.MainThreadDecorations)}registerFileDecorationProvider(d,t){const i=a.c++;this.f.set(i,{provider:d,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const c=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(b=>{if(!b){this.g.$onDidChange(i,null);return}const E=(0,D.$3b)(b);if(E.length<=a.d){this.g.$onDidChange(i,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,E.length);const v=E.map(n=>({uri:n,rank:(0,$.$Ge)(n.path,"/")})),s=(0,D.$zb)(v,(n,o)=>n.rank-o.rank||(0,$.$Ue)(n.uri.path,o.uri.path)),r=[];e:for(const n of s){let o;for(const w of n){const f=(0,R.$mc)(w.uri.path);if(o!==f&&(o=f,r.push(w.uri)>=a.d))break e}}this.g.$onDidChange(i,r)});return new C.$hK(()=>{c?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(d,t,i){if(!this.f.has(d))return Object.create(null);const c=Object.create(null),{provider:b,extensionDescription:E}=this.f.get(d);return await Promise.all(t.map(async v=>{try{const{uri:s,id:r}=v,n=await Promise.resolve(b.provideFileDecoration(y.URI.revive(s),i));if(!n)return;try{C.$CL.validate(n),n.badge&&typeof n.badge!="string"&&(0,k.$dF)(E,"codiconDecoration"),c[r]=[n.propagate,n.tooltip,n.badge,n.color]}catch(o){this.h.warn(`INVALID decoration from extension '${E.identifier.value}': ${o}`)}}catch(s){this.h.error(s)}})),c}};e.$0cc=p,e.$0cc=p=a=qe([Ke(0,A.$gM),Ke(1,l.$0i)],p),e.$$cc=(0,T.$Ph)("IExtHostDecorations")}),define(Ae[228],Re([1,0,147,94,2,3,7,8,5,14,28,40]),function(ye,e,y,M,C,T,A,l,D,$,R,k){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=e.$1bc=void 0;class p{#e;#t;#i;constructor(t,i,c,b,E,v,s,r){this.d=t,this.e=i,this.f=c,this.g=b,this.h=E,this.c=!1,this.f=Math.max(b,c),this.#i=new R.$Ac(n=>v.getComparisonKey(n)),this.#e=s,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let c=[];if(C.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),c=[t]}else if(Array.isArray(t)){c=[];let v;t=[...t].sort(p.k);for(const s of t){const[r,n]=s;if((!v||r.toString()!==v.toString())&&(v&&this.#i.get(v).length===0&&this.#i.delete(v),v=r,c.push(r),this.#i.set(r,[])),n)this.#i.get(r)?.push(...n);else{const o=this.#i.get(r);o&&(o.length=0)}}}if(this.#t.fire(c),!this.#e)return;const b=[];let E=0;for(const v of c){let s=[];const r=this.#i.get(v);if(r)if(r.length>this.g){s=[];const n=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const w of r)if(w.severity===n[o]&&s.push({...l.Diagnostic.from(w),modelVersionId:this.h(v)})===this.g)break e;s.push({severity:M.MarkerSeverity.Info,message:(0,y.localize)(0,null,r.length-this.g),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=r.map(n=>({...l.Diagnostic.from(n),modelVersionId:this.h(v)}));if(b.push([v,s]),E+=s.length,E>this.f)break}this.#e.$changeMany(this.e,b)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[c,b]of this)t.call(i,c,b,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$1bc=p;let g=class{static{a=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*a.d}static _mapper(t){const i=new R.$Ac;for(const c of t)i.set(c,c);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,c,b){this.j=i,this.k=c,this.l=b,this.g=new Map,this.h=new D.$Rd({merge:E=>E.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.h.event,a._mapper),this.f=t.getProxy(T.$fK.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:c,f:b,h:E,j:v,k:s,l:r}=this,n=new class{$changeMany(f,I){b.$changeMany(f,I),v.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,f,I.length===0?"CLEARING":I)}$clear(f){b.$clear(f),v.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,f)}dispose(){b.dispose()}};let o;if(!i)i="_generated_diagnostic_collection_name_#"+a.c++,o=i;else if(!c.has(i))o=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do o=i+a.c++;while(c.has(o))}return new class extends p{constructor(){super(i,o,a.e,a.d,f=>r.getDocument(f)?.version,s.extUri,n,E),c.set(o,this)}dispose(){super.dispose(),c.delete(o)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,c=[];for(const b of this.g.values())b.forEach((E,v)=>{let s=i.get(E.toString());typeof s>"u"&&(s=c.length,i.set(E.toString(),s),c.push([E,[]])),c[s][1]=c[s][1].concat(...v)});return c}}m(t){let i=[];for(const c of this.g.values())c.has(t)&&(i=i.concat(c.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",c=new p(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,b=>{},this.k.extUri,void 0,this.h);this.g.set(i,c),this.n=c}for(const[i,c]of t)this.n.set(C.URI.revive(i),c.map(l.Diagnostic.to))}};e.$2bc=g,e.$2bc=g=a=qe([Ke(1,$.$0i),Ke(2,k.$Zbc)],g)}),define(Ae[229],Re([1,0,2,3,25]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=void 0;class T{constructor(l){this.a=l.getProxy(M.$fK.MainThreadDialogs)}showOpenDialog(l,D){return D?.allowUIResources&&(0,C.$dF)(l,"showLocal"),this.a.$showOpenDialog(D).then($=>$?$.map(R=>y.URI.revive(R)):void 0)}showSaveDialog(l){return this.a.$showSaveDialog(l).then(D=>D?y.URI.revive(D):void 0)}}e.$ecc=T}),define(Ae[230],Re([1,0,9,2,7,3,13,20,16]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=void 0;class ${static{this.a=0}constructor(k,a,p){this.d=a,this.e=p,this.b=new Map,this.c=k.getProxy(T.$fK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,a){if(Object.keys(A.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const p=$.a++;this.b.set(p,a),this.c.$registerTextContentProvider(p,k);let g;return typeof a.onDidChange=="function"&&(g=a.onDidChange(d=>{if(d.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this.d.getDocument(d)&&this.$provideTextDocumentContent(p,d).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(d);if(!i)return;const c=(0,D.$Pe)(t);if(!i.equalLines(c))return this.c.$onVirtualDocumentChange(d,t)},y.$1)})),new C.$hK(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(k,a){const p=this.b.get(k);return p?Promise.resolve(p.provideTextDocumentContent(M.URI.revive(a),l.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.$fcc=$}),define(Ae[231],Re([1,0,5,6,2,3,100,8,15,24,7,9]),function(ye,e,y,M,C,T,A,l,D,$,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=void 0;class a{constructor(g,d){this.a=new y.$Nd({onListenerError:k.$2}),this.b=new y.$Nd({onListenerError:k.$2}),this.c=new y.$Nd({onListenerError:k.$2}),this.d=new y.$Nd({onListenerError:k.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Rc,this.h=new Map,this.f=g.getProxy(T.$fK.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(g){if(!g)return;const d=this.g.getDocument(g);if(d)return d}getDocument(g){const d=this.getDocumentData(g);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${g}'`);return d.document}ensureDocumentData(g){const d=this.g.getDocument(g);if(d)return Promise.resolve(d);let t=this.h.get(g.toString());return t||(t=this.f.$tryOpenDocument(g).then(i=>{this.h.delete(g.toString());const c=C.URI.revive(i);return(0,D.$Jf)(this.g.getDocument(c))},i=>(this.h.delete(g.toString()),Promise.reject(i))),this.h.set(g.toString(),t)),t}createDocumentData(g){return this.f.$tryCreateDocument(g).then(d=>C.URI.revive(d))}$acceptModelLanguageChanged(g,d){const t=C.URI.revive(g),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(d),this.a.fire(i.document)}$acceptModelSaved(g){const d=C.URI.revive(g),t=this.g.getDocument(d);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(g,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(g,d){const t=C.URI.revive(g),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(d),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(g,d,t){const i=C.URI.revive(g),c=this.g.getDocument(i);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(d);let b;d.isUndoing?b=R.TextDocumentChangeReason.Undo:d.isRedoing&&(b=R.TextDocumentChangeReason.Redo),this.c.fire((0,$.$8m)({document:c.document,contentChanges:d.changes.map(E=>({range:l.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:b}))}setWordDefinitionFor(g,d){(0,A.$iM)(g,d)}}e.$Xbc=a}),define(Ae[60],Re([1,0,52,5,6,2,4,3,100,17,105,8,14,28,13,66,41]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=e.$qM=void 0;class i{constructor(E){this.value=E,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(E,v){this.h=E,this.i=v,this.a=null,this.b=new Map,this.c=new p.$Ac,this.d=new M.$Nd,this.e=new M.$Nd,this.f=new M.$Nd,this.g=new M.$Nd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(E){this.acceptDocumentsAndEditorsDelta(E)}acceptDocumentsAndEditorsDelta(E){const v=[],s=[],r=[];if(E.removedDocuments)for(const n of E.removedDocuments){const o=T.URI.revive(n),w=this.c.get(o);w?.unref()&&(this.c.delete(o),v.push(w.value))}if(E.addedDocuments)for(const n of E.addedDocuments){const o=T.URI.revive(n.uri);let w=this.c.get(o);if(w&&o.scheme!==g.Schemas.vscodeNotebookCell&&o.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);w||(w=new i(new D.$jM(this.h.getProxy(l.$fK.MainThreadDocuments),o,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this.c.set(o,w),s.push(w.value)),w.ref()}if(E.removedEditors)for(const n of E.removedEditors){const o=this.b.get(n);this.b.delete(n),o&&r.push(o)}if(E.addedEditors)for(const n of E.addedEditors){const o=T.URI.revive(n.documentUri);y.ok(this.c.has(o),`document '${o}' does not exist`),y.ok(!this.b.has(n.id),`editor '${n.id}' already exists!`);const w=this.c.get(o).value,f=new R.$pM(n.id,this.h.getProxy(l.$fK.MainThreadTextEditors),this.i,new t.$V(()=>w.document),n.selections.map(k.Selection.to),n.options,n.visibleRanges.map(I=>k.Range.to(I)),typeof n.editorPosition=="number"?k.ViewColumn.to(n.editorPosition):void 0);this.b.set(n.id,f)}E.newActiveEditor!==void 0&&(y.ok(E.newActiveEditor===null||this.b.has(E.newActiveEditor),`active editor '${E.newActiveEditor}' does not exist`),this.a=E.newActiveEditor),(0,C.$Nc)(v),(0,C.$Nc)(r),E.removedDocuments&&this.e.fire(v),E.addedDocuments&&this.d.fire(s),(E.removedEditors||E.addedEditors)&&this.f.fire(this.allEditors().map(n=>n.value)),E.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(E){return this.c.get(E)?.value}allDocuments(){return d.Iterable.map(this.c.values(),E=>E.value)}getEditor(E){return this.b.get(E)}activeEditor(E){if(!this.a)return;const v=this.b.get(this.a);return E?v:v?.value}allEditors(){return[...this.b.values()]}};e.$qM=c,e.$qM=c=qe([Ke(0,$.$gM),Ke(1,a.$0i)],c),e.$rM=(0,A.$Ph)("IExtHostDocumentsAndEditors")}),define(Ae[61],Re([1,0,8,3,2,5,4,7,17,15,232]),function(ye,e,y,M,C,T,A,l,D,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=e.$cdc=void 0,e.$cdc=(0,A.$Ph)("IExtHostEditorTabs");class k{constructor(t,i,c){this.e=c,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new l.$YL(C.URI.revive(this.b.input.uri));case 2:return new l.$ZL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new l.$1L(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new l.$2L(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new l.$3L(this.b.input.viewType);case 4:return new l.$4L(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new l.$5L(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new l.$6L;case 9:return new l.$7L(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class a{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const c of t.tabs)c.isActive&&(this.d=c.id),this.c.push(new k(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return y.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(c=>c.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(c=>c.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const c=new k(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,c),t.tabDto.isActive&&(this.d=c.tabId),c}else if(t.kind===1){const c=this.c.splice(t.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(t.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,c),c}const i=this.c.find(c=>c.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let p=class{constructor(t){this.b=new T.$Nd,this.c=new T.$Nd,this.e=[],this.a=t.getProxy(M.$fK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(c=>c.apiObject))},get activeTabGroup(){const c=t.d;return(0,$.$Jf)(t.e.find(E=>E.groupId===c)?.apiObject)},close:async(c,b)=>{const E=Array.isArray(c)?c:[c];return E.length?g(E[0])?this.j(E,b):this.i(E,b):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(n=>n.groupId)),c=new Set(t.map(n=>n.groupId)),b=(0,R.$K)(i,c),E=this.e.filter(n=>b.removed.includes(n.groupId)).map(n=>n.apiObject),v=[],s=[];this.e=t.map(n=>{const o=new a(n,()=>this.d);return b.added.includes(o.groupId)?v.push(o.apiObject):s.push(o.apiObject),o});const r=(0,$.$Jf)(t.find(n=>n.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:v,closed:E,changed:s}))}$acceptTabGroupUpdate(t){const i=this.e.find(c=>c.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(b=>b.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const c=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(t){for(const i of this.e)for(const c of i.tabs)if(c.apiObject===t)return c}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const c=[];for(const b of t){const E=this.g(b);if(!E)throw new Error("Tab close: Invalid tab not found!");c.push(E.tabId)}return this.a.$closeTab(c,i)}async j(t,i){const c=[];for(const b of t){const E=this.h(b);if(!E)throw new Error("Group close: Invalid group not found!");c.push(E.groupId)}return this.a.$closeGroup(c,i)}};e.$ddc=p,e.$ddc=p=qe([Ke(0,D.$gM)],p);function g(d){return d.tabs!==void 0}}),define(Ae[233],Re([1,0,3,7]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$fK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,l,D){if(this.a.size===0)throw new Error("No embedding vector providers registered");const $=this.a.get(A);if(!$)throw new Error("Embedding vector provider not found");const R=await $.provideEmbeddingVector(l,D);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,l,D){const $=this.b;return this.b++,this.a.set($,D),this.c.$registerAiEmbeddingVectorProvider(l,$),new M.$hK(()=>{this.c.$unregisterAiEmbeddingVectorProvider($),this.a.delete($)})}}e.$2dc=C}),define(Ae[234],Re([1,0,2,3,6,7,8,281,16,26,25,50]),function(ye,e,y,M,C,T,A,l,D,$,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;class a{constructor(){this.a=[]}add(d){this.b=void 0,this.a.push(d)}delete(d){const t=this.a.indexOf(d);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const d=this.a.sort(),t=[];let i,c,b=14,E=14;for(const v of d){let s=i?(0,D.$4e)(i,v):0;for(s===0?c=1:c=E;s<v.length;s++)s+1===v.length?(b=E,E=9):E+=1,t.push([c,v.toUpperCase().charCodeAt(s),E]),t.push([c,v.toLowerCase().charCodeAt(s),E]),c=E;i=v,E=b}t.push([9,58,10]),t.push([10,47,12]),this.b=new l.$YY(t)}}provideDocumentLinks(d){this.c();const t=[],i=l.$ZY.computeLinks({getLineContent(c){return d.lineAt(c-1).text},getLineCount(){return d.lineCount}},this.b);for(const c of i){const b=A.DocumentLink.to(c);b.target&&t.push(b)}return t}}class p{constructor(d,t){this.i=t,this.b=new a,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=d.getProxy(M.$fK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(d,t,i,c={}){if(p.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(d,"*",this.b));const b=this.h++;this.b.add(t),this.d.add(t),this.c.set(b,i);let E=2;c.isCaseSensitive&&(E+=1024),c.isReadonly&&(E+=2048),typeof i.copy=="function"&&(E+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,R.$dF)(d,"fsChunks"),E+=4);let v;c.isReadonly&&(0,k.$5j)(c.isReadonly)&&((0,R.$dF)(d,"readonlyMessage"),v={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this.a.$registerFileSystemProvider(b,t,E,v).catch(r=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${t}`),console.error(r)});const s=i.onDidChangeFile(r=>{const n=[];for(const o of r){const{uri:w,type:f}=o;if(w.scheme!==t)continue;let I;switch(f){case T.FileChangeType.Changed:I=0;break;case T.FileChangeType.Created:I=1;break;case T.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:w,type:I})}this.a.$onFileSystemChange(b,n)});return(0,C.$Qc)(()=>{s.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(b),this.a.$unregisterProvider(b)})}static j(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static k(d){const{type:t,ctime:i,mtime:c,size:b,permissions:E}=d;return{type:t,ctime:i,mtime:c,size:b,permissions:E}}$stat(d,t){return Promise.resolve(this.l(d).stat(y.URI.revive(t))).then(i=>p.k(i))}$readdir(d,t){return Promise.resolve(this.l(d).readDirectory(y.URI.revive(t)))}$readFile(d,t){return Promise.resolve(this.l(d).readFile(y.URI.revive(t))).then(i=>$.$be.wrap(i))}$writeFile(d,t,i,c){return Promise.resolve(this.l(d).writeFile(y.URI.revive(t),i.buffer,c))}$delete(d,t,i){return Promise.resolve(this.l(d).delete(y.URI.revive(t),i))}$rename(d,t,i,c){return Promise.resolve(this.l(d).rename(y.URI.revive(t),y.URI.revive(i),c))}$copy(d,t,i,c){const b=this.l(d);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(y.URI.revive(t),y.URI.revive(i),c))}$mkdir(d,t){return Promise.resolve(this.l(d).createDirectory(y.URI.revive(t)))}$watch(d,t,i,c){const b=this.l(d).watch(y.URI.revive(i),c);this.f.set(t,b)}$unwatch(d,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(d,t,i){const c=this.l(d);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(y.URI.revive(t),i))}$close(d,t){const i=this.l(d);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(d,t,i,c){const b=this.l(d);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const E=$.$be.alloc(c);return Promise.resolve(b.read(t,i,E.buffer,0,c)).then(v=>E.slice(0,v))}$write(d,t,i,c){const b=this.l(d);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(t,i,c.buffer,0,c.byteLength))}l(d){const t=this.c.get(d);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$Lcc=p}),define(Ae[62],Re([1,0,3,39,7,26,4,17,40,6,12,23,13]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=e.$rcc=void 0;let g=p=class{constructor(t,i){this.b=new Map,this.c=new R.$3g,this.a=t.getProxy(y.$fK.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(b){try{let E;const v=c.b.get(b.scheme);return v?(await c.a.$ensureActivation(b.scheme),E=await v.impl.stat(b)):E=await c.a.$stat(b),{type:E.type,ctime:E.ctime,mtime:E.mtime,size:E.size,permissions:E.permissions===M.FilePermission.Readonly?1:void 0}}catch(E){p.e(E)}},async readDirectory(b){try{const E=c.b.get(b.scheme);return E?(await c.a.$ensureActivation(b.scheme),(await E.impl.readDirectory(b)).slice()):await c.a.$readdir(b)}catch(E){return p.e(E)}},async createDirectory(b){try{const E=c.b.get(b.scheme);return E&&!E.isReadonly?(await c.a.$ensureActivation(b.scheme),await c.d(E.impl,E.extUri,b)):await c.a.$mkdir(b)}catch(E){return p.e(E)}},async readFile(b){try{const E=c.b.get(b.scheme);return E?(await c.a.$ensureActivation(b.scheme),(await E.impl.readFile(b)).slice()):(await c.a.$readFile(b)).buffer}catch(E){return p.e(E)}},async writeFile(b,E){try{const v=c.b.get(b.scheme);return v&&!v.isReadonly?(await c.a.$ensureActivation(b.scheme),await c.d(v.impl,v.extUri,v.extUri.dirname(b)),await c.c.queueFor(b).queue(()=>Promise.resolve(v.impl.writeFile(b,E,{create:!0,overwrite:!0})))):await c.a.$writeFile(b,T.$be.wrap(E))}catch(v){return p.e(v)}},async delete(b,E){try{const v=c.b.get(b.scheme);return v&&!v.isReadonly?(await c.a.$ensureActivation(b.scheme),await v.impl.delete(b,{recursive:!1,...E})):await c.a.$delete(b,{recursive:!1,useTrash:!1,atomic:!1,...E})}catch(v){return p.e(v)}},async rename(b,E,v){try{return await c.a.$rename(b,E,{overwrite:!1,...v})}catch(s){return p.e(s)}},async copy(b,E,v){try{return await c.a.$copy(b,E,{overwrite:!1,...v})}catch(s){return p.e(s)}},isWritableFileSystem(b){const E=i.getCapabilities(b);if(typeof E=="number")return!(E&2048)}})}async d(t,i,c){const b=[];for(;!i.isEqual(c,i.dirname(c));)try{if(!((await t.stat(c)).type&M.FileType.Directory))throw C.$uL.FileExists(`Unable to create folder '${c.scheme===a.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(E){if(M.$ok(E)!==M.FileSystemProviderErrorCode.FileNotFound)throw E;b.push(i.basename(c)),c=i.dirname(c)}for(let E=b.length-1;E>=0;E--){c=i.joinPath(c,b[E]);try{await t.createDirectory(c)}catch(v){if(M.$ok(v)!==M.FileSystemProviderErrorCode.FileExists)throw v}}}static e(t){if(t instanceof C.$uL)throw t;if(t instanceof M.$kk)switch(t.code){case M.FileSystemProviderErrorCode.FileExists:throw C.$uL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$uL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$uL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$uL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$uL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$uL.Unavailable(t.message);default:throw new C.$uL(t.message,t.name)}if(!(t instanceof Error))throw new C.$uL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw C.$uL.Unavailable(t.message);switch(t.name){case M.FileSystemProviderErrorCode.FileExists:throw C.$uL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$uL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$uL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$uL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$uL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$uL.Unavailable(t.message);default:throw new C.$uL(t.message,t.name)}}addFileSystemProvider(t,i,c){return this.b.set(t,{impl:i,extUri:c?.isCaseSensitive?k.$lg:k.$ng,isReadonly:!!c?.isReadonly}),(0,$.$Qc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??k.$lg}};e.$rcc=g,e.$rcc=g=p=qe([Ke(0,l.$gM),Ke(1,D.$Zbc)],g),e.$scc=(0,A.$Ph)("IExtHostConsumerFileSystem")}),define(Ae[235],Re([1,0,5,38,2,3,8,7,41]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class ${get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,g,d,t,i,c){this.a=Math.random(),this.b=new y.$Nd,this.c=new y.$Nd,this.d=new y.$Nd,this.h=0,c?.ignoreCreateEvents&&(this.h+=1),c?.ignoreChangeEvents&&(this.h+=2),c?.ignoreDeleteEvents&&(this.h+=4);const b=(0,M.$wj)(i),E=typeof i=="string",v=t(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)){if(!c?.ignoreCreateEvents)for(const r of s.created){const n=C.URI.revive(r);b(n.fsPath)&&(!E||g.getWorkspaceFolder(n))&&this.b.fire(n)}if(!c?.ignoreChangeEvents)for(const r of s.changed){const n=C.URI.revive(r);b(n.fsPath)&&(!E||g.getWorkspaceFolder(n))&&this.c.fire(n)}if(!c?.ignoreDeleteEvents)for(const r of s.deleted){const n=C.URI.revive(r);b(n.fsPath)&&(!E||g.getWorkspaceFolder(n))&&this.d.fire(n)}}});this.g=l.$hK.from(this.i(p,d,i,c),this.b,this.c,this.d,v)}i(p,g,d,t){const i=l.$hK.from();if(typeof d=="string")return i;const c=p.getProxy(T.$fK.MainThreadFileSystemEventService);let b=!1;return(d.pattern.includes(M.$sj)||d.pattern.includes(M.$tj))&&(b=!0),c.$watch(g.identifier.value,this.a,d.baseUri,{recursive:b,excludes:t?.excludes??[]}),l.$hK.from({dispose:()=>c.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(p){this.a=p,this.session=this.a.session,this.b=new D.$V(()=>this.a.created.map(C.URI.revive)),this.c=new D.$V(()=>this.a.changed.map(C.URI.revive)),this.d=new D.$V(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(p,g,d){this.j=p,this.k=g,this.l=d,this.a=new y.$Nd,this.b=new y.$Nd,this.c=new y.$Nd,this.d=new y.$Nd,this.g=new y.$Pd,this.h=new y.$Pd,this.i=new y.$Pd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,g,d,t){return new $(this.j,p,g,this.a.event,A.GlobPattern.from(d),t)}$onFileEvent(p){this.a.fire(new R(p))}$onDidRunFileOperation(p,g){switch(p){case 2:this.b.fire(Object.freeze({files:g.map(d=>({oldUri:C.URI.revive(d.source),newUri:C.URI.revive(d.target)}))}));break;case 1:this.d.fire(Object.freeze({files:g.map(d=>C.URI.revive(d.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:g.map(d=>C.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,g){return(d,t,i)=>{const c=function(E){d.call(t,E)};return c.extension=p,g.event(c,void 0,i)}}async $onWillRunFileOperation(p,g,d,t){switch(p){case 2:return await this.n(this.g,{files:g.map(i=>({oldUri:C.URI.revive(i.source),newUri:C.URI.revive(i.target)}))},d,t);case 1:return await this.n(this.i,{files:g.map(i=>C.URI.revive(i.target))},d,t);case 0:case 3:return await this.n(this.h,{files:g.map(i=>C.URI.revive(i.target))},d,t)}}async n(p,g,d,t){const i=new Set,c=[];if(await p.fireAsync(g,t,async(E,v)=>{const s=Date.now(),r=await Promise.resolve(E);r instanceof l.$rK&&(c.push([v.extension,r]),i.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-s>d&&this.k.warn("SLOW file-participant",v.extension.identifier)}),t.isCancellationRequested||c.length===0)return;const b={edits:[]};for(const[,E]of c){const{edits:v}=A.WorkspaceEdit.from(E,{getTextDocumentVersion:s=>this.l.getDocument(s)?.version,getNotebookDocumentVersion:()=>{}});b.edits=b.edits.concat(v)}return{edit:b,extensionNames:Array.from(i)}}}e.$Mcc=k}),define(Ae[236],Re([1,0,6,2,3,8,7,31,12]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class ${static{this.a=0}constructor(p,g){this.extension=p,this.provider=g,this.handle=$.a++}}class R{constructor(p){this.session=p,this.responses=[]}}class k{static{this.a=0}constructor(p,g,d,t){this.f=d,this.g=t,this.b=new Map,this.d=new Map,this.e=p.getProxy(C.$fK.MainThreadInlineChat),g.registerApiCommand(new l.$GM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new l.$EM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?T.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?T.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?T.Position.from(i.position):void 0}})],l.$FM.Void))}registerProvider(p,g,d){const t=new $(p,g);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,d.label,p.identifier.value,typeof g.handleInteractiveEditorResponseFeedback=="function"),(0,y.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(p,g,d,t){const i=this.b.get(p);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const c=this.f.getDocument(M.URI.revive(g)),b=T.Selection.to(d),E=await i.provider.prepareInteractiveEditorSession({document:c,selection:b},t);if(!E)return;if(E.wholeRange&&!E.wholeRange.contains(b))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const v=k.a++;return this.d.set(v,new R(E)),{id:v,placeholder:E.placeholder,slashCommands:E.slashCommands?.map(s=>({command:s.command,detail:s.detail,refer:s.refer,executeImmediately:s.executeImmediately})),wholeRange:T.Range.from(E.wholeRange),message:E.message}}async $provideResponse(p,g,d,t){const i=this.b.get(p);if(!i)return;const c=this.d.get(g.id);if(!c)return;const b={prompt:d.prompt,selection:T.Selection.to(d.selection),wholeRange:T.Range.to(d.wholeRange),attempt:d.attempt,live:d.live};let E=!1;const v={report:async f=>{if(!d.live)throw new Error("Progress reporting is only supported for live sessions");E||t.isCancellationRequested||await this.e.$handleProgressChunk(d.requestId,{message:f.message,edits:f.edits?.map(T.TextEdit.from),slashCommand:f.slashCommand?.command})}},s=Promise.resolve(i.provider.provideInteractiveEditorResponse(c.session,b,v,t));let r;try{r=await(0,D.$Ig)(s,t)}finally{E=!0}if(!r)return;const n=c.responses.push(r)-1,o={wholeRange:T.Range.from(r.wholeRange),placeholder:r.placeholder};if(k.h(r))return{...o,id:n,type:"message",message:T.MarkdownString.from(r.contents)};const{edits:w}=r;return w instanceof A.$rK?{...o,id:n,type:"bulkEdit",edits:T.WorkspaceEdit.from(w)}:{...o,id:n,type:"editorEdit",edits:w.map(T.TextEdit.from)}}$handleFeedback(p,g,d,t){const i=this.b.get(p),c=this.d.get(g),b=c?.responses[d];if(i&&b){const E=T.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(c.session,b,E)}}$releaseSession(p,g){}static h(p){return typeof p=="object"&&typeof p.contents=="object"}}e.$Tdc=k}),define(Ae[237],Re([1,0,2,31]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;class C{constructor(A,l,D,$,R){this.a=l,this.b=D,this.c=$;const k=new M.$GM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$EM("showOptions","Show Options",a=>!0,a=>a),new M.$EM("resource","Interactive resource Uri",a=>!0,a=>a),new M.$EM("controllerId","Notebook controller Id",a=>!0,a=>a),new M.$EM("title","Interactive editor title",a=>!0,a=>a)],new M.$FM("Notebook and input URI",a=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const p=this.a.getEditorById(a.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:y.URI.revive(a.notebookUri),inputUri:y.URI.revive(a.inputUri),notebookEditor:p.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:y.URI.revive(a.notebookUri),inputUri:y.URI.revive(a.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(A,l,D,$){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:l,lines:[""],languageId:D,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive($))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,l){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Pdc=C}),define(Ae[238],Re([1,0,3,7]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;class C{constructor(A){this.a=new Map,this.b=A.getProxy(y.$fK.MainThreadIssueReporter)}async $getIssueReporterUri(A,l){if(this.a.size===0)throw new Error("No issue request handlers registered");const D=this.a.get(A);if(!D)throw new Error("Issue request handler not found");const $=await D.handleIssueUrlRequest();if(!$)throw new Error("Issue request handler returned no result");return $}registerIssueUriRequestHandler(A,l){const D=A.identifier.value;return this.a.set(D,l),this.b.$registerIssueUriRequestHandler(D),new M.$hK(()=>{this.b.$unregisterIssueUriRequestHandler(D),this.a.delete(D)})}}e.$Vdc=C}),define(Ae[239],Re([1,0,6,3]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(M.$fK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const l=this.b++;return this.a.$registerResourceLabelFormatter(l,A),(0,y.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(l)})}}e.$9cc=C}),define(Ae[240],Re([1,0,2,24,8,7,78,3,16,45,18,15,282,20,21,6,91,88,74,59,9,12,25,149]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d,t,i,c,b,E,v,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=void 0;class n{constructor(F,V){this.d=F,this.e=V}async provideDocumentSymbols(F,V){const G=this.d.getDocument(F),J=await this.e.provideDocumentSymbols(G,V);if(!(0,R.$Kb)(J))return J[0]instanceof T.$zK?J.map(C.DocumentSymbol.from):n.f(J)}static f(F){F=F.slice(0).sort((J,q)=>{let x=J.location.range.start.compareTo(q.location.range.start);return x===0&&(x=q.location.range.end.compareTo(J.location.range.end)),x});const V=[],G=[];for(const J of F){const q={name:J.name||"!!MISSING: name!!",kind:C.SymbolKind.from(J.kind),tags:J.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:C.Range.from(J.location.range),selectionRange:C.Range.from(J.location.range),children:[]};for(;;){if(G.length===0){G.push(q),V.push(q);break}const x=G[G.length-1];if($.$ts.containsRange(x.range,q.range)&&!$.$ts.equalsRange(x.range,q.range)){x.children?.push(q),G.push(q);break}G.pop()}}return V}}class o{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(F,V,G){this.g=F,this.h=V,this.j=G,this.e=new c.$Wbc("CodeLens"),this.f=new Map}async provideCodeLenses(F,V){const G=this.g.getDocument(F),J=await this.j.provideCodeLenses(G,V);if(!J||V.isCancellationRequested)return;const q=this.e.add(J),x=new d.$Rc;this.f.set(q,x);const ce={cacheId:q,lenses:[]};for(let Ne=0;Ne<J.length;Ne++)ce.lenses.push({cacheId:[q,Ne],range:C.Range.from(J[Ne].range),command:this.h.toInternal(J[Ne].command,x)});return ce}async resolveCodeLens(F,V){const G=F.cacheId&&this.e.get(...F.cacheId);if(!G)return;let J;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?J=G:J=await this.j.resolveCodeLens(G,V),J||(J=G),V.isCancellationRequested)return;const q=F.cacheId&&this.f.get(F.cacheId[0]);if(q)return F.command=this.h.toInternal(J.command??o.d,q),F}releaseCodeLenses(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}}function w(Ie){return Array.isArray(Ie)?Ie.map(C.DefinitionLink.from):Ie?[C.DefinitionLink.from(Ie)]:[]}class f{constructor(F,V){this.d=F,this.e=V}async provideDefinition(F,V,G){const J=this.d.getDocument(F),q=C.Position.to(V),x=await this.e.provideDefinition(J,q,G);return w(x)}}class I{constructor(F,V){this.d=F,this.e=V}async provideDeclaration(F,V,G){const J=this.d.getDocument(F),q=C.Position.to(V),x=await this.e.provideDeclaration(J,q,G);return w(x)}}class S{constructor(F,V){this.d=F,this.e=V}async provideImplementation(F,V,G){const J=this.d.getDocument(F),q=C.Position.to(V),x=await this.e.provideImplementation(J,q,G);return w(x)}}class u{constructor(F,V){this.d=F,this.e=V}async provideTypeDefinition(F,V,G){const J=this.d.getDocument(F),q=C.Position.to(V),x=await this.e.provideTypeDefinition(J,q,G);return w(x)}}class m{constructor(F,V){this.d=F,this.e=V}async provideHover(F,V,G){const J=this.d.getDocument(F),q=C.Position.to(V),x=await this.e.provideHover(J,q,G);if(!(!x||(0,R.$Kb)(x.contents)))return x.range||(x.range=J.getWordRangeAtPosition(q)),x.range||(x.range=new T.$jK(q,q)),C.Hover.from(x)}}class h{constructor(F,V){this.d=F,this.e=V}async provideEvaluatableExpression(F,V,G){const J=this.d.getDocument(F),q=C.Position.to(V),x=await this.e.provideEvaluatableExpression(J,q,G);if(x)return C.EvaluatableExpression.from(x)}}class P{constructor(F,V){this.d=F,this.e=V}async provideInlineValues(F,V,G,J){const q=this.d.getDocument(F),x=await this.e.provideInlineValues(q,C.Range.to(V),C.InlineValueContext.to(G),J);if(Array.isArray(x))return x.map(ce=>C.InlineValue.from(ce))}}class W{constructor(F,V){this.d=F,this.e=V}async provideDocumentHighlights(F,V,G){const J=this.d.getDocument(F),q=C.Position.to(V),x=await this.e.provideDocumentHighlights(J,q,G);if(Array.isArray(x))return x.map(C.DocumentHighlight.from)}}class K{constructor(F,V){this.d=F,this.e=V}async provideLinkedEditingRanges(F,V,G){const J=this.d.getDocument(F),q=C.Position.to(V),x=await this.e.provideLinkedEditingRanges(J,q,G);if(x&&Array.isArray(x.ranges))return{ranges:(0,R.$Hb)(x.ranges.map(C.Range.from)),wordPattern:x.wordPattern}}}class z{constructor(F,V){this.d=F,this.e=V}async provideReferences(F,V,G,J){const q=this.d.getDocument(F),x=C.Position.to(V),ce=await this.e.provideReferences(q,x,G,J);if(Array.isArray(ce))return ce.map(C.location.from)}}class j{static{this.d=1e3}constructor(F,V,G,J,q,x,ce){this.g=F,this.h=V,this.j=G,this.k=J,this.l=q,this.m=x,this.n=ce,this.e=new c.$Wbc("CodeAction"),this.f=new Map}async provideCodeActions(F,V,G,J){const q=this.g.getDocument(F),x=a.$vs.isISelection(V)?C.Selection.to(V):C.Range.to(V),ce=[];for(const Ye of this.j.getDiagnostics(F))if(x.intersection(Ye.range)&&ce.push(Ye)>j.d)break;const Ne={diagnostics:ce,only:G.only?new T.$BK(G.only):void 0,triggerKind:C.CodeActionTriggerKind.to(G.trigger)},Ue=await this.k.provideCodeActions(q,x,Ne,J);if(!(0,R.$Lb)(Ue)||J.isCancellationRequested)return;const Qe=this.e.add(Ue),Ge=new d.$Rc;this.f.set(Qe,Ge);const xe=[];for(let Ye=0;Ye<Ue.length;Ye++){const _e=Ue[Ye];_e&&(j.o(_e)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),xe.push({_isSynthetic:!0,title:_e.title,command:this.h.toInternal(_e,Ge)})):(Ne.only&&(_e.kind?Ne.only.contains(_e.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),xe.push({cacheId:[Qe,Ye],title:_e.title,command:_e.command&&this.h.toInternal(_e.command,Ge),diagnostics:_e.diagnostics&&_e.diagnostics.map(C.Diagnostic.from),edit:_e.edit&&C.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,isAI:(0,s.$cF)(this.m,"codeActionAI")?_e.isAI:!1,disabled:_e.disabled?.reason})))}return{cacheId:Qe,actions:xe}}async resolveCodeAction(F,V){const[G,J]=F,q=this.e.get(G,J);if(!q||j.o(q))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(q,V)??q;let ce;x.edit&&(ce=C.WorkspaceEdit.from(x.edit,void 0));let Ne;if(x.command){const Ue=this.f.get(G);Ue&&(Ne=this.h.toInternal(x.command,Ue))}return{edit:ce,command:Ne}}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static o(F){return typeof F.command=="string"&&typeof F.title=="string"}}class O{static toInternalProviderId(F,V){return F+"."+V}constructor(F,V,G,J,q){this.d=F,this.e=V,this.f=G,this.g=J,this.h=q}async prepareDocumentPaste(F,V,G,J){if(!this.f.prepareDocumentPaste)return;const q=this.e.getDocument(F),x=V.map(Ue=>C.Range.to(Ue)),ce=C.DataTransfer.toDataTransfer(G,()=>{throw new E.$$});if(await this.f.prepareDocumentPaste(q,x,ce,J),J.isCancellationRequested)return;const Ne=Array.from(ce).filter(([,Ue])=>!(Ue instanceof T.$8K));return C.DataTransfer.from(Ne)}async providePasteEdits(F,V,G,J,q){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(V),ce=G.map(Qe=>C.Range.to(Qe)),Ne=C.DataTransfer.toDataTransfer(J,async Qe=>(await this.d.$resolvePasteFileData(this.g,F,Qe)).buffer),Ue=await this.f.provideDocumentPasteEdits(x,ce,Ne,q);if(Ue)return{label:Ue.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:O.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class N{constructor(F,V){this.d=F,this.e=V}async provideDocumentFormattingEdits(F,V,G){const J=this.d.getDocument(F),q=await this.e.provideDocumentFormattingEdits(J,V,G);if(Array.isArray(q))return q.map(C.TextEdit.from)}}class ie{constructor(F,V){this.d=F,this.e=V}async provideDocumentRangeFormattingEdits(F,V,G,J){const q=this.d.getDocument(F),x=C.Range.to(V),ce=await this.e.provideDocumentRangeFormattingEdits(q,x,G,J);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,V,G,J){(0,k.$If)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const q=this.d.getDocument(F),x=V.map(C.Range.to),ce=await this.e.provideDocumentRangesFormattingEdits(q,x,G,J);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}}class X{constructor(F,V){this.d=F,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,V,G,J,q){const x=this.d.getDocument(F),ce=C.Position.to(V),Ne=await this.e.provideOnTypeFormattingEdits(x,ce,G,J,q);if(Array.isArray(Ne))return Ne.map(C.TextEdit.from)}}class Ee{constructor(F,V){this.e=F,this.f=V,this.d=new c.$Wbc("WorkspaceSymbols")}async provideWorkspaceSymbols(F,V){const G=await this.e.provideWorkspaceSymbols(F,V);if(!(0,R.$Lb)(G))return{symbols:[]};const J=this.d.add(G),q={cacheId:J,symbols:[]};for(let x=0;x<G.length;x++){const ce=G[x];if(!ce||!ce.name){this.f.warn("INVALID SymbolInformation",ce);continue}q.symbols.push({...C.WorkspaceSymbol.from(ce),cacheId:[J,x]})}return q}async resolveWorkspaceSymbol(F,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const G=this.d.get(...F.cacheId);if(G){const J=await this.e.resolveWorkspaceSymbol(G,V);return J&&(0,M.$0m)(F,C.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class Se{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,V,G){this.d=F,this.e=V,this.f=G}async provideRenameEdits(F,V,G,J){const q=this.d.getDocument(F),x=C.Position.to(V);try{const ce=await this.e.provideRenameEdits(q,x,G,J);return ce?C.WorkspaceEdit.from(ce):void 0}catch(ce){const Ne=Se.g(ce);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(F,V,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(F),q=C.Position.to(V);try{const x=await this.e.prepareRename(J,q,G);let ce,Ne;if(T.$jK.isRange(x)?(ce=x,Ne=J.getText(x)):(0,k.$Af)(x)&&(ce=x.range,Ne=x.placeholder),!ce||!Ne)return;if(ce.start.line>q.line||ce.end.line<q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ce),text:Ne}}catch(x){const ce=Se.g(x);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(x)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class Pe{constructor(F,V){this.resultId=F,this.tokens=V}}class $e{constructor(F,V){this.f=F,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,V,G){const J=this.f.getDocument(F),q=V!==0?this.d.get(V):null;let x=typeof q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,q.resultId,G):await this.g.provideDocumentSemanticTokens(J,G);return q&&this.d.delete(V),x?(x=$e.h(x),this.o($e.n(q,x),x)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return $e.j(F)?$e.k(F)?F:new T.$yL(new Uint32Array(F.data),F.resultId):$e.l(F)?$e.m(F)?F:new T.$AL(F.edits.map(V=>new T.$zL(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const V of F.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(F,V){if(!$e.j(V)||!F||!F.tokens)return V;const G=F.tokens,J=G.length,q=V.data,x=q.length;let ce=0;const Ne=Math.min(J,x);for(;ce<Ne&&G[ce]===q[ce];)ce++;if(ce===J&&ce===x)return new T.$AL([],V.resultId);let Ue=0;const Qe=Ne-ce;for(;Ue<Qe&&G[J-Ue-1]===q[x-Ue-1];)Ue++;return new T.$AL([{start:ce,deleteCount:J-ce-Ue,data:q.subarray(ce,x-Ue)}],V.resultId)}o(F,V){if($e.j(F)){const G=this.e++;return this.d.set(G,new Pe(F.resultId,F.data)),(0,t.$V0)({id:G,type:"full",data:F.data})}if($e.l(F)){const G=this.e++;return $e.j(V)?this.d.set(G,new Pe(V.resultId,V.data)):this.d.set(G,new Pe(F.resultId)),(0,t.$V0)({id:G,type:"delta",deltas:(F.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class pe{constructor(F,V){this.d=F,this.e=V}async provideDocumentRangeSemanticTokens(F,V,G){const J=this.d.getDocument(F),q=await this.e.provideDocumentRangeSemanticTokens(J,C.Range.to(V),G);return q?this.f(q):null}f(F){return(0,t.$V0)({id:0,type:"full",data:F.data})}}class ue{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,V,G,J,q){this.f=F,this.g=V,this.h=G,this.j=J,this.k=q,this.d=new c.$Wbc("CompletionItem"),this.e=new Map}async provideCompletionItems(F,V,G,J){const q=this.f.getDocument(F),x=C.Position.to(V),ce=q.getWordRangeAtPosition(x)||new T.$jK(x,x),Ne=ce.with({end:x}),Ue=new b.$Jd,Qe=await this.h.provideCompletionItems(q,x,J,C.CompletionContext.to(G));if(!Qe||J.isCancellationRequested)return;const Ge=Array.isArray(Qe)?new T.$OK(Qe):Qe,xe=ue.supportsResolving(this.h)?this.d.add(Ge.items):this.d.add([]),Ye=new d.$Rc;this.e.set(xe,Ye);const _e=[],it={x:xe,b:_e,a:{replace:C.Range.from(ce),insert:C.Range.from(Ne)},c:Ge.isIncomplete||void 0,d:Ue.elapsed()};for(let tt=0;tt<Ge.items.length;tt++){const ze=Ge.items[tt],st=this.l(ze,[xe,tt],Ne,ce);_e.push(st)}return it}async resolveCompletionItem(F,V){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...F);if(!G)return;const J=this.l(G,F),q=await this.h.resolveCompletionItem(G,V);if(!q)return;const x=this.l(q,F);return(J.h!==x.h||J.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==x.n||J.o!==x.o||!(0,M.$$m)(J.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,V,G,J){const q=this.e.get(V[0]);if(!q)throw Error("DisposableStore is missing...");const x=this.g.toInternal(F.command,q),ce={x:V,a:F.label,b:F.kind!==void 0?C.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(C.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:C.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(C.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=F.textEdit.newText):typeof F.insertText=="string"?ce.h=F.insertText:F.insertText instanceof T.$sK&&(ce.h=F.insertText.value,ce.i|=4);let Ne;return F.textEdit?Ne=F.textEdit.range:F.range&&(Ne=F.range),T.$jK.isRange(Ne)?ce.j=C.Range.from(Ne):Ne&&(!G?.isEqual(Ne.inserting)||!J?.isEqual(Ne.replacing))&&(ce.j={insert:C.Range.from(Ne.inserting),replace:C.Range.from(Ne.replacing)}),ce}}class oe{async provideInlineCompletions(F,V,G,J){}disposeCompletions(F){}handleDidShowCompletionItem(F,V,G){}handlePartialAccept(F,V,G){}}class be extends oe{constructor(F,V,G,J){super(),this.f=F,this.g=V,this.h=G,this.j=J,this.d=new _,this.e=(0,s.$cF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:T.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:T.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,s.$cF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,V,G,J){const q=this.g.getDocument(F),x=C.Position.to(V),ce=await this.h.provideInlineCompletionItems(q,x,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},J);if(!ce||J.isCancellationRequested)return;const Ne=Array.isArray(ce)?ce:ce.items,Ue=this.e?Array.isArray(ce)?[]:ce.commands||[]:[],Qe=this.e&&!Array.isArray(ce)?ce.enableForwardStability:void 0;let Ge;return{pid:this.d.createReferenceId({dispose(){Ge?.dispose()},items:Ne}),items:Ne.map((Ye,_e)=>{let it;Ye.command&&(Ge||(Ge=new d.$Rc),it=this.j.toInternal(Ye.command,Ge));const tt=Ye.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ye.filterText,range:Ye.range?C.Range.from(Ye.range):void 0,command:it,idx:_e,completeBracketPairs:this.e?Ye.completeBracketPairs:!1}}),commands:Ue.map(Ye=>(Ge||(Ge=new d.$Rc),this.j.toInternal(Ye,Ge))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,V,G){const J=this.d.get(F)?.items[V];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,G)}handlePartialAccept(F,V,G){const J=this.d.get(F)?.items[V];J&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(J,G)}}class _{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const V=this.e++;return this.d.set(V,F),V}disposeReferenceId(F){const V=this.d.get(F);return this.d.delete(F),V}get(F){return this.d.get(F)}}class B{constructor(F,V){this.e=F,this.f=V,this.d=new c.$Wbc("SignatureHelp")}async provideSignatureHelp(F,V,G,J){const q=this.e.getDocument(F),x=C.Position.to(V),ce=this.g(G),Ne=await this.f.provideSignatureHelp(q,x,J,ce);if(Ne){const Ue=this.d.add([Ne]);return{...C.SignatureHelp.from(Ne),id:Ue}}}g(F){let V;if(F.activeSignatureHelp){const G=C.SignatureHelp.to(F.activeSignatureHelp),J=this.d.get(F.activeSignatureHelp.id,0);J?(V=J,V.activeSignature=G.activeSignature,V.activeParameter=G.activeParameter):V=G}return{...F,activeSignatureHelp:V}}releaseSignatureHelp(F){this.d.delete(F)}}class Z{constructor(F,V,G,J,q){this.f=F,this.g=V,this.h=G,this.j=J,this.k=q,this.d=new c.$Wbc("InlayHints"),this.e=new Map}async provideInlayHints(F,V,G){const J=this.f.getDocument(F),q=C.Range.to(V),x=await this.h.provideInlayHints(J,q,G);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${V}`);return}if(G.isCancellationRequested)return;const ce=this.d.add(x);this.e.set(ce,new d.$Rc);const Ne={hints:[],cacheId:ce};for(let Ue=0;Ue<x.length;Ue++)this.l(x[Ue],q)&&Ne.hints.push(this.m(x[Ue],[ce,Ue]));return this.j.trace(`[InlayHints] ${Ne.hints.length} inlay hints from '${this.k.identifier.value}' for ${V}`),Ne}async resolveInlayHint(F,V){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...F);if(!G)return;const J=await this.h.resolveInlayHint(G,V);if(J&&this.l(J))return this.m(J,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,V){return F.label.length===0||Array.isArray(F.label)&&F.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(V&&!V.contains(F.position))}m(F,V){const G=this.e.get(V[0]);if(!G)throw Error("DisposableStore is missing...");const J={label:"",cacheId:V,tooltip:C.MarkdownString.fromStrict(F.tooltip),position:C.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(C.TextEdit.from),kind:F.kind&&C.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?J.label=F.label:J.label=F.label.map(q=>{const x={label:q.value};return x.tooltip=C.MarkdownString.fromStrict(q.tooltip),T.$tK.isLocation(q.location)&&(x.location=C.location.from(q.location)),q.command&&(x.command=this.g.toInternal(q.command,G)),x}),J}}class ee{constructor(F,V){this.e=F,this.f=V,this.d=new c.$Wbc("DocumentLink")}async provideLinks(F,V){const G=this.e.getDocument(F),J=await this.f.provideDocumentLinks(G,V);if(!(!Array.isArray(J)||J.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(ee.g).map(C.DocumentLink.from)};{const q=this.d.add(J),x={links:[],cacheId:q};for(let ce=0;ce<J.length;ce++){if(!ee.g(J[ce]))continue;const Ne=C.DocumentLink.from(J[ce]);Ne.cacheId=[q,ce],x.links.push(Ne)}return x}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,V){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...F);if(!G)return;const J=await this.f.resolveDocumentLink(G,V);if(!(!J||!ee.g(J)))return C.DocumentLink.from(J)}releaseLinks(F){this.d.delete(F)}}class ve{constructor(F,V){this.d=F,this.e=V}async provideColors(F,V){const G=this.d.getDocument(F),J=await this.e.provideDocumentColors(G,V);return Array.isArray(J)?J.map(x=>({color:C.Color.from(x.color),range:C.Range.from(x.range)})):[]}async provideColorPresentations(F,V,G){const J=this.d.getDocument(F),q=C.Range.to(V.range),x=C.Color.to(V.color),ce=await this.e.provideColorPresentations(x,{document:J,range:q},G);if(Array.isArray(ce))return ce.map(C.ColorPresentation.from)}}class ge{constructor(F,V){this.d=F,this.e=V}async provideFoldingRanges(F,V,G){const J=this.d.getDocument(F),q=await this.e.provideFoldingRanges(J,V,G);if(Array.isArray(q))return q.map(C.FoldingRange.from)}}class de{constructor(F,V,G){this.d=F,this.e=V,this.f=G}async provideSelectionRanges(F,V,G){const J=this.d.getDocument(F),q=V.map(C.Position.to),x=await this.e.provideSelectionRanges(J,q,G);if(!(0,R.$Lb)(x))return[];if(x.length!==q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Ne=0;Ne<q.length;Ne++){const Ue=[];ce.push(Ue);let Qe=q[Ne],Ge=x[Ne];for(;;){if(!Ge.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(C.SelectionRange.from(Ge)),!Ge.parent)break;Qe=Ge.range,Ge=Ge.parent}}return ce}}class De{constructor(F,V){this.f=F,this.g=V,this.d=new i.$lM(""),this.e=new Map}async prepareSession(F,V,G){const J=this.f.getDocument(F),q=C.Position.to(V),x=await this.g.prepareCallHierarchy(J,q,G);if(!x)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(x)?x.map(Ne=>this.h(ce,Ne)):[this.h(ce,x)]}async provideCallsTo(F,V,G){const J=this.j(F,V);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyIncomingCalls(J,G);if(q)return q.map(x=>({from:this.h(F,x.from),fromRanges:x.fromRanges.map(ce=>C.Range.from(ce))}))}async provideCallsFrom(F,V,G){const J=this.j(F,V);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyOutgoingCalls(J,G);if(q)return q.map(x=>({to:this.h(F,x.to),fromRanges:x.fromRanges.map(ce=>C.Range.from(ce))}))}releaseSession(F){this.e.delete(F)}h(F,V){const G=this.e.get(F),J=C.CallHierarchyItem.from(V,F,G.size.toString(36));return G.set(J._itemId,V),J}j(F,V){return this.e.get(F)?.get(V)}}class re{constructor(F,V){this.f=F,this.g=V,this.d=new i.$lM(""),this.e=new Map}async prepareSession(F,V,G){const J=this.f.getDocument(F),q=C.Position.to(V),x=await this.g.prepareTypeHierarchy(J,q,G);if(!x)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(x)?x.map(Ne=>this.h(ce,Ne)):[this.h(ce,x)]}async provideSupertypes(F,V,G){const J=this.j(F,V);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySupertypes(J,G);if(q)return q.map(x=>this.h(F,x))}async provideSubtypes(F,V,G){const J=this.j(F,V);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySubtypes(J,G);if(q)return q.map(x=>this.h(F,x))}releaseSession(F){this.e.delete(F)}h(F,V){const G=this.e.get(F),J=C.TypeHierarchyItem.from(V,F,G.size.toString(36));return G.set(J._itemId,V),J}j(F,V){return this.e.get(F)?.get(V)}}class le{static toInternalProviderId(F,V){return F+"."+V}constructor(F,V,G,J,q){this.d=F,this.e=V,this.f=G,this.g=J,this.h=q}async provideDocumentOnDropEdits(F,V,G,J,q){const x=this.e.getDocument(V),ce=C.Position.to(G),Ne=C.DataTransfer.toDataTransfer(J,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,Qe)).buffer),Ue=await this.f.provideDocumentDropEdits(x,ce,Ne,q);if(Ue)return{label:Ue.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:le.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class ne{constructor(F,V){this.d=F,this.e=V}async provideMappedEdits(F,V,G,J){const q=y.URI.revive(F),x=this.d.getDocument(q),ce=G.documents.map(Qe=>Qe.map(Ge=>({uri:y.URI.revive(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(xe=>C.Range.to(xe))}))),Ne={documents:ce,selections:ce[0]?.[0]?.ranges??[]},Ue=await this.e.provideMappedEdits(x,V,Ne,J);return Ue?C.WorkspaceEdit.from(Ue):null}}class ae{constructor(F,V){this.adapter=F,this.extension=V}}class fe{static{this.d=0}constructor(F,V,G,J,q,x,ce,Ne){this.g=V,this.h=G,this.j=J,this.k=q,this.l=x,this.m=ce,this.n=Ne,this.f=new Map,this.e=F.getProxy(l.$fK.MainThreadLanguageFeatures)}o(F,V){return C.DocumentSelector.from(F,this.g,V)}p(F){return new T.$hK(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return fe.d++}async s(F,V,G,J,q,x=!1){const ce=this.f.get(F);if(!ce||!(ce.adapter instanceof V))return J;const Ne=Date.now();x||this.l.trace(`[${ce.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ue=G(ce.adapter,ce.extension);return Promise.resolve(Ue).catch(Qe=>{(0,E.$4)(Qe)||(this.l.error(`[${ce.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ce.extension.identifier,Qe))}).finally(()=>{x||this.l.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Ne}ms`)}),p.CancellationToken.isCancellationToken(q)?(0,v.$Jg)(Ue,q):Ue}t(F,V){const G=this.q();return this.f.set(G,new ae(F,V)),G}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,V,G,J){const q=this.t(new n(this.h,G),F),x=J&&J.label||fe.u(F);return this.e.$registerDocumentSymbolProvider(q,this.o(V,F),x),this.p(q)}$provideDocumentSymbols(F,V,G){return this.s(F,n,J=>J.provideDocumentSymbols(y.URI.revive(V),G),void 0,G)}registerCodeLensProvider(F,V,G){const J=this.q(),q=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new ae(new o(this.h,this.j.converter,G),F)),this.e.$registerCodeLensSupport(J,this.o(V,F),q);let x=this.p(J);if(q!==void 0){const ce=G.onDidChangeCodeLenses(Ne=>this.e.$emitCodeLensEvent(q));x=T.$hK.from(x,ce)}return x}$provideCodeLenses(F,V,G){return this.s(F,o,J=>J.provideCodeLenses(y.URI.revive(V),G),void 0,G)}$resolveCodeLens(F,V,G){return this.s(F,o,J=>J.resolveCodeLens(V,G),void 0,void 0)}$releaseCodeLenses(F,V){this.s(F,o,G=>Promise.resolve(G.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(F,V,G){const J=this.t(new f(this.h,G),F);return this.e.$registerDefinitionSupport(J,this.o(V,F)),this.p(J)}$provideDefinition(F,V,G,J){return this.s(F,f,q=>q.provideDefinition(y.URI.revive(V),G,J),[],J)}registerDeclarationProvider(F,V,G){const J=this.t(new I(this.h,G),F);return this.e.$registerDeclarationSupport(J,this.o(V,F)),this.p(J)}$provideDeclaration(F,V,G,J){return this.s(F,I,q=>q.provideDeclaration(y.URI.revive(V),G,J),[],J)}registerImplementationProvider(F,V,G){const J=this.t(new S(this.h,G),F);return this.e.$registerImplementationSupport(J,this.o(V,F)),this.p(J)}$provideImplementation(F,V,G,J){return this.s(F,S,q=>q.provideImplementation(y.URI.revive(V),G,J),[],J)}registerTypeDefinitionProvider(F,V,G){const J=this.t(new u(this.h,G),F);return this.e.$registerTypeDefinitionSupport(J,this.o(V,F)),this.p(J)}$provideTypeDefinition(F,V,G,J){return this.s(F,u,q=>q.provideTypeDefinition(y.URI.revive(V),G,J),[],J)}registerHoverProvider(F,V,G,J){const q=this.t(new m(this.h,G),F);return this.e.$registerHoverProvider(q,this.o(V,F)),this.p(q)}$provideHover(F,V,G,J){return this.s(F,m,q=>q.provideHover(y.URI.revive(V),G,J),void 0,J)}registerEvaluatableExpressionProvider(F,V,G,J){const q=this.t(new h(this.h,G),F);return this.e.$registerEvaluatableExpressionProvider(q,this.o(V,F)),this.p(q)}$provideEvaluatableExpression(F,V,G,J){return this.s(F,h,q=>q.provideEvaluatableExpression(y.URI.revive(V),G,J),void 0,J)}registerInlineValuesProvider(F,V,G,J){const q=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new P(this.h,G),F);this.e.$registerInlineValuesProvider(x,this.o(V,F),q);let ce=this.p(x);if(q!==void 0){const Ne=G.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(q));ce=T.$hK.from(ce,Ne)}return ce}$provideInlineValues(F,V,G,J,q){return this.s(F,P,x=>x.provideInlineValues(y.URI.revive(V),G,J,q),void 0,q)}registerDocumentHighlightProvider(F,V,G){const J=this.t(new W(this.h,G),F);return this.e.$registerDocumentHighlightProvider(J,this.o(V,F)),this.p(J)}$provideDocumentHighlights(F,V,G,J){return this.s(F,W,q=>q.provideDocumentHighlights(y.URI.revive(V),G,J),void 0,J)}registerLinkedEditingRangeProvider(F,V,G){const J=this.t(new K(this.h,G),F);return this.e.$registerLinkedEditingRangeProvider(J,this.o(V,F)),this.p(J)}$provideLinkedEditingRanges(F,V,G,J){return this.s(F,K,async q=>{const x=await q.provideLinkedEditingRanges(y.URI.revive(V),G,J);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?fe.w(x.wordPattern):void 0}},void 0,J)}registerReferenceProvider(F,V,G){const J=this.t(new z(this.h,G),F);return this.e.$registerReferenceSupport(J,this.o(V,F)),this.p(J)}$provideReferences(F,V,G,J,q){return this.s(F,z,x=>x.provideReferences(y.URI.revive(V),G,J,q),void 0,q)}registerCodeActionProvider(F,V,G,J){const q=new d.$Rc,x=this.t(new j(this.h,this.j.converter,this.k,G,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(x,this.o(V,F),{providedKinds:J?.providedCodeActionKinds?.map(ce=>ce.value),documentation:J?.documentation?.map(ce=>({kind:ce.kind.value,command:this.j.converter.toInternal(ce.command,q)}))},fe.u(F),!!G.resolveCodeAction),q.add(this.p(x)),q}$provideCodeActions(F,V,G,J,q){return this.s(F,j,x=>x.provideCodeActions(y.URI.revive(V),G,J,q),void 0,q)}$resolveCodeAction(F,V,G){return this.s(F,j,J=>J.resolveCodeAction(V,G),{},void 0)}$releaseCodeActions(F,V){this.s(F,j,G=>Promise.resolve(G.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(F,V,G){const J=this.t(new N(this.h,G),F);return this.e.$registerDocumentFormattingSupport(J,this.o(V,F),F.identifier,F.displayName||F.name),this.p(J)}$provideDocumentFormattingEdits(F,V,G,J){return this.s(F,N,q=>q.provideDocumentFormattingEdits(y.URI.revive(V),G,J),void 0,J)}registerDocumentRangeFormattingEditProvider(F,V,G){const J=typeof G.provideDocumentRangesFormattingEdits=="function",q=this.t(new ie(this.h,G),F);return this.e.$registerRangeFormattingSupport(q,this.o(V,F),F.identifier,F.displayName||F.name,J),this.p(q)}$provideDocumentRangeFormattingEdits(F,V,G,J,q){return this.s(F,ie,x=>x.provideDocumentRangeFormattingEdits(y.URI.revive(V),G,J,q),void 0,q)}$provideDocumentRangesFormattingEdits(F,V,G,J,q){return this.s(F,ie,x=>x.provideDocumentRangesFormattingEdits(y.URI.revive(V),G,J,q),void 0,q)}registerOnTypeFormattingEditProvider(F,V,G,J){const q=this.t(new X(this.h,G),F);return this.e.$registerOnTypeFormattingSupport(q,this.o(V,F),J,F.identifier),this.p(q)}$provideOnTypeFormattingEdits(F,V,G,J,q,x){return this.s(F,X,ce=>ce.provideOnTypeFormattingEdits(y.URI.revive(V),G,J,q,x),void 0,x)}registerWorkspaceSymbolProvider(F,V){const G=this.t(new Ee(V,this.l),F);return this.e.$registerNavigateTypeSupport(G,typeof V.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(F,V,G){return this.s(F,Ee,J=>J.provideWorkspaceSymbols(V,G),{symbols:[]},G)}$resolveWorkspaceSymbol(F,V,G){return this.s(F,Ee,J=>J.resolveWorkspaceSymbol(V,G),void 0,void 0)}$releaseWorkspaceSymbols(F,V){this.s(F,Ee,G=>G.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(F,V,G){const J=this.t(new Se(this.h,G,this.l),F);return this.e.$registerRenameSupport(J,this.o(V,F),Se.supportsResolving(G)),this.p(J)}$provideRenameEdits(F,V,G,J,q){return this.s(F,Se,x=>x.provideRenameEdits(y.URI.revive(V),G,J,q),void 0,q)}$resolveRenameLocation(F,V,G,J){return this.s(F,Se,q=>q.resolveRenameLocation(y.URI.revive(V),G,J),void 0,J)}registerDocumentSemanticTokensProvider(F,V,G,J){const q=this.t(new $e(this.h,G),F),x=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(q,this.o(V,F),J,x);let ce=this.p(q);if(x){const Ne=G.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(x));ce=T.$hK.from(ce,Ne)}return ce}$provideDocumentSemanticTokens(F,V,G,J){return this.s(F,$e,q=>q.provideDocumentSemanticTokens(y.URI.revive(V),G,J),null,J)}$releaseDocumentSemanticTokens(F,V){this.s(F,$e,G=>G.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,V,G,J){const q=this.t(new pe(this.h,G),F);return this.e.$registerDocumentRangeSemanticTokensProvider(q,this.o(V,F),J),this.p(q)}$provideDocumentRangeSemanticTokens(F,V,G,J){return this.s(F,pe,q=>q.provideDocumentRangeSemanticTokens(y.URI.revive(V),G,J),null,J)}registerCompletionItemProvider(F,V,G,J){const q=this.t(new ue(this.h,this.j.converter,G,this.m,F),F);return this.e.$registerCompletionsProvider(q,this.o(V,F),J,ue.supportsResolving(G),F.identifier),this.p(q)}$provideCompletionItems(F,V,G,J,q){return this.s(F,ue,x=>x.provideCompletionItems(y.URI.revive(V),G,J,q),void 0,q)}$resolveCompletionItem(F,V,G){return this.s(F,ue,J=>J.resolveCompletionItem(V,G),void 0,G)}$releaseCompletionItems(F,V){this.s(F,ue,G=>G.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(F,V,G,J){const q=new be(F,this.h,G,this.j.converter),x=this.t(q,F);return this.e.$registerInlineCompletionsSupport(x,this.o(V,F),q.supportsHandleEvents,g.$6l.toKey(F.identifier.value),J?.yieldTo?.map(ce=>g.$6l.toKey(ce))||[]),this.p(x)}$provideInlineCompletions(F,V,G,J,q){return this.s(F,oe,x=>x.provideInlineCompletions(y.URI.revive(V),G,J,q),void 0,q)}$handleInlineCompletionDidShow(F,V,G,J){this.s(F,oe,async q=>{q.handleDidShowCompletionItem(V,G,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,V,G,J){this.s(F,oe,async q=>{q.handlePartialAccept(V,G,J)},void 0,void 0)}$freeInlineCompletionsList(F,V){this.s(F,oe,async G=>{G.disposeCompletions(V)},void 0,void 0)}registerSignatureHelpProvider(F,V,G,J){const q=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,x=this.t(new B(this.h,G),F);return this.e.$registerSignatureHelpProvider(x,this.o(V,F),q),this.p(x)}$provideSignatureHelp(F,V,G,J,q){return this.s(F,B,x=>x.provideSignatureHelp(y.URI.revive(V),G,J,q),void 0,q)}$releaseSignatureHelp(F,V){this.s(F,B,G=>G.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(F,V,G){const J=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,q=this.t(new Z(this.h,this.j.converter,G,this.l,F),F);this.e.$registerInlayHintsProvider(q,this.o(V,F),typeof G.resolveInlayHint=="function",J,fe.u(F));let x=this.p(q);if(J!==void 0){const ce=G.onDidChangeInlayHints(Ne=>this.e.$emitInlayHintsEvent(J));x=T.$hK.from(x,ce)}return x}$provideInlayHints(F,V,G,J){return this.s(F,Z,q=>q.provideInlayHints(y.URI.revive(V),G,J),void 0,J)}$resolveInlayHint(F,V,G){return this.s(F,Z,J=>J.resolveInlayHint(V,G),void 0,G)}$releaseInlayHints(F,V){this.s(F,Z,G=>G.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(F,V,G){const J=this.t(new ee(this.h,G),F);return this.e.$registerDocumentLinkProvider(J,this.o(V,F),typeof G.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(F,V,G){return this.s(F,ee,J=>J.provideLinks(y.URI.revive(V),G),void 0,G,V.scheme==="output")}$resolveDocumentLink(F,V,G){return this.s(F,ee,J=>J.resolveLink(V,G),void 0,void 0,!0)}$releaseDocumentLinks(F,V){this.s(F,ee,G=>G.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(F,V,G){const J=this.t(new ve(this.h,G),F);return this.e.$registerDocumentColorProvider(J,this.o(V,F)),this.p(J)}$provideDocumentColors(F,V,G){return this.s(F,ve,J=>J.provideColors(y.URI.revive(V),G),[],G)}$provideColorPresentations(F,V,G,J){return this.s(F,ve,q=>q.provideColorPresentations(y.URI.revive(V),G,J),void 0,J)}registerFoldingRangeProvider(F,V,G){const J=this.q(),q=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new ae(new ge(this.h,G),F)),this.e.$registerFoldingRangeProvider(J,this.o(V,F),F.identifier,q);let x=this.p(J);if(q!==void 0){const ce=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(q));x=T.$hK.from(x,ce)}return x}$provideFoldingRanges(F,V,G,J){return this.s(F,ge,q=>q.provideFoldingRanges(y.URI.revive(V),G,J),void 0,J)}registerSelectionRangeProvider(F,V,G){const J=this.t(new de(this.h,G,this.l),F);return this.e.$registerSelectionRangeProvider(J,this.o(V,F)),this.p(J)}$provideSelectionRanges(F,V,G,J){return this.s(F,de,q=>q.provideSelectionRanges(y.URI.revive(V),G,J),[],J)}registerCallHierarchyProvider(F,V,G){const J=this.t(new De(this.h,G),F);return this.e.$registerCallHierarchyProvider(J,this.o(V,F)),this.p(J)}$prepareCallHierarchy(F,V,G,J){return this.s(F,De,q=>Promise.resolve(q.prepareSession(y.URI.revive(V),G,J)),void 0,J)}$provideCallHierarchyIncomingCalls(F,V,G,J){return this.s(F,De,q=>q.provideCallsTo(V,G,J),void 0,J)}$provideCallHierarchyOutgoingCalls(F,V,G,J){return this.s(F,De,q=>q.provideCallsFrom(V,G,J),void 0,J)}$releaseCallHierarchy(F,V){this.s(F,De,G=>Promise.resolve(G.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(F,V,G){const J=this.t(new re(this.h,G),F);return this.e.$registerTypeHierarchyProvider(J,this.o(V,F)),this.p(J)}$prepareTypeHierarchy(F,V,G,J){return this.s(F,re,q=>Promise.resolve(q.prepareSession(y.URI.revive(V),G,J)),void 0,J)}$provideTypeHierarchySupertypes(F,V,G,J){return this.s(F,re,q=>q.provideSupertypes(V,G,J),void 0,J)}$provideTypeHierarchySubtypes(F,V,G,J){return this.s(F,re,q=>q.provideSubtypes(V,G,J),void 0,J)}$releaseTypeHierarchy(F,V){this.s(F,re,G=>Promise.resolve(G.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(F,V,G,J){const q=this.q();this.f.set(q,new ae(new le(this.e,this.h,G,q,F),F));const x=(0,s.$cF)(F,"dropMetadata")&&J?le.toInternalProviderId(F.identifier.value,J.id):void 0;return this.e.$registerDocumentOnDropEditProvider(q,this.o(V,F),x,(0,s.$cF)(F,"dropMetadata")?J:void 0),this.p(q)}$provideDocumentOnDropEdits(F,V,G,J,q,x){return this.s(F,le,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(V,y.URI.revive(G),J,q,x)),void 0,void 0)}registerMappedEditsProvider(F,V,G){const J=this.t(new ne(this.h,G),F);return this.e.$registerMappedEditsProvider(J,this.o(V,F)),this.p(J)}$provideMappedEdits(F,V,G,J,q){return this.s(F,ne,x=>Promise.resolve(x.provideMappedEdits(V,G,J,q)),null,q)}registerDocumentPasteEditProvider(F,V,G,J){const q=this.q();this.f.set(q,new ae(new O(this.e,this.h,G,q,F),F));const x=O.toInternalProviderId(F.identifier.value,J.id);return this.e.$registerPasteEditProvider(q,this.o(V,F),x,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(q)}$prepareDocumentPaste(F,V,G,J,q){return this.s(F,O,x=>x.prepareDocumentPaste(y.URI.revive(V),G,J,q),void 0,q)}$providePasteEdits(F,V,G,J,q,x){return this.s(F,O,ce=>ce.providePasteEdits(V,y.URI.revive(G),J,q,x),void 0,x)}static w(F){return{pattern:F.source,flags:F.flags}}static y(F){return{decreaseIndentPattern:fe.w(F.decreaseIndentPattern),increaseIndentPattern:fe.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?fe.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?fe.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:fe.w(F.beforeText),afterText:F.afterText?fe.w(F.afterText):void 0,previousLineText:F.previousLineText?fe.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(fe.z)}static C(F){return{open:F.open,close:F.close,notIn:F.notIn?F.notIn.map(V=>T.SyntaxTokenType.toString(V)):void 0}}static D(F){return F.map(fe.C)}setLanguageConfiguration(F,V,G){const{wordPattern:J}=G;if(J&&(0,D.$Oe)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(V,J):this.h.setWordDefinitionFor(V,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const q=this.q(),x={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?fe.w(G.wordPattern):void 0,indentationRules:G.indentationRules?fe.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?fe.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?fe.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(q,V,x),this.p(q)}$setWordDefinitions(F){for(const V of F)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$6bc=fe}),define(Ae[241],Re([1,0,3,8,7,29,12,6,25]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=void 0;class ${constructor(k,a,p,g){this.c=a,this.d=p,this.e=g,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(y.$fK.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,a){await this.a.$changeLanguage(k,a);const p=this.c.getDocumentData(k);if(!p)throw new Error(`document '${k.toString()}' NOT found`);return p.document}async tokenAtPosition(k,a){const p=k.version,g=M.Position.from(a),d=await this.a.$tokensAtPosition(k.uri,g),t={type:C.StandardTokenType.Other,range:k.getWordRangeAtPosition(a)??new C.$jK(a.line,a.character,a.line,a.character)};if(!d)return t;const i={range:M.Range.to(d.range),type:M.TokenType.to(d.type)};return!i.range.contains(a)||p!==k.version?t:i}createLanguageStatusItem(k,a,p){const g=this.f++,d=this.a,t=this.g,i=`${k.identifier.value}/${a}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${a}' ALREADY exists`);t.add(i);const c={selector:p,id:a,name:k.displayName??k.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b;const E=new l.$Rc,v=()=>{if(b?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${a}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}b=(0,A.$Vg)(()=>{E.clear(),this.a.$setLanguageStatus(g,{id:i,name:c.name??k.displayName??k.name,source:k.displayName??k.name,selector:M.DocumentSelector.from(c.selector,this.e),label:c.text,detail:c.detail??"",severity:c.severity===C.LanguageStatusSeverity.Error?T.default.Error:c.severity===C.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:c.command&&this.d.toInternal(c.command,E),accessibilityInfo:c.accessibilityInformation,busy:c.busy})},0)},s={dispose(){E.dispose(),b?.dispose(),d.$removeLanguageStatus(g),t.delete(i)},get id(){return c.id},get name(){return c.name},set name(r){c.name=r,v()},get selector(){return c.selector},set selector(r){c.selector=r,v()},get text(){return c.text},set text(r){c.text=r,v()},set text2(r){(0,D.$dF)(k,"languageStatusText"),c.text=r,v()},get text2(){return(0,D.$dF)(k,"languageStatusText"),c.text},get detail(){return c.detail},set detail(r){c.detail=r,v()},get severity(){return c.severity},set severity(r){c.severity=r,v()},get accessibilityInformation(){return c.accessibilityInformation},set accessibilityInformation(r){c.accessibilityInformation=r,v()},get command(){return c.command},set command(r){c.command=r,v()},get busy(){return c.busy},set busy(r){c.busy=r,v()}};return v(),s}}e.$Ncc=$}),define(Ae[81],Re([1,0,22,16,2,4,14,3,27,17]),function(ye,e,y,M,C,T,A,l,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=e.$Ccc=void 0;let R=class{constructor(a,p,g){this.f=g,this.d=new Map,this.a=p.getProxy(l.$fK.MainThreadLocalization),this.b=a.environment.appLanguage,this.c=this.b===y.$g}getMessage(a,p){const{message:g,args:d,comment:t}=p;if(this.c)return(0,M.$De)(g,d??{});let i=g;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const c=this.d.get(a)?.contents[i];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,M.$De)(c??g,d??{})}getBundle(a){return this.d.get(a)?.contents}getBundleUri(a){return this.d.get(a)?.uri}async initializeLocalizedMessages(a){if(this.c||!a.l10n&&!a.isBuiltin||this.d.has(a.identifier.value))return;let p;const g=await this.g(a);if(!g){this.f.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents(g),t=JSON.parse(d);p=a.isBuiltin?t.contents?.bundle:t}catch(d){this.f.error(`Failed to load translations for ${a.identifier.value} from ${g}: ${d.message}`);return}p&&this.d.set(a.identifier.value,{contents:p,uri:g})}async g(a){if(a.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(a.identifier.value,this.b);return C.URI.revive(p)}return a.l10n?C.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Ccc=R,e.$Ccc=R=qe([Ke(0,D.$wM),Ke(1,$.$gM),Ke(2,A.$0i)],R),e.$Dcc=(0,T.$Ph)("IExtHostLocalizationService")}),define(Ae[242],Re([1,0,14,3,27,17,2,68]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;let D=class extends y.$ij{constructor(k,a){super(a.logLevel,a.logsLocation,a.loggers.map(p=>(0,l.$mh)(p))),this.r=k.getProxy(M.$fK.MainThreadLogger)}$setLogLevel(k,a){a?this.setLogLevel(A.URI.revive(a),k):this.setLogLevel(k)}setVisibility(k,a){super.setVisibility(k,a),this.r.$setVisibility(k,a)}s(k,a,p){return new $(this.r,k,a,p)}};e.$6dc=D,e.$6dc=D=qe([Ke(0,T.$gM),Ke(1,C.$wM)],D);class $ extends y.$dj{constructor(k,a,p,g){super(g?.logLevel==="always"),this.r=k,this.s=a,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(a,g).then(()=>{this.u(this.n),this.m=!0})}g(k,a){const p=[[k,a]];this.m?this.u(p):this.n.push(...p)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Ae[82],Re([1,0,3,4,6,17,26]),function(ye,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=e.$Ecc=void 0,e.$Ecc=(0,M.$Ph)("IExtHostManagedSockets");let l=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(y.$fK.MainThreadManagedSockets)}setFactory(k,a){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new D(k,a),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const a=++this.b,p=await this.c.makeConnection(),g=new C.$Rc;return this.d.set(a,new $(a,p,g)),g.add((0,C.$Qc)(()=>this.d.delete(a))),g.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(a),g.dispose()})),g.add(p.onDidClose(d=>{this.a.$onDidManagedSocketClose(a,d?.stack??d?.message),g.dispose()})),g.add(p.onDidReceiveMessage(d=>this.a.$onDidManagedSocketHaveData(a,A.$be.wrap(d)))),a}$remoteSocketWrite(k,a){this.d.get(k)?.actual.send(a.buffer)}$remoteSocketEnd(k){const a=this.d.get(k);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$Fcc=l,e.$Fcc=l=qe([Ke(0,T.$gM)],l);class D{constructor(k,a){this.socketFactoryId=k,this.makeConnection=a}}class $ extends C.$Sc{constructor(k,a,p){super(),this.socketId=k,this.actual=a,this.B(p)}}}),define(Ae[243],Re([1,0,3,14,25]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=void 0;function T(l){return l&&l.title}let A=class{constructor(D,$){this.b=$,this.a=D.getProxy(y.$fK.MainThreadMessageService)}showMessage(D,$,R,k,a){const p={source:{identifier:D.identifier,label:D.displayName||D.name}};let g;typeof k=="string"||T(k)?g=[k,...a]:(p.modal=k?.modal,p.useCustom=k?.useCustom,p.detail=k?.detail,g=a),p.useCustom&&(0,C.$dF)(D,"resolvers");const d=[];for(let t=0;t<g.length;t++){const i=g[t];if(typeof i=="string")d.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:c,isCloseAffordance:b}=i;d.push({title:c,isCloseAffordance:!!b,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage($,R,p,d).then(t=>{if(typeof t=="number")return g[t]})}};e.$Occ=A,e.$Occ=A=qe([Ke(1,M.$0i)],A)}),define(Ae[244],Re([1,0,151,26,5,6,28,16,15,2,39,74,3,31,8,7,47,204,103,9,24,13]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d,t,i,c,b,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;class s{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(n=>n.apiEditor)}constructor(n,o,w,f,I){this.q=w,this.r=f,this.s=I,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new C.$Nd({onListenerError:b.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$Nd({onListenerError:b.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$Nd({onListenerError:b.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$Nd({onListenerError:b.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$Wbc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=n.getProxy(a.$fK.MainThreadNotebook),this.c=n.getProxy(a.$fK.MainThreadNotebookDocuments),this.d=n.getProxy(a.$fK.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const u=S.notebookEditor?.notebookUri,m=S.cell.handle,P=this.g.get(u)?.getCell(m);if(P)return P.apiCell}if(S&&S.$mid===14){const u=S.uri,m=this.g.get(u);if(m)return m.apiNotebook}return S}}),s.A(o)}getEditorById(n){const o=this.h.get(n);if(!o)throw new Error(`unknown text editor: ${n}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(n){for(const[o,w]of this.h)if(w.apiEditor===n)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(n,o){const w=this.g.get(n);if(!w&&!o)throw new Error(`NO notebook document for '${n}'`);return w}static t(n,o){if(!o)return;const w=o.filenamePattern.map(f=>g.NotebookExclusiveDocumentPattern.from(f)).filter(f=>f!==void 0);if(o.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:n.identifier,providerDisplayName:n.displayName||n.name,displayName:o.displayName,filenamePattern:w,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(n,o,w){const f=s.a++,I=typeof w.onDidChangeCellStatusBarItems=="function"?s.a++:void 0;this.f.set(f,w),this.b.$registerNotebookCellStatusBarItemProvider(f,I,o);let S;return I!==void 0&&(S=w.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(I))),new d.$hK(()=>{this.f.delete(f),this.b.$unregisterNotebookCellStatusBarItemProvider(f,I),S?.dispose()})}async createNotebookDocument(n){const o=await this.c.$tryCreateNotebook({viewType:n.viewType,content:n.content&&g.NotebookData.from(n.content)});return $.URI.revive(o)}async openNotebookDocument(n){const o=this.g.get(n);if(o)return o.apiNotebook;const w=await this.c.$tryOpenNotebook(n),f=this.g.get($.URI.revive(w));return(0,D.$Jf)(f?.apiNotebook)}async showNotebookDocument(n,o){$.URI.isUri(n)&&(n=await this.openNotebookDocument(n));let w;typeof o=="object"?w={position:g.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(g.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:w={preserveFocus:!1};const f=await this.d.$tryShowNotebookDocument(n.uri,n.notebookType,w),I=f&&this.h.get(f)?.apiEditor;if(I)return I;throw f?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(n,o,w,f){const I=this.f.get(n),S=$.URI.revive(o),u=this.g.get(S);if(!u||!I)return;const m=u.getCellFromIndex(w);if(!m)return;const h=await I.provideCellStatusBarItems(m.apiCell,f);if(!h)return;const P=new T.$Rc,W=this.p.add([P]),z=(Array.isArray(h)?h:[h]).map(j=>g.NotebookStatusBarItem.from(j,this.i,P));return{cacheId:W,items:z}}$releaseNotebookCellStatusBarItems(n){this.p.delete(n)}registerNotebookSerializer(n,o,w,f,I){if((0,l.$Be)(o))throw new Error("viewType cannot be empty or just whitespace");const S=this.u++;return this.w.set(S,{viewType:o,serializer:w,options:f}),this.b.$registerNotebookSerializer(S,{id:n.identifier,location:n.extensionLocation},o,g.NotebookDocumentContentOptions.from(f),s.t(n,I)),(0,T.$Qc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(n,o,w){const f=this.w.get(n);if(!f)throw new Error("NO serializer found");const I=await f.serializer.deserializeNotebook(o.buffer,w);return new t.$pv(g.NotebookData.from(I))}async $notebookToData(n,o,w){const f=this.w.get(n);if(!f)throw new Error("NO serializer found");const I=await f.serializer.serializeNotebook(g.NotebookData.to(o.value),w);return M.$be.wrap(I)}async $saveNotebook(n,o,w,f,I){const S=$.URI.revive(o),u=this.w.get(n);if(!u)throw new Error("NO serializer found");const m=this.g.get(S);if(!m)throw new Error("Document NOT found");if(m.versionId!==w)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new R.$tk((0,y.localize)(0,null,this.y(S)),6);await this.x(S,f);const h={metadata:(0,E.$cn)(m.apiNotebook.metadata,j=>!(u.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of m.apiNotebook.getCells()){const O=new d.$FL(j.kind,j.document.getText(),j.document.languageId,j.mime,u.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);O.metadata=(0,E.$cn)(j.metadata,N=>!(u.options?.transientCellMetadata??{})[N]),h.cells.push(O)}const P=await u.serializer.serializeNotebook(h,I);await this.s.value.writeFile(S,P);const W=this.s.getFileSystemProviderExtUri(S.scheme),K=await this.s.value.stat(S);return{name:W.basename(S),isFile:(K.type&R.FileType.File)!==0,isDirectory:(K.type&R.FileType.Directory)!==0,isSymbolicLink:(K.type&R.FileType.SymbolicLink)!==0,mtime:K.mtime,ctime:K.ctime,size:K.size,readonly:!!((K.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((K.permissions??0)&R.FilePermission.Locked),etag:R.$Ek({mtime:K.mtime,size:K.size}),children:void 0}}async x(n,o){const w=await this.s.value.stat(n);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==R.$Dk&&typeof w.mtime=="number"&&typeof w.size=="number"&&o.mtime<w.mtime&&o.etag!==R.$Ek({mtime:o.mtime,size:w.size}))throw new R.$tk((0,y.localize)(1,null),3,o)}y(n){return n.scheme===v.Schemas.file?n.fsPath:n.toString()}z(n,o,w){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const f=new c.$vdc(o,this.d,n,w.visibleRanges.map(g.NotebookRange.to),w.selections.map(g.NotebookRange.to),typeof w.viewColumn=="number"?g.ViewColumn.to(w.viewColumn):void 0);this.h.set(o,f)}$acceptDocumentAndEditorsDelta(n){if(n.value.removedDocuments)for(const w of n.value.removedDocuments){const f=$.URI.revive(w),I=this.g.get(f);I&&(I.dispose(),this.g.delete(f),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(I.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===f.toString()&&this.h.delete(S.id)}if(n.value.addedDocuments){const w=[];for(const f of n.value.addedDocuments){const I=$.URI.revive(f.uri);if(this.g.has(I))throw new Error(`adding EXISTING notebook ${I} `);const S=new i.$udc(this.c,this.q,this.r,I,f);w.push(...f.cells.map(u=>i.$tdc.asModelAddData(S.apiNotebook,u))),this.g.get(I)?.dispose(),this.g.set(I,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(S.apiNotebook)}}if(n.value.addedEditors)for(const w of n.value.addedEditors){if(this.h.has(w.id))return;const f=$.URI.revive(w.documentUri),I=this.g.get(f);I&&this.z(I,w.id,w)}const o=[];if(n.value.removedEditors)for(const w of n.value.removedEditors){const f=this.h.get(w);f&&(this.h.delete(w),this.k?.id===f.id&&(this.k=void 0),o.push(f))}if(n.value.visibleEditors){this.l=n.value.visibleEditors.map(f=>this.h.get(f)).filter(f=>!!f);const w=new Set;this.l.forEach(f=>w.add(f.id));for(const f of this.h.values()){const I=w.has(f.id);f._acceptVisibility(I)}this.l=[...this.h.values()].map(f=>f).filter(f=>f.visible),this.o.fire(this.visibleNotebookEditors)}n.value.newActiveEditor===null?this.k=void 0:n.value.newActiveEditor&&(this.h.get(n.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${n.value.newActiveEditor}`),this.k=this.h.get(n.value.newActiveEditor)),n.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(n){const o=p.$EM.String.with("notebookType","A notebook type"),w=new p.$GM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new p.$EM("data","Bytes to convert to data",I=>I instanceof Uint8Array,I=>M.$be.wrap(I))],new p.$FM("Notebook Data",I=>g.NotebookData.to(I.value))),f=new p.$GM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new p.$EM("NotebookData","Notebook data to convert to bytes",I=>!0,I=>new t.$pv(g.NotebookData.from(I)))],new p.$FM("Bytes",I=>I.buffer));n.registerApiCommand(w),n.registerApiCommand(f)}}e.$wdc=s}),define(Ae[245],Re([1,0,18,12,20,5,6,28,2,21,14,3,31,8,7,77,197,25,47]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=e.$Kdc=void 0;let b=class{constructor(f,I,S,u,m){this.l=I,this.m=S,this.n=u,this.o=m,this.b=new l.$Ac,this.c=new l.$Ac,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new T.$Nd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=f.getProxy(k.$fK.MainThreadNotebookKernels);const h=new a.$GM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.$EM("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const W=this.m.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:W}}else if(P&&"notebookEditor"in P){const W=this.m.getIdByEditor(P.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return P})],a.$FM.Void);this.n.registerApiCommand(h)}createNotebookController(f,I,S,u,m,h){for(const pe of this.i.values())if(pe.controller.id===I&&$.$6l.equals(f.identifier,pe.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const P=this.j++,W=this;this.o.trace(`NotebookController[${P}], CREATED by ${f.identifier.value}, ${I}`);const K=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${f.identifier}'`);let z=!1;const j=new T.$Nd,O=new T.$Nd,N={id:o(f.identifier,I),notebookType:S,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:u||f.identifier.value,preloads:h?h.map(p.NotebookRendererScript.from):[]};let ie=m??K,X;this.a.$addKernel(P,N).catch(pe=>{console.log(pe),z=!0});let Ee=0;const Se=()=>{if(z)return;const pe=++Ee;Promise.resolve().then(()=>{pe===Ee&&this.a.$updateKernel(P,N)})},Pe=new l.$Ac,$e={get id(){return I},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return N.label},set label(pe){N.label=pe??f.displayName??f.name,Se()},get detail(){return N.detail??""},set detail(pe){N.detail=pe,Se()},get description(){return N.description??""},set description(pe){N.description=pe,Se()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(pe){N.supportedLanguages=pe,Se()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(pe){N.supportsExecutionOrder=pe,Se()},get rendererScripts(){return N.preloads?N.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(pe){ie=pe??K},get interruptHandler(){return X},set interruptHandler(pe){X=pe,N.supportsInterrupt=!!pe,Se()},createNotebookCellExecution(pe){if(z)throw new Error("notebook controller is DISPOSED");if(!Pe.has(pe.notebook.uri))throw W.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.notebook.uri.toString()}`);return W._createNotebookCellExecution(pe,o(f.identifier,this.id))},createNotebookExecution(pe){if((0,i.$dF)(f,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!Pe.has(pe.uri))throw W.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.uri.toString()}`);return W._createNotebookExecution(pe,o(f.identifier,this.id))},dispose:()=>{z||(this.o.trace(`NotebookController[${P}], DISPOSED`),z=!0,this.i.delete(P),j.dispose(),O.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(pe,ue){ue===g.NotebookControllerAffinity2.Hidden&&(0,i.$dF)(f,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(P,pe.uri,ue)},onDidReceiveMessage:O.event,postMessage(pe,ue){return(0,i.$dF)(f,"notebookMessaging"),W.a.$postMessage(P,ue&&W.m.getIdByEditor(ue),pe)},asWebviewUri(pe){return(0,i.$dF)(f,"notebookMessaging"),(0,d.$8ob)(pe,W.l.remote)}};return this.i.set(P,{extensionId:f.identifier,controller:$e,onDidReceiveMessage:O,onDidChangeSelection:j,associatedNotebooks:Pe}),$e}getIdByController(f){for(const[I,S]of this.i)if(S.controller===f)return o(S.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,I){const S=this.f++,u=this;this.o.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(S,I);const m={dispose:()=>{this.e.delete(S),u.a.$removeKernelDetectionTask(S)}};return this.e.set(S,m),m}registerKernelSourceActionProvider(f,I,S){const u=this.h++,m=typeof S.onDidChangeNotebookKernelSourceActions=="function"?u:void 0,h=this;this.g.set(u,S),this.o.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(u,u,I);let P;return m!==void 0&&(P=S.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this.g.delete(u),h.a.$removeKernelSourceActionProvider(u,u),P?.dispose()}}}async $provideKernelSourceActions(f,I){const S=this.g.get(f);if(S){const u=new A.$Rc;return(await S.provideNotebookKernelSourceActions(I)??[]).map(h=>p.NotebookKernelSourceAction.from(h,this.n.converter,u))}return[]}$acceptNotebookAssociation(f,I,S){const u=this.i.get(f);if(u){const m=this.m.getNotebookDocument(D.URI.revive(I));S?u.associatedNotebooks.set(m.uri,!0):u.associatedNotebooks.delete(m.uri),this.o.trace(`NotebookController[${f}] ASSOCIATE notebook`,m.uri.toString(),S),u.onDidChangeSelection.fire({selected:S,notebook:m.apiNotebook})}}async $executeCells(f,I,S){const u=this.i.get(f);if(!u)return;const m=this.m.getNotebookDocument(D.URI.revive(I)),h=[];for(const P of S){const W=m.getCell(P);W&&h.push(W.apiCell)}try{this.o.trace(`NotebookController[${f}] EXECUTE cells`,m.uri.toString(),h.length),await u.controller.executeHandler.call(u.controller,h,m.apiNotebook,u.controller)}catch(P){this.o.error(`NotebookController[${f}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(f,I,S){const u=this.i.get(f);if(!u)return;const m=this.m.getNotebookDocument(D.URI.revive(I));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,m.apiNotebook);else for(const h of S){const P=m.getCell(h);P&&this.b.get(P.uri)?.cancel()}if(u.controller.interruptHandler){const h=this.c.get(m.uri);S.length&&Array.isArray(h)&&h.length&&h.forEach(P=>P.dispose())}}$acceptKernelMessageFromRenderer(f,I,S){const u=this.i.get(f);if(!u)return;const m=this.m.getEditorById(I);u.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:S}))}$cellExecutionChanged(f,I,S){const m=this.m.getNotebookDocument(D.URI.revive(f)).getCell(I);if(m){const h=S?p.NotebookCellExecutionState.to(S):g.NotebookCellExecutionState.Idle;h!==void 0&&this.k.fire({cell:m.apiCell,state:h})}}_createNotebookCellExecution(f,I){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this.m.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!u)throw new Error("invalid cell");if(this.b.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const m=new v(I,u,this.a);this.b.set(u.uri,m);const h=m.onDidChangeState(()=>{m.state===E.Resolved&&(m.dispose(),h.dispose(),this.b.delete(u.uri))});return m.asApiObject()}_createNotebookExecution(f,I){const S=this.m.getNotebookDocument(f.uri),u=f.getCells().find(P=>{const W=S.getCellFromApiCell(P);return W&&this.b.has(W.uri)});if(u)throw new Error(`duplicate cell execution for ${u.document.uri}`);if(this.c.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const m=new r(I,S,this.a),h=m.onDidChangeState(()=>{m.state===s.Resolved&&(m.dispose(),h.dispose(),this.c.delete(S.uri))});return this.c.set(S.uri,[m,h]),m.asApiObject()}};e.$Kdc=b,e.$Kdc=b=qe([Ke(4,R.$0i)],b);var E;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(E||(E={}));class v extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(f,I,S){super(),this.m=I,this.n=S,this.b=v.a++,this.c=new T.$Nd,this.onDidChangeState=this.c.event,this.f=E.Init,this.g=this.B(new C.$Xd),this.h=new n(10,u=>this.s(u)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const I=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new c.$pv(I))}t(){if(this.f===E.Init)throw new Error("Must call start before modifying cell output");if(this.f===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let I=this.m;if(f&&(I=this.m.notebook.getCellFromApiCell(f)),!I)throw new Error("INVALID cell");return I.handle}y(f){return f.map(I=>{const S=g.$IL.ensureUniqueMimeTypes(I.items,!0);return S===I.items?p.NotebookCellOutput.from(I):p.NotebookCellOutput.from({items:S,id:I.id,metadata:I.metadata})})}async z(f,I,S){const u=this.w(I),m=this.y((0,y.$3b)(f));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:u,append:S,outputs:m})}async C(f,I,S){return f=g.$IL.ensureUniqueMimeTypes((0,y.$3b)(f),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:f.map(p.NotebookCellOutputItem.from),outputId:I.id,append:S})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(S){f.j=S,f.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(S){if(f.f===E.Resolved||f.f===E.Started)throw new Error("Cannot call start again");f.f=E.Started,f.c.fire(),f.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,u){if(f.f===E.Resolved)throw new Error("Cannot call resolve twice");f.f=E.Resolved,f.c.fire(),f.h.flush(),f.n.$completeExecution(f.b,new c.$pv({runEndTime:u,lastRunSuccess:S}))},clearOutput(S){return f.t(),f.z([],S,!1)},appendOutput(S,u){return f.t(),f.z(S,u,!0)},replaceOutput(S,u){return f.t(),f.z(S,u,!1)},appendOutputItems(S,u){return f.t(),f.C(S,u,!0)},replaceOutputItems(S,u){return f.t(),f.C(S,u,!1)}})}}var s;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(s||(s={}));class r extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(f,I,S){super(),this.h=I,this.j=S,this.b=r.a++,this.c=new T.$Nd,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new C.$Xd),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===s.Resolved||this.f===s.Started)throw new Error("Cannot call start again");this.f=s.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===s.Resolved)throw new Error("Cannot call resolve twice");this.f=s.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class n{constructor(f,I){this.e=f,this.f=I,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new M.$ch,this.b=Date.now(),(0,M.$Ug)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>f.complete())}}function o(w,f){return`${w.value}/${f}`}e.$Ldc=o}),define(Ae[246],Re([1,0,5,3,103]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=void 0;class T{constructor(l,D){this.c=D,this.a=new Map,this.b=l.getProxy(M.$fK.MainThreadNotebookRenderers)}$postRendererMessage(l,D,$){const R=this.c.getEditorById(l);this.a.get(D)?.fire({editor:R.apiEditor,message:$})}createRendererMessaging(l,D){if(!l.contributes?.notebookRenderer?.some(R=>R.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(R,k,a)=>this.d(D).event(R,k,a),postMessage:(R,k)=>{C.$vdc.apiEditorsToExtHost.has(R)&&([R,k]=[k,R]);const a=k&&C.$vdc.apiEditorsToExtHost.get(k);return this.b.$postMessage(a?.id,D,R)}}}d(l){let D=this.a.get(l);return D||(D=new y.$Nd({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete(l)}}),this.a.set(l,D),D)}}e.$Mdc=T}),define(Ae[247],Re([1,0,6,15,2,25,3]),function(ye,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;class l{constructor($){this.b=new Map,this.a=$.getProxy(A.$fK.MainThreadProfileContentHandlers)}registrProfileContentHandler($,R,k){if((0,T.$dF)($,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,k),this.a.$registerProfileContentHandler(R,k.name,k.description,$.identifier.value),(0,y.$Qc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile($,R,k,a){const p=this.b.get($);if(!p)throw new Error(`Unknown handler with id: ${$}`);return p.saveProfile(R,k,a)}async $readProfile($,R,k){const a=this.b.get($);if(!a)throw new Error(`Unknown handler with id: ${$}`);return a.readProfile((0,M.$yf)(R)?R:C.URI.revive(R),k)}}e.$Qdc=l}),define(Ae[248],Re([1,0,2,3,12,8]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;class A{static{this.a=0}constructor(D,$){this.d=$,this.c=new Map,this.b=D.getProxy(M.$fK.MainThreadQuickDiff)}$provideOriginalResource(D,$,R){const k=y.URI.revive($),a=this.c.get(D);return a?(0,C.$Mg)(()=>a.provideOriginalResource(k,R)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(D,$,R,k){const a=A.a++;return this.c.set(a,$),this.b.$registerQuickDiffProvider(a,T.DocumentSelector.from(D,this.d),R,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(a),this.c.delete(a)}}}}e.$Rdc=A}),define(Ae[249],Re([1,0,20,5,6,3,2,7,9,18,29,42,25,8]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0;function g(d,t,i){const c=d.getProxy(T.$fK.MainThreadQuickOpen);class b{constructor(I,S){this.e=new Map,this.f=0,this.a=I,this.b=S}showQuickPick(I,S,u,m=y.CancellationToken.None){this.c=void 0;const h=Promise.resolve(S),P=++this.f,W=c.$show(P,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},m),K={},z=W.then(()=>K);return Promise.race([z,h]).then(j=>{if(j===K)return;const O=(0,a.$cF)(I,"quickPickItemTooltip");return h.then(N=>{const ie=[];for(let X=0;X<N.length;X++){const Ee=N[X];if(typeof Ee=="string")ie.push({label:Ee,handle:X});else if(Ee.kind===l.QuickPickItemKind.Separator)ie.push({type:"separator",label:Ee.label});else{Ee.tooltip&&!O&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const Se=Ee.iconPath?n(Ee.iconPath):void 0;ie.push({label:Ee.label,iconPath:Se?.iconPath,iconClass:Se?.iconClass,description:Ee.description,detail:Ee.detail,picked:Ee.picked,alwaysShow:Ee.alwaysShow,tooltip:O?p.MarkdownString.fromStrict(Ee.tooltip):void 0,handle:X})}}return u&&typeof u.onDidSelectItem=="function"&&(this.c=X=>{u.onDidSelectItem(N[X])}),c.$setItems(P,ie),W.then(X=>{if(typeof X=="number")return N[X];if(Array.isArray(X))return X.map(Ee=>N[Ee])})})}).then(void 0,j=>{if(!(0,D.$4)(j))return c.$setError(P,j),Promise.reject(j)})}$onItemSelected(I){this.c?.(I)}showInput(I,S=y.CancellationToken.None){return this.d=I?.validateInput,c.$input(I,typeof this.d=="function",S).then(void 0,u=>{if(!(0,D.$4)(u))return Promise.reject(u)})}async $validateInput(I){if(!this.d)return;const S=await this.d(I);if(!S||typeof S=="string")return S;let u;switch(S.severity){case l.InputBoxValidationSeverity.Info:u=R.default.Info;break;case l.InputBoxValidationSeverity.Warning:u=R.default.Warning;break;case l.InputBoxValidationSeverity.Error:u=R.default.Error;break;default:u=S.message?R.default.Error:R.default.Ignore;break}return{content:S.message,severity:u}}async showWorkspaceFolderPick(I,S=y.CancellationToken.None){const u=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!u)return;const m=await this.a.getWorkspaceFolders2();if(m)return m.find(h=>h.uri.toString()===u.uri.toString())}createQuickPick(I){const S=new o(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(I){const S=new w(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(I,S){this.e.get(I)?._fireDidChangeValue(S)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,S){const u=this.e.get(I);u instanceof o&&u._fireDidChangeActive(S)}$onDidChangeSelection(I,S){const u=this.e.get(I);u instanceof o&&u._fireDidChangeSelection(S)}$onDidTriggerButton(I,S){this.e.get(I)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(I,S,u){const m=this.e.get(I);m instanceof o&&m._fireDidTriggerItemButton(S,u)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class E{static{this.a=1}constructor(I,S){this.x=I,this.y=S,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Nd,this.q=new M.$Nd,this.r=new M.$Nd,this.s=new M.$Nd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((S,u)=>{const m=S===l.$BL.Back?-1:u;this.o.set(m,S)}),this.z({buttons:I.map((S,u)=>({...n(S.iconPath),tooltip:S.tooltip,handle:S===l.$BL.Back?-1:u}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const S=this.o.get(I);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(I){if(!this.v){for(const S of Object.keys(I)){const u=I[S];this.u[S]=u===void 0?null:u}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}function v(f){if(f instanceof l.$bL)return{id:f.id};const I=r(f),S=s(f);return{dark:typeof I=="string"?A.URI.file(I):I,light:typeof S=="string"?A.URI.file(S):S}}function s(f){return typeof f=="object"&&"light"in f?f.light:f}function r(f){return typeof f=="object"&&"dark"in f?f.dark:f}function n(f){const I=v(f);let S,u;return"id"in I?u=k.ThemeIcon.asClassName(I):S=I,{iconPath:S,iconClass:u}}class o extends E{constructor(I,S){super(I.identifier,S),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Nd,this.L=[],this.M=new M.$Nd,this.N=new M.$Nd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((m,h)=>{this.C.set(h,m),this.D.set(m,h)});const S=(0,a.$cF)(this.O,"quickPickItemTooltip"),u=[];for(let m=0;m<I.length;m++){const h=I[m];if(h.kind===l.QuickPickItemKind.Separator)u.push({type:"separator",label:h.label});else{h.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=h.iconPath?n(h.iconPath):void 0;u.push({handle:m,label:h.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,tooltip:S?p.MarkdownString.fromStrict(h.tooltip):void 0,buttons:h.buttons?.map((W,K)=>({...n(W.iconPath),tooltip:W.tooltip,handle:K}))})}}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(I){const S=(0,$.$Hb)(I.map(u=>this.C.get(u)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(I){const S=(0,$.$Hb)(I.map(u=>this.C.get(u)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(I,S){const u=this.C.get(I);if(!u||!u.buttons||!u.buttons.length)return;const m=u.buttons[S];m&&this.N.fire({button:m,item:u})}}class w extends E{constructor(I,S){super(I.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:R.default.Error}):this.z({validationMessage:I.message,severity:I.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new b(t,i)}e.$Scc=g}),define(Ae[250],Re([1,0,2,5,65,6,12,3,18,131,14,21,42,8,25,13]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=e.$Tcc=void 0;function i(m){if(m)return typeof m.iconPath=="string"?y.URI.file(m.iconPath):y.URI.isUri(m.iconPath)||a.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function c(m){if(m.icon){if(y.URI.isUri(m.icon))return m.icon;if(a.ThemeIcon.isThemeIcon(m.icon))return m.icon;{const h=m.icon;return{light:h.light,dark:h.dark}}}else return}function b(m,h){if(!m.iconPath&&!h.iconPath)return 0;if(m.iconPath){if(!h.iconPath)return 1}else return-1;const P=typeof m.iconPath=="string"?m.iconPath:y.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,W=typeof h.iconPath=="string"?h.iconPath:y.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,$.$sq)(P,W)}function E(m,h){let P=0;if(m.strikeThrough!==h.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==h.faded)return m.faded?1:-1;if(m.tooltip!==h.tooltip)return(m.tooltip||"").localeCompare(h.tooltip||"");if(P=b(m,h),P!==0)return P;if(m.light&&h.light)P=b(m.light,h.light);else{if(m.light)return 1;if(h.light)return-1}if(P!==0)return P;if(m.dark&&h.dark)P=b(m.dark,h.dark);else{if(m.dark)return 1;if(h.dark)return-1}return P}function v(m,h){if(m.command!==h.command)return m.command<h.command?-1:1;if(m.title!==h.title)return m.title<h.title?-1:1;if(m.tooltip!==h.tooltip){if(m.tooltip!==void 0&&h.tooltip!==void 0)return m.tooltip<h.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(m.arguments===h.arguments)return 0;if(m.arguments)if(h.arguments){if(m.arguments.length!==h.arguments.length)return m.arguments.length-h.arguments.length}else return 1;else return-1;for(let P=0;P<m.arguments.length;P++){const W=m.arguments[P],K=h.arguments[P];if(W!==K)return W<K?-1:1}return 0}function s(m,h){let P=(0,$.$sq)(m.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(P!==0)return P;if(m.command&&h.command)P=v(m.command,h.command);else{if(m.command)return 1;if(h.command)return-1}if(P!==0)return P;if(m.decorations&&h.decorations)P=E(m.decorations,h.decorations);else{if(m.decorations)return 1;if(h.decorations)return-1}return P}function r(m,h){for(let P=0;P<m.length;P++)if(m[P]!==h[P])return!1;return!0}function n(m,h){return m.command===h.command&&m.title===h.title&&m.tooltip===h.tooltip&&(m.arguments&&h.arguments?r(m.arguments,h.arguments):m.arguments===h.arguments)}function o(m,h){return(0,D.$ub)(m,h,n)}function w(m,h){return m===h?!0:!m||!h?!1:m.id===h.id&&m.label===h.label&&m.upstream?.id===h.upstream?.id&&m.upstream?.label===h.upstream?.label}class f{#e;#t;get value(){return this.d}set value(h){h=h??"",this.#e.$setInputBoxValue(this.l,h),this.n(h)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(h){this.#e.$setInputBoxPlaceholder(this.l,h),this.f=h}get validateInput(){return(0,g.$dF)(this.k,"scmValidation"),this.g}set validateInput(h){if((0,g.$dF)(this.k,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=h,this.#e.$setValidationProviderIsEnabled(this.l,!!h)}get enabled(){return this.h}set enabled(h){h=!!h,this.h!==h&&(this.h=h,this.#e.$setInputBoxEnablement(this.l,h))}get visible(){return this.j}set visible(h){h=!!h,this.j!==h&&(this.j=h,this.#e.$setInputBoxVisibility(this.l,h))}get document(){return(0,g.$dF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(h,P,W,K,z){this.k=h,this.l=K,this.m=z,this.d="",this.e=new M.$Nd,this.f="",this.h=!0,this.j=!0,this.#t=P,this.#e=W}showValidationMessage(h,P){(0,g.$dF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,h,P)}$onInputBoxValueChange(h){this.n(h)}n(h){this.d=h,this.e.fire(h)}}e.$Tcc=f;class I{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(h){this.v=h,this.q.$updateGroupLabel(this.t,this.handle,h)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(h){this.p=h,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(h){this.f=[...h],this.k.fire()}constructor(h,P,W,K,z){this.q=h,this.s=P,this.t=W,this.u=K,this.v=z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Nd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Nd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=I.d++}getResourceState(h){return this.g.get(h)}$executeResourceCommand(h,P){const W=this.h.get(h);return W?(0,A.$Mg)(()=>this.s.executeCommand(W.command,...W.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this.f].sort(s),W=(0,D.$Db)(this.o,h,s).map(j=>{const O=j.toInsert.map(N=>{const ie=this.e++;this.g.set(ie,N);const X=N.resourceUri;let Ee;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const Z=new T.$Rc;Ee=this.s.converter.toInternal(N.command,Z),this.j.set(ie,Z)}else this.h.set(ie,N.command);const Se=i(N.decorations),Pe=N.decorations&&i(N.decorations.light)||Se,$e=N.decorations&&i(N.decorations.dark)||Se,pe=[Pe,$e],ue=N.decorations&&N.decorations.tooltip||"",oe=N.decorations&&!!N.decorations.strikeThrough,be=N.decorations&&!!N.decorations.faded,_=N.contextValue||"";return{rawResource:[ie,X,pe,ue,oe,be,_,Ee],handle:ie}});return{start:j.start,deleteCount:j.deleteCount,toInsert:O}}),K=W.map(({start:j,deleteCount:O,toInsert:N})=>[j,O,N.map(ie=>ie.rawResource)]),z=W.reverse();for(const{start:j,deleteCount:O,toInsert:N}of z){const ie=N.map(Ee=>Ee.handle),X=this.n.splice(j,O,...ie);for(const Ee of X)this.g.delete(Ee),this.h.delete(Ee),this.j.get(Ee)?.dispose(),this.j.delete(Ee)}return this.o=h,K}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(h){this.g!==h&&(this.g=h,this.#e.$updateSourceControl(this.x,{count:h}))}get quickDiffProvider(){return this.h}set quickDiffProvider(h){this.h=h;let P;(0,g.$cF)(this.y,"quickDiffProvider")&&(P=h?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!h,quickDiffLabel:P})}get historyProvider(){return(0,g.$dF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(h){(0,g.$dF)(this.y,"scmHistoryProvider"),this.j=h,this.k.value=new T.$Rc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!h}),h&&(this.k.value.add(h.onDidChangeCurrentHistoryItemGroup(()=>{w(this.l,h?.currentHistoryItemGroup)||(this.l=h?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(h.onDidChangeActionButton(()=>{(0,g.$dF)(this.y,"scmActionButton"),this.m.value=new T.$Rc;const P=h.actionButton!==void 0?{command:this.z.converter.toInternal(h.actionButton.command,this.m.value),description:h.actionButton.description,enabled:h.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,P??null)})))}get commitTemplate(){return this.n}set commitTemplate(h){h!==this.n&&(this.n=h,this.#e.$updateSourceControl(this.x,{commitTemplate:h}))}get acceptInputCommand(){return this.p}set acceptInputCommand(h){this.o.value=new T.$Rc,this.p=h;const P=this.z.converter.toInternal(h,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:P})}get actionButton(){return(0,g.$dF)(this.y,"scmActionButton"),this.s}set actionButton(h){(0,g.$dF)(this.y,"scmActionButton"),this.q.value=new T.$Rc,this.s=h;const P=h!==void 0?{command:this.z.converter.toInternal(h.command,this.q.value),secondaryCommands:h.secondaryCommands?.map(W=>W.map(K=>this.z.converter.toInternal(K,this.q.value))),description:h.description,enabled:h.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:P??null})}get statusBarCommands(){return this.u}set statusBarCommands(h){if(this.u&&h&&o(this.u,h))return;this.t.value=new T.$Rc,this.u=h;const P=(h||[]).map(W=>this.z.converter.toInternal(W,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:P})}get selected(){return this.v}constructor(h,P,W,K,z,j,O){this.y=h,this.z=K,this.A=z,this.B=j,this.C=O,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new T.$Tc,this.m=new T.$Tc,this.n=void 0,this.o=new T.$Tc,this.p=void 0,this.q=new T.$Tc,this.t=new T.$Tc,this.u=void 0,this.v=!1,this.w=new M.$Nd,this.onDidChangeSelection=this.w.event,this.x=S.d++,this.D=new Map,this.E=new Set,this.#e=W;const N=y.URI.from({scheme:d.Schemas.vscodeSourceControl,path:`${z}/scm${this.x}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new f(h,P,this.#e,this.x,N),this.#e.$registerSourceControl(this.x,z,j,O,N)}createResourceGroup(h,P){const W=new I(this.#e,this.z,this.x,h,P),K=M.Event.once(W.onDidDispose)(()=>this.D.delete(W));return this.D.set(W,K),this.eventuallyAddResourceGroups(),W}eventuallyAddResourceGroups(){const h=[],P=[];for(const[W,K]of this.D){K.dispose();const z=W.onDidUpdateResourceStates(()=>{this.E.add(W),this.eventuallyUpdateResourceStates()});M.Event.once(W.onDidDispose)(()=>{this.E.delete(W),z.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.x,W.handle)}),h.push([W.handle,W.id,W.label,W.features]);const j=W._takeResourceStateSnapshot();j.length>0&&P.push([W.handle,j]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.x,h,P),this.D.clear()}eventuallyUpdateResourceStates(){const h=[];this.E.forEach(P=>{const W=P._takeResourceStateSnapshot();W.length!==0&&h.push([P.handle,W])}),h.length>0&&this.#e.$spliceResourceStates(this.x,h),this.E.clear()}getResourceGroup(h){return this.e.get(h)}setSelectionState(h){this.v=h,this.w.fire(h)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(h=>h.dispose()),this.#e.$unregisterSourceControl(this.x)}}qe([(0,C.$ih)(100)],S.prototype,"eventuallyAddResourceGroups",null),qe([(0,C.$ih)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let u=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(h,P,W,K){this.l=P,this.m=W,this.n=K,this.g=new Map,this.h=new k.$8l,this.j=new M.$Nd,this.e=h.getProxy(l.$fK.MainThreadSCM),this.f=h.getProxy(l.$fK.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:z=>{if(z&&z.$mid===3){const j=this.g.get(z.sourceControlHandle);if(!j)return z;const O=j.getResourceGroup(z.groupHandle);return O?O.getResourceState(z.handle):z}else if(z&&z.$mid===4){const j=this.g.get(z.sourceControlHandle);return j?j.getResourceGroup(z.groupHandle):z}else if(z&&z.$mid===5){const j=this.g.get(z.handle);return j||z}return z}})}createSourceControl(h,P,W,K){this.n.trace("ExtHostSCM#createSourceControl",h.identifier.value,P,W,K),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const z=t.d++,j=new S(h,this.m,this.e,this.l,P,W,K);this.g.set(z,j);const O=this.h.get(h.identifier)||[];return O.push(j),this.h.set(h.identifier,O),j}getLastInputBox(h){this.n.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const P=this.h.get(h.identifier),W=P&&P[P.length-1];return W&&W.inputBox}$provideOriginalResource(h,P,W){const K=y.URI.revive(P);this.n.trace("ExtHostSCM#$provideOriginalResource",h,K.toString());const z=this.g.get(h);return!z||!z.quickDiffProvider||!z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Mg)(()=>z.quickDiffProvider.provideOriginalResource(K,W)).then(j=>j||null)}$onInputBoxValueChange(h,P){this.n.trace("ExtHostSCM#$onInputBoxValueChange",h);const W=this.g.get(h);return W&&W.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(h,P,W,K){this.n.trace("ExtHostSCM#$executeResourceCommand",h,P,W);const z=this.g.get(h);if(!z)return Promise.resolve(void 0);const j=z.getResourceGroup(P);return j?j.$executeResourceCommand(W,K):Promise.resolve(void 0)}$validateInput(h,P,W){this.n.trace("ExtHostSCM#$validateInput",h);const K=this.g.get(h);return!K||!K.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Mg)(()=>K.inputBox.validateInput(P,W)).then(z=>{if(!z)return Promise.resolve(void 0);const j=p.MarkdownString.fromStrict(z.message);return j?Promise.resolve([j,z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this.g.get(h)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=h,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(h,P,W){return await this.g.get(h)?.historyProvider?.resolveHistoryItemGroupBase(P,W)??void 0}async $resolveHistoryItemGroupCommonAncestor(h,P,W,K){return await this.g.get(h)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(P,W,K)??void 0}async $provideHistoryItems(h,P,W,K){return(await this.g.get(h)?.historyProvider?.provideHistoryItems(P,W,K))?.map(O=>({id:O.id,parentIds:O.parentIds,label:O.label,description:O.description,icon:c(O),timestamp:O.timestamp}))??void 0}async $provideHistoryItemChanges(h,P,W){return await this.g.get(h)?.historyProvider?.provideHistoryItemChanges(P,W)??void 0}};e.$Ucc=u,e.$Ucc=u=t=qe([Ke(3,R.$0i)],u)}),define(Ae[83],Re([1,0,3,5,4]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=e.$zcc=void 0;class T{constructor(l){this.b=new M.$Nd,this.onDidChangePassword=this.b.event,this.a=l.getProxy(y.$fK.MainThreadSecretState)}async $onDidChangePassword(l){this.b.fire(l)}get(l,D){return this.a.$getPassword(l,D)}store(l,D,$){return this.a.$setPassword(l,D,$)}delete(l,D){return this.a.$deletePassword(l,D)}}e.$zcc=T,e.$Acc=(0,C.$Ph)("IExtHostSecretState")}),define(Ae[251],Re([1,0,3,8,2]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=void 0;class T{static{this.a=0}constructor(l,D){this.d=D,this.c=new Map,this.b=l.getProxy(y.$fK.MainThreadShare)}async $provideShare(l,D,$){return await this.c.get(l)?.provideShare({selection:M.Range.to(D.selection),resourceUri:C.URI.revive(D.resourceUri)},$)??void 0}registerShareProvider(l,D){const $=T.a++;return this.c.set($,D),this.b.$registerShareProvider($,M.DocumentSelector.from(l,this.d),D.id,D.label,D.priority),{dispose:()=>{this.b.$unregisterShareProvider($),this.c.delete($)}}}}e.$Wdc=T}),define(Ae[252],Re([1,0,6,3]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0;class C{static{this.a=1}constructor(A){this.c=new Map,this.b=A.getProxy(M.$fK.MainThreadSpeech)}async $createSpeechToTextSession(A,l,D){const $=this.c.get(A);if(!$)return;const R=$.provideSpeechToTextSession(D);if(D.isCancellationRequested)return;const k=R.onDidChange(a=>{D.isCancellationRequested||this.b.$emitSpeechToTextEvent(l,a)});D.onCancellationRequested(()=>{k.dispose(),R.dispose()})}registerProvider(A,l,D){const $=C.a++;return this.c.set($,D),this.b.$registerProvider($,l,{extension:A,displayName:A.value}),(0,y.$Qc)(()=>{this.b.$unregisterProvider($),this.c.delete($)})}}e.$Ydc=C}),define(Ae[253],Re([1,0,7,3,153,6,8,15]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=e.$Vcc=void 0;class D{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new y.$cL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$cL("statusBarItem.warningForeground")]])}#e;#t;constructor(a,p,g,d,t,i=y.StatusBarAlignment.Left,c){if(this.i=!1,this.k="",this.q=new T.$Rc,this.#e=a,this.#t=p,t&&d){this.c=(0,y.$RK)(d.identifier,t);const b=g.get(this.c);b&&(i=b.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,c=b.priority,this.j=!0,this.name=b.name,this.text=b.text,this.tooltip=b.tooltip,this.command=b.command,this.accessibilityInformation=b.accessibilityInformation)}else this.c=String(D.a++);this.e=d,this.f=t,this.g=i,this.h=this.u(c)}u(a){if((0,l.$Cf)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(a){this.k=a,this.v()}set name(a){this.m=a,this.v()}set tooltip(a){this.l=a,this.v()}set color(a){this.n=a,this.v()}set backgroundColor(a){a&&!D.b.has(a.id)&&(a=void 0),this.o=a,this.v()}set command(a){this.r?.fromApi!==a&&(this.p&&this.q.add(this.p),this.p=new T.$Rc,typeof a=="string"?this.r={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this.p)}:a?this.r={fromApi:a,internal:this.#t.toInternal(a,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(a){this.t=a,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let a;this.e?this.f?a=`${this.e.identifier.value}.${this.f}`:a=this.e.identifier.value:a=this.f;let p;this.m?p=this.m:p=(0,C.localize)(0,null,this.e.displayName||this.e.name);let g=this.n;this.o&&(g=D.b.get(this.o.id));const d=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,a,this.e?.identifier.value,p,this.k,d,this.r?.internal,g,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Vcc=D;class ${constructor(a){this.b=[],this.a=a.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(a){const p={message:a};return this.b.unshift(p),this.c(),new y.$hK(()=>{const g=this.b.indexOf(p);g>=0&&(this.b.splice(g,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(a,p){this.e=new Map,this.a=a.getProxy(M.$fK.MainThreadStatusBar),this.b=p,this.c=new $(this)}$acceptStaticEntries(a){for(const p of a)this.e.set(p.entryId,p)}createStatusBarEntry(a,p,g,d){return new D(this.a,this.b,this.e,a,p,g,d)}setStatusBarMessage(a,p){const g=this.c.setMessage(a);let d;return typeof p=="number"?d=setTimeout(()=>g.dispose(),p):typeof p<"u"&&p.then(()=>g.dispose(),()=>g.dispose()),new y.$hK(()=>{g.dispose(),clearTimeout(d)})}}e.$Wcc=R}),define(Ae[84],Re([1,0,3,5,4]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=e.$ncc=void 0;class T{constructor(l,D){this.c=D,this.b=new M.$Nd,this.onDidChangeStorage=this.b.event,this.a=l.getProxy(y.$fK.MainThreadStorage)}registerExtensionStorageKeysToSync(l,D){this.a.$registerExtensionStorageKeysToSync(l,D)}async initializeExtensionStorage(l,D,$){const R=await this.a.$initializeExtensionStorage(l,D);let k;return R&&(k=this.d(l,D,R)),k||$}setValue(l,D,$){return this.a.$setValue(l,D,$)}$acceptValue(l,D,$){const R=this.d(l,D,$);R&&this.b.fire({shared:l,key:D,value:R})}d(l,D,$){try{return JSON.parse($)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${l}): ${R}`)}}}e.$ncc=T,e.$occ=(0,C.$Ph)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,14,62,2]),function(ye,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=e.$tcc=void 0,e.$tcc=(0,y.$Ph)("IExtensionStoragePaths");let l=class{constructor($,R,k){this.d=R,this.f=k,this.a=$.workspace??void 0,this.b=$.environment,this.whenReady=this.h().then(a=>this.c=a)}async g($){return A.URI.joinPath(this.b.workspaceStorageHome,$)}async h(){if(!this.a)return Promise.resolve(void 0);const $=this.a.id,R=await this.g($);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue($){if(this.c)return A.URI.joinPath(this.c,$.identifier.value)}globalValue($){return A.URI.joinPath(this.b.globalStorageHome,$.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$ucc=l,e.$ucc=l=qe([Ke(0,M.$wM),Ke(1,C.$0i),Ke(2,T.$scc)],l)}),define(Ae[63],Re([1,0,5,3,4,2,17,6,7,155,9,181,20,36,182,42,12,8,31]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=e.$xcc=e.$wcc=e.$vcc=void 0,e.$vcc=(0,C.$Ph)("IExtHostTerminalService");class b{constructor(u,m,h,P){this.l=u,this._id=m,this.m=h,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(K=>this.f=K);const W=this;this.value={get name(){return W.n||""},get processId(){return W.b},get creationOptions(){return W.m},get exitStatus(){return W.h},get state(){return W.j},get selection(){return W.k},sendText(K,z=!0){W.q(),W.l.$sendText(W._id,K,z)},show(K){W.q(),W.l.$show(W._id,K)},hide(){W.q(),W.l.$hide(W._id)},dispose(){W.a||(W.a=!0,W.l.$dispose(W._id))},get dimensions(){if(!(W.d===void 0||W.g===void 0))return{columns:W.d,rows:W.g}}}}async create(u,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:u.name,shellPath:u.shellPath??void 0,shellArgs:u.shellArgs??void 0,cwd:u.cwd??void 0,env:u.env??void 0,icon:w(u.iconPath)??void 0,color:d.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:u.message??void 0,strictEnv:u.strictEnv??void 0,hideFromUser:u.hideFromUser??void 0,isFeatureTerminal:m?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:m?.useShellEnvironment??void 0,location:m?.location||this.o(u.location,m?.resolvedExtHostIdentifier),isTransient:u.isTransient??void 0})}async createExtensionTerminal(u,m,h,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:h,color:d.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o(u,m),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(u,m){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in u?{viewColumn:i.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.n=u}setExitStatus(u,m){this.h=Object.freeze({code:u,reason:m})}setDimensions(u,m){return u===this.d&&m===this.g||u===0||m===0?!1:(this.d=u,this.g=m,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(u){this.k=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(m=>{m!==u&&(this.b=Promise.resolve(u))})}}e.$wcc=b;class E{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new y.$Nd,this.onProcessData=this.a.event,this.b=new y.$Nd,this.d=new y.$Nd,this.onDidChangeProperty=this.d.event,this.f=new y.$Nd,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,m){this.g.setDimensions?.({columns:u,rows:m})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:"title",value:m})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let v=1,s=class extends l.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}constructor(u,m,h){super(),this.Q=m,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new l.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$Nd,this.onDidCloseTerminal=this.H.event,this.I=new y.$Nd,this.onDidOpenTerminal=this.I.event,this.J=new y.$Nd,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$Nd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$Nd,this.onDidChangeTerminalState=this.M.event,this.N=new y.$Nd,this.onDidChangeShell=this.N.event,this.O=new y.$Nd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$Nd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=h.getProxy(M.$fK.MainThreadTerminalService),this.y=new g.$Skb(this.a.$sendProcessData),this.a.$registerProcessSupport(u),this.Q.registerArgumentProcessor({processArgument:P=>{const W=K=>{const z=K;return this.W(z.instanceId)?.value};switch(P?.$mid){case 15:return W(P);default:{if(Array.isArray(P))for(let K=0;K<P.length&&P[K].$mid===15;K++)P[K]=W(P[K]);return P}}}}),this.B({dispose:()=>{for(const[P,W]of this.g)W.shutdown(!0)}})}getDefaultShell(u){return(u?this.u:this.s)?.path||""}getDefaultShellArgs(u){return(u?this.u:this.s)?.args||[]}createExtensionTerminal(u,m){const h=new b(this.a,(0,p.$eg)(),u,u.name),P=new E(u.pty);return h.createExtensionTerminal(u.location,this.R(u,m).resolvedExtHostIdentifier,w(u.iconPath),f(u.color)).then(W=>{const K=this.S(W,P);this.h[W]=K}),this.f.push(h),h.value}R(u,m){if(m=m||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const h=u.location.parentTerminal;if(h){const P=this.f.find(W=>W.value===h);P&&(m.resolvedExtHostIdentifier=P._id)}}else u.location&&typeof u.location!="object"?m.location=u.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(u,m){if(!this.W(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const P=new E(m),W=this.S(u,P);this.h[u]=W}async $acceptActiveTerminalChanged(u){const m=this.b;if(u===null){this.b=void 0,m!==this.b&&this.J.fire(this.b);return}const h=this.W(u);h&&(this.b=h,m!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(u,m){const h=this.W(u);h&&this.O.fire({terminal:h.value,data:m})}async $acceptTerminalDimensions(u,m,h){const P=this.W(u);P&&P.setDimensions(m,h)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(u,m){const h=this.W(u);h&&this.P.fire({terminal:h.value,...m})}async $acceptTerminalMaximumDimensions(u,m,h){this.g.get(u)?.resize(m,h)}async $acceptTerminalTitleChange(u,m){const h=this.W(u);h&&(h.name=m)}async $acceptTerminalClosed(u,m,h){const P=this.Y(this.f,u);if(P!==null){const W=this.f.splice(P,1)[0];W.setExitStatus(m,h),this.H.fire(W.value)}}$acceptTerminalOpened(u,m,h,P){if(m){const z=this.Y(this.f,m);if(z!==null){this.f[z]._id=u,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const W={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:T.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},K=new b(this.a,u,W,h);this.f.push(K),this.I.fire(K.value),K.isOpen=!0}async $acceptTerminalProcessId(u,m){this.W(u)?._setProcessId(m)}async $startExtensionTerminal(u,m){const h=this.W(u);if(!h)return{message:(0,$.localize)(0,null,u)};h.isOpen||await new Promise(W=>{const K=this.onDidOpenTerminal(async z=>{z===h.value&&(K.dispose(),W())})});const P=this.g.get(u);P?P.startSendingEvents(m):this.j[u]={initialDimensions:m}}S(u,m){const h=new l.$Rc;h.add(m.onProcessReady(W=>this.a.$sendProcessReady(u,W.pid,W.cwd,W.windowsPty))),h.add(m.onDidChangeProperty(W=>this.a.$sendProcessProperty(u,W))),this.y.startBuffering(u,m.onProcessData),h.add(m.onProcessExit(W=>this.U(u,W))),this.g.set(u,m);const P=this.j[u];return P&&m instanceof E&&(m.startSendingEvents(P.initialDimensions),delete this.j[u]),h}$acceptProcessAckDataEvent(u,m){this.g.get(u)?.acknowledgeDataEvent(m)}$acceptProcessInput(u,m){this.g.get(u)?.input(m)}$acceptTerminalInteraction(u){const m=this.W(u);m?.setInteractedWith()&&this.M.fire(m.value)}$acceptTerminalSelection(u,m){this.W(u)?.setSelection(m)}$acceptProcessResize(u,m,h){try{this.g.get(u)?.resize(m,h)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(u,m){this.g.get(u)?.shutdown(m)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(m=>this.a.$sendProcessProperty(u,{type:"cwd",value:m}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.z.add(u),this.z.size===1&&this.a.$startLinkProvider(),new D.$hK(()=>{this.z.delete(u),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,m,h){if(this.C.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.C.set(m,h),this.a.$registerProfileProvider(m,u.identifier.value),new D.$hK(()=>{this.C.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(u,m,h){if(this.D.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.D.set(u,h),this.a.$registerQuickFixProvider(u,m),new D.$hK(()=>{this.D.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,m){const h=new a.$Xd().token;if(h.isCancellationRequested)return;const P=this.D.get(u);if(!P)return;const W=await P.provideTerminalQuickFixes(m,h);if(W===null||Array.isArray(W)&&W.length===0)return;const K=new l.$Rc;if(this.w.value=K,!Array.isArray(W))return W?i.TerminalQuickFix.from(W,this.Q.converter,K):void 0;const z=[];for(const j of W){const O=i.TerminalQuickFix.from(j,this.Q.converter,K);O&&z.push(O)}return z}async $createContributedProfileTerminal(u,m){const h=new a.$Xd().token;let P=await this.C.get(u)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,m);return}this.createTerminalFromOptions(P.options,m)}}async $provideLinks(u,m){const h=this.W(u);if(!h)return[];this.F.delete(u),this.G.get(u)?.dispose(!0);const W=new a.$Xd;this.G.set(u,W);const K=[],z={terminal:h.value,line:m},j=[];for(const ie of this.z)j.push(t.Promises.withAsyncBody(async X=>{W.token.onCancellationRequested(()=>X({provider:ie,links:[]}));const Ee=await ie.provideTerminalLinks(z,W.token)||[];W.token.isCancellationRequested||X({provider:ie,links:Ee})}));const O=await Promise.all(j);if(W.token.isCancellationRequested)return[];const N=new Map;for(const ie of O)ie&&ie.links.length>0&&K.push(...ie.links.map(X=>{const Ee={id:v++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return N.set(Ee.id,{provider:ie.provider,link:X}),Ee}));return this.F.set(u,N),K}$activateLink(u,m){const h=this.F.get(u)?.get(m);h&&h.provider.handleTerminalLink(h.link)}U(u,m){this.y.stopBuffering(u),this.g.delete(u),delete this.j[u];const h=this.h[u];h&&(h.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,m)}W(u){return this.X(this.f,u)}X(u,m){const h=this.Y(u,m);return h!==null?u[h]:null}Y(u,m){const h=u.findIndex(P=>P._id===m);return h===-1?null:h}getEnvironmentVariableCollection(u){let m=this.n.get(u.identifier.value);return m||(m=new r,this.$(u.identifier.value,m)),m.getScopedEnvironmentVariableCollection(void 0)}Z(u,m){const h=(0,k.$lr)(m.map),P=(0,k.$mr)(m.descriptionMap);this.a.$setEnvironmentVariableCollection(u,m.persistent,h.length===0?void 0:h,P)}$initEnvironmentVariableCollections(u){u.forEach(m=>{const h=m[0],P=new r(m[1]);this.$(h,P)})}$acceptDefaultProfile(u,m){const h=this.s;this.s=u,this.u=m,h?.path!==u.path&&this.N.fire(u.path)}$(u,m){this.n.set(u,m),m.onDidChangeCollection(()=>{this.Z(u,m)})}};e.$xcc=s,e.$xcc=s=qe([Ke(1,c.$CM),Ke(2,A.$gM)],s);class r{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$Nd,this.map=new Map(u)}getScopedEnvironmentVariableCollection(u){const m=this.h(u);let h=this.a.get(m);return h||(h=new n(this,u),this.a.set(m,h),h.onDidChangeCollection(()=>this.d.fire())),h}replace(u,m,h,P){this.f(u,{value:m,type:D.EnvironmentVariableMutatorType.Replace,options:h??{applyAtProcessCreation:!0},scope:P})}append(u,m,h,P){this.f(u,{value:m,type:D.EnvironmentVariableMutatorType.Append,options:h??{applyAtProcessCreation:!0},scope:P})}prepend(u,m,h,P){this.f(u,{value:m,type:D.EnvironmentVariableMutatorType.Prepend,options:h??{applyAtProcessCreation:!0},scope:P})}f(u,m){if(m.options&&m.options.applyAtProcessCreation===!1&&!m.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const h=this.g(u,m.scope),P=this.map.get(h),W=m.options?{applyAtProcessCreation:m.options.applyAtProcessCreation??!1,applyAtShellIntegration:m.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==m.value||P.type!==m.type||P.options?.applyAtProcessCreation!==W.applyAtProcessCreation||P.options?.applyAtShellIntegration!==W.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const K=this.g(u,m.scope),z={variable:u,...m,options:W};this.map.set(K,z),this.d.fire()}}get(u,m){const h=this.g(u,m),P=this.map.get(h);return P?I(P):void 0}g(u,m){const h=this.h(m);return h.length?`${u}:::${h}`:u}h(u){return this.j(u?.workspaceFolder)??""}j(u){return u?u.uri.toString():void 0}getVariableMap(u){const m=new Map;for(const[h,P]of this.map)this.h(P.scope)===this.h(u)&&m.set(P.variable,I(P));return m}delete(u,m){const h=this.g(u,m);this.map.delete(h),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[m,h]of this.map)h.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(m);this.k(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,m){const h=this.h(m),P=this.descriptionMap.get(h);if(!P||P.description!==u){let W;typeof u=="string"?W=u:W=u?.value.split(`

`)[0];const K={description:W,scope:m};this.descriptionMap.set(h,K),this.d.fire()}}getDescription(u){const m=this.h(u);return this.descriptionMap.get(m)?.description}k(u){const m=this.h(u);this.descriptionMap.delete(m)}}class n{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,m){this.b=u,this.d=m,this.a=new y.$Nd}getScoped(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,m,h){this.b.replace(u,m,h,this.d)}append(u,m,h){this.b.append(u,m,h,this.d)}prepend(u,m,h){this.b.prepend(u,m,h,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,m){this.b.getVariableMap(this.d).forEach((h,P)=>u.call(m,P,h,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends s{constructor(u,m){super(!1,u,m)}createTerminal(u,m,h){throw new R.$_}createTerminalFromOptions(u,m){throw new R.$_}};e.$ycc=o,e.$ycc=o=qe([Ke(0,c.$CM),Ke(1,A.$gM)],o);function w(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function f(S){return d.ThemeColor.isThemeColor(S)?S:void 0}function I(S){const u={...S};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(Ae[254],Re([1,0,283,12,26,20,5,202,93,6,24,15,36,3,17,104,8,7,46,76,57,25]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d,t,i,c,b,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=e.$Hdc=e.$Gdc=e.$Fdc=void 0;let s=class{constructor(z,j,O){this.k=O,this.d=new A.$Nd,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=z.getProxy(p.$fK.MainThreadTesting),this.j=new h(this.g),this.h=new w(this.g),j.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const ie=N,X=ie.tests[ie.tests.length-1].item.extId;return this.f.get(c.$$I.root(X))?.collection.tree.get(X)?.actual??(0,d.$sM)(N)}case 18:{const{extId:ie,message:X}=N;return{test:this.f.get(c.$$I.root(ie))?.collection.tree.get(ie)?.actual,message:t.TestMessage.to(X)}}default:return N}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await j.executeCommand("_testing.getExplorerSelection"),ie=X=>{const Ee=this.f.get(c.$$I.root(X));if(Ee)return c.$$I.isRoot(X)?Ee.controller:Ee.collection.tree.get(X)?.actual};return{include:N?.include.map(ie).filter(k.$Gf)||[],exclude:N?.exclude.map(ie).filter(k.$Gf)||[]}})}createTestController(z,j,O,N){if(this.f.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const ie=new $.$Rc,X=ie.add(new d.$vM(j,O,this.k));X.root.label=O;const Ee=new Map,Se=this.g,Pe={items:X.root.children,get label(){return O},set label(pe){O=pe,X.root.label=pe,Se.$updateController(j,{label:O})},get refreshHandler(){return N},set refreshHandler(pe){N=pe,Se.$updateController(j,{canRefresh:!!pe})},get id(){return j},createRunProfile:(pe,ue,oe,be,_,B)=>{let Z=(0,D.$Di)(pe);for(;Ee.has(Z);)Z++;return new P(this.g,Ee,j,Z,pe,ue,oe,be,_,B)},createTestItem(pe,ue,oe){return new d.$tM(j,pe,ue,oe)},createTestRun:(pe,ue,oe=!0)=>this.h.createTestRun(z,j,X,pe,ue,oe),invalidateTestResults:pe=>{if(pe===void 0)this.g.$markTestRetired(void 0);else{const ue=pe instanceof Array?pe:[pe];this.g.$markTestRetired(ue.map(oe=>c.$$I.fromExtHostTestItem(oe,j).toString()))}},set resolveHandler(pe){X.resolveHandler=pe},get resolveHandler(){return X.resolveHandler},dispose:()=>{ie.dispose()}};Se.$registerTestController(j,O,!!N),ie.add((0,$.$Qc)(()=>Se.$unregisterTestController(j)));const $e={controller:Pe,collection:X,profiles:Ee,extension:z};return this.f.set(j,$e),ie.add((0,$.$Qc)(()=>this.f.delete(j))),ie.add(X.onDidGenerateDiff(pe=>Se.$publishDiff(j,pe.map(E.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.j.checkout()}async runTests(z,j=T.CancellationToken.None){const O=f(z);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.f.get(O.controllerId);if(!N)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:z.include?.map(ie=>c.$$I.fromExtHostTestItem(ie,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:W[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:z.exclude?.map(ie=>ie.id)},j)}$syncTests(){for(const{collection:z}of this.f.values())z.flushDiff();return Promise.resolve()}$provideFileCoverage(z,j,O){return(0,y.$rb)(this.h.trackers,ie=>ie.id===z?ie.getCoverage(j):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(z,j,O,N){return(0,y.$rb)(this.h.trackers,X=>X.id===z?X.getCoverage(j):void 0)?.resolveFileCoverage(O,N)??Promise.resolve([])}$configureRunProfile(z,j){this.f.get(z)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(z,j){await this.f.get(z)?.controller.refreshHandler?.(j)}$publishTestResults(z){this.results=Object.freeze(z.map(j=>(0,R.$8m)(t.TestResults.to(j))).concat(this.results).sort((j,O)=>O.completedAt-j.completedAt).slice(0,32)),this.d.fire()}async $expandTest(z,j){const O=this.f.get(c.$$I.fromString(z).controllerId)?.collection;O&&(await O.expand(z,j<0?1/0:j),O.flushDiff())}$acceptDiff(z){this.j.applyDiff(z.map(E.TestsDiffOp.deserialize))}async $runControllerTests(z,j){return Promise.all(z.map(O=>this.l(O,!1,j)))}async $startContinuousRun(z,j){const O=new T.$Xd(j),N=await Promise.all(z.map(ie=>this.l(ie,!0,O.token)));return!j.isCancellationRequested&&!N.some(ie=>ie.error)&&await new Promise(ie=>j.onCancellationRequested(ie)),O.dispose(!0),N}async l(z,j,O){const N=this.f.get(z.controllerId);if(!N)return{};const{collection:ie,profiles:X,extension:Ee}=N,Se=X.get(z.profileId);if(!Se)return{};const Pe=z.testIds.map(oe=>ie.tree.get(oe)).filter(k.$Gf),$e=z.excludeExtIds.map(oe=>N.collection.tree.get(oe)).filter(k.$Gf).filter(oe=>Pe.some(be=>be.fullId.compare(oe.fullId)===2));if(!Pe.length)return{};const pe=new i.$PL(Pe.some(oe=>oe.actual instanceof d.$uM)?void 0:Pe.map(oe=>oe.actual),$e.map(oe=>oe.actual),Se,j),ue=(0,E.$aJ)(z)&&this.h.prepareForMainThreadTestRun(pe,I.fromInternal(z,N.collection),Ee,O);try{return await Se.runHandler(pe,O),{}}catch(oe){return{error:String(oe)}}finally{ue&&(ue.hasRunningTasks&&!O.isCancellationRequested&&await A.Event.toPromise(ue.onEnd),ue.dispose())}}$cancelExtensionTestRun(z){z===void 0?this.h.cancelAllRuns():this.h.cancelRunById(z)}};e.$Fdc=s,e.$Fdc=s=qe([Ke(0,g.$gM)],s);const r=1e4;var n;(function(K){K[K.Running=0]="Running",K[K.Cancelling=1]="Cancelling",K[K.Ended=2]="Ended"})(n||(n={}));class o extends $.$Sc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(z,j,O,N){super(),this.s=z,this.u=j,this.w=O,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$Nd),this.onEnd=this.m.event,this.j=this.B(new T.$Xd(N));const ie=this.B(new M.$6g(()=>this.y(),r));this.B(this.j.token.onCancellationRequested(()=>ie.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(z){return this.g.get(z)?.coverage}createRun(z){const j=this.s.id,O=this.s.controllerId,N=(0,a.$eg)(),ie=new S(this.u,j,N),X=$e=>(pe,...ue)=>{if(Se){console.warn(`Setting the state of test "${pe.id}" is a no-op after the run ends.`);return}this.s.isIncluded(pe)&&(this.C(pe),$e(pe,...ue))},Ee=($e,pe)=>{const ue=pe instanceof Array?pe.map(t.TestMessage.from):[t.TestMessage.from(pe)];if(ue.some(oe=>oe.contextValue!==void 0)&&(0,v.$dF)(this.w,"testMessageContextValue"),$e.uri&&$e.range){const oe={range:t.Range.from($e.range),uri:$e.uri};for(const be of ue)be.location=be.location||oe}this.u.$appendTestMessagesInRun(j,N,c.$$I.fromExtHostTestItem($e,O).toString(),ue)};let Se=!1;const Pe={isPersisted:this.s.isPersisted,token:this.j.token,name:z,get coverageProvider(){return ie.coverageProvider},set coverageProvider($e){ie.coverageProvider=$e},enqueued:X($e=>{this.u.$updateTestStateInRun(j,N,c.$$I.fromExtHostTestItem($e,O).toString(),1)}),skipped:X($e=>{this.u.$updateTestStateInRun(j,N,c.$$I.fromExtHostTestItem($e,O).toString(),5)}),started:X($e=>{this.u.$updateTestStateInRun(j,N,c.$$I.fromExtHostTestItem($e,O).toString(),2)}),errored:X(($e,pe,ue)=>{Ee($e,pe),this.u.$updateTestStateInRun(j,N,c.$$I.fromExtHostTestItem($e,O).toString(),6,ue)}),failed:X(($e,pe,ue)=>{Ee($e,pe),this.u.$updateTestStateInRun(j,N,c.$$I.fromExtHostTestItem($e,O).toString(),4,ue)}),passed:X(($e,pe)=>{this.u.$updateTestStateInRun(j,N,c.$$I.fromExtHostTestItem($e,this.s.controllerId).toString(),3,pe)}),appendOutput:($e,pe,ue)=>{Se||(ue&&(this.s.isIncluded(ue)?this.C(ue):ue=void 0),this.u.$appendOutputToRun(j,N,C.$be.fromString($e),pe&&t.location.from(pe),ue&&c.$$I.fromExtHostTestItem(ue,O).toString()))},end:()=>{Se||(Se=!0,this.u.$finishedTestRunTask(j,N),this.g.delete(N),this.g.size||this.z())}};return this.g.set(N,{run:Pe,coverage:ie}),this.u.$startedTestRunTask(j,{id:N,name:z,running:!0}),Pe}y(){for(const{run:z}of this.g.values())z.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(z){if(!(z instanceof d.$tM))throw new b.$$L(z.id);if(this.h.has(c.$$I.fromExtHostTestItem(z,this.s.controllerId).toString()))return;const j=[],O=this.s.colllection.root;for(;;){const N=t.TestItem.from(z);if(j.unshift(N),this.h.has(N.extId)||(this.h.add(N.extId),z===O))break;z=z.parent||O}this.u.$addTestsToRun(this.s.controllerId,this.s.id,j)}dispose(){this.z(),super.dispose()}}class w{get trackers(){return this.d.values()}constructor(z){this.f=z,this.d=new Map}prepareForMainThreadTestRun(z,j,O,N){return this.g(z,j,O,N)}cancelRunById(z){for(const j of this.d.values())if(j.id===z){j.cancel();return}}cancelAllRuns(){for(const z of this.d.values())z.cancel()}createTestRun(z,j,O,N,ie,X){const Ee=this.d.get(N);if(Ee)return Ee.createRun(ie);const Se=I.fromPublic(j,O,N,X),Pe=f(N);this.f.$startedExtensionTestRun({controllerId:j,continuous:!!N.continuous,profile:Pe&&{group:W[Pe.kind],id:Pe.profileId},exclude:N.exclude?.map(pe=>c.$$I.fromExtHostTestItem(pe,O.root.id).toString())??[],id:Se.id,include:N.include?.map(pe=>c.$$I.fromExtHostTestItem(pe,O.root.id).toString())??[O.root.id],persist:X});const $e=this.g(N,Se,z);return A.Event.once($e.onEnd)(()=>{this.f.$finishedExtensionTestRun(Se.id),$e.dispose()}),$e.createRun(ie)}g(z,j,O,N){const ie=new o(j,this.f,O,N);return this.d.set(z,ie),A.Event.once(ie.onEnd)(()=>this.d.delete(z)),ie}}e.$Gdc=w;const f=K=>{if(K.profile){if(!(K.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return K.profile}};class I{static fromPublic(z,j,O,N){return new I(z,(0,a.$eg)(),O.include?.map(ie=>c.$$I.fromExtHostTestItem(ie,z).toString())??[z],O.exclude?.map(ie=>c.$$I.fromExtHostTestItem(ie,z).toString())??[],N,j)}static fromInternal(z,j){return new I(z.controllerId,z.runId,z.testIds,z.excludeExtIds,!0,j)}constructor(z,j,O,N,ie,X){this.controllerId=z,this.id=j,this.isPersisted=ie,this.colllection=X,this.d=O.map(Ee=>Ee+"\0"),this.f=N.map(Ee=>Ee+"\0")}isIncluded(z){const j=c.$$I.fromExtHostTestItem(z,this.controllerId).toString()+"\0";for(const O of this.f)if(j===O||j.startsWith(O))return!1;for(const O of this.d)if(j===O||j.startsWith(O))return!0;return!1}}e.$Hdc=I;class S{set coverageProvider(z){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");z&&(this.d=z,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(z,j,O){this.g=z,this.h=j,this.j=O}async provideFileCoverage(z){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(z))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(j){throw this.f=void 0,j}}async resolveFileCoverage(z,j){const O=await this.f;let N=O?.[z];return!this.d||!O||!N?[]:(N.detailedCoverage||(N=O[z]=await this.d.resolveFileCoverage?.(N,j)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class u{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(z){this.j=z,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(z){this.d.add(z)}update(z){Object.assign(z.revived,t.TestItem.toPlain(z.item)),this.d.has(z)||this.f.add(z)}remove(z){if(this.d.has(z)){this.d.delete(z);return}this.f.delete(z);const j=c.$$I.parentId(z.item.extId);if(j&&this.h.has(j.toString())){this.h.add(z.item.extId);return}this.g.add(z)}getChangeEvent(){const{d:z,f:j,g:O}=this;return{get added(){return[...z].map(N=>N.revived)},get updated(){return[...j].map(N=>N.revived)},get removed(){return[...O].map(N=>N.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class m extends E.$fJ{constructor(){super(...arguments),this.s=new A.$Nd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(z){return this.f.get(z)}getMirroredTestDataByReference(z){return this.f.get(z.id)}q(z,j){return{...z,revived:t.TestItem.toPlain(z.item),depth:j?j.depth+1:0,children:new Set}}p(){return new u(this.s)}}class h{constructor(z){this.f=z}checkout(){this.d||(this.d=this.g());const z=this.d;return z.observers++,{onDidChangeTest:z.tests.onDidChangeTests,get tests(){return[...z.tests.rootTests].map(j=>j.revived)},dispose:(0,l.$db)(()=>{--z.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(z){return this.d?.tests.getMirroredTestDataByReference(z)}applyDiff(z){this.d?.tests.apply(z)}g(){const z=new m;return this.f.$subscribeToDiffs(),{observers:0,tests:z}}}class P{#e;#t;get label(){return this.f}set label(z){z!==this.f&&(this.f=z,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:z}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(z){z!==this.h&&(this.h=z,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:z}))}get isDefault(){return this.g}set isDefault(z){z!==this.g&&(this.g=z,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:z}))}get tag(){return this._tag}set tag(z){z?.id!==this._tag?.id&&(this._tag=z,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:z?t.TestTag.namespace(this.controllerId,z.id):null}))}get configureHandler(){return this.d}set configureHandler(z){z!==this.d&&(this.d=z,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!z}))}constructor(z,j,O,N,ie,X,Ee,Se=!1,Pe=void 0,$e=!1){this.controllerId=O,this.profileId=N,this.f=ie,this.kind=X,this.runHandler=Ee,this.g=Se,this._tag=Pe,this.h=$e,this.#e=z,this.#t=j,j.set(N,this);const pe=W[X];if(typeof pe!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);this.#e.$publishTestRunProfile({profileId:N,controllerId:O,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:ie,group:pe,isDefault:Se,hasConfigurationHandler:!1,supportsContinuousRun:$e})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Idc=P;const W={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[255],Re([1,0,18,9,5,3,105,8,7]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=void 0;class ${constructor(k,a){this.i=a,this.a=new C.$Nd({onListenerError:M.$2}),this.b=new C.$Nd({onListenerError:M.$2}),this.c=new C.$Nd({onListenerError:M.$2}),this.d=new C.$Nd({onListenerError:M.$2}),this.f=new C.$Nd({onListenerError:M.$2}),this.g=new C.$Nd({onListenerError:M.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=k.getProxy(T.$fK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(k){const a=this.i.allEditors();return k?a:a.map(p=>p.value)}async showTextDocument(k,a,p){let g;typeof a=="number"?g={position:l.ViewColumn.from(a),preserveFocus:p}:typeof a=="object"?g={position:l.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?l.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:g={preserveFocus:!1};const d=await this.h.$tryShowTextDocument(k.uri,g),t=d&&this.i.getEditor(d);if(t)return t.value;throw d?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,a){return new A.$nM(this.h,k,a).value}$acceptEditorPropertiesChanged(k,a){const p=this.i.getEditor(k);if(!p)throw new Error("unknown text editor");if(a.options&&p._acceptOptions(a.options),a.selections){const g=a.selections.selections.map(l.Selection.to);p._acceptSelections(g)}if(a.visibleRanges){const g=y.$Hb(a.visibleRanges.map(l.Range.to));p._acceptVisibleRanges(g)}if(a.options&&this.b.fire({textEditor:p.value,options:{...a.options,lineNumbers:l.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const g=D.TextEditorSelectionChangeKind.fromValue(a.selections.source),d=a.selections.selections.map(l.Selection.to);this.a.fire({textEditor:p.value,selections:d,kind:g})}if(a.visibleRanges){const g=y.$Hb(a.visibleRanges.map(l.Range.to));this.c.fire({textEditor:p.value,visibleRanges:g})}}$acceptEditorPositionData(k){for(const a in k){const p=this.i.getEditor(a);if(!p)throw new Error("Unknown text editor");const g=l.ViewColumn.to(k[a]);p.value.viewColumn!==g&&(p._acceptViewColumn(g),this.d.fire({textEditor:p.value,viewColumn:g}))}}getDiffInformation(k){return Promise.resolve(this.h.$getDiffInformation(k))}}e.$Xcc=$}),define(Ae[256],Re([1,0,2,4,3,6,7,8,21,15]),function(ye,e,y,M,C,T,A,l,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=e.$zdc=void 0,e.$zdc=(0,M.$Ph)("IExtHostTimeline");class R{constructor(p,g){this.b=new Map,this.c=new Map,this.a=p.getProxy(C.$fK.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(d,t)=>{if(d&&d.$mid===12)if(this.b.get(d.source)&&D.$6l.equals(t,this.b.get(d.source)?.extension)){const i=d.uri===void 0?void 0:y.URI.revive(d.uri);return this.c.get(d.source)?.get(k(i))?.get(d.handle)}else return;return d}})}async $getTimeline(p,g,d,t){return this.b.get(p)?.provider.provideTimeline(y.URI.revive(g),d,t)}registerTimelineProvider(p,g,d,t){const i=new T.$Rc,c=this.d(g.id,t,i).bind(this);let b;g.onDidChange&&(b=g.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:g.id}),this));const E=this.c;return this.f({...g,scheme:p,onDidChange:void 0,async provideTimeline(v,s,r){s?.resetCache&&(i.clear(),E.get(g.id)?.clear());const n=await g.provideTimeline(v,s,r);if(n==null)return;const o=c(v,s);return{...n,source:g.id,items:n.items.map(o)}},dispose(){for(const v of E.values())v.get(g.id)?.clear();b?.dispose(),i.dispose()}},d)}d(p,g,d){return(t,i)=>{let c;if(i?.cacheResults){let b=this.c.get(p);b===void 0&&(b=new Map,this.c.set(p,b));const E=k(t);c=b.get(E),c===void 0&&(c=new Map,b.set(E,c))}return b=>{const{iconPath:E,...v}=b,s=`${p}|${b.id??b.timestamp}`;c?.set(s,b);let r,n,o;b.iconPath&&(E instanceof A.$bL?o={id:E.id,color:E.color}:y.URI.isUri(E)?(r=E,n=E):{light:r,dark:n}=E);let w;return A.$HK.isMarkdownString(v.tooltip)?w=l.MarkdownString.from(v.tooltip):(0,$.$yf)(v.tooltip)?w=v.tooltip:A.$HK.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=l.MarkdownString.from(v.detail)):(0,$.$yf)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=v.detail),{...v,id:v.id??void 0,handle:s,source:p,command:b.command?g.toInternal(b.command,d):void 0,icon:r,iconDark:n,themeIcon:o,tooltip:w,accessibilityInformation:b.accessibilityInformation}}}}f(p,g){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:g}),(0,T.$Qc)(()=>{for(const t of this.c.values())t.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$Adc=R;function k(a){return a?.toString()}}),define(Ae[86],Re([1,0,20,5,6,157,4,14,184,3,27,17,7]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6vb=e.$5vb=e.TunnelDtoConverter=void 0;class p extends D.$fv{}var g;(function(t){function i(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:b.protocol}}t.fromApiTunnel=i;function c(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==D.TunnelPrivacyId.ConstantPrivate&&b.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}t.fromServiceTunnel=c})(g||(e.TunnelDtoConverter=g={})),e.$5vb=(0,A.$Ph)("IExtHostTunnelService");let d=class extends C.$Sc{constructor(i,c,b){super(),this.s=b,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Nd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy($.$fK.MainThreadTunnelService)}async openTunnel(i,c){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const b=await this.a.$openTunnel(c,i.displayName);if(b){const E=new p(b.remoteAddress,b.localAddress,()=>this.a.$closeTunnel(b.remoteAddress));return this.B(E),E}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,c){const b=this.u();return this.r.set(b,{selector:i,provider:c}),this.a.$registerPortsAttributesProvider(i,b),new a.$hK(()=>{this.r.delete(b),this.a.$unregisterPortsAttributesProvider(b)})}async $providePortAttributes(i,c,b,E,v){const s=[];for(const n of i){const o=this.r.get(n);if(!o)return[];s.push(...await Promise.all(c.map(async w=>{let f;try{f=await o.provider.providePortAttributes({port:w,pid:b,commandLine:E},v)}catch{f=await o.provider.providePortAttributes(w,b,E,v)}return{providedAttributes:f,port:w}})))}const r=s.filter(n=>!!n.providedAttributes);return r.length>0?r.map(n=>({autoForwardAction:n.providedAttributes.autoForwardAction,port:n.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(E,v)=>await i.provideTunnel(E,v,new y.$Xd().token)??void 0;const b=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(b),Promise.resolve((0,C.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,c){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const b=i.tunnelFactory??(c?this.w(c):void 0);if(b){this.b=b;let E=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&E.length===0&&(E=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const v=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:E}:void 0;this.a.$setTunnelProvider(v)}}else this.b=void 0;return(0,C.$Qc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,c){if(this.g.has(i.host)){const b=this.g.get(i.host);b.has(i.port)&&(c&&b.get(i.port).disposeListener.dispose(),await b.get(i.port).tunnel.dispose(),b.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,c){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const b=this.b(i,c);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),b!==void 0){const E=await b;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),E===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const v=this.B(E.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(E.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:E,disposeListener:v}),g.fromApiTunnel(E)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(b){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),b instanceof Error)return b.message}}async $applyCandidateFilter(i){const c=await Promise.all(i.map(E=>this.f(E.host,E.port,E.detail??""))),b=i.filter((E,v)=>c[v]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(E=>E.port).join(", ")} to ${b.map(E=>E.port).join(", ")}`),b}};e.$6vb=d,e.$6vb=d=qe([Ke(0,k.$gM),Ke(1,R.$wM),Ke(2,l.$0i)],d)}),define(Ae[257],Re([1,0,6,13,2,3]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;class A{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(D){this.c=new Map,this.b=D.getProxy(T.$fK.MainThreadUriOpeners)}registerExternalUriOpener(D,$,R,k){if(this.c.has($))throw new Error(`Opener with id '${$}' already registered`);const a=k.schemes.find(p=>!A.a.has(p));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this.c.set($,R),this.b.$registerUriOpener($,k.schemes,D,k.label),(0,y.$Qc)(()=>{this.c.delete($),this.b.$unregisterUriOpener($)})}async $canOpenUri(D,$,R){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener with id: ${D}`);const a=C.URI.revive($);return k.canOpenExternalUri(a,R)}async $openUri(D,$,R){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener id: '${D}'`);return k.openExternalUri(C.URI.revive($.resolvedUri),{sourceUri:C.URI.revive($.sourceUri)},R)}}e.$Jdc=A}),define(Ae[258],Re([1,0,3,2,6,9,21]),function(ye,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;class l{static{this.a=0}constructor($){this.c=new A.$7l,this.d=new Map,this.b=$.getProxy(y.$fK.MainThreadUrls)}registerUriHandler($,R){const k=$.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const a=l.a++;return this.c.add(k),this.d.set(a,R),this.b.$registerUriHandler(a,k,$.displayName||$.name),(0,C.$Qc)(()=>{this.c.delete(k),this.d.delete(a),this.b.$unregisterUriHandler(a)})}$handleExternalUri($,R){const k=this.d.get($);if(!k)return Promise.resolve(void 0);try{k.handleUri(M.URI.revive(R))}catch(a){(0,T.$1)(a)}return Promise.resolve(void 0)}async createAppUri($){return M.URI.revive(await this.b.$createAppUri($))}}e.$Zcc=l}),define(Ae[64],Re([1,0,5,6,13,24,2,169,191,77,3]),function(ye,e,y,M,C,T,A,l,D,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=e.$4cc=e.$3cc=e.$2cc=e.$1cc=void 0;class k{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#h;constructor(E,v,s,r,n,o,w){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new y.$Nd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new y.$Nd,this._onDidDispose=this.#d.event,this.#e=E,this.#t=v,this.#r=s,this.#l=r,this.#u=n,this.#n=o,this.#c=a(o),this.#h=p(o),this.#i=w}#d;dispose(){this.#o=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(E){return this.#a=!0,(0,$.$8ob)(E,this.#l)}get cspSource(){const E=this.#n.extensionLocation;if(E.scheme===C.Schemas.https||E.scheme===C.Schemas.http){let v=E.toString();return v.endsWith("/")||(v+="/"),v+" "+$.$7ob}return $.$7ob}get html(){return this.a(),this.#s}set html(E){this.a(),this.#s!==E&&(this.#s=E,this.#h&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(E)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(E)))}get options(){return this.a(),this.#r}set options(E){this.a(),T.$$m(this.#r,E)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,E)),this.#r=E}async postMessage(E){if(this.#o)return!1;const v=(0,D.$ycb)(E,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,v.message,...v.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(E){if(!this.#h)return E;const v=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,s=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return E.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,n,o,w,f,I)=>{const S=A.URI.from({scheme:w||"file",path:decodeURIComponent(f)}),u=(0,$.$8ob)(S,{isRemote:v,authority:s}).toString();return`${n}${u}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,n,o,w,f,I)=>{const S=A.URI.from({scheme:w||"file",path:decodeURIComponent(f)}),u=(0,$.$8ob)(S,{isRemote:v,authority:s}).toString();return`${n}${u}${I}`})}}e.$1cc=k;function a(b){try{const E=(0,l.$Oo)((0,l.$No)(b.engines.vscode));return!!E&&E.majorBase>=1&&E.minorBase>=57}catch{return!1}}e.$2cc=a;function p(b){try{const E=(0,l.$Oo)((0,l.$No)(b.engines.vscode));return E?E.majorBase<1||E.majorBase===1&&E.minorBase<60:!1}catch{return!1}}class g extends M.$Sc{constructor(E,v,s,r,n){super(),this.c=v,this.f=s,this.g=r,this.h=n,this.b=new Map,this.a=E.getProxy(R.$fK.MainThreadWebviews)}dispose(){super.dispose();for(const E of this.b.values())E.dispose();this.b.clear()}$onMessage(E,v,s){const r=this.j(E);if(r){const{message:n}=(0,D.$zcb)(v,s.value);r._onMessageEmitter.fire(n)}}$onMissingCsp(E,v){this.g.warn(`${v} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(E,v,s){const r=new k(E,this.a,i(v),this.c,this.f,s,this.h);this.b.set(E,r);const n=r._onDidDispose(()=>{n.dispose(),this.deleteWebview(E)});return r}deleteWebview(E){this.b.delete(E)}j(E){return this.b.get(E)}}e.$3cc=g;function d(b){return{id:b.identifier,location:b.extensionLocation}}e.$4cc=d;function t(b,E,v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots||c(b,E)}}e.$5cc=t;function i(b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots?.map(E=>A.URI.from(E))}}function c(b,E){return[...(E?.getWorkspaceFolders()||[]).map(v=>v.uri),b.extensionLocation]}}),define(Ae[259],Re([1,0,20,93,6,13,23,2,8,64,74,3,7]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;class p{constructor(r,n){this.document=r,this.b=n,this.a=1,this.c=new R.$Wbc("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,n){await this.f(r).undo(),n||this.disposeBackup()}async redo(r,n){await this.f(r).redo(),n||this.disposeBackup()}disposeEdits(r){for(const n of r)this.c.delete(n)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=v(this.document.uri)+this.a++;return(0,A.$vg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const n=this.c.get(r,0);if(!n)throw new Error("No edit found");return n}}class g{constructor(){this.a=new Map}get(r,n){return this.a.get(this.b(r,n))}add(r,n,o){const w=this.b(r,n.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${r} resource:${n.uri}`);const f=new p(n,o);return this.a.set(w,f),f}delete(r,n){const o=this.b(r,n.uri);this.a.delete(o)}b(r,n){return`${r}@@@${n}`}}var d;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(d||(d={}));class t{constructor(){this.a=new Map}addTextProvider(r,n,o){return this.b(0,r,n,o)}addCustomProvider(r,n,o){return this.b(1,r,n,o)}get(r){return this.a.get(r)}b(r,n,o,w){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,{type:r,extension:o,provider:w}),new a.$hK(()=>this.a.delete(n))}}class i{constructor(r,n,o,w,f){this.d=n,this.f=o,this.g=w,this.h=f,this.b=new t,this.c=new g,this.a=r.getProxy(k.$fK.MainThreadCustomEditors)}registerCustomEditorProvider(r,n,o,w){const f=new C.$Rc;return b(o)?(f.add(this.b.addTextProvider(n,r,o)),this.a.$registerTextEditorProvider((0,$.$4cc)(r),n,w.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,$.$2cc)(r))):(f.add(this.b.addCustomProvider(n,r,o)),c(o)&&f.add(o.onDidChangeCustomDocument(I=>{const S=this.i(n,I.document.uri);if(E(I)){const u=S.addEdit(I);this.a.$onDidEdit(I.document.uri,n,u,I.label)}else this.a.$onContentChange(I.document.uri,n)})),this.a.$registerCustomEditorProvider((0,$.$4cc)(r),n,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,$.$2cc)(r))),a.$hK.from(f,new a.$hK(()=>{this.a.$unregisterEditorProvider(n)}))}async $createCustomDocument(r,n,o,w,f){const I=this.b.get(n);if(!I)throw new Error(`No provider found for '${n}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${n}'`);const S=l.URI.revive(r),u=await I.provider.openCustomDocument(S,{backupId:o,untitledDocumentData:w?.buffer},f);let m;return c(I.provider)&&this.f&&(m=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(n,u,m),{editable:c(I.provider)}}async $disposeCustomDocument(r,n){const o=this.b.get(n);if(!o)throw new Error(`No provider found for '${n}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${n}'`);const w=l.URI.revive(r),{document:f}=this.i(n,w);this.c.delete(n,f),f.dispose()}async $resolveCustomEditor(r,n,o,w,f,I){const S=this.b.get(o);if(!S)throw new Error(`No provider found for '${o}'`);const u=D.ViewColumn.to(f),m=this.g.createNewWebview(n,w.contentOptions,S.extension),h=this.h.createNewWebviewPanel(n,o,w.title,u,w.options,m,w.active),P=l.URI.revive(r);switch(S.type){case 1:{const{document:W}=this.i(o,P);return S.provider.resolveCustomEditor(W,h,I)}case 0:{const W=this.d.getDocument(P);return S.provider.resolveCustomTextEditor(W,h,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,n,o){this.i(n,r).disposeEdits(o)}async $onMoveCustomEditor(r,n,o){const w=this.b.get(o);if(!w)throw new Error(`No provider found for '${o}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const f=this.h.getWebviewPanel(r);if(!f)throw new Error("No webview found");const I=l.URI.revive(n),S=this.d.getDocument(I);await w.provider.moveCustomTextEditor(S,f,y.CancellationToken.None)}async $undo(r,n,o,w){return this.i(n,r).undo(o,w)}async $redo(r,n,o,w){return this.i(n,r).redo(o,w)}async $revert(r,n,o){const w=this.i(n,r);await this.j(n).revertCustomDocument(w.document,o),w.disposeBackup()}async $onSave(r,n,o){const w=this.i(n,r);await this.j(n).saveCustomDocument(w.document,o),w.disposeBackup()}async $onSaveAs(r,n,o,w){const f=this.i(n,r);return this.j(n).saveCustomDocumentAs(f.document,l.URI.revive(o),w)}async $backup(r,n,o){const w=this.i(n,r),I=await this.j(n).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},o);return w.updateBackup(I),I.id}i(r,n){const o=this.c.get(r,l.URI.revive(n));if(!o)throw new Error("No custom document found");return o}j(r){const o=this.b.get(r)?.provider;if(!o||!c(o))throw new Error("Custom document is not editable");return o}}e.$Ddc=i;function c(s){return!!s.onDidChangeCustomDocument}function b(s){return typeof s.resolveCustomTextEditor=="function"}function E(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function v(s){const r=s.scheme===T.Schemas.file||s.scheme===T.Schemas.untitled?s.fsPath:s.toString();return(0,M.$Di)(r)+""}}),define(Ae[260],Re([1,0,5,6,2,36,8,64,3,7]),function(ye,e,y,M,C,T,A,l,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class R extends M.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#h;#d;constructor(g,d,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#h=this.B(new y.$Nd),this.onDidDispose=this.#h.event,this.#d=this.B(new y.$Nd),this.onDidChangeViewState=this.#d.event,this.#e=g,this.#t=d,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(g){this.c(),this.#n!==g&&(this.#n=g,this.#t.$setTitle(this.#e,g))}get iconPath(){return this.c(),this.#s}set iconPath(g){this.c(),this.#s!==g&&(this.#s=g,this.#t.$setIconPath(this.#e,C.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(g){this.#c||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(this.#a=g.active,this.#o=g.visible,this.#r=g.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(g,d){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof g>"u"?void 0:A.ViewColumn.from(g),preserveFocus:!!d})}c(){if(this.#c)throw new Error("Webview is disposed")}}class k extends M.$Sc{static c(){return(0,T.$eg)()}constructor(g,d,t){super(),this.j=d,this.m=t,this.g=new Map,this.h=new Map,this.f=g.getProxy(D.$fK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(g=>g.dispose()),this.g.clear()}createWebviewPanel(g,d,t,i,c={}){const b=typeof i=="object"?i.viewColumn:i,E={viewColumn:A.ViewColumn.from(b),preserveFocus:typeof i=="object"&&!!i.preserveFocus},v=(0,l.$2cc)(g),s=k.c();this.f.$createWebviewPanel((0,l.$4cc)(g),s,d,{title:t,panelOptions:a(c),webviewOptions:(0,l.$5cc)(g,this.m,c),serializeBuffersForPostMessage:v},E);const r=this.j.createNewWebview(s,c,g);return this.createNewWebviewPanel(s,d,t,b,c,r,!0)}$onDidChangeWebviewPanelViewStates(g){const d=Object.keys(g);d.sort((t,i)=>{const c=g[t],b=g[i];return c.active?1:b.active?-1:+c.visible-+b.visible});for(const t of d){const i=this.getWebviewPanel(t);if(!i)continue;const c=g[t];i._updateViewState({active:c.active,visible:c.visible,viewColumn:A.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this.g.delete(g),this.j.deleteWebview(g)}registerWebviewPanelSerializer(g,d,t){if(this.h.has(d))throw new Error(`Serializer for '${d}' already registered`);return this.h.set(d,{serializer:t,extension:g}),this.f.$registerSerializer(d,{serializeBuffersForPostMessage:(0,l.$2cc)(g)}),new $.$hK(()=>{this.h.delete(d),this.f.$unregisterSerializer(d)})}async $deserializeWebviewPanel(g,d,t,i){const c=this.h.get(d);if(!c)throw new Error(`No serializer found for '${d}'`);const{serializer:b,extension:E}=c,v=this.j.createNewWebview(g,t.webviewOptions,E),s=this.createNewWebviewPanel(g,d,t.title,i,t.panelOptions,v,t.active);await b.deserializeWebviewPanel(s,t.state)}createNewWebviewPanel(g,d,t,i,c,b,E){const v=new R(g,this.f,b,{viewType:d,title:t,viewColumn:i,panelOptions:c,active:E});return this.g.set(g,v),v}getWebviewPanel(g){return this.g.get(g)}}e.$Cdc=k;function a(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Ae[261],Re([1,0,5,6,64,8,3,7]),function(ye,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;class D extends M.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(k,a,p,g,d,t){super(),this.#u=!1,this.#a=this.B(new y.$Nd),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new y.$Nd),this.onDidDispose=this.#c.event,this.#i=p,this.#s=g,this.#e=k,this.#t=a,this.#l=d,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(k){this.a(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#r}set description(k){this.a(),this.#r!==k&&(this.#r=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(k){k===this.#n||this.#u||(this.#n=k,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(k){this.a(),!(k?.value===this.#o?.value&&k?.tooltip===this.#o?.tooltip)&&(this.#o=T.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#u)throw new Error("Webview is disposed")}}class ${constructor(k,a){this.d=a,this.b=new Map,this.c=new Map,this.a=k.getProxy(A.$fK.MainThreadWebviewViews)}registerWebviewViewProvider(k,a,p,g){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:p,extension:k}),this.a.$registerWebviewViewProvider((0,C.$4cc)(k),a,{retainContextWhenHidden:g?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$2cc)(k)}),new l.$hK(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(k,a,p,g,d){const t=this.b.get(a);if(!t)throw new Error(`No view provider found for '${a}'`);const{provider:i,extension:c}=t,b=this.d.createNewWebview(k,{},c),E=new D(k,this.a,a,p,b,!0);this.c.set(k,E),await i.resolveWebviewView(E,{state:g},d)}async $onDidChangeWebviewViewVisibility(k,a){this.e(k)._setVisible(a)}async $disposeWebviewView(k){const a=this.e(k);this.c.delete(k),a.dispose(),this.d.deleteWebview(k)}e(k){const a=this.c.get(k);if(!a)throw new Error("No webview found");return a}}e.$Bdc=$}),define(Ae[108],Re([1,0,5,3,2,13,16,4,17,25]),function(ye,e,y,M,C,T,A,l,D,$){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=e.$6cc=void 0;let k=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(p){const g=this.d;return{get focused(){return g.focused},get active(){return(0,$.$dF)(p,"windowActivity"),g.active}}}constructor(p){this.c=new y.$Nd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=p.getProxy(M.$fK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:g,isActive:d})=>{this.onDidChangeWindowProperty("focused",g),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,g){g!==this.d[p]&&(this.d={...this.d,[p]:g},this.c.fire(this.d))}openUri(p,g){let d;if(typeof p=="string"){d=p;try{p=C.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,A.$Be)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,d,g)}async asExternalUri(p,g){if((0,A.$Be)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(p,g);return C.URI.from(d)}};e.$6cc=k,e.$6cc=k=R=qe([Ke(0,D.$gM)],k),e.$7cc=(0,l.$Ph)("IExtHostWindow")}),define(Ae[262],Re([1,0,227,27,17]),function(ye,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;let T=class extends y.$7dc{constructor(l,D){super(l,D)}f(l,D,$){D.apply(console,$)}};e.$bgc=T,e.$bgc=T=qe([Ke(0,C.$gM),Ke(1,M.$wM)],T)}),define(Ae[263],Re([1,0,12,26,20,9,5,6,132,215,47]),function(ye,e,y,M,C,T,A,l,D,$,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$q4b=e.ResponsiveState=e.RequestInitiator=e.$p4b=e.$o4b=void 0;function a(h,P){try{return JSON.stringify(h,P)}catch{return"null"}}const p="$$ref$$",g={[p]:-1};class d{constructor(P,W){this.jsonString=P,this.referencedBuffers=W}}function t(h,P=null,W=!1){const K=[];return{jsonString:(W?a:JSON.stringify)(h,(j,O)=>{if(typeof O>"u")return g;if(typeof O=="object"){if(O instanceof M.$be){const N=K.push(O)-1;return{[p]:N}}if(P)return P(j,O)}return O}),referencedBuffers:K}}e.$o4b=t;function i(h,P,W){return JSON.parse(h,(K,z)=>{if(z){const j=z[p];if(typeof j=="number")return P[j];if(W&&z.$mid===1)return W.transformIncoming(z)}return z})}e.$p4b=i;function c(h,P){return JSON.stringify(h,P)}function b(h){return h?(P,W)=>W&&W.$mid===1?h.transformOutgoing(W):W:null}var E;(function(h){h[h.LocalSide=0]="LocalSide",h[h.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));var v;(function(h){h[h.Responsive=0]="Responsive",h[h.Unresponsive=1]="Unresponsive"})(v||(e.ResponsiveState=v={}));const s=()=>{},r=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class o extends l.$Sc{static{k=r}static{this.a=3*1e3}constructor(P,W=null,K=null){super(),this[k]=!0,this.b=this.B(new A.$Nd),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=W,this.g=K,this.h=b(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,j=R.$mv.count;z<j;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new y.$6g(()=>this.H(),1e3)),this.c.onMessage(z=>this.L(z))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const W=this.w[P];delete this.w[P],W.resolveErr(T.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,D.$Om)(P,this.g):P}getProxy(P){const{nid:W,sid:K}=P;return this.s[W]||(this.s[W]=this.J(W,K)),this.s[W]}J(P,W){const K={get:(z,j)=>(typeof j=="string"&&!z[j]&&j.charCodeAt(0)===36&&(z[j]=(...O)=>this.U(P,j,O)),j===n?W:z[j])};return new Proxy(Object.create(null),K)}set(P,W){return this.m[P.nid]=W,W}assertRegistered(P){for(let W=0,K=P.length;W<K;W++){const z=P[W];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(P){if(this.j)return;const W=P.byteLength,K=f.read(P,0),z=K.readUInt8(),j=K.readUInt32();switch(z){case 1:case 2:{let{rpcId:O,method:N,args:ie}=S.deserializeRequestJSONArgs(K);this.g&&(ie=(0,D.$Om)(ie,this.g)),this.M(W,j,O,N,ie,z===2);break}case 3:case 4:{let{rpcId:O,method:N,args:ie}=S.deserializeRequestMixedArgs(K);this.g&&(ie=(0,D.$Om)(ie,this.g)),this.M(W,j,O,N,ie,z===4);break}case 5:{this.f?.logIncoming(W,j,0,"ack"),this.G(j);break}case 6:{this.N(W,j);break}case 7:{this.O(W,j,void 0);break}case 9:{let O=S.deserializeReplyOKJSON(K);this.g&&(O=(0,D.$Om)(O,this.g)),this.O(W,j,O);break}case 10:{const O=S.deserializeReplyOKJSONWithBuffers(K,this.g);this.O(W,j,O);break}case 8:{const O=S.deserializeReplyOKVSBuffer(K);this.O(W,j,O);break}case 11:{let O=S.deserializeReplyErrError(K);this.g&&(O=(0,D.$Om)(O,this.g)),this.P(W,j,O);break}case 12:{this.P(W,j,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,W,K,z,j,O){this.f?.logIncoming(P,W,1,`receiveRequest ${(0,R.$ov)(K)}.${z}(`,j);const N=String(W);let ie,X;if(O){const Se=new C.$Xd;j.push(Se.token),ie=this.Q(K,z,j),X=()=>Se.cancel()}else ie=this.Q(K,z,j),X=s;this.u[N]=X;const Ee=S.serializeAcknowledged(W);this.f?.logOutgoing(Ee.byteLength,W,1,"ack"),this.c.send(Ee),ie.then(Se=>{delete this.u[N];const Pe=S.serializeReplyOK(W,Se,this.h);this.f?.logOutgoing(Pe.byteLength,W,1,"reply:",Se),this.c.send(Pe)},Se=>{delete this.u[N];const Pe=S.serializeReplyErr(W,Se);this.f?.logOutgoing(Pe.byteLength,W,1,"replyErr:",Se),this.c.send(Pe)})}N(P,W){this.f?.logIncoming(P,W,1,"receiveCancel");const K=String(W);this.u[K]?.()}O(P,W,K){this.f?.logIncoming(P,W,0,"receiveReply:",K);const z=String(W);if(!this.w.hasOwnProperty(z))return;const j=this.w[z];delete this.w[z],j.resolveOk(K)}P(P,W,K){this.f?.logIncoming(P,W,0,"receiveReplyErr:",K);const z=String(W);if(!this.w.hasOwnProperty(z))return;const j=this.w[z];delete this.w[z];let O;K&&(K.$isError?(O=new Error,O.name=K.name,O.message=K.message,O.stack=K.stack):O=K),j.resolveErr(O)}Q(P,W,K){try{return Promise.resolve(this.S(P,W,K))}catch(z){return Promise.reject(z)}}S(P,W,K){const z=this.m[P];if(!z)throw new Error("Unknown actor "+(0,R.$ov)(P));const j=z[W];if(typeof j!="function")throw new Error("Unknown method "+W+" on actor "+(0,R.$ov)(P));return j.apply(z,K)}U(P,W,K){if(this.j)return new $.$n4b;let z=null;if(K.length>0&&C.CancellationToken.isCancellationToken(K[K.length-1])&&(z=K.pop()),z&&z.isCancellationRequested)return Promise.reject(T.$6());const j=S.serializeRequestArguments(K,this.h),O=++this.t,N=String(O),ie=new $.$m4b,X=new l.$Rc;z&&X.add(z.onCancellationRequested(()=>{const Se=S.serializeCancel(O);this.f?.logOutgoing(Se.byteLength,O,0,"cancel"),this.c.send(S.serializeCancel(O))})),this.w[N]=new w(ie,X),this.F(O);const Ee=S.serializeRequest(O,P,W,j,!!z);return this.f?.logOutgoing(Ee.byteLength,O,0,`request: ${(0,R.$ov)(P)}.${W}(`,K),this.c.send(Ee),ie}}e.$q4b=o;class w{constructor(P,W){this.a=P,this.b=W}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class f{static alloc(P,W,K){const z=new f(M.$be.alloc(K+1+4),0);return z.writeUInt8(P),z.writeUInt32(W),z}static read(P,W){return new f(P,W)}get buffer(){return this.a}constructor(P,W){this.a=P,this.b=W}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const K=this.a.slice(this.b,this.b+P).toString();return this.b+=P,K}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+P).toString();return this.b+=P,K}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+P);return this.b+=P,W}static sizeMixedArray(P){let W=0;W+=1;for(let K=0,z=P.length;K<z;K++){const j=P[K];switch(W+=1,j.type){case 1:W+=this.sizeLongString(j.value);break;case 2:W+=this.sizeVSBuffer(j.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(j.value);for(let O=0;O<j.buffers.length;++O)W+=this.sizeVSBuffer(j.buffers[O]);break;case 4:break}}return W}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let W=0,K=P.length;W<K;W++){const z=P[W];switch(z.type){case 1:this.writeUInt8(1),this.writeLongString(z.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(z.value);break;case 3:this.writeUInt8(3),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let j=0;j<z.buffers.length;++j)this.writeBuffer(z.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const W=new Array(P);for(let K=0;K<P;K++)switch(this.readUInt8()){case 1:W[K]=this.readLongString();break;case 2:W[K]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),O=this.readLongString(),N=[];for(let ie=0;ie<j;++ie)N.push(this.readVSBuffer());W[K]=new R.$pv(i(O,N,null));break}case 4:W[K]=void 0;break}return W}}var I;(function(h){h[h.Simple=0]="Simple",h[h.Mixed=1]="Mixed"})(I||(I={}));class S{static a(P){for(let W=0,K=P.length;W<K;W++)if(P[W]instanceof M.$be||P[W]instanceof R.$pv||typeof P[W]>"u")return!0;return!1}static serializeRequestArguments(P,W){if(this.a(P)){const K=[];for(let z=0,j=P.length;z<j;z++){const O=P[z];if(O instanceof M.$be)K[z]={type:2,value:O};else if(typeof O>"u")K[z]={type:4};else if(O instanceof R.$pv){const{jsonString:N,referencedBuffers:ie}=t(O.value,W);K[z]={type:3,value:M.$be.fromString(N),buffers:ie}}else K[z]={type:1,value:M.$be.fromString(c(O,W))}}return{type:1,args:K}}return{type:0,args:c(P,W)}}static serializeRequest(P,W,K,z,j){switch(z.type){case 0:return this.b(P,W,K,z.args,j);case 1:return this.c(P,W,K,z.args,j)}}static b(P,W,K,z,j){const O=M.$be.fromString(K),N=M.$be.fromString(z);let ie=0;ie+=f.sizeUInt8(),ie+=f.sizeShortString(O),ie+=f.sizeLongString(N);const X=f.alloc(j?2:1,P,ie);return X.writeUInt8(W),X.writeShortString(O),X.writeLongString(N),X.buffer}static deserializeRequestJSONArgs(P){const W=P.readUInt8(),K=P.readShortString(),z=P.readLongString();return{rpcId:W,method:K,args:JSON.parse(z)}}static c(P,W,K,z,j){const O=M.$be.fromString(K);let N=0;N+=f.sizeUInt8(),N+=f.sizeShortString(O),N+=f.sizeMixedArray(z);const ie=f.alloc(j?4:3,P,N);return ie.writeUInt8(W),ie.writeShortString(O),ie.writeMixedArray(z),ie.buffer}static deserializeRequestMixedArgs(P){const W=P.readUInt8(),K=P.readShortString(),z=P.readMixedArray(),j=new Array(z.length);for(let O=0,N=z.length;O<N;O++){const ie=z[O];typeof ie=="string"?j[O]=JSON.parse(ie):j[O]=ie}return{rpcId:W,method:K,args:j}}static serializeAcknowledged(P){return f.alloc(5,P,0).buffer}static serializeCancel(P){return f.alloc(6,P,0).buffer}static serializeReplyOK(P,W,K){if(typeof W>"u")return this.d(P);if(W instanceof M.$be)return this.e(P,W);if(W instanceof R.$pv){const{jsonString:z,referencedBuffers:j}=t(W.value,K,!0);return this.g(P,z,j)}else return this.f(P,a(W,K))}static d(P){return f.alloc(7,P,0).buffer}static e(P,W){let K=0;K+=f.sizeVSBuffer(W);const z=f.alloc(8,P,K);return z.writeVSBuffer(W),z.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,W){const K=M.$be.fromString(W);let z=0;z+=f.sizeLongString(K);const j=f.alloc(9,P,z);return j.writeLongString(K),j.buffer}static g(P,W,K){const z=M.$be.fromString(W);let j=0;j+=f.sizeUInt32,j+=f.sizeLongString(z);for(const N of K)j+=f.sizeVSBuffer(N);const O=f.alloc(10,P,j);O.writeUInt32(K.length),O.writeLongString(z);for(const N of K)O.writeBuffer(N);return O.buffer}static deserializeReplyOKJSON(P){const W=P.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(P,W){const K=P.readUInt32(),z=P.readLongString(),j=[];for(let O=0;O<K;++O)j.push(P.readVSBuffer());return new R.$pv(i(z,j,W))}static serializeReplyErr(P,W){const K=W?a(T.$3(W),null):void 0;if(typeof K!="string")return this.h(P);const z=M.$be.fromString(K);let j=0;j+=f.sizeLongString(z);const O=f.alloc(11,P,j);return O.writeLongString(z),O.buffer}static deserializeReplyErrError(P){const W=P.readLongString();return JSON.parse(W)}static h(P){return f.alloc(12,P,0).buffer}}var u;(function(h){h[h.RequestJSONArgs=1]="RequestJSONArgs",h[h.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",h[h.RequestMixedArgs=3]="RequestMixedArgs",h[h.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",h[h.Acknowledged=5]="Acknowledged",h[h.Cancel=6]="Cancel",h[h.ReplyOKEmpty=7]="ReplyOKEmpty",h[h.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",h[h.ReplyOKJSON=9]="ReplyOKJSON",h[h.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",h[h.ReplyErrError=11]="ReplyErrError",h[h.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var m;(function(h){h[h.String=1]="String",h[h.VSBuffer=2]="VSBuffer",h[h.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",h[h.Undefined=4]="Undefined"})(m||(m={}))}),define(Ae[264],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;const y=function(T){const A=l=>{globalThis.removeEventListener("message",A);const D=l.data;Object.defineProperties(globalThis,{postMessage:{value($,R){D.postMessage($,R)}},onmessage:{get(){return D.onmessage},set($){D.onmessage=$}}}),D.addEventListener("message",$=>{globalThis.dispatchEvent(new MessageEvent("message",{data:$.data,ports:$.ports?[...$.ports]:void 0}))}),D.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};globalThis.addEventListener("message",A)}.toString();class M extends EventTarget{constructor(T,A,l){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${y})('${A}'))`,$=new Blob([D],{type:"application/javascript"}),R=URL.createObjectURL($),k=new MessageChannel,a=R,p={type:"_newWorker",id:a,port:k.port2,url:R,options:l};T(p,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{T({type:"_terminateWorker",id:a}),URL.revokeObjectURL(R),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(g){k.port1.onmessage=g}},onmessageerror:{get(){return k.port1.onmessageerror},set(g){k.port1.onmessageerror=g}}}),k.port1.addEventListener("messageerror",g=>{const d=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(d)}),k.port1.addEventListener("message",g=>{const d=new MessageEvent("message",{data:g.data});this.dispatchEvent(d)}),k.port1.start()}}e.$dgc=M}),define(Ae[265],Re([1,0,5,30,32,4]),function(ye,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BJ=e.$AJ=e.OutputChannelUpdateMode=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=void 0,e.$qJ="text/x-code-output",e.$rJ="output",e.$sJ="Log",e.$tJ="text/x-code-log-output",e.$uJ="log",e.$vJ="workbench.panel.output",e.$wJ=new C.$7i("inOutput",!1),e.$xJ=new C.$7i("activeLogOutput",!1),e.$yJ=new C.$7i("outputView.scrollLock",!1),e.$zJ=(0,T.$Ph)("outputService");var A;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$AJ={OutputChannels:"workbench.contributions.outputChannels"};class l{constructor(){this.a=new Map,this.b=new y.$Nd,this.onDidRegisterChannel=this.b.event,this.c=new y.$Nd,this.onDidRemoveChannel=this.c.event}registerChannel($){this.a.has($.id)||(this.a.set($.id,$),this.b.fire($.id))}getChannels(){const $=[];return this.a.forEach(R=>$.push(R)),$}getChannel($){return this.a.get($)}removeChannel($){this.a.delete($),this.c.fire($)}}M.$gn.add(e.$AJ.OutputChannels,new l),e.$BJ=new C.$7i("activeOutputChannel","")}),define(Ae[109],Re([1,0,3,4,17,21,14,265,62,27,40,129,26,15,39,5,6]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=e.$Pcc=void 0;class i extends A.$dj{get disposed(){return this.n}constructor(v,s,r,n,o){super(),this.id=v,this.name=s,this.r=r,this.s=n,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.m;this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Clear,v)}replace(v){const s=this.m;this.info(v),this.s.$update(this.id,l.OutputChannelUpdateMode.Replace,s),this.visible&&this.r.flush()}show(v,s){this.r.flush(),this.s.$reveal(this.id,!!(typeof v=="boolean"?v:s))}hide(){this.s.$close(this.id)}g(v,s){this.m+=a.$be.fromString(s).byteLength,(0,A.log)(this.r,v,s),this.visible&&(this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class c extends i{appendLine(v){this.append(v)}}let b=class{constructor(v,s,r,n,o,w){this.i=s,this.j=r,this.k=n,this.l=o,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=v.getProxy(y.$fK.MainThreadOutputService),this.b=this.k.extUri.joinPath(s.logsLocation,`output_logging_${(0,k.$em)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.h=v;for(const[s,r]of this.g)r.visible=s===this.h}createOutputChannel(v,s,r){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const n=typeof s=="object"&&s.log,o=(0,p.$yf)(s)?s:void 0;if((0,p.$yf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const f=this.i.environment.extensionLogLevel?.find(([S])=>T.$6l.equals(r.identifier,S))?.[1];f&&(w=(0,A.$nj)(f));const I=n?this.o(v,w,r):this.n(v,o,r);return I.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),n?this.r(v,w??this.m.getLevel(),I):this.q(v,I)}async n(v,s,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const n=await this.c,o=this.k.extUri.joinPath(n,`${this.f++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.a.$register(v,o,s,r.identifier.value);return new i(f,v,w,this.a,r)}async o(v,s,r){const n=await this.p(r),o=v.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(n,`${o}.log`),f=`${r.identifier.value}.${o}`,I=this.l.createLogger(w,{id:f,name:v,logLevel:s,extensionId:r.identifier.value});return new c(f,v,I,this.a,r)}p(v){let s=this.d.get(v.identifier.value);if(!s){const r=this.k.extUri.joinPath(this.i.logsLocation,v.identifier.value);this.d.set(v.identifier.value,s=(async()=>{try{await this.j.value.createDirectory(r)}catch(n){if((0,g.$ok)(n)!==g.FileSystemProviderErrorCode.FileExists)throw n}return r})())}return s}q(v,s){let r=!1;const n=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return v},append(o){n(),s.then(w=>w.append(o))},appendLine(o){n(),s.then(w=>w.appendLine(o))},clear(){n(),s.then(o=>o.clear())},replace(o){n(),s.then(w=>w.replace(o))},show(o,w){n(),s.then(f=>f.show(o,w))},hide(){n(),s.then(o=>o.hide())},dispose(){r=!0,s.then(o=>o.dispose())}}}r(v,s,r){const n=new t.$Rc,o=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},w=n.add(new d.$Nd);function f(I){s=I,w.fire(I)}return r.then(I=>{n.add(I),I.logLevel!==s&&f(I.logLevel),n.add(I.onDidChangeLogLevel(S=>f(S)))}),{...this.q(v,r),get logLevel(){return s},onDidChangeLogLevel:w.event,trace(I,...S){o(),r.then(u=>u.trace(I,...S))},debug(I,...S){o(),r.then(u=>u.debug(I,...S))},info(I,...S){o(),r.then(u=>u.info(I,...S))},warn(I,...S){o(),r.then(u=>u.warn(I,...S))},error(I,...S){o(),r.then(u=>u.error(I,...S))},dispose(){n.dispose()}}}};e.$Pcc=b,e.$Pcc=b=qe([Ke(0,C.$gM),Ke(1,$.$wM),Ke(2,D.$scc),Ke(3,R.$Zbc),Ke(4,A.$$i),Ke(5,A.$0i)],b),e.$Qcc=(0,M.$Ph)("IExtHostOutputService")}),define(Ae[266],Re([1,0,4,12]),function(ye,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0,e.$tm=(0,y.$Ph)("remoteAgentService"),e.$um=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let T=1/0;for(let l=0;l<this.maxSampleCount;l++){const D=await C.getRoundTripTime();if(D===void 0)return;T=Math.min(T,D/2),await(0,M.$Ug)(this.sampleDelay)}this.average.push(T),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(T):A=this.initial.reduce((l,D)=>l+D,0)/this.initial.length,this.lastMeasurement={initial:A,current:T,average:this.average.reduce((l,D)=>l+D,0)/this.average.length,high:(()=>typeof A>"u"?!1:T>this.highLatencyMaxThreshold||T>this.highLatencyMinThreshold&&T>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[267],Re([1,0,43,13,19,22,23,2,4,186,55,208,266]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$UJ=e.$TJ=void 0,e.$TJ=(0,D.$Ph)("pathService");let g=p=class{constructor(t,i,c,b){this.d=t,this.e=i,this.f=c,this.g=b,this.a=(async()=>(await this.e.getEnvironment())?.os||T.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??t})()}hasValidBasename(t,i,c){return typeof i=="string"||typeof i>"u"?this.a.then(b=>this.h(t,b,i)):this.h(t,i,c)}h(t,i,c){return t.scheme===M.Schemas.file||t.scheme===M.Schemas.vscodeRemote?(0,y.$Vf)(c??(0,A.$sg)(t),i===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return M.Schemas.vscodeRemote;const c=(0,$.$QJ)(i.getWorkspace());if(c)return c;const b=i.getWorkspace().folders[0];if(b)return b.uri.scheme;const E=i.getWorkspace().configuration;return E?E.scheme:M.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?C.$fc:C.$gc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const b=t.indexOf("/",2);b===-1?(i=t.substring(2),t="/"):(i=t.substring(2,b),t=t.substring(b)||"/")}return l.URI.from({scheme:M.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$UJ=g,e.$UJ=g=p=qe([Ke(1,a.$tm),Ke(2,k.$CJ),Ke(3,R.$Yh)],g)}),define(Ae[110],Re([1,0]),function(ye,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$BI=e.$AI=void 0;class y{constructor(A,l){this.line=A,this.character=l}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,l){return new y(0,0)}with(A){return new y(0,0)}}e.$AI=y;class M{constructor(A,l,D,$){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(A,l),this.end=new y(D,$)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new M(0,0,0,0)}with(A){return new M(0,0,0,0)}}e.$BI=M;var C;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ae[48],Re([1,0,18,38,24,43,16,4,19,9,110,12]),function(ye,e,y,M,C,T,A,l,D,$,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.SearchErrorCode=e.$QI=e.$PI=e.SearchSortOrder=e.ViewMode=e.$OI=e.$NI=e.$MI=e.$LI=e.SearchCompletionExitCode=e.$KI=e.$JI=e.$II=e.QueryType=e.SearchProviderType=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$CI="workbench.view.search",e.$DI="workbench.panel.search",e.$EI="workbench.view.search",e.$FI="search-result",e.$GI="search.exclude";const a="\u27EA ",p=" characters skipped \u27EB",g=(a.length+p.length+5)*2;e.$HI=(0,l.$Ph)("searchService");var d;(function($e){$e[$e.file=0]="file",$e[$e.text=1]="text"})(d||(e.SearchProviderType=d={}));var t;(function($e){$e[$e.File=1]="File",$e[$e.Text=2]="Text"})(t||(e.QueryType=t={}));function i($e){return!!$e.preview}e.$II=i;function c($e){return!!$e.resource}e.$JI=c;function b($e){return!!$e.message}e.$KI=b;var E;(function($e){$e[$e.Normal=0]="Normal",$e[$e.NewSearchStarted=1]="NewSearchStarted"})(E||(e.SearchCompletionExitCode=E={}));class v{constructor(pe){this.resource=pe,this.results=[]}}e.$LI=v;class s{constructor(pe,ue,oe,be){this.ranges=ue,this.webviewIndex=be;const _=Array.isArray(ue)?ue:[ue];if(oe&&oe.matchLines===1&&r(_)){pe=(0,A.$rf)(pe,oe.matchLines);let B="",Z=0,ee=0;const ve=Math.floor(oe.charsPerLine/5),ge=[];for(const de of _){const De=Math.max(de.startColumn-ve,0),re=de.startColumn+oe.charsPerLine;if(De>ee+ve+g){const le=a+(De-ee)+p;B+=le+pe.slice(De,re),Z+=De-(ee+le.length)}else B+=pe.slice(ee,re);ge.push(new o(0,de.startColumn-Z,de.endColumn-Z)),ee=re}this.preview={text:B,matches:Array.isArray(this.ranges)?ge:ge[0]}}else{const B=Array.isArray(ue)?ue[0].startLineNumber:ue.startLineNumber;this.preview={text:pe,matches:(0,y.$2b)(ue,Z=>new n(Z.startLineNumber-B,Z.startColumn,Z.endLineNumber-B,Z.endColumn))}}}}e.$MI=s;function r($e){const pe=$e[0].startLineNumber;for(const ue of $e)if(ue.startLineNumber!==pe||ue.endLineNumber!==pe)return!1;return!0}class n{constructor(pe,ue,oe,be){this.startLineNumber=pe,this.startColumn=ue,this.endLineNumber=oe,this.endColumn=be}}e.$NI=n;class o extends n{constructor(pe,ue,oe){super(pe,ue,pe,oe)}}e.$OI=o;var w;(function($e){$e.List="list",$e.Tree="tree"})(w||(e.ViewMode=w={}));var f;(function($e){$e.Default="default",$e.FileNames="fileNames",$e.Type="type",$e.Modified="modified",$e.CountDescending="countDescending",$e.CountAscending="countAscending"})(f||(e.SearchSortOrder=f={}));function I($e,pe=!0){const ue=$e&&$e.files&&$e.files.exclude,oe=pe&&$e&&$e.search&&$e.search.exclude;if(!ue&&!oe)return;if(!ue||!oe)return ue||oe;let be=Object.create(null);return be=C.$0m(be,C.$7m(ue)),be=C.$0m(be,C.$7m(oe),!0),be}e.$PI=I;function S($e,pe){return $e.excludePattern&&M.$vj($e.excludePattern,pe)?!1:$e.includePattern||$e.usingSearchPaths?$e.includePattern&&M.$vj($e.includePattern,pe)?!0:$e.usingSearchPaths?!!$e.folderQueries&&$e.folderQueries.some(ue=>{const oe=ue.folder.fsPath;if(T.$Xf(pe,oe)){const be=D.$lc(oe,pe);return!ue.includePattern||!!M.$vj(ue.includePattern,be)}else return!1}):!1:!0}e.$QI=S;var u;(function($e){$e[$e.unknownEncoding=1]="unknownEncoding",$e[$e.regexParseError=2]="regexParseError",$e[$e.globParseError=3]="globParseError",$e[$e.invalidLiteral=4]="invalidLiteral",$e[$e.rgProcessError=5]="rgProcessError",$e[$e.other=6]="other",$e[$e.canceled=7]="canceled"})(u||(e.SearchErrorCode=u={}));class m extends Error{constructor(pe,ue){super(pe),this.code=ue}}e.$RI=m;function h($e){const pe=$e.message;if((0,$.$4)($e))return new m(pe,u.canceled);try{const ue=JSON.parse(pe);return new m(ue.message,ue.code)}catch{return new m(pe,u.other)}}e.$SI=h;function P($e){const pe={message:$e.message,code:$e.code};return new Error(JSON.stringify(pe))}e.$TI=P;function W($e){return $e.type==="error"?!0:$e.type==="success"}e.$UI=W;function K($e){return $e.type==="success"}e.$VI=K;function z($e){return!!$e.path}e.$WI=z;function j($e,pe){const ue=$e.searchPath?$e.searchPath:$e.relativePath;return(0,A.$of)(ue,pe)}e.$XI=j;class O{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$YI=O;function N($e,pe){const ue={...$e||{},...pe||{}};return Object.keys(ue).filter(oe=>{const be=ue[oe];return typeof be=="boolean"&&be})}e.$ZI=N;class ie{constructor(pe,ue){this.c=null,this.a={...pe.excludePattern||{},...ue.excludePattern||{}},this.b=M.$wj(this.a);let oe=pe.includePattern;ue.includePattern&&(oe?oe={...oe,...ue.includePattern}:oe=ue.includePattern),oe&&(this.c=M.$wj(oe))}matchesExcludesSync(pe,ue,oe){return!!(this.b&&this.b(pe,ue,oe))}includedInQuerySync(pe,ue,oe){return!(this.b&&this.b(pe,ue,oe)||this.c&&!this.c(pe,ue,oe))}includedInQuery(pe,ue,oe){const be=this.b(pe,ue,oe),_=()=>this.c?!!this.c(pe,ue,oe):!0;return(0,k.$Gg)(be)?be.then(B=>B?!1:_()):_()}hasSiblingExcludeClauses(){return X(this.a)}}e.$1I=ie;function X($e){for(const pe in $e)if(typeof $e[pe]!="boolean")return!0;return!1}function Ee($e){if(!$e)return;let pe;return ue=>(pe||(pe=($e()||Promise.resolve([])).then(oe=>oe?Pe(oe):{})),pe.then(oe=>!!oe[ue]))}e.$2I=Ee;function Se($e){if(!$e)return;let pe;return ue=>{if(!pe){const oe=$e();pe=oe?Pe(oe):{}}return!!pe[ue]}}e.$3I=Se;function Pe($e){const pe={};for(const ue of $e)pe[ue]=!0;return pe}}),define(Ae[33],Re([1,0,18,12,20,5,6,49,13,117,23,16,2,158,4,14,175,55,40,27,17,8,7,56,48,3]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d,t,i,c,b,E,v,s,r,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=e.$_bc=void 0;function w(W,K,z){return new R.$kg(j=>u(j,z)).isEqual(W,K)}function f(W,K,z){return w(W.uri,K.uri,z)?0:(0,k.$Ue)(W.uri.toString(),K.uri.toString())}function I(W,K,z){return W.index!==K.index?W.index<K.index?-1:1:w(W.uri,K.uri,z)?(0,k.$Ue)(W.name,K.name):(0,k.$Ue)(W.uri.toString(),K.uri.toString())}function S(W,K,z,j){const O=W.slice(0).sort((ie,X)=>z(ie,X,j)),N=K.slice(0).sort((ie,X)=>z(ie,X,j));return(0,y.$Eb)(O,N,(ie,X)=>z(ie,X,j))}function u(W,K){const z=K.getCapabilities(W.scheme);return!(z&&z&1024)}class m extends i.$9h{static toExtHostWorkspace(K,z,j,O){if(!K)return{workspace:null,added:[],removed:[]};const{id:N,name:ie,folders:X,configuration:Ee,transient:Se,isUntitled:Pe}=K,$e=[],pe=z;z?X.forEach((_,B)=>{const Z=a.URI.revive(_.uri),ee=m.o(j||z,Z,O);ee?(ee.name=_.name,ee.index=_.index,$e.push(ee)):$e.push({uri:Z,name:_.name,index:B})}):$e.push(...X.map(({uri:_,name:B,index:Z})=>({uri:a.URI.revive(_),name:B,index:Z}))),$e.sort((_,B)=>_.index<B.index?-1:1);const ue=new m(N,ie,$e,!!Se,Ee?a.URI.revive(Ee):null,!!Pe,_=>u(_,O)),{added:oe,removed:be}=S(pe?pe.workspaceFolders:[],ue.workspaceFolders,f,O);return{workspace:ue,added:oe,removed:be}}static o(K,z,j){for(let O=0;O<K.folders.length;O++){const N=K.workspaceFolders[O];if(w(N.uri,z,j))return N}}constructor(K,z,j,O,N,ie,X){super(K,j.map(Ee=>new i.$0h(Ee)),O,N,X),this.t=z,this.u=ie,this.q=[],this.s=l.$Vh.forUris(X),j.forEach(Ee=>{this.q.push(Ee),this.s.set(Ee.uri,Ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(K,z){return z&&this.s.get(K)&&(K=(0,R.$ug)(K)),this.s.findSubstr(K)}resolveWorkspaceFolder(K){return this.s.get(K)}}let h=class{constructor(K,z,j,O,N){this.c=new T.$Nd,this.onDidChangeWorkspace=this.c.event,this.g=new T.$Nd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new T.$Pd,this.B=new Map,this.h=O,this.s=j,this.t=N,this.j=new $.$Ql,this.k=new M.$Sg,this.o=K.getProxy(o.$fK.MainThreadWorkspace),this.q=K.getProxy(o.$fK.MainThreadMessageService);const ie=z.workspace;this.l=ie?new m(ie.id,ie.name,[],!!ie.transient,ie.configuration?a.URI.revive(ie.configuration):null,!!ie.isUntitled,X=>u(X,j)):void 0}$initializeWorkspace(K,z){this.v=z,this.$acceptWorkspaceData(K),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?a.URI.from({scheme:D.Schemas.untitled,path:(0,R.$sg)((0,R.$ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(K,z,j,...O){const N=[];if(Array.isArray(O)&&O.forEach(Pe=>{a.URI.isUri(Pe.uri)&&!N.some($e=>w($e.uri,Pe.uri,this.s))&&N.push({uri:Pe.uri,name:Pe.name||(0,R.$rg)(Pe.uri)})}),this.n||[z,j].some(Pe=>typeof Pe!="number"||Pe<0)||j===0&&N.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(z+j>ie.length)return!1;const X=ie.slice(0);X.splice(z,j,...N.map(Pe=>({uri:Pe.uri,name:Pe.name||(0,R.$rg)(Pe.uri),index:void 0})));for(let Pe=0;Pe<X.length;Pe++){const $e=X[Pe];if(X.some((pe,ue)=>ue!==Pe&&w($e.uri,pe.uri,this.s)))return!1}X.forEach((Pe,$e)=>Pe.index=$e);const{added:Ee,removed:Se}=S(ie,X,I,this.s);if(Ee.length===0&&Se.length===0)return!1;if(this.o){const Pe=K.displayName||K.name;this.o.$updateWorkspaceFolders(Pe,z,j,N).then(void 0,$e=>{this.n=void 0;const pe={source:{identifier:K.identifier,label:K.displayName||K.name}};this.q.$showMessage(t.Severity.Error,(0,p.localize)(0,null,Pe,$e.toString()),pe,[])})}return this.y(X),!0}getWorkspaceFolder(K,z){if(this.x)return this.x.getWorkspaceFolder(K,z)}async getWorkspaceFolder2(K,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(K,z)}async resolveWorkspaceFolder(K){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(K)}getPath(){if(!this.x)return;const{folders:K}=this.x;if(K.length!==0)return K[0].uri.fsPath}getRelativePath(K,z){let j,O="";if(typeof K=="string"?(j=a.URI.file(K),O=K):typeof K<"u"&&(j=K,O=K.fsPath),!j)return O;const N=this.getWorkspaceFolder(j,!0);if(!N)return O;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let ie=(0,R.$xg)(N.uri,j);return z&&N.name&&(ie=`${N.name}/${ie}`),ie}y(K){this.x&&(this.n=m.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:K,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(K){const{workspace:z,added:j,removed:O}=m.toExtHostWorkspace(K,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:O}))}findFiles(K,z,j,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let ie;if(z===null?ie=!1:z&&(typeof z=="string"?ie=z:ie=z.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:X,folder:Ee}=P(v.GlobPattern.from(K));return this.o.$startFileSearch(X??null,Ee??null,ie??null,j??null,N).then(Se=>Array.isArray(Se)?Se.map(Pe=>a.URI.revive(Pe)):[])}async findTextInFiles(K,z,j,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),X=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:Ee,folder:Se}=P(v.GlobPattern.from(z.include)),Pe=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,$e={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:X,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:Ee,excludePattern:Pe},pe=!1;if(this.u[ie]=ue=>{if(pe)return;const oe=a.URI.revive(ue.resource);ue.results.forEach(be=>{(0,n.$II)(be)?j({uri:oe,preview:{text:be.preview.text,matches:(0,y.$2b)(be.preview.matches,_=>new s.$jK(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,y.$2b)(be.ranges,_=>new s.$jK(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):j({uri:oe,text:be.text,lineNumber:be.lineNumber})})},N.isCancellationRequested)return{};try{const ue=await this.o.$startTextSearch(K,Se??null,$e,ie,N);return delete this.u[ie],ue||{}}catch(ue){throw delete this.u[ie],ue}}$handleTextSearchResult(K,z){this.u[z]?.(K)}async save(K){const z=await this.o.$save(K,{saveAs:!1});return a.URI.revive(z)}async saveAs(K){const z=await this.o.$save(K,{saveAs:!0});return a.URI.revive(z)}saveAll(K){return this.o.$saveAll(K)}resolveProxy(K){return this.o.$resolveProxy(K)}get trusted(){return this.v}requestWorkspaceTrust(K){return this.o.$requestWorkspaceTrust(K)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(K,z){if(this.w.has(K))throw new Error(`A provider has already been registered for scheme ${K}`);this.w.set(K,z);const j=this.t.transformOutgoingScheme(K),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,j),(0,A.$Qc)(()=>{this.w.delete(K),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(K,z){this.h.info("Getting edit session identifier for workspaceFolder",K);const j=await this.resolveWorkspaceFolder(a.URI.revive(K));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const O=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!O),!O)return;const N=await O.provideEditSessionIdentity(j,z);if(this.h.info("Provider returned edit session identifier: ",N),!!N)return N}async $provideEditSessionIdentityMatch(K,z,j,O){this.h.info("Getting edit session identifier for workspaceFolder",K);const N=await this.resolveWorkspaceFolder(a.URI.revive(K));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const ie=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!ie),!ie)return;const X=await ie.provideEditSessionIdentityMatch?.(z,j,O);if(this.h.info("Provider returned edit session identifier match result: ",X),!!X)return X}getOnWillCreateEditSessionIdentityEvent(K){return(z,j,O)=>{const N=function(X){z.call(j,X)};return N.extension=K,this.A.event(N,void 0,O)}}async $onWillCreateEditSessionIdentity(K,z,j){const O=await this.resolveWorkspaceFolder(a.URI.revive(K));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},z,async(N,ie)=>{const X=Date.now();await Promise.resolve(N),Date.now()-X>j&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(K,z){if(this.B.has(K))throw new Error(`A provider has already been registered for scheme ${K}`);this.B.set(K,z);const j=this.t.transformOutgoingScheme(K),O=this.z++;return this.o.$registerCanonicalUriProvider(O,j),(0,A.$Qc)(()=>{this.B.delete(K),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(K,z,j){const O=this.B.get(K.scheme);if(!O)return;const N=await O.provideCanonicalUri?.(a.URI.revive(K),z,j);if(N)return N}async $provideCanonicalUri(K,z,j){return this.provideCanonicalUri(a.URI.revive(K),{targetScheme:z},j)}};e.$_bc=h,e.$_bc=h=qe([Ke(0,E.$gM),Ke(1,b.$wM),Ke(2,c.$Zbc),Ke(3,d.$0i),Ke(4,r.$0bc)],h),e.$acc=(0,g.$Ph)("IExtHostWorkspace");function P(W){let K,z;return W&&(typeof W=="string"?K=W:(K=W.pattern,z=a.URI.revive(W.baseUri))),{includePattern:K,folder:z}}}),define(Ae[34],Re([1,0,24,5,33,3,7,177,96,15,12,4,17,14,2]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=e.$ccc=e.$bcc=void 0;function d(r,n){if(n){const o=n.split(".");let w=r;for(let f=0;w&&f<o.length;f++)w=w[o[f]];return w}}function t(r){return r instanceof g.URI}function i(r){return r&&r.uri instanceof g.URI&&r.languageId&&typeof r.languageId=="string"}function c(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function b(r){return r&&r.uri instanceof g.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function E(r){if(t(r))return{resource:r};if(i(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(c(r))return{overrideIdentifier:r.languageId};if(b(r))return{resource:r.uri};if(r===null)return{resource:null}}let v=class{constructor(n,o,w){this.a=n.getProxy(T.$fK.MainThreadConfiguration),this.c=o,this.b=w,this.d=new R.$Sg,this.e=null}getConfigProvider(){return this.d.wait().then(n=>this.e)}$initializeConfiguration(n){this.e=new s(this.a,this.c,n,this.b),this.d.open()}$acceptConfigurationChanged(n,o){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(n,o))}};e.$bcc=v,e.$bcc=v=qe([Ke(0,a.$gM),Ke(1,C.$acc),Ke(2,p.$0i)],v);class s{constructor(n,o,w,f){this.a=new M.$Nd,this.b=n,this.f=f,this.c=o,this.e=l.$En.parse(w),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(n,o){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=l.$En.parse(n),this.d=this.k(n.configurationScopes),this.a.fire(this.j(o,w))}getConfiguration(n,o,w){const f=E(o)||{},I=this.g(n?d(this.e.getValue(void 0,f,this.c.workspace),n):this.e.getValue(void 0,f,this.c.workspace));n&&this.h(n,f,w?.identifier);function S(m){if(m==null)return null;if(typeof m=="boolean")return m?2:5;switch(m){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(m){return typeof d(I,m)<"u"},get:(m,h)=>{this.h(n?`${n}.${m}`:m,f,w?.identifier);let P=d(I,m);if(typeof P>"u")P=h;else{let W;const K=(z,j)=>{if((0,$.$Af)(z)){let O;const N=()=>{W=W||(0,y.$7m)(I),O=O||d(W,j)};return new Proxy(z,{get:(ie,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return N(),()=>O;if(W)return O=O||d(W,j),O[X];const Ee=ie[X];return typeof X=="string"?K(Ee,`${j}.${X}`):Ee},set:(ie,X,Ee)=>(N(),O&&(O[X]=Ee),!0),deleteProperty:(ie,X)=>(N(),O&&delete O[X],!0),defineProperty:(ie,X,Ee)=>(N(),O&&Object.defineProperty(O,X,Ee),!0)})}return Array.isArray(z)?(0,y.$7m)(z):z};P=K(P,m)}return P},update:(m,h,P,W)=>{m=n?`${n}.${m}`:m;const K=S(P);return h!==void 0?this.b.$updateConfigurationOption(K,m,h,f,W):this.b.$removeConfigurationOption(K,m,f,W)},inspect:m=>{m=n?`${n}.${m}`:m;const h=this.e.inspect(m,f,this.c.workspace);if(h)return{key:m,defaultValue:(0,y.$7m)(h.policy?.value??h.default?.value),globalValue:(0,y.$7m)(h.user?.value??h.application?.value),workspaceValue:(0,y.$7m)(h.workspace?.value),workspaceFolderValue:(0,y.$7m)(h.workspaceFolder?.value),defaultLanguageValue:(0,y.$7m)(h.default?.override),globalLanguageValue:(0,y.$7m)(h.user?.override??h.application?.override),workspaceLanguageValue:(0,y.$7m)(h.workspace?.override),workspaceFolderLanguageValue:(0,y.$7m)(h.workspaceFolder?.override),languageIds:(0,y.$7m)(h.overrideIdentifiers)}}};return typeof I=="object"&&(0,y.$0m)(u,I,!1),Object.freeze(u)}g(n){const o=w=>(0,$.$Af)(w)?new Proxy(w,{get:(f,I)=>o(f[I]),set:(f,I,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(f,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(f,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return o(n)}h(n,o,w){const f=D.$vn.test(n)?4:this.d.get(n),I=w?`[${w.value}] `:"";if(f===4){typeof o?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){o?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(n,o){const w=new l.$Gn(n,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(f,I)=>w.affectsConfiguration(f,E(I))})}k(n){return n.reduce((o,w)=>(o.set(w[0],w[1]),o),new Map)}}e.$ccc=s,e.$dcc=(0,k.$Ph)("IExtHostConfiguration")}),define(Ae[111],Re([1,0,2,12,5,3,7,33,60,34,20,63,17,27,4,13,22,14,80,214,9]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d,t,i,c,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=e.$adc=e.$_cc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var v;(function(K){function z(O){if(O!=null)return O}K.from=z;function j(O){if(O!=null)return O}K.to=j})(v||(v={}));var s;(function(K){function z(O){if(O!=null)return O}K.from=z;function j(O){if(O!=null)return O}K.to=j})(s||(s={}));var r;(function(K){function z(O){if(O!=null)return O}K.from=z;function j(O){if(O!=null)return O}K.to=j})(r||(r={}));var n;(function(K){function z(N){if(N){const ie=N;return ie&&!!ie.process}else return!1}K.is=z;function j(N){if(N==null)return;const ie={process:N.process,args:N.args};return N.options&&(ie.options=r.from(N.options)),ie}K.from=j;function O(N){if(N!=null)return new A.$2K(N.process,N.args,N.options)}K.to=O})(n||(n={}));var o;(function(K){function z(O){if(O!=null)return O}K.from=z;function j(O){if(O!=null)return O}K.to=j})(o||(o={}));var w;(function(K){function z(N){if(N){const ie=N;return ie&&(!!ie.commandLine||!!ie.command)}else return!1}K.is=z;function j(N){if(N==null)return;const ie={};return N.commandLine!==void 0?ie.commandLine=N.commandLine:(ie.command=N.command,ie.args=N.args),N.options&&(ie.options=o.from(N.options)),ie}K.from=j;function O(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.$3K(N.commandLine,N.options):new A.$3K(N.command,N.args?N.args:[],N.options)}K.to=O})(w||(w={}));var f;(function(K){function z(N){if(N){const ie=N;return ie&&ie.customExecution==="customExecution"}else return!1}K.is=z;function j(N){return{customExecution:"customExecution"}}K.from=j;function O(N,ie){return ie.get(N)}K.to=O})(f||(e.CustomExecutionDTO=f={}));var I;(function(K){function z(j,O){let N;return j.scope!==void 0&&typeof j.scope!="number"?N=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===A.TaskScope.Workspace&&O&&O.workspaceFile?N=O.workspaceFile:N=b.$OF),{id:j._id,workspaceFolder:N}}K.from=z})(I||(e.TaskHandleDTO=I={}));var S;(function(K){function z(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}K.from=z})(S||(S={}));var u;(function(K){function z(N,ie){if(N==null)return[];const X=[];for(const Ee of N){const Se=j(Ee,ie);Se&&X.push(Se)}return X}K.fromMany=z;function j(N,ie){if(N==null)return;let X;N.execution instanceof A.$2K?X=n.from(N.execution):N.execution instanceof A.$3K?X=w.from(N.execution):N.execution&&N.execution instanceof A.$4K&&(X=f.from(N.execution));const Ee=v.from(N.definition);let Se;return N.scope?typeof N.scope=="number"?Se=N.scope:Se=N.scope.uri:Se=A.TaskScope.Workspace,!Ee||!Se?void 0:{_id:N._id,definition:Ee,name:N.name,source:{extensionId:ie.identifier.value,label:N.source,scope:Se},execution:X,isBackground:N.isBackground,group:S.from(N.group),presentationOptions:s.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}K.from=j;async function O(N,ie,X){if(N==null)return;let Ee;n.is(N.execution)?Ee=n.to(N.execution):w.is(N.execution)?Ee=w.to(N.execution):f.is(N.execution)&&(Ee=f.to(N._id,X));const Se=v.to(N.definition);let Pe;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Pe=N.source.scope:Pe=await ie.resolveWorkspaceFolder(y.URI.revive(N.source.scope)):Pe=A.TaskScope.Workspace),!Se||!Pe)return;const $e=new A.$5K(Se,Pe,N.name,N.source.label,Ee,N.problemMatchers);return N.isBackground!==void 0&&($e.isBackground=N.isBackground),N.group!==void 0&&($e.group=A.$1K.from(N.group._id),$e.group&&N.group.isDefault&&($e.group=new A.$1K($e.group.id,$e.group.label),N.group.isDefault===!0&&($e.group.isDefault=N.group.isDefault))),N.presentationOptions&&($e.presentationOptions=s.to(N.presentationOptions)),N._id&&($e._id=N._id),N.detail&&($e.detail=N.detail),$e}K.to=O})(u||(e.TaskDTO=u={}));var m;(function(K){function z(O){return O}K.from=z;function j(O){if(O)return Object.assign(Object.create(null),O)}K.to=j})(m||(m={}));class h{#e;constructor(z,j,O){this._id=j,this.a=O,this.#e=z}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}let P=class{constructor(z,j,O,N,ie,X,Ee,Se){this.q=new C.$Nd,this.r=new C.$Nd,this.s=new C.$Nd,this.t=new C.$Nd,this.a=z.getProxy(T.$fK.MainThreadTask),this.b=O,this.c=N,this.d=ie,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Ee,this.g=Se,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(z,j,O){if(!O)return new A.$hK(()=>{});const N=this.w();return this.j.set(N,{type:j,provider:O,extension:z}),this.a.$registerTaskProvider(N,j),new A.$hK(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(z,j){this.a.$registerTaskSystem(z,j)}fetchTasks(z){return this.a.$fetchTasks(m.from(z)).then(async j=>{const O=[];for(const N of j){const ie=await u.to(N,this.b,this.m);ie&&O.push(ie)}return O})}get taskExecutions(){const z=[];return this.k.forEach(j=>z.push(j)),z}terminateTask(z){if(!(z instanceof h))throw new Error("No valid task execution provided");return this.a.$terminateTask(z._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(z,j,O){const N=this.m.get(z.id);N&&(this.o.set(z.id,N),this.e.attachPtyToTerminal(j,await N.callback(O))),this.p=z.id,this.q.fire({execution:await this.y(z)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(z){const j=await this.y(z);this.l.delete(z.id),this.k.delete(z.id),this.A(z),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(z){const j=await this.y(z.id);this.s.fire({execution:j,processId:z.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(z){const j=await this.y(z.id);this.t.fire({execution:j,exitCode:z.exitCode})}$provideTasks(z,j){const O=this.j.get(z);if(!O)return Promise.reject(new Error("no handler found"));const N=[],ie=(0,M.$Mg)(()=>O.provider.provideTasks(R.CancellationToken.None)).then(X=>this.u(j,N,O,X));return new Promise(X=>{ie.then(Ee=>{Promise.all(N).then(()=>{X(Ee)})})})}async $resolveTask(z,j){const O=this.j.get(z);if(!O)return Promise.reject(new Error("no handler found"));if(j.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${O.type}].`);const N=await u.to(j,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const ie=await O.provider.resolveTask(N,R.CancellationToken.None);if(!ie)return;this.z(ie,O);const X=u.from(ie,O.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(ie.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(X.execution)&&await this.x(X,ie,!0),await this.v(X)}w(){return this.h++}async x(z,j,O){const N=await this.a.$createTaskId(z);!O&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,j.execution)),this.m.set(N,j.execution)}async y(z,j){if(typeof z=="string"){const ie=this.l.get(z);if(!ie)throw new E.$bb("Unexpected: The specified task is missing an execution");return ie}const O=this.l.get(z.id);if(O)return O;const N=new Promise((ie,X)=>{function Ee(Se,Pe,$e){$e?ie(new h(Se,Pe.id,$e)):X("Unexpected: Task does not exist.")}j?Ee(this,z,j):u.to(z.task,this.b,this.m).then(Se=>Ee(this,z,Se))});return this.l.set(z.id,N),N.then(ie=>(this.k.set(z.id,ie),ie),ie=>Promise.reject(ie))}z(z,j){z._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(z){this.o.get(z.id)&&this.o.delete(z.id),this.n.has(z.id)&&this.p!==z.id&&(this.m.delete(z.id),this.n.delete(z.id));const O=this.n.values();let N=O.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=O.next()}};e.$_cc=P,e.$_cc=P=qe([Ke(0,a.$gM),Ke(1,p.$wM),Ke(2,l.$acc),Ke(3,D.$rM),Ke(4,$.$dcc),Ke(5,k.$vcc),Ke(6,i.$0i),Ke(7,c.$3bc)],P);let W=class extends P{constructor(z,j,O,N,ie,X,Ee,Se){super(z,j,O,N,ie,X,Ee,Se),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:t.$i(0)})}async executeTask(z,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const O=u.from(j,z);if(O===void 0)throw new Error("Task is not valid");if(f.is(O.execution))await this.x(O,j,!1);else throw new E.$_;const N=await this.y(await this.a.$getTaskExecution(O),j);return this.a.$executeTask(O).catch(ie=>{throw new Error(ie)}),N}u(z,j,O,N){const ie=[];if(N)for(const X of N){this.z(X,O),(!X.definition||!z[X.definition.type])&&this.f.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const Ee=u.from(X,O.extension);Ee&&f.is(Ee.execution)?(ie.push(Ee),j.push(this.x(Ee,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ie,extension:O.extension}}async v(z){if(f.is(z.execution))return z;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(z,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,j,O){}};e.$adc=W,e.$adc=W=qe([Ke(0,a.$gM),Ke(1,p.$wM),Ke(2,l.$acc),Ke(3,D.$rM),Ke(4,$.$dcc),Ke(5,k.$vcc),Ke(6,i.$0i),Ke(7,c.$3bc)],W),e.$bdc=(0,g.$Ph)("IExtHostTask")}),define(Ae[268],Re([1,0,19,20,37,38,23,59,48]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;class ${constructor(a,p,g){this.k=a,this.l=p,this.o=g,this.e=!1,this.f=0,this.g=!1,this.a=a.filePattern,this.b=a.includePattern&&T.$wj(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.h=new Set,this.j=a.excludePattern&&T.$wj(a.excludePattern)}cancel(){this.g=!0,this.h.forEach(a=>a.cancel()),this.h=new Set}search(a){const p=this.k.folderQueries||[];return new Promise((g,d)=>{const t=i=>{this.f++,a(i)};if(this.g)return g({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const c=i.toString(),b=y.$nc(c);this.j&&this.j(c,b)||this.v(t,{base:i,basename:b})}),Promise.all(p.map(i=>this.p(i,t))).then(i=>{g({limitHit:this.e,stats:i[0]||void 0})},i=>{d(new Error((0,C.$Ai)(i)))})})}async p(a,p){const g=new M.$Xd,d=this.q(a),t=this.r(),i=new D.$1I(this.k,a),c=!i.hasSiblingExcludeClauses();let b;try{this.h.add(g),b=l.$Jd.create();const E=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,g.token),v=b.elapsed(),s=l.$Jd.create();return this.g&&!this.e||(E&&E.forEach(r=>{const n=y.$gc.relative(a.folder.path,r.path);if(c){const o=y.$nc(r.path);this.v(p,{base:a.folder,relativePath:n,basename:o});return}this.s(t,a.folder,n,p)}),this.g&&!this.e)?null:(this.u(t,i,p),{providerTime:v,postProcessTime:s.elapsed()})}finally{g.dispose(),this.h.delete(g)}}q(a){const p=(0,D.$ZI)(this.k.includePattern,a.includePattern),g=(0,D.$ZI)(this.k.excludePattern,a.excludePattern);return{folder:a.folder,excludes:g,includes:p,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}s({pathToEntries:a},p,g,d){if(g===this.a){const i=y.$nc(this.a);this.v(d,{base:p,relativePath:this.a,basename:i})}function t(i){const c=y.$nc(i),b=y.$mc(i);let E=a[b];E||(E=a[b]=[],t(b)),E.push({base:p,relativePath:i,basename:c})}t(g)}u({rootEntries:a,pathToEntries:p},g,d){const t=this,i=this.a;function c(b){const E=(0,D.$3I)(()=>b.map(v=>v.basename));for(let v=0,s=b.length;v<s;v++){const r=b[v],{relativePath:n,basename:o}=r;if(g.matchesExcludesSync(n,o,i!==o?E:void 0))continue;const w=p[n];if(w)c(w);else{if(n===i)continue;t.v(d,r)}if(t.e)break}}c(a)}v(a,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||a(p))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(a,p,g,d){const t=this.c(a.cacheKey),i=new $(a,p,t&&t.token);let c=0;const b=E=>{c+=E.length,g(E.map(v=>this.d(v)))};return this.e(i,R.a,b,d).then(E=>({limitHit:E.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:E.stats}}))}clearCache(a){this.c(a)?.cancel()}c(a){if(a)return this.b.has(a)||this.b.set(a,new M.$Xd),this.b.get(a)}d(a){return a.relativePath?{resource:A.$vg(a.base,a.relativePath)}:{resource:a.base}}e(a,p,g,d){const t=d.onCancellationRequested(()=>{a.cancel()}),i=b=>{b&&(c.push(b),p>0&&c.length>=p&&(g(c),c=[]))};let c=[];return a.search(i).then(b=>(c.length&&g(c),t.dispose(),b),b=>(c.length&&g(c),t.dispose(),Promise.reject(b)))}}e.$ldc=R}),define(Ae[269],Re([1,0,18,232,38,90,28,13,19,23,16,15,2,284,167,44,14,55,102,267,48]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d,t,i,c,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WJ=e.$VJ=void 0;let v=class{constructor(m,h,P,W,K){this.a=m,this.b=h,this.c=P,this.d=W,this.e=K}text(m,h,P={}){m=this.f(m,P);const W=this.a.getValue(),K=h&&h.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(h?.map(i.$$h),P),type:2,contentPattern:m,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:W.search.usePCRE2||K||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(m,h){const P=this.a.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const W={...m,wordSeparators:P.editor.wordSeparators};return this.j(m,h)&&(W.isCaseSensitive=!0),this.k(m)&&(W.isMultiline=!0),h.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=h.notebookSearchConfig.includeMarkupInput),h.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=h.notebookSearchConfig.includeMarkupPreview),h.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=h.notebookSearchConfig.includeCodeInput),h.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=h.notebookSearchConfig.includeOutput),W}file(m,h={}){return{...this.h(m,h),type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey}}g(m,h){return m?(m=Array.isArray(m)?m.map(w):w(m),h?this.parseSearchPaths(m):{pattern:r(...Array.isArray(m)?m:[m])}):{}}h(m=[],h={}){const P=this.g(h.includePattern,h.expandPatterns),W=this.g(h.excludePattern,h.expandPatterns),K=m.length>1,z=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(N=>this.q(N,h,W)):m.map(N=>this.r(N,h,W,K))).filter(N=>!!N),j={_reason:h._reason,folderQueries:z,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:W.pattern,includePattern:P.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const N=y.$Hb(y.$Rb(this.c.groups.map(Ee=>Ee.editors.map(Se=>Se.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const ie=N.filter(Ee=>(0,E.$QI)(j,Ee.fsPath)),X=this.i(ie);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...j,...X}}const O=h.extraFileResources&&h.extraFileResources.filter(N=>(0,E.$QI)(j,N.fsPath));return j.extraFileResources=O&&O.length?O:void 0,j}i(m){const h=[],P=new A.$Ac,W={};let K=!1;return m.forEach(z=>{if(z.scheme===l.Schemas.walkThrough)return;if((0,$.$zg)(z)){const O=this.b.getWorkspaceFolder(z)?.uri??z.with({path:D.$mc(z.fsPath)});let N=P.get(O);N||(K=!0,N={folder:O,includePattern:{}},h.push(N),P.set(O,N));const ie=D.$lc(O.fsPath,z.fsPath);(0,k.$Jf)(N.includePattern)[ie.replace(/\\/g,"/")]=!0}else z.fsPath&&(K=!0,W[z.fsPath]=!0)}),{folderQueries:h,includePattern:W,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(m,h){if(h.isSmartCase){if(m.isRegExp){if(R.$pf(m.pattern,!0))return!0}else if(R.$pf(m.pattern))return!0}return!!m.isCaseSensitive}k(m){return m.isMultiline||m.isRegExp&&(0,p.$tB)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const h=X=>D.$ic(X)||/^\.\.?([\/\\]|$)/.test(X),W=(Array.isArray(m)?m:n(m)).map(X=>{const Ee=this.e.resolvedUserHome;return Ee?(0,T.$tv)(X,Ee.scheme===l.Schemas.file?Ee.fsPath:Ee.path):X}),K=M.$J(W,X=>h(X)?"searchPaths":"exprSegments"),z=(K.exprSegments||[]).map(X=>R.$Ke(X,"/")).map(X=>R.$Ke(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),o(X))),j={},O=this.m(K.searchPaths||[]);O&&O.length&&(j.searchPaths=O);const N=y.$Rb(z),ie=r(...N);return ie&&(j.pattern=ie),j}l(m,h){return h.disregardExcludeSettings?void 0:(0,E.$PI)(m,!h.disregardSearchExcludeSettings)}m(m){if(!m||!m.length)return[];const h=m.flatMap(W=>{let{pathPortion:K,globPortion:z}=s(W);return z&&(z=f(z)),this.n(K).flatMap(O=>this.o(O,z))}),P=new Map;return h.forEach(W=>{const K=W.searchPath.toString(),z=P.get(K);z?W.pattern&&(z.pattern=z.pattern||{},z.pattern[W.pattern]=!0):P.set(K,{searchPath:W.searchPath,pattern:W.pattern?r(W.pattern):void 0})}),Array.from(P.values())}n(m){if(D.$ic(m)){const h=this.b.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==l.Schemas.file?[{searchPath:h[0].uri.with({path:m})}]:[{searchPath:a.URI.file(D.$hc(m))}]}if(this.b.getWorkbenchState()===2){const h=this.b.getWorkspace().folders[0].uri;if(m=w(m),m.startsWith("../")||m===".."){const W=D.$gc.resolve(h.path,m);return[{searchPath:h.with({path:W})}]}const P=f(m);return[{searchPath:h,pattern:P}]}else{if(m==="./"||m===".\\")return[];{const h=m.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(K=>{const z=h.match(new RegExp(`^${R.$Fe(K.name)}(?:/(.*)|$)`));return z?{match:z,folder:K}:null}).filter(k.$Gf);if(W.length)return W.map(K=>{const z=K.match[1];return{searchPath:K.folder.uri,pattern:z&&f(z)}});{const K=m.match(/\.[\/\\](.+)[\/\\]?/),z=K?K[1]:m,j=g.localize(0,null,z);throw new Error(j)}}}}o(m,h){const P=m.pattern&&h?`${m.pattern}/${h}`:m.pattern||h,W=[{searchPath:m.searchPath,pattern:P}];return P&&!P.endsWith("**")&&W.push({searchPath:m.searchPath,pattern:P+"/**"}),W}q(m,h,P){const W=this.r((0,i.$$h)(m.searchPath),h,P,!1);return W?{...W,includePattern:m.pattern}:null}r(m,h,P,W){let K;const z=a.URI.isUri(m)?m:m.uri;if(P.searchPaths){const X=P.searchPaths.filter(Ee=>(0,$.$og)(Ee.searchPath,z))[0];if(X&&!X.pattern)return null;X&&(K=X.pattern)}const j=this.a.getValue({resource:z}),N={...this.l(j,h)||{},...K||{}},ie=a.URI.isUri(m)?(0,$.$sg)(m):m.name;return{folder:z,folderName:W?ie:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof h.disregardParentIgnoreFiles=="boolean"?h.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!j.search.followSymlinks}}};e.$VJ=v,e.$VJ=v=qe([Ke(0,d.$ji),Ke(1,i.$Yh),Ke(2,c.$dC),Ke(3,t.$0i),Ke(4,b.$TJ)],v);function s(u){const m=u.match(/[\*\{\}\(\)\[\]\?]/);if(m){const h=m.index,P=u.substr(0,h).match(/[/|\\][^/\\]*$/);if(P){let W=u.substr(0,P.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:u.substr((P.index||0)+1)}}}return{pathPortion:u}}function r(...u){return u.length?u.reduce((m,h)=>(m[h]=!0,m),Object.create(null)):void 0}function n(u){return C.$uj(u,",").map(m=>m.trim()).filter(m=>!!m.length)}function o(u){return[`**/${u}/**`,`**/${u}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function w(u){return u.replace(/\\/g,"/")}function f(u){return w(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(u){return u.replace(/([?*[\]])/g,"[$1]")}function S(u,m){u=y.$Mb(u,W=>W.toString());const h=[],P=m.getWorkspace();return u&&u.forEach(W=>{let K;if(m.getWorkbenchState()===2)K=(0,$.$xg)(P.folders[0].uri,W),K&&K!=="."&&(K="./"+K);else{const z=m.getWorkspaceFolder(W);if(z){const j=z.name;if(P.folders.filter(N=>N.name===j).length===1){const N=(0,$.$xg)(z.uri,W);N===""?K=`./${z.name}`:K=`./${z.name}/${N}`}else K=W.fsPath}}K&&h.push(I(K))}),h}e.$WJ=S}),define(Ae[270],Re([1,0,23,2,20,9,4,269,48,55]),function(ye,e,y,M,C,T,A,l,D,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlb=e.$ylb=void 0;const R=7e3;function k(d,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const c=[],b=[];for(const o of i)if(/^workspaceContains:/.test(o)){const w=o.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||d.forceUsingSearch?b.push(w):c.push(w)}if(c.length===0&&b.length===0)return Promise.resolve(void 0);let E;const v=new Promise((o,w)=>{E=o}),s=o=>E({activationEvent:o}),r=Promise.all(c.map(o=>a(d,o,s))).then(()=>{}),n=p(d,t.identifier,b,s);return Promise.all([r,n]).then(()=>{E(void 0)}),v}e.$ylb=k;async function a(d,t,i){for(const c of d.folders)if(await d.exists(y.$vg(M.URI.revive(c),t))){i(`workspaceContains:${t}`);return}}async function p(d,t,i,c){if(i.length===0)return Promise.resolve(void 0);const b=new C.$Xd,E=d.checkExists(d.folders,i,b.token),v=setTimeout(async()=>{b.cancel(),d.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},R);let s=!1;try{s=await E}catch(r){T.$4(r)||T.$1(r)}b.dispose(),clearTimeout(v),s&&c(`workspaceContains:${i.join(",")}`)}function g(d,t,i,c){const b=d.get(A.$Oh),E=d.get(D.$HI),s=b.createInstance(l.$VJ).file(t.map(r=>(0,$.$$h)(M.URI.revive(r))),{_reason:"checkExists",includePattern:i,exists:!0});return E.fileSearch(s,c).then(r=>!!r.limitHit,r=>T.$4(r)?!1:Promise.reject(r))}e.$zlb=g}),define(Ae[35],Re([1,0,148,19,87,23,12,6,49,2,14,3,34,209,84,33,25,106,9,21,26,188,7,97,4,27,85,17,71,86,63,5,270,83,190,13,81,59,22,82]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d,t,i,c,b,E,v,s,r,n,o,w,f,I,S,u,m,h,P,W,K,z,j,O,N){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=e.$Icc=e.$Hcc=e.$Gcc=void 0,e.$Gcc=(0,n.$Ph)("IHostUtils");let X=ie=class extends l.$Sc{constructor(_,B,Z,ee,ve,ge,de,De,re,le,ne,ae){super(),this.X=ae,this.a=this.B(new m.$Nd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=B,this.g=Z,this.f=de,this.j=ee,this.m=ve,this.s=ge,this.t=re,this.u=le,this.w=ne,this.y=this.g.getProxy(k.$fK.MainThreadWorkspace),this.z=this.g.getProxy(k.$fK.MainThreadTelemetry),this.C=this.g.getProxy(k.$fK.MainThreadExtensionService),this.D=new A.$Sg,this.F=new A.$Sg,this.G=new A.$Sg,this.H=new A.$Sg,this.I=new oe(this.f.extensions.activationEvents),this.L=new i.$h4b(this.I,this.f.extensions.allExtensions);const fe=new b.$7l(this.f.extensions.myExtensions);this.J=new i.$h4b(this.I,pe(this.L,fe)),O.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Pe(this.J)}`)),this.M=new g.$ncc(this.g,this.s),this.N=new P.$zcc(this.g),this.O=De,this.h=_.createChild(new I.$Nh([g.$occ,this.M],[P.$Acc,this.N])),this.P=this.B(new p.$mcc(this.J,this.L,{onExtensionActivationError:(Ie,F,V)=>{this.C.$onExtensionActivationError(Ie,c.$3(F),V)},actualActivateExtension:async(Ie,F)=>{if(i.$h4b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,F),new p.$lcc;const V=this.J.getExtensionDescription(Ie);return this.db(V,F)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(_){c.$1(_)}}async Y(){this.O.onWillDeactivateAll();let _=[];try{_=this.J.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this.cb(ve))}catch{}await Promise.all(_)}terminate(_,B=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${_}`),this.s.flush(),this.u.dispose(),this.P.dispose(),c.setUnexpectedErrorHandler(ee=>{this.s.error(ee)}),this.g.dispose();const Z=this.Y();Promise.race([(0,A.$Ug)(5e3),Z]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(_){return this.G.isOpen()?this.P.isActivated(_):!1}async getExtension(_){const B=await this.C.$getExtension(_);return B&&{...B,identifier:new b.$6l(B.identifier.value),extensionLocation:$.URI.revive(B.extensionLocation)}}Z(_,B){return this.P.activateByEvent(_,B)}$(_,B){return this.P.activateById(_,B)}activateByIdWithErrors(_,B){return this.$(_,B).then(()=>{const Z=this.P.getActivatedExtension(_);if(Z.activationFailed)return Promise.reject(Z.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(_=>this.J)}getExtensionExports(_){if(this.G.isOpen())return this.P.getActivatedExtension(_).exports;try{return this.P.getActivatedExtension(_).exports}catch{return null}}async ab(_){if(_.scheme===K.Schemas.file&&this.c.fsRealpath){const B=await this.c.fsRealpath(_.fsPath);return $.URI.file(B)}return _}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(_=>new ue(_))),this.Q}async bb(_){const B=D.$Vh.forUris(Z=>T.$mg.ignorePathCasing(Z));return await Promise.all(_.map(async Z=>{if(this.ub(Z)){const ee=await this.ab(Z.extensionLocation);B.set(ee,Z)}})),B}cb(_){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(_))return B;const Z=this.P.getActivatedExtension(_);if(!Z)return B;try{typeof Z.module.deactivate=="function"&&(B=Promise.resolve(Z.module.deactivate()).then(void 0,ee=>(this.s.error(ee),Promise.resolve(void 0))))}catch(ee){this.s.error(`An error occurred when deactivating the extension '${_.value}':`),this.s.error(ee)}try{(0,l.$Nc)(Z.subscriptions)}catch(ee){this.s.error(`An error occurred when deactivating the subscriptions for extension '${_.value}':`),this.s.error(ee)}return B}async db(_,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(_.identifier):await this.C.$onWillActivateExtension(_.identifier),this.fb(_,B).then(Z=>{const ee=Z.activationTimes;return this.C.$onDidActivateExtension(_.identifier,ee.codeLoadingTime,ee.activateCallTime,ee.activateResolvedTime,B),this.eb(_,B,"success",ee),Z},Z=>{throw this.eb(_,B,"failure"),Z})}eb(_,B,Z,ee){const ve=Se(_,B);this.z.$publicLog2("extensionActivationTimes",{...ve,...ee||{},outcome:Z})}fb(_,B){const Z=Se(_,B);this.z.$publicLog2("activatePlugin",Z);const ee=this.ub(_);if(!ee)return Promise.resolve(new p.$kcc(p.$hcc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${_.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${_.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const ve=new p.$icc(B.startup);return Promise.all([this.vb(_,(0,T.$vg)(_.extensionLocation,ee),ve),this.gb(_)]).then(ge=>(C.mark(`code/extHost/willActivateExtension/${_.identifier.value}`),ie.hb(this.s,_.identifier,ge[0],ge[1],ve))).then(ge=>(C.mark(`code/extHost/didActivateExtension/${_.identifier.value}`),ge))}gb(_){const B=new v.$qcc(_,this.M),Z=new v.$pcc(_.identifier.value,!1,this.M),ee=new W.$Bcc(_,this.N),ve=_.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,ge=this.f.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${_.identifier.value}`),Promise.all([B.whenReady,Z.whenReady,this.O.whenReady]).then(()=>{const de=this;let De,re;const le=(0,t.$cF)(_,"ipc")?this.f.messagePorts?.get(b.$6l.toKey(_.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:Z,secrets:ee,subscriptions:[],get extensionUri(){return _.extensionLocation},get extensionPath(){return _.extensionLocation.fsPath},asAbsolutePath(ne){return M.$jc(_.extensionLocation.fsPath,ne)},get storagePath(){return de.O.workspaceValue(_)?.fsPath},get globalStoragePath(){return de.O.globalValue(_).fsPath},get logPath(){return M.$jc(de.f.logsLocation.fsPath,_.identifier.value)},get logUri(){return $.URI.joinPath(de.f.logsLocation,_.identifier.value)},get storageUri(){return de.O.workspaceValue(_)},get globalStorageUri(){return de.O.globalValue(_)},get extensionMode(){return ve},get extension(){return De===void 0&&(De=new $e(de,_.identifier,_,ge,!1)),De},get extensionRuntime(){return(0,t.$dF)(_,"extensionRuntime"),de.extensionRuntime},get environmentVariableCollection(){return de.u.getEnvironmentVariableCollection(_)},get messagePassingProtocol(){if(!re){if(!le)return;const ne=m.Event.buffer(m.Event.fromDOMEventEmitter(le,"message",ae=>ae.data));le.start(),re={onDidReceiveMessage:ne,postMessage:le.postMessage.bind(le)}}return re}})})}static hb(_,B,Z,ee,ve){return Z=Z||{activate:void 0,deactivate:void 0},this.ib(_,B,Z,ee,ve).then(ge=>new p.$jcc(!1,null,ve.build(),Z,ge,ee.subscriptions))}static ib(_,B,Z,ee,ve){if(typeof Z.activate=="function")try{ve.activateCallStart(),_.trace(`ExtensionService#_callActivateOptional ${B.value}`);const ge=typeof global=="object"?global:self,de=Z.activate.apply(ge,[ee]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(de).then(De=>(ve.activateResolveStop(),De))}catch(ge){return Promise.reject(ge)}else return Promise.resolve(Z)}jb(_,B){this.$(_.identifier,{startup:!1,extensionId:_.identifier,activationEvent:B}).then(void 0,Z=>{this.s.error(Z)})}kb(_,B=0){const ee=Date.now();(0,O.$B)(()=>{for(let ve=B;ve<_.length;ve+=1){const ge=_[ve];for(const de of ge.activationEvents??[])if(de==="onStartupFinished")if(Date.now()-ee>50){this.kb(_,ve);break}else this.jb(ge,de)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(_=>{const B=_.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Z=this.J.getAllExtensionDescriptions();if(B)this.kb(Z);else for(const ee of Z)if(ee.activationEvents)for(const ve of ee.activationEvents)ve==="onStartupFinished"&&this.jb(ee,ve)})}mb(){const _=this.Z("*",!0).then(void 0,ge=>{this.s.error(ge)});this.B(this.j.onDidChangeWorkspace(ge=>this.nb(ge.added)));const B=this.j.workspace?this.j.workspace.folders:[],Z=this.nb(B),ee=this.pb(),ve=Promise.all([ee,_,Z]).then(()=>{});return Promise.race([ve,(0,A.$Ug)(1e4)]).then(()=>{this.lb()}),ve}nb(_){return _.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.ob(_,B))).then(()=>{})}async ob(_,B){if(this.isActivated(B.identifier))return;const Z=!this.f.remote.isRemote&&!!this.f.remote.authority,ee={logService:this.s,folders:_.map(ge=>ge.uri),forceUsingSearch:Z||!this.c.fsExists,exists:ge=>this.c.fsExists(ge.fsPath),checkExists:(ge,de,De)=>this.y.$checkExists(ge,de,De)},ve=await(0,h.$ylb)(ee,B);if(ve)return this.$(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:ve.activationEvent}).then(void 0,ge=>this.s.error(ge))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(_){throw console.error(_),_}}async qb(){const{extensionDevelopmentLocationURI:_,extensionTestsLocationURI:B}=this.f.environment;if(!_||!B)throw new Error(y.localize(0,null));const Z=await this.vb(null,B,new p.$icc(!1));if(!Z||typeof Z.run!="function")throw new Error(y.localize(1,null,B.toString()));return new Promise((ee,ve)=>{const ge=(re,le)=>{re?(O.$t&&this.s.error("Test runner called back with error",re),ve(re)):(O.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),ee(typeof le=="number"&&le>0?1:0))},de=(0,T.$jg)(B),De=Z.run(de,ge);De&&De.then&&De.then(()=>{O.$t&&this.s.info("Test runner finished successfully."),ee(0)}).catch(re=>{O.$t&&this.s.error("Test runner finished with error",re),ve(re instanceof Error&&re.stack?re.stack:String(re))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Ug)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(_,B){return this.R[_]=B,(0,l.$Qc)(()=>{delete this.R[_]})}async getRemoteExecServer(_){const{resolver:B}=await this.sb(_);return B?.resolveExecServer?.(_,{resolveAttempt:0})}async sb(_){const B=_.indexOf("+");if(B===-1)throw new s.$nK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const Z=_.substr(0,B);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${Z}`,!1),{authorityPrefix:Z,resolver:this.R[Z]}}async $resolveAuthority(_,B){const Z=j.$Jd.create(!1),ee=()=>`[resolveAuthority(${(0,r.$Tk)(_)},${B})][${Z.elapsed()}ms] `,ve=J=>this.s.info(`${ee()}${J}`),ge=J=>this.s.warn(`${ee()}${J}`),de=(J,q=void 0)=>this.s.error(`${ee()}${J}`,q),De=J=>{if(J instanceof s.$nK)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J},re=async J=>{ve(`activating resolver for ${J}...`);const{resolver:q,authorityPrefix:x}=await this.sb(J);if(!q)throw de(`no resolver for ${x}`),new s.$nK(`No remote extension installed to resolve ${x}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:x,remoteAuthority:J}},le=_.split(/@|%40/g).reverse();ve(`activating remote resolvers ${le.join(" -> ")}`);let ne;try{ne=await Promise.all(le.map(re)).catch(async J=>{if(!(J instanceof s.$nK)||J._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw J;return ge(`resolving nested authorities failed: ${J.message}`),[await re(_)]})}catch(J){return De(J)}const ae=new A.$5g;ae.cancelAndSet(()=>ve("waiting..."),1e3);let fe,Ie;for(const[J,{authorityPrefix:q,resolver:x,remoteAuthority:ce}]of ne.entries())try{if(J===ne.length-1)ve("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${q}`),fe=await x.resolve(ce,{resolveAttempt:B,execServer:Ie}),C.mark(`code/extHost/didResolveAuthorityOK/${q}`),ve("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,s.$mK.isManagedResolvedAuthority(fe)?fe:void 0));else{if(ve(`invoking resolveExecServer() for ${ce}`),C.mark(`code/extHost/willResolveExecServer/${q}`),Ie=await x.resolveExecServer?.(ce,{resolveAttempt:B,execServer:Ie}),!Ie)throw new s.$nK(`Exec server was not available for ${ce}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Ne){return C.mark(`code/extHost/didResolveAuthorityError/${q}`),de("returned an error",Ne),ae.dispose(),De(Ne)}ae.dispose();const F={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures},V={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};ve(`returned ${s.$mK.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let G;if(s.$mK.isManagedResolvedAuthority(fe)){const J=B;this.X.setFactory(J,fe.makeConnection),G={authority:_,connectTo:new r.$Qk(J),connectionToken:fe.connectionToken}}else G={authority:_,connectTo:new r.$Rk(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:G,options:V,tunnelInformation:F}}}async $getCanonicalURI(_,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$Tk)(_)})`);const{resolver:Z}=await this.sb(_);if(!Z)return null;const ee=$.URI.revive(B);if(typeof Z.getCanonicalURI>"u")return ee;const ve=await(0,A.$Mg)(()=>Z.getCanonicalURI(ee));return ve||ee}$startExtensionHost(_){_.toAdd.forEach(ee=>ee.extensionLocation=$.URI.revive(ee.extensionLocation));const{globalRegistry:B,myExtensions:Z}=Ee(this.I,this.L,this.J,_);return this.L.set(B.getAllExtensionDescriptions()),this.J.set(Z),O.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Pe(this.J)}`)),this.rb()}$activateByEvent(_,B){return B===1?this.D.wait().then(Z=>this.Z(_,!1)):this.G.wait().then(Z=>this.Z(_,!1))}async $activate(_,B){return await this.G.wait(),this.J.getExtensionDescription(_)?(await this.$(_,B),!0):!1}async $deltaExtensions(_){_.toAdd.forEach(ge=>ge.extensionLocation=$.URI.revive(ge.extensionLocation));const{globalRegistry:B,myExtensions:Z}=Ee(this.I,this.L,this.J,_),ee=await this.bb(Z);return(await this.getExtensionPathIndex()).setSearchTree(ee),this.L.set(B.getAllExtensionDescriptions()),this.J.set(Z),O.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(_){return _}async $test_up(_){return _.byteLength}async $test_down(_){const B=E.$be.alloc(_),Z=Math.random()%256;for(let ee=0;ee<_;ee++)B.writeUInt8(Z,ee);return B}async $updateRemoteConnectionData(_){this.W=_,this.a.fire()}};e.$Hcc=X,e.$Hcc=X=ie=qe([Ke(0,n.$Oh),Ke(1,e.$Gcc),Ke(2,f.$gM),Ke(3,d.$acc),Ke(4,a.$dcc),Ke(5,R.$0i),Ke(6,o.$wM),Ke(7,w.$tcc),Ke(8,S.$5vb),Ke(9,u.$vcc),Ke(10,z.$Dcc),Ke(11,N.$Ecc)],X);function Ee(be,_,B,Z){be.addActivationEvents(Z.addActivationEvents);const ee=new i.$h4b(be,_.getAllExtensionDescriptions());ee.deltaExtensions(Z.toAdd,Z.toRemove);const ve=new b.$7l(B.getAllExtensionDescriptions().map(de=>de.identifier));for(const de of Z.myToRemove)ve.delete(de);for(const de of Z.myToAdd)ve.add(de);const ge=pe(ee,ve);return{globalRegistry:ee,myExtensions:ge}}function Se(be,_){return{id:be.identifier.value,name:be.name,extensionVersion:be.version,publisherDisplayName:be.publisher,activationEvents:be.activationEvents?be.activationEvents.join(","):null,isBuiltin:be.isBuiltin,reason:_.activationEvent,reasonId:_.extensionId.value}}function Pe(be){return be.getAllExtensionDescriptions().map(_=>_.identifier.value).join(",")}e.$Icc=(0,n.$Ph)("IExtHostExtensionService");class $e{#e;#t;#i;constructor(_,B,Z,ee,ve){this.#e=_,this.#t=B,this.#i=Z.identifier,this.id=Z.identifier.value,this.extensionUri=Z.extensionLocation,this.extensionPath=M.$hc((0,T.$jg)(Z.extensionLocation)),this.packageJSON=Z,this.extensionKind=ee,this.isFromDifferentExtensionHost=ve}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Jcc=$e;function pe(be,_){return be.getAllExtensionDescriptions().filter(B=>_.has(B.identifier))}class ue{constructor(_){this.a=_}setSearchTree(_){this.a=_}findSubstr(_){return this.a.findSubstr(_)}forEach(_){return this.a.forEach(_)}}e.$Kcc=ue;class oe{constructor(_){this.a=new b.$8l,this.addActivationEvents(_)}readActivationEvents(_){return this.a.get(_.identifier)}addActivationEvents(_){for(const B of Object.keys(_))this.a.set(B,_[B])}}}),define(Ae[271],Re([1,0,87,2,3,34,25,21,17,27,4,35,14,16]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=void 0;let d=class{constructor(E,v,s,r,n,o,w){this.c=E,this.d=v,this.e=s,this.f=r,this.g=n,this.h=o,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),y.mark("code/extHost/willWaitForConfig");const E=await this.f.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const v=await this.g.getExtensionPathIndex();this.register(new i(this.c,v,this.d,E,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(c,v,this.h.environment.appUriScheme))}register(E){if("nodeModuleName"in E)if(Array.isArray(E.nodeModuleName))for(const v of E.nodeModuleName)this.a.set(v,E);else this.a.set(E.nodeModuleName,E);typeof E.alternativeModuleName=="function"&&this.b.push(v=>E.alternativeModuleName(v))}};e.$9dc=d,e.$9dc=d=qe([Ke(2,R.$Oh),Ke(3,T.$dcc),Ke(4,k.$Icc),Ke(5,$.$wM),Ke(6,a.$0i)],d);let t=class{static{g=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(E){if(E.environment.appRoot&&g.a.size){const v=(0,p.$Fe)(this.c(E.environment.appRoot.fsPath)),s="[a-z0-9_.-]",r=`@${s}+\\/${s}+|${s}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${v}/${n}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(E){if(!this.b)return;const v=this.b.exec(this.c(E));if(!v)return;const[,s,r,n]=v,o=g.a.get(r);if(o!==void 0)return console.warn(`${r} as been renamed to ${o}, please update your imports`),s+o+n}c(E){return E.replace(/\\/g,"/")}};t=g=qe([Ke(0,$.$wM)],t);class i{constructor(E,v,s,r,n){this.c=E,this.d=v,this.e=s,this.f=r,this.g=n,this.nodeModuleName="vscode",this.a=new l.$8l}load(E,v){const s=this.d.findSubstr(v);if(s){let r=this.a.get(s.identifier);return r||(r=this.c(s,this.e,this.f),this.a.set(s.identifier,r)),r}if(!this.b){let r="";this.d.forEach((n,o)=>r+=`	${o} -> ${n.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${v}. These are the extension path mappings: 
${r}`),this.b=this.c(A.$0E,this.e,this.f)}return this.b}}let c=class{constructor(E,v,s){this.e=E,this.f=v,this.nodeModuleName=["open","opn"],this.d=s.getProxy(C.$fK.MainThreadTelemetry);const r=s.getProxy(C.$fK.MainThreadWindow);this.c=(n,o)=>{const w=M.URI.parse(n);return o?this.g(n,o):w.scheme==="http"||w.scheme==="https"?r.$openUri(w,n,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?r.$openUri(w,n,{}):this.g(n,o)}}load(E,v,s){const r=this.e.findSubstr(v);return r&&(this.a=r.identifier.value,this.h()),this.b=s(E),this.c}g(E,v){return this.i(),this.b(E,v)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};c=qe([Ke(2,D.$gM)],c)}),define(Ae[112],Re([1,0,41,6,19,73,4,60,61,35,7,33,200,34]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=void 0,e.$edc=(0,A.$Ph)("IExtHostVariableResolverProvider");class g extends a.$hN{constructor(i,c,b,E,v,s,r){function n(){if(b){const o=b.activeEditor();if(o)return o.document.uri;const w=E.tabGroups.all.find(f=>f.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof R.$ZL||w.input instanceof R.$5L)return w.input.modified;if(w.input instanceof R.$YL||w.input instanceof R.$4L||w.input instanceof R.$2L)return w.input.uri}}}super({getFolderUri:o=>{const w=s.folders.filter(f=>f.name===o);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(o,w)=>v.getConfiguration(void 0,o).get(w),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=n();if(o)return C.$hc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const o=n();if(o){const w=c.getWorkspaceFolder(o);if(w)return C.$hc(w.uri.fsPath)}}},getSelectedText:()=>{if(b){const o=b.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(b){const o=b.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>i.getExtension(o)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(T.env))}}let d=class extends M.$Sc{constructor(i,c,b,E,v){super(),this.b=i,this.c=c,this.g=b,this.h=E,this.j=v,this.a=new y.$V(async()=>{const s=await this.h.getConfigProvider(),n={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{n.folders=await this.c.getWorkspaceFolders2()||[]})),new g(this.b,this.c,this.g,this.j,s,n,this.m())})}getResolver(){return this.a.value}m(){}};e.$fdc=d,e.$fdc=d=qe([Ke(0,$.$Icc),Ke(1,k.$acc),Ke(2,l.$rM),Ke(3,p.$dcc),Ke(4,D.$cdc)],d)}),define(Ae[113],Re([1,0,12,5,2,4,3,61,35,17,7,33,193,195,34,112]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=e.$jdc=e.$idc=e.$hdc=e.$gdc=void 0,e.$gdc=(0,T.$Ph)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,n,o,w,f,I){this.E=n,this.F=o,this.G=w,this.H=f,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new M.$Nd,this.n=new M.$Nd,this.o=new M.$Nd,this.u=new M.$Nd,this.k=r.getProxy(A.$fK.MainThreadDebugService),this.y=new M.$Nd,this.A=new M.$Nd,this.v=new c(this.k),this.w=new Map,this.F.getExtensionRegistry().then(S=>{S.onDidChange(u=>{this.J(S)}),this.J(S)})}asDebugSourceUri(r,n){const o=r;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let w=`debug:${encodeURIComponent(o.path||"")}`,f="?";return n&&(w+=`${f}session=${encodeURIComponent(n.id)}`,f="&"),w+=`${f}ref=${o.sourceReference}`,C.URI.parse(w)}else{if(o.path)return C.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const n=[];for(const o of r.getAllExtensionDescriptions())if(o.contributes){const w=o.contributes.debuggers;if(w&&w.length>0)for(const f of w)(0,p.$rF)(f)&&n.push(f.type)}this.k.$registerDebugTypes(n)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(n=>r.push(n)),r}addBreakpoints(r){const n=r.filter(f=>{const I=f.id;return this.w.has(I)?!1:(this.w.set(I,f),!0)});this.U(n,[],[]);const o=[],w=new Map;for(const f of n)if(f instanceof R.$gL){let I=w.get(f.location.uri.toString());I||(I={type:"sourceMulti",uri:f.location.uri,lines:[]},w.set(f.location.uri.toString(),I),o.push(I)),I.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof R.$hL&&o.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(r){const n=r.filter(I=>this.w.delete(I.id));this.U([],n,[]);const o=n.filter(I=>I instanceof R.$gL).map(I=>I.id),w=n.filter(I=>I instanceof R.$hL).map(I=>I.id),f=n.filter(I=>I instanceof R.$iL).map(I=>I.id);return this.k.$unregisterBreakpoints(o,w,f)}startDebugging(r,n,o){return this.k.$startDebugging(r?r.uri:void 0,n,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,n,o){if(!n)return new R.$hK(()=>{});const w=this.d++;return this.f.push({type:r,handle:w,provider:n}),this.k.$registerDebugConfigurationProvider(r,o,!!n.provideDebugConfigurations,!!n.resolveDebugConfiguration,!!n.resolveDebugConfigurationWithSubstitutedVariables,w),new R.$hK(()=>{this.f=this.f.filter(f=>f.provider!==n),this.k.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(r,n,o){if(!o)return new R.$hK(()=>{});if(!this.Q(r,n))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${n}' debugger.`);if(this.N(n))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.g++;return this.h.push({type:n,handle:w,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(n,w),new R.$hK(()=>{this.h=this.h.filter(f=>f.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(r,n){if(!n)return new R.$hK(()=>{});const o=this.i++;return this.j.push({type:r,handle:o,factory:n}),new R.$hK(()=>{this.j=this.j.filter(w=>w.factory!==n)})}async $runInTerminal(r,n){return Promise.resolve(void 0)}async $substituteVariables(r,n){let o;const w=await this.W(r);return w&&(o={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,n)}K(r,n){if(r.type==="implementation")return new E(r.implementation)}L(){}async $startDASession(r,n){const o=this,w=await this.V(n);return this.S(this.N(w.type),w).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const I=this.M(f),S=this.K(I,w);if(!S)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const u=S;return this.B.set(r,u),this.R(w).then(m=>(m&&this.C.set(r,m),u.onMessage(async h=>{if(h.type==="request"&&h.command==="handshake"){const P=h,W={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const K=await this.D.sign(P.arguments.value);W.body={signature:K},u.sendResponse(W)}else throw new Error("no signer")}catch(K){W.success=!1,W.message=K.message,u.sendResponse(W)}}else m&&m.onDidSendMessage&&m.onDidSendMessage(h),h=(0,p.$wF)(h,!0),o.k.$acceptDAMessage(r,h)}),u.onError(h=>{m&&m.onError&&m.onError(h),this.k.$acceptDAError(r,h.name,h.message,h.stack)}),u.onExit(h=>{m&&m.onExit&&m.onExit(h??void 0,void 0),this.k.$acceptDAExit(r,h??void 0,void 0)}),m&&m.onWillStartSession&&m.onWillStartSession(),u.startSession()))})}$sendDAMessage(r,n){n=(0,p.$vF)(n,!1);const o=this.C.get(r);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(n),this.B.get(r)?.sendMessage(n)}$stopDASession(r){const n=this.C.get(r);this.C.delete(r),n&&n.onWillStopSession&&n.onWillStopSession();const o=this.B.get(r);return this.B.delete(r),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const n=[],o=[],w=[];if(r.added)for(const f of r.added){const I=f.id;if(I&&!this.w.has(I)){let S;if(f.type==="function")S=new R.$hL(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")S=new R.$iL(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const u=C.URI.revive(f.uri);S=new R.$gL(new R.$tK(u,new R.$iK(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,R.$eL)(S,I),this.w.set(I,S),n.push(S)}}if(r.removed)for(const f of r.removed){const I=this.w.get(f);I&&(this.w.delete(f),o.push(I))}if(r.changed){for(const f of r.changed)if(f.id){const I=this.w.get(f.id);if(I){if(I instanceof R.$hL&&f.type==="function"){const S=I;S.enabled=f.enabled,S.condition=f.condition,S.hitCondition=f.hitCondition,S.logMessage=f.logMessage,S.functionName=f.functionName}else if(I instanceof R.$gL&&f.type==="source"){const S=I;S.enabled=f.enabled,S.condition=f.condition,S.hitCondition=f.hitCondition,S.logMessage=f.logMessage,S.location=new R.$tK(C.URI.revive(f.uri),new R.$iK(f.line,f.character))}w.push(I)}}}this.U(n,o,w)}async $acceptStackFrameFocus(r){let n;const o=r.sessionId?await this.V(r.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?n=new R.$oL(o,r.threadId):n=new R.$nL(o,r.threadId,r.frameId),this.z=n,this.A.fire(this.z)}$provideDebugConfigurations(r,n,o){return(0,y.$Mg)(async()=>{const w=this.P(r);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.W(n);return w.provideDebugConfigurations(f,o)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(r,n,o,w){return(0,y.$Mg)(async()=>{const f=this.P(r);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(n);return f.resolveDebugConfiguration(I,o,w)})}$resolveDebugConfigurationWithSubstitutedVariables(r,n,o,w){return(0,y.$Mg)(async()=>{const f=this.P(r);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(n);return f.resolveDebugConfigurationWithSubstitutedVariables(I,o,w)})}async $provideDebugAdapter(r,n){const o=this.O(r);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.V(n);return this.S(o,w).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.M(f)})}async $acceptDebugSessionStarted(r){const n=await this.V(r);this.m.fire(n)}async $acceptDebugSessionTerminated(r){const n=await this.V(r);n&&(this.n.fire(n),this.l.delete(n.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,n){(await this.V(r))?._acceptNameChanged(n)}async $acceptDebugSessionCustomEvent(r,n){const w={session:await this.V(r),event:n.event,body:n.body};this.u.fire(w)}M(r){if(r instanceof R.$jL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof R.$kL)return{type:"server",port:r.port,host:r.host};if(r instanceof R.$lL)return{type:"pipeServer",path:r.path};if(r instanceof R.$mL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const n=this.h.filter(o=>o.type===r);if(n.length>0)return n[0].factory}O(r){const n=this.h.filter(o=>o.handle===r);if(n.length>0)return n[0].factory}P(r){const n=this.f.filter(o=>o.handle===r);if(n.length>0)return n[0].provider}Q(r,n){if(r.contributes){const o=r.contributes.debuggers;if(o&&o.length>0){for(const w of o)if(w.label&&w.type&&w.type===n)return!0}}return!1}R(r){const o=r.configuration.type,w=this.j.filter(f=>f.type===o||f.type==="*").map(f=>(0,y.$Mg)(()=>f.factory.createDebugAdapterTracker(r)).then(I=>I,I=>null));return Promise.race([Promise.all(w).then(f=>{const I=f.filter(S=>!!S);if(I.length>0)return new b(I)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async S(r,n){const o=n.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new R.$kL(o));if(r){const f=await this.F.getExtensionRegistry();return(0,y.$Mg)(()=>r.createDebugAdapterDescriptor(n,this.T(n,f))).then(I=>{if(I)return I})}const w=await this.F.getExtensionRegistry();return Promise.resolve(this.T(n,w))}T(r,n){}U(r,n,o){(r.length>0||n.length>0||o.length>0)&&this.y.fire(Object.freeze({added:r,removed:n,changed:o}))}async V(r){if(r)if(typeof r=="string"){const n=this.l.get(r);if(n)return n}else{let n=this.l.get(r.id);if(!n){const o=await this.W(r.folderUri),w=r.parent?this.l.get(r.parent):void 0;n=new i(this.k,r.id,r.type,r.name,o,r.configuration,w),this.l.set(n.id,n),this.k.$sessionCached(n.id)}return n}throw new Error("cannot find session")}W(r){if(r){const n=C.URI.revive(r);return this.E.resolveWorkspaceFolder(n)}return Promise.resolve(void 0)}};e.$hdc=t,e.$hdc=t=qe([Ke(0,$.$gM),Ke(1,k.$acc),Ke(2,D.$Icc),Ke(3,g.$dcc),Ke(4,l.$cdc),Ke(5,d.$edc)],t);class i{constructor(r,n,o,w,f,I,S){this.d=r,this.f=n,this.g=o,this.h=w,this.i=f,this.j=I,this.k=S}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,n){return this.d.$customDebugAdapterRequest(this.f,r,n)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$idc=i;class c{constructor(r){this.value=Object.freeze({append(n){r.$appendDebugConsole(n)},appendLine(n){this.append(n+`
`)}})}}e.$jdc=c;class b{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(n=>n.onWillReceiveMessage?n.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(n=>n.onDidSendMessage?n.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(n=>n.onError?n.onError(r):void 0)}onExit(r,n){this.d.forEach(o=>o.onExit?o.onExit(r,n):void 0)}}class E extends a.$5cb{constructor(r){super(),this.h=r,r.onDidSendMessage(n=>{this.acceptMessage(n)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let v=class extends t{constructor(r,n,o,w,f,I){super(r,n,o,w,f,I)}};e.$kdc=v,e.$kdc=v=qe([Ke(0,$.$gM),Ke(1,k.$acc),Ke(2,D.$Icc),Ke(3,g.$dcc),Ke(4,l.$cdc),Ke(5,d.$edc)],v)}),define(Ae[272],Re([1,0,9,87,2,3,263,14,70,71,27,172,17,56,35,58]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=e.$0dc=void 0;class t{static async installEarlyHandler(b){Error.stackTraceLimit=100;const E=b.get(l.$0i),s=b.get(a.$gM).getProxy(T.$fK.MainThreadErrors);y.setUnexpectedErrorHandler(r=>{E.error(r);const n=y.$3(r);s.$onUnexpectedError(n)})}static async installFullHandler(b){const E=b.get(l.$0i),v=b.get(a.$gM),s=b.get(g.$Icc),r=b.get(d.$AM),n=v.getProxy(T.$fK.MainThreadExtensionService),o=v.getProxy(T.$fK.MainThreadErrors),w=await s.getExtensionPathIndex(),f=new WeakMap;function I(m,h){if(f.has(m))return f.get(m).stack;let P="",W,K;for(const j of h)P+=`
	at ${j.toString()}`,K=j.getFileName(),!W&&K&&(W=w.findSubstr(C.URI.file(K)));const z=`${m.name||"Error"}: ${m.message||""}${P}`;return f.set(m,{extensionIdentifier:W?.identifier,stack:z}),z}const S=Symbol("prepareStackTrace wrapped");let u=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(m){if(m===I||!m||m[S]){u=m||I;return}u=function(h,P){return I(h,P),m.call(Error,h,P)},Object.assign(u,{[S]:!0})}}),y.setUnexpectedErrorHandler(m=>{E.error(m);const h=y.$3(m),P=f.get(m);if(!P?.extensionIdentifier){o.$onUnexpectedError(h);return}n.$onExtensionRuntimeError(P.extensionIdentifier,h);const W=r.onExtensionError(P.extensionIdentifier,m);E.trace("forwarded error to extension?",W,P)})}}e.$0dc=t;class i{constructor(b,E,v,s,r){this.a=v,this.b=new A.$q4b(b,null,s),E=i.e(E,this.b);const n=new $.$Nh(...(0,D.$yr)());n.set(R.$wM,{_serviceBrand:void 0,...E,messagePorts:r}),n.set(a.$gM,new a.$hM(this.b)),n.set(p.$0bc,new p.$$bc(s)),n.set(g.$Gcc,v);const o=new k.$eq(n,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(w=>w.get(l.$0i)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",E),this.c=o.invokeFunction(w=>w.get(g.$Icc)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(b){const E=this.b.getProxy(T.$fK.MainThreadExtensionService);return C.URI.revive(await E.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,E){b.extensions.allExtensions.forEach(s=>{s.extensionLocation=C.URI.revive(E.transformIncomingURIs(s.extensionLocation))}),b.environment.appRoot=C.URI.revive(E.transformIncomingURIs(b.environment.appRoot));const v=b.environment.extensionDevelopmentLocationURI;return v&&(b.environment.extensionDevelopmentLocationURI=v.map(s=>C.URI.revive(E.transformIncomingURIs(s)))),b.environment.extensionTestsLocationURI=C.URI.revive(E.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=C.URI.revive(E.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=C.URI.revive(E.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=C.URI.revive(E.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=C.URI.revive(E.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=C.URI.revive(E.transformIncomingURIs(b.logsLocation)),b.workspace=E.transformIncomingURIs(b.workspace),b}}e.$$dc=i}),define(Ae[273],Re([1,0,18,12,20,37,13,19,23,2,48]),function(ye,e,y,M,C,T,A,l,D,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=e.$odc=e.$ndc=e.$mdc=void 0;class k{constructor(c,b,E,v){this.d=c,this.e=b,this.f=E,this.g=v,this.a=null,this.b=!1,this.c=0}search(c,b){const E=this.d.folderQueries||[],v=new C.$Xd(b);return new Promise((s,r)=>{this.a=new p(c);let n=!1;const o=(w,f)=>{if(!n&&!this.b){const I=this.h(w);d(w)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,n=!0,v.cancel(),w=this.j(w,this.d.maxResults-this.c));const S=this.h(w);this.c+=S,(S>0||!d(w))&&this.a.add(w,f)}};Promise.all(E.map((w,f)=>this.k(w,I=>o(I,f),v.token))).then(w=>{v.dispose(),this.a.flush();const f=w.some(I=>!!I&&!!I.limitHit);s({limitHit:this.b||f,messages:(0,y.$Rb)(w.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},w=>{v.dispose();const f=(0,T.$Ai)(w);r(new Error(f))})})}h(c){return d(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}j(c,b){const E=Array.isArray(c.ranges)?c.ranges:[c.ranges],v=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:E.slice(0,b),preview:{matches:v.slice(0,b),text:c.preview.text},uri:c.uri}}async k(c,b,E){const v=new R.$1I(this.d,c),s=[],r={report:w=>{if(!this.l(w))return;const f=c.folder.scheme===A.Schemas.file?(0,R.$2I)(()=>this.f.readdir(D.$ug(w.uri))):void 0,I=D.$xg(c.folder,w.uri);if(I){const S=v.includedInQuery(I,l.$nc(I),f);(0,M.$Gg)(S)?s.push(S.then(u=>{u&&b(w)})):S&&b(w)}}},n=this.n(c),o=await this.e.provideTextSearchResults(a(this.d.contentPattern),n,r,E);return s.length&&await Promise.all(s),o}l(c){if(d(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(c){const b=(0,R.$ZI)(this.d.includePattern,c.includePattern),E=(0,R.$ZI)(this.d.excludePattern,c.excludePattern),v={folder:$.URI.from(c.folder),excludes:E,includes:b,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.f.toCanonicalName(c.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return v.usePCRE2=this.d.usePCRE2,v}}e.$mdc=k;function a(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class p{constructor(c){this.e=c,this.b=-1,this.d=null,this.a=new t(512,b=>this.g(b))}add(c,b){this.d&&(this.b!==b||!D.$og(this.c,c.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:c.uri,results:[]}),this.d.results.push(g(c))}f(){const c=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,c)}flush(){this.f(),this.a.flush()}g(c){this.e(c)}}e.$ndc=p;function g(i){return d(i)?{preview:{matches:(0,y.$2b)(i.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:i.preview.text},ranges:(0,y.$2b)(i.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function d(i){return!!i.preview}e.$odc=d;class t{static{this.a=4e3}static{this.b=50}constructor(c,b){this.g=c,this.h=b,this.c=0,this.d=[],this.e=0}addItem(c,b){c&&this.j(c,b)}addItems(c,b){c&&this.k(c,b)}j(c,b){this.d.push(c),this.e+=b,this.l()}k(c,b){this.d=this.d.concat(c),this.e+=b,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$pdc=t}),define(Ae[114],Re([1,0,6,3,4,268,17,56,14,2,273]),function(ye,e,y,M,C,T,A,l,D,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=e.$rdc=e.$qdc=void 0,e.$qdc=(0,C.$Ph)("IExtHostSearch");let k=class{constructor(d,t,i){this.k=d,this.l=t,this.n=i,this.c=this.k.getProxy(M.$fK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new T.$ldc}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,t){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(d)),(0,y.$Qc)(()=>{this.g.delete(d),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(d,t){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(d)),(0,y.$Qc)(()=>{this.i.delete(d),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(d,t,i,c){const b=a(i),E=this.h.get(d);if(E)return this.j.fileSearch(b,E,v=>{this.c.$handleFileMatch(d,t,v.map(s=>s.resource))},c);throw new Error("unknown provider: "+d)}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,t,i,c){const b=this.e.get(d);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const E=a(i);return this.q(E,b).search(s=>this.c.$handleTextMatch(d,t,s),c)}$enableExtensionHostSearch(){}q(d,t){return new R.$mdc(d,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$rdc=k,e.$rdc=k=qe([Ke(0,A.$gM),Ke(1,l.$0bc),Ke(2,D.$0i)],k);function a(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(p),extraFileResources:g.extraFileResources&&g.extraFileResources.map(d=>$.URI.revive(d))}}e.$sdc=a;function p(g){return{...g,folder:$.URI.revive(g.folder)}}}),define(Ae[274],Re([1,0,20,9,5,29,2,135,285,124,133,39,3,79,225,224,31,226,34,228,229,230,203,231,60,35,234,235,240,241,243,109,207,249,250,253,84,63,255,210,8,7,54,258,64,108,33,21,198,239,53,107,111,113,114,14,56,17,27,244,196,86,80,217,256,85,62,261,259,260,218,40,254,257,83,61,58,245,110,246,13,95,206,189,237,6,25,194,81,185,247,248,219,236,205,238,82,251,222,252,223,216,233,220,221]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d,t,i,c,b,E,v,s,r,n,o,w,f,I,S,u,m,h,P,W,K,z,j,O,N,ie,X,Ee,Se,Pe,$e,pe,ue,oe,be,_,B,Z,ee,ve,ge,de,De,re,le,ne,ae,fe,Ie,F,V,G,J,q,x,ce,Ne,Ue,Qe,Ge,xe,Ye,_e,it,tt,ze,st,Y,Q,we,Be,Oe,Xe,nt,ft,wt,Pt,Zt,Gt,pt,jt,Nt,Bt,At,Rt,Ot,Wt,Jt,Kt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=void 0;function Mt(ut){const ht=ut.get(re.$wM),Lt=ut.get(Ne.$Zbc),qt=ut.get(G.$scc),kt=ut.get(o.$Icc),at=ut.get(pe.$acc),vt=ut.get(Ye.$AM),Ht=ut.get(c.$dcc),Ct=ut.get(de.$0bc),We=ut.get(De.$gM),Ce=ut.get(z.$occ),Fe=ut.get(V.$tcc),me=ut.get(ge.$$i),H=ut.get(ge.$0i),Me=ut.get(ae.$5vb),je=ut.get(fe.$3bc),Je=ut.get($e.$7cc),Ve=ut.get(Ge.$Acc),et=ut.get(xe.$cdc),bt=ut.get(Nt.$Ecc);We.set(a.$gK.ExtHostFileSystemInfo,Lt),We.set(a.$gK.ExtHostLogLevelServiceShape,me),We.set(a.$gK.ExtHostWorkspace,at),We.set(a.$gK.ExtHostConfiguration,Ht),We.set(a.$gK.ExtHostExtensionService,kt),We.set(a.$gK.ExtHostStorage,Ce),We.set(a.$gK.ExtHostTunnelService,Me),We.set(a.$gK.ExtHostWindow,Je),We.set(a.$gK.ExtHostSecretState,Ve),We.set(a.$gK.ExtHostTelemetry,vt),We.set(a.$gK.ExtHostEditorTabs,et),We.set(a.$gK.ExtHostManagedSockets,bt);const zt=We.set(a.$gK.ExtHostDecorations,ut.get(B.$$cc)),Dt=We.set(a.$gK.ExtHostDocumentsAndEditors,ut.get(n.$rM)),lt=We.set(a.$gK.ExtHostCommands,ut.get(t.$CM)),gt=We.set(a.$gK.ExtHostTerminalService,ut.get(j.$vcc)),yt=We.set(a.$gK.ExtHostDebugService,ut.get(ee.$gdc)),mi=We.set(a.$gK.ExtHostSearch,ut.get(ve.$qdc)),St=We.set(a.$gK.ExtHostTask,ut.get(Z.$bdc)),Si=We.set(a.$gK.ExtHostOutputService,ut.get(m.$Qcc)),ui=We.set(a.$gK.ExtHostLocalization,ut.get(nt.$Dcc)),$i=We.set(a.$gK.ExtHostUrls,new Se.$Zcc(We)),It=We.set(a.$gK.ExtHostDocuments,new r.$Xbc(We,Dt)),fn=We.set(a.$gK.ExtHostDocumentContentProviders,new v.$fcc(We,Dt,H)),ri=We.set(a.$gK.ExtHostDocumentSaveParticipant,new s.$gcc(H,It,We.getProxy(a.$fK.MainThreadBulkEdits))),Et=We.set(a.$gK.ExtHostNotebook,new le.$wdc(We,lt,Dt,It,qt)),pi=We.set(a.$gK.ExtHostNotebookDocuments,new Q.$Odc(Et)),vi=We.set(a.$gK.ExtHostNotebookEditors,new Y.$Ndc(H,Et)),si=We.set(a.$gK.ExtHostNotebookKernels,new _e.$Kdc(We,ht,Et,lt,H)),Ii=We.set(a.$gK.ExtHostNotebookRenderers,new tt.$Mdc(We,Et)),Ci=We.set(a.$gK.ExtHostNotebookDocumentSaveParticipant,new pt.$Udc(H,Et,We.getProxy(a.$fK.MainThreadBulkEdits))),Ft=We.set(a.$gK.ExtHostEditors,new O.$Xcc(We,Dt)),bi=We.set(a.$gK.ExtHostTreeViews,new N.$Ycc(We.getProxy(a.$fK.MainThreadTreeViews),lt,H)),Pi=We.set(a.$gK.ExtHostEditorInsets,new oe.$8cc(We.getProxy(a.$fK.MainThreadEditorInsets),Ft,ht.remote)),oi=We.set(a.$gK.ExtHostDiagnostics,new b.$2bc(We,H,Lt,Dt)),li=We.set(a.$gK.ExtHostLanguages,new S.$Ncc(We,It,lt.converter,Ct)),ct=We.set(a.$gK.ExtHostLanguageFeatures,new I.$6bc(We,Ct,It,lt,oi,H,je,vt)),Ai=We.set(a.$gK.ExtHostFileSystem,new w.$Lcc(We,ct)),Yt=We.set(a.$gK.ExtHostFileSystemEventService,new f.$Mcc(We,H,Dt)),ii=We.set(a.$gK.ExtHostQuickOpen,(0,P.$Scc)(We,at,lt)),Ri=We.set(a.$gK.ExtHostSCM,new W.$Ucc(We,lt,It,H)),Mi=We.set(a.$gK.ExtHostQuickDiff,new Pt.$Rdc(We,Ct)),Fi=We.set(a.$gK.ExtHostShare,new Bt.$Wdc(We,Ct)),Xi=We.set(a.$gK.ExtHostComments,(0,i.$9bc)(We,lt,It)),Ti=We.set(a.$gK.ExtHostProgress,new h.$Rcc(We.getProxy(a.$fK.MainThreadProgress))),Zi=We.set(a.$gK.ExtHosLabelService,new be.$9cc(We)),Li=We.set(a.$gK.ExtHostTheming,new ne.$xdc(We)),ai=We.set(a.$gK.ExtHostAuthentication,new Ie.$ydc(We)),gn=We.set(a.$gK.ExtHostTimeline,new F.$Adc(We,lt)),Ni=We.set(a.$gK.ExtHostWebviews,new Pe.$3cc(We,ht.remote,at,H,je)),di=We.set(a.$gK.ExtHostWebviewPanels,new x.$Cdc(We,Ni,at)),Oi=We.set(a.$gK.ExtHostCustomEditors,new q.$Ddc(We,It,Fe,Ni,di)),mn=We.set(a.$gK.ExtHostWebviewViews,new J.$Bdc(We,Ni)),hi=We.set(a.$gK.ExtHostTesting,new Ue.$Fdc(We,lt,Dt)),Yi=We.set(a.$gK.ExtHostUriOpeners,new Qe.$Jdc(We)),zi=We.set(a.$gK.ExtHostProfileContentHandlers,new wt.$Qdc(We));We.set(a.$gK.ExtHostInteractive,new we.$Pdc(We,Et,Dt,lt,H));const xi=We.set(a.$gK.ExtHostInlineChat,new Gt.$Tdc(We,lt,It,H)),fi=We.set(a.$gK.ExtHostChatProvider,new At.$Xdc(We,H)),_i=We.set(a.$gK.ExtHostChatAgents,new Kt.$3dc(We,fi,H)),$n=We.set(a.$gK.ExtHostChatAgents2,new Vt.$4dc(We,fi,H)),Ui=We.set(a.$gK.ExtHostChatVariables,new Ot.$Zdc(We)),gi=We.set(a.$gK.ExtHostChat,new Zt.$Sdc(We,H)),xt=We.set(a.$gK.ExtHostAiRelatedInformation,new Wt.$1dc(We)),wi=We.set(a.$gK.ExtHostAiEmbeddingVector,new Jt.$2dc(We)),pn=We.set(a.$gK.ExtHostIssueReporter,new jt.$Vdc(We)),Qt=We.set(a.$gK.ExtHostStatusBar,new K.$Wcc(We,lt.converter)),yi=We.set(a.$gK.ExtHostSpeech,new Rt.$Ydc(We)),en=Object.values(a.$gK);We.assertRegistered(en);const tn=new ce.$Edc(We,Dt),nn=new d.$8bc(We),Ei=new u.$Occ(We,H),rn=new E.$ecc(We);return g.$7bc.register(lt),function(Le,_t,sn){const mt=function(){let te=!Le.isUnderDevelopment;function he(){te||(H.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(rt){if(Array.isArray(rt))rt.forEach(Te);else if(typeof rt=="string")he();else{const $t=rt;typeof $t.scheme>"u"&&he(),typeof $t.exclusive=="boolean"&&(0,Oe.$dF)(Le,"documentFiltersExclusive")}return rt}}(),ji={getSession(te,he,Te){return ai.getSession(Le,te,he,Te)},getSessions(te,he){return(0,Oe.$dF)(Le,"authGetSessions"),ai.getSessions(Le,te,he)},async hasSession(te,he){return(0,Oe.$dF)(Le,"authSession"),!!await ai.getSession(Le,te,he,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(te,he,Te,rt){return ai.registerAuthenticationProvider(te,he,Te,rt)}},on={registerCommand(te,he,Te){return lt.registerCommand(!0,te,he,Te,void 0,Le)},registerTextEditorCommand(te,he,Te){return lt.registerCommand(!0,te,(...rt)=>{const $t=Ft.getActiveTextEditor();if(!$t){H.warn("Cannot execute "+te+" because there is no active text editor.");return}return $t.edit(Tt=>{he.apply(Te,[$t,Tt,...rt])}).then(Tt=>{Tt||H.warn("Edits from command "+te+" were not applied.")},Tt=>{H.warn("An error occurred while running command "+te,Tt)})},void 0,void 0,Le)},registerDiffInformationCommand:(te,he,Te)=>((0,Oe.$dF)(Le,"diffCommand"),lt.registerCommand(!0,te,async(...rt)=>{const $t=Dt.activeEditor(!0);if(!$t){H.warn("Cannot execute "+te+" because there is no active text editor.");return}const Tt=await Ft.getDiffInformation($t.id);he.apply(Te,[Tt,...rt])},void 0,void 0,Le)),executeCommand(te,...he){return lt.executeCommand(te,...he)},getCommands(te=!1){return lt.getCommands(te)}},Bi={get machineId(){return ht.telemetryInfo.machineId},get sessionId(){return ht.telemetryInfo.sessionId},get language(){return ht.environment.appLanguage},get appName(){return ht.environment.appName},get appRoot(){return ht.environment.appRoot?.fsPath??""},get appHost(){return ht.environment.appHost},get uriScheme(){return ht.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return gt.onDidChangeShell},get isTelemetryEnabled(){return vt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return vt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Oe.$dF)(Le,"telemetry"),vt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Oe.$dF)(Le,"telemetry"),vt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.$zM)(ht.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,he){return Ye.$yM.validateSender(te),vt.instantiateLogger(Le,te,he)},openExternal(te,he){return Je.openUri(te,{allowTunneling:!!ht.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ht.environment.appUriScheme)return $i.createAppUri(te);try{return await Je.asExternalUri(te,{allowTunneling:!!ht.remote.authority})}catch(he){if((0,st.$cU)(te,ze.Schemas.http)||(0,st.$cU)(te,ze.Schemas.https))return te;throw he}},get remoteName(){return(0,_.$Vk)(ht.remote.authority)},get remoteAuthority(){return(0,Oe.$dF)(Le,"resolvers"),ht.remote.authority},get uiKind(){return ht.uiKind},get logLevel(){return H.getLevel()},get onDidChangeLogLevel(){return H.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Oe.$dF)(Le,"handleIssueUri"),pn.registerIssueUriRequestHandler(Le,te)},get appQuality(){return(0,Oe.$dF)(Le,"resolvers"),ht.quality},get appCommit(){return(0,Oe.$dF)(Le,"resolvers"),ht.commit}};ht.environment.extensionTestsLocationURI||Object.freeze(Bi);const an={createTestController(te,he,Te){return hi.createTestController(Le,te,he,Te)},createTestObserver(){return(0,Oe.$dF)(Le,"testObserver"),hi.createTestObserver()},runTests(te){return(0,Oe.$dF)(Le,"testObserver"),hi.runTests(te)},get onDidChangeTestResults(){return(0,Oe.$dF)(Le,"testObserver"),hi.onResultsChanged},get testResults(){return(0,Oe.$dF)(Le,"testObserver"),hi.results}},Di=ht.remote.isRemote?X.ExtensionKind.Workspace:X.ExtensionKind.UI,vn={getExtension(te,he){(0,Oe.$cF)(Le,"extensionsAny")||(he=!1);const Te=_t.mine.getExtensionDescription(te);if(Te)return new o.$Jcc(kt,Le.identifier,Te,Di,!1);if(he){const rt=_t.all.getExtensionDescription(te);if(rt)return new o.$Jcc(kt,Le.identifier,rt,Di,!0)}},get all(){const te=[];for(const he of _t.mine.getAllExtensionDescriptions())te.push(new o.$Jcc(kt,Le.identifier,he,Di,!1));return te},get allAcrossExtensionHosts(){(0,Oe.$dF)(Le,"extensionsAny");const te=new ue.$7l(_t.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),he=[];for(const Te of _t.all.getAllExtensionDescriptions()){const rt=!te.has(Te.identifier);he.push(new o.$Jcc(kt,Le.identifier,Te,Di,rt))}return he},get onDidChange(){return(0,Oe.$cF)(Le,"extensionsAny")?C.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},cn={createDiagnosticCollection(te){return oi.createDiagnosticCollection(Le.identifier,te)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:te=>oi.getDiagnostics(te),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(te,he){return li.changeLanguage(te.uri,he)},match(te,he){const Te=It.getDocumentData(he.uri)?.notebook;return(0,R.$rE)(ie.LanguageSelector.from(te),he.uri,he.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(te,he,Te){return ct.registerCodeActionProvider(Le,mt(te),he,Te)},registerDocumentPasteEditProvider(te,he,Te){return(0,Oe.$dF)(Le,"documentPaste"),ct.registerDocumentPasteEditProvider(Le,mt(te),he,Te)},registerCodeLensProvider(te,he){return ct.registerCodeLensProvider(Le,mt(te),he)},registerDefinitionProvider(te,he){return ct.registerDefinitionProvider(Le,mt(te),he)},registerDeclarationProvider(te,he){return ct.registerDeclarationProvider(Le,mt(te),he)},registerImplementationProvider(te,he){return ct.registerImplementationProvider(Le,mt(te),he)},registerTypeDefinitionProvider(te,he){return ct.registerTypeDefinitionProvider(Le,mt(te),he)},registerHoverProvider(te,he){return ct.registerHoverProvider(Le,mt(te),he,Le.identifier)},registerEvaluatableExpressionProvider(te,he){return ct.registerEvaluatableExpressionProvider(Le,mt(te),he,Le.identifier)},registerInlineValuesProvider(te,he){return ct.registerInlineValuesProvider(Le,mt(te),he,Le.identifier)},registerDocumentHighlightProvider(te,he){return ct.registerDocumentHighlightProvider(Le,mt(te),he)},registerLinkedEditingRangeProvider(te,he){return ct.registerLinkedEditingRangeProvider(Le,mt(te),he)},registerReferenceProvider(te,he){return ct.registerReferenceProvider(Le,mt(te),he)},registerRenameProvider(te,he){return ct.registerRenameProvider(Le,mt(te),he)},registerDocumentSymbolProvider(te,he,Te){return ct.registerDocumentSymbolProvider(Le,mt(te),he,Te)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Le,te)},registerDocumentFormattingEditProvider(te,he){return ct.registerDocumentFormattingEditProvider(Le,mt(te),he)},registerDocumentRangeFormattingEditProvider(te,he){return ct.registerDocumentRangeFormattingEditProvider(Le,mt(te),he)},registerOnTypeFormattingEditProvider(te,he,Te,...rt){return ct.registerOnTypeFormattingEditProvider(Le,mt(te),he,[Te].concat(rt))},registerDocumentSemanticTokensProvider(te,he,Te){return ct.registerDocumentSemanticTokensProvider(Le,mt(te),he,Te)},registerDocumentRangeSemanticTokensProvider(te,he,Te){return ct.registerDocumentRangeSemanticTokensProvider(Le,mt(te),he,Te)},registerSignatureHelpProvider(te,he,Te,...rt){return typeof Te=="object"?ct.registerSignatureHelpProvider(Le,mt(te),he,Te):ct.registerSignatureHelpProvider(Le,mt(te),he,typeof Te>"u"?[]:[Te,...rt])},registerCompletionItemProvider(te,he,...Te){return ct.registerCompletionItemProvider(Le,mt(te),he,Te)},registerInlineCompletionItemProvider(te,he,Te){return he.handleDidShowCompletionItem&&(0,Oe.$dF)(Le,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,Oe.$dF)(Le,"inlineCompletionsAdditions"),Te&&(0,Oe.$dF)(Le,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Le,mt(te),he,Te)},registerDocumentLinkProvider(te,he){return ct.registerDocumentLinkProvider(Le,mt(te),he)},registerColorProvider(te,he){return ct.registerColorProvider(Le,mt(te),he)},registerFoldingRangeProvider(te,he){return ct.registerFoldingRangeProvider(Le,mt(te),he)},registerSelectionRangeProvider(te,he){return ct.registerSelectionRangeProvider(Le,te,he)},registerCallHierarchyProvider(te,he){return ct.registerCallHierarchyProvider(Le,te,he)},registerTypeHierarchyProvider(te,he){return ct.registerTypeHierarchyProvider(Le,te,he)},setLanguageConfiguration:(te,he)=>ct.setLanguageConfiguration(Le,te,he),getTokenInformationAtPosition(te,he){return(0,Oe.$dF)(Le,"tokenInformation"),li.tokenAtPosition(te,he)},registerInlayHintsProvider(te,he){return ct.registerInlayHintsProvider(Le,te,he)},createLanguageStatusItem(te,he){return li.createLanguageStatusItem(Le,te,he)},registerDocumentDropEditProvider(te,he,Te){return ct.registerDocumentOnDropEditProvider(Le,te,he,(0,Oe.$cF)(Le,"dropMetadata")?Te:void 0)}},un={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(te,he,Te){const rt=await(A.URI.isUri(te)?Promise.resolve(ki.openTextDocument(te)):Promise.resolve(te));return Ft.showTextDocument(rt,he,Te)},createTextEditorDecorationType(te){return Ft.createTextEditorDecorationType(Le,te)},onDidChangeActiveTextEditor(te,he,Te){return Ft.onDidChangeActiveTextEditor(te,he,Te)},onDidChangeVisibleTextEditors(te,he,Te){return Ft.onDidChangeVisibleTextEditors(te,he,Te)},onDidChangeTextEditorSelection(te,he,Te){return Ft.onDidChangeTextEditorSelection(te,he,Te)},onDidChangeTextEditorOptions(te,he,Te){return Ft.onDidChangeTextEditorOptions(te,he,Te)},onDidChangeTextEditorVisibleRanges(te,he,Te){return Ft.onDidChangeTextEditorVisibleRanges(te,he,Te)},onDidChangeTextEditorViewColumn(te,he,Te){return Ft.onDidChangeTextEditorViewColumn(te,he,Te)},onDidCloseTerminal(te,he,Te){return gt.onDidCloseTerminal(te,he,Te)},onDidOpenTerminal(te,he,Te){return gt.onDidOpenTerminal(te,he,Te)},onDidChangeActiveTerminal(te,he,Te){return gt.onDidChangeActiveTerminal(te,he,Te)},onDidChangeTerminalDimensions(te,he,Te){return(0,Oe.$dF)(Le,"terminalDimensions"),gt.onDidChangeTerminalDimensions(te,he,Te)},onDidChangeTerminalState(te,he,Te){return gt.onDidChangeTerminalState(te,he,Te)},onDidWriteTerminalData(te,he,Te){return(0,Oe.$dF)(Le,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(te,he,Te)},onDidExecuteTerminalCommand(te,he,Te){return(0,Oe.$dF)(Le,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(te,he,Te)},get state(){return Je.getState(Le)},onDidChangeWindowState(te,he,Te){return Je.onDidChangeWindowState(te,he,Te)},showInformationMessage(te,...he){return Ei.showMessage(Le,T.default.Info,te,he[0],he.slice(1))},showWarningMessage(te,...he){return Ei.showMessage(Le,T.default.Warning,te,he[0],he.slice(1))},showErrorMessage(te,...he){return Ei.showMessage(Le,T.default.Error,te,he[0],he.slice(1))},showQuickPick(te,he,Te){return ii.showQuickPick(Le,te,he,Te)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,he){return ii.showInput(te,he)},showOpenDialog(te){return rn.showOpenDialog(Le,te)},showSaveDialog(te){return rn.showSaveDialog(te)},createStatusBarItem(te,he,Te){let rt,$t,Tt;return typeof te=="string"?(rt=te,$t=he,Tt=Te):($t=te,Tt=he),Qt.createStatusBarEntry(Le,rt,$t,Tt)},setStatusBarMessage(te,he){return Qt.setStatusBarMessage(te,he)},withScmProgress(te){return je.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Ti.withProgress(Le,{location:X.ProgressLocation.SourceControl},(he,Te)=>te({report(rt){}}))},withProgress(te,he){return Ti.withProgress(Le,te,he)},createOutputChannel(te,he){return Si.createOutputChannel(te,he,Le)},createWebviewPanel(te,he,Te,rt){return di.createWebviewPanel(Le,te,he,Te,rt)},createWebviewTextEditorInset(te,he,Te,rt){return(0,Oe.$dF)(Le,"editorInsets"),Pi.createWebviewEditorInset(te,he,Te,rt,Le)},createTerminal(te,he,Te){return typeof te=="object"?"pty"in te?gt.createExtensionTerminal(te):gt.createTerminalFromOptions(te):gt.createTerminal(te,he,Te)},registerTerminalLinkProvider(te){return gt.registerLinkProvider(te)},registerTerminalProfileProvider(te,he){return gt.registerProfileProvider(Le,te,he)},registerTerminalQuickFixProvider(te,he){return(0,Oe.$dF)(Le,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(te,Le.identifier.value,he)},registerTreeDataProvider(te,he){return bi.registerTreeDataProvider(te,he,Le)},createTreeView(te,he){return bi.createTreeView(te,he,Le)},registerWebviewPanelSerializer:(te,he)=>di.registerWebviewPanelSerializer(Le,te,he),registerCustomEditorProvider:(te,he,Te={})=>Oi.registerCustomEditorProvider(Le,te,he,Te),registerFileDecorationProvider(te){return zt.registerFileDecorationProvider(te,Le)},registerUriHandler(te){return $i.registerUriHandler(Le,te)},createQuickPick(){return ii.createQuickPick(Le)},createInputBox(){return ii.createInputBox(Le)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(te,he,Te){return Li.onDidChangeActiveColorTheme(te,he,Te)},registerWebviewViewProvider(te,he,Te){return mn.registerWebviewViewProvider(Le,te,he,Te?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,he,Te){return Et.onDidChangeActiveNotebookEditor(te,he,Te)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,he,Te){return vi.onDidChangeNotebookEditorSelection(te,he,Te)},onDidChangeNotebookEditorVisibleRanges(te,he,Te){return vi.onDidChangeNotebookEditorVisibleRanges(te,he,Te)},showNotebookDocument(te,he){return Et.showNotebookDocument(te,he)},registerExternalUriOpener(te,he,Te){return(0,Oe.$dF)(Le,"externalUriOpener"),Yi.registerExternalUriOpener(Le.identifier,te,he,Te)},registerProfileContentHandler(te,he){return(0,Oe.$dF)(Le,"profileContentHandlers"),zi.registrProfileContentHandler(Le,te,he)},registerQuickDiffProvider(te,he,Te,rt){return(0,Oe.$dF)(Le,"quickDiffProvider"),Mi.registerQuickDiffProvider(mt(te),he,Te,rt)},get tabGroups(){return et.tabGroups},registerShareProvider(te,he){return(0,Oe.$dF)(Le,"shareProvider"),Fi.registerShareProvider(mt(te),he)}},ki={get rootPath(){return je.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),at.getPath()},set rootPath(te){throw new M.$9("rootPath")},getWorkspaceFolder(te){return at.getWorkspaceFolder(te)},get workspaceFolders(){return at.getWorkspaceFolders()},get name(){return at.name},set name(te){throw new M.$9("name")},get workspaceFile(){return at.workspaceFile},set workspaceFile(te){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(te,he,...Te)=>at.updateWorkspaceFolders(Le,te,he||0,...Te),onDidChangeWorkspaceFolders:function(te,he,Te){return at.onDidChangeWorkspace(te,he,Te)},asRelativePath:(te,he)=>at.getRelativePath(te,he),findFiles:(te,he,Te,rt)=>at.findFiles(te,he,Te,Le.identifier,rt),findTextInFiles:(te,he,Te,rt)=>{(0,Oe.$dF)(Le,"findTextInFiles");let $t,Tt;return typeof he=="object"?($t=he,Tt=Te):($t={},Tt=he,rt=Te),at.findTextInFiles(te,$t||{},Tt,Le.identifier,rt)},save:te=>((0,Oe.$dF)(Le,"saveEditor"),at.save(te)),saveAs:te=>((0,Oe.$dF)(Le,"saveEditor"),at.saveAs(te)),saveAll:te=>at.saveAll(te),applyEdit(te,he){return tn.applyWorkspaceEdit(te,Le,he)},createFileSystemWatcher:(te,he,Te,rt)=>{let $t;return typeof he=="boolean"?$t={ignoreCreateEvents:!!he,ignoreChangeEvents:!!Te,ignoreDeleteEvents:!!rt}:he&&((0,Oe.$dF)(Le,"createFileSystemWatcher"),$t=he),Yt.createFileSystemWatcher(at,Le,te,$t)},get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new M.$9("textDocuments")},openTextDocument(te){let he;const Te=te;if(typeof te=="string")he=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))he=Promise.resolve(te);else if(!Te||typeof Te=="object")he=It.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(rt=>It.ensureDocumentData(rt).then($t=>$t.document))},onDidOpenTextDocument:(te,he,Te)=>It.onDidAddDocument(te,he,Te),onDidCloseTextDocument:(te,he,Te)=>It.onDidRemoveDocument(te,he,Te),onDidChangeTextDocument:(te,he,Te)=>It.onDidChangeDocument(te,he,Te),onDidSaveTextDocument:(te,he,Te)=>It.onDidSaveDocument(te,he,Te),onWillSaveTextDocument:(te,he,Te)=>ri.getOnWillSaveTextDocumentEvent(Le)(te,he,Te),get notebookDocuments(){return Et.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,he){let Te;if(A.URI.isUri(te))Te=te,await Et.openNotebookDocument(te);else if(typeof te=="string")Te=A.URI.revive(await Et.createNotebookDocument({viewType:te,content:he}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(te,he,Te){return pi.onDidSaveNotebookDocument(te,he,Te)},onDidChangeNotebookDocument(te,he,Te){return pi.onDidChangeNotebookDocument(te,he,Te)},onWillSaveNotebookDocument(te,he,Te){return Ci.getOnWillSaveNotebookDocumentEvent(Le)(te,he,Te)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(te,he,Te,rt){return Et.registerNotebookSerializer(Le,te,he,Te,(0,Oe.$cF)(Le,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,he,Te)=>sn.onDidChangeConfiguration(te,he,Te),getConfiguration(te,he){return he=arguments.length===1?void 0:he,sn.getConfiguration(te,he,Le)},registerTextDocumentContentProvider(te,he){return fn.registerTextDocumentContentProvider(te,he)},registerTaskProvider:(te,he)=>(je.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(Le,te,he)),registerFileSystemProvider(te,he,Te){return(0,Be.$Pc)(Ai.registerFileSystemProvider(Le,te,he,Te),qt.addFileSystemProvider(te,he,Te))},get fs(){return qt.value},registerFileSearchProvider:(te,he)=>((0,Oe.$dF)(Le,"fileSearchProvider"),mi.registerFileSearchProvider(te,he)),registerTextSearchProvider:(te,he)=>((0,Oe.$dF)(Le,"textSearchProvider"),mi.registerTextSearchProvider(te,he)),registerRemoteAuthorityResolver:(te,he)=>((0,Oe.$dF)(Le,"resolvers"),kt.registerRemoteAuthorityResolver(te,he)),registerResourceLabelFormatter:te=>((0,Oe.$dF)(Le,"resolvers"),Zi.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Oe.$dF)(Le,"resolvers"),kt.getRemoteExecServer(te)),onDidCreateFiles:(te,he,Te)=>Yt.onDidCreateFile(te,he,Te),onDidDeleteFiles:(te,he,Te)=>Yt.onDidDeleteFile(te,he,Te),onDidRenameFiles:(te,he,Te)=>Yt.onDidRenameFile(te,he,Te),onWillCreateFiles:(te,he,Te)=>Yt.getOnWillCreateFileEvent(Le)(te,he,Te),onWillDeleteFiles:(te,he,Te)=>Yt.getOnWillDeleteFileEvent(Le)(te,he,Te),onWillRenameFiles:(te,he,Te)=>Yt.getOnWillRenameFileEvent(Le)(te,he,Te),openTunnel:te=>((0,Oe.$dF)(Le,"tunnels"),Me.openTunnel(Le,te).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Oe.$dF)(Le,"tunnels"),Me.getTunnels()},onDidChangeTunnels:(te,he,Te)=>((0,Oe.$dF)(Le,"tunnels"),Me.onDidChangeTunnels(te,he,Te)),registerPortAttributesProvider:(te,he)=>((0,Oe.$dF)(Le,"portsAttributes"),Me.registerPortsAttributesProvider(te,he)),registerTunnelProvider:(te,he)=>((0,Oe.$dF)(Le,"tunnelFactory"),Me.registerTunnelProvider(te,he)),registerTimelineProvider:(te,he)=>((0,Oe.$dF)(Le,"timeline"),gn.registerTimelineProvider(te,he,Le.identifier,lt.converter)),get isTrusted(){return at.trusted},requestWorkspaceTrust:te=>((0,Oe.$dF)(Le,"workspaceTrust"),at.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,he,Te)=>at.onDidGrantWorkspaceTrust(te,he,Te),registerEditSessionIdentityProvider:(te,he)=>((0,Oe.$dF)(Le,"editSessionIdentityProvider"),at.registerEditSessionIdentityProvider(te,he)),onWillCreateEditSessionIdentity:(te,he,Te)=>((0,Oe.$dF)(Le,"editSessionIdentityProvider"),at.getOnWillCreateEditSessionIdentityEvent(Le)(te,he,Te)),registerCanonicalUriProvider:(te,he)=>((0,Oe.$dF)(Le,"canonicalUriProvider"),at.registerCanonicalUriProvider(te,he)),getCanonicalUri:(te,he,Te)=>((0,Oe.$dF)(Le,"canonicalUriProvider"),at.provideCanonicalUri(te,he,Te))},Wi={get inputBox(){return je.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),Ri.getLastInputBox(Le)},createSourceControl(te,he,Te){return Ri.createSourceControl(Le,te,he,Te)}},Ki={createCommentController(te,he){return Xi.createCommentController(Le,te,he)}},ci={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get stackFrameFocus(){return yt.stackFrameFocus},onDidStartDebugSession(te,he,Te){return yt.onDidStartDebugSession(te,he,Te)},onDidTerminateDebugSession(te,he,Te){return yt.onDidTerminateDebugSession(te,he,Te)},onDidChangeActiveDebugSession(te,he,Te){return yt.onDidChangeActiveDebugSession(te,he,Te)},onDidReceiveDebugSessionCustomEvent(te,he,Te){return yt.onDidReceiveDebugSessionCustomEvent(te,he,Te)},onDidChangeBreakpoints(te,he,Te){return yt.onDidChangeBreakpoints(te,he,Te)},onDidChangeStackFrameFocus(te,he,Te){return(0,Oe.$dF)(Le,"debugFocus"),yt.onDidChangeStackFrameFocus(te,he,Te)},registerDebugConfigurationProvider(te,he,Te){return yt.registerDebugConfigurationProvider(te,he,Te||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,he){return yt.registerDebugAdapterDescriptorFactory(Le,te,he)},registerDebugAdapterTrackerFactory(te,he){return yt.registerDebugAdapterTrackerFactory(te,he)},startDebugging(te,he,Te){return!Te||typeof Te=="object"&&"configuration"in Te?yt.startDebugging(te,he,{parentSession:Te}):yt.startDebugging(te,he,Te||{})},stopDebugging(te){return yt.stopDebugging(te)},addBreakpoints(te){return yt.addBreakpoints(te)},removeBreakpoints(te){return yt.removeBreakpoints(te)},asDebugSourceUri(te,he){return yt.asDebugSourceUri(te,he)}},Vi={registerTaskProvider:(te,he)=>St.registerTaskProvider(Le,te,he),fetchTasks:te=>St.fetchTasks(te),executeTask:te=>St.executeTask(Le,te),get taskExecutions(){return St.taskExecutions},onDidStartTask:(te,he,Te)=>St.onDidStartTask(te,he,Te),onDidEndTask:(te,he,Te)=>St.onDidEndTask(te,he,Te),onDidStartTaskProcess:(te,he,Te)=>St.onDidStartTaskProcess(te,he,Te),onDidEndTaskProcess:(te,he,Te)=>St.onDidEndTaskProcess(te,he,Te)},qi={createNotebookController(te,he,Te,rt,$t){return si.createNotebookController(Le,te,he,Te,rt,(0,Oe.$cF)(Le,"notebookMessaging")?$t:void 0)},registerNotebookCellStatusBarItemProvider:(te,he)=>Et.registerNotebookCellStatusBarItemProvider(Le,te,he),createRendererMessaging(te){return Ii.createRendererMessaging(Le,te)},createNotebookControllerDetectionTask(te){return(0,Oe.$dF)(Le,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Le,te)},registerKernelSourceActionProvider(te,he){return(0,Oe.$dF)(Le,"notebookKernelSource"),si.registerKernelSourceActionProvider(Le,te,he)},onDidChangeNotebookCellExecutionState(te,he,Te){return(0,Oe.$dF)(Le,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(te,he,Te)}},Hi={t(...te){if(typeof te[0]=="string"){const he=te.shift(),Te=!te||typeof te[0]!="object"?te:te[0];return ui.getMessage(Le.identifier.value,{message:he,args:Te})}return ui.getMessage(Le.identifier.value,te[0])},get bundle(){return ui.getBundle(Le.identifier.value)},get uri(){return ui.getBundleUri(Le.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(te,he){return(0,Oe.$dF)(Le,"interactive"),xi.registerProvider(Le,te,he={label:he?.label??Le.displayName??Le.name})},registerInteractiveSessionProvider(te,he){return(0,Oe.$dF)(Le,"interactive"),gi.registerChatProvider(Le,te,he)},sendInteractiveRequestToProvider(te,he){return(0,Oe.$dF)(Le,"interactive"),gi.sendInteractiveRequestToProvider(te,he)},get onDidPerformUserAction(){return(0,Oe.$dF)(Le,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(te,he){return(0,Oe.$dF)(Le,"interactive"),gi.transferChatSession(te,he)}},ln={getRelatedInformation(te,he){return(0,Oe.$dF)(Le,"aiRelatedInformation"),xt.getRelatedInformation(Le,te,he)},registerRelatedInformationProvider(te,he){return(0,Oe.$dF)(Le,"aiRelatedInformation"),xt.registerRelatedInformationProvider(Le,te,he)},registerEmbeddingVectorProvider(te,he){return(0,Oe.$dF)(Le,"aiRelatedInformation"),wi.registerEmbeddingVectorProvider(Le,te,he)}},dn={registerChatResponseProvider(te,he,Te){return(0,Oe.$dF)(Le,"chatProvider"),fi.registerProvider(Le.identifier,te,he,Te)},requestChatAccess(te){return(0,Oe.$dF)(Le,"chatRequestAccess"),fi.requestChatResponseProvider(Le.identifier,te)},registerVariable(te,he,Te){return(0,Oe.$dF)(Le,"chatVariables"),Ui.registerVariableResolver(Le,te,he,Te)},registerMappedEditsProvider(te,he){return(0,Oe.$dF)(Le,"mappedEditsProvider"),ct.registerMappedEditsProvider(Le,te,he)},createChatAgent(te,he){return(0,Oe.$dF)(Le,"chatAgents2"),$n.createChatAgent(Le.identifier,te,he)},registerAgent(te,he,Te){return(0,Oe.$dF)(Le,"chatAgents"),_i.registerAgent(Le.identifier,te,he,Te)}},hn={registerSpeechProvider(te,he){return(0,Oe.$dF)(Le,"speech"),yi.registerProvider(Le.identifier,te,he)}};return{version:ht.version,ai:ln,authentication:ji,commands:on,comments:Ki,chat:dn,debug:ci,env:Bi,extensions:vn,interactive:Gi,l10n:Hi,languages:cn,notebooks:qi,scm:Wi,speech:hn,tasks:Vi,tests:an,window:un,workspace:ki,Breakpoint:X.$fL,TerminalOutputAnchor:X.TerminalOutputAnchor,ChatMessage:X.$8L,ChatMessageRole:X.ChatMessageRole,ChatVariableLevel:X.ChatVariableLevel,CallHierarchyIncomingCall:X.$EK,CallHierarchyItem:X.$DK,CallHierarchyOutgoingCall:X.$FK,CancellationError:M.$5,CancellationTokenSource:y.$Xd,CandidatePortSource:a.CandidatePortSource,CodeAction:X.$AK,CodeActionKind:X.$BK,CodeActionTriggerKind:X.CodeActionTriggerKind,CodeLens:X.$GK,Color:X.$TK,ColorInformation:X.$UK,ColorPresentation:X.$VK,ColorThemeKind:X.ColorThemeKind,CommentMode:X.CommentMode,CommentState:X.CommentState,CommentThreadCollapsibleState:X.CommentThreadCollapsibleState,CommentThreadState:X.CommentThreadState,CompletionItem:X.$NK,CompletionItemKind:X.CompletionItemKind,CompletionItemTag:X.CompletionItemTag,CompletionList:X.$OK,CompletionTriggerKind:X.CompletionTriggerKind,ConfigurationTarget:X.ConfigurationTarget,CustomExecution:X.$4K,DebugAdapterExecutable:X.$jL,DebugAdapterInlineImplementation:X.$mL,DebugAdapterNamedPipeServer:X.$lL,DebugAdapterServer:X.$kL,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:X.DebugConsoleMode,DecorationRangeBehavior:X.DecorationRangeBehavior,Diagnostic:X.$vK,DiagnosticRelatedInformation:X.$uK,DiagnosticSeverity:X.DiagnosticSeverity,DiagnosticTag:X.DiagnosticTag,Disposable:X.$hK,DocumentHighlight:X.$xK,DocumentHighlightKind:X.DocumentHighlightKind,DocumentLink:X.$SK,DocumentSymbol:X.$zK,EndOfLine:X.EndOfLine,EnvironmentVariableMutatorType:X.EnvironmentVariableMutatorType,EvaluatableExpression:X.$pL,InlineValueText:X.$qL,InlineValueVariableLookup:X.$rL,InlineValueEvaluatableExpression:X.$sL,InlineCompletionTriggerKind:X.InlineCompletionTriggerKind,EventEmitter:C.$Nd,ExtensionKind:X.ExtensionKind,ExtensionMode:X.ExtensionMode,ExternalUriOpenerPriority:X.ExternalUriOpenerPriority,FileChangeType:X.FileChangeType,FileDecoration:X.$CL,FileDecoration2:X.$CL,FileSystemError:X.$uL,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:X.$vL,FoldingRangeKind:X.FoldingRangeKind,FunctionBreakpoint:X.$hL,InlineCompletionItem:X.$PK,InlineCompletionList:X.$QK,Hover:X.$wK,IndentAction:$.IndentAction,Location:X.$tK,MarkdownString:X.$HK,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:X.$IK,PortAutoForwardAction:X.PortAutoForwardAction,Position:X.$iK,ProcessExecution:X.$2K,ProgressLocation:X.ProgressLocation,QuickInputButtons:X.$BL,Range:X.$jK,RelativePattern:X.$dL,Selection:X.$kK,SelectionRange:X.$CK,SemanticTokens:X.$yL,SemanticTokensBuilder:X.$xL,SemanticTokensEdit:X.$zL,SemanticTokensEdits:X.$AL,SemanticTokensLegend:X.$wL,ShellExecution:X.$3K,ShellQuoting:X.ShellQuoting,SignatureHelp:X.$KK,SignatureHelpTriggerKind:X.SignatureHelpTriggerKind,SignatureInformation:X.$JK,SnippetString:X.$sK,SourceBreakpoint:X.$gL,StandardTokenType:X.StandardTokenType,StatusBarAlignment:X.StatusBarAlignment,SymbolInformation:X.$yK,SymbolKind:X.SymbolKind,SymbolTag:X.SymbolTag,Task:X.$5K,TaskGroup:X.$1K,TaskPanelKind:X.TaskPanelKind,TaskRevealKind:X.TaskRevealKind,TaskScope:X.TaskScope,TerminalLink:X.$WK,TerminalQuickFixExecuteTerminalCommand:X.$YK,TerminalQuickFixOpener:X.$XK,TerminalLocation:X.TerminalLocation,TerminalProfile:X.$ZK,TerminalExitReason:X.TerminalExitReason,TextDocumentSaveReason:X.TextDocumentSaveReason,TextEdit:X.$oK,SnippetTextEdit:X.$qK,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:X.TextEditorLineNumbersStyle,TextEditorRevealType:X.TextEditorRevealType,TextEditorSelectionChangeKind:X.TextEditorSelectionChangeKind,SyntaxTokenType:X.SyntaxTokenType,TextDocumentChangeReason:X.TextDocumentChangeReason,ThemeColor:X.$cL,ThemeIcon:X.$bL,TreeItem:X.$6K,TreeItemCheckboxState:X.TreeItemCheckboxState,TreeItemCollapsibleState:X.TreeItemCollapsibleState,TypeHierarchyItem:X.$XL,UIKind:p.UIKind,Uri:A.URI,ViewColumn:X.ViewColumn,WorkspaceEdit:X.$rK,DocumentDropEdit:X.$_K,DocumentPasteEdit:X.$aL,InlayHint:X.$MK,InlayHintLabelPart:X.$LK,InlayHintKind:X.InlayHintKind,RemoteAuthorityResolverError:X.$nK,ResolvedAuthority:X.$lK,ManagedResolvedAuthority:X.$mK,SourceControlInputBoxValidationType:X.SourceControlInputBoxValidationType,ExtensionRuntime:X.ExtensionRuntime,TimelineItem:X.$ML,NotebookRange:X.$EL,NotebookCellKind:X.NotebookCellKind,NotebookCellExecutionState:X.NotebookCellExecutionState,NotebookCellData:X.$FL,NotebookData:X.$GL,NotebookRendererScript:X.$KL,NotebookCellStatusBarAlignment:X.NotebookCellStatusBarAlignment,NotebookEditorRevealType:X.NotebookEditorRevealType,NotebookCellOutput:X.$IL,NotebookCellOutputItem:X.$HL,NotebookCellStatusBarItem:X.$JL,NotebookControllerAffinity:X.NotebookControllerAffinity,NotebookControllerAffinity2:X.NotebookControllerAffinity2,NotebookEdit:X.$pK,NotebookKernelSourceAction:X.$LL,PortAttributes:X.$OL,LinkedEditingRanges:X.$NL,TestResultState:X.TestResultState,TestRunRequest:X.$PL,TestMessage:X.$QL,TestMessage2:X.$QL,TestTag:X.$RL,TestRunProfileKind:X.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:X.$$K,DataTransferItem:X.$7K,CoveredCount:X.$SL,FileCoverage:X.$TL,StatementCoverage:X.$UL,BranchCoverage:X.$VL,FunctionCoverage:X.$WL,WorkspaceTrustState:X.WorkspaceTrustState,LanguageStatusSeverity:X.LanguageStatusSeverity,QuickPickItemKind:X.QuickPickItemKind,InputBoxValidationSeverity:X.InputBoxValidationSeverity,TabInputText:X.$YL,TabInputTextDiff:X.$ZL,TabInputTextMerge:X.$1L,TabInputCustom:X.$2L,TabInputNotebook:X.$4L,TabInputNotebookDiff:X.$5L,TabInputWebview:X.$3L,TabInputTerminal:X.$6L,TabInputInteractiveWindow:X.$7L,TelemetryTrustedValue:Ee.$ko,LogLevel:ge.LogLevel,EditSessionIdentityMatch:ft.EditSessionIdentityMatch,InteractiveSessionVoteDirection:X.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:X.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:X.InteractiveEditorResponseFeedbackKind,StackFrameFocus:X.$nL,ThreadFocus:X.$oL,RelatedInformationType:X.RelatedInformationType,SpeechToTextStatus:X.SpeechToTextStatus}}}e.$5dc=Mt}),define(Ae[275],Re([1,0,70,109,33,107,34,31,60,63,111,113,114,84,86,80,108,62,40,83,58,61,242,14,112,81,82]),function(ye,e,y,M,C,T,A,l,D,$,R,k,a,p,g,d,t,i,c,b,E,v,s,r,n,o,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$xr)(o.$Dcc,o.$Ccc,1),(0,y.$xr)(r.$$i,s.$6dc,1),(0,y.$xr)(d.$3bc,d.$4bc,1),(0,y.$xr)(l.$CM,l.$BM,0),(0,y.$xr)(A.$dcc,A.$bcc,0),(0,y.$xr)(i.$scc,i.$rcc,0),(0,y.$xr)(k.$gdc,k.$kdc,0),(0,y.$xr)(T.$$cc,T.$0cc,0),(0,y.$xr)(D.$rM,D.$qM,0),(0,y.$xr)(w.$Ecc,w.$Fcc,0),(0,y.$xr)(c.$Zbc,c.$Ybc,0),(0,y.$xr)(M.$Qcc,M.$Pcc,1),(0,y.$xr)(a.$qdc,a.$rdc,0),(0,y.$xr)(p.$occ,p.$ncc,0),(0,y.$xr)(R.$bdc,R.$adc,0),(0,y.$xr)($.$vcc,$.$ycc,0),(0,y.$xr)(g.$5vb,g.$6vb,0),(0,y.$xr)(t.$7cc,t.$6cc,0),(0,y.$xr)(C.$acc,C.$_bc,0),(0,y.$xr)(b.$Acc,b.$zcc,0),(0,y.$xr)(E.$AM,E.$xM,0),(0,y.$xr)(v.$cdc,v.$ddc,0),(0,y.$xr)(n.$edc,n.$fdc,0)}),define(Ae[276],Re([1,0,274,35,2,271,7,12,262]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;class $ extends T.$9dc{j(){}getModule(p,g){for(const d of this.b){const t=d(p);if(t){p=t;break}}if(this.a.has(p))return this.a.get(p).load(p,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends M.$Hcc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(D.$bgc);const p=this.h.invokeFunction(y.$5dc);this.r=this.h.createInstance($,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,g,d){g=g.with({path:k(g.path,".js")});const t=p?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=C.URI.revive(await this.C.$asBrowserUri(g)),c=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),c.status!==200)throw new Error(c.statusText);const b=await c.text(),E=`${g.toString(!0)}#vscode-extension`,v=`${b}
//# sourceURL=${E}`;let s;try{s=new Function("module","exports","require",v)}catch(w){throw console.error(t?`Loading code for extension ${t} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${g.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}p&&await this.w.initializeLocalizedMessages(p);const r={},n={exports:r},o=w=>{const f=this.r.getModule(w,g);if(f===void 0)throw new Error(`Cannot load module '${w}'`);return f};try{return d.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),s(n,r,o),n.exports!==r?n.exports:r}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),d.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+p;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,l.$Ug)(10)}}e.$cgc=R;function k(a,p){return a.endsWith(p)?a:a+p}}),define(Ae[277],Re([1,0,69,70,14,35,187,85,276]),function(ye,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$xr)(C.$0i,new y.$Mh(A.$8dc,[!0],!0)),(0,M.$xr)(T.$Icc,D.$cgc,0),(0,M.$xr)(l.$tcc,l.$ucc,0)}),define(Ae[286],Re([1,0,26,5,79,272,264,19,87,13,2,275,277]),function(ye,e,y,M,C,T,A,l,D,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(s){return/^(file|vscode-remote):/i.test(s)}const g=fetch.bind(self);function d(s){self.fetch=async function(r,n){return r instanceof Request||p(String(r))&&(r=(await s(R.URI.parse(String(r)))).toString(!0)),g(r,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,n,o,w,f){(async()=>(p(n.toString())&&(n=(await s(R.URI.parse(n.toString()))).toString(!0)),super.open(r,n,o??!0,w,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const s=self.Worker;Worker=function(r,n){if(/^file:/i.test(r.toString()))r=$.$cg.uriToBrowserUri(R.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(u){function m(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const h=fetch.bind(self);self.fetch=function(W,K){return W instanceof Request?h(W,K):h(m(W),K)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,K,z,j,O){return super.open(W,m(K),z??!0,j,O)}};const P=importScripts.bind(self);self.importScripts=(...W)=>{P(...W.map(m))},P(u)}.toString()}('${r}'))`;n=n||{},n.name=n.name||l.$nc(r.toString());const f=new Blob([w],{type:"application/javascript"}),I=URL.createObjectURL(f);return new s(I,n)}}else self.Worker=class extends A.$dgc{constructor(s,r){super(a,s,{name:l.$nc(s.toString()),...r})}};const t=new class{constructor(){this.pid=void 0}exit(s){k()}};class i{constructor(){const r=new MessageChannel,n=new M.$Nd;let o=!1;a(r.port2,[r.port2]),r.port1.onmessage=w=>{const{data:f}=w;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const I=y.$be.wrap(new Uint8Array(f,0,f.byteLength));if((0,C.$cm)(I,2)){o=!0,b("received terminate message from renderer");return}n.fire(I)},this.protocol={onMessage:n.event,send:w=>{if(!o){const f=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);r.port1.postMessage(f,[f])}}}}}function c(s){return new Promise(r=>{const n=s.onMessage(o=>{n.dispose();const w=JSON.parse(o.toString());s.send((0,C.$bm)(0)),r({protocol:s,initData:w})});s.send((0,C.$bm)(1))})}let b=s=>k();function E(s){return!!s&&typeof s=="object"&&s.type==="vscode.init"&&s.data instanceof Map}function v(){D.mark("code/extHost/willConnectToRenderer");const s=new i;return{onmessage(r){E(r)&&c(s.protocol).then(n=>{D.mark("code/extHost/didWaitForInitData");const o=new T.$$dc(n.protocol,n.initData,t,null,r.data);d(w=>o.asBrowserUri(w)),b=w=>o.terminate(w)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4678919d52909efc7c4ab958a2e5c8f45d50ffc3/core/vs/workbench/api/worker/extensionHostWorker.js.map
